# Flatiron Institute Fast Multipole Libraries
[![Actions status](https://github.com/flatironinstitute/FMM3D/actions/workflows/python_cmake.yml/badge.svg)](https://github.com/flatironinstitute/FMM3D/actions)

This codebase is a set of libraries to compute N-body interactions
governed by the Laplace and Helmholtz equations, to a specified
precision, in three dimensions, on a multi-core shared-memory machine.

Please see the [online documentation](https://fmm3d.readthedocs.io),
or its equivalent [user manual](fmm3d_manual.pdf).

This folder contains the MATLAB wrappers, legacy wrappers for FMMLIB3D, 
and precompiled mex interfaces for MacOSX and Linux.

We strongly recommend recompiling the mex interfaces (see 
https://fmm3d.readthedocs.io/en/latest/install.html for detailed installation 
instructions).

Example codes for demonstrating the Helmholtz and Laplace interfaces are
``hfmm3d_example.m`` and ``lfmm3d_example.m``.

Example codes for demonstrating the legacy Helmholtz and Laplace wrappers are
``test_hfmm3dpart_direct.m`` and ``test_lfmm3dpart_direct.m``.

  This folder contains the header files for the c wrappers,
  some utility files, and a few examples. 

  -  The Helmholtz wrappers are contained in ``hfmm3d_c.h``
  -  The Laplace wrappers are contained in ``lfmm3d_c.h``

  - The Helmholtz FMM example files are ``hfmm3d_example.c`` and
  ``hfmm3d_vec_example.c`` (for vectorized routines).
  To run these examples, run their corresponding makefiles, 
  ``hfmm3d_example.make`` and ``hfmm3d_vec_example.make``.

  - The Laplace FMM example files are ``lfmm3d_example.c`` and
  ``lfmm3d_vec_example.c`` (for vectorized routines).
  To run these examples, run their corresponding makefiles, 
  ``lfmm3d_example.make`` and ``lfmm3d_vec_example.make``.

  - In order to run any of the makefiles, you will need to have compiled
  the static library in the main folder by running
    
        make lib

    Then to run the makefile, run

        make -f "<makefile>"
 

# FMM3D.jl

FMM3D.jl is a set of julia interfaces for
computing N-body interactions using the
Flatiron Institute's `FMM3D` library.

## Using FMM3D.jl

`FMM3D.jl` is now registered in the Julia General registry, so you can install it in Julia 1.6 or later.
Press `]` in Julia REPL to enter the package manager and then enter:
```julia
pkg> add FMM3D
```
then the package should be installed automatically.

You can then use the package with

```julia
julia> using FMM3D
```

It can also be obtained by downloading this
git repository and a recent version of julia
(1.6 or later is required). Then, from the
root directory (the parent directory of the
julia subdirectory) run the following in
julia:

```julia
julia> using Pkg

julia> Pkg.add(url=".",subdir="julia")
 ```

You can test the package with

```julia
julia> Pkg.test("FMM3D")
```

## Contributing

Contributions are welcome! Check out the issues
tab for feature requests/bugs.

It's pretty straightforward to write
a wrapper for any subroutine in the FMM3D library
because they are all exposed by the FMM3D_jll library
and can be executed using `ccall` (see existing wrappers
in src/FMM3D.jl for examples). Many of the
low-level routines have other uses and could
benefit from a user-friendly wrapper.

Requirements for a pull request to be approved:
* Any new wrapper should have associated tests
in test/runtests.jl.
* If the pull request is fixing a bug, that bug
should be tested in test/runtests.jl
* Any new wrapper which is exported by the module
should have documentation. Typically, the documentation
from the original Fortran code is a good starting
point. See existing wrappers for style.
* Wrappers for the highest level routines (actual
FMMs and direct evaluation codes) should be added to
the list in the module documentation at the top of
src/FMM3D.jl. All other wrappers may be added to the
list in the documentation for the `lower_level_routs`
function in src/FMM3D.jl.

To install in the system:
pip install -e . 


On compilation you can import the package fmm3dpy
which has 2 main subroutines

- hfmm3d: for computing N-body Helmholtz interactions
- lfmm3d: for computing N-body Laplace interactions

Examples for both of these are demonstrated in
``hfmmexample.py`` and ``lfmmexample.py``

  This folder contains the examples for the Fortran wrappers. 

  - The Helmholtz FMM example files are ``hfmm3d_example.f``
  ``hfmm3d_vec_example.f`` (for vectorized routines), and
  ``hfmm3d_legacy_example.f`` (for the legacy routines).
  To run these examples, run their corresponding makefiles, 
  ``hfmm3d_example.make``, ``hfmm3d_vec_example.make``, and
  ``hfmm3d_legacy_example.make``.

  - The Helmholtz FMM example files are ``lfmm3d_example.f``
  ``lfmm3d_vec_example.f`` (for vectorized routines), and
  ``lfmm3d_legacy_example.f`` (for the legacy routines).
  To run these examples, run their corresponding makefiles, 
  ``lfmm3d_example.make``, ``lfmm3d_vec_example.make``, and
  ``lfmm3d_legacy_example.make``.

  - In order to run any of the makefiles, you will need to have compiled
  the static library in the main folder by running
    
        make lib

    Then to run the makefile, run

        make -f "<makefile>"
 

using FMM3D
using Random
using LinearAlgebra

#  This is a sample code to demonstrate how to use
#  the fmm libraries
#

# sample with one density, sources to sources,
# charge interactions, and potential only
#
n = 2000
nd = 1
sources = rand(3,n)
eps = 10.0^(-5)

zk = 1.1 + im*0
charges = rand(n) + im*rand(n)
vals = hfmm3d(eps,zk,sources,charges=charges,pg=1)


# sample with a vector of densities, sources to 
# sources and targets, dipole interactions, 
# potential and gradietns

nd = 3
zk = 1.1 + im*0
nt = 1870
targ = rand(3,nt)
dipvecs = rand(nd,3,n) + im*rand(nd,3,n)
vals = hfmm3d(eps,zk,sources,dipvecs=dipvecs,
             targets=targ,nd=nd,pg=2,pgt=2)

      implicit real *8 (a-h,o-z)
      integer *8, parameter :: nd = 1
      integer *8, parameter :: nt = 3
      integer *8 i,icomp,ns
      real *8 ztarg(3,nt),sources(3,10)
      complex *16 charge(nd,10),pot(nd,nt),grad(nd,3,nt)
      complex *16 hess(nd,6,nt)
      complex *16 dipvec(nd,3,10)
      complex *16 zk,v1,v2,zfd
      complex *16 zfd1,zfd2,zfd3
c
c 
      zk  = dcmplx(1.1d0,0.4d0)
c
      sources(1,1) = 0.1d0     
      sources(2,1) = -0.2d0     
      sources(3,1) = 0.3d0     
      dipvec(1,1,1) = dcmplx(1.1d0,0.3d0)     
      dipvec(1,2,1) = dcmplx(-2.2d0,0.2d0)     
      dipvec(1,3,1) = dcmplx(3.3d0,0.1d0)
cc      dipvec(1,1,1) = 0
cc      dipvec(1,2,1) = 0     
cc      dipvec(1,3,1) = 0     
      charge(1,1) = dcmplx(1.3d0,0.11d0)
      sources(1,2) = -0.13d0     
      sources(2,2) = 0.2d0     
      sources(3,2) = -0.25d0     
      dipvec(1,1,2) = dcmplx(-2.13d0,0.1d0)
      dipvec(1,2,2) = dcmplx(1.2d0,0.3d0)
      dipvec(1,3,2) = dcmplx(-3.25d0,0.2d0)
cc      dipvec(1,1,2) = 0     
cc      dipvec(1,2,2) = 0     
cc      dipvec(1,3,2) = 0     
      charge(1,2) = dcmplx(2.3d0,0.21d0)
      ns = 2
      ztarg(1,1) = 1.0d0
      ztarg(2,1) = 1.3d0
      ztarg(3,1) = 1.4d0
c
c     pick component in which to do finite difference
c
c
      icomp = 3

      hh = 1.0d-5
      ztarg(1,2) = 1.0d0 
      ztarg(2,2) = 1.3d0 
      ztarg(3,2) = 1.4d0 
      ztarg(1,3) = 1.0d0 
      ztarg(2,3) = 1.3d0 
      ztarg(3,3) = 1.4d0 
      ztarg(icomp,2) = ztarg(icomp,2) + hh
      ztarg(icomp,3) = ztarg(icomp,3) - hh
c
c
      write(6,*) ' directc  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectcp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      zfd =  (pot(1,2) - pot(1,3))/(2*hh)
      write(6,*) ' FD deriv ', zfd
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectcg(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      zfd1 = (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      zfd2 = (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      zfd3 = (v1-v2)/(2*hh)
      write(6,*) ' FD deriv of p_x ', zfd1 
      write(6,*) ' FD deriv of p_y ', zfd2
      write(6,*) ' FD deriv of p_z ', zfd3
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectch(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      if (icomp.eq.1) then
         write(6,*) ' dir pxx ', hess(1,1,1)
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pxz ', hess(1,5,1)
         exx = abs( hess(1,1,1)- zfd1)/abs(hess(1,1,1))
         exy = abs( hess(1,4,1)- zfd2)/abs(hess(1,4,1))
         exz = abs( hess(1,5,1)- zfd3)/abs(hess(1,5,1))
         write(6,*) ' exx  ', exx
         write(6,*) ' exy  ', exy
         write(6,*) ' exz  ', exz
      else if (icomp.eq.2) then
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pyy ', hess(1,2,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         exy = abs( hess(1,4,1)- zfd1)/abs(hess(1,4,1))
         eyy = abs( hess(1,2,1)- zfd2)/abs(hess(1,2,1))
         eyz = abs( hess(1,6,1)- zfd3)/abs(hess(1,6,1))
         write(6,*) ' exy  ', exy
         write(6,*) ' eyy  ', eyy
         write(6,*) ' eyz  ', eyz
      else if (icomp.eq.3) then
         write(6,*) ' dir pxz ', hess(1,4,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         write(6,*) ' dir pzz ', hess(1,3,1)
         exz = abs( hess(1,5,1)- zfd1)/abs(hess(1,5,1))
         eyz = abs( hess(1,6,1)- zfd2)/abs(hess(1,6,1))
         ezz = abs( hess(1,3,1)- zfd3)/abs(hess(1,3,1))
         write(6,*) ' exz  ', exz
         write(6,*) ' eyz  ', eyz
         write(6,*) ' ezz  ', ezz
      endif
c
c
      write(6,*) ' directd  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectdp(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      zfd =  (pot(1,2) - pot(1,3))/(2*hh)
      write(6,*) ' FD deriv ', zfd
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectdg(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      zfd1 = (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      zfd2 = (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      zfd3 = (v1-v2)/(2*hh)
      write(6,*) ' FD x deriv of p_x ', zfd1
      write(6,*) ' FD x deriv of p_y ', zfd2
      write(6,*) ' FD x deriv of p_z ', zfd3
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectdh(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      if (icomp.eq.1) then
         write(6,*) ' dir pxx ', hess(1,1,1)
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pxz ', hess(1,5,1)
         exx = abs( hess(1,1,1)- zfd1)/abs(hess(1,1,1))
         exy = abs( hess(1,4,1)- zfd2)/abs(hess(1,4,1))
         exz = abs( hess(1,5,1)- zfd3)/abs(hess(1,5,1))
         write(6,*) ' exx  ', exx
         write(6,*) ' exy  ', exy
         write(6,*) ' exz  ', exz
      else if (icomp.eq.2) then
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pyy ', hess(1,2,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         exy = abs( hess(1,4,1)- zfd1)/abs(hess(1,4,1))
         eyy = abs( hess(1,2,1)- zfd2)/abs(hess(1,2,1))
         eyz = abs( hess(1,6,1)- zfd3)/abs(hess(1,6,1))
         write(6,*) ' exy  ', exy
         write(6,*) ' eyy  ', eyy
         write(6,*) ' eyz  ', eyz
      else if (icomp.eq.3) then
         write(6,*) ' dir pxz ', hess(1,4,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         write(6,*) ' dir pzz ', hess(1,3,1)
         exz = abs( hess(1,5,1)- zfd1)/abs(hess(1,5,1))
         eyz = abs( hess(1,6,1)- zfd2)/abs(hess(1,6,1))
         ezz = abs( hess(1,3,1)- zfd3)/abs(hess(1,3,1))
         write(6,*) ' exz  ', exz
         write(6,*) ' eyz  ', eyz
         write(6,*) ' ezz  ', ezz
      endif

c
      write(6,*) ' directcd  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectcdp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      zfd =  (pot(1,2) - pot(1,3))/(2*hh)
      write(6,*) ' FD deriv ', zfd
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectcdg(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      zfd1 = (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      zfd2 = (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      zfd3 = (v1-v2)/(2*hh)
      write(6,*) ' FD deriv of p_x ', zfd1
      write(6,*) ' FD deriv of p_y ', zfd2
      write(6,*) ' FD deriv of p_z ', zfd3

c
      call setzero(pot,grad,hess,nd,nt)
      call h3ddirectcdh(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
      write(6,*) ' dir cp '
      do i = 1,nt
         write(6,*)pot(1,i)
      enddo
      write(6,*) ' analytic grad ', grad(1,icomp,1)
      egrad = abs( grad(1,icomp,1)- zfd)/abs(grad(1,icomp,1))
      write(6,*) ' egrad  ', egrad
      if (icomp.eq.1) then
         write(6,*) ' dir pxx ', hess(1,1,1)
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pxz ', hess(1,5,1)
         exx = abs( hess(1,1,1)- zfd1)/abs(hess(1,1,1))
         exy = abs( hess(1,4,1)- zfd2)/abs(hess(1,4,1))
         exz = abs( hess(1,5,1)- zfd3)/abs(hess(1,5,1))
         write(6,*) ' exx  ', exx
         write(6,*) ' exy  ', exy
         write(6,*) ' exz  ', exz
      else if (icomp.eq.2) then
         write(6,*) ' dir pxy ', hess(1,4,1)
         write(6,*) ' dir pyy ', hess(1,2,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         exy = abs( hess(1,4,1)- zfd1)/abs(hess(1,4,1))
         eyy = abs( hess(1,2,1)- zfd2)/abs(hess(1,2,1))
         eyz = abs( hess(1,6,1)- zfd3)/abs(hess(1,6,1))
         write(6,*) ' exy  ', exy
         write(6,*) ' eyy  ', eyy
         write(6,*) ' eyz  ', eyz
      else if (icomp.eq.3) then
         write(6,*) ' dir pxz ', hess(1,4,1)
         write(6,*) ' dir pyz ', hess(1,6,1)
         write(6,*) ' dir pzz ', hess(1,3,1)
         exz = abs( hess(1,5,1)- zfd1)/abs(hess(1,5,1))
         eyz = abs( hess(1,6,1)- zfd2)/abs(hess(1,6,1))
         ezz = abs( hess(1,3,1)- zfd3)/abs(hess(1,3,1))
         write(6,*) ' exz  ', exz
         write(6,*) ' eyz  ', eyz
         write(6,*) ' ezz  ', ezz
      endif

      end

      subroutine setzero(pot,grad,hess,nd,nt)
      implicit none
      integer *8 nd,nt,ii,jj
      complex *16 pot(nd,nt),grad(nd,3,nt)
      complex *16 hess(nd,6,nt)

      do ii=1,nd
      do jj=1,nt
         pot(ii,jj) = 0.0d0
         grad(ii,1,jj) = 0.0d0
         grad(ii,2,jj) = 0.0d0
         grad(ii,3,jj) = 0.0d0
         hess(ii,1,jj) = 0.0d0
         hess(ii,2,jj) = 0.0d0
         hess(ii,3,jj) = 0.0d0
         hess(ii,4,jj) = 0.0d0
         hess(ii,5,jj) = 0.0d0
         hess(ii,6,jj) = 0.0d0
      enddo
      enddo
      return
      end

c
c     Computation of spherical Bessel functions via recurrence
c
c**********************************************************************
      subroutine besseljs3d(nterms,z,scale,fjs,ifder,fjder)
c**********************************************************************
c
c PURPOSE:
c
c	This subroutine evaluates the first NTERMS spherical Bessel 
c	functions and if required, their derivatives.
c	It incorporates a scaling parameter SCALE so that
c       
c		fjs_n(z)=j_n(z)/SCALE^n
c		fjder_n(z)=\frac{\partial fjs_n(z)}{\partial z}
c
c INPUT:
c
c    nterms (integer *8): order of expansion of output array fjs 
c    z     (complex *16): argument of the spherical Bessel functions
c    scale    (real *8) : scaling factor (discussed above)
c    ifder  (integer *8): flag indicating whether to calculate "fjder"
c		          0	NO
c		          1	YES
c OUTPUT:
c    fjs   (complex *16): array of scaled Bessel functions.
c    fjder (complex *16): array of derivs of scaled Bessel functions.
c
c
      implicit none
      integer *8 ier,nterms,ifder,lwfjs,ntop,i,ncntr
      real *8 scale,d0,d1,dc1,dc2,dcoef,dd,done,tiny,zero
      real *8 scalinv,sctot,upbound,upbound2,upbound2inv
      integer *8, allocatable :: iscale(:)
      complex *16, allocatable :: fjtmp(:)
      complex *16 wavek,fjs(0:nterms),fjder(0:*)
      complex *16 z,zinv,com,fjm1,fj0,fj1,zscale,ztmp
c
      data upbound/1.0d+32/, upbound2/1.0d+40/, upbound2inv/1.0d-40/
      data tiny/1.0d-200/,done/1.0d0/,zero/0.0d0/
c
c ... Initializing ...
c
      ier=0
c
c       set to asymptotic values if argument is sufficiently small
c
      if (abs(z).lt.tiny) then
        fjs(0) = done
        do i = 1, nterms
          fjs(i) = zero
	    enddo
c
	    if (ifder.eq.1) then
	      do i=0,nterms
	        fjder(i)=zero
	      enddo
          fjder(1)=done/(3*scale)
        endif
        return 
      endif
c
c ... Step 1: recursion up to find ntop, starting from nterms
c
      zinv=done/z

      fjm1 = zero
      fj0 = done

c
cc     note max point for upward recurrence is
c      hard coded to nterms + 1000,
c      this might cause loss of accuracy for some
c      arguments in the complex plane for large 
c      nterms. For example, it is a terrible idea
c      to use this code for z>>nterms^2

      lwfjs = nterms + 100000
      ntop=lwfjs
c
      do i=nterms,lwfjs
        dcoef=2*i+done
        fj1=dcoef*zinv*fj0-fjm1
        dd = abs(fj1)**2
        if(dd .gt. upbound2) then
          ntop=i+1
          goto 1300
        endif
        fjm1 = fj0
        fj0 = fj1
      enddo
 1300 continue

cc      call prinf('ntop=*',ntop,1)

      allocate(iscale(0:ntop),fjtmp(0:ntop))
c
c ... Step 2: Recursion back down to generate the unscaled jfuns:
c             if magnitude exceeds UPBOUND2, rescale and continue the 
c	      recursion (saving the order at which rescaling occurred 
c	      in array iscale.
c
      do i=0,ntop
         iscale(i)=0
      enddo
c
      fjtmp(ntop)=zero
      fjtmp(ntop-1)=done
      do i=ntop-1,1,-1
        dcoef=2*i+done
        fjtmp(i-1)=dcoef*zinv*fjtmp(i)-fjtmp(i+1)
        dd = abs(fjtmp(i-1))**2
        if (dd.gt.UPBOUND2) then
          fjtmp(i) = fjtmp(i)*UPBOUND2inv
          fjtmp(i-1) = fjtmp(i-1)*UPBOUND2inv
          iscale(i) = 1
        endif
      enddo
c
c ...  Step 3: go back up to the top and make sure that all
c              Bessel functions are scaled by the same factor
c              (i.e. the net total of times rescaling was invoked
c              on the way down in the previous loop).
c              At the same time, add scaling to fjs array.
c
      ncntr=0
      scalinv=done/scale
      sctot = 1.0d0
      do i=1,ntop
         sctot = sctot*scalinv
         if(iscale(i-1).eq.1) sctot=sctot*UPBOUND2inv
         fjtmp(i)=fjtmp(i)*sctot
      enddo
c
c ... Determine the normalization parameter:
c
      fj0=sin(z)*zinv
      fj1=fj0*zinv-cos(z)*zinv
c
      d0=abs(fj0)
      d1=abs(fj1)
      if (d1 .gt. d0) then
         zscale=fj1/(fjtmp(1)*scale)
      else
         zscale=fj0/fjtmp(0)
      endif
c
c ... Scale the jfuns by zscale:
c
      ztmp=zscale
      do i=0,nterms
         fjs(i)=fjtmp(i)*ztmp
      enddo
c
c ... Finally, calculate the derivatives if desired:
c
      if (ifder.eq.1) then
        fjder(0)=-fjs(1)*scale
        do i=1,nterms
          dc1=i/(2*i+done)
          dc2=done-dc1
          dc1=dc1*scalinv
          dc2=dc2*scale
          fjder(i)=(dc1*fjtmp(i-1)-dc2*fjtmp(i+1))*ztmp
        enddo
      endif
      return
      end
c

      implicit none
      integer *8 ns,nt,nd
      double precision, allocatable :: source(:,:),targ(:,:)
      double precision, allocatable :: charge(:,:),dipvec(:,:,:)
      double precision, allocatable :: pot(:,:)
      double precision, allocatable :: pottarg(:,:)

      double precision eps
      integer *8 i,j,k,idim,ier
      double precision hkrand
      


c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      call prin2("This code is an example fortran driver*",i,0)
      call prin2("On output, the code prints sample pot,pottarg*",i,0)
      write(*,*)
      write(*,*)

      ns = 2000
      nt = 1999
      
      nd = 5

      allocate(source(3,ns))
      allocate(targ(3,nt))
      allocate(charge(nd,ns))
      allocate(dipvec(nd,3,ns))
      allocate(pot(nd,ns))
      allocate(pottarg(nd,nt))


      eps = 0.5d-9

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source+targ, charges+dipoles, pot
c



c
cc      generate sources uniformly in the unit cube 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        do idim=1,nd
          charge(idim,i) = hkrand(0) 
          dipvec(idim,1,i) = hkrand(0) 
          dipvec(idim,2,i) = hkrand(0) 
          dipvec(idim,3,i) = hkrand(0) 
          pot(idim,i) = 0
        enddo
      enddo

      do i=1,nt
        targ(1,i) = hkrand(0)
        targ(2,i) = hkrand(0)
        targ(3,i) = hkrand(0)

        do idim=1,nd
          pottarg(idim,i) = 0
        enddo
      enddo


       call lfmm3d_st_cd_p_vec(nd,eps,ns,source,charge,
     1      dipvec,pot,nt,targ,pottarg,ier)

       call prin2("potential at sources=*",pot,12)
       call prin2("potential at targets=*",pottarg,12)


      stop
      end
c----------------------------------------------------------
c
cc
c
c

c
c     This file contains the Stokes FMM wrappers
c
c**********************************************************************
c
c     We take the following conventions for the Stokes kernels.
c
c     1) The dynamic viscosity (mu) is assumed to be 1.
c     2) All kernels are using standard definitions.
c
c     For a source y and target x, let r_i = x_i-y_i     (note sign)
c     and let r = sqrt(r_1^2 + r_2^2 + r_3^2)
c
c     The Stokeslet, G_{ij}, and its associated pressure tensor, P_j,
c     we define as
c
c     G_{ij}(x,y) = ( delta_{ij}/r  + r_i r_j / r^3 )/(8\pi)
c     P_j(x,y) = 1/(4\pi) * r_j/r^3
c
c     The (Type I) stresslet, T_{ijk}, and its associated pressure
c     tensor, PI_{jk}, we define as
c
c     T_{ijk}(x,y) = 3/(4\pi) r_i r_j r_k/ r^5
c     PI_{jk}(x,y) = -1/(2\pi) delta_{jk}/r^3 + 3/(2\pi) r_j r_k/r^5

c     The rotlet, R_{ijk}, and its associated pressure tensor, Q_{jk}, are
c
c     R_{ijk}(x,y) = -\delta_{ik} r_j/(4\pi r^3) + \delta_{ij} r_k/(4\pi r^3)
c     Q_{jk} = 0;
c
c     The doublet, D_{ijk}, and its associated pressure tensor, L_{jk}, are
c
c     D_{ijk}(x,y) = -\delta_{jk} r_i/(4\pi r^3) - \delta_{ik} r_j/(4\\pi r^3) + \delta_{ij} r_k/(4\pi r^3) + 3 r_i r_j r_k/ (4\pi r^5)
c     L_{jk} = -1/(2\pi) \delta_{jk} + 3 r_j r_k/(2\pi r^5)



      subroutine stfmm3d(nd, eps,
     $                 nsource, source,
     $                 ifstoklet, stoklet, ifstrslet, strslet, strsvec,
     $                 ifrotlet, rotlet, rotvec,
     $                 ifdoublet, doublet, doubvec,
     $                 ifppreg, pot, pre, grad, ntarg, targ,
     $                 ifppregtarg, pottarg, pretarg, gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source
cf2py  intent(in) ifstoklet,stoklet
cf2py  intent(in) ifstrslet,strslet,strsvec
cf2py  intent(in) ifrotlet,rotlet,rotvec
cf2py  intent(in) ifdoublet,doublet,doubvec
cf2py  intent(in) ifppreg,ifppregtarg
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,pre,grad
cf2py  intent(out) pottarg,pretarg,gradtarg
cf2py  intent(out) ier
c
c     Stokes FMM in R^{3}: evaluate all pairwise particle
c     interactions (ignoring self-interactions) and
c     interactions with targs.
c
c     This routine computes the sum for the velocity vector,
c
c       u_i(x) = sum_m G_{ij}(x,y^{(m)}) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k
c                + sum_m R_{ijk}(x,y^{(m)}) rlet^{(m)}_j rvec^{(m)}_k
c                + sum_m D_{ijk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c     for x at all of the target locations, and i=1,2,3,
c     where sigma^{(m)} is the Stokeslet force, mu^{(m)} is the
c     stresslet strength, nu^{(m)} is the stresslet orientation,
c     rlet^{(m)} is the rotlet strength, rvec^{(m)} is the rotlet
c     dlet^{(m)} is the doublet strength, and dvec^{(m)} is the doublet
c     (note that each of these is a 3 vector per source point y^{(m)}).
c     Repeated indices are taken as summed over 1,2,3, ie, Einstein
c     convention. For x a source point, the self-interaction in the
c     sum is omitted.
c
c     Optionally, the associated pressure p(x) and 3x3 gradient tensor
c     grad u(x) are returned
c
c       p(x) = sum_m P_j(x,y^m) sigma^{(m)}_j
c          + sum_m PI_{jk}(x,y{(m)}) mu^{(m)}_j nu^{(m)}_k
c          + sum_m L_{jk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c       grad_l u_i(x) = grad_l [sum_m G_{ij}(x,y^m) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k]
c                + sum_m R_{ijk}(x,y^{(m)}) rlet^{(m)}_j rvec^{(m)}_k
c                + sum_m D_{ijk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c     Note that these two may be combined to get the stress tensor.
c
c-----------------------------------------------------------------------
c     INPUT PARAMETERS:
c
c   nd:    in: integer *8
c              number of densities
c
c   eps:   in: double precision
c              requested precision
c
c   nsource in: integer *8
c               number of sources
c
c   source  in: double precision (3,nsource)
c               source(k,j) is the kth component of the jth
c               source locations
c
c   ifstoklet  in: integer *8
c               Stokeslet charge computation flag
c               ifstoklet = 1   =>  include Stokeslet contribution
c                                   otherwise do not
c 
c   stoklet in: double precision (nd,3,nsource) 
c               Stokeslet charge strengths (sigma vectors above)
c
c   ifstrslet in: integer *8
c               stresslet computation flag
c               ifstrslet = 1   =>  include standard stresslet
c                                   (type I)
c
c            NOT YET IMPLEMENTED
c
c               ifstrslet = 2   =>  include symmetric stresslet
c                                   (type II)
c               ifstrslet = 3   =>  include rotlet
c               ifstrslet = 4   =>  include Stokes doublet
c                      otherwise do not include
c
c   strslet  in: double precision (nd,3,nsource) 
c               stresslet strengths (mu vectors above)
c
c   strsvec  in: double precision (nd,3,nsource)   
c               stresslet orientations (nu vectors above)
c
c     ifppreg    in: integer *8
c               flag for evaluating potential, gradient, and pressure
c               at the sources
c               ifppreg = 1, only potential
c               ifppreg = 2, potential and pressure
c         GRADIENT NOT IMPLEMENTED
c               ifppreg = 3, potential, pressure, and gradient 
c
c   ntarg   in: integer *8
c              number of targs 
c
c   targ    in: double precision (3,ntarg)
c             targ(k,j) is the kth component of the jth
c             targ location
c
c   ifppregtarg in: integer *8
c                flag for evaluating potential, gradient, and pressure
c                at the targets
c                ifppregtarg = 1, only potential
c                ifppregtarg = 2, potential and pressure
c                ifppregtarg = 3, potential, pressure, and gradient
c
c-----------------------------------------------------------------------
c
c   OUTPUT parameters:
c
c   pot   out: double precision(nd,3,nsource) 
c           velocity at the source locations
c
c   pre   out: double precision(nd,nsource)
c           pressure at the source locations
c
c         GRADIENT NOT IMPLEMENTED
c   grad   out: double precision(nd,3,3,nsource) 
c              gradient of velocity at the source locations
c              grad(l,i,j,k) is the ith component of the
c              gradient of the jth component of the velocity
c              for the lth density at the kth source location
c
c   pottarg   out: double precision(nd,3,ntarg) 
c               velocity at the targets
c
c   pretarg   out: double precision(nd,ntarg)
c               pressure at the targets
c
c   gradtarg   out: double precision(nd,3,3,ntarg) 
c               gradient of velocity at the targets
c               gradtarg(l,i,j,k) is the ith component of the
c               gradient of the jth component of the velocity
c               for the lth density at the kth target
c     ier     out: integer *8
c               error flag
c
c     TODO: implement other stresslet options and gradient
c------------------------------------------------------------------
      implicit none
      integer *8 nd, ifstoklet, ifstrslet, ntarg
      integer ifrotlet, ifdoublet
      double precision eps
      integer *8 nsource, ifppreg, ifppregtarg
      double precision source(3, nsource), targ(3, ntarg)
      double precision stoklet(nd, 3, nsource), strslet(nd, 3, nsource)
      double precision strsvec(nd, 3, nsource)
      double precision rotlet(nd, 3, nsource), rotvec(nd, 3, nsource)
      double precision doublet(nd, 3, nsource), doubvec(nd, 3, nsource)
      double precision pot(nd, 3, nsource), pre(nd,nsource)
      double precision grad(nd, 3, 3, nsource)
      double precision pottarg(nd, 3, ntarg), pretarg(nd,ntarg),
     1     gradtarg(nd, 3, 3, ntarg)

c     local
      double precision, allocatable :: charge(:,:,:), dipvec(:,:,:,:)
      double precision, allocatable :: potl(:,:,:), gradl(:,:,:,:),
     1     hessl(:,:,:,:), pottargl(:,:,:), gradtargl(:,:,:,:),
     2     hesstargl(:,:,:,:)
      double precision :: pt(3), gl(3), hl(6), vel(3), velgrad(3,3)
      double precision :: press, pl, pv, dmu(3), dnu(3), sigma(3)
      double precision :: rlet(3), rvec(3), dlet(3), dvec(3)

      integer *8 ndl, ifchargel, ifdipolel, ifpghl, ifpghtargl
      integer *8 ndper, loffset

      integer *8 i, j, ii, ifppreg1, l, npt, ier,iper


      ndper = 0

      if (ifstrslet .eq. 1 .or. ifstoklet .eq. 1) then
         ndper = 4
         if (ifrotlet .eq. 1 .or. ifdoublet .eq. 1) then
            ndper = 7
         endif
      else
         if (ifrotlet .eq. 1) then
            ndper = 3
         endif
         if (ifdoublet .eq. 1) then
            ndper = 7
         endif
      endif

      if (ndper .eq. 7) then
         loffset = 4
      else
         loffset = 0
      endif

      ifdipolel = 0
      ifchargel = 0

      if (ifstoklet .eq. 1) ifchargel = 1
      if (ifstrslet .eq. 1) ifdipolel = 1
      if (ifrotlet .eq. 1) ifdipolel = 1
      if (ifdoublet .eq. 1) ifchargel = 1
      if (ifdoublet .eq. 1) ifdipolel = 1

      ndl = ndper*nd

      ifpghl = 3
      ifpghtargl = 3

c     allocate necessary arrays

      allocate(charge(ndper,nd,nsource),dipvec(ndper,nd,3,nsource),
     1     potl(ndper,nd,nsource),pottargl(ndper,nd,ntarg),
     2     gradl(ndper,nd,3,nsource),gradtargl(ndper,nd,3,ntarg),
     3     hessl(ndper,nd,6,nsource),hesstargl(ndper,nd,6,ntarg),
     4     stat=ier)
      if(ier .ne. 0) then
         print *, "In stfmm3d: cannot allocate Laplace call storage"
         print *, "ndper =",ndper
         print *, "nd =",nd
         print *, "nsource =",nsource
         print *, "ntarg =",ntarg
         stop
      endif

c     set-up appropriate vector charge and dipole arrays

c$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l,sigma,dmu,dnu)
c$OMP$ PRIVATE(pl,pv,rlet,rvec,dlet,dvec)
      do i = 1,nsource

         do j = 1,nd
            do l = 1,ndper
               charge(l,j,i) = 0
               dipvec(l,j,1,i) = 0
               dipvec(l,j,2,i) = 0
               dipvec(l,j,3,i) = 0
            enddo
         enddo

         do j = 1,nd
            if (ifstoklet .eq. 1) then
               sigma(1) = stoklet(j,1,i)
               sigma(2) = stoklet(j,2,i)
               sigma(3) = stoklet(j,3,i)
            endif
            if (ifstrslet .ge. 1) then
               dmu(1) = strslet(j,1,i)
               dmu(2) = strslet(j,2,i)
               dmu(3) = strslet(j,3,i)
               dnu(1) = strsvec(j,1,i)
               dnu(2) = strsvec(j,2,i)
               dnu(3) = strsvec(j,3,i)
            endif
            if (ifrotlet .eq. 1) then
               rlet(1) = rotlet(j,1,i)
               rlet(2) = rotlet(j,2,i)
               rlet(3) = rotlet(j,3,i)
               rvec(1) = rotvec(j,1,i)
               rvec(2) = rotvec(j,2,i)
               rvec(3) = rotvec(j,3,i)
            endif
            if (ifdoublet .eq. 1) then
               dlet(1) = doublet(j,1,i)
               dlet(2) = doublet(j,2,i)
               dlet(3) = doublet(j,3,i)
               dvec(1) = doubvec(j,1,i)
               dvec(2) = doubvec(j,2,i)
               dvec(3) = doubvec(j,3,i)
            endif

            do l = 1,3

               if (ifstoklet .eq. 1) then
                  charge(l,j,i) = charge(l,j,i) + sigma(l)/2
               endif
               if (ifstrslet .eq. 1) then
                  dipvec(l,j,1,i) = dipvec(l,j,1,i) + (dmu(l)*dnu(1) +
     1                 dmu(1)*dnu(l))/2
                  dipvec(l,j,2,i) = dipvec(l,j,2,i) + (dmu(l)*dnu(2) +
     1                 dmu(2)*dnu(l))/2
                  dipvec(l,j,3,i) = dipvec(l,j,3,i) + (dmu(l)*dnu(3) +
     1                 dmu(3)*dnu(l))/2
               endif
               if (ifrotlet .eq. 1) then
                   dipvec(l+loffset,j,1,i) = dipvec(l+loffset,j,1,i) -
     1                                       rvec(l)*rlet(1) +
     2                                       rlet(l)*rvec(1)
                   dipvec(l+loffset,j,2,i) = dipvec(l+loffset,j,2,i) -
     1                                       rvec(l)*rlet(2) +
     2                                       rlet(l)*rvec(2)
                   dipvec(l+loffset,j,3,i) = dipvec(l+loffset,j,3,i) -
     1                                       rvec(l)*rlet(3) +
     2                                       rlet(l)*rvec(3)
               endif
               if (ifdoublet .eq. 1) then
                  dipvec(l,j,1,i) = dipvec(l,j,1,i) + (dlet(l)*dvec(1) +
     1                 dlet(1)*dvec(l))/2
                  dipvec(l,j,2,i) = dipvec(l,j,2,i) + (dlet(l)*dvec(2) +
     1                 dlet(2)*dvec(l))/2
                  dipvec(l,j,3,i) = dipvec(l,j,3,i) + (dlet(l)*dvec(3) +
     1                 dlet(3)*dvec(l))/2
                  dipvec(l+loffset,j,1,i) = dipvec(l+loffset,j,1,i) -
     1                                     dvec(l)*dlet(1) +
     2                                     dlet(l)*dvec(1)
                  dipvec(l+loffset,j,2,i) = dipvec(l+loffset,j,2,i) -
     1                                     dvec(l)*dlet(2) +
     2                                     dlet(l)*dvec(2)
                  dipvec(l+loffset,j,3,i) = dipvec(l+loffset,j,3,i) -
     1                                     dvec(l)*dlet(3) +
     2                                     dlet(l)*dvec(3)
               endif
            enddo

            l = 4

            if (ifstoklet .eq. 1) then
               pl = sigma(1)*source(1,i) + sigma(2)*source(2,i) +
     1              sigma(3)*source(3,i)
               charge(l,j,i) = charge(l,j,i) + pl/2
            endif
            if (ifstrslet .eq. 1) then
               pl = dmu(1)*source(1,i) + dmu(2)*source(2,i) +
     1              dmu(3)*source(3,i)
               pv = dnu(1)*source(1,i) + dnu(2)*source(2,i) +
     1              dnu(3)*source(3,i)

               dipvec(l,j,1,i) = dipvec(l,j,1,i) +
     1              (dmu(1)*pv + dnu(1)*pl)/2
               dipvec(l,j,2,i) = dipvec(l,j,2,i) +
     1              (dmu(2)*pv + dnu(2)*pl)/2
               dipvec(l,j,3,i) = dipvec(l,j,3,i) +
     1              (dmu(3)*pv + dnu(3)*pl)/2
            endif
            if (ifdoublet .eq. 1) then
               pl = dlet(1)*dvec(1) + dlet(2)*dvec(2) + dlet(3)*dvec(3)
               charge(l,j,i) = charge(l,j,i) + pl

               pl = dlet(1)*source(1,i) + dlet(2)*source(2,i) +
     1              dlet(3)*source(3,i)
               pv = dvec(1)*source(1,i) + dvec(2)*source(2,i) +
     1              dvec(3)*source(3,i)

               dipvec(l,j,1,i) = dipvec(l,j,1,i) +
     1              (dlet(1)*pv + dvec(1)*pl)/2
               dipvec(l,j,2,i) = dipvec(l,j,2,i) +
     1              (dlet(2)*pv + dvec(2)*pl)/2
               dipvec(l,j,3,i) = dipvec(l,j,3,i) +
     1              (dlet(3)*pv + dvec(3)*pl)/2
            endif

         enddo

      enddo
c$OMP END PARALLEL DO


c     call Laplace FMM

      iper = 0
      ier = 0
      call lfmm3d(ndl,eps,nsource,source,ifchargel,charge,
     1     ifdipolel,dipvec,iper,ifpghl,potl,gradl,hessl,ntarg,
     2     targ,ifpghtargl,pottargl,gradtargl,hesstargl,ier)


      npt = ntarg + nsource

c     unpack stacked Laplace FMM calls

c$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l,ifppreg1,ii)
c$OMP$ PRIVATE(pt,pl,gl,hl,vel,velgrad,press)
      do i = 1,npt

         do j = 1,nd

            vel(1) = 0
            vel(2) = 0
            vel(3) = 0
            velgrad(1,1) = 0
            velgrad(2,1) = 0
            velgrad(3,1) = 0
            velgrad(1,2) = 0
            velgrad(2,2) = 0
            velgrad(3,2) = 0
            velgrad(1,3) = 0
            velgrad(2,3) = 0
            velgrad(3,3) = 0
            press = 0

            do l = 1,ndper

               if (i .gt. ntarg) then
                  ifppreg1 = ifppreg
                  ii = i-ntarg
                  pt(1) = source(1,ii)
                  pt(2) = source(2,ii)
                  pt(3) = source(3,ii)
                  pl = potl(l,j,ii)
                  gl(1) = gradl(l,j,1,ii)
                  gl(2) = gradl(l,j,2,ii)
                  gl(3) = gradl(l,j,3,ii)
                  hl(1) = hessl(l,j,1,ii)
                  hl(2) = hessl(l,j,2,ii)
                  hl(3) = hessl(l,j,3,ii)
                  hl(4) = hessl(l,j,4,ii)
                  hl(5) = hessl(l,j,5,ii)
                  hl(6) = hessl(l,j,6,ii)
               else
                  ifppreg1 = ifppregtarg
                  ii = i
                  pt(1) = targ(1,ii)
                  pt(2) = targ(2,ii)
                  pt(3) = targ(3,ii)
                  pl = pottargl(l,j,ii)
                  gl(1) = gradtargl(l,j,1,ii)
                  gl(2) = gradtargl(l,j,2,ii)
                  gl(3) = gradtargl(l,j,3,ii)
                  hl(1) = hesstargl(l,j,1,ii)
                  hl(2) = hesstargl(l,j,2,ii)
                  hl(3) = hesstargl(l,j,3,ii)
                  hl(4) = hesstargl(l,j,4,ii)
                  hl(5) = hesstargl(l,j,5,ii)
                  hl(6) = hesstargl(l,j,6,ii)
               endif


               if (l .ge. 1 .and. l .le. 3 .and. ndper .ge. 4) then

                  vel(l) = vel(l) + pl
                  vel(1) = vel(1) - pt(l)*gl(1)
                  vel(2) = vel(2) - pt(l)*gl(2)
                  vel(3) = vel(3) - pt(l)*gl(3)
                  press = press - gl(l)*2
                  if (ifppreg1 .eq. 3) then
                     velgrad(1,l) =  velgrad(1,l) + gl(1)
                     velgrad(2,l) =  velgrad(2,l) + gl(2)
                     velgrad(3,l) =  velgrad(3,l) + gl(3)

                     velgrad(l,1) = velgrad(l,1) - gl(1)
                     velgrad(l,2) = velgrad(l,2) - gl(2)
                     velgrad(l,3) = velgrad(l,3) - gl(3)

c     confirm hessian ordering convention
                     velgrad(1,1) = velgrad(1,1) - pt(l)*hl(1)
                     velgrad(2,1) = velgrad(2,1) - pt(l)*hl(4)
                     velgrad(3,1) = velgrad(3,1) - pt(l)*hl(5)
                     velgrad(1,2) = velgrad(1,2) - pt(l)*hl(4)
                     velgrad(2,2) = velgrad(2,2) - pt(l)*hl(2)
                     velgrad(3,2) = velgrad(3,2) - pt(l)*hl(6)
                     velgrad(1,3) = velgrad(1,3) - pt(l)*hl(5)
                     velgrad(2,3) = velgrad(2,3) - pt(l)*hl(6)
                     velgrad(3,3) = velgrad(3,3) - pt(l)*hl(3)
                  endif

               else if (l .ge. 1 .and. l .le. 3 .and. ndper .eq. 3) then
                  vel(l) = vel(l) + pl
                  if (ifppreg1 .eq. 3) then
                     velgrad(1,l) =  velgrad(1,l) + gl(1)
                     velgrad(2,l) =  velgrad(2,l) + gl(2)
                     velgrad(3,l) =  velgrad(3,l) + gl(3)
                  endif
               else if (l .eq. 4) then

                  vel(1) = vel(1) + gl(1)
                  vel(2) = vel(2) + gl(2)
                  vel(3) = vel(3) + gl(3)
                  if (ifppreg1 .eq. 3) then
c     confirm hessian ordering convention
                     velgrad(1,1) = velgrad(1,1) + hl(1)
                     velgrad(2,1) = velgrad(2,1) + hl(4)
                     velgrad(3,1) = velgrad(3,1) + hl(5)
                     velgrad(1,2) = velgrad(1,2) + hl(4)
                     velgrad(2,2) = velgrad(2,2) + hl(2)
                     velgrad(3,2) = velgrad(3,2) + hl(6)
                     velgrad(1,3) = velgrad(1,3) + hl(5)
                     velgrad(2,3) = velgrad(2,3) + hl(6)
                     velgrad(3,3) = velgrad(3,3) + hl(3)
                  endif
               else if (l .ge. 5 .and. l .le. 7) then
                  vel(l-4) = vel(l-4) + pl
                  if (ifppreg1 .eq. 3) then
                     velgrad(1,l-4) =  velgrad(1,l-4) + gl(1)
                     velgrad(2,l-4) =  velgrad(2,l-4) + gl(2)
                     velgrad(3,l-4) =  velgrad(3,l-4) + gl(3)
                  endif
               endif
            enddo

            if (i .gt. ntarg) then
               if (ifppreg1 .ge. 1) then
                  pot(j,1,ii) = vel(1)
                  pot(j,2,ii) = vel(2)
                  pot(j,3,ii) = vel(3)
               endif
               if (ifppreg1 .ge. 2) then
                  pre(j,ii) = press
               endif
               if (ifppreg1 .ge. 3) then
                  grad(j,1,1,ii) = velgrad(1,1)
                  grad(j,2,1,ii) = velgrad(2,1)
                  grad(j,3,1,ii) = velgrad(3,1)
                  grad(j,1,2,ii) = velgrad(1,2)
                  grad(j,2,2,ii) = velgrad(2,2)
                  grad(j,3,2,ii) = velgrad(3,2)
                  grad(j,1,3,ii) = velgrad(1,3)
                  grad(j,2,3,ii) = velgrad(2,3)
                  grad(j,3,3,ii) = velgrad(3,3)
               endif
            else
               if (ifppreg1 .ge. 1) then
                  pottarg(j,1,ii) = vel(1)
                  pottarg(j,2,ii) = vel(2)
                  pottarg(j,3,ii) = vel(3)
               endif
               if (ifppreg1 .ge. 2) then
                  pretarg(j,ii) = press
               endif
               if (ifppreg1 .ge. 3) then
                  gradtarg(j,1,1,ii) = velgrad(1,1)
                  gradtarg(j,2,1,ii) = velgrad(2,1)
                  gradtarg(j,3,1,ii) = velgrad(3,1)
                  gradtarg(j,1,2,ii) = velgrad(1,2)
                  gradtarg(j,2,2,ii) = velgrad(2,2)
                  gradtarg(j,3,2,ii) = velgrad(3,2)
                  gradtarg(j,1,3,ii) = velgrad(1,3)
                  gradtarg(j,2,3,ii) = velgrad(2,3)
                  gradtarg(j,3,3,ii) = velgrad(3,3)
               endif
            endif
         enddo
      enddo
c$OMP END PARALLEL DO

      return
      end

interface

  subroutine helm3d_f(nd, zk, sources, charge, ns, ztarg, nt, pot, thresh) !bind(C, name="helm3d_f_")
    implicit none
    integer *4, intent(in) :: nd
    complex *8, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex *8, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex *8, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine helm3d_vec_f(nd, zk, sources, charge, ns, ztarg, nt, pot, thresh) !bind(C, name="helm3d_vec_f_")
    implicit none
    integer *4, intent(in) :: nd
    complex *8, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex *8, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex *8, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine helm3d_d(nd, zk, sources, charge, ns, ztarg, nt, pot, thresh) !bind(C, name="helm3d_d_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine helm3d_vec_d(nd, zk, sources, charge, ns, ztarg, nt, pot, thresh) !bind(C, name="helm3d_vec_d_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectcp(nd, zk, sources, charge, ns, ztarg, nt, pot, thresh) !bind(C, name="h3ddirectcp_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectcg(nd, zk, sources, charge, ns, ztarg, nt, pot, grad, thresh) !bind(C, name="h3ddirectcg_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    complex*16, intent(out):: grad(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectdp(nd, zk, sources, dipvec, ns, ztarg, nt, pot, thresh) !bind(C, name="h3ddirectdp_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: dipvec(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectdg(nd, zk, sources, dipvec, ns, ztarg, nt, pot, grad, thresh) !bind(C, name="h3ddirectdg_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: dipvec(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    complex*16, intent(out):: grad(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectcdp(nd, zk, sources, charge, dipvec, ns, ztarg, nt, pot, thresh) !bind(C, name="h3ddirectcdp_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    complex*16, intent(in) :: dipvec(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    real    *8, intent(in) :: thresh
  end subroutine

  subroutine h3ddirectcdg(nd, zk, sources, charge, dipvec, ns, ztarg, nt, pot, grad, thresh) !bind(C, name="h3ddirectcdg_")
    implicit none
    integer *4, intent(in) :: nd
    complex*16, intent(in) :: zk
    real    *8, intent(in) :: sources(*)
    complex*16, intent(in) :: charge(*)
    complex*16, intent(in) :: dipvec(*)
    integer *4, intent(in) :: ns
    real    *8, intent(in) :: ztarg(*)
    integer *4, intent(in) :: nt
    complex*16, intent(out):: pot(*)
    complex*16, intent(out):: grad(*)
    real    *8, intent(in) :: thresh
  end subroutine

end interface

"""
    module FMM3D

Wrappers for the Flatiron Institute's FMM3D
library. 

# wrappers

All N-body codes return output in an 
`FMMVals` structure. See documentation
of N-body codes for details.

N-body interactions with the Helmholtz kernel
- [`hfmm3d`](@ref): ``O(N)`` fast mutlipole code
- [`h3ddir`](@ref): ``O(N^2)`` direct code

N-body interactions with the Laplace kernel
- [`lfmm3d`](@ref): ``O(N)`` fast mutlipole code
- [`l3ddir`](@ref): ``O(N^2)`` direct code

N-body interactions with Stokes kernels
- [`stfmm3d`](@ref): ``O(N)`` fast mutlipole code
- [`st3ddir`](@ref): ``O(N^2)`` direct code

N-body interactions with an electromagnetic kernel
- [`emfmm3d`](@ref): ``O(N)`` fast mutlipole code
- [`em3ddir`](@ref): ``O(N^2)`` direct code

# lower level routines

For a list of lower level routines see the 
documentation for [`lower_level_routs`](@ref)
"""
module FMM3D

using FMM3D_jll

export FMMVals, hfmm3d, hfmm3d_ndiv, lfmm3d, lfmm3d_ndiv, h3ddir, l3ddir, lowerlevel_routs
export stfmm3d, st3ddir, emfmm3d, em3ddir
export besseljs3d

"""

# Available lower level routines

* [`besseljs3d`](@ref) spherical Bessel function eval
"""
function lower_level_routs() end

# fortran input/return types

Fd = Ref{Float64}
Fi = Ref{Int64}
Fc = Ref{ComplexF64}

# common input types

TFN = Union{Array{Float64},Nothing}
TCN = Union{Array{ComplexF64},Nothing}


"""
    FMMVals()

Return type for FMM and direct computation function
calls. Fields are `nothing` on return unless requested.
See individual FMM/direct computation function 
documentation for specifics.
"""
mutable struct FMMVals
    pot
    grad
    hess

    pottarg
    gradtarg
    hesstarg

    ier

    # stokes-specific return values
    
    pre
    pretarg

    # maxwell-specific return values
    E
    divE
    curlE

    Etarg
    divEtarg
    curlEtarg
end

function FMMVals()
    return FMMVals(nothing,nothing,nothing,
                   nothing,nothing,nothing,
                   nothing,
                   nothing,nothing,
                   nothing,nothing,nothing,
                   nothing,nothing,nothing)
end


"""
```julia
    anyfail, n, nt, ifcharge, ifdipole = (
        scalarfmm3dinputcheck(sources,charges,dipvecs,
                                targets,pg,pgt,nd) )
```

Input checking for Helmholtz and Laplace routines. 
Checks the sizes of these arrays and the compatibility
of the various flags, nd, and provided arrays. 
If something is off, a warning is issued and 
`anyfail` is set to true. Non-fatal mistakes result in
a warning but `anyfail` remains false. 

Output:
* `anyfail` - boolean is true if any checks fail, false otherwise
* n - integer, number of sources
* nt - integer, number of targets
* ifcharge - integer, is 1 if there are charges, 0 otherwise
* ifdipole - integer, is 1 if there are dipoles, 0 otherwise
"""
function scalarfmm3dinputcheck(sources,charges,dipvecs,targets,pg,pgt,nd)
    anyfail = false
    
    if (size(sources,1) != 3)
        @warn "sources array is wrong shape, computing nothing"
        anyfail = true
    end
    if (nd < 0)
        @warn "nd has invalid value, computing nothing"
        anyfail = true
    end
    if (pg > 3 || pg < 0)
        @warn "flag pg not in expected range, computing nothing"
        anyfail = true
    end
    if (pgt > 3 || pgt < 0)
        @warn "flag pgt not in expected range, computing nothing"
        anyfail = true
    end    

    n = div(length(sources),3)
    nt = 0

    if targets != nothing
        if (size(targets,1) != 3)
            @warn "targets array is wrong shape, computing nothing"
            anyfail = true
        end
        nt = div(length(targets),3)
    end
    
    if charges != nothing
        if (div(length(charges),nd) != n)
            @warn "size of charges array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ifcharge = 1
    else
        ifcharge = 0
    end

    if dipvecs != nothing
        if (div(length(dipvecs),nd) != n*3)
            @warn "size of dipvecs array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ifdipole = 1
    else
        ifdipole = 0
    end

    if ifcharge == 0 && ifdipole == 0
        @warn "no charges or dipoles provided, doing nothing"
        anyfail = true
    end

    if (pg != 1 && pg != 2 && pg != 3) && (pgt != 1 && pgt != 2 && pgt != 3)
        @warn "no output requested, doing nothing"
        anyfail = true
    end

    if (pgt == 1 || pgt == 2 || pgt == 3) && targets == nothing
        @warn "target values requested but no targets provided, proceeding anyway"
    end

    return anyfail, n, nt, ifcharge, ifdipole
end

"""
```julia
    vals = hfmm3d(eps,zk,sources;charges=nothing,dipvecs=nothing,
                  targets=nothing,pg=0,pgt=0,nd=1)
```

This function computes the N-body Helmholtz interactions
in three dimensions where the interaction kernel is given 
by ``e^{ikr}/(4\\pi r)`` and its gradients. This is the 
``O(N)`` fast multipole code which computes the interactions
to the requested precision.

```math
 u(x) = \\sum_{j=1}^{N} c_{j} \\frac{e^{ik \\|x-x_{j}\\|}}{4\\pi\\|x-x_{j}\\|} 
- v_{j} \\cdot \\nabla \\left( \\frac{e^{ik \\|x-x_{j}\\|}}{4\\pi\\|x-x_{j}\\|} 
\\right)  \\, , 
```
 
where ``c_{j}`` are the charge densities,  
      ``v_{j}`` are the dipole orientation vectors, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum

# Input

* `eps::Float64` precision requested
* `zk::ComplexF64` Helmholtz parameter 
* `sources::Array{Float64}` size (3,n) source locations (``x_{j}``)

# Optional Keyword Input

* `charges::Array{ComplexF64}` size (nd,n) or (n) charge densities (c_{j})
* `dipvecs::Array{ComplexF64}` size (nd,3,n) or (3,n)) dipole orientation vectors (``v_{j}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)
* `pg::Integer` source eval flag. 
    + Do not compute any quantities at sources if `pg == 0`
    + Potential (``u``) at sources evaluated if `pg == 1`. 
    + Potential and gradient (``\\nabla u``) at sources evaluated if `pg == 2`
    + Potential, gradient, and Hessian (``\\nabla \\nabla u``) at sources evaluated if `pg == 3`
* `pgt::Integer` target eval flag. 
    + Do not compute any quantities at targets if `pgt == 0`
    + Potential at targets evaluated if `pgt == 1`. 
    + Potential and gradient at targets evaluated if `pgt == 2`
    + Potential, gradient, and Hessian at targets evaluated if `pgt == 3`
* `nd::Integer` number of densities

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

Note that the Hessian is returned as a length
6 vector at each point with the second derivatives
in the order: ``\\partial_{xx}``, ``\\partial_{yy}``,
``\\partial_{zz}``, ``\\partial_{xy}``, 
``\\partial_{xz}``, ``\\partial_{yz}``.

* `vals.pot::Array{ComplexF64}` size (nd,n) or (n) potential at source locations if requested
* `vals.grad::Array{ComplexF64}` size (nd,3,n) or (3,n) gradient at source locations if requested
* `vals.hess::Array{ComplexF64}` size (nd,6,n) or (6,n) Hessian at source locations if requested
* `vals.pottarg::Array{ComplexF64}` size (nd,nt) or (nt) potential at target locations if requested
* `vals.gradtarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) gradient at target locations if requested
* `vals.hesstarg::Array{ComplexF64}` size (nd,6,nt) or (6,nt) Hessian at target locations if requested
* `vals.ier` error flag as returned by FMM3D library. A value of 0 indicates a successful call. 
Non-zero values may indicate insufficient memory available. See the documentation for the FMM3D library. 
If not set (`nothing`), then FMM3D library was never called.
"""
function _hfmm3d_impl(eps::Float64,zk::Union{Float64,ComplexF64},
                      sources::Array{Float64};
                      charges::TCN=nothing,dipvecs::TCN=nothing,
                      targets::TFN=nothing,pg::Integer=0,pgt::Integer=0,
                      nd::Integer=1,ndiv::Union{Integer,Nothing}=nothing)

    zk = complex(zk)
    
    # default values

    vals = FMMVals()
    
    ifcharge = 0
    ifdipole = 0

    zero = ComplexF64(0)
    
    pot = zero
    grad = zero
    hess = zero
    pottarg = zero
    gradtarg = zero
    hesstarg = zero

    # check inputs

    if (pg == 3)
        @warn "Hessian not implemented for Helmholtz fmm, only computing potential and gradients at sources"
        pg = 2
    end
    if (pgt == 3)
        @warn "Hessian not implemented for Helmholtz fmm, only computing potential and gradients at targets"
        pgt = 2
    end
    
    anyfail, n, nt, ifcharge, ifdipole = (
        scalarfmm3dinputcheck(sources,charges,dipvecs,targets,pg,pgt,nd))

    if anyfail
        return vals
    end
    if ndiv !== nothing && ndiv < 1
        @warn "ndiv must be a positive integer, computing nothing"
        return vals
    end

    if (ifcharge == 0); charges = zero end
    if (ifdipole == 0); dipvecs = zero end
    if (nt == 0); targets = 0.0 end
    
    # allocate memory for return values
    
    if pg == 1 || pg == 2 || pg == 3
        if nd > 1
            pot = zeros(ComplexF64,nd,n)
        else
            pot = zeros(ComplexF64,n)
        end
    end

    if pg == 2 || pg == 3
        if nd > 1
            grad = zeros(ComplexF64,nd,3,n)
        else
            grad = zeros(ComplexF64,3,n)
        end
    end

    if pg == 3
        if nd > 1
            hess = zeros(ComplexF64,nd,6,n)
        else
            hess = zeros(ComplexF64,6,n)
        end
    end

    if pgt == 1 || pgt == 2 || pgt == 3
        if nd > 1
            pottarg = zeros(ComplexF64,nd,nt)
        else
            pottarg = zeros(ComplexF64,nt)
        end
    end

    if pgt == 2 || pgt == 3
        if nd > 1
            gradtarg = zeros(ComplexF64,nd,3,nt)
        else
            gradtarg = zeros(ComplexF64,3,nt)
        end
    end

    if pgt == 3
        if nd > 1
            hesstarg = zeros(ComplexF64,nd,6,nt)
        else
            hesstarg = zeros(ComplexF64,6,nt)
        end
    end

    # actually call the function
    #
    # fortran calling sequence:
    # subroutine hfmm3d(nd,eps,zk,nsource,source,ifcharge,
    #     $    charge,ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,
    #     $    targ,ifpghtarg,pottarg,gradtarg,hesstarg,ier)
    #

    ier = Integer(0)
    iper = Integer(0)
    
    if ndiv === nothing
        ccall((:hfmm3d_,libfmm3d),Cvoid,(Fi,Fd,Fc,Fi,Fd,Fi,Fc,
                                        Fi,Fc,Fi,Fi,Fc,Fc,Fc,Fi,
                                        Fd,Fi,Fc,Fc,Fc,Fi),
              nd,eps,zk,n,sources,ifcharge,charges,ifdipole,
              dipvecs,iper,pg,pot,grad,hess,nt,targets,pgt,
              pottarg,gradtarg,hesstarg,ier)
    else
        ndiv64 = Int64(ndiv)
        idivflag = Int64(0)
        ifnear = Int64(1)
        timeinfo = zeros(Float64,6)
        ccall((:hfmm3d_ndiv_,libfmm3d),Cvoid,(Fi,Fd,Fc,Fi,Fd,Fi,Fc,
                                             Fi,Fc,Fi,Fi,Fc,Fc,Fc,Fi,
                                             Fd,Fi,Fc,Fc,Fc,Fi,Fi,Fi,
                                             Fd,Fi),
              nd,eps,zk,n,sources,ifcharge,charges,ifdipole,
              dipvecs,iper,pg,pot,grad,hess,nt,targets,pgt,
              pottarg,gradtarg,hesstarg,ndiv64,idivflag,ifnear,
              timeinfo,ier)
    end

    vals.ier = ier
    if (ier != 0); @warn "libfmm3d had an error, see vals.ier"; end    
    
    # load requested values

    if pg == 1 || pg == 2 || pg == 3; vals.pot = pot end
    if pg == 2 || pg == 3; vals.grad = grad end
    if pg == 3; vals.hess = hess end        
    if pgt == 1 || pgt == 2 || pgt == 3; vals.pottarg = pottarg end
    if pgt == 2 || pgt == 3; vals.gradtarg = gradtarg end
    if pgt == 3; vals.hesstarg = hesstarg end    
    
    return vals

end

function hfmm3d(eps::Float64,zk::Union{Float64,ComplexF64},
                sources::Array{Float64};
                charges::TCN=nothing,dipvecs::TCN=nothing,
                targets::TFN=nothing,pg::Integer=0,pgt::Integer=0,
                nd::Integer=1)
    return _hfmm3d_impl(eps,zk,sources,charges=charges,dipvecs=dipvecs,
                        targets=targets,pg=pg,pgt=pgt,nd=nd)
end

function hfmm3d_ndiv(eps::Float64,zk::Union{Float64,ComplexF64},
                     sources::Array{Float64},ndiv::Integer;
                     charges::TCN=nothing,dipvecs::TCN=nothing,
                     targets::TFN=nothing,pg::Integer=0,pgt::Integer=0,
                     nd::Integer=1)
    return _hfmm3d_impl(eps,zk,sources,charges=charges,dipvecs=dipvecs,
                        targets=targets,pg=pg,pgt=pgt,nd=nd,ndiv=ndiv)
end

"""
```julia
    vals = h3ddir(zk,sources,targets;charges=nothing,
                    dipvecs=nothing,pgt=0,nd=1,
                    thresh=1e-16)
```

This function computes the N-body Helmholtz interactions
in three dimensions where the interaction kernel is given 
by ``e^{ikr}/(4\\pi r)`` and its gradients. This is the 
``O(N^2)`` direct evaluation code. By convention this code only computes 
the effect of sources on targets. If the value at sources is 
also needed, the routine can be called again with targets equal
to the source locations.

```math
 u(x) = \\sum_{j=1}^{N} c_{j} \\frac{e^{ik \\|x-x_{j}\\|}}{4\\pi\\|x-x_{j}\\|} 
- v_{j} \\cdot \\nabla \\left( \\frac{e^{ik \\|x-x_{j}\\|}}{4\\pi\\|x-x_{j}\\|} 
\\right)  \\, , 
```
 
where ``c_{j}`` are the charge densities,  
      ``v_{j}`` are the dipole orientation vectors, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum

# Input

* `zk::ComplexF64` Helmholtz parameter 
* `sources::Array{Float64}` size (3,n) source locations (``x_{j}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)

# Optional Keyword Input

* `charges::Array{ComplexF64}` size (nd,n) or (n) charge densities (c_{j})
* `dipvecs::Array{ComplexF64}` size (nd,3,n) or (3,n)) dipole orientation vectors (``v_{j}``)
* `pgt::Integer` target eval flag. 
    + Potential at targets evaluated if `pgt == 1`. 
    + Potential and gradient at targets evaluated if `pgt == 2`
    + Potential, gradient, and Hessian at targets evaluated if `pgt == 3`
* `nd::Integer` number of densities
* `thresh::Float64` threshold for ignoring interactions when ``\\|x-x_{j}\\| \\leq thresh``

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

Note that the Hessian is returned as a length
6 vector at each point with the second derivatives
in the order: ``\\partial_{xx}``, ``\\partial_{yy}``,
``\\partial_{zz}``, ``\\partial_{xy}``, 
``\\partial_{xz}``, ``\\partial_{yz}``.

* `vals.pottarg::Array{ComplexF64}` size (nd,nt) or (nt) potential at target locations if requested
* `vals.gradtarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) gradient at target locations if requested
* `vals.hesstarg::Array{ComplexF64}` size (nd,6,nt) or (6,nt) gradient at target locations if requested
"""
function h3ddir(zk::Union{ComplexF64,Float64},sources::Array{Float64},
                targets::Array{Float64};
                charges::TCN=nothing,dipvecs::TCN=nothing,
                pgt::Integer=0,nd::Integer=1,
                thresh::Float64=1e-16)

    zk = complex(zk)
    
    # default values

    vals = FMMVals()
    
    ifcharge = 0
    ifdipole = 0

    zero = ComplexF64(0)
    
    pottarg = zero
    gradtarg = zero
    hesstarg = zero

    # check inputs

    if (pgt == 3)
        @warn "Hessian not implemented for Helmholtz fmm, only computing potential and gradients at targets"
        pgt = 2
    end

    
    pg = 0
    anyfail, n, nt, ifcharge, ifdipole = (
        scalarfmm3dinputcheck(sources,charges,dipvecs,targets,pg,pgt,nd))

    if anyfail
        return vals
    end

    if (ifcharge == 0); charges = zero end
    if (ifdipole == 0); dipvecs = zero end
    if (nt == 0); targets = 0.0 end

    # allocate memory for return values
    
    if pgt == 1 || pgt == 2 || pgt == 3
        if nd > 1
            pottarg = zeros(ComplexF64,nd,nt)
        else
            pottarg = zeros(ComplexF64,nt)
        end
    end

    if pgt == 2 || pgt == 3
        if nd > 1
            gradtarg = zeros(ComplexF64,nd,3,nt)
        else
            gradtarg = zeros(ComplexF64,3,nt)
        end
    end

    if pgt == 3
        if nd > 1
            hesstarg = zeros(ComplexF64,nd,6,nt)
        else
            hesstarg = zeros(ComplexF64,6,nt)
        end
    end

    # dispatch to appropriate wrapper
    
    if pgt == 1
        if ifcharge == 1
            if ifdipole == 1
                h3ddirectcdp!(nd,zk,sources,charges,
                              dipvecs,n,targets,nt,
                              pottarg,thresh)
                vals.pottarg = pottarg
            else
                h3ddirectcp!(nd,zk,sources,charges,
                             n,targets,nt,pottarg,
                             thresh)
                vals.pottarg = pottarg
            end
        else
            if ifdipole == 1
                h3ddirectdp!(nd,zk,sources,
                             dipvecs,n,targets,nt,
                             pottarg,thresh)
                vals.pottarg = pottarg
            end
        end
    elseif pgt == 2
        if ifcharge == 1
            if ifdipole == 1
                h3ddirectcdg!(nd,zk,sources,charges,
                              dipvecs,n,targets,nt,
                              pottarg,gradtarg,thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg                
            else
                h3ddirectcg!(nd,zk,sources,charges,
                             n,targets,nt,pottarg,
                             gradtarg,thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg                                
            end
        else
            if ifdipole == 1
                h3ddirectdg!(nd,zk,sources,
                              dipvecs,n,targets,nt,
                             pottarg,gradtarg,thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg                                
            end
        end
    elseif pgt == 3
        if ifcharge == 1
            if ifdipole == 1
                h3ddirectcdh!(nd,zk,sources,charges,
                              dipvecs,n,targets,nt,
                              pottarg,gradtarg,hesstarg,thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg
                vals.hesstarg = hesstarg                                
            else
                h3ddirectch!(nd,zk,sources,charges,
                             n,targets,nt,pottarg,
                             gradtarg,hesstarg,thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg
                vals.hesstarg = hesstarg                                                
            end
        else
            if ifdipole == 1
                h3ddirectdh!(nd,zk,sources,
                              dipvecs,n,targets,nt,
                             pottarg,gradtarg,hesstarg,
                             thresh)
                vals.pottarg = pottarg
                vals.gradtarg = gradtarg
                vals.hesstarg = hesstarg                                                
            end
        end
    end                
            
    return vals

end

function h3ddirectcp!(nd,zk,sources,charges,n,targets,nt,
                      pot,thresh)
    ccall((:h3ddirectcp_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fd),
          nd,zk,sources,charges,n,targets,nt,pot,thresh)
    return
end

function h3ddirectdp!(nd,zk,sources,dipvecs,n,targets,nt,
                      pot,thresh)
    ccall((:h3ddirectdp_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fd),
          nd,zk,sources,dipvecs,n,targets,nt,pot,thresh)
    return
end

function h3ddirectcdp!(nd,zk,sources,charges,dipvecs,n,targets,
                       nt,pot,thresh)
    ccall((:h3ddirectcdp_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fc,Fi,
                                          Fd,Fi,Fc,Fd),
          nd,zk,sources,charges,dipvecs,n,targets,nt,pot,thresh)
    return
end

function h3ddirectcg!(nd,zk,sources,charges,n,targets,nt,
                      pot,grad,thresh)
    ccall((:h3ddirectcg_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fd),
          nd,zk,sources,charges,n,targets,nt,pot,grad,thresh)
    return
end

function h3ddirectdg!(nd,zk,sources,dipvecs,n,targets,nt,
                      pot,grad,thresh)
    ccall((:h3ddirectdg_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fd),
          nd,zk,sources,dipvecs,n,targets,nt,pot,grad,thresh)
    return
end

function h3ddirectcdg!(nd,zk,sources,charges,dipvecs,n,targets,
                       nt,pot,grad,thresh)
    ccall((:h3ddirectcdg_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fd),
          nd,zk,sources,charges,dipvecs,n,targets,nt,pot,grad,thresh)
    return
end

function h3ddirectch!(nd,zk,sources,charges,n,targets,nt,
                      pot,grad,hess,thresh)
    ccall((:h3ddirectch_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fc,Fd),
          nd,zk,sources,charges,n,targets,nt,pot,grad,hess,thresh)
    return
end

function h3ddirectdh!(nd,zk,sources,dipvecs,n,targets,nt,
                      pot,grad,hess,thresh)
    ccall((:h3ddirectdh_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fc,Fd),
          nd,zk,sources,dipvecs,n,targets,nt,pot,grad,hess,thresh)
    return
end

function h3ddirectcdh!(nd,zk,sources,charges,dipvecs,n,targets,
                       nt,pot,grad,hess,thresh)
    ccall((:h3ddirectcdh_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fc,Fi,
                                          Fd,Fi,Fc,Fc,Fc,Fd),
          nd,zk,sources,charges,dipvecs,n,targets,nt,pot,grad,hess,thresh)
    return
end

    
"""
```julia
    vals = lfmm3d(eps,sources;charges=nothing,dipvecs=nothing,
                  targets=nothing,pg=0,pgt=0,nd=1)
```

This function computes the N-body Laplace interactions
in three dimensions where the interaction kernel is given 
by ``\$1/(4\\pi r)\$`` and its gradients.  This is the 
``O(N)`` fast multipole code which computes the interactions
to the requested precision.

```math
u(x) = \\sum_{j=1}^{N} c_{j} \\frac{1}{4\\pi\\|x-x_{j}\\|} 
- v_{j} \\cdot \\nabla \\left( \\frac{1}{4\\pi\\|x-x_{j}\\|} 
\\right)  \\, , 
```
 
where ``c_{j}`` are the charge densities,  
      ``v_{j}`` are the dipole orientation vectors, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum

# Input

* `eps::Float64` precision requested
* `sources::Array{Float64}` size (3,n) source locations (``x_{j}``)

# Optional Keyword Input

* `charges::Array{Float64}` size (nd,n) or (n) charge densities (c_{j})
* `dipvecs::Array{Float64}` size (nd,3,n) or (3,n)) dipole orientation vectors (``v_{j}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)
* `pg::Integer` source eval flag. 
    + Potential (``u``) at sources evaluated if `pg == 1`. 
    + Potential and gradient (``\\nabla u``) at sources evaluated if `pg == 2`
* `pgt::Integer` target eval flag. 
    + Potential at targets evaluated if `pgt == 1`. 
    + Potential and gradient at targets evaluated if `pgt == 2`
* `nd::Integer` number of densities

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

Note that the Hessian is returned as a length
6 vector at each point with the second derivatives
in the order: ``\\partial_{xx}``, ``\\partial_{yy}``,
``\\partial_{zz}``, ``\\partial_{xy}``, 
``\\partial_{xz}``, ``\\partial_{yz}``.

* `vals.pot::Array{Float64}` size (nd,n) potential at source locations if requested
* `vals.grad::Array{Float64}` size (nd,3,n) gradient at source locations if requested
* `vals.hess::Array{Float64}` size (nd,6,n) Hessian at source locations if requested
* `vals.pottarg::Array{Float64}` size (nd,nt) potential at target locations if requested
* `vals.gradtarg::Array{Float64}` size (nd,3,nt) gradient at target locations if requested
* `vals.hesstarg::Array{Float64}` size (nd,6,nt) Hessian at target locations if requested
* `vals.ier` error flag as returned by FMM3D library. A value of 0 indicates a successful call. 
Non-zero values may indicate insufficient memory available. See the documentation for the FMM3D library. 
If not set (`nothing`), then FMM3D library was never called.
"""
function _lfmm3d_impl(eps::Float64,sources::Array{Float64};charges::TFN=nothing,
                      dipvecs::TFN=nothing,targets::TFN=nothing,
                      pg::Integer=0,pgt::Integer=0,nd::Integer=1,
                      ndiv::Union{Integer,Nothing}=nothing)

    # default values

    vals = FMMVals()
    
    ifcharge = 0
    ifdipole = 0

    zero = Float64(0)
    
    pot = zero
    grad = zero
    hess = zero
    pottarg = zero
    gradtarg = zero
    hesstarg = zero

    # check inputs

    anyfail, n, nt, ifcharge, ifdipole = (
        scalarfmm3dinputcheck(sources,charges,dipvecs,targets,pg,pgt,nd))

    if anyfail
        return vals
    end
    if ndiv !== nothing && ndiv < 1
        @warn "ndiv must be a positive integer, computing nothing"
        return vals
    end

    if (ifcharge == 0); charges = zero end
    if (ifdipole == 0); dipvecs = zero end
    if (nt == 0); targets = 0.0 end

    # allocate memory for return values
    
    if pg == 1 || pg == 2 || pg == 3
        if nd > 1
            pot = zeros(Float64,nd,n)
        else
            pot = zeros(Float64,n)
        end
    end

    if pg == 2 || pg == 3
        if nd > 1
            grad = zeros(Float64,nd,3,n)
        else
            grad = zeros(Float64,3,n)
        end
    end

    if pg == 3
        if nd > 1
            hess = zeros(Float64,nd,6,n)
        else
            hess = zeros(Float64,6,n)
        end
    end

    if pgt == 1 || pgt == 2 || pgt == 3
        if nd > 1
            pottarg = zeros(Float64,nd,nt)
        else
            pottarg = zeros(Float64,nt)
        end
    end

    if pgt == 2 || pgt == 3
        if nd > 1
            gradtarg = zeros(Float64,nd,3,nt)
        else
            gradtarg = zeros(Float64,3,nt)
        end
    end

    if pgt == 3
        if nd > 1
            hesstarg = zeros(Float64,nd,6,nt)
        else
            hesstarg = zeros(Float64,6,nt)
        end
    end

    # actually call the function
    #
    # fortran calling sequence:
    # subroutine lfmm3d(nd,eps,nsource,source,ifcharge,
    #     $    charge,ifdipole,dipvec,iper,ifpgh,pot,grad,
    #     $    hess,ntarg,
    #     $    targ,ifpghtarg,pottarg,gradtarg,hesstarg,ier)
    #


    ier = Integer(0)
    iper = Integer(0)
    
    if ndiv === nothing
        ccall((:lfmm3d_,libfmm3d),Cvoid,(Fi,Fd,Fi,Fd,Fi,Fd,
                                        Fi,Fd,Fi,Fi,Fd,Fd,Fd,Fi,
                                        Fd,Fi,Fd,Fd,Fd,Fi),
              nd,eps,n,sources,ifcharge,charges,ifdipole,
              dipvecs,iper,pg,pot,grad,hess,nt,targets,pgt,
              pottarg,gradtarg,hesstarg,ier)
    else
        ndiv64 = Int64(ndiv)
        idivflag = Int64(0)
        ifnear = Int64(1)
        timeinfo = zeros(Float64,6)
        ccall((:lfmm3d_ndiv_,libfmm3d),Cvoid,(Fi,Fd,Fi,Fd,Fi,Fd,
                                             Fi,Fd,Fi,Fi,Fd,Fd,Fd,Fi,
                                             Fd,Fi,Fd,Fd,Fd,Fi,Fi,Fi,
                                             Fd,Fi),
              nd,eps,n,sources,ifcharge,charges,ifdipole,
              dipvecs,iper,pg,pot,grad,hess,nt,targets,pgt,
              pottarg,gradtarg,hesstarg,ndiv64,idivflag,ifnear,
              timeinfo,ier)
    end

    if (ier != 0); @warn "libfmm3d had an error, see vals.ier"; end
    vals.ier = ier

    # load requested values

    if pg == 1 || pg == 2 || pg == 3; vals.pot = pot end
    if pg == 2 || pg == 3; vals.grad = grad end
    if pg == 3; vals.hess = hess end        
    if pgt == 1 || pgt == 2 || pgt == 3; vals.pottarg = pottarg end
    if pgt == 2 || pgt == 3; vals.gradtarg = gradtarg end
    if pgt == 3; vals.hesstarg = hesstarg end    
    
    return vals

end

function lfmm3d(eps::Float64,sources::Array{Float64};charges::TFN=nothing,
                dipvecs::TFN=nothing,targets::TFN=nothing,
                pg::Integer=0,pgt::Integer=0,nd::Integer=1)
    return _lfmm3d_impl(eps,sources,charges=charges,dipvecs=dipvecs,
                        targets=targets,pg=pg,pgt=pgt,nd=nd)
end

function lfmm3d_ndiv(eps::Float64,sources::Array{Float64},ndiv::Integer;
                     charges::TFN=nothing,dipvecs::TFN=nothing,
                     targets::TFN=nothing,pg::Integer=0,pgt::Integer=0,
                     nd::Integer=1)
    return _lfmm3d_impl(eps,sources,charges=charges,dipvecs=dipvecs,
                        targets=targets,pg=pg,pgt=pgt,nd=nd,ndiv=ndiv)
end


"""
```julia
    vals = l3ddir(sources,targets;charges=nothing,
                dipvecs=nothing,pgt=0,nd=1,
                thresh=1e-16)
```

This function computes the N-body Laplace interactions
in three dimensions where the interaction kernel is given 
by ``1/(4\\pi r)`` and its gradients.  This is the 
``O(N^2)`` direct evaluation code. By convention this code only computes 
the effect of sources on targets. If the value at sources is 
also needed, the routine can be called again with targets equal
to the source locations.

```math
 u(x) = \\sum_{j=1}^{N} c_{j} \\frac{1}{4\\pi\\|x-x_{j}\\|} 
- v_{j} \\cdot \\nabla \\left( \\frac{1}{4\\pi\\|x-x_{j}\\|} 
\\right)  \\, , 
```
 
where ``c_{j}`` are the charge densities,  
      ``v_{j}`` are the dipole orientation vectors, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum

# Input

* `sources::Array{Float64}` size (3,n) source locations (``x_{j}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)

# Optional Keyword Input

* `charges::Array{ComplexF64}` size (nd,n) or (n) charge densities (c_{j})
* `dipvecs::Array{ComplexF64}` size (nd,3,n) or (3,n)) dipole orientation vectors (``v_{j}``)
* `pgt::Integer` target eval flag. 
    + Potential at targets evaluated if `pgt == 1`. 
    + Potential and gradient at targets evaluated if `pgt == 2`
* `nd::Integer` number of densities
* `thresh::Float64` threshold for ignoring interactions when ``\\|x-x_{j}\\| \\leq thresh``

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

* `vals.pottarg::Array{ComplexF64}` size (nd,nt) or (nt) potential at target locations if requested
* `vals.gradtarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) gradient at target locations if requested
"""
function l3ddir(sources::Array{Float64},targets::Array{Float64};
                charges::TFN=nothing,dipvecs::TFN=nothing,
                pgt::Integer=0,nd::Integer=1,
                thresh::Float64=1e-16)
    
    # default values

    vals = FMMVals()
    
    ifcharge = 0
    ifdipole = 0

    zero = Float64(0)
    
    pottarg = zero
    gradtarg = zero
    hesstarg = zero

    # check inputs


    pg = 0
    anyfail, n, nt, ifcharge, ifdipole = (
        scalarfmm3dinputcheck(sources,charges,dipvecs,targets,pg,pgt,nd))

    if anyfail
        return vals
    end

    if (ifcharge == 0); charges = zero end
    if (ifdipole == 0); dipvecs = zero end
    if (nt == 0); targets = 0.0 end

    # allocate memory for return values
    
    if pgt == 1 || pgt == 2
        if nd > 1
            pottarg = zeros(Float64,nd,nt)
        else
            pottarg = zeros(Float64,nt)
        end
    end

    if pgt == 2
        if nd > 1
            gradtarg = zeros(Float64,nd,3,nt)
        else
            gradtarg = zeros(Float64,3,nt)
        end
    end

    # dispatch to appropriate wrapper
    
    if pgt == 1
        if ifcharge == 1
            if ifdipole == 1
                l3ddirectcdp!(nd,sources,charges,
                              dipvecs,n,targets,nt,
                              pottarg,thresh)
            else
                l3ddirectcp!(nd,sources,charges,
                             n,targets,nt,pottarg,
                             thresh)
            end
        else
            if ifdipole == 1
                l3ddirectdp!(nd,sources,
                             dipvecs,n,targets,nt,
                             pottarg,thresh)
            end
        end
    elseif pgt == 2
        if ifcharge == 1
            if ifdipole == 1
                l3ddirectcdg!(nd,sources,charges,
                              dipvecs,n,targets,nt,
                              pottarg,gradtarg,thresh)
            else
                l3ddirectcg!(nd,sources,charges,
                             n,targets,nt,pottarg,
                             gradtarg,thresh)
            end
        else
            if ifdipole == 1
                l3ddirectdg!(nd,sources,
                              dipvecs,n,targets,nt,
                             pottarg,gradtarg,thresh)
            end
        end
    end                

    if pgt == 1 || pgt == 2 ; vals.pottarg = pottarg end
    if pgt == 2; vals.gradtarg = gradtarg end
    
    return vals

end

function l3ddirectcp!(nd,sources,charges,n,targets,nt,
                      pot,thresh)
    ccall((:l3ddirectcp_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd),
          nd,sources,charges,n,targets,nt,pot,thresh)
    return
end

function l3ddirectdp!(nd,sources,dipvecs,n,targets,nt,
                      pot,thresh)
    ccall((:l3ddirectdp_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd),
          nd,sources,dipvecs,n,targets,nt,pot,thresh)
    return
end

function l3ddirectcdp!(nd,sources,charges,dipvecs,n,targets,
                       nt,pot,thresh)
    ccall((:l3ddirectcdp_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd),
          nd,sources,charges,dipvecs,n,targets,nt,pot,thresh)
    return
end

function l3ddirectcg!(nd,sources,charges,n,targets,nt,
                      pot,grad,thresh)
    ccall((:l3ddirectcg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd,Fd),
          nd,sources,charges,n,targets,nt,pot,grad,thresh)
    return
end

function l3ddirectdg!(nd,sources,dipvecs,n,targets,nt,
                      pot,grad,thresh)
    ccall((:l3ddirectdg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd,Fd),
          nd,sources,dipvecs,n,targets,nt,pot,grad,thresh)
    return
end

function l3ddirectcdg!(nd,sources,charges,dipvecs,n,targets,
                       nt,pot,grad,thresh)
    ccall((:l3ddirectcdg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fd,Fi,
                                          Fd,Fi,Fd,Fd,Fd),
          nd,sources,charges,dipvecs,n,targets,nt,pot,grad,thresh)
    return
end

"""
    function fj, fjder = besseljs3d(nterms,z;scale=1.0,ifder=0)

This subroutine evaluates the first `nterms` spherical Bessel 
functions, and if requested, their derivatives.
It incorporates a scaling parameter `scale` so that
      
      	fjs_n(z)=j_n(z)/SCALE^n
      	fjder_n(z)=\\frac{\\partial fjs_n(z)}{\\partial z}

# Input

* `nterms::Integer` order of expansion of output array `fjs` 
* `z::ComplexF64` argument of the spherical Bessel functions
* `scale::Float64` scaling factor
* `ifder::Integer1` flag indicating whether to calculate `fjder`
      	          0	NO
      	          1	YES
OUTPUT:

* `fjs::Array{ComplexF64}` array of length `nterms+1` of scaled Bessel functions.
* `fjder::Array{ComplexF64}` array of derivatives of scaled Bessel functions, if requested.
"""
function besseljs3d(nterms::Integer,z::ComplexF64;scale::Float64=1.0,
                    ifder::Integer=0)

    if (nterms < 0)
        @warn "nterms has invalid value, computing nothing"
        fjs = nothing; fjder = nothing;
        return fjs, fjder
    end
    if (ifder !=0 && ifder != 1)
        @warn "unexpected value in ifder, no ders computed"
    end

    fjs = Array{ComplexF64}(undef,nterms+1)
    fjder = ComplexF64(0)

    
    
    if ifder == 1
        fjder = Array{ComplexF64}(undef,nterms+1)
    end
    
    # fortran interface
    # subroutine besseljs3d(nterms,z,scale,fjs,ifder,fjder)
    
    ccall((:besseljs3d_,libfmm3d),Cvoid,(Fi,Fc,Fd,Fc,Fi,Fc),
          nterms,z,scale,fjs,ifder,fjder)

    if ifder != 1
        fjder = nothing
    end

    return fjs, fjder
    
end


"""
```julia
    anyfail, n, nt, ifstoklet, ifstrslet, ifrotlet, ifdoublet = (
        stfmm3dinputcheck(sources,stoklet,strslet,strsvec,
                          rotlet,rotvec,doublet,doubvec,
                                targets,ppreg,ppregt,nd) )
```

Input checking for Stokes routines. 
Checks the sizes of these arrays and the compatibility
of the various flags, nd, and provided arrays. 
If something is off, a warning is issued and 
`anyfail` is set to true. Non-fatal mistakes result in
a warning but `anyfail` remains false. 

Output:
* `anyfail` - boolean is true if any checks fail, false otherwise
* n - integer, number of sources
* nt - integer, number of targets
* ifstoklet - integer, is 1 if there are Stokeslets, 0 otherwise
* ifstrslet - integer, is 1 if there are (type I) stresslets, 0 otherwise
* ifrotlet - integer, is 1 if there are rotlet, 0 otherwise
* ifdoublet - integer, is 1 if there are doublet, 0 otherwise
"""
function stfmm3dinputcheck(sources,stoklet,strslet,strsvec,rotlet,rotvec,doublet,doubvec,targets,ppreg,ppregt,nd)
    anyfail = false
    
    if (size(sources,1) != 3)
        @warn "sources array is wrong shape, computing nothing"
        anyfail = true
    end
    if (nd < 0)
        @warn "nd has invalid value, computing nothing"
        anyfail = true
    end
    if (ppreg > 3 || ppreg < 0)
        @warn "flag ppreg not in expected range, computing nothing"
        anyfail = true
    end
    if (ppregt > 3 || ppregt < 0)
        @warn "flag ppregt not in expected range, computing nothing"
        anyfail = true
    end    

    n = div(length(sources),3)
    nt = 0

    if targets != nothing
        if (size(targets,1) != 3)
            @warn "targets array is wrong shape, computing nothing"
            anyfail = true
        end
        nt = div(length(targets),3)
    end
    
    if stoklet != nothing
        if (div(length(stoklet),nd) != 3*n)
            @warn "size of stoklet array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ifstoklet = 1
    else
        ifstoklet = 0
    end

    if (strslet != nothing || strsvec != nothing)
        if (strsvec == nothing || strslet == nothing)
            @warn "if stresslets in calculation, need both strslet and strsvec arrays, computing nothing"
            anyfail = true
        end
        if (div(length(strslet),nd) != n*3)
            @warn "size of strslet array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        if (div(length(strsvec),nd) != n*3)
            @warn "size of strsvec array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        ifstrslet = 1
    else
        ifstrslet = 0
    end

    if (rotlet != nothing || rotvec != nothing)
        if (rotlet == nothing || rotvec == nothing)
            @warn "if rotlet in calculation, need both rotlet and rotvec arrays, computing nothing"
            anyfail = true
        end
        if (div(length(rotlet),nd) != n*3)
            @warn "size of rotlet array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        if (div(length(rotvec),nd) != n*3)
            @warn "size of rotvec array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        ifrotlet = 1
    else
        ifrotlet = 0
    end

    if (doublet != nothing || doubvec != nothing)
        if (doublet == nothing || doubvec == nothing)
            @warn "if doublet in calculation, need both doublet and doubvec arrays, computing nothing"
            anyfail = true
        end
        if (div(length(doublet),nd) != n*3)
            @warn "size of doublet array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        if (div(length(doubvec),nd) != n*3)
            @warn "size of doubvec array is incompatible with sources array and nd paramter, computing nothing"
            anyfail = true
        end
        ifdoublet = 1
    else
        ifdoublet = 0
    end

    if ifstoklet == 0 && ifstrslet == 0 && ifrotlet == 0 && ifdoublet == 0
        @warn "no Stokeslets or stresslets or rotlet or doublet provided, doing nothing"
        anyfail = true
    end

    if (ppreg != 1 && ppreg != 2 && ppreg != 3) && (ppregt != 1 && ppregt != 2 && ppregt != 3)
        @warn "no output requested, doing nothing"
        anyfail = true
    end

    if (ppregt == 1 || ppregt == 2 || ppregt == 3) && targets == nothing
        if !anyfail
            @warn "target values requested but no targets provided, proceeding anyway"
        else
            @warn "target values requested but no targets provided. There are other points of failure. Computing nothing."
        end
    end

    return anyfail, n, nt, ifstoklet, ifstrslet, ifrotlet, ifdoublet
end


"""
```julia
    vals = stfmm3d(eps,sources;stoklet=nothing,strslet=nothing,
                   strsvec=nothing,rotlet=nothing,rotvec=nothing,
                   doublet=nothing,doubvec=nothing,
                   targets=nothing,ppreg=0,ppregt=0,nd=1)
```

This function computes the N-body Stokes interactions
in three dimensions where the interaction kernels are
the Stokeslet and stresslet (see below). This is the
``O(N)`` fast multipole code which computes the interactions
to the requested precision.

We take the following conventions for the Stokes kernels:

For a source ``y`` and target ``x``, let ``r_i = x_i-y_i``
 and let ``r = \\sqrt{r_1^2 + r_2^2 + r_3^2}``

The Stokeslet, ``G_{ij}``, and its associated pressure tensor,
``P_j``, are

```math
G_{ij}(x,y) = (r_i r_j)/(8\\pi r^3) + \\delta_{ij}/(8\\pi r) \\; ,
\\quad
P_j(x,y) = r_j/(4\\pi r^3)
```
The (Type I) stresslet, ``T_{ijk}``, and its associated
pressure tensor, ``\\Pi_{jk}``, are

```math
 T_{ijk}(x,y) = 3 r_i r_j r_k/ (4\\pi r^5) \\; , \\quad
 PI_{jk} = -1/(2\\pi) \\delta_{jk} + 3 r_j r_k/(2\\pi r^5)
```
The rotlet, ``R_{ijk}``, and its associated pressure tensor,
``Q_{jk}``, are

```math
 R_{ijk}(x,y) = -\\delta_{ik} r_j/(4\\pi r^3) + \\delta_{ij} r_k/(4\\pi r^3)\\; , \\quad
 Q_{jk} = 0;
```
The doublet, ``D_{ijk}``, and its associated pressure tensor,
``L_{jk}``, are

```math
 D_{ijk}(x,y) = -\\delta_{jk} r_i/(4\\pi r^3) - \\delta_{ik} r_j/(4\\pi r^3) + \\delta_{ij} r_k/(4\\pi r^3) + 3 r_i r_j r_k/ (4\\pi r^5)\\; , \\quad
 L_{jk} = -1/(2\\pi) \\delta_{jk} + 3 r_j r_k/(2\\pi r^5)
```

The output of this routine gives the velocity
```math
 u_i(x) = \\sum_{m=1}^{N} G_{ij}(x,x_m) \\sigma^{(m)}_j
    + T_{ijk}(x,x_m) \\mu^{(m)}_j \\nu^{(m)}_k
    + R_{ijk}(x,x_m) rd^{(m)}_j rv^{(m)}_k
    + D_{ijk}(x,x_m) dd^{(m)}_j dv^{(m)}_k \\,
```
and, optionally, the pressure

```math
 p(x) = \\sum_{m=1}^{N} P_{j}(x,x_m) \\sigma^{(m)}_j
    + \\PI_{jk}(x,x_m) \\mu^{(m)}_j \\nu^{(m)}_k
    + \\L_{jk}(x,x_m) dd^{(m)}_j dv^{(m)}_k \\, ,
```
where ``\\sigma^{(m)}`` is a Stokeslet density 3-vector,
``\\mu^{(m)}`` and ``\\nu^{(m)}`` are the stresslet
density and orientation 3-vectors,
``rd^{(m)}`` and ``rv^{(m)}`` are the rotlet
density and orientation 3-vectors,
``dd^{(m)}`` and ``dv^{(m)}`` are the doublet
density and orientation 3-vectors, and
``x_{m}`` are the source locations.
When ``x=x_{m}``, the term corresponding to 
``x_{m}`` is dropped from the sum.
The gradient of the velocity can also be computed by request.

# Input

* `eps::Float64` precision requested
* `sources::Array{Float64}` size (3,n) source locations (``x_{m}``)

# Optional Keyword Input

* `stoklet::Array{Float64}` size (nd,3,n) or (3,n) Stokeslet densities (``\\sigma``)
* `strslet::Array{Float64}` size (nd,3,n) or (3,n) Stresslet densities (``\\mu'')  if either strsvec or strslet is provided, the other must be as well
* `strsvec::Array{Float64}` size (nd,3,n) or (3,n) Stresslet orientations (``\\nu``) if either strsvec or strslet is provided, the other must be as well
* `rotlet::Array{Float64}` size (nd,3,n) or (3,n) Rotlet densities (``rd'')  if either rotvec or rotlet is provided, the other must be as well
* `rotvec::Array{Float64}` size (nd,3,n) or (3,n) Rotlet orientations (``rv``) if either rotvec or rotlet is provided, the other must be as well
* `doublet::Array{Float64}` size (nd,3,n) or (3,n) Doublet densities (``dd'')  if either doubvec or doublet is provided, the other must be as well
* `doubvec::Array{Float64}` size (nd,3,n) or (3,n) Doublet orientations (``dv``) if either doubvec or doublet is provided, the other must be as well
* `targets::Array{Float64}` size (3,nt) target locations (``x``)
* `ppreg::Integer` source eval flag.
    + Velocity (``u``) at sources evaluated if `ppreg == 1`.
    + Velocity and pressure (``p``) at sources evaluated if `ppreg == 2`
    + Velocity, pressure, and velocity gradient (``\\nabla u``)
    at sources evaluated if `ppreg == 3`
* `ppregt::Integer` source eval flag.
    + Velocity (``u``) at targets evaluated if `ppregt == 1`.
    + Velocity and pressure (``p``) at targets evaluated if `ppregt == 2`
    + Velocity, pressure, and velocity gradient (``\\nabla u``)
    at targets evaluated if `ppregt == 3`
* `nd::Integer` number of densities of each type

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

* `vals.pot::Array{Float64}` size (nd,3,n) or (3,n) velocity at source locations if requested
* `vals.grad::Array{Float64}` size (nd,3,3,n) or (3,n) gradient of velocity at source locations if requested.
`grad[l,i,j,k]` is the i-th component of the gradient of the j-th component of the velocity
for the l-th density at the k-th source location
* `vals.pre::Array{Float64}` size (nd,n) or (n) pressure at source locations if requested
* `vals.pottarg::Array{Float64}` size (nd,3,nt) or (3,nt) velocity at target locations if requested
* `vals.gradtarg::Array{Float64}` size (nd,3,3,nt) or (3,nt) gradient of velocity at target locations if requested.
`gradtarg[l,i,j,k]` is the i-th component of the gradient of the j-th component of the velocity
for the l-th density at the k-th target location
* `vals.pretarg::Array{Float64}` size (nd,nt) or (nt) pressure at target locations if requested
* `vals.ier` error flag as returned by FMM3D library. A value of 0 indicates a successful call. 
Non-zero values may indicate insufficient memory available. See the documentation for the FMM3D library. 
If not set (`nothing`), then FMM3D library was never called.
"""
function stfmm3d(eps::Float64,
                sources::Array{Float64};
                 stoklet::TFN=nothing,strslet::TFN=nothing,
                 strsvec::TFN=nothing,
                 rotlet::TFN=nothing,rotvec::TFN=nothing,
                 doublet::TFN=nothing,doubvec::TFN=nothing,
                 targets::TFN=nothing,ppreg::Integer=0,
                 ppregt::Integer=0,nd::Integer=1)

    # default values

    vals = FMMVals()
    
    ifstoklet = 0
    ifstrslet = 0
    ifrotlet = 0
    ifdoublet = 0

    zero = Float64(0)
    zero3 = zeros(Float64,3)
    
    pot = zero
    grad = zero
    pre = zero
    pottarg = zero
    gradtarg = zero
    pretarg = zero

    ier = Integer(0)

    # check inputs

    anyfail, n, nt, ifstoklet, ifstrslet, ifrotlet, ifdoublet = (
        stfmm3dinputcheck(sources,stoklet,strslet,strsvec,rotlet,rotvec,doublet,doubvec,targets,ppreg,ppregt,nd))

    if anyfail
        return vals
    end

    if (ifstoklet == 0); stoklet = zero3 end
    if (ifstrslet == 0); strslet = zero3; strsvec=zero3 end
    if (ifrotlet == 0); rotlet = zero3; rotvec=zero3 end
    if (ifdoublet == 0); doublet = zero3; doubvec=zero3 end
    if (nt == 0); targets = zero3 end

    # allocate memory for return values
    
    if ppreg == 1 || ppreg == 2 || ppreg == 3
        if nd > 1
            pot = zeros(Float64,nd,3,n)
        else
            pot = zeros(Float64,3,n)
        end
    end

    if ppreg == 2 || ppreg == 3
        if nd > 1
            pre = zeros(Float64,nd,n)
        else
            pre = zeros(Float64,n)
        end
    end

    if ppreg == 3
        if nd > 1
            grad = zeros(Float64,nd,3,3,n)
        else
            grad = zeros(Float64,3,3,n)
        end
    end

    if ppregt == 1 || ppregt == 2 || ppregt == 3
        if nd > 1
            pottarg = zeros(Float64,nd,3,nt)
        else
            pottarg = zeros(Float64,3,nt)
        end
    end

    if ppregt == 2 || ppregt == 3
        if nd > 1
            pretarg = zeros(Float64,nd,nt)
        else
            pretarg = zeros(Float64,nt)
        end
    end

    if ppregt == 3
        if nd > 1
            gradtarg = zeros(Float64,nd,3,3,nt)
        else
            gradtarg = zeros(Float64,3,3,nt)
        end
    end

    # actually call the function
    #
    # fortran calling sequence
    #  subroutine stfmm3d(nd, eps, 
    # $                 nsource, source,
    # $                 ifstoklet, stoklet, ifstrslet, strslet, strsvec,
    # $                 ifppreg, pot, pre, grad, ntarg, targ, 
    # $                 ifppregtarg, pottarg, pretarg, gradtarg,ier)    

    
    ccall((:stfmm3d_,libfmm3d),Cvoid,(Fi,Fd,Fi,Fd,Fi,Fd,
                                    Fi,Fd,Fd,Fi,Fd,Fd,Fi,Fd,Fd,
                                    Fi,Fd,Fd,Fd,Fi,
                                    Fd,Fi,Fd,Fd,Fd,Fi),
          nd,eps,n,sources,ifstoklet,stoklet,ifstrslet,
          strslet,strsvec,ifrotlet,rotlet,rotvec,ifdoublet,doublet,doubvec,
          ppreg,pot,pre,grad,nt,targets,ppregt,
          pottarg,pretarg,gradtarg,ier)

    # copy over error message

    if (ier != 0); @warn "libfmm3d had an error, see vals.ier" end
    vals.ier = ier
    
    # load requested values

    if ppreg == 1 || ppreg == 2 || ppreg == 3; vals.pot = pot end
    if ppreg == 2 || ppreg == 3; vals.pre = pre end
    if ppreg == 3; vals.grad = grad end    
    if ppregt == 1 || ppregt == 2 || ppregt == 3; vals.pottarg = pottarg end
    if ppregt == 2 || ppregt == 3; vals.pretarg = pretarg end
    if ppregt == 3; vals.gradtarg = gradtarg end    

    
    return vals

end


"""
```julia
    vals = st3ddir(sources,targets;stoklet=nothing,strslet=nothing,
                   strsvec=nothing,rotlet=nothing,rotvec=nothing,
                   doublet=nothing,doubvec=nothing,ppregt=0,nd=1,thresh=1e-16)
```

This function computes the N-body Stokes interactions
in three dimensions where the interaction kernels are
the Stokeslet and stresslet (see below). This is the 
``O(N^2)`` direct evaluation code. By convention this code only computes 
the effect of sources on targets. If the value at sources is 
also needed, the routine can be called again with targets equal
to the source locations.

We take the following conventions for the Stokes kernels:

For a source ``y`` and target ``x``, let ``r_i = x_i-y_i``
 and let ``r = \\sqrt{r_1^2 + r_2^2 + r_3^2}``

The Stokeslet, ``G_{ij}``, and its associated pressure tensor,
``P_j``, are

```math
G_{ij}(x,y) = (r_i r_j)/(8\\pi r^3) + \\delta_{ij}/(8\\pi r) \\; ,
\\quad
P_j(x,y) = r_j/(4\\pi r^3)
```
The (Type I) stresslet, ``T_{ijk}``, and its associated
pressure tensor, ``\\Pi_{jk}``, are

```math
 T_{ijk}(x,y) = 3 r_i r_j r_k/ (4\\pi r^5) \\; , \\quad
 PI_{jk} = -1/(2\\pi) \\delta_{jk} + 3 r_j r_k/(2\\pi r^5)
```
The rotlet, ``R_{ijk}``, and its associated pressure tensor,
``Q_{jk}``, are

```math
 R_{ijk}(x,y) = -\\delta_{ik} r_j/(4\\pi r^3) + \\delta_{ij} r_k/(4\\pi r^3)\\; , \\quad
 Q_{jk} = 0;
```
The doublet, ``D_{ijk}``, and its associated pressure tensor,
``L_{jk}``, are

```math
 D_{ijk}(x,y) = -\\delta_{jk} r_i/(4\\pi r^3) - \\delta_{ik} r_j/(4\\pi r^3) + \\delta_{ij} r_k/(4\\pi r^3) + 3 r_i r_j r_k/ (4\\pi r^5)\\; , \\quad
 L_{jk} = -1/(2\\pi) \\delta_{jk} + 3 r_j r_k/(2\\pi r^5)
```

The output of this routine gives the velocity
```math
 u_i(x) = \\sum_{m=1}^{N} G_{ij}(x,x_m) \\sigma^{(m)}_j
    + T_{ijk}(x,x_m) \\mu^{(m)}_j \\nu^{(m)}_k
    + R_{ijk}(x,x_m) rd^{(m)}_j rv^{(m)}_k
    + D_{ijk}(x,x_m) dd^{(m)}_j dv^{(m)}_k \\,
```
and, optionally, the pressure

```math
 p(x) = \\sum_{m=1}^{N} P_{j}(x,x_m) \\sigma^{(m)}_j
    + \\PI_{jk}(x,x_m) \\mu^{(m)}_j \\nu^{(m)}_k
    + \\L_{jk}(x,x_m) dd^{(m)}_j dv^{(m)}_k \\, ,
```
where ``\\sigma^{(m)}`` is a Stokeslet density 3-vector,
``\\mu^{(m)}`` and ``\\nu^{(m)}`` are the stresslet
density and orientation 3-vectors,
``rd^{(m)}`` and ``rv^{(m)}`` are the rotlet
density and orientation 3-vectors,
``dd^{(m)}`` and ``dv^{(m)}`` are the doublet
density and orientation 3-vectors, and
``x_{m}`` are the source locations.
When ``x=x_{m}``, the term corresponding to 
``x_{m}`` is dropped from the sum.
The gradient of the velocity can also be computed by request.

# Input

* `sources::Array{Float64}` size (3,n) source locations (``x_{m}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)

# Optional Keyword Input

* `stoklet::Array{Float64}` size (nd,3,n) or (3,n) Stokeslet densities (``\\sigma``)
* `strslet::Array{Float64}` size (nd,3,n) or (3,n) Stresslet densities (``\\mu'')  if either strsvec or strslet is provided, the other must be as well
* `strsvec::Array{Float64}` size (nd,3,n) or (3,n) Stresslet orientations (``\\nu``) if either strsvec or strslet is provided, the other must be as well
* `rotlet::Array{Float64}` size (nd,3,n) or (3,n) Rotlet densities (``rd'')  if either rotvec or rotlet is provided, the other must be as well
* `rotvec::Array{Float64}` size (nd,3,n) or (3,n) Rotlet orientations (``rv``) if either rotvec or rotlet is provided, the other must be as well
* `doublet::Array{Float64}` size (nd,3,n) or (3,n) Doublet densities (``dd'')  if either doubvec or doublet is provided, the other must be as well
* `doubvec::Array{Float64}` size (nd,3,n) or (3,n) Doublet orientations (``dv``) if either doubvec or doublet is provided, the other must be as well
* `ppregt::Integer` source eval flag. 
    + Velocity (``u``) at targets evaluated if `ppregt == 1`. 
    + Velocity and pressure (``p``) at targets evaluated if `ppregt == 2`
    + Velocity, pressure, and velocity gradient (``\\nabla u``) 
    at targets evaluated if `ppregt == 3`
* `nd::Integer` number of densities of each type

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

* `vals.pottarg::Array{Float64}` size (nd,3,nt) or (3,nt) velocity at target locations if requested
* `vals.gradtarg::Array{Float64}` size (nd,3,3,nt) or (3,nt) gradient of velocity at target locations if requested.
`gradtarg[l,i,j,k]` is the i-th component of the gradient of the j-th component of the velocity
for the l-th density at the k-th target location
* `vals.pretarg::Array{Float64}` size (nd,nt) or (nt) pressure at target locations if requested
"""
function st3ddir(sources::Array{Float64},targets::Array{Float64};
                 stoklet::TFN=nothing,strslet::TFN=nothing,
                 strsvec::TFN=nothing,
                 rotlet::TFN=nothing,rotvec::TFN=nothing,
                 doublet::TFN=nothing,doubvec::TFN=nothing,
                 ppregt::Integer=0,nd::Integer=1,thresh=1e-16)

    # default values

    vals = FMMVals()
    
    ifstoklet = 0
    ifstrslet = 0

    zero = Float64(0)
    zero3 = zeros(Float64,3)
    
    pottarg = zero
    gradtarg = zero
    pretarg = zero

    ier = Integer(0)

    # check inputs

    ppreg=0
    anyfail, n, nt, ifstoklet, ifstrslet, ifrotlet, ifdoublet = (
        stfmm3dinputcheck(sources,stoklet,strslet,strsvec,rotlet,rotvec,doublet,doubvec,targets,ppreg,ppregt,nd))

    if anyfail
        return vals
    end

    if (ifstoklet == 0); stoklet = zero3 end
    if (ifstrslet == 0); strslet = zero3; strsvec=zero3 end
    if (ifrotlet == 0); rotlet = zero3; rotvec=zero3 end
    if (ifdoublet == 0); doublet = zero3; doubvec=zero3 end
    if (nt == 0); targets = zero3 end

    # allocate memory for return values

    # for now we always allocate all quantities
    # and return requested
    
    if nd > 1
        pottarg = zeros(Float64,nd,3,nt)
    else
        pottarg = zeros(Float64,3,nt)
    end

    if nd > 1
        pretarg = zeros(Float64,nd,nt)
    else
        pretarg = zeros(Float64,nt)
    end

    if nd > 1
        gradtarg = zeros(Float64,nd,3,3,nt)
    else
        gradtarg = zeros(Float64,3,3,nt)
    end

    # dispatch to appropriate wrapper
    
    if ifstoklet == 1
        st3ddirectstokstrsrotdoubg!(nd,sources,stoklet,
                             ifstrslet,strslet,strsvec,
                             ifrotlet,rotlet,rotvec,
                             ifdoublet,doublet,doubvec,
                             n,targets,nt,pottarg,
                             pretarg,gradtarg,thresh)
    else
        stoklet = zeros(Float64,nd,3,n)
        st3ddirectstokstrsrotdoubg!(nd,sources,stoklet,
                             ifstrslet,strslet,strsvec,
                             ifrotlet,rotlet,rotvec,
                             ifdoublet,doublet,doubvec,
                             n,targets,nt,pottarg,
                             pretarg,gradtarg,thresh)
    end
    
    if ppregt == 1 || ppregt == 2 || ppregt == 3; vals.pottarg = pottarg end
    if ppregt == 2 || ppregt == 3; vals.pretarg = pretarg end
    if ppregt == 3; vals.gradtarg = gradtarg end    

    
    return vals

end

function st3ddirectstokstrsrotdoubg!(nd,sources,stoklet,istress,
                              strslet,strsvec,irotlet,rotlet,rotvec,idoublet,doublet,doubvec,
                              n,targets,nt,pottarg,pretarg,gradtarg,thresh)
    ccall((:st3ddirectstokstrsrotdoubg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,Fd,Fd,
                                                         Fi,Fd,Fd,Fi,Fd,Fd,Fi,
                                                         Fd,Fi,Fd,Fd,Fd,Fd),
          nd,sources,stoklet,istress,
          strslet,strsvec,irotlet,rotlet,rotvec,idoublet,doublet,doubvec,
          n,targets,nt,pottarg,pretarg,gradtarg,thresh)
    return
end

function st3ddirectstokstrsg!(nd,sources,stoklet,istress,
                              strslet,strsvec,n,targets,nt,pottarg,
                              pretarg,gradtarg,thresh)
    ccall((:st3ddirectstokstrsg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,Fd,Fd,Fi,
                                                  Fd,Fi,Fd,Fd,Fd,Fd),
          nd,sources,stoklet,istress,
                              strslet,strsvec,n,targets,nt,pottarg,
          pretarg,gradtarg,thresh)
    return
end

function st3ddirectstokg!(nd,sources,stoklet,n,targets,nt,pottarg,
                              pretarg,gradtarg,thresh)
    ccall((:st3ddirectstokg_,libfmm3d),Cvoid,(Fi,Fd,Fd,Fi,Fd,Fi,Fd,
                                              Fd,Fd,Fd),
          nd,sources,stoklet,n,targets,nt,pottarg,
          pretarg,gradtarg,thresh)
    return
end

"""
```julia
    anyfail, n, nt, ifh_current, ife_current, ife_charge = (
        emfmm3dinputcheck(sources,h_current,e_current,e_charge,
                        targets,ifE,ifdivE,ifcurlE,
                        ifEtarg,ifdivEtarg,
                        ifcurlEtarg,nd) )
```

Input checking for electromagnetics routines. 
Checks the sizes of these arrays and the compatibility
of the various flags, nd, and provided arrays. 
If something is off, a warning is issued and 
`anyfail` is set to true. Non-fatal mistakes result in
a warning but `anyfail` remains false. 

Output:
* `anyfail` - boolean is true if any checks fail, false otherwise
* `n` - integer, number of sources
* `nt` - integer, number of targets
* `ifh_current` - integer, is 1 if there is an h_current vector, 0 otherwise
* `ife_current` - integer, is 1 if there is a e_current vector, 0 otherwise
* `ife_charge` - integer, is 1 if there is a e_charge density, 0 otherwise
"""
function emfmm3dinputcheck(sources,h_current,e_current,e_charge,targets,
                           ifE,ifdivE,ifcurlE,ifEtarg,ifdivEtarg,
                           ifcurlEtarg,nd)
    anyfail = false
    
    if (size(sources,1) != 3)
        @warn "sources array is wrong shape, computing nothing"
        anyfail = true
    end
    if (nd < 0)
        @warn "nd has invalid value, computing nothing"
        anyfail = true
    end

    n = div(length(sources),3)
    nt = 0

    if targets != nothing
        if (size(targets,1) != 3)
            @warn "targets array is wrong shape, computing nothing"
            anyfail = true
        end
        nt = div(length(targets),3)
    end
    
    if h_current != nothing
        if (div(length(h_current),nd) != 3*n)
            @warn "size of h_current vector array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ifh_current = 1
    else
        ifh_current = 0
    end

    if e_current != nothing
        if (div(length(e_current),nd) != 3*n)
            @warn "size of e_current vector array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ife_current = 1
    else
        ife_current = 0
    end

    if e_charge != nothing
        if (div(length(e_charge),nd) != n)
            @warn "size of e_charge array incompatible with sources array and nd parameter, computing nothing"
            anyfail = true
        end
        ife_charge = 1
    else
        ife_charge = 0
    end

    if ifh_current == 0 && ife_current == 0 && ife_charge == 0
        @warn "none of h_current vectors, e_current vectors, or e_charges provided at sources, doing nothing"
        anyfail = true
    end

    if !ifEtarg && !ifdivEtarg && !ifcurlEtarg
        @warn "no output requested, doing nothing"
        anyfail = true
    end

    if (ifEtarg || ifdivEtarg || ifcurlEtarg) && targets == nothing
        @warn "target values requested but no targets provided, doing nothing for these"
    end

    return anyfail, n, nt, ifh_current, ife_current, ife_charge
end


"""
```julia
    vals = emfmm3d(eps,zk,sources;h_current=nothing,e_current=nothing,e_charge=nothing,
                ifE=false,ifdivE=false,ifcurlE=false,
                ifEtarg=false,ifdivEtarg=false,ifcurlEtarg=false,
                nd=1,targets=nothing)
```

This function computes N-body electromagnetic interactions
in three dimensions where the interaction kernels are
the Helmholtz kernel and its curl and gradient (see below). This is the 
``O(N)`` fast multipole code which computes the interactions
to the requested precision.

The Helmholtz Green's function
is
```math
 G_k(x,y) = \\frac{e^{ik \\|x-y\\|}}{4\\pi\\|x-y\\|} \\, , 
```

This routine computes the sum 

```math
E(x) = \\sum_{j=1}^m \\nabla \\times (G_k(x,x_{j}) h_current_j) + 
G_k(x,x_{j}) e_current_j + \\nabla G_k(x,x_{j}) \\e_charge_j
```
 
where ``h_current_{j}`` and ``e_current_{j}`` are vector densities
      ``\\e_charge_{j}`` is a scalar density, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum


# Input

* `eps::Float64` precision requested
* `zk::ComplexF64` Helmholtz parameter
* `sources::Array{Float64}` size (3,n) source locations (``x_{m}``)

# Optional Keyword Input

* `targets::Array{Float64}` size (3,nt) target locations (``x``)
* `h_current::Array{ComplexF64}` size (nd,3,n) or (3,n) vector densities
* `e_current::Array{ComplexF64}` size (nd,3,n) or (3,n) vector densities
* `e_charge::Array{ComplexF64}` size (nd,n) or (n) scalar densities
* `ifE::Bool` E field evaluation flag, if true evaluate E at source points. 
* `ifdivE::Bool` divergence of E field evaluation flag, if true evaluate divergence of E at source points. 
* `ifcurlE::Bool` curl of E field evaluation flag, if true evaluate curl of E at source points.
* `ifEtarg::Bool` E field evaluation flag, if true evaluate E at target points. 
* `ifdivEtarg::Bool` divergence of E field evaluation flag, if true evaluate divergence of E at target points. 
* `ifcurlEtarg::Bool` curl of E field evaluation flag, if true evaluate curl of E at target points. 
* `nd::Integer` number of densities of each type

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

* `vals.E::Array{ComplexF64}` size (nd,3,n) or (3,n) E field at source locations if requested
* `vals.divE::Array{ComplexF64}` size (nd,n) or (n) divergence of E field at source locations if requested
* `vals.curlE::Array{ComplexF64}` size (nd,3,n) or (3,n) curl of E field at source locations if requested
* `vals.Etarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) E field at target locations if requested
* `vals.divEtarg::Array{ComplexF64}` size (nd,nt) or (nt) divergence of E field at target locations if requested
* `vals.curlEtarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) curl of E field at target locations if requested
* `vals.ier` error flag as returned by FMM3D library. A value of 0 indicates a successful call. 
Non-zero values may indicate insufficient memory available. See the documentation for the FMM3D library. 
If not set (`nothing`), then FMM3D library was never called.
"""
function emfmm3d(eps::Float64,zk::Union{Float64,ComplexF64},sources::Array{Float64};
                 h_current::TCN=nothing,e_current::TCN=nothing,e_charge::TCN=nothing,
                 ifE::Bool=false,ifdivE::Bool=false,
                 ifcurlE::Bool=false,ifEtarg::Bool=false,
                 ifdivEtarg::Bool=false,ifcurlEtarg::Bool=false,
                 nd::Integer=1,targets::TFN=nothing)

    zk = complex(zk)
    
    # default values

    vals = FMMVals()
    
    zero = ComplexF64(0)
    zero3 = zeros(ComplexF64,3)
    
    E1 = zero3
    divE1 = zero
    curlE1 = zero3

    ier = Integer(0)

    # check inputs

    anyfail, n, nt, ifh_current, ife_current, ife_charge = (
        emfmm3dinputcheck(sources,h_current,e_current,e_charge,
                          targets,ifE,ifdivE,ifcurlE,
                          ifEtarg,ifdivEtarg,
                          ifcurlEtarg,nd) )

    if anyfail
        return vals
    end

    if (ifh_current == 0); h_current = zero3 end
    if (ife_current == 0); e_current = zero3 end
    if (ife_charge == 0); e_charge = zero end    
    if (nt == 0); targets = zero3 end

    # allocate memory for return values

    anysrc = (ifE || ifdivE || ifcurlE)
    anytarg = (ifEtarg || ifdivEtarg || ifcurlEtarg)

    ntot = 0
    if anysrc; ntot = ntot+n; end
    if anytarg; ntot = ntot+nt; end

    targ1 = zeros(Float64,3,ntot)
    itstart = 1
    itend = nt
    if anysrc
        targ1[:,1:n] = sources
        itstart = itstart+n
        itend = itend+n
    end
    if anytarg
        targ1[:,itstart:itend] = targets
    end

    anyE = ifE || ifEtarg
    anydivE = ifdivE || ifdivEtarg
    anycurlE = ifcurlE || ifcurlEtarg

    ifE1 = 0; ifdivE1 = 0; ifcurlE1 = 0
    
    if anyE
        if nd > 1
            E1 = zeros(ComplexF64,nd,3,ntot)
        else
            E1 = zeros(ComplexF64,3,ntot)
        end
        ifE1 = 1
    end

    if anydivE
        if nd > 1
            divE1 = zeros(ComplexF64,nd,ntot)
        else
            divE1 = zeros(ComplexF64,ntot)
        end
        ifdivE1 = 1
    end

    if anyE
        if nd > 1
            curlE1 = zeros(ComplexF64,nd,3,ntot)
        else
            curlE1 = zeros(ComplexF64,3,ntot)
        end
        ifcurlE1 = 1
    end


# actually call the function
#
# fortran calling sequence
#  subroutine emfmm3d(nd,eps,zk,ns,source,ifa_vect,a_vect,&
#   ifb_vect,b_vect,ife_charge,e_charge,nt,targets,ifE,E,ifcurlE,curlE,&
#   ifdivE,divE,ier)

    
    ccall((:emfmm3d_,libfmm3d),Cvoid,(Fi,Fd,Fc,Fi,Fd,Fi,Fc,
                                      Fi,Fc,Fi,Fc,Fi,Fd,Fi,Fc,
                                      Fi,Fc,Fi,Fc,Fi),
          nd,eps,zk,n,sources,ifh_current,h_current,ife_current,e_current,ife_charge,e_charge,
          ntot,targ1,ifE1,E1,ifcurlE1,curlE1,ifdivE1,divE1,ier)

    # copy over error message

    if (ier != 0); @warn "libfmm3d had an error, see vals.ier" end
    vals.ier = ier
    
    # load requested values

    if (nd == 1)
        if ifE; vals.E = E1[:,1:n] end
        if ifdivE; vals.divE = divE1[1:n] end
        if ifcurlE; vals.curlE = curlE1[:,1:n] end
        
        if ifEtarg; vals.Etarg = E1[:,itstart:itend] end
        if ifdivEtarg; vals.divEtarg = divE1[itstart:itend] end
        if ifcurlEtarg; vals.curlEtarg = curlE1[:,itstart:itend] end
    else
        if ifE; vals.E = E1[:,:,1:n] end
        if ifdivE; vals.divE = divE1[:,1:n] end
        if ifcurlE; vals.curlE = curlE1[:,:,1:n] end
        
        if ifEtarg; vals.Etarg = E1[:,:,itstart:itend] end
        if ifdivEtarg; vals.divEtarg = divE1[:,itstart:itend] end
        if ifcurlEtarg; vals.curlEtarg = curlE1[:,:,itstart:itend] end
    end    
    return vals

end


"""
```julia
    vals = em3ddir(zk,sources,targets;h_current=nothing,e_current=nothing,e_charge=nothing,
                ifEtarg=false,ifdivEtarg=false,ifcurlEtarg=false,
                nd=1,thresh=1e-16)
```

This function computes N-body electromagnetic interactions
in three dimensions where the interaction kernels are
the Helmholtz kernel and its curl and gradient (see below). This is the 
``O(N^2)`` direct code. By convention this code only computes 
the effect of sources on targets. If the value at sources is 
also needed, the routine can be called again with targets equal
to the source locations.

The Helmholtz Green's function
is
```math
 G_k(x,y) = \\frac{e^{ik \\|x-y\\|}}{4\\pi\\|x-y\\|} \\, , 
```

This routine computes the sum 

```math
E(x) = \\sum_{j=1}^m \\nabla \\times (G_k(x,x_{j}) h_current_j) + 
G_k(x,x_{j}) e_current_j + \\nabla G_k(x,x_{j}) \\e_charge_j
```
 
where ``h_current_{j}`` and ``e_current_{j}`` are vector densities
      ``\\e_charge_{j}`` is a scalar density, and 
      ``x_{j}`` are the source locations.
      When ``x=x_{m}``, the term corresponding to 
      ``x_{m}`` is dropped from the sum


# Input

* `zk::ComplexF64` Helmholtz parameter
* `sources::Array{Float64}` size (3,n) source locations (``x_{m}``)
* `targets::Array{Float64}` size (3,nt) target locations (``x``)

# Optional Keyword Input

* `h_current::Array{ComplexF64}` size (nd,3,n) or (3,n) vector densities
* `e_current::Array{ComplexF64}` size (nd,3,n) or (3,n) vector densities
* `e_charge::Array{ComplexF64}` size (nd,n) or (n) scalar densities
* `ifEtarg::Bool` E field evaluation flag, if true evaluate E at target points. 
* `ifdivEtarg::Bool` divergence of E field evaluation flag, if true evaluate divergence of E at target points. 
* `ifcurlEtarg::Bool` curl of E field evaluation flag, if true evaluate curl of E at target points. 
* `nd::Integer` number of densities of each type

Note: if all default values are used for optional input, nothing
is computed.

# Output
        
`vals::FMMVals` with the fields

* `vals.Etarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) E field at target locations if requested
* `vals.divEtarg::Array{ComplexF64}` size (nd,nt) or (nt) divergence of E field at target locations if requested
* `vals.curlEtarg::Array{ComplexF64}` size (nd,3,nt) or (3,nt) curl of E field at target locations if requested
"""
function em3ddir(zk::Union{Float64,ComplexF64},sources::Array{Float64},
                 targets::Array{Float64};
                 h_current::TCN=nothing,e_current::TCN=nothing,e_charge::TCN=nothing,
                 ifEtarg::Bool=false,
                 ifdivEtarg::Bool=false,ifcurlEtarg::Bool=false,
                 nd::Integer=1,thresh::Float64=1e-16)

    zk = complex(zk)
    
    # default values

    vals = FMMVals()
    
    zero = ComplexF64(0)
    zero3 = zeros(ComplexF64,3)
    
    Etarg = zero3
    divEtarg = zero
    curlEtarg = zero3

    ier = Integer(0)

    # check inputs

    ifE = false; ifdivE = false; ifcurlE = false

    anyfail, n, nt, ifh_current, ife_current, ife_charge = (
        emfmm3dinputcheck(sources,h_current,e_current,e_charge,
                          targets,ifE,ifdivE,ifcurlE,
                          ifEtarg,ifdivEtarg,
                          ifcurlEtarg,nd) )
    if anyfail
        return vals
    end

    if (ifh_current == 0); h_current = zero3 end
    if (ife_current == 0); e_current = zero3 end
    if (ife_charge == 0); e_charge = zero end    
    if (nt == 0); targets = zero3 end

    if (nt == 0)
        return vals
    end
    
    # allocate memory for return values

    ifE1 = Integer(0); ifcurlE1 = Integer(0)
    ifdivE1 = Integer(0)
    
    if ifEtarg
        if nd > 1
            Etarg = zeros(ComplexF64,nd,3,nt)
        else
            Etarg = zeros(ComplexF64,3,nt)
        end
        ifE1 = 1
    end

    if ifcurlEtarg
        if nd > 1
            curlEtarg = zeros(ComplexF64,nd,3,nt)
        else
            curlEtarg = zeros(ComplexF64,3,nt)
        end
        ifcurlE1 = 1
    end

    if ifdivEtarg
        if nd > 1
            divEtarg = zeros(ComplexF64,nd,nt)
        else
            divEtarg = zeros(ComplexF64,nt)
        end
        ifdivE1 = 1
    end

# actually call routine    
#
# subroutine em3ddirect(nd,zk,ns,source,ifa_vect,a_vect,&
#  ifb_vect,b_vect,ife_charge,e_charge,nt,targets,ifE,E,ifcurlE,curlE,&
#  ifdivE,divE,thresh)

    ccall((:em3ddirect_,libfmm3d),Cvoid,(Fi,Fc,Fi,Fd,Fi,Fc,
                                         Fi,Fc,Fi,Fc,Fi,Fd,
                                         Fi,Fc,Fi,Fc,Fi,Fc,
                                         Fd),
          nd,zk,n,sources,ifh_current,h_current,ife_current,e_current,ife_charge,e_charge,nt,targets,
          ifE1,Etarg,ifcurlE1,curlEtarg,ifdivE1,divEtarg,thresh)

    if ifEtarg; vals.Etarg = Etarg end
    if ifdivEtarg; vals.divEtarg = divEtarg end
    if ifcurlEtarg; vals.curlEtarg = curlEtarg end
    
    return vals

end



end # module

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! This file contains interfaces for the maxwell fmm3d and 
! direct calculation. It contains the two subroutines:
!
!   emfmm3d - Maxwell fmm3d with nd densities
!
!   em3ddirect - Maxwell direct calculation with nd
!    densities
!
!   (input sources and output requests are controleld by flags)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine emfmm3d(nd,eps,zk,ns,source,ifh_current,h_current,&
 ife_current,e_current,ife_charge,e_charge,nt,targets,ifE,E,ifcurlE,curlE,&
 ifdivE,divE,ier)
implicit none

!jmc_edc

!  This function computes 
!
!    E = curl S_{k}[h_current] + S_{k}[e_current] + grad S_{k}[e_charge]  -- (1)
!  using the vector Helmholtz fmm.
!
!  The subroutine also computes divE, curlE 
!  with appropriate flags
!
!  Remark: the subroutine uses a stabilized representation
!    for computing the divergence by using integration by parts 
!    wherever possible. If the divergence is not requested, then the
!    helmholtz fmm is called with 3*nd densities, while if the divergence
!    is requested, then the helmholtz fmm is calld with 4*nd densities
!    
!
!  input:
!    nd - integer *8
!      number of densities (h_current,e_current,e_charge)
!
!    eps - real *8
!      epsilon for the fmm call
!
!    zk - complex *16
!      Helmholtz parameter
!
!    ns - integer *8
!      number of sources
!
!    source - real *8 (3,ns)
!      location of the sources
!
!    ifh_current - integer *8
!     Contribution due to curl S_{k}[h_current] is included if
!     ifh_current = 1
!
!    h_current - complex *16(nd,3,ns)
!      a vector source
!
!    ife_current - integer *8
!      Contribution due to S_{k}[e_current] is included if
!      ife_current = 1
!
!    e_current - complex *16(nd,3,ns)
!      b vector source
!
!    ife_charge - integer *8
!      Contribution due to grad S_{k} [e_charge] is included
!      if ife_charge = 1
!
!    e_charge - complex *16(nd,ns)
!      e_charge source
!
!    nt - integer *8
!      number of targets
!
!    targets - real *8 (3,nt)
!      location of the targets
!
!    ifE - integer *8
!      E is returned at the target locations if ifE = 1
!
!    ifcurlE - integer *8
!      curl E is returned at the target locations if 
!      ifcurlE = 1
!
!    ifdivE - integer *8
!      div E is returned at the target locations if 
!      ifdivE = 1
!
!  output:
!
!    E - complex *16(nd,3,nt)
!      E field defined in (1) above
!
!    curlE - complex *16(nd,3,nt)
!      curl of E field
!
!    divE - complex *16(nd,nt)
!      divergence of E
!

  !List of calling arguments
  double precision, intent(in) :: eps
  double complex, intent(in) :: zk
  integer *8, intent(in) :: nd,ns,nt
  double precision, intent(in) :: source(3,ns)
  integer *8, intent(in) :: ifh_current
  double complex, intent(in) :: h_current(nd,3,ns)
  integer *8, intent(in) :: ife_current
  double complex, intent(in) :: e_current(nd,3,ns)
  integer *8, intent(in) :: ife_charge
  double complex, intent(in) :: e_charge(nd,ns)
  integer *8, intent(in) :: ifE
  double complex, intent(out) :: E(nd,3,nt)
  integer *8, intent(in) :: ifcurlE
  double complex, intent(out) :: curlE(nd,3,nt)
  integer *8, intent(in) :: ifdivE
  double complex, intent(out) :: divE(nd,nt)
  double precision, intent(in) :: targets(3,nt)

  !List of local variables
  double complex, allocatable :: sigmh_current(:,:,:)
  double complex, allocatable :: dipvect_vect(:,:,:,:)
  double complex, allocatable :: Etmp(:,:,:)
  double complex, allocatable :: gradE_vect(:,:,:,:)

  double complex, allocatable :: pot(:),grad(:,:),hess(:,:)
  double complex, allocatable :: hesstarg(:,:)
  integer *8 ndens
  integer *8 ier,iper


  integer *8 i,j,nd0,l,m
  integer *8 ifcharge,ifdipole,ifpgh,ifpghtarg

!! f2py declarations
!f2py intent(in) :: nd,eps
!f2py intent(in) :: zk
!f2py intent(in) :: ns,source
!f2py intent(in) :: ifh_current,h_current
!f2py intent(in) :: ife_current,e_current
!f2py intent(in) :: ife_charge,e_charge
!f2py intent(in) :: nt,targets
!f2py intent(in) :: ifE,ifcurlE,ifdivE
!f2py intent(out) :: E,curlE,divE
!f2py intent(out) :: ier

  ndens = 3
  if(ifdivE.eq.1) ndens = 4

  !!Initialize sources
  allocate(sigmh_current(nd,ndens,ns))
  allocate(dipvect_vect(nd,ndens,3,ns))
  allocate(Etmp(nd,ndens,nt))
  allocate(gradE_vect(nd,ndens,3,nt))

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,l,j,m)
  do i=1,nt
    do l=1,ndens
      do j=1,nd
        Etmp(j,l,i)=0.0d0
      enddo
    enddo

    do l=1,3
      do m=1,ndens
        do j=1,nd
          gradE_vect(j,m,l,i)=0.0d0
        enddo
      enddo
    enddo
  enddo
!$OMP END PARALLEL DO  

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,l,j,m)
  do i=1,ns
    do l=1,ndens
      do j=1,nd
        sigmh_current(j,l,i)=0.0d0
      enddo
    enddo

    do l=1,3
      do m=1,ndens
        do j=1,nd
          dipvect_vect(j,m,l,i)=0.0d0
        enddo
      enddo
    enddo
  enddo
!$OMP END PARALLEL DO  

  if (ife_current.eq.1) then

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,l,j)  
    do i=1,ns
      do l=1,3
        do j=1,nd
          sigmh_current(j,l,i)=sigmh_current(j,l,i)+e_current(j,l,i)
        enddo
      enddo
    enddo
!$OMP END PARALLEL DO    

    if(ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,l,j)  
      do i=1,ns
        do l=1,3
          do j=1,nd
            dipvect_vect(j,4,l,i) = dipvect_vect(j,4,l,i) - e_current(j,l,i)
          enddo
        enddo
      enddo
!$OMP END PARALLEL DO    
    endif   
  endif

  if (ife_charge.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,ns
      do j=1,nd
        dipvect_vect(j,1,1,i)=dipvect_vect(j,1,1,i)-e_charge(j,i)
        dipvect_vect(j,2,2,i)=dipvect_vect(j,2,2,i)-e_charge(j,i)
        dipvect_vect(j,3,3,i)=dipvect_vect(j,3,3,i)-e_charge(j,i)
      enddo
    enddo
!$OMP END PARALLEL DO  

!
!  Add in the contribution corresponding to the divergence
!  Here we use the identity that
!  \nabla \cdot \nabla S_{k} [\e_charge] = k^2 S_{k} [\e_charge]
!
    if(ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)   
      do i=1,ns
        do j=1,nd
          sigmh_current(j,4,i) = sigmh_current(j,4,i) - zk**2*e_charge(j,i)
        enddo
      enddo
!$OMP END PARALLEL DO      
    endif
  endif

  if (ifh_current.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,ns
      do j=1,nd
        dipvect_vect(j,1,2,i)=dipvect_vect(j,1,2,i)-h_current(j,3,i)
        dipvect_vect(j,1,3,i)=dipvect_vect(j,1,3,i)+h_current(j,2,i)

        dipvect_vect(j,2,1,i)=dipvect_vect(j,2,1,i)+h_current(j,3,i)
        dipvect_vect(j,2,3,i)=dipvect_vect(j,2,3,i)-h_current(j,1,i)

        dipvect_vect(j,3,1,i)=dipvect_vect(j,3,1,i)-h_current(j,2,i)
        dipvect_vect(j,3,2,i)=dipvect_vect(j,3,2,i)+h_current(j,1,i)
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif

  ifcharge=1
  ifdipole=1
  ifpgh = 0
  ifpghtarg=2

  ifcharge=1
  ifdipole=1
  ifpgh = 0
  ifpghtarg=2

  if ((ifcurlE.ne.1).and.(ifdivE.ne.1)) then
    ifpghtarg=1
  endif

  if(ifdivE.ne.1) then
    if ((ifh_current.ne.1).and.(ife_charge.ne.1)) then
      ifdipole=0
    endif
    if (ife_current.ne.1) then
      ifcharge=0
    endif
  else
    if (ife_current.ne.1.and.ife_charge.ne.1) then
      ifcharge = 0
    endif
  endif

  nd0 = ndens*nd

  allocate(pot(nd0),grad(nd0,3),hess(nd0,6),hesstarg(nd0,6))

  call hfmm3d(nd0,eps,zk,ns,source,ifcharge,sigmh_current,ifdipole, &
   dipvect_vect,iper,ifpgh,pot,grad,hess,nt,targets,ifpghtarg,Etmp, &
   gradE_vect,hesstarg,ier)

  if (ifE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
    do i=1,nt
      do l=1,3
        do j=1,nd
          E(j,l,i) = Etmp(j,l,i)
        enddo
      enddo
    enddo
!$OMP END PARALLEL DO
  endif


  if (ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,nt
      do j=1,nd
        divE(j,i)=Etmp(j,4,i)
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif


  if (ifcurlE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,nt
      do j=1,nd
        curlE(j,1,i)=gradE_vect(j,3,2,i)-gradE_vect(j,2,3,i)
        curlE(j,2,i)=gradE_vect(j,1,3,i)-gradE_vect(j,3,1,i)
        curlE(j,3,i)=gradE_vect(j,2,1,i)-gradE_vect(j,1,2,i)
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif

  deallocate(sigmh_current)
  deallocate(dipvect_vect)
  deallocate(gradE_vect)
  deallocate(Etmp)

return
end subroutine emfmm3d
!
!
!
!
!

subroutine em3ddirect(nd,zk,ns,source,ifh_current,h_current,&
 ife_current,e_current,ife_charge,e_charge,nt,targets,ifE,E,ifcurlE,curlE,&
 ifdivE,divE,thresh)
implicit none

!  This function computes 
!    E = curl S_{k}[h_current] + S_{k}[e_current] + grad S_{k}[e_charge]  -- (1)
!  via direct computation.
!  The subroutine also returns divE, curlE with appropriate flags
!
!  input:
!    nd - integer *8
!      number of densities (h_current,e_current,e_charge)
!
!    eps - real *8
!      epsilon for the fmm call
!
!    zk - complex *16
!      Helmholtz parameter
!
!    ns - integer *8
!      number of sources
!
!    source - real *8 (3,ns)
!      location of the sources
!
!    ifh_current - integer *8
!     Contribution due to curl S_{k}[h_current] is included if
!     ifh_current = 1
!
!    h_current - complex *16(nd,3,ns)
!      a vector source
!
!    ife_current - integer *8
!      Contribution due to S_{k}[e_current] is included if
!      ife_current = 1
!
!    e_current - complex *16(nd,3,ns)
!      b vector source
!
!    ife_charge - integer *8
!      Contribution due to grad S_{k} [e_charge] is included
!      if ife_charge = 1
!
!    e_charge - complex *16(nd,ns)
!      e_charge source
!
!    nt - integer *8
!      number of targets
!
!    targets - real *8 (3,nt)
!      location of the targets
!
!    ifE - integer *8
!      E is returned at the target locations if ifE = 1
!
!    ifcurlE - integer *8
!      curl E is returned at the target locations if 
!      ifcurlE = 1
!
!    ifdivE - integer *8
!      div E is returned at the target locations if 
!      ifdivE = 1
!
!
!    thresh - real *8
!      threshold for self interaction term
!
!
!  output:
!
!    E - complex *16(nd,3,nt)
!      E field
!
!    curlE - complex *16(nd,3,nt)
!      curlE curl of E field
!
!    divE - complex *16(nd,nt)
!      divE divergence of E
!

  !List of calling arguments
  double complex, intent(in) :: zk
  integer *8, intent(in) :: nd,ns,nt
  double precision, intent(in) :: source(3,ns)
  integer *8, intent(in) :: ifh_current
  double complex, intent(in) :: h_current(nd,3,ns)
  integer *8, intent(in) :: ife_current
  double complex, intent(in) :: e_current(nd,3,ns)
  integer *8, intent(in) :: ife_charge
  double complex, intent(in) :: e_charge(nd,ns)
  integer *8, intent(in) :: ifE
  double complex, intent(out) :: E(nd,3,nt)
  integer *8, intent(in) :: ifcurlE
  double complex, intent(out) :: curlE(nd,3,nt)
  integer *8, intent(in) :: ifdivE
  double complex, intent(out) :: divE(nd,nt)
  double precision, intent(in) :: targets(3,nt)
  double precision, intent(in) :: thresh


  !List of local variables
  double complex, allocatable :: sigmh_current(:,:,:)
  double complex, allocatable :: dipvect_vect(:,:,:,:)
  double complex, allocatable :: gradE_vect(:,:,:,:)
  double complex, allocatable :: Etmp(:,:,:)
  integer *8 i,j,nd0,l,m
  integer *8 ifcharge,ifdipole,ifpot,ifgrad,ifpghtarg
  integer *8 ndens

!! f2py declarations
!f2py intent(in) :: nd,eps
!f2py intent(in) :: zk
!f2py intent(in) :: ns,source
!f2py intent(in) :: ifh_current,h_current
!f2py intent(in) :: ife_current,e_current
!f2py intent(in) :: ife_charge,e_charge
!f2py intent(in) :: nt,targets
!f2py intent(in) :: ifE,ifcurlE,ifdivE
!f2py intent(in) :: thresh
!f2py intent(out) :: E,curlE,divE

  !!Initialize sources
  
  ndens = 3
  if(ifdivE.eq.1) ndens = 4

  allocate(sigmh_current(nd,ndens,ns))
  allocate(dipvect_vect(nd,ndens,3,ns))
  allocate(Etmp(nd,ndens,nt))
  allocate(gradE_vect(nd,ndens,3,nt))

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l,m)
  do i=1,nt
    do l=1,ndens
      do j=1,nd
        Etmp(j,l,i)=0.0d0
      enddo
    enddo

    do l=1,3
      do m=1,ndens
        do j=1,nd
          gradE_vect(j,m,l,i) = 0.0d0
        enddo
      enddo
    enddo
  enddo
!$OMP END PARALLEL DO

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l,m)
  do i=1,ns
    do l=1,ndens
      do j=1,nd
        sigmh_current(j,l,i)=0.0d0
      enddo
    enddo

    do l=1,3
      do m=1,ndens
        do j=1,nd
          dipvect_vect(j,m,l,i)=0.0d0
        enddo
      enddo
    enddo
  enddo
!$OMP END PARALLEL DO  

  if (ife_current.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l)  
    do i=1,ns
      do l=1,3
        do j=1,nd
          sigmh_current(j,l,i)=sigmh_current(j,l,i)+e_current(j,l,i)
        enddo
      enddo
    enddo
!$OMP END PARALLEL DO   


    if(ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l)  
      do i=1,ns
        do l=1,3
          do j=1,nd
            dipvect_vect(j,4,l,i) = dipvect_vect(j,4,l,i) - e_current(j,l,i)
          enddo
        enddo
      enddo
!$OMP END PARALLEL DO   
    endif
  endif

  if (ife_charge.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,ns
      do j=1,nd
        dipvect_vect(j,1,1,i)=dipvect_vect(j,1,1,i)-e_charge(j,i)
        dipvect_vect(j,2,2,i)=dipvect_vect(j,2,2,i)-e_charge(j,i)
        dipvect_vect(j,3,3,i)=dipvect_vect(j,3,3,i)-e_charge(j,i)
      enddo
    enddo
!$OMP END PARALLEL DO    

!
!  Add in the contribution corresponding to the divergence
!  Here we use the identity that
!  \nabla \cdot \nabla S_{k} [\e_charge] = k^2 S_{k} [\e_charge]
!
    if(ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)   
      do i=1,ns
        do j=1,nd
          sigmh_current(j,4,i) = sigmh_current(j,4,i) - zk**2*e_charge(j,i)
        enddo
      enddo
!$OMP END PARALLEL DO      
    endif
  endif

  if (ifh_current.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,ns
      do j=1,nd
        dipvect_vect(j,1,2,i)=dipvect_vect(j,1,2,i)-h_current(j,3,i)
        dipvect_vect(j,1,3,i)=dipvect_vect(j,1,3,i)+h_current(j,2,i)

        dipvect_vect(j,2,1,i)=dipvect_vect(j,2,1,i)+h_current(j,3,i)
        dipvect_vect(j,2,3,i)=dipvect_vect(j,2,3,i)-h_current(j,1,i)

        dipvect_vect(j,3,1,i)=dipvect_vect(j,3,1,i)-h_current(j,2,i)
        dipvect_vect(j,3,2,i)=dipvect_vect(j,3,2,i)+h_current(j,1,i)
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif


  ifcharge=1
  ifdipole=1
  ifpghtarg=2

  if ((ifcurlE.ne.1).and.(ifdivE.ne.1)) then
    ifpghtarg=1
  endif

  if(ifdivE.ne.1) then
    if ((ifh_current.ne.1).and.(ife_charge.ne.1)) then
      ifdipole=0
    endif
    if (ife_current.ne.1) then
      ifcharge=0
    endif
  else
    if (ife_current.ne.1.and.ife_charge.ne.1) then
      ifcharge = 0
    endif
  endif

  nd0=ndens*nd
  if(ifpghtarg.eq.1) then
    if(ifcharge.eq.1.and.ifdipole.eq.0) then
      call h3ddirectcp(nd0,zk,source,sigmh_current,ns, &
         targets,nt,Etmp,thresh)
    endif
    if(ifcharge.eq.0.and.ifdipole.eq.1) then
      call h3ddirectdp(nd0,zk,source,dipvect_vect,ns, &
         targets,nt,Etmp,thresh)
    endif
    if(ifcharge.eq.1.and.ifdipole.eq.1) then
      call h3ddirectcdp(nd0,zk,source,sigmh_current,dipvect_vect,ns, &
         targets,nt,Etmp,thresh)
    endif

  else if(ifpghtarg.eq.2) then
    if(ifcharge.eq.1.and.ifdipole.eq.0) then
      call h3ddirectcg(nd0,zk,source,sigmh_current,ns, &
         targets,nt,Etmp,gradE_vect,thresh)
    endif
    if(ifcharge.eq.0.and.ifdipole.eq.1) then
      call h3ddirectdg(nd0,zk,source,dipvect_vect,ns, &
         targets,nt,Etmp,gradE_vect,thresh)
    endif
    if(ifcharge.eq.1.and.ifdipole.eq.1) then
      call h3ddirectcdg(nd0,zk,source,sigmh_current,dipvect_vect,ns, &
         targets,nt,Etmp,gradE_vect,thresh)
    endif
  endif
  
  if(ifE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l)  
    do i=1,nt
      do l=1,3
        do j=1,nd
          E(j,l,i) = E(j,l,i) + Etmp(j,l,i)
        enddo
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif


  if (ifdivE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,nt
      do j=1,nd
        divE(j,i)=divE(j,i) + Etmp(j,4,i)
       enddo
    enddo
!$OMP END PARALLEL DO     
  endif

  if (ifcurlE.eq.1) then
!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)  
    do i=1,nt
      do j=1,nd
        curlE(j,1,i)=curlE(j,1,i)+gradE_vect(j,3,2,i)-gradE_vect(j,2,3,i)
        curlE(j,2,i)=curlE(j,2,i)+gradE_vect(j,1,3,i)-gradE_vect(j,3,1,i)
        curlE(j,3,i)=curlE(j,3,i)+gradE_vect(j,2,1,i)-gradE_vect(j,1,2,i)
      enddo
    enddo
!$OMP END PARALLEL DO    
  endif


  deallocate(Etmp)
  deallocate(sigmh_current)
  deallocate(dipvect_vect)
  deallocate(gradE_vect)

return
end subroutine em3ddirect

      implicit real *8 (a-h,o-z)
      integer *8, parameter :: nd = 1
      integer *8, parameter :: nt = 3
      integer *8 ns
      real *8 ztarg(3,nt),sources(3,10)
      real *8 charge(nd,10),pot(nd,nt),grad(nd,3,nt)
      real *8 hess(nd,6,nt)
      real *8 dipvec(nd,3,10)
c
c 
c
      sources(1,1) = 0.1d0     
      sources(2,1) = -0.2d0     
      sources(3,1) = 0.3d0     
      dipvec(1,1,1) = 1.1d0     
      dipvec(1,2,1) = -2.2d0     
      dipvec(1,3,1) = 3.3d0     
cc      dipvec(1,1,1) = 0
cc      dipvec(1,2,1) = 0     
cc      dipvec(1,3,1) = 0     
      charge(1,1) = 1.3d0
      sources(1,2) = -0.13d0     
      sources(2,2) = 0.2d0     
      sources(3,2) = -0.25d0     
      dipvec(1,1,2) = -2.13d0     
      dipvec(1,2,2) = 1.2d0     
      dipvec(1,3,2) = -3.25d0     
cc      dipvec(1,1,2) = 0     
cc      dipvec(1,2,2) = 0     
cc      dipvec(1,3,2) = 0     
      charge(1,2) = 2.3d0
      ns = 2
      ztarg(1,1) = 1.0d0
      ztarg(2,1) = 1.3d0
      ztarg(3,1) = 1.4d0
c
      hh = 1.0d-3
      ztarg(1,2) = 1.0d0 + hh 
      ztarg(2,2) = 1.3d0
      ztarg(3,2) = 1.4d0
      ztarg(1,3) = 1.0d0 - hh
      ztarg(2,3) = 1.3d0
      ztarg(3,3) = 1.4d0
c
c
      write(6,*) ' directc  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectcp(nd,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' FD z deriv ', (pot(1,2) - pot(1,3))/(2*hh)
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectcg(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      write(6,*) ' FD x deriv of p_x ', (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      write(6,*) ' FD x deriv of p_y ', (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      write(6,*) ' FD x deriv of p_z ', (v1-v2)/(2*hh)
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectch(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      write(6,*) ' dir pxx ', hess(1,1,1)
      write(6,*) ' dir pxy ', hess(1,4,1)
      write(6,*) ' dir pxz ', hess(1,5,1)
c
c
      write(6,*) ' directd  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectdp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' FD y deriv ', (pot(1,2) - pot(1,3))/(2*hh)
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectdg(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      write(6,*) ' FD x deriv of p_x ', (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      write(6,*) ' FD x deriv of p_y ', (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      write(6,*) ' FD x deriv of p_z ', (v1-v2)/(2*hh)
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectdh(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      write(6,*) ' dir pxx ', hess(1,1,1)
      write(6,*) ' dir pxy ', hess(1,4,1)
      write(6,*) ' dir pxz ', hess(1,5,1)
c
      write(6,*) ' directcd  tests -------------------------------'
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectcdp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' FD x deriv ', (pot(1,2) - pot(1,3))/(2*hh)
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectcdg(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      v1 = grad(1,1,2)
      v2 = grad(1,1,3)
      write(6,*) ' FD x deriv of p_x ', (v1-v2)/(2*hh)
      v1 = grad(1,2,2)
      v2 = grad(1,2,3)
      write(6,*) ' FD x deriv of p_y ', (v1-v2)/(2*hh)
      v1 = grad(1,3,2)
      v2 = grad(1,3,3)
      write(6,*) ' FD x deriv of p_z ', (v1-v2)/(2*hh)
c
      call setzero(pot,grad,hess,nd,nt)
      call l3ddirectcdh(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
      write(6,*) ' dir cp ', pot
      write(6,*) ' dir grad ', grad(1,1,1)
      write(6,*) ' dir pxx ', hess(1,1,1)
      write(6,*) ' dir pxy ', hess(1,4,1)
      write(6,*) ' dir pxz ', hess(1,5,1)
      end

      subroutine setzero(pot,grad,hess,nd,nt)
      implicit real *8 (a-h,o-z)
      integer *8 nd,nt,ii,jj
      real *8 pot(nd,nt),grad(nd,3,nt)
      real *8 hess(nd,6,nt)

      do ii=1,nd
      do jj=1,nt
         pot(ii,jj) = 0.0d0
         grad(ii,1,jj) = 0.0d0
         grad(ii,2,jj) = 0.0d0
         grad(ii,3,jj) = 0.0d0
         hess(ii,1,jj) = 0.0d0
         hess(ii,2,jj) = 0.0d0
         hess(ii,3,jj) = 0.0d0
         hess(ii,4,jj) = 0.0d0
         hess(ii,5,jj) = 0.0d0
         hess(ii,6,jj) = 0.0d0
      enddo
      enddo
      return
      end

      implicit none
      integer *8 ns,nt
      double precision, allocatable :: source(:,:),targ(:,:)
      double precision, allocatable :: charge(:,:)
      double precision, allocatable :: dipvec(:,:,:)
      double precision, allocatable :: pot(:,:),pottarg(:,:)
      double precision, allocatable :: grad(:,:,:),gradtarg(:,:,:)
      double precision, allocatable :: hess(:,:,:),hesstarg(:,:,:)

      double precision eps
      double complex eye
      integer *8 i,j,k,ntest,idim,nd,ier
      integer *8 ifcharge,ifdipole,ifpgh,ifpghtarg
      double precision err,hkrand
      integer *8 ipass(27),len1,ntests,isum
      character(len=100) str1
      

      data eye/(0.0d0,1.0d0)/

c
cc      initialize printing routine
c
      call prini(6,13)

      ns = 4000 
      nt = 3999

      ntest = 10

      nd = 2

      allocate(source(3,ns),targ(3,nt))
      allocate(charge(nd,ns),dipvec(nd,3,ns))
      allocate(pot(nd,ns))
      allocate(grad(nd,3,ns))
      allocate(hess(nd,6,ns))

      allocate(pottarg(nd,nt))
      allocate(gradtarg(nd,3,nt))
      allocate(hesstarg(nd,6,nt))

      eps = 0.51d-3

      write(*,*) "=========================================="
      write(*,*) "Testing suite for lfmm3d_vec"
      write(*,'(a,e11.4)') "Requested precision = ",eps

      open(unit=33,file='print_testres.txt',access='append')

      ntests = 27
      do i=1,ntests
        ipass(i) = 0
      enddo



c
cc      generate sources uniformly in the unit cube 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        do idim=1,nd
          charge(idim,i) = hkrand(0) 

          dipvec(idim,1,i) = hkrand(0) 
          dipvec(idim,2,i) = hkrand(0)
          dipvec(idim,3,i) = hkrand(0)

          pot(idim,i) = 0
          grad(idim,1,i) = 0
          grad(idim,2,i) = 0
          grad(idim,3,i) = 0
        enddo
      enddo


c
cc      generate targets uniformly in the unit cube
c
      do i=1,nt
        targ(1,i) = hkrand(0)
        targ(2,i) = hkrand(0)
        targ(3,i) = hkrand(0)

        do idim=1,nd
          pottarg(idim,i) = 0
          gradtarg(idim,1,i) = 0
          gradtarg(idim,2,i) = 0
          gradtarg(idim,3,i) = 0 
        enddo
      enddo


c
cc     now test source to source, charge, 
c      with potentials
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_c_p_vec(nd,eps,ns,source,charge,pot,ier)


       ifcharge = 1
       ifdipole = 0
       ifpgh = 1
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(1) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c

c
cc     now test source to source, charge, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_c_g_vec(nd,eps,ns,source,charge,
     1      pot,grad,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 2
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(2) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 
      

      
c
cc     now test source to source, dipole, 
c      with potentials
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_d_p_vec(nd,eps,ns,source,dipvec,
     1      pot,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 1
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(3) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source, dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_d_g_vec(nd,eps,ns,source,dipvec,
     1      pot,grad,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 2
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(4) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 

c
cc     now test source to source, charge + dipole, 
c      with potentials
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_cd_p_vec(nd,eps,ns,source,charge,dipvec,
     1      pot,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 1
       ifpghtarg = 0 

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(5) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source, charge + dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_cd_g_vec(nd,eps,ns,source,charge,dipvec,
     1      pot,grad,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 2
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(6) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 



c
cc     now test source to target, charge, 
c      with potentials
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_c_p_vec(nd,eps,ns,source,charge,
     1      nt,targ,pottarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 0
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(7) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 



c
cc     now test source to target, charge, 
c      with potentials and gradients
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_c_g_vec(nd,eps,ns,source,charge,
     1      nt,targ,pottarg,gradtarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 0
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(8) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 
      


c
cc     now test source to target, dipole, 
c      with potentials
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_d_p_vec(nd,eps,ns,source,dipvec,
     1      nt,targ,pottarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(9) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to target, dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_d_g_vec(nd,eps,ns,source,dipvec,
     1      nt,targ,pottarg,gradtarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(10) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 

c
cc     now test source to target, charge + dipole, 
c      with potentials
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_cd_p_vec(nd,eps,ns,source,charge,dipvec,
     1      nt,targ,pottarg,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(11) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to target, charge + dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_cd_g_vec(nd,eps,ns,source,charge,dipvec,
     1      nt,targ,pottarg,gradtarg,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(12) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 

c
cc     now test source to source + target, charge, 
c      with potentials
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_c_p_vec(nd,eps,ns,source,charge,
     1      pot,nt,targ,pottarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 1
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(13) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source + target, charge, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_c_g_vec(nd,eps,ns,source,charge,
     1      pot,grad,nt,targ,pottarg,gradtarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 2
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(14) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 
      


c
cc     now test source to source + target, dipole, 
c      with potentials
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_d_p_vec(nd,eps,ns,source,dipvec,
     1      pot,nt,targ,pottarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 1
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(15) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source + target, dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_d_g_vec(nd,eps,ns,source,dipvec,
     1      pot,grad,nt,targ,pottarg,gradtarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 2
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(16) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 

c
cc     now test source to source + target, charge + dipole, 
c      with potentials
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_cd_p_vec(nd,eps,ns,source,charge,dipvec,
     1      pot,nt,targ,pottarg,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 1
       ifpghtarg = 1

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(17) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source + target, charge + dipole, 
c      with potentials and gradients
c
       write(6,*) 'testing source to source and target'
       write(6,*) 'interaction: charges + dipoles'
       write(6,*) 'output: potentials + gradients'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_cd_g_vec(nd,eps,ns,source,charge,dipvec,
     1      pot,grad,nt,targ,pottarg,gradtarg,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 2
       ifpghtarg = 2

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(18) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1) 


c
cc     now test source to source, charge, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_c_h_vec(nd,eps,ns,source,charge,
     1      pot,grad,hess,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 3
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(19) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)


c
cc     now test source to source, dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: dipoles'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_d_h_vec(nd,eps,ns,source,dipvec,
     1      pot,grad,hess,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 3
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(20) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)

c
cc     now test source to source, charge+dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source'
       write(6,*) 'interaction: charges+dipoles'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_s_cd_h_vec(nd,eps,ns,source,charge,dipvec,
     1      pot,grad,hess,ier)

       ifcharge = 1
       ifdipole = 1
       ifpgh = 3
       ifpghtarg = 0

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(21) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)


c
cc     now test source to target, charge, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_c_h_vec(nd,eps,ns,source,charge,
     1      nt,targ,pottarg,gradtarg,hesstarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 0
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(22) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)


c
cc     now test source to target, dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: dipole'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_d_h_vec(nd,eps,ns,source,dipvec,
     1      nt,targ,pottarg,gradtarg,hesstarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(23) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)

c
cc     now test source to target, charge+dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to target'
       write(6,*) 'interaction: charges+dipoles'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_t_cd_h_vec(nd,eps,ns,source,charge,dipvec,
     1      nt,targ,pottarg,gradtarg,hesstarg,ier)


       ifcharge = 1
       ifdipole = 1
       ifpgh = 0
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(24) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)

c
cc     now test source to source+target, charge, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source+target'
       write(6,*) 'interaction: charges'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_c_h_vec(nd,eps,ns,source,charge,pot,grad,hess,
     1      nt,targ,pottarg,gradtarg,hesstarg,ier)

       ifcharge = 1
       ifdipole = 0
       ifpgh = 3
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(25) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)


c
cc     now test source to source+target, dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source+target'
       write(6,*) 'interaction: dipole'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_d_h_vec(nd,eps,ns,source,dipvec,pot,grad,hess,
     1      nt,targ,pottarg,gradtarg,hesstarg,ier)

       ifcharge = 0
       ifdipole = 1
       ifpgh = 3
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(26) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)

c
cc     now test source to source+target, charge+dipole, 
c      with potentials, gradients, and hessians
c
       write(6,*) 'testing source to source+target'
       write(6,*) 'interaction: charges+dipoles'
       write(6,*) 'output: potentials + gradients + hessians'
       write(6,*) 
       write(6,*) 

       call lfmm3d_st_cd_h_vec(nd,eps,ns,source,charge,dipvec,pot,grad,
     1     hess,nt,targ,pottarg,gradtarg,hesstarg,ier)


       ifcharge = 1
       ifdipole = 1
       ifpgh = 3
       ifpghtarg = 3

       
       call comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

       call prin2('l2 rel err=*',err,1)
       write(6,*)
       write(6,*)
       write(6,*) '================'
      if(err.lt.eps) ipass(27) = 1
      call geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      if(err.ge.eps) write(33,*) str1(1:len1)

      isum = 0
      do i=1,ntests
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i2,a,i2,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in lfmm3d testing suite'
      write(33,'(a,i2,a,i2,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in lfmm3d testing suite'
      close(33)
      

      stop
      end
c----------------------------------------------------------
c
cc
c
c
c
c
      subroutine comperr_vec(nd,ns,source,ifcharge,charge,ifdipole,
     1   dipvec,ifpgh,pot,grad,hess,nt,targ,ifpghtarg,pottarg,gradtarg,
     2   hesstarg,ntest,err)

      implicit none
      double complex zk
      integer *8 ns,nt,ifcharge,ifdipole,ifpgh,ifpghtarg
      
      integer *8 nd
      double precision source(3,*),targ(3,*)
      double precision dipvec(nd,3,*)
      double precision charge(nd,*)

      double precision pot(nd,*),pottarg(nd,*),grad(nd,3,*)
      double precision gradtarg(nd,3,*)
      double precision hess(nd,6,*),hesstarg(nd,6,*)

      integer *8 i,j,ntest,l,idim

      double precision err,ra
      
      double precision potex(nd,ntest),gradex(nd,3,ntest)
      double precision pottargex(nd,ntest),gradtargex(nd,3,ntest)
      double precision hessex(nd,6,ntest),hesstargex(nd,6,ntest)

      double precision thresh

      err = 0 
      do i=1,ntest
        do idim=1,nd
          potex(idim,i) = 0
          pottargex(idim,i) = 0

          gradex(idim,1,i) = 0
          gradex(idim,2,i) = 0
          gradex(idim,3,i) = 0

          gradtargex(idim,1,i) = 0
          gradtargex(idim,2,i) = 0
          gradtargex(idim,3,i) = 0

          do j=1,6
            hessex(idim,j,i) = 0
            hesstargex(idim,j,i) = 0
          enddo
        enddo
      enddo

      thresh = 1.0d-16

      if(ifcharge.eq.1.and.ifdipole.eq.0) then
        if(ifpgh.eq.1) then
          call l3ddirectcp(nd,source,charge,ns,source,ntest,
     1       potex,thresh)
        endif

        if(ifpgh.eq.2) then
          call l3ddirectcg(nd,source,charge,ns,source,ntest,
     1       potex,gradex,thresh)
        endif

        if(ifpgh.eq.3) then
          call l3ddirectch(nd,source,charge,ns,source,ntest,
     1       potex,gradex,hessex,thresh)
        endif

        if(ifpghtarg.eq.1) then
          call l3ddirectcp(nd,source,charge,ns,targ,ntest,
     1       pottargex,thresh)
        endif

        if(ifpghtarg.eq.2) then
          call l3ddirectcg(nd,source,charge,ns,targ,ntest,
     1       pottargex,gradtargex,thresh)
        endif

        if(ifpghtarg.eq.3) then
          call l3ddirectch(nd,source,charge,ns,targ,ntest,
     1       pottargex,gradtargex,hesstargex,thresh)
        endif
      endif

      if(ifcharge.eq.0.and.ifdipole.eq.1) then
        if(ifpgh.eq.1) then
          call l3ddirectdp(nd,source,dipvec,
     1      ns,source,ntest,potex,thresh)
        endif

        if(ifpgh.eq.2) then
          call l3ddirectdg(nd,source,dipvec,
     1       ns,source,ntest,potex,gradex,thresh)
        endif

        if(ifpgh.eq.3) then
          call l3ddirectdh(nd,source,dipvec,
     1       ns,source,ntest,potex,gradex,hessex,thresh)
        endif

        if(ifpghtarg.eq.1) then
          call l3ddirectdp(nd,source,dipvec,
     1       ns,targ,ntest,pottargex,thresh)
        endif

        if(ifpghtarg.eq.2) then
          call l3ddirectdg(nd,source,dipvec,
     1       ns,targ,ntest,pottargex,gradtargex,thresh)
        endif

        if(ifpghtarg.eq.3) then
          call l3ddirectdh(nd,source,dipvec,
     1       ns,targ,ntest,pottargex,gradtargex,hesstargex,thresh)
        endif
      endif

      if(ifcharge.eq.1.and.ifdipole.eq.1) then
        if(ifpgh.eq.1) then
          call l3ddirectcdp(nd,source,charge,dipvec,
     1      ns,source,ntest,potex,thresh)
        endif

        if(ifpgh.eq.2) then
          call l3ddirectcdg(nd,source,charge,dipvec,
     1       ns,source,ntest,potex,gradex,thresh)
        endif

        if(ifpgh.eq.3) then
          call l3ddirectcdh(nd,source,charge,dipvec,
     1       ns,source,ntest,potex,gradex,hessex,thresh)
        endif

        if(ifpghtarg.eq.1) then
          call l3ddirectcdp(nd,source,charge,dipvec,
     1       ns,targ,ntest,pottargex,thresh)
        endif

        if(ifpghtarg.eq.2) then
          call l3ddirectcdg(nd,source,charge,dipvec,
     1       ns,targ,ntest,pottargex,gradtargex,thresh)
        endif

        if(ifpghtarg.eq.3) then
          call l3ddirectcdh(nd,source,charge,dipvec,
     1       ns,targ,ntest,pottargex,gradtargex,hesstargex,thresh)
        endif
      endif

      err = 0
      ra = 0

      if(ifpgh.eq.1) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(potex(idim,i))**2
            err = err + abs(pot(idim,i)-potex(idim,i))**2
          enddo
        enddo
      endif

      if(ifpgh.eq.2) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(potex(idim,i))**2
            ra = ra + abs(gradex(idim,1,i))**2
            ra = ra + abs(gradex(idim,2,i))**2
            ra = ra + abs(gradex(idim,3,i))**2

            err = err + abs(pot(idim,i)-potex(idim,i))**2
            err = err + abs(grad(idim,1,i)-gradex(idim,1,i))**2
            err = err + abs(grad(idim,2,i)-gradex(idim,2,i))**2
            err = err + abs(grad(idim,3,i)-gradex(idim,3,i))**2
          enddo
        enddo
      endif

      if(ifpgh.eq.3) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(potex(idim,i))**2
            ra = ra + abs(gradex(idim,1,i))**2
            ra = ra + abs(gradex(idim,2,i))**2
            ra = ra + abs(gradex(idim,3,i))**2
            do l=1,6
              ra = ra + abs(hessex(idim,l,i))**2
            enddo

            err = err + abs(pot(idim,i)-potex(idim,i))**2
            err = err + abs(grad(idim,1,i)-gradex(idim,1,i))**2
            err = err + abs(grad(idim,2,i)-gradex(idim,2,i))**2
            err = err + abs(grad(idim,3,i)-gradex(idim,3,i))**2
            do l=1,6
              err = err + abs(hess(idim,l,i)-hessex(idim,l,i))**2
            enddo
          enddo
        enddo
      endif


      if(ifpghtarg.eq.1) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(pottargex(idim,i))**2
            err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
          enddo
        enddo
      endif

      if(ifpghtarg.eq.2) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(pottargex(idim,i))**2
            ra = ra + abs(gradtargex(idim,1,i))**2
            ra = ra + abs(gradtargex(idim,2,i))**2
            ra = ra + abs(gradtargex(idim,3,i))**2

            err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
            err = err + abs(gradtarg(idim,1,i)-gradtargex(idim,1,i))**2
            err = err + abs(gradtarg(idim,2,i)-gradtargex(idim,2,i))**2
            err = err + abs(gradtarg(idim,3,i)-gradtargex(idim,3,i))**2
          enddo
        enddo
      endif

      if(ifpghtarg.eq.3) then
        do i=1,ntest
          do idim=1,nd
            ra = ra + abs(pottargex(idim,i))**2
            ra = ra + abs(gradtargex(idim,1,i))**2
            ra = ra + abs(gradtargex(idim,2,i))**2
            ra = ra + abs(gradtargex(idim,3,i))**2

            do l=1,6
              ra = ra + abs(hesstargex(idim,l,i))**2
            enddo

            err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
            err = err + abs(gradtarg(idim,1,i)-gradtargex(idim,1,i))**2
            err = err + abs(gradtarg(idim,2,i)-gradtargex(idim,2,i))**2
            err = err + abs(gradtarg(idim,3,i)-gradtargex(idim,3,i))**2
            do l=1,6
             err = err + abs(hesstarg(idim,l,i)-hesstargex(idim,l,i))**2
            enddo
          enddo
        enddo
      endif

      err = sqrt(err/ra)
      return
      end
      
      
c
c
c
c

c
c   Estimate the memory used by Helmholtz FMM. Note that this is a 
c   rough estimate which may be off by up to 10% in either direction
c
c
c-----------------------------------------------------------
        subroutine hfmm3d_memest(nd,eps,zk,nsource,source,ifcharge,
     $    ifdipole,iper,ifpgh,ntarg,targ,ifpghtarg,rmem)
c-----------------------------------------------------------------------
c   INPUT PARAMETERS:
c
c   nd:    in: integer *8
c             number of densities
c   
c   eps:   in: double precision
c             requested precision
c
c   zk:    in: double complex
c               helmholtz parameter                
c
c   nsource in: integer *8  
c                number of sources
c
c   source  in: double precision (3,nsource)
c                source(k,j) is the kth component of the jth
c                source locations
c
c   ifcharge  in: integer *8  
c             charge computation flag
c              ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c 
c   ifdipole   in: integer *8
c              dipole computation flag
c              ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c   iper    in: integer *8
c             flag for periodic implmentations. Currently unused
c   ifpgh   in: integer *8
c              flag for evaluating potential/gradient at the sources
c              ifpgh = 1, only potential is evaluated
c              ifpgh = 2, potential and gradients are evaluated
c
c
c   ntarg  in: integer *8  
c                 number of targs 
c
c   targ  in: double precision (3,ntarg)
c               targ(k,j) is the kth component of the jth
c               targ location
c
c   ifpghtarg   in: integer *8
c              flag for evaluating potential/gradient at the targs
c              ifpghtarg = 1, only potential is evaluated
c              ifpghtarg = 2, potential and gradient are evaluated
c
c
c     OUTPUT parameters:
c
c   rmem        out: real *8
c                 memory used in gb
c     
c------------------------------------------------------------------

      implicit none

      integer *8 nd
      integer *8 iper
      integer *8 ier

      double complex zk
      double precision eps

      integer *8 ifcharge,ifdipole
      integer *8 ifpgh,ifpghtarg

      integer *8 nsource,ntarg

      double precision source(3,nsource),targ(3,ntarg)
      double precision rmem


c       Tree variables
      integer *8 mhung,idivflag,ndiv,isep,nboxes,nbmax,nlevels
      integer *8 nlmax
      integer *8 mnbors
      integer *8 ifunif,nlmin
      integer *8 ipointer(8),ltree,lmem8,bigint,bigint0
      integer *8, allocatable :: itree(:)
      integer *8, allocatable :: isrcse(:,:),itargse(:,:),isrc(:)
      integer *8, allocatable :: itarg(:)
      integer *8, allocatable :: iexpcse(:,:)
      integer *8 iexpc
      double precision, allocatable :: treecenters(:,:),boxsize(:)
      double precision b0,b0inv,b0inv2,b0inv3
      integer *8 mnlist1,mnlist2,mnlist3,mnlist4
      double precision xmin, xmax, ymin, ymax, zmin, zmax, dbsize
      double precision bs0, sizey, sizez
      


c
cc       temporary fmm arrays
c
      integer *8 ilevcutoff
      double complex zkfmm,zk2
      double precision epsfmm
      integer *8, allocatable :: nterms(:)
      integer *8, allocatable :: iaddr(:,:)
      double precision rz,zi,zkiupbound,zkrupbound

      integer *8 lmptemp,nmax
      integer *8 lmptot
c
c    plane wave arrays
c
      integer *8 nlams,nphmax,ntmax,nthmax
      double complex, allocatable :: rlams(:),whts(:)
      integer *8, allocatable :: nfourier(:), nphysical(:)
      integer *8 nexptot, nexptotp, nn
      integer *8 nexptot_max, nexptotp_max, nn_max


c
cc       temporary variables not used in particle code
c
      double precision expc(3),scjsort(1),radexp
      double complex texpssort(100)
      double precision expcsort(3),radssort(1)
      integer *8 ntj,nexpc,nadd,ifnear

c
cc        other temporary variables
c
      integer *8 i,iert,ifprint,ilev,idim
      integer *8 nthread
      double precision time1,time2,omp_get_wtime,second
      integer *8 omp_get_max_threads,ntread
      double precision done,pi



       
c
c
c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c      
      ifprint=0

c
c       turn on computation of list 1
c
      ifnear = 1

c
c  Determine the computational boxsize
c

      xmin = source(1,1)
      xmax = source(1,1)
      ymin = source(2,1)
      ymax = source(2,1)
      zmin = source(3,1)
      zmax = source(3,1)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,nsource
        if(source(1,i).lt.xmin) xmin = source(1,i)
        if(source(1,i).gt.xmax) xmax = source(1,i)
        if(source(2,i).lt.ymin) ymin = source(2,i)
        if(source(2,i).gt.ymax) ymax = source(2,i)
        if(source(3,i).lt.zmin) zmin = source(3,i)
        if(source(3,i).gt.zmax) zmax = source(3,i)
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,ntarg
        if(targ(1,i).lt.xmin) xmin = targ(1,i)
        if(targ(1,i).gt.xmax) xmax = targ(1,i)
        if(targ(2,i).lt.ymin) ymin = targ(2,i)
        if(targ(2,i).gt.ymax) ymax = targ(2,i)
        if(targ(3,i).lt.zmin) zmin = targ(3,i)
        if(targ(3,i).gt.zmax) zmax = targ(3,i)
      enddo
C$OMP END PARALLEL DO      

      bs0 = (xmax - xmin)
      sizey = (ymax - ymin)
      sizez = (zmax - zmin)
      if(sizey.gt.bs0) bs0 = sizey
      if(sizez.gt.bs0) bs0 = sizez

      pi = atan(1.0d0)*4.0d0

      dbsize = real(zk)*bs0/2/pi
      
c
cc        set criterion for box subdivision
c
      call hndiv(dbsize,eps,nsource,ntarg,ifcharge,ifdipole,ifpgh,
     1   ifpghtarg,ndiv,idivflag) 

      nexpc = 0
      nadd = 0
      ntj = 0
c
cc      set tree flags
c 
      nlmax = 51
      nlevels = 0
      nboxes = 0
      ltree = 0
      nlmin = 0
      iper = 0
      ifunif = 0

c
cc     memory management code for contructing level restricted tree
      call pts_tree_mem(source,nsource,targ,ntarg,idivflag,ndiv,nlmin,
     1  nlmax,iper,ifunif,nlevels,nboxes,ltree)
      
        if(ifprint.ge.1) print *, ltree/1.0d9

        allocate(itree(ltree))
        allocate(boxsize(0:nlevels))
        allocate(treecenters(3,nboxes))

c       Call tree code
      call pts_tree_build(source,nsource,targ,ntarg,idivflag,ndiv,
     1  nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree,itree,ipointer,
     2  treecenters,boxsize)
      

c
c   End of tree build
c
c
c   estimate mnlist1,mnlist2,mnlist3,mnlist4
c
      mnbors = 27
      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
      isep = 1

      call computemnlists(nlevels,nboxes,itree(ipointer(1)),boxsize,
     1  treecenters,itree(ipointer(3)),itree(ipointer(4)),
     2  itree(ipointer(5)),isep,itree(ipointer(6)),mnbors,
     2  itree(ipointer(7)),iper,mnlist1,mnlist2,mnlist3,mnlist4)
      

c
c  Set rescaling parameters
c
      b0 = boxsize(0)
      b0inv = 1.0d0/b0
      b0inv2 = b0inv**2

      allocate(nterms(0:nlevels)) 

      zkfmm = zk*b0



c     Compute length of expansions at each level      
      nmax = 0
      if(ifprint.ge.1) call prin2('boxsize=*',boxsize,nlevels+1)
      if(ifprint.ge.1) call prin2('zkfmm=*',zkfmm,2)
      do i=0,nlevels
         call h3dterms(boxsize(i),zkfmm,eps,nterms(i))
         if(nterms(i).gt.nmax) nmax = nterms(i)
      enddo
      if(ifprint.ge.1) call prinf('nlevels=*',nlevels,1)
      if(ifprint.ge.1) call prinf('nterms=*',nterms,nlevels+1)
c       
c     Multipole and local expansions will be held in workspace
c     in locations pointed to by array iaddr(2,nboxes).
c
c     iiaddr is pointer to iaddr array, itself contained in workspace.
c     imptemp is pointer for single expansion (dimensioned by nmax)
c
c       ... allocate iaddr and temporary arrays
c

      allocate(iaddr(2,nboxes))
      lmptemp = (nmax+1)*(2*nmax+1)*2*nd
      call mpalloc(nd,itree(ipointer(1)),iaddr,nlevels,lmptot,nterms)
      if(ifprint.ge. 1) print *, "lmptot =",lmptot/1.0d9

      lmem8 = 100000
c
c    note that things are doubled due to two copies of arrays
c    needed
c
c    source array
c
      bigint = 7
      bigint = bigint*nsource
      lmem8 = lmem8 + bigint 
c
c    charge and dipole arrays
c
      bigint0 = nsource
      bigint0 = bigint0*nd
      if(ifcharge.eq.1) then
        bigint = 4*bigint0
        lmem8 = lmem8 + bigint
      endif
      if(ifdipole.eq.1) then
        bigint = 12*bigint0
        lmem8 = lmem8 + bigint 
      endif

c
c    target array
c
      bigint = 7
      bigint = 7*ntarg
      lmem8 = lmem8 + bigint 
c
c
c     pot, grad, hess arrays
c
      bigint0 = nsource
      bigint0 = bigint0*nd
      if(ifpgh.eq.1) then
        bigint = bigint0*4
        lmem8 = lmem8 + bigint 
      endif
      if(ifpgh.eq.2) then
        bigint = bigint0*12
        lmem8 = lmem8 + bigint 
      endif
      if(ifpgh.eq.3) then
        bigint = bigint0*24
        lmem8 = lmem8 + bigint
      endif
      
      bigint0 = ntarg*nd
      if(ifpghtarg.eq.1) then
        bigint = bigint0*4
        lmem8 = lmem8 + bigint 
      endif
      if(ifpghtarg.eq.1) then
        bigint = bigint0*12
        lmem8 = lmem8 + bigint 
      endif
      if(ifpghtarg.eq.1) then
        bigint = bigint0*24
        lmem8 = lmem8 + bigint 
      endif

      nthread = 1
C$      nthread = omp_get_max_threads()

c
c
c    tree variables
c  
      lmem8 = lmem8 + ltree
      lmem8 = lmem8 + 7*nboxes

c
c   buffer for temporary arrays proportional to nboxes
c
      bigint = 20
      bigint = bigint*nboxes
      bigint = bigint*nthread
      lmem8 = lmem8 + bigint 
c
c   rmlexp array
c
      lmem8 = lmem8 + lmptot

c
c   buffer for mptemp arrays
c
      bigint = 4
      bigint = bigint*lmptemp
      bigint = bigint*nthread
      lmem8 = lmem8 + bigint 
c
c    list1-4
c
      bigint = mnlist1 + mnlist2 + mnlist3 + mnlist4 + 4
      bigint = bigint*nboxes
      lmem8 = lmem8 + bigint 
c
c    pwlist 
c
      lmem8 = lmem8 + 1000*nthread

c
c    temp list3-4 arrays
c
      bigint = 48
      bigint = bigint*(nsource+ntarg)
      bigint = bigint*nthread
      lmem8 = lmem8 + bigint

      bigint = 32
      bigint = bigint*nthread
      bigint = bigint*lmptemp
      lmem8 = lmem8 + bigint 
c
c    plane wave arrays
c
      ntmax = 1000
      allocate(nfourier(ntmax),nphysical(ntmax))
      allocate(rlams(ntmax),whts(ntmax))

      nexptot_max = 0
      nexptotp_max = 0
      nn_max = 0

      done = 1
      pi = atan(done)*4

      zkiupbound = 12*pi
      zkrupbound = 16*pi
      zi = dimag(zkfmm)

      ilevcutoff = -1

      nmax = 0
      do i=0,nlevels
         if(nmax.lt.nterms(i)) nmax = nterms(i)
         rz = exp(-zi*boxsize(i))/boxsize(i)
         if(rz.lt.eps) ilevcutoff = i
      enddo


      do ilev=2,nlevels
        zk2 = zkfmm*boxsize(ilev)
        if(real(zk2).le.zkrupbound.and.dimag(zk2).lt.zkiupbound.and.
     1     ilev.gt.ilevcutoff) then

          ier = 0
          call hwts3e(ier,eps,zk2,rlams,whts,nlams)
          call hnumfour(eps,zk2,nlams,nfourier)
          call hnumphys(eps,zk2,nlams,nphysical)
          nphmax = 0
          nthmax = 0
          nexptotp = 0
          nexptot = 0
          nn = nterms(ilev)
          do i=1,nlams
            nexptotp = nexptotp + nphysical(i)
            nexptot = nexptot + 2*nfourier(i)+1
            if(nfourier(i).gt.nthmax) nthmax = nfourier(i)
            if(nphysical(i).gt.nphmax) nphmax = nphysical(i)
          enddo
          if(nn.gt.nn_max) nn_max = nn
          if(nexptotp.gt.nexptotp_max) nexptotp_max = nexptotp
          if(nexptot.gt.nexptot_max) nexptot_max = nexptot
        endif
      enddo
      
      bigint = 54
      bigint = bigint*nexptotp_max
      lmem8 = lmem8 + bigint

      bigint = 4*nd
      bigint = bigint*nthread
      bigint = bigint*nexptot_max
      lmem8 = lmem8 + bigint
      bigint = 36*nd
      bigint = bigint*nexptotp_max
      bigint = bigint*nthread
      lmem8 = lmem8 + bigint
c
c  adding buffer of 6*nboxes*nexptotp_max*nd to account for list4
c  processing through plane waves

      bigint = 18
      bigint = bigint*nd
      bigint = bigint*nexptotp_max
      bigint = bigint*nboxes
      lmem8 = lmem8 + bigint 


      lmem8 = lmem8 + 100*(nn_max+1)*(nn_max+1)*(2*nn_max+1)

      rmem = (lmem8+0.0d0)/1024/1024/1024*8
      if(ifprint.ge.1) call prinf('nthread=*',nthread,1)
      if(ifprint.ge.1) call prinf('nexptot_max=*',nexptot_max,1)
      if(ifprint.ge.1) call prinf('nn_max=*',nn_max,1)
      if(ifprint.ge.1) call prinf('nboxes=*',nboxes,1)
      if(ifprint.ge.1) call prinf('nexptotp_max=*',nexptotp_max,1)
      if(ifprint.ge.1) print *, "lmem8=",lmem8
      if(ifprint.ge.1) call prin2('mem required in GB=*',rmem,1)
       

      return
      end
c

c
c
c    common routines for generating and processing
c     a level restricted quad tree in 2D
c   
c
c
c
      subroutine tree_refine_boxes(irefinebox,nboxes,
     1  ifirstbox,nbloc,centers,bs,nbctr,nlctr,
     2  ilevel,iparent,nchild,ichild)
      implicit none
      integer *8 nboxes,nbloc,nbctr,nlctr
      real *8 centers(3,nboxes),bs
      integer *8 ilevel(nboxes),iparent(nboxes)
      integer *8 ichild(8,nboxes),nchild(nboxes)
      integer *8 irefinebox(nbloc)
      integer *8 ifirstbox
      integer *8, allocatable :: isum(:)
      integer *8 ii

      integer *8 i,ibox,nel0,j,l,jbox,nel1,nbl,jj

      allocate(isum(nbloc))
      if(nbloc.gt.0) call cumsum(nbloc,irefinebox,isum)
      
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,ibox,nbl,j,jbox,ii,jj,l)
      do i = 1,nbloc
        ibox = ifirstbox + i-1
        if(irefinebox(i).eq.1) then
          nbl = nbctr + (isum(i)-1)*8
          
          nchild(ibox) = 8
          do j=1,8
            ii = 2
            jj = 2
            if(j.eq.1.or.j.eq.2.or.j.eq.5.or.j.eq.6) ii = 1
            if(j.lt.5) jj = 1
            jbox = nbl+j
            centers(1,jbox) = centers(1,ibox)+(-1)**j*bs/2
            centers(2,jbox) = centers(2,ibox)+(-1)**ii*bs/2 
            centers(3,jbox) = centers(3,ibox)+(-1)**jj*bs/2 
            iparent(jbox) = ibox
            nchild(jbox) = 0
            do l=1,8
              ichild(l,jbox) = -1
            enddo
            ichild(j,ibox) = jbox
            ilevel(jbox) = nlctr 
          enddo
        endif
      enddo
C$OMP END PARALLEL DO      

      if(nbloc.gt.0) nbctr = nbctr + isum(nbloc)*8


      return
      end
c
c
c
c
c
c
       subroutine tree_copy(nb,centers,ilevel,iparent,nchild,ichild,
     1              centers2,ilevel2,iparent2,nchild2,ichild2)

       implicit none
       integer *8 nd,nb,npb
       real *8 centers(3,nb),centers2(3,nb)
       integer *8 ilevel(nb),ilevel2(nb)
       integer *8 iparent(nb),iparent2(nb)
       integer *8 nchild(nb),nchild2(nb)
       integer *8 ichild(8,nb),ichild2(8,nb)

       integer *8 i,j,nel


C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
       do i=1,nb
         centers2(1,i) = centers(1,i)
         centers2(2,i) = centers(2,i)
         centers2(3,i) = centers(3,i)
         ilevel2(i) = ilevel(i)
         iparent2(i) = iparent(i)
         nchild2(i) = nchild(i)
         ichild2(1,i) = ichild(1,i)
         ichild2(2,i) = ichild(2,i)
         ichild2(3,i) = ichild(3,i)
         ichild2(4,i) = ichild(4,i)
         ichild2(5,i) = ichild(5,i)
         ichild2(6,i) = ichild(6,i)
         ichild2(7,i) = ichild(7,i)
         ichild2(8,i) = ichild(8,i)
       enddo
C$OMP END PARALLEL DO       
       

       return
       end
c
c
c
c
c

      subroutine computecoll(nlevels,nboxes,laddr,boxsize,
     1                       centers,iparent,nchild,ichild,
     2                       iper,nnbors,nbors)

c     This subroutine computes the colleagues for an adaptive
c     pruned tree. box j is a colleague of box i, if they share a
c     vertex or an edge and the two boxes are at the same
c     level in the tree
c
c     INPUT arguments
c     nlevels     in: integer *8
c                 Number of levels
c
c     nboxes      in: integer *8
c                 Total number of boxes
c
c     laddr       in: integer *8(2,0:nlevels)
c                 indexing array providing access to boxes at
c                 each level. 
c                 the first box on level i is laddr(1,i)
c                 the last box on level i is laddr(2,i)
c
c     boxsize     in: double precision(0:nlevels)
c                 Array of boxsizes
c 
c     centers     in: double precision(3,nboxes)
c                 array of centers of boxes
c   
c     iparent     in: integer *8(nboxes)
c                 iparent(i) is the box number of the parent of
c                 box i
c
c     nchild      in: integer *8(nboxes)
c                 nchild(i) is the number of children of box i
c
c     ichild      in: integer *8(8,nboxes)
c                 ichild(j,i) is the box id of the jth child of
c                 box i
c
c     iper        in: integer *8
c                 flag for periodic implementations. 
c                 Currently not used. Feature under construction.
c
c----------------------------------------------------------------
c     OUTPUT
c     nnbors      out: integer *8(nboxes)
c                 nnbors(i) is the number of colleague boxes of
c                 box i
c
c     nbors       out: integer *8(27,nboxes)
c                 nbors(j,i) is the box id of the jth colleague
c                 box of box i
c---------------------------------------------------------------
      implicit none
      integer *8 nlevels,nboxes,iper
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes), nchild(nboxes), ichild(8,nboxes)
      integer *8 nnbors(nboxes)
      integer *8 nbors(27,nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,dad
      integer *8 i,j,ifirstbox,ilastbox


c     Setting parameters for level = 0
      nnbors(1) = 1
      nbors(1,1) = 1
      do ilev = 1,nlevels
c        Find the first and the last box at level ilev      
         ifirstbox = laddr(1,ilev)
         ilastbox = laddr(2,ilev)
c        Loop over all boxes to evaluate neighbors, list1 and updating
c        hunglists of targets

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox)
         do ibox = ifirstbox,ilastbox
c           Find the parent of the current box         
            dad = iparent(ibox)
c           Loop over the neighbors of the parent box
c           to find out list 1 and list 2
            do i=1,nnbors(dad)
                jbox = nbors(i,dad)
                do j=1,8
c               ichild(j,jbox) is one of the children of the
c               neighbors of the parent of the current
c               box
                   kbox = ichild(j,jbox)
                   if(kbox.gt.0) then
c               Check if kbox is a nearest neighbor or in list 2
                      if((abs(centers(1,kbox)-centers(1,ibox)).le.
     1                   1.05*boxsize(ilev)).and.
     2                   (abs(centers(2,kbox)-centers(2,ibox)).le.
     3                   1.05*boxsize(ilev)).and.
     2                   (abs(centers(3,kbox)-centers(3,ibox)).le.
     3                   1.05*boxsize(ilev))) then
                     
                         nnbors(ibox) = nnbors(ibox)+1
                         nbors(nnbors(ibox),ibox) = kbox
                      endif
                   endif
                enddo
            enddo
c           End of computing colleagues of box i
         enddo
C$OMP END PARALLEL DO         
      enddo

      return
      end
c
c
c
c
c--------------------------------------------------------------------      
      subroutine updateflags(curlev,nboxes,nlevels,laddr,nchild,ichild,
     1                    nnbors,nbors,centers,boxsize,iflag)

c      This subroutine is to check the boxes flagged as flag++
c      and determine which of the boxes need refinement. The flag
c      of the box which need refinement is updated to iflag(box)=1
c      and that of the boxes which do not need refinement is
c      updated to iflag(box) = 0
c
c      INPUT arguments
c      curlev         in: integer *8
c                     the level for which boxes need to be processed
c
c      nboxes         in: integer *8
c                     total number of boxes
c
c      nlevels        in: integer *8
c                     total number of levels
c
c      laddr          in: integer *8(2,0:nlevels)
c                     boxes from laddr(1,ilev) to laddr(2,ilev)
c                     are at level ilev
c
c      nchild         in: integer *8(nboxes)
c                     nchild(ibox) is the number of children
c                     of box ibox
c
c      ichild         in: integer *8(8,nboxes)
c                     ichild(j,ibox) is the box id of the jth
c                     child of box ibox
c
c      nnbors         in: integer *8(nboxes)
c                     nnbors(ibox) is the number of colleagues
c                     of box ibox
c
c      nbors          in: integer *8(27,nboxes)
c                     nbors(j,ibox) is the jth colleague of box
c                     ibox
c
c      centers        in: double precision(2,nboxes)
c                     x and y coordinates of the box centers
c
c      boxsize        in: double precision(0:nlevels)
c                     boxsize(i) is the size of the box at level i
c
c      iflag          in/out: integer *8(nboxes)
c                     iflag(ibox)=3 if it is flag++. iflag(ibox) =1
c                     or 0 at the end of routine depending on
c                     whether box needs to be subdivided or not
c
      implicit none
c     Calling sequence variables
      integer *8 curlev, nboxes, nlevels
      integer *8 laddr(2,0:nlevels),nchild(nboxes),ichild(8,nboxes)
      integer *8 nnbors(nboxes), nbors(27,nboxes)
      integer *8 iflag(nboxes)
      double precision centers(3,nboxes),boxsize(0:nlevels)

c     Temporary variables
      integer *8 i,j,k,l,ibox,jbox,kbox,lbox, ict
      double precision distest,xdis,ydis,zdis

      distest = 1.05d0*(boxsize(curlev) + boxsize(curlev+1))/2.0d0
c     Loop over all boxes at the current level     

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,i,jbox,j,kbox,xdis,ydis)
C$OMP$PRIVATE(zdis,ict)
      do ibox = laddr(1,curlev),laddr(2,curlev)
         if(iflag(ibox).eq.3) then
            iflag(ibox) = 0
c           Loop over colleagues of the current box      
            do i=1,nnbors(ibox)
c              Loop over colleagues of flag++ box        
               jbox = nbors(i,ibox)
              
c              Loop over the children of the colleague box
c              Note we do not need to exclude self from
c              the list of colleagues as a self box which
c              is flag++ does not have any children 
c              and will not enter the next loop
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if(nchild(kbox).gt.0) then
                        xdis = centers(1,kbox) - centers(1,ibox)
                        ydis = centers(2,kbox) - centers(2,ibox)
                        zdis = centers(3,kbox) - centers(3,ibox)
                        ict = 0
                        if(abs(xdis).le.distest) ict = ict + 1
                        if(abs(ydis).le.distest) ict = ict + 1
                        if(abs(zdis).le.distest) ict = ict + 1
                        if(ict.eq.3) then
                           iflag(ibox) = 1
                           goto 1111
                        endif
                     endif
                  endif
c                 End of looping over the children of the child
c                 of the colleague box
               enddo
c              End of looping over the children of the colleague box       
            enddo
c           End of looping over colleagues            
 1111       continue        
         endif
c        End of testing if the current box needs to checked for         
      enddo
c     End of looping over boxes at the current level      
C$OMP END PARALLEL DO      

      return
      end
c
c
c
c
c
c

      subroutine tree_refine_boxes_flag(iflag,nboxes,
     1  ifirstbox,nbloc,centers,bs,nbctr,nlctr,
     2  ilevel,iparent,nchild,ichild)
      implicit none
      integer *8 nboxes,nbloc,nbctr,nlctr
      real *8 centers(3,nboxes),bs
      integer *8 ilevel(nboxes),iparent(nboxes)
      integer *8 ichild(8,nboxes),nchild(nboxes)
      integer *8 iflag(nboxes)
      integer *8 ifirstbox
      integer *8, allocatable :: isum(:),itmp(:)

      integer *8 i,ibox,nel0,j,l,jbox,nel1,nbl
      integer *8 ii,jj

      allocate(isum(nbloc),itmp(nbloc))
      
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,i)
      do i=1,nbloc
        ibox = ifirstbox+i-1
        itmp(i) = 0
        if(iflag(ibox).gt.0) itmp(i) = 1
      enddo
C$OMP END PARALLEL DO
      if(nbloc.gt.0) call cumsum(nbloc,itmp,isum)
      
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,ibox,nbl,j,jbox,ii,jj,l)
      do i = 1,nbloc
        ibox = ifirstbox + i-1
        if(iflag(ibox).gt.0) then
          nbl = nbctr + (isum(i)-1)*8
          
          nchild(ibox) = 8
          do j=1,8
            ii = 2
            jj = 2
            if(j.eq.1.or.j.eq.2.or.j.eq.5.or.j.eq.6) ii = 1
            if(j.lt.5) jj = 1
            jbox = nbl+j
            centers(1,jbox) = centers(1,ibox)+(-1)**j*bs/2
            centers(2,jbox) = centers(2,ibox)+(-1)**ii*bs/2 
            centers(3,jbox) = centers(3,ibox)+(-1)**jj*bs/2 
            iparent(jbox) = ibox
            nchild(jbox) = 0
            do l=1,8
              ichild(l,jbox) = -1
            enddo
            ichild(j,ibox) = jbox
            ilevel(jbox) = nlctr+1 
            if(iflag(ibox).eq.1) iflag(jbox) = 3
            if(iflag(ibox).eq.2) iflag(jbox) = 0
          enddo
        endif
      enddo
C$OMP END PARALLEL DO      

      if(nbloc.gt.0) nbctr = nbctr + isum(nbloc)*8


      return
      end
c
c
c
c
c
      subroutine computemnlists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,isep,nnbors,mnbors,nbors,iper,mnlist1,
     3                   mnlist2,mnlist3,mnlist4)
c     Compute max nuber of boxes in list1,list2,list3,list4
      implicit none
      integer *8 nlevels,nboxes
      integer *8 iper
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes),nchild(nboxes),ichild(8,nboxes)
      integer *8 mnbors,isep
      integer *8 nnbors(nboxes),nbors(mnbors,nboxes)
      integer *8 mnlist1,mnlist2,mnlist3,mnlist4
      integer *8 nlist1(nboxes),nlist2(nboxes),nlist3(nboxes)
      integer *8 nlist4(nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,i,j,k,l
      integer *8 firstbox,lastbox,dad
      double precision xdis,ydis,zdis,distest


C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nboxes
         nlist1(i) = 0
         nlist2(i) = 0
         nlist3(i) = 0
         nlist4(i) = 0
      enddo
C$OMP END PARALLEL DO
      
      nlist1(1) = 1
      nlist2(1) = 0
      nlist3(1) = 0
      nlist4(1) = 0

      do ilev = 1,nlevels
         firstbox = laddr(1,ilev)
         lastbox = laddr(2,ilev)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox,distest,xdis,ydis,zdis)
         do ibox = firstbox,lastbox
            dad = iparent(ibox)
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if((abs(centers(1,kbox)-centers(1,ibox)).ge.
     1                  1.05d0*isep*boxsize(ilev)).or.
     2                  (abs(centers(2,kbox)-centers(2,ibox)).ge.
     3                  1.05d0*isep*boxsize(ilev)).or.
     4                  (abs(centers(3,kbox)-centers(3,ibox)).ge.
     5                  1.05d0*isep*boxsize(ilev))) then

                        nlist2(ibox) = nlist2(ibox) + 1
                     endif
                  endif
               enddo
            enddo
c           Compute list1 and list3 of ibox if it is childless
            if(nchild(ibox).eq.0) then
               do i=1,nnbors(ibox)
                  jbox = nbors(i,ibox)

c
cc                     check for list1 at the same level
c
                  if(nchild(jbox).eq.0) then
                     nlist1(ibox) = nlist1(ibox) + 1
                  endif
c
cc                     check for list1 and list3 at one ilev+1
                  if(nchild(jbox).gt.0) then
                     distest = 1.05d0*(boxsize(ilev)+boxsize(ilev+1))/
     1                         2.0d0*isep
                     do j=1,8
                        kbox = ichild(j,jbox)
                        if(kbox.gt.0) then
                           xdis = dabs(centers(1,kbox)-centers(1,ibox))
                           ydis = dabs(centers(2,kbox)-centers(2,ibox))
                           zdis = dabs(centers(3,kbox)-centers(3,ibox))

                           if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                        zdis.lt.distest) then
                              nlist1(ibox) = nlist1(ibox)+1
                           else
                              nlist3(ibox) = nlist3(ibox)+1
                           endif
                        endif
                     enddo
                  endif
               enddo
c
cc               compute list1 and list4 for boxes at level ilev-1 
               do i=1,nnbors(dad)
                   jbox = nbors(i,dad)
                   if(nchild(jbox).eq.0) then
                      distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                         2.0d0*isep
                      xdis = dabs(centers(1,jbox)-centers(1,ibox))
                      ydis = dabs(centers(2,jbox)-centers(2,ibox))
                      zdis = dabs(centers(3,jbox)-centers(3,ibox))
                      if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                  zdis.lt.distest) then
                         nlist1(ibox) = nlist1(ibox)+1
                      endif
                   endif
               enddo
            endif
c
cc           compute list 4 at level ilev-1
c
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               if(nchild(jbox).eq.0) then
                   distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                 2.0d0*isep
                    xdis = dabs(centers(1,jbox)-centers(1,ibox))
                    ydis = dabs(centers(2,jbox)-centers(2,ibox))
                    zdis = dabs(centers(3,jbox)-centers(3,ibox))
                    if(xdis.gt.distest.or.ydis.gt.distest.or.
     1                 zdis.gt.distest) then
                       nlist4(ibox) = nlist4(ibox)+1
                    endif
               endif
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i) 
C$OMP$REDUCTION(max:mnlist1,mnlist2,mnlist3,mnlist4)      
      do i=1,nboxes
         if(nlist1(i).gt.mnlist1) mnlist1 = nlist1(i)
         if(nlist2(i).gt.mnlist2) mnlist2 = nlist2(i)
         if(nlist3(i).gt.mnlist3) mnlist3 = nlist3(i)
         if(nlist4(i).gt.mnlist4) mnlist4 = nlist4(i)
      enddo
C$OMP END PARALLEL DO      

      return
      end
c---------------------------------------------------------------      
      subroutine computelists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,isep,nnbors,mnbors,nbors,iper,nlist1,
     3                   mnlist1,list1,nlist2,mnlist2,list2,
     4                   nlist3,mnlist3,list3,nlist4,mnlist4,list4)
c     Compute max nuber of boxes in list1,list2,list3,list4
      implicit none
      integer *8 nlevels,nboxes
      integer *8 iper
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes),nchild(nboxes),ichild(8,nboxes)
      integer *8 mnbors
      integer *8 nnbors(nboxes),nbors(mnbors,nboxes)
      integer *8 mnlist1,mnlist2,mnlist3,mnlist4,isep
      integer *8 nlist1(nboxes),nlist2(nboxes),nlist3(nboxes)
      integer *8 nlist4(nboxes)
      integer *8 list1(mnlist1,nboxes),list2(mnlist2,nboxes)
      integer *8 list3(mnlist3,nboxes),list4(mnlist4,nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,i,j,k,l
      integer *8 firstbox,lastbox,dad
      double precision xdis,ydis,zdis,distest

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,nboxes
         nlist1(i) = 0
         nlist2(i) = 0
         nlist3(i) = 0
         nlist4(i) = 0
      enddo
C$OMP END PARALLEL DO      
      if(nchild(1).eq.0) then
         nlist1(1) = 1
         list1(1,1) = 1
      else
         nlist1(1) = 0
      endif
      nlist2(1) = 0
      nlist3(1) = 0
      nlist4(1) = 0

      do ilev = 1,nlevels
         firstbox = laddr(1,ilev)
         lastbox = laddr(2,ilev)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox,xdis,ydis,zdis,distest)
         do ibox = firstbox,lastbox
            dad = iparent(ibox)
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if((abs(centers(1,kbox)-centers(1,ibox)).ge.
     1                  1.05d0*isep*boxsize(ilev)).or.
     2                  (abs(centers(2,kbox)-centers(2,ibox)).ge.
     3                  1.05d0*isep*boxsize(ilev)).or.
     4                  (abs(centers(3,kbox)-centers(3,ibox)).ge.
     5                  1.05d0*isep*boxsize(ilev))) then

                        nlist2(ibox) = nlist2(ibox) + 1
                        list2(nlist2(ibox),ibox) = kbox
                     endif
                  endif
               enddo
            enddo
c           Compute list1 and list3 of ibox if it is childless
            if(nchild(ibox).eq.0) then
               do i=1,nnbors(ibox)
                  jbox = nbors(i,ibox)

c
cc                boxes in list 1 at the same level
c

                  if(nchild(jbox).eq.0) then
                     nlist1(ibox) = nlist1(ibox) + 1
                     list1(nlist1(ibox),ibox) = jbox
                  else
c
cc                     boxes in list1 and list3 at level ilev+1
c
                     distest = 1.05d0*(boxsize(ilev)+boxsize(ilev+1))/
     1                         2.0d0*isep
                     do j=1,8
                        kbox = ichild(j,jbox)
                        if(kbox.gt.0) then
                           xdis = dabs(centers(1,kbox)-centers(1,ibox))
                           ydis = dabs(centers(2,kbox)-centers(2,ibox))
                           zdis = dabs(centers(3,kbox)-centers(3,ibox))

                           if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                        zdis.lt.distest) then
                              nlist1(ibox) = nlist1(ibox)+1
                              list1(nlist1(ibox),ibox) = kbox
                           else
                              nlist3(ibox) = nlist3(ibox)+1
                              list3(nlist3(ibox),ibox) = kbox
                           endif
                        endif
                     enddo
                  endif
               enddo
c
cc               compute list1 at level ilev-1 
               do i=1,nnbors(dad)
                   jbox = nbors(i,dad)
                   if(nchild(jbox).eq.0) then
                      distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                         2.0d0*isep
                      xdis = dabs(centers(1,jbox)-centers(1,ibox))
                      ydis = dabs(centers(2,jbox)-centers(2,ibox))
                      zdis = dabs(centers(3,jbox)-centers(3,ibox))
                      if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                  zdis.lt.distest) then
                         nlist1(ibox) = nlist1(ibox)+1
                         list1(nlist1(ibox),ibox) = jbox
                      endif
                   endif
                enddo
            endif
c
cc           compute list 4 at level ilev-1
c
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               if(nchild(jbox).eq.0) then
                   distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                 2.0d0*isep
                    xdis = dabs(centers(1,jbox)-centers(1,ibox))
                    ydis = dabs(centers(2,jbox)-centers(2,ibox))
                    zdis = dabs(centers(3,jbox)-centers(3,ibox))
                    if(xdis.gt.distest.or.ydis.gt.distest.or.
     1                 zdis.gt.distest) then
                       nlist4(ibox) = nlist4(ibox)+1
                       list4(nlist4(ibox),ibox)=jbox
                    endif
               endif
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      return
      end
c----------------------------------------------------------------

      subroutine getpwlistall(ibox,bs,nboxes,nnbors,nbors,
     1           nchild,ichild,centers,isep,nuall,uall,ndall,dall,nnall,
     2           nall,nsall,sall,neall,eall,nwall,wall,nu1234,u1234,
     3           nd5678,d5678,nn1256,n1256,ns3478,s3478,ne1357,e1357,
     4           nw2468,w2468,nn12,n12,nn56,n56,ns34,s34,ns78,s78,ne13,
     5           e13,ne57,e57,nw24,w24,nw68,w68,ne1,e1,ne3,e3,ne5,e5,
     6           ne7,e7,nw2,w2,nw4,w4,nw6,w6,nw8,w8)
c-------------------------------------------------------------------
      implicit none
      integer *8 ibox
      double precision boxsize,bs
      integer *8 nboxes,nnbors,nbors(nnbors)
      integer *8 nchild, ichild(8,nboxes)
      double precision centers(3,nboxes)
      integer *8 isep
      integer *8 nuall,ndall,nnall,nsall,neall,nwall,nu1234
      integer *8 nd5678,nn1256,ns3478,ne1357,nw2468
      integer *8 nn12,nn56,ns34,ns78,ne13,ne57,nw24,nw68
      integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8
      integer *8 uall(1),dall(1),nall(1),sall(1),eall(1),wall(1)
      integer *8 u1234(1),d5678(1),n1256(1),s3478(1),e1357(1),w2468(1)
      integer *8 n12(1),n56(1),s34(1),s78(1),e13(1),e57(1),w24(1),w68(1)
      integer *8 e1(1),e3(1),e5(1),e7(1)
      integer *8 w2(1),w4(1),w6(1),w8(1)

      integer *8 jbox,kbox
      integer *8 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c16
      integer *8 i,j

      nuall = 0
      ndall = 0
      nnall = 0
      nsall = 0
      neall = 0
      nwall = 0
      nu1234 = 0
      nd5678 = 0
      nn1256 = 0
      ns3478 = 0
      ne1357 = 0
      nw2468 = 0
      nn12 = 0
      nn56 = 0
      ns34 = 0
      ns78 = 0
      ne13 = 0
      ne57 = 0
      nw24 = 0
      nw68 = 0
      ne1 = 0
      ne3 = 0
      ne5 = 0
      ne7 = 0
      nw2 = 0
      nw4 = 0
      nw6 = 0
      nw8 = 0
      do i=1,nnbors
         jbox = nbors(i)
         do j=1,8
            kbox = ichild(j,jbox)
            if(kbox.gt.0) then
               c1 = 0
               c2 = 0
               c3 = 0
               c4 = 0
               c5 = 0
               c6 = 0
               c7 = 0
               c8 = 0
               c9 = 0
               c10 = 0
               c11 = 0
               c12 = 0
               if((centers(3,kbox)-centers(3,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c1 = 1
               if((centers(3,kbox)-centers(3,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c2 = 1
               if((centers(2,kbox)-centers(2,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c3 = 1
               if((centers(2,kbox)-centers(2,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c4 = 1
               if((centers(1,kbox)-centers(1,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c5 = 1
               if((centers(1,kbox)-centers(1,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c6 = 1
               if((centers(3,kbox)-centers(3,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c7 = 1
               if((centers(3,kbox)-centers(3,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c8 = 1
               if((centers(2,kbox)-centers(2,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c9 = 1
               if((centers(2,kbox)-centers(2,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c10 = 1
               if((centers(1,kbox)-centers(1,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c11 = 1
               if((centers(1,kbox)-centers(1,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c12 = 1
               if(c1.eq.1) then
                  nuall = nuall + 1
                  uall(nuall) = kbox
               endif

               if(c2.eq.1) then
                  ndall = ndall + 1
                  dall(ndall) = kbox
               endif

               if(c3.eq.1.and.c1.eq.0.and.c2.eq.0) then
                  nnall = nnall + 1
                  nall(nnall) = kbox
               endif

               if(c4.eq.1.and.c1.eq.0.and.c2.eq.0) then   
                  nsall = nsall + 1
                  sall(nsall) = kbox
               endif

               if(c5.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1             c4.eq.0) then
                  neall = neall + 1
                  eall(neall) = kbox
               endif

               if(c6.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1            c4.eq.0) then
                  nwall = nwall + 1
                  wall(nwall) = kbox
               endif

               c16 = c1 + c2 + c3 + c4 + c5 +c6
               if(c16.eq.0.and.c7.eq.1) then
                  nu1234 = nu1234 + 1
                  u1234(nu1234) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1) then
                  nd5678 = nd5678 + 1
                  d5678(nd5678) = kbox
               endif

               if(c16.eq.0.and.c9.eq.1.and.c7.eq.0.and.c8.eq.0) then
                  nn1256 = nn1256 + 1
                  n1256(nn1256) = kbox
               endif

               if(c16.eq.0.and.c10.eq.1.and.c7.eq.0.and.c8.eq.0) then
                  ns3478 = ns3478 + 1
                  s3478(ns3478) = kbox
               endif

               if(c16.eq.0.and.c11.eq.1.and.(c7+c8+c9+c10).eq.0) then
                  ne1357 = ne1357 + 1
                  e1357(ne1357) = kbox
               endif

               if(c16.eq.0.and.c12.eq.1.and.(c7+c8+c9+c10).eq.0) then
                  nw2468 = nw2468 + 1
                  w2468(nw2468) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c9.eq.1) then
                  nn12 = nn12 + 1
                  n12(nn12) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c9.eq.1) then
                  nn56 = nn56 + 1
                  n56(nn56) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c10.eq.1) then
                  ns34 = ns34 + 1
                  s34(ns34) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c10.eq.1) then
                  ns78 = ns78 + 1
                  s78(ns78) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c11.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  ne13 = ne13 + 1
                  e13(ne13) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c11.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  ne57 = ne57 + 1
                  e57(ne57) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c12.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  nw24 = nw24 + 1
                  w24(nw24) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c12.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  nw68 = nw68 + 1
                  w68(nw68) = kbox
               endif

               if(c16.eq.0.and.c7.eq.0.and.c10.eq.1.and.c11.eq.1) then
                  ne1 = ne1 + 1
                  e1(ne1) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c9.eq.1.and.c11.eq.1) then
                  ne3 = ne3 + 1
                  e3(ne3) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c10.eq.1.and.c11.eq.1) then
                  ne5 = ne5 + 1
                  e5(ne5) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c9.eq.1.and.c11.eq.1) then
                  ne7 = ne7 + 1
                  e7(ne7) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c10.eq.1.and.c12.eq.1) then
                  nw2 = nw2 + 1
                  w2(nw2) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c9.eq.1.and.c12.eq.1) then
                  nw4 = nw4 + 1
                  w4(nw4) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c10.eq.1.and.c12.eq.1) then
                  nw6 = nw6 + 1
                  w6(nw6) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c9.eq.1.and.c12.eq.1) then
                  nw8 = nw8 + 1
                  w8(nw8) = kbox
               endif
            endif
         enddo
      enddo
      

      return
      end
c--------------------------------------------------------------------      

      subroutine getlist3pwlistall(ibox,bs,nboxes,nlist3,list3,
     1           isep,centers,nuall,uall,ndall,dall,nnall,
     2           nall,nsall,sall,neall,eall,nwall,wall)
c-------------------------------------------------------------------
      implicit none
      integer *8 ibox
      integer *8 isep
      integer *8 nboxes,nlist3,list3(nlist3)
      double precision centers(3,nboxes)
      double precision sepdist,bs
      integer *8 nuall,ndall,nnall,nsall,neall,nwall
      integer *8 uall(1),dall(1),nall(1),sall(1),eall(1),wall(1)

      integer *8 jbox
      integer *8 c1,c2,c3,c4,c5,c6
      integer *8 j

      nuall = 0
      ndall = 0
      nnall = 0
      nsall = 0
      neall = 0
      nwall = 0
      sepdist = 1.01d0*isep*bs+bs/2.0d0
      do j=1,nlist3
         jbox = list3(j)
C         print *,"jbox: ",jbox
         if(jbox.gt.0) then
            c1 = 0
            c2 = 0
            c3 = 0
            c4 = 0
            c5 = 0
            c6 = 0
            if((centers(3,jbox)-centers(3,ibox)).ge.sepdist) c1 = 1
            if((centers(3,jbox)-centers(3,ibox)).le.-sepdist) c2 = 1
            if((centers(2,jbox)-centers(2,ibox)).ge.sepdist) c3 = 1
            if((centers(2,jbox)-centers(2,ibox)).le.-sepdist) c4 = 1
            if((centers(1,jbox)-centers(1,ibox)).ge.sepdist) c5 = 1
            if((centers(1,jbox)-centers(1,ibox)).le.-sepdist) c6 = 1

C            print *,c1,c2,c3,c4,c5,c6

            if(c1.eq.1) then
               nuall = nuall + 1
               uall(nuall) = jbox
            endif

            if(c2.eq.1) then
               ndall = ndall + 1
               dall(ndall) = jbox
            endif

            if(c3.eq.1.and.c1.eq.0.and.c2.eq.0) then
               nnall = nnall + 1
               nall(nnall) = jbox
            endif

            if(c4.eq.1.and.c1.eq.0.and.c2.eq.0) then   
               nsall = nsall + 1
               sall(nsall) = jbox
            endif

            if(c5.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1         c4.eq.0) then
               neall = neall + 1
               eall(neall) = jbox
            endif

            if(c6.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1         c4.eq.0) then
               nwall = nwall + 1
               wall(nwall) = jbox
            endif
         endif
      enddo
      

      return
      end
c
c
c
c
c
c
c--------------------------------------------------------------------      

      subroutine getlist4pwdir(dir,censrc,centrg,boxsize)
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 dir
      double precision censrc(3)
      double precision centrg(3)
      double precision boxsize
ccc   scopded function variables
      double precision sepdist
      double precision ctmp(3)
      ctmp(1) = censrc(1)-0*boxsize/2.0d0
      ctmp(2) = censrc(2)-0*boxsize/2.0d0
      ctmp(3) = censrc(3)-0*boxsize/2.0d0

      sepdist=1.51d0*boxsize

      if(ctmp(3)-centrg(3).ge.sepdist) then
        dir=1
      else if(ctmp(3)-centrg(3).le.-sepdist) then
        dir=2
      else if(ctmp(2)-centrg(2).ge.sepdist) then
        dir=3
      else if(ctmp(2)-centrg(2).le.-sepdist) then
        dir=4
      else if(ctmp(1)-centrg(1).ge.sepdist) then
        dir=5
      else if(ctmp(1)-centrg(1).le.-sepdist) then
        dir=6
      else
        dir=0
      end if
C      dir=0

      return
      end
      
      subroutine getlist4pwdirtest(dir,censrc,centrg,boxsize)
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 dir
      double precision censrc(3)
      double precision centrg(3)
      double precision boxsize
ccc   scopded function variables
      double precision sepdist
      double precision ctmp(3)
      ctmp(1) = censrc(1)-0*boxsize/2.0d0
      ctmp(2) = censrc(2)-0*boxsize/2.0d0
      ctmp(3) = censrc(3)-0*boxsize/2.0d0

      sepdist=1.51d0*boxsize

      if((ctmp(3)-centrg(3)).ge.sepdist) then
        dir=1
      else if((ctmp(3)-centrg(3)).le.-sepdist) then
        dir=2
      else if((ctmp(2)-centrg(2)).ge.sepdist) then
        dir=3
      else if((ctmp(2)-centrg(2)).le.-sepdist) then
        dir=4
      else if((ctmp(1)-centrg(1)).ge.sepdist) then
        dir=5
      else if((ctmp(1)-centrg(1)).le.-sepdist) then
        dir=6
      else
        dir=0
        print *,"dir:",dir
      end if

      return
      end
c      
c
c
c
c
c--------------------------------------------------------------
c
      subroutine subdividebox(pos,npts,center,boxsize,
     1           isorted,iboxfl,subcenters)
      implicit none
      integer *8 npts
      double precision pos(3,npts)
      double precision center(3)
      double precision subcenters(3,8)
      double precision boxsize
      integer *8 isorted(*)
      integer *8 iboxfl(2,8)

c     Temporary variables
      integer *8 isortedtmp(npts)
      integer *8 i,j,i12,i34,istart,jstart,kstart,ii,iii,nss,nee
      integer *8 jj,irefinebox,ntt
      integer *8 i56, i78, i1234, i5678
      integer *8 ibox,ifirstbox,ilastbox,nbfirst
      integer *8 is,it,ie
      integer *8 nc(8)

      i1234 = 0
      i5678 = 0
      do i = 1,npts
         if(pos(3,i)-center(3).lt.0) then
            i1234 = i1234 + 1
            isorted(i1234) = i
         else
            i5678 = i5678 + 1
            isortedtmp(i5678) = i
         endif
      enddo
      do i=1,i5678
         isorted(i1234+i) = isortedtmp(i)
      enddo

c     Sort i1234 into i12 and i34         
      i12 = 0
      i34 = 0
      do i = 1,i1234
         if(pos(2,isorted(i))-center(2).lt.0) then
            i12 = i12 + 1
            isorted(i12) = isorted(i)
         else
            i34 = i34 + 1
            isortedtmp(i34) = isorted(i)
         endif
      enddo
c     Note at the end of the loop, i12 is where the particles
c     in part 12 of the box end
c
c     Reorder sources to include 34 in the array
      do i=1,i34
         isorted(i12+i) = isortedtmp(i)
      enddo

c     sort i5678 into i56 and i78
      i56 = i1234
      i78 = 0
      do i=i1234+1,npts
         if(pos(2,isorted(i))-center(2).lt.0) then
            i56 = i56 + 1
            isorted(i56) = isorted(i)
         else
            i78 = i78 + 1
            isortedtmp(i78) = isorted(i)
         endif
      enddo
c     Reorder sources to include 78 in the array
      do i=1,i78
         isorted(i56+i) = isortedtmp(i)
      enddo
c     End of reordering i5678         

      nc = 0
c     Sort into boxes 1 and 2
      do i = 1,i12
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(1) = nc(1) + 1
            isorted(nc(1)) = isorted(i)
         else
            nc(2) = nc(2) + 1
            isortedtmp(nc(2)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 2 are at the
c     end of this part of the array
      do i=1,nc(2)
         isorted(nc(1)+i) = isortedtmp(i)
      enddo

c     Sort into boxes 3 and 4
      do i = i12+1, i1234
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(3) = nc(3) + 1
            isorted(i12+nc(3)) = isorted(i)
         else
            nc(4) = nc(4)+1
            isortedtmp(nc(4)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 4 are at the
c     end of this part of the array
      do i=1,nc(4)
         isorted(i12+nc(3)+i) = isortedtmp(i)
      enddo

c     Sort into boxes 5 and 6
      do i = i1234+1,i56
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(5) = nc(5) + 1
            isorted(i1234+nc(5)) = isorted(i)
         else
            nc(6) = nc(6) + 1
            isortedtmp(nc(6)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 6 are at the
c     end of this part of the array
      do i=1,nc(6)
         isorted(i1234+nc(5)+i) = isortedtmp(i)
      enddo
c     End of sorting sources into boxes 5 and 6

c     Sort into boxes 7 and 8
      do i=i56+1,npts
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(7) = nc(7) + 1
            isorted(i56+nc(7)) = isorted(i)
         else
            nc(8) = nc(8) + 1
            isortedtmp(nc(8)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 8 are at the
c     end of the array
      do i=1,nc(8)
         isorted(i56+nc(7)+i) = isortedtmp(i)
      enddo
      
      istart=1
      iboxfl=0
      subcenters=0.0d0
      do i=1,8
         ii = 2
         jj = 2
         if(i.eq.1.or.i.eq.2.or.i.eq.5.or.i.eq.6) ii = 1
         if(i.lt.5) jj = 1
         if(nc(i).gt.0) then
            subcenters(1,i) = center(1)+(-1)**i*boxsize/2.0d0
            subcenters(2,i) = center(2)+(-1)**ii*boxsize/2.0d0
            subcenters(3,i) = center(3)+(-1)**jj*boxsize/2.0d0

            iboxfl(1,i) = istart
            iboxfl(2,i) = istart+nc(i)-1

            istart = istart+nc(i)
          endif
      enddo

      return
      end
c--------------------------------------------------------------------     
c
c
c

      implicit none
      integer ns,nt
      double precision, allocatable :: source(:,:)
      double complex, allocatable :: charge(:)
      double complex, allocatable :: pot(:),potex(:)

      double precision eps(5)
      double complex eye,zk,rkmin,rkmax
      double complex, allocatable :: zks(:)
      integer i,j,k,ntest
      integer ifcharge,ifdipole,ifpgh,ifpghtarg
      integer len1,ntests,isum
      integer idomain,ndom
      integer, allocatable :: ipass(:,:)
      double precision err,hkrand,erra,ra,tt
      integer nprec,iprec
      

      data eye/(0.0d0,1.0d0)/

c
cc      initialize printing routine
c
      call prini(6,13)


      ns = 2000
      nt = 1999
      
      ntest = 10

      tt = 1.0d-16

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(pot(ns),potex(ns))



      write(*,*) "=========================================="
      write(*,*) "Testing suite for pw representations for hfmm3d"

      ndom = 437


      nprec = 5
      eps(1) = 0.51d-2
      eps(2) = 0.51d-3
      eps(3) = 0.51d-6
      eps(4) = 0.51d-9
      eps(5) = 0.51d-12


      allocate(ipass(ndom,nprec))
      allocate(zks(ndom))

      do idomain=1,ndom

        call getrkinfo2(idomain,ndom,rkmin,rkmax)
        zks(idomain) = (rkmin+rkmax)*2
      enddo

c
cc      generate sources uniformly in the unit cube 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)
        source(2,i) = hkrand(0)
        source(3,i) = hkrand(0)

        charge(i) = hkrand(0) + eye*hkrand(0)

      enddo

      ndom = 437
      nprec = 5
      open(unit=33,file='pw_res.log')
      open(unit=34,file='pw_fail.log')

      do iprec=1,nprec
        do idomain=1,ndom

          do i=1,ns
            pot(i) = 0
            potex(i) = 0
          enddo



          call hfmm3d_s_c_p(eps(iprec),zks(idomain),ns,source,charge,
     1          pot)
       
       
          call h3ddirectcp(1,zks(idomain),source,charge,ns,source,
     1        ntest,potex,tt)

          ra = 0
          erra = 0
          do i=1,ntest
            ra = ra + abs(potex(i))**2
            erra = erra + abs(potex(i)-pot(i))**2
          enddo

          erra = sqrt(erra/ra)
          write(33,'(a,i3,a,i1,a,e11.5)')
     1        'idom=',idomain,',iprec=',iprec-1,',err=',erra      
          if(erra.le.eps(iprec)) then
            ipass(idomain,iprec) = 1
            write(13,'(a,i3,a,i1,a)') 'success: idom=',idomain,
     1                 ',iprec=',iprec-1
          else
            ipass(idomain,iprec) = 0
            write(13,'(a,i3,a,i1,a)') 'fail: idom=',idomain,
     1                 ',iprec=',iprec-1
          write(34,'(a,i3,a,i1,a,e11.5)')
     1        'idom=',idomain,',iprec=',iprec-1,',err=',erra      
             
          endif
        enddo
      enddo
       

       stop
       end

c
c    generate level restricted oct tree refined 
c    to finest level. Features include 
c
c     radsrc parameter (preventing sources with large radius 
c                         from being pushed to the finest level)
c     radexp parameter (preventing exp centers with large radius 
c                         from being pushed to the finest level)
c     ndiv parameter (usual refinement parameter extending tree
c                         depth until all leaf nodes hanve fewer than
c                         ndiv particles)
c     idivflag       (allows use of ndiv parameter for sources OR
c                         targets OR sources+targets OR sources+targets
c                         + expansion centers)
c   
c     isep           (separation parameter: isep = 1 or 2
c                     based on whether to include neighbors
c                     and self in list 1 or two neighbors
c                     and self in list 2)
c     
c     extraction of plane wave lists
c
c     mhung is the max number of hung chunks in a given box
c
c     This tree code MUST be used along with its
c     memomry code mkptreemem located at the end of this file.
c     The memory code precomputes the number of levels, the number
c     of boxes, the max number of hung sources and the length
c     of the tree. 
c
      subroutine mklraptree(src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,idivflag,ndiv,isep,
     $                   mhung,mnbors,mnlist1,mnlist2,mnlist3,
     $                   mnlist4,nlevels,nboxes,
     $                   centers,boxsize,itree,ltree,
     $                   ipointer)
      implicit none
      integer *8 ier,ns,nt,nexpc,idivflag,ndiv,isep,mhung
      integer *8 mnbors,mnlist1,mnlist2,mnlist3,mnlist4
      integer *8 nlevels,lcenters
      integer *8 ltree
      integer *8 nlmax,nbmax,nboxes, nlevtmp,nbtmp, mhungtmp
      integer *8 itree(ltree)
      integer *8 i,j
      integer *8, allocatable :: laddr(:,:)
      integer *8, allocatable :: ilevel(:)
      integer *8, allocatable :: iparenttemp(:)
      integer *8, allocatable :: nchild(:)
      integer *8, allocatable :: ichildtemp(:,:)
      integer *8, allocatable :: nnbors(:)
      integer *8, allocatable :: nbors(:,:)
      integer *8, allocatable :: isourcetemp(:)
      integer *8, allocatable :: itargettemp(:)
      integer *8, allocatable :: iexpctemp(:)
      integer *8, allocatable :: ihsfirsttemp(:)
      integer *8, allocatable :: ihslasttemp(:)
      integer *8, allocatable :: isfirsttemp(:)
      integer *8, allocatable :: islasttemp(:)
      integer *8, allocatable :: itfirsttemp(:)
      integer *8, allocatable :: itlasttemp(:)
      integer *8, allocatable :: ihefirsttemp(:)
      integer *8, allocatable :: ihelasttemp(:)
      integer *8, allocatable :: iefirsttemp(:)
      integer *8, allocatable :: ielasttemp(:)
      integer *8, allocatable :: nhungsrc(:)
      integer *8, allocatable :: nhunglistsrc(:)
      integer *8, allocatable :: nhungexp(:)
      integer *8, allocatable :: ihunglistsrc(:,:)

      integer *8, allocatable :: nlist1(:)
      integer *8, allocatable :: list1(:,:)
      integer *8, allocatable :: nlist2(:)
      integer *8, allocatable :: list2(:,:)
      integer *8, allocatable :: nlist3(:)
      integer *8, allocatable :: list3(:,:)
      integer *8, allocatable :: nlist4(:)
      integer *8, allocatable :: list4(:,:)


      integer *8 ipointer(32)
      double precision boxsize(0:nlevels)
      double precision src(3,ns),radsrc(ns)
      double precision trg(3,nt)
      double precision centers(3,nboxes)
      double precision expc(3,nexpc)
      double precision radexp(nexpc)
c
      double precision xmin,xmax,ymin,ymax,zmin,zmax,sizey,sizez
      integer *8 ictr,ih,irefine,is,ie
      integer *8 nss,nee

c     INPUT:
c
c     src           source locations        
c     ns            number of sources 
c     rads          source radii (determines deepest level that
c                   the source can reach) 
c     trg           target locations        
c     nt            number of targets
c
c     expc          expansion center locations
c     nexpc         number of expansion centers
c
c     idivflag      0 => divide on sources
c                   1 => divide on targets
c                   2 => divide on sources+targets
c                   3 => divide on sources+targets+expansion centers
c 
c     ndiv          refinement criterion - extend tree until all
c                   nodes at finest level have less than ndiv 
c                   source/targets/sources+targets depending on
c                   idivflag
c
c     isep          separation parameter for determining 
c                   nearest neighbors
c
c     ltree         length of ltree
c     nlevels       number of levels determined using the memory code
c     nboxes        number of boxes determined using mem code
c                   refer to mkptreemem.
c
c
c     OUTPUT:
c     centers       array of box centers
c     boxsize       box dimensions at all levels
c
c     itree         tree array
c     
c     iladdr = 1
c     itree(iladdr) <-> laddr
c                   indexing array providing access to boxes at
c                   each level. 
c                   the first box on level i is laddr(1,i)
c                   the last box on level i is laddr(2,i)
c
c     iparent = iladdr + 2*(nlevels+1)
c     itree(iparent) <-> parent
c                   parent of box (set to -1 for root node)
c
c     inchild = iparent + nboxes
c     itree(inchild) <-> nchild
c                   number of children for each box 
c
c     ichild = inchild + nboxes
c     itree(ichild) <-> child
c                   list of children for each box
c                   (others set to -1). The array should be viewed 
c                   as dimensioned (8,nboxes)
c
c     isource = ichild + 8*nboxes
c     itree(isource) <-> isource
c                   tree-ordered array of sources
c
c     itarget = isource + ns
c     itree(itarget) <-> itarget
c                   tree-ordered array of targets
c
c     iexpc = itarget + nt
c     itree(iexpc) <-> iexpc
c                      tree-ordered array of expansion centers
c
c     ihsfirst = itarget + nt
c     itree(ihsfirst) <-> ihsfirst
c                   ihsfirst(j) = location in isource of first hung 
c                                source for box j 
c
c     ihslast = ihsfirst + nboxes
c     itree(ihslast) <-> ihslast
c                   ihslast(j)  = location in isource of last hung
c                                source for box j 
c
c     isfirst = ihlast + nboxes
c     itree(isfirst) <-> isfirst
c                   isfirst(j) = location in isource of first 
c                                source for box j 
c
c     islast = isfirst + nboxes
c     itree(islast) <-> islast
c                   islast(j)  = location in isource of last 
c                                source for box j 
c
c     itfirst = islast + nboxes
c     itree(itfirst) <-> itfirst
c                   itfirst(j) = location in itarget of first 
c                                target for box j 
c
c     itlast = itfirst + nboxes
c     itree(itlast) <-> itlast
c                   itlast(j)  = location in itarget of last 
c                                target for box j
c
c     ihefirst = itlast + nboxes
c     itree(ihefirst) <-> ihefirst
c                   ihefirst(j) = location in iexpc of first hung 
c                                 expansion center for box j 
c
c     ihelast = ihefirst + nboxes
c     itree(ihelast) <-> ihelast
c                   ihelast(j)  = location in iexpc of last hung
c                                expansion center for box j 
c
c     iefirst = ihelast + nboxes
c     itree(iefirst) <-> iefirst
c                    iefirst(j) = location in iexpc of first target
c                                 in box j
c
c     ielast = ielast + nboxes
c     itree(ielast) <-> ielast
c                       ielast(j) = location in iexpc of last target
c                                   in box j
c
c     innbor = ielast + nboxes
c     itree(innbor) <-> nnbor
c                   number of neighbors
c
c     inbors = innbor + nboxes
c     itree(inbors) <-> nbors
c                   only first nnbor entries are set 
c                   (others set to -1). The array should be viewed 
c                   as dimensioned (27,nboxes) if isep = 1
c                   and (125, nboxes) if isep = 2
c                   mnnbors = 27/125 if isep=1/2
c
c     inlist1 = inbors + mnnbors*nboxes
c     itree(inlist1) <-> nlist1
c                        nlist1(i) = number of boxes in list 1
c                        of box i. The list 1 of a box i, Ui, is
c                        the set of boxes which touch
c                        box i. In a level restricted tree,
c                        the maximum number of boxes in list
c                        1 of a box can be 13 (mnlist1 = 13)
c
c 
c     ilist1 = inlist1 + nboxes
c     itree(ilist1) <-> list1
c                       list1(j,i) is the id of the jth box
c                       in list 1 of box i
c
c     inlist2 = ilist1 + mnlist1*nboxes
c     itree(inlist2) <-> nlist2
c                       nlist2(i) = number of boxes in list 2 of
c                       box i. The list 2 of a box i, Vi, is
c                       the set of boxes which are descendants
c                       of the colleagues of the parent of box i
c                       which are well separated from box i
c                       at the scale of box i. In a level
c                       restricted tree, the maximum number of boxes
c                       in list 2 of a box can be 27 (mnlist2=27)
c
c     ilist2 = inlist2 + nboxes
c     itree(ilist2) <-> list2
c                       list2(j,i) is the id fo the jth box in 
c                       list 2 of box i
c
c     inlist3 = ilist2 + mnlist2*nboxes
c     itree(inlist3) <-> nlist3
c                        nlist3(i) = number of boxes in list3 of
c                        box i. The list 3 of a box i, Wi, is
c                        the set of boxes which are descendants
c                        of the colleagues of box i which
c                        are not in list 1 of box i. In a level
c                        restricted tree, the maximum number of
c                        boxes in list 3 of a box can be 
c                        20 (mnlist3 = 20). Note
c                        that list 3 of a box is non empty
c                        iff the box is childless
c
c     ilist3 = inlist3 + nboxes
c     itree(ilist3) <-> list3(j,i) is the id of the jth box in
c                       list 3 of box i
c
c     inlist4 = ilist3 + mnlist3*nboxes
c     itree(inlist4) <-> nlist4
c                        nlist4(i) = number of boxes in list4
c                        of box i. The list 4 of a box i, Xi,
c                        is dual to Wi. j in Xi if i in Wj, that
c                        is box j is in list 4 of box i if i is
c                        in list 3 of box j. In a level restricted
c                        tree the max number of boxes in list 4
c                        of a box is 5.
c       
c     ilist4 = inlist4 + nboxes
c     itree(ilist4) <-> list4
c                       list4(j,i) is the id of the jth box
c                       in list 4 of box i
c
c     inhungsrc = ilist4 + mnlist4*nboxes
c     itree(inhungsrc) <-> inhungsrc
c                inhungsrc(j)  = number of hung chunks in box j
c
c     inhungexp = inhungsrc + nboxes
c     itree(inhungexp) <-> inhungexp
c                inhungexp(j) = number of hung expansion centers
c                               in box j
c
c     nhunglistsrc = inhungexp + nboxes
c     itree(inhunglistsrc) <-> inhunglistsrc
c           inhunglistsrc(j) = Total number of hung sources
c                              relevant for box j
c
c     ihunglistsrc = inhungexp + nboxes
c     itree(ihunglistsrc) <-> ihunglistsrc
c                   ihunglistsrc(m,j) = src id of  mth hung src
c                   relevant to box j. A hung src is relevant to
c                   a box if the box is a descendant of the
c                   neighbor of the box in which the src is hung
c
c     ltree = ihunglistsrc + mhung*nboxes
c
c     ipointers is the collection of pointers
c     ipointer(1) = iladdr
c     ipointer(2) = iparent = ipointer(1) + 2*(nlevels+1)
c     ipointer(3) = inchild = ipointer(2) + nboxes
c     ipointer(4) = ichild = ipointer(3) + nboxes
c     ipointer(5) = isource = ipointer(4) + 8*nboxes
c     ipointer(6) = itarget = ipointer(5) + ns
c     ipointer(7) = iexpc = ipointer(6) + nt
c     ipointer(8) = ihsfirst = ipointer(7) + nexpc
c     ipointer(9) = ihslast = ipointer(8) + nboxes
c     ipointer(10) = isfirst = ipointer(9) + nboxes
c     ipointer(11) = islast = ipointer(10) + nboxes
c     ipointer(12) = itfirst = ipointer(11) + nboxes
c     ipointer(13) = itlast = ipointer(12) + nboxes
c     ipointer(14) = ihefirst = ipointer(13) + nboxes
c     ipointer(15) = ihelast = ipointer(14) + nboxes
c     ipointer(16) = iefirst = ipointer(15) + nboxes
c     ipointer(17) = ielast = ipointer(16) + nboxes
c     ipointer(18) = innbors = ipointer(17) + nboxes
c     ipointer(19) = inbors = ipointer(18) + nboxes
c     ipointer(20) = inlist1 = ipointer(19) + mnbors*nboxes
c     ipointer(21) = ilist1 = ipointer(20) + nboxes
c     ipointer(22) = inlist2 = ipointer(21) + mnlist1*nboxes
c     ipointer(23) = ilist2 = ipointer(22) + nboxes
c     ipointer(24) = inlist3 = ipointer(23) + mnlist2*nboxes
c     ipointer(25) = ilist3 = ipointer(24) + nboxes
c     ipointer(26) = inlist4 = ipointer(25) + mnlist3*nboxes
c     ipointer(27) = ilist4 = ipointer(26) + nboxes
c     ipointer(28) = nhungsrc = ipointer(27) + mnlist4*nboxes
c     ipointer(29) = nhungexp = ipointer(28) + nboxes
c     ipointer(30) = nhunglistsrc = ipointer(29) + nboxes
c     ipointer(31) = hunglistsrc = ipointer(30) + nboxes
c     ipointer(32) = lentree = ipointer(31) + mhung*nboxes
c
c     mhung is the max number of hung sources 
c
c---------------------------------------------------------------------
c
c     Other notes:
c
c     refinement criterion w.r.t rads is:
c
c     hang if (rads .geq. boxsize)
c
c
      lcenters = nboxes

      ier = 0

      allocate(laddr(2,0:nlevels))
      allocate(ilevel(nboxes))
      allocate(iparenttemp(nboxes))
      allocate(nchild(nboxes))
      allocate(ichildtemp(8,nboxes))
      allocate(isourcetemp(ns))
      allocate(itargettemp(nt))
      allocate(iexpctemp(nexpc))
      allocate(ihsfirsttemp(nboxes))
      allocate(ihslasttemp(nboxes))
      allocate(isfirsttemp(nboxes))
      allocate(islasttemp(nboxes))
      allocate(itfirsttemp(nboxes))
      allocate(itlasttemp(nboxes))
      allocate(ihefirsttemp(nboxes))
      allocate(ihelasttemp(nboxes))
      allocate(iefirsttemp(nboxes))
      allocate(ielasttemp(nboxes))
      allocate(nhungsrc(nboxes))
      allocate(nhungexp(nboxes))
      allocate(nnbors(nboxes))
      allocate(nbors(mnbors,nboxes))

      if(isep.ne.1.and.isep.ne.2) then
         ier = 4
cc         call prinf('Error tree not allocated, isep.ne.1,2*',ier,0)
           print *, "Error tree not allocated, isep.ne.1,2"
         return
      endif

c     Step 1: Find enclosing box
c
      xmin = src(1,1)
      xmax = src(1,1)
      ymin = src(2,1)
      ymax = src(2,1)
      zmin = src(3,1)
      zmax = src(3,1)
c
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
C$OMP$PRIVATE(i)
      do i=1,ns
        if(src(1,i) .lt. xmin) xmin=src(1,i)
        if(src(1,i) .gt. xmax) xmax=src(1,i)
        if(src(2,i) .lt. ymin) ymin=src(2,i)
        if(src(2,i) .gt. ymax) ymax=src(2,i)
        if(src(3,i) .lt. zmin) zmin=src(3,i)
        if(src(3,i) .gt. zmax) zmax=src(3,i)
      enddo
C$OMP END PARALLEL DO    

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
C$OMP$PRIVATE(i)
      do i=1,nt
        if(trg(1,i) .lt. xmin) xmin=trg(1,i)
        if(trg(1,i) .gt. xmax) xmax=trg(1,i)
        if(trg(2,i) .lt. ymin) ymin=trg(2,i)
        if(trg(2,i) .gt. ymax) ymax=trg(2,i)
        if(trg(3,i) .lt. zmin) zmin=trg(3,i)
        if(trg(3,i) .gt. zmax) zmax=trg(3,i)
      enddo
C$OMP END PARALLEL DO    

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
C$OMP$PRIVATE(i)
      do i=1,nexpc
        if(expc(1,i) .lt. xmin) xmin=expc(1,i)
        if(expc(1,i) .gt. xmax) xmax=expc(1,i)
        if(expc(2,i) .lt. ymin) ymin=expc(2,i)
        if(expc(2,i) .gt. ymax) ymax=expc(2,i)
        if(expc(3,i) .lt. zmin) zmin=expc(3,i)
        if(expc(3,i) .gt. zmax) zmax=expc(3,i)
      enddo
C$OMP END PARALLEL DO   

      boxsize(0)=xmax-xmin
      sizey=ymax-ymin
      sizez=zmax-zmin
      if(sizey .gt. boxsize(0)) boxsize(0)=sizey
      if(sizez .gt. boxsize(0)) boxsize(0)=sizez
c
c     initialize arrays at level 0
c
      centers(1,1)=(xmin+xmax)/2
      centers(2,1)=(ymin+ymax)/2
      centers(3,1)=(zmin+zmax)/2
      laddr(1,0) = 1
      laddr(2,0) = 1
      ilevel(1) = 0
      iparenttemp(1) = -1
      isfirsttemp(1) = 1
      nhungsrc(1) = 0
      nhungexp(1) = 0
c
c     count number of hung sources
c     and hang up "big" sources
      do i = 1,ns
         if (radsrc(i).gt.boxsize(0)) nhungsrc(1)=nhungsrc(1)+1 
      enddo
      isfirsttemp(1) = nhungsrc(1)+1
      islasttemp(1) = ns
      if (nhungsrc(1) .gt. 0) then 
         ihsfirsttemp(1) = 1
         ihslasttemp(1) = nhungsrc(1)
      else
         ihsfirsttemp(1) = 0
         ihslasttemp(1) = -1
      endif

c     Count number of hung expansion centers      
c     and hang up "big" expansion centers
      do i=1,nexpc
         if (radexp(i).gt.boxsize(0)) nhungexp(1)=nhungexp(1)+1
      enddo
      iefirsttemp(1) = nhungexp(1)+1
      ielasttemp(1) = nexpc
      if (nhungexp(1).gt.0) then
          ihefirsttemp(1) = 1
          ihelasttemp(1) = nhungexp(1)
      else
         ihefirsttemp(1) = 0
         ihelasttemp(1) = -1
      endif

c
c     reorder isourcetemp to put hung sources in beginning
      ih = 0
      is = nhungsrc(1)
      do i = 1,ns
         if (radsrc(i).gt.boxsize(0)) then
            ih = ih+1
            isourcetemp(ih) = i
         else
            is = is+1
            isourcetemp(is) = i
         endif
      enddo
c     reorder iexptemp to put hung expansion centers in beginning
      ih = 0
      ie = nhungexp(1)
      do i= 1,nexpc
         if(radexp(i).gt.boxsize(0)) then
            ih = ih+1
            iexpctemp(ih) = i
         else
            ie = ie+1
            iexpctemp(ie) = i
         endif
      enddo

c     initialize itargettemp

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(i)
      do i = 1,nt
         itargettemp(i) = i
      enddo
C$OMP END PARALLEL DO      
      itfirsttemp(1) = 1
      itlasttemp(1) = nt

      nchild(1) = 0
      ichildtemp(1,1) = -1
      ichildtemp(2,1) = -1
      ichildtemp(3,1) = -1
      ichildtemp(4,1) = -1
      ichildtemp(5,1) = -1
      ichildtemp(6,1) = -1
      ichildtemp(7,1) = -1
      ichildtemp(8,1) = -1
c
      irefine = 0
      nss = ns - nhungsrc(1)
      nee = nexpc - nhungexp(1)
      if ((idivflag .eq.0).and.(nss.gt.ndiv)) irefine=1
      if ((idivflag .eq.1).and.(nt.gt.ndiv)) irefine=1
      if ((idivflag .eq.2).and.(nss+nt.gt.ndiv)) irefine=1
      if ((idivflag .eq.3).and.(nss+nt+nee.gt.ndiv)) irefine=1

c     Reset nlevels, nboxes
      nbmax = nboxes
      nlmax = nlevels
      nlevels = 0
      nboxes = 1


      do i = 1,nlmax
         if (irefine.eq.1) then
            call subdivide_adap(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,idivflag,ndiv,
     $                   nlevels,nboxes,
     $                   centers,lcenters,boxsize,nbmax,nlmax,
     $                   laddr,ilevel,iparenttemp,nchild,ichildtemp,
     $                   isourcetemp,itargettemp,iexpctemp,
     $                   ihsfirsttemp,ihslasttemp,
     $                   isfirsttemp,islasttemp,
     $                   itfirsttemp,itlasttemp,
     $                   ihefirsttemp,ihelasttemp,
     $                   iefirsttemp,ielasttemp,nhungsrc,
     $                   nhungexp,irefine)
            if(ier.ne.0) return  
         else
            exit
         endif
      enddo
c     Set up computation of list1 and list2     

      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo

      call computecoll(nlevels,nboxes,laddr,boxsize,centers,
     1     iparenttemp,nchild,ichildtemp,mnbors,nnbors,nbors)

      if(nlevels.ge.2) then
      call d3hpfixtree(ier,src,ns,radsrc,trg,nt,expc,nexpc,radexp,
     1     nlevels,nboxes,centers,boxsize,nbmax,laddr,ilevel,
     2     iparenttemp,nchild,ichildtemp,mnbors,nnbors,nbors,
     3     isourcetemp,itargettemp,iexpctemp,ihsfirsttemp,ihslasttemp,
     4     isfirsttemp,islasttemp,itfirsttemp,itlasttemp,ihefirsttemp,
     5     ihelasttemp,iefirsttemp,ielasttemp,nhungsrc,nhungexp)
      if(ier.ne.0) return
      endif

 
      
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(i,j)
      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo
C$OMP END PARALLEL DO
      
      call computecollisep(nlevels,nboxes,laddr,boxsize,centers,
     1     iparenttemp,nchild,ichildtemp,isep,mnbors,nnbors,nbors)

      allocate(nlist1(nboxes),list1(mnlist1,nboxes))
      allocate(nlist2(nboxes),list2(mnlist2,nboxes))
      allocate(nlist3(nboxes),list3(mnlist3,nboxes))
      allocate(nlist4(nboxes),list4(mnlist4,nboxes))

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(i,j)
      do i=1,nboxes
         nlist1(i) = 0
         nlist2(i) = 0
         nlist3(i) = 0
         nlist4(i) = 0
         do j=1,mnlist1
            list1(j,i) = -1
         enddo
         do j=1,mnlist2
            list2(j,i) = -1
         enddo
         do j=1,mnlist3
            list3(j,i) = -1
         enddo
         do j=1,mnlist4
            list4(j,i) = -1
         enddo
      enddo
C$OMP END PARALLEL DO      

      call computelists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparenttemp,nchild,
     2                   ichildtemp,isep,nnbors,mnbors,nbors,nlist1,
     3                   mnlist1,list1,nlist2,mnlist2,list2,
     4                   nlist3,mnlist3,list3,nlist4,mnlist4,list4)

      allocate(ihunglistsrc(mhung,nboxes))
      allocate(nhunglistsrc(nboxes))

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(i,j)
      do i=1,nboxes
         nhunglistsrc(i) = 0
         do j=1,mhung
            ihunglistsrc(j,i) = -1
         enddo 
      enddo
C$OMP END PARALLEL DO      

      call computehunglist(mhung,nlevels,nboxes,laddr,ns,
     1     isourcetemp,iparenttemp,ihsfirsttemp,ihslasttemp,ilevel,
     2     nnbors,mnbors,
     2     nbors,nlist1,mnlist1,list1,
     3     nhungsrc,nhunglistsrc,ihunglistsrc)


      ipointer(1) = 1
      ipointer(2) = ipointer(1)+2*(nlevels+1)
      ipointer(3) = ipointer(2) + nboxes
      ipointer(4) = ipointer(3) + nboxes
      ipointer(5) = ipointer(4) + 8*nboxes
      ipointer(6) = ipointer(5) + ns
      ipointer(7) = ipointer(6) + nt
      ipointer(8) = ipointer(7) + nexpc
      ipointer(9) = ipointer(8) + nboxes
      ipointer(10) = ipointer(9) + nboxes
      ipointer(11) = ipointer(10) + nboxes
      ipointer(12) = ipointer(11) + nboxes
      ipointer(13) = ipointer(12) + nboxes
      ipointer(14) = ipointer(13) + nboxes
      ipointer(15) = ipointer(14) + nboxes
      ipointer(16) = ipointer(15) + nboxes
      ipointer(17) = ipointer(16) + nboxes
      ipointer(18) = ipointer(17) + nboxes
      ipointer(19) = ipointer(18) + nboxes
      ipointer(20) = ipointer(19) + mnbors*nboxes
      ipointer(21) = ipointer(20) + nboxes
      ipointer(22) = ipointer(21) + mnlist1*nboxes
      ipointer(23) = ipointer(22) + nboxes
      ipointer(24) = ipointer(23) + mnlist2*nboxes
      ipointer(25) = ipointer(24) + nboxes
      ipointer(26) = ipointer(25) + mnlist3*nboxes
      ipointer(27) = ipointer(26) + nboxes
      ipointer(28) = ipointer(27) + mnlist4*nboxes
      ipointer(29) = ipointer(28) + nboxes
      ipointer(30) = ipointer(29) + nboxes
      ipointer(31) = ipointer(30) + nboxes
      ipointer(32) = ipointer(31) + mhung*nboxes


c     Move the output to itree
c     Store iladdr - first and last box at level ilev
      do i=0,nlevels
         itree(2*i+1) = laddr(1,i)
         itree(2*i+2) = laddr(2,i)
      enddo

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,ns
         itree(ipointer(5)+i-1) = isourcetemp(i)
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nt
         itree(ipointer(6)+i-1) = itargettemp(i)
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nexpc
         itree(ipointer(7)+i-1) = iexpctemp(i)
      enddo
C$OMP END PARALLEL DO      


C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
      do i = 1,nboxes
          itree(ipointer(2)+i-1) = iparenttemp(i)
          itree(ipointer(3)+i-1) = nchild(i)
          do j=1,8
             itree(ipointer(4)+8*(i-1)+j-1) = ichildtemp(j,i)
          enddo
          itree(ipointer(8)+i-1) = ihsfirsttemp(i)
          itree(ipointer(9)+i-1) = ihslasttemp(i)
          itree(ipointer(10)+i-1) = isfirsttemp(i)
          itree(ipointer(11)+i-1) = islasttemp(i)
          itree(ipointer(12)+i-1) = itfirsttemp(i)
          itree(ipointer(13)+i-1) = itlasttemp(i)
          itree(ipointer(14)+i-1) = ihefirsttemp(i)
          itree(ipointer(15)+i-1) = ihelasttemp(i)
          itree(ipointer(16)+i-1) = iefirsttemp(i)
          itree(ipointer(17)+i-1) = ielasttemp(i)
          itree(ipointer(18)+i-1) = nnbors(i)
          do j=1,mnbors
             itree(ipointer(19)+(i-1)*mnbors+j-1) = nbors(j,i)
          enddo
          itree(ipointer(20)+i-1) = nlist1(i)
          do j=1,mnlist1
             itree(ipointer(21)+(i-1)*mnlist1+j-1) = list1(j,i)
          enddo
          itree(ipointer(22)+i-1) = nlist2(i)
          do j=1,mnlist2
             itree(ipointer(23)+(i-1)*mnlist2+j-1) = list2(j,i)
          enddo
          itree(ipointer(24)+i-1) = nlist3(i)
          do j=1,mnlist3
             itree(ipointer(25)+(i-1)*mnlist3+j-1) = list3(j,i)
          enddo
          itree(ipointer(26)+i-1) = nlist4(i)
          do j=1,mnlist4
             itree(ipointer(27)+(i-1)*mnlist4+j-1) = list4(j,i)
          enddo
          itree(ipointer(28)+i-1) = nhungsrc(i)
          itree(ipointer(29)+i-1) = nhungexp(i)
          itree(ipointer(30)+i-1) = nhunglistsrc(i)
          do j=1,mhung
             itree(ipointer(31)+(i-1)*mhung+j-1) = ihunglistsrc(j,i)
          enddo
      enddo
C$OMP END PARALLEL DO

      return
      end
c--------------------------------------------------------------
c
      subroutine subdivide_adap(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,idivflag,ndiv,
     $                   nlevels,nboxes,
     $                   centers,lcenters,boxsize,nbmax,nlmax,
     $                   laddr,ilevel,iparent,nchild,ichild,
     $                   isource,itarget,iexpc,
     $                   ihsfirst,ihslast,
     $                   isfirst,islast,
     $                   itfirst,itlast,
     $                   ihefirst,ihelast,
     $                   iefirst,ielast,nhungsrc,
     $                   nhungexp,irefine)
      implicit none
      integer *8 ier,ns,nt,nexpc,idivflag,ndiv,mhung
      integer *8 nlevels,nboxes,lcenters,nbmax,nlmax
      integer *8 irefine
      double precision src(3,ns),radsrc(ns)
      double precision trg(3,nt)
      double precision expc(3,nexpc),radexp(nexpc)
      double precision centers(3,lcenters)
      double precision boxsize(0:nlmax)
      integer *8 laddr(2,0:nlmax)
      integer *8 ilevel(nbmax)
      integer *8 iparent(nbmax)
      integer *8 nchild(nbmax)
      integer *8 ichild(8,nbmax)
      integer *8 isource(ns)
      integer *8 itarget(nt)
      integer *8 iexpc(nexpc)
      integer *8 ihsfirst(nbmax)
      integer *8 ihslast(nbmax)
      integer *8 isfirst(nbmax)
      integer *8 islast(nbmax)
      integer *8 itfirst(nbmax)
      integer *8 itlast(nbmax)
      integer *8 ihefirst(nbmax)
      integer *8 ihelast(nbmax)
      integer *8 iefirst(nbmax)
      integer *8 ielast(nbmax)
      integer *8 nhungsrc(nbmax)
      integer *8 nhungexp(nbmax)
c     Temporary variables
      integer *8 isrctmp(ns),itargtmp(nt),iexpctmp(nexpc)
      integer *8 i,j,i12,i34,istart,jstart,kstart,ii,iii,nss,nee
      integer *8 jj,irefinebox,ntt
      integer *8 i56, i78, i1234, i5678
      integer *8 ibox,ifirstbox,ilastbox,nbfirst
      integer *8 iss,itt,ie
      integer *8 nsc(8),ntc(8),nh(8),nexpcc(8),nhc(8)
c
c     for every box at level nlevels,
c     sort into children, updating various arrays 
c     perhaps just build tree here paren/child/particle sorting...
c     lists in second call ???
c     
c     allocate temp array for isourcetemp2 itargtemp2
c     after all done, write back to isourcetemp, itargtemp
c     this is O(N) * nlevels work for rewriting.
c     can be fancier I suppose.
c     
      irefine = 0
      ifirstbox = laddr(1,nlevels)
      ilastbox =  laddr(2,nlevels)
c
      nbfirst = nboxes+1
      boxsize(nlevels+1) = boxsize(0)/2.0d0**(nlevels+1)

      do ibox = ifirstbox,ilastbox
c        Determine if current box needs to be subdivided
c        if current box needs to be subdivided then set
c        irefinebox = 1
         nss = islast(ibox) - isfirst(ibox) + 1
         ntt = itlast(ibox) - itfirst(ibox) + 1
         nee = ielast(ibox) - iefirst(ibox) + 1
         irefinebox = 0
         if((idivflag.eq.0).and.(nss.gt.ndiv)) irefinebox=1
         if((idivflag.eq.1).and.(ntt.gt.ndiv)) irefinebox=1
         if((idivflag.eq.2).and.(nss.gt.ndiv.or.ntt.gt.ndiv)) 
     1        irefinebox=1
         if((idivflag.eq.3).and.(nss.gt.ndiv.or.
     1       ntt.gt.ndiv.or.nee.gt.ndiv)) irefinebox=1
         if(irefinebox.eq.1) then
c            Based on the subdivision criterion, the current
c            box needs to be divided
      
c           Allocate temporary array to figure out which child you
c           belong to
c           which child?  1,2,3,4,5,6,7,8? counter ns1,ns2,ns3,ns4,
c           ns5,ns6,ns7,ns8
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0

            i1234 = isfirst(ibox)-1
            i5678 = 0
            do iss = isfirst(ibox),islast(ibox)
               if(src(3,isource(iss)) - centers(3,ibox).lt.0) then
                  i1234 = i1234+1
                  isource(i1234) = isource(iss)
               else
                  i5678 = i5678 + 1
                  isrctmp(i5678) = isource(iss)
               endif
            enddo
c           Note at the end of the loop, i1234 is where the particles
c           in part 1234 of the box end

c           Reorder sources to include sources in 5678 in the array
            do i=1,i5678
               isource(i1234+i) = isrctmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = isfirst(ibox)-1
            i34 = 0
            do iss = isfirst(ibox),i1234
               if(src(2,isource(iss))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  isource(i12) = isource(iss)
               else
                  i34 = i34 + 1
                  isrctmp(i34) = isource(iss)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder sources to include 34 in the array
            do i=1,i34
               isource(i12+i) = isrctmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do iss=i1234+1,islast(ibox)
               if(src(2,isource(iss))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  isource(i56) = isource(iss)
               else
                  i78 = i78 + 1
                  isrctmp(i78) = isource(iss)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               isource(i56+i) = isrctmp(i)
            enddo
c           End of reordering i5678         

            nsc(1) = 0
            nsc(2) = 0
            nsc(3) = 0
            nsc(4) = 0
            nsc(5) = 0
            nsc(6) = 0
            nsc(7) = 0
            nsc(8) = 0
c           Sort into boxes 1 and 2
            do iss = isfirst(ibox),i12
               if(src(1,isource(iss))-centers(1,ibox).lt.0) then
                  isource(isfirst(ibox)+nsc(1)) = isource(iss)
                  nsc(1) = nsc(1) + 1
               else
                  nsc(2) = nsc(2) + 1
                  isrctmp(nsc(2)) = isource(iss)
               endif
            enddo
c           Reorder sources so that sources in 2 are at the
c           end of this part of the array
            do i=1,nsc(2)
               isource(isfirst(ibox)+nsc(1)+i-1) = isrctmp(i)
            enddo

c           Sort into boxes 3 and 4
            do iss = i12+1, i1234
               if(src(1,isource(iss))-centers(1,ibox).lt.0) then
                  isource(i12+1+nsc(3)) = isource(iss)
                  nsc(3) = nsc(3) + 1
                else
                   nsc(4) = nsc(4)+1
                   isrctmp(nsc(4)) = isource(iss)
                endif
            enddo
c           Reorder sources so that sources in 4 are at the
c           end of this part of the array
            do i=1,nsc(4)
               isource(i12+nsc(3)+i) = isrctmp(i)
            enddo

c           Sort into boxes 5 and 6
            do iss = i1234+1,i56
               if(src(1,isource(iss))-centers(1,ibox).lt.0) then
                  isource(i1234+1+nsc(5)) = isource(iss)
                  nsc(5) = nsc(5) + 1
               else
                  nsc(6) = nsc(6) + 1
                  isrctmp(nsc(6)) = isource(iss)
               endif
            enddo
c           Reorder sources so that sources in 6 are at the
c           end of this part of the array
            do i=1,nsc(6)
               isource(i1234+nsc(5)+i) = isrctmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do iss=i56+1,islast(ibox)
               if(src(1,isource(iss))-centers(1,ibox).lt.0) then
                  isource(i56+1+nsc(7)) = isource(iss)
                  nsc(7) = nsc(7) + 1
               else
                  nsc(8) = nsc(8) + 1
                  isrctmp(nsc(8)) = isource(iss)
               endif
            enddo
c           Reorder sources so that sources in 8 are at the
c           end of the array
            do i=1,nsc(8)
               isource(i56+nsc(7)+i) = isrctmp(i)
            enddo

            istart = isfirst(ibox)-1
            do j=1,8
c           check hung -> counter nh1,nh2,nh3,nh4,nh5,nh6,nh7,nh8
               ii = 0
               nh(j) = 0
               do i=1,nsc(j)
                  if(radsrc(isource(istart+i)).gt.boxsize(nlevels+1))
     1            then     
                     nh(j) = nh(j) + 1
                     isource(istart+nh(j)) = isource(istart+i)
                  else
                     ii = ii+1
                     isrctmp(ii) = isource(istart+i)
                  endif
               enddo
c           Reorder sources to have hung chunks at the star
c           of the sorted sources in the box ibox
                do i=1,ii
                  isource(istart+nh(j)+i) = isrctmp(i)
                enddo
                istart = istart + nsc(j)
            enddo
c           End of sorting sources

c           Sort targets
c           which child?  1,2,3,4,5,6,7,8? counter nt1,nt2,nt3,nt4,
c           nt5,nt6,nt7,nt8
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0
c
            i1234 = itfirst(ibox)-1
            i5678 = 0
            do itt = itfirst(ibox),itlast(ibox)
               if(trg(3,itarget(itt)) - centers(3,ibox).lt.0) then
                 i1234 = i1234+1
                 itarget(i1234) = itarget(itt)
               else
                  i5678 = i5678 + 1
                  itargtmp(i5678) = itarget(itt)
               endif
            enddo
c           Reorder sources to include targets in 5678 in the array
            do i=1,i5678
               itarget(i1234+i) = itargtmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = itfirst(ibox)-1
            i34 = 0
            do itt = itfirst(ibox),i1234
               if(trg(2,itarget(itt))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  itarget(i12) = itarget(itt)
               else
                  i34 = i34 + 1
                  itargtmp(i34) = itarget(itt)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder targets to include 34 in the array
            do i=1,i34
               itarget(i12+i) = itargtmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do itt=i1234+1,itlast(ibox)
               if(trg(2,itarget(itt))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  itarget(i56) = itarget(itt)
               else
                  i78 = i78 + 1
                  itargtmp(i78) = itarget(itt)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               itarget(i56+i) = itargtmp(i)
            enddo
c           End of reordering i5678         

            ntc(1) = 0
            ntc(2) = 0
            ntc(3) = 0
            ntc(4) = 0
            ntc(5) = 0
            ntc(6) = 0
            ntc(7) = 0
            ntc(8) = 0

c           Sort into boxes 1 and 2
            do itt = itfirst(ibox),i12
               if(trg(1,itarget(itt))-centers(1,ibox).lt.0) then
                  itarget(itfirst(ibox)+ntc(1)) = itarget(itt)
                  ntc(1) = ntc(1) + 1
               else
                  ntc(2) = ntc(2) + 1
                  itargtmp(ntc(2)) = itarget(itt)
               endif
            enddo
c           Reorder targets so that sources in 2 are at the
c           end of this part of the array
            do i=1,ntc(2)
               itarget(itfirst(ibox)+ntc(1)+i-1) = itargtmp(i)
            enddo
c           Sort into boxes 3 and 4
            do itt = i12+1, i1234
               if(trg(1,itarget(itt))-centers(1,ibox).lt.0) then
                  itarget(i12+1+ntc(3)) = itarget(itt)
                  ntc(3) = ntc(3) + 1
                else
                   ntc(4) = ntc(4)+1
                   itargtmp(ntc(4)) = itarget(itt)
                endif
            enddo
c           Reorder targets so that sources in 4 are at the
c           end of this part of the array
            do i=1,ntc(4)
               itarget(i12+ntc(3)+i) = itargtmp(i)
            enddo

c           Sort into boxes 5 and 6
            do itt = i1234+1,i56
               if(trg(1,itarget(itt))-centers(1,ibox).lt.0) then
                  itarget(i1234+1+ntc(5)) = itarget(itt)
                  ntc(5) = ntc(5) + 1
               else
                  ntc(6) = ntc(6) + 1
                  itargtmp(ntc(6)) = itarget(itt)
               endif
            enddo
c           Reorder targets so that sources in 6 are at the
c           end of this part of the array
            do i=1,ntc(6)
               itarget(i1234+ntc(5)+i) = itargtmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do itt=i56+1,itlast(ibox)
               if(trg(1,itarget(itt))-centers(1,ibox).lt.0) then
                  itarget(i56+1+ntc(7)) = itarget(itt)
                  ntc(7) = ntc(7) + 1
               else
                  ntc(8) = ntc(8) + 1
                  itargtmp(ntc(8)) = itarget(itt)
               endif
            enddo
c           Reorder targets so that sources in 8 are at the
c           end of the array
            do i=1,ntc(8)
               itarget(i56+ntc(7)+i) = itargtmp(i)
            enddo
c           End of sorting targets

c           Sort expansion centers
c           which child?  1,2,3,4,5,6,7,8? counter
c           nexpcc1, nexpcc2, nexpcc3, nexpcc4,
c           nexpcc5, nexpcc6, nexpcc7, nexpcc8,
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0
c
            i1234 = iefirst(ibox)-1
            i5678 = 0
            do ie = iefirst(ibox),ielast(ibox)
               if(expc(3,iexpc(ie)) - centers(3,ibox).lt.0) then
                  i1234 = i1234+1
                  iexpc(i1234) = iexpc(ie)
               else
                  i5678 = i5678 + 1
                  iexpctmp(i5678) = iexpc(ie)
               endif
            enddo

c           Reorder sources to include sources in 5678 in the array
            do i=1,i5678
               iexpc(i1234+i) = iexpctmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = iefirst(ibox)-1
            i34 = 0
            do ie = iefirst(ibox),i1234
               if(expc(2,iexpc(ie))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  iexpc(i12) = iexpc(ie)
               else
                  i34 = i34 + 1
                  iexpctmp(i34) = iexpc(ie)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder sources to include 34 in the array
            do i=1,i34
               iexpc(i12+i) = iexpctmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do ie=i1234+1,ielast(ibox)
               if(expc(2,iexpc(ie))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  iexpc(i56) = iexpc(ie)
               else
                  i78 = i78 + 1
                  iexpctmp(i78) = iexpc(ie)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               iexpc(i56+i) = iexpctmp(i)
            enddo
c           End of reordering i5678         

            nexpcc(1) = 0
            nexpcc(2) = 0
            nexpcc(3) = 0
            nexpcc(4) = 0
            nexpcc(5) = 0
            nexpcc(6) = 0
            nexpcc(7) = 0
            nexpcc(8) = 0

c           Sort into boxes 1 and 2
            do ie = iefirst(ibox),i12
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(iefirst(ibox)+nexpcc(1)) = iexpc(ie)
                  nexpcc(1) = nexpcc(1) + 1
               else
                  nexpcc(2) = nexpcc(2) + 1
                  iexpctmp(nexpcc(2)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 2 are at the
c           end of this part of the array
            do i=1,nexpcc(2)
               iexpc(iefirst(ibox)+nexpcc(1)+i-1) = iexpctmp(i)
            enddo
c           Sort into boxes 3 and 4
            do ie = i12+1, i1234
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i12+1+nexpcc(3)) = iexpc(ie)
                  nexpcc(3) = nexpcc(3) + 1
               else
                  nexpcc(4) = nexpcc(4)+1
                  iexpctmp(nexpcc(4)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 4 are at the
c           end of this part of the array
            do i=1,nexpcc(4)
               iexpc(i12+nexpcc(3)+i) = iexpctmp(i)
            enddo

c           Sort into boxes 5 and 6
            do ie = i1234+1,i56
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i1234+1+nexpcc(5)) = iexpc(ie)
                  nexpcc(5) = nexpcc(5) + 1
               else
                  nexpcc(6) = nexpcc(6) + 1
                  iexpctmp(nexpcc(6)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 6 are at the
c           end of this part of the array
            do i=1,nexpcc(6)
               iexpc(i1234+nexpcc(5)+i) = iexpctmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do ie=i56+1,ielast(ibox)
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i56+1+nexpcc(7)) = iexpc(ie)
                  nexpcc(7) = nexpcc(7) + 1
               else
                  nexpcc(8) = nexpcc(8) + 1
                  iexpctmp(nexpcc(8)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 8 are at the
c           end of the array
            do i=1,nexpcc(8)
               iexpc(i56+nexpcc(7)+i) = iexpctmp(i)
            enddo
c           End of sorting expanison centers

            istart = iefirst(ibox)-1
            do j=1,8
c           check hung -> counter nhc1,nhc2,nhc3,nhc4,nhc5,nhc6,nhc7,nhc8
               ii = 0
               nhc(j) = 0
               do i=1,nexpcc(j)
                  if(radexp(iexpc(istart+i)).gt.boxsize(nlevels+1))
     1            then     
                     nhc(j) = nhc(j) + 1
                     iexpc(istart+nhc(j)) = iexpc(istart+i)
                  else
                     ii = ii+1
                     iexpctmp(ii) = iexpc(istart+i)
                  endif
               enddo
c           Reorder sources to have hung chunks at the star
c           of the sorted sources in the box ibox
               do i=1,ii
                  iexpc(istart+nhc(j)+i) = iexpctmp(i)
               enddo
               istart = istart + nexpcc(j)
            enddo

            nchild(ibox) = 0
c           Create the required boxes
            istart = isfirst(ibox)
            jstart = itfirst(ibox)
            kstart = iefirst(ibox)
            do i=1,8
               ii = 2
               jj = 2
               if(i.eq.1.or.i.eq.2.or.i.eq.5.or.i.eq.6) ii = 1
               if(i.lt.5) jj = 1
               if(nsc(i)+ntc(i)+nexpcc(i).ge.0) then
c                 Increment total number of boxes               
                  nboxes = nboxes + 1
                  if(nboxes.gt.nbmax) then
                    write(*,*) "Exceeding max number of boxes"
                    write(*,*) "Exiting"
                    ier = 12
                    return
                  endif

c                 Increment number of children for the current box
                  nchild(ibox) = nchild(ibox)+1
c                 Update the array of children for the current box
                  ichild(i,ibox) = nboxes
c                 Update the array of levels for the child box
                  ilevel(nboxes) = nlevels+1
c                 Update the array of parents for the child box
                  iparent(nboxes) = ibox
c                 Compute center for the child box
                  centers(1,nboxes) = centers(1,ibox)+(-1)**i*
     1                                boxsize(nlevels+1)/2.0
                  centers(2,nboxes) = centers(2,ibox)+(-1)**ii*
     1                              boxsize(nlevels+1)/2.0
                  centers(3,nboxes) = centers(3,ibox)+(-1)**jj*
     1                              boxsize(nlevels+1)/2.0

                  nchild(nboxes) = 0
                  ichild(1,nboxes) = -1
                  ichild(2,nboxes) = -1
                  ichild(3,nboxes) = -1
                  ichild(4,nboxes) = -1
                  ichild(5,nboxes) = -1
                  ichild(6,nboxes) = -1
                  ichild(7,nboxes) = -1
                  ichild(8,nboxes) = -1
c                 Update arrays ihsfirst,ihslast,isfirst,islast
                  ihsfirst(nboxes) = istart
                  ihslast(nboxes) = istart + nh(i) - 1
                  nhungsrc(nboxes) = nh(i)

                  isfirst(nboxes) = istart + nh(i)
                  islast(nboxes) = istart + nsc(i) - 1

c                 Update arrays itfirst, itlast
                  itfirst(nboxes) = jstart
                  itlast(nboxes) = jstart + ntc(i) - 1

c                 Update arrays ihefirst,ihelast,iefirst,ielast
                  ihefirst(nboxes) = kstart
                  ihelast(nboxes) = kstart + nhc(i)-1
                  nhungexp(nboxes) = nhc(i)

                  iefirst(nboxes) = kstart + nhc(i)
                  ielast(nboxes) = kstart + nexpcc(i) - 1

                  nss = islast(nboxes) - isfirst(nboxes)+1
                  nee = ielast(nboxes) - iefirst(nboxes)+1 
c                 Check if further refinement required
                  if ((idivflag.eq.0).and.(nss.gt.ndiv)) irefine=1
                  if ((idivflag.eq.1).and.(ntc(i).gt.ndiv)) irefine=1
                  if ((idivflag.eq.2).and.(nss.gt.ndiv.or.
     1                     ntc(i).gt.ndiv))  irefine=1
                  if ((idivflag.eq.3).and.(nss.gt.ndiv.or.
     1                      ntc(i).gt.ndiv.or.nee.gt.ndiv)) irefine=1  
               endif
               istart = istart + nsc(i)
               jstart = jstart + ntc(i)
               kstart = kstart + nexpcc(i)
            enddo
         endif
      enddo
      nlevels = nlevels+1
      laddr(1,nlevels) = nbfirst
      laddr(2,nlevels) = nboxes

      return
      end
c------------------------------------------------------------------      

      subroutine computemhung(nlevels,nboxes,laddr,iparent,ilevel,
     1                        nnbors,mnbors,nbors,nlist1,mnlist1,list1,
     2                        nhungsrc,nhunglistsrc,mhung)
c     This subroutine computes mhung for a given tree 
c     and the number of hung sources per box
c
c     INPUT arguments
c     nlevels     in: integer *8
c                 Number of levels
c
c     nboxes      in: integer *8
c                 Total number of boxes
c
c     laddr       in: integer *8(2,0:nlevels)
c                 indexing array providing access to boxes at
c                 each level. 
c                 the first box on level i is laddr(1,i)
c                 the last box on level i is laddr(2,i)
c    
c     iparent     in: integer *8(nboxes)
c                 iparent(i) is the parent of box i
c
c     nnbors      in: integer *8(nboxes)
c                 nnbors(i) is the number of boxes in list 1 of box i
c
c     nbors       in: integer *8(9,nboxes)
c                 nbors(j,i) is the box id of the jth box in
c                 list 1 of box i
c
c     mnbors      in: integer *8
c                 max number of boxes in list1. If isep=1, 
c                 mnbors should be 27 and if isep=2, mnbors
c                 should be 125
c
c     nhungsrc   in: integer *8(nboxes)
c                 nhung(i) is the number of hung sources in box i
c 
c      OUTPUT
c      nhunglistsrc  out:integer *8(nboxes)
c                    nhunglistsrc(i) is the number of hung sources
c                    relevant to box i, nhunglistsrc(i) = 
c                    nhunglistsrc(idad) + \sum_{j=1}{nnbors(i)}
c                    nhungsrc(nbors(j,i))
c
c      mhung         out: integer *8
c                    max(nhunglistsrc)
      implicit none
      integer *8 nlevels,nboxes, mnbors,mnlist1
      integer *8 laddr(2,0:nlevels), ilevel(nboxes)
      integer *8 iparent(nboxes),nnbors(nboxes), nbors(mnbors,nboxes)
      integer *8 nlist1(nboxes),list1(mnlist1,nboxes)
      integer *8 nhungsrc(nboxes), nhunglistsrc(nboxes)
      integer *8 mhung

c     Temporary variables
      integer *8 ilev,ibox,i,dad,jbox

c     initialize for level 0      
      nhunglistsrc(1) = nhungsrc(1)
      do ilev = 1,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP$PRIVATE(ibox,dad,i,jbox)
         do ibox = laddr(1,ilev),laddr(2,ilev)
            dad = iparent(ibox)
            nhunglistsrc(ibox) = nhunglistsrc(dad)
            do i=1,nnbors(ibox)
               jbox = nbors(i,ibox)
               nhunglistsrc(ibox) = nhunglistsrc(ibox) +
     1                              nhungsrc(jbox)
            enddo
            do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                if(ilevel(ibox).lt.ilevel(jbox)) nhunglistsrc(ibox)=
     1            nhunglistsrc(ibox) + nhungsrc(jbox)
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      mhung = 0
C$OMP PARALLEL DO DEFAULT(SHARED) REDUCTION(max:mhung) PRIVATE(i)      
      do ibox = 1,nboxes
         if(nhunglistsrc(ibox).gt.mhung) mhung = nhunglistsrc(ibox)
      enddo
C$OMP END PARALLEL DO      
      


      return
      end
c------------------------------------------------------------------
      subroutine computehunglist(mhung,nlevels,nboxes,laddr,ns,
     1           isource,iparent,ihsfirst,ihslast,ilevel,nnbors,mnbors,
     2           nbors,nlist1,mnlist1,list1,
     3           nhungsrc,nhunglistsrc,ihunglistsrc)
c     This subroutine computes the hung list for each box 
c     and stores it. The hung list of sources of a box is
c     the hunglist of the parent + the sources hung in list1
c     of the box
c 
c     INPUT arguments
c     mhung         in: Integer
c                   max number of hung chunks for a box
c
c     nlevels       in: Integer
c                   number of levels in the tree
c
c     nboxes        in: Integer
c                   number of boxes
c
c     laddr       in: integer *8(2,0:nlevels)
c                 indexing array providing access to boxes at
c                 each level. 
c                 the first box on level i is laddr(1,i)
c                 the last box on level i is laddr(2,i)
c
c     ns          in: integer *8
c                 number of sources
c
c     isource     in: integer *8(ns)
c                 Mapping from tree sorted array of sources
c                 to the user prescribed ordering
c  
c     iparent     in: integer *8(nboxes)
c                 iparent(i) is the parent of box i
c     
c     ihsfirst    in: integer *8(nboxes)
c                 ihsfirst(i) points to the first hung source
c                 in box i in the sorted array
c
c      ihslast    in: integer *8(nboxes)
c                 ihslast(i) points to the last hung source
c                 in box i in the sorted array
c
c     nnbors      in: integer *8(nboxes)
c                 nnbors(i) is the number of boxes in list 1 of box i
c
c     nbors       in: integer *8(9,nboxes)
c                 nbors(j,i) is the box id of the jth box in
c                 list 1 of box i
c
c     mnbors      in: integer *8
c                 max number of boxes in list1. If isep=1, 
c                 mnbors should be 27 and if isep=2, mnbors
c                 should be 125
c
c     nhungsrc   in: integer *8(nboxes)
c                 nhung(i) is the number of hung sources in box i
c 
c      OUTPUT
c      nhunglistsrc  out:integer *8(nboxes)
c                    nhunglistsrc(i) is the number of hung sources
c                    relevant to box i 
c
c      ihunglistsrc  out: integer *8(mhung,nboxes)
c                    ihunglistsrc(j,i) is the id of the jth
c                    hung source relevant to box i
c-----------------------------------------------------------------
       implicit none
       integer *8 mhung,nlevels,nboxes,ns, mnbors, mnlist1
       integer *8 laddr(2,0:nlevels)
       integer *8 iparent(nboxes),ilevel(nboxes)
       integer *8 isource(ns), ihsfirst(nboxes),ihslast(nboxes)
       integer *8 nnbors(nboxes), nbors(mnbors,nboxes)
       integer *8 nlist1(nboxes), list1(mnlist1,nboxes)
       integer *8 nhungsrc(nboxes),nhunglistsrc(nboxes)
       integer *8 ihunglistsrc(mhung,nboxes)
c      Temp variables
       integer *8 i,j,ibox,jbox,ilev,dad

c     initialize for level 0      
      nhunglistsrc(1) = nhungsrc(1)
      do i=1,nhungsrc(1)
          ihunglistsrc(i,1) = isource(ihsfirst(1)+i-1)
      enddo
      do ilev = 1,nlevels
         do ibox = laddr(1,ilev),laddr(2,ilev)
            dad = iparent(ibox)
            do i=1,nhunglistsrc(dad)
               ihunglistsrc(i,ibox) = ihunglistsrc(i,dad)
            enddo
            nhunglistsrc(ibox) = nhunglistsrc(dad)
            do i=1,nnbors(ibox)
               jbox = nbors(i,ibox)
               do j=1,nhungsrc(jbox)
                  ihunglistsrc(nhunglistsrc(ibox)+j,ibox) = 
     1                  isource(ihsfirst(jbox)+j-1)
               enddo
               nhunglistsrc(ibox) = nhunglistsrc(ibox) +
     1                              nhungsrc(jbox)
            enddo
            do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                if(ilevel(ibox).lt.ilevel(jbox)) then
                   do j=1,nhungsrc(jbox)
                      ihunglistsrc(nhunglistsrc(ibox)+j,ibox)=
     1                    isource(ihsfirst(jbox)+j-1)
                   enddo
                   nhunglistsrc(ibox)=
     1             nhunglistsrc(ibox) + nhungsrc(jbox)
                endif
            enddo
         enddo
      enddo

      return
      end
c------------------------------------------------------------------

      subroutine mklraptreemem(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,idivflag,ndiv,isep,
     $                   nlmax,nbmax,nlevels,nboxes,mnbors,mnlist1,
     $                   mnlist2,mnlist3,mnlist4,mhung,ltree)

      implicit none
      integer *8 ier
      integer *8 ns,nt,nexpc,idivflag,ndiv,mhung,isep
      integer *8 nlevels,nboxes,lcenters
      integer *8 ltree,nboxes8
      integer *8 i,j,nbmax,nlmax
      integer *8, allocatable :: laddr(:,:)
      integer *8, allocatable :: ilevel(:),ilevel2(:)
      integer *8, allocatable :: iparenttemp(:),iparenttemp2(:)
      integer *8, allocatable :: nchild(:),nchild2(:)
      integer *8, allocatable :: ichildtemp(:,:),ichildtemp2(:,:)
      integer *8, allocatable :: nnbors(:)
      integer *8, allocatable :: nbors(:,:)
      integer *8, allocatable :: isourcetemp(:)
      integer *8, allocatable :: itargettemp(:)
      integer *8, allocatable :: iexpctemp(:)
      integer *8, allocatable :: ihsfirsttemp(:),ihsfirsttemp2(:)
      integer *8, allocatable :: ihslasttemp(:),ihslasttemp2(:)
      integer *8, allocatable :: isfirsttemp(:),isfirsttemp2(:)
      integer *8, allocatable :: islasttemp(:),islasttemp2(:)
      integer *8, allocatable :: itfirsttemp(:),itfirsttemp2(:)
      integer *8, allocatable :: itlasttemp(:),itlasttemp2(:)
      integer *8, allocatable :: ihefirsttemp(:),ihefirsttemp2(:)
      integer *8, allocatable :: ihelasttemp(:),ihelasttemp2(:)
      integer *8, allocatable :: iefirsttemp(:),iefirsttemp2(:)
      integer *8, allocatable :: ielasttemp(:),ielasttemp2(:)
      integer *8, allocatable :: nhungsrc(:),nhungsrc2(:)
      integer *8, allocatable :: nhungexp(:),nhungexp2(:)
      integer *8, allocatable :: nhunglistsrc(:)

      double precision boxsize(0:nlmax)
      double precision src(3,ns),radsrc(ns)
      double precision trg(3,nt)
      double precision, allocatable :: centers(:,:),centers2(:,:)
      double precision expc(3,nexpc)
      double precision radexp(nexpc)
c
      double precision xmin,xmax,ymin,ymax,zmin,zmax,sizex,sizey,sizez
      double precision btmp
      integer *8 ictr,ih,irefine,is,ie
      integer *8 nss,nee,ntot,nbtmp,ntt
      integer *8 ibox, ifirstbox,ilastbox, nnew, nbtot

      integer *8 mnbors, mnlist1, mnlist2,mnlist3,mnlist4
      integer *8, allocatable :: nlist1(:)
      integer *8, allocatable :: list1(:,:)
      integer *8, allocatable :: nlist2(:)
      integer *8, allocatable :: list2(:,:)
      integer *8, allocatable :: nlist3(:)
      integer *8, allocatable :: list3(:,:)
      integer *8, allocatable :: nlist4(:)
      integer *8, allocatable :: list4(:,:)

c     This code is a memory code for mkptree. This
c     subroutine determines the number of boxes (lcenters) required,
c     the length of the tree array (ltree) and the maximum number
c     of hung chunks (mhung)
c     
c     INPUT:
c
c     src           source locations        
c     ns            number of sources 
c     rads          source radii (determines deepest level that
c                   the source can reach) 
c     trg           target locations        
c     nt            number of targets
c
c     expc          expansion center locations
c     nexpc         number of expansion centers
c
c     radexp        expansion center radius
c
c     idivflag      0 => divide on sources
c                   1 => divide on targets
c                   2 => divide on sources+targets
c                   3 => divide on sources+targets+expansion centers
c 
c     ndiv          refinement criterion - extend tree until all
c                   nodes at finest level have less than ndiv 
c                   source/targets/sources+targets depending on
c                   idivflag
c
c     nlmax         max number of levels
c     nbmax         max number of boxes (no longer in use!)
c
c     OUTPUT:
c     ier           error code
c                    ier = 0, normal execution
c                    ier = 4, isep != 1 or 2 
c                    ier = 8, sources and targets too close
c     nlevels       number of levels
c     nboxes        number of boxes
c     mhung         max number of hung chunks
c     ltree         length of the tree
c
c     mhung is the max number of hung sources on output
c
c     This subroutine essentially creates the quad tree
c     and in process determines the memory required for the tree.
c
c     It can be shown that the maximum number of boxes is less
c     than 2*(nexpc + ns + nt)
c
c     For details of the variables used in the tree, refer
c     to the main routine
c---------------------------------------------------------------------
c
c     initialize temporary arrays
c  
c     assumes nlevels lt 200
c
c     Other notes:
c
c     refinement criterion w.r.t rads is:
c
c     hang if (rads .geq. boxsize)
c
c
      ier = 0
      ntot = ns + nt + nexpc
      nbmax = 10000
      nboxes = nbmax
      lcenters = nbmax
      nlevels = nlmax
      ier = 0
c
      allocate(laddr(2,0:nlmax))
      allocate(ilevel(nbmax))
      allocate(iparenttemp(nbmax))
      allocate(nchild(nbmax))
      allocate(ichildtemp(8,nbmax))
      allocate(isourcetemp(ns))
      allocate(itargettemp(nt))
      allocate(iexpctemp(nexpc))
      allocate(ihsfirsttemp(nbmax))
      allocate(ihslasttemp(nbmax))
      allocate(isfirsttemp(nbmax))
      allocate(islasttemp(nbmax))
      allocate(itfirsttemp(nbmax))
      allocate(itlasttemp(nbmax))
      allocate(ihefirsttemp(nbmax))
      allocate(ihelasttemp(nbmax))
      allocate(iefirsttemp(nbmax))
      allocate(ielasttemp(nbmax))
      allocate(nhungsrc(nbmax))
      allocate(nhungexp(nbmax))
      allocate(centers(3,lcenters))

      if(isep.eq.1) then
         mnbors = 27
      endif

      if(isep.eq.2) then
         mnbors = 125
      endif

      if(isep.ne.1.and.isep.ne.2) then
         ier = 4
cc         call prinf('Error tree not allocated, isep.ne.1,2*',ier,0)
         print *, "Error tree not allocated, isep.ne.1,2"
         return
      endif

c     Step 1: Find enclosing box
c
      xmin = src(1,1)
      xmax = src(1,1)
      ymin = src(2,1)
      ymax = src(2,1)
      zmin = src(3,1)
      zmax = src(3,1)
c
      do i=1,ns
        if(src(1,i) .lt. xmin) xmin=src(1,i)
        if(src(1,i) .gt. xmax) xmax=src(1,i)
        if(src(2,i) .lt. ymin) ymin=src(2,i)
        if(src(2,i) .gt. ymax) ymax=src(2,i)
        if(src(3,i) .lt. zmin) zmin=src(3,i)
        if(src(3,i) .gt. zmax) zmax=src(3,i)
      enddo
      do i=1,nt
        if(trg(1,i) .lt. xmin) xmin=trg(1,i)
        if(trg(1,i) .gt. xmax) xmax=trg(1,i)
        if(trg(2,i) .lt. ymin) ymin=trg(2,i)
        if(trg(2,i) .gt. ymax) ymax=trg(2,i)
        if(trg(3,i) .lt. zmin) zmin=trg(3,i)
        if(trg(3,i) .gt. zmax) zmax=trg(3,i)
      enddo

      do i=1,nexpc
        if(expc(1,i) .lt. xmin) xmin=expc(1,i)
        if(expc(1,i) .gt. xmax) xmax=expc(1,i)
        if(expc(2,i) .lt. ymin) ymin=expc(2,i)
        if(expc(2,i) .gt. ymax) ymax=expc(2,i)
        if(expc(3,i) .lt. zmin) zmin=expc(3,i)
        if(expc(3,i) .gt. zmax) zmax=expc(3,i)
      enddo
      sizex=xmax-xmin
      sizey=ymax-ymin
      sizez=zmax-zmin
      boxsize(0) = sizex
      if(sizey .gt. boxsize(0)) boxsize(0)=sizey
      if(sizez .gt. boxsize(0)) boxsize(0)=sizez

      btmp = sqrt(sizex**2+sizey**2+sizez**2)
      if(boxsize(0)/btmp.le.1.0d-16) then
        ier = 8
        write(*,*) "Nothing to compute"
        write(*,*) "Sources and targets too close"
        write(*,*) "Exiting"
      endif
c
c     initialize arrays at level 0
c
      centers(1,1)=(xmin+xmax)/2
      centers(2,1)=(ymin+ymax)/2
      centers(3,1)=(zmin+zmax)/2
      laddr(1,0) = 1
      laddr(2,0) = 1
      iparenttemp(1) = -1
      isfirsttemp(1) = 1
      nhungsrc(1) = 0
      nhungexp(1) = 0
c
c     count number of hung sources
c     and hang up "big" sources
      do i = 1,ns
         if (radsrc(i).gt.boxsize(0)) nhungsrc(1)=nhungsrc(1)+1 
      enddo
      isfirsttemp(1) = nhungsrc(1)+1
      islasttemp(1) = ns
      if (nhungsrc(1) .gt. 0) then 
         ihsfirsttemp(1) = 1
         ihslasttemp(1) = nhungsrc(1)
      else
         ihsfirsttemp(1) = 0
         ihslasttemp(1) = -1
      endif

c     Count number of hung expansion centers      
c     and hang up "big" expansion centers
      do i=1,nexpc
         if (radexp(i).gt.boxsize(0)) nhungexp(1)=nhungexp(1)+1
      enddo
      iefirsttemp(1) = nhungexp(1)+1
      ielasttemp(1) = nexpc
      if (nhungexp(1).gt.0) then
          ihefirsttemp(1) = 1
          ihelasttemp(1) = nhungexp(1)
      else
         ihefirsttemp(1) = 0
         ihelasttemp(1) = -1
      endif

c
c     reorder isourcetemp to put hung sources in beginning
      ih = 0
      is = nhungsrc(1)
      do i = 1,ns
         if (radsrc(i).gt.boxsize(0)) then
            ih = ih+1
            isourcetemp(ih) = i
         else
            is = is+1
            isourcetemp(is) = i
         endif
      enddo
c     reorder iexptemp to put hung expansion centers in beginning
      ih = 0
      ie = nhungexp(1)
      do i= 1,nexpc
         if(radexp(i).gt.boxsize(0)) then
            ih = ih+1
            iexpctemp(ih) = i
         else
            ie = ie+1
            iexpctemp(ie) = i
         endif
      enddo

c     initialize itargettemp 
      do i = 1,nt
         itargettemp(i) = i
      enddo
      itfirsttemp(1) = 1
      itlasttemp(1) = nt

      nchild(1) = 0
      ichildtemp(1,1) = -1
      ichildtemp(2,1) = -1
      ichildtemp(3,1) = -1
      ichildtemp(4,1) = -1
      ichildtemp(5,1) = -1
      ichildtemp(6,1) = -1
      ichildtemp(7,1) = -1
      ichildtemp(8,1) = -1
c
      nlevels = 0
      nboxes = 1
c
      irefine = 0
      nss = ns - nhungsrc(1)
      nee = nexpc - nhungexp(1)
      if ((idivflag .eq.0).and.(nss.gt.ndiv)) irefine=1
      if ((idivflag .eq.1).and.(nt.gt.ndiv)) irefine=1
      if ((idivflag .eq.2).and.(nss+nt.gt.ndiv)) irefine=1
      if ((idivflag .eq.3).and.(nss+nt+nee.gt.ndiv)) irefine=1



      do i = 1,nlmax
         if (irefine.eq.1) then
c
c
c            estimate number of new boxes to be created
c
           nnew = 0
           ifirstbox = laddr(1,nlevels)
           ilastbox =  laddr(2,nlevels)

           do ibox = ifirstbox,ilastbox
               nss = islasttemp(ibox) - isfirsttemp(ibox) + 1
               ntt = itlasttemp(ibox) - itfirsttemp(ibox) + 1
               nee = ielasttemp(ibox) - iefirsttemp(ibox) + 1
               if((idivflag.eq.0).and.(nss.gt.ndiv)) nnew = nnew + 1
               if((idivflag.eq.1).and.(ntt.gt.ndiv)) nnew = nnew + 1
               if((idivflag.eq.2).and.(nss.gt.ndiv.or.ntt.gt.ndiv)) 
     1            nnew = nnew + 1
               if((idivflag.eq.3).and.(nss.gt.ndiv.or.
     1           ntt.gt.ndiv.or.nee.gt.ndiv)) nnew = nnew + 1
            enddo

            nbtot = nboxes + 8*nnew

c
c            if current memory is not sufficient, 
c            delete previous arrays and allocate more memory
c            allocate more memory
c
            if(nbtot.gt.nbmax) then
              nbmax = nbtot
              lcenters = nbtot
              allocate(centers2(3,nboxes))
              allocate(ilevel2(nboxes),iparenttemp2(nboxes))
              allocate(nchild2(nboxes),ichildtemp2(8,nboxes))
              allocate(ihsfirsttemp2(nboxes),ihslasttemp2(nboxes))
              allocate(isfirsttemp2(nboxes),islasttemp2(nboxes))
              allocate(itfirsttemp2(nboxes),itlasttemp2(nboxes))
              allocate(ihefirsttemp2(nboxes),ihelasttemp2(nboxes))
              allocate(iefirsttemp2(nboxes),ielasttemp2(nboxes))
              allocate(nhungsrc2(nboxes),nhungexp2(nboxes))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,j)
              do ibox = 1,nboxes
                ilevel2(ibox) = ilevel(ibox)
                iparenttemp2(ibox) = iparenttemp(ibox)
                nchild2(ibox) = nchild(ibox)
                ihsfirsttemp2(ibox) = ihsfirsttemp(ibox)
                ihslasttemp2(ibox) = ihslasttemp(ibox)
                isfirsttemp2(ibox) = isfirsttemp(ibox)
                islasttemp2(ibox) = islasttemp(ibox)
                itfirsttemp2(ibox) = itfirsttemp(ibox)
                itlasttemp2(ibox) = itlasttemp(ibox)
                ihefirsttemp2(ibox) = ihefirsttemp(ibox)
                ihelasttemp2(ibox) = ihelasttemp(ibox)
                iefirsttemp2(ibox) = iefirsttemp(ibox)
                ielasttemp2(ibox) = ielasttemp(ibox)
                nhungsrc2(ibox) = nhungsrc(ibox)
                nhungexp2(ibox) = nhungexp(ibox)
                do j=1,3
                  centers2(j,ibox) = centers(j,ibox)
                enddo

                do j=1,8
                  ichildtemp2(j,ibox) = ichildtemp(j,ibox)
                enddo

              enddo
C$OMP END PARALLEL DO              
              deallocate(centers,ilevel,iparenttemp,nchild,ichildtemp)
              deallocate(ihsfirsttemp,ihslasttemp)
              deallocate(isfirsttemp,islasttemp)
              deallocate(itfirsttemp,itlasttemp)
              deallocate(ihefirsttemp,ihelasttemp)
              deallocate(iefirsttemp,ielasttemp)
              deallocate(nhungsrc,nhungexp)

              allocate(centers(3,nbmax))
              allocate(ilevel(nbmax),iparenttemp(nbmax))
              allocate(nchild(nbmax),ichildtemp(8,nbmax))
              allocate(ihsfirsttemp(nbmax),ihslasttemp(nbmax))
              allocate(isfirsttemp(nbmax),islasttemp(nbmax))
              allocate(itfirsttemp(nbmax),itlasttemp(nbmax))
              allocate(ihefirsttemp(nbmax),ihelasttemp(nbmax))
              allocate(iefirsttemp(nbmax),ielasttemp(nbmax))
              allocate(nhungsrc(nbmax),nhungexp(nbmax))

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,j)
              do ibox = 1,nboxes
                ilevel(ibox) = ilevel2(ibox)
                iparenttemp(ibox) = iparenttemp2(ibox)
                nchild(ibox) = nchild2(ibox)
                ihsfirsttemp(ibox) = ihsfirsttemp2(ibox)
                ihslasttemp(ibox) = ihslasttemp2(ibox)
                isfirsttemp(ibox) = isfirsttemp2(ibox)
                islasttemp(ibox) = islasttemp2(ibox)
                itfirsttemp(ibox) = itfirsttemp2(ibox)
                itlasttemp(ibox) = itlasttemp2(ibox)
                ihefirsttemp(ibox) = ihefirsttemp2(ibox)
                ihelasttemp(ibox) = ihelasttemp2(ibox)
                iefirsttemp(ibox) = iefirsttemp2(ibox)
                ielasttemp(ibox) = ielasttemp2(ibox)
                nhungsrc(ibox) = nhungsrc2(ibox)
                nhungexp(ibox) = nhungexp2(ibox)
                do j=1,3
                  centers(j,ibox) = centers2(j,ibox)
                enddo
                do j=1,8
                  ichildtemp(j,ibox) = ichildtemp2(j,ibox)
                enddo
              enddo
C$OMP END PARALLEL DO              



              deallocate(centers2,ilevel2,iparenttemp2,nchild2)
              deallocate(ichildtemp2)
              deallocate(ihsfirsttemp2,ihslasttemp2)
              deallocate(isfirsttemp2,islasttemp2)
              deallocate(itfirsttemp2,itlasttemp2)
              deallocate(ihefirsttemp2,ihelasttemp2)
              deallocate(iefirsttemp2,ielasttemp2)
              deallocate(nhungsrc2,nhungexp2)
            endif

            

            call subdivide_adap(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,idivflag,ndiv,
     $                   nlevels,nboxes,
     $                   centers,lcenters,boxsize,nbmax,nlmax,
     $                   laddr,ilevel,iparenttemp,nchild,ichildtemp,
     $                   isourcetemp,itargettemp,iexpctemp,
     $                   ihsfirsttemp,ihslasttemp,
     $                   isfirsttemp,islasttemp,
     $                   itfirsttemp,itlasttemp,
     $                   ihefirsttemp,ihelasttemp,
     $                   iefirsttemp,ielasttemp,nhungsrc,
     $                   nhungexp,irefine)
            if(ier.ne.0) return
         else
            exit
         endif
      enddo


c
c
c        check with Leslie/Dhairya/Alex/Zydrunas if 16 is enough
c

      nbtot = 16*nboxes
c
c            if current memory is not sufficient, 
c            delete previous arrays and allocate more memory
c            allocate more memory
c
      if(nbtot.gt.nbmax) then
        nbmax = nbtot
        lcenters = nbtot

        allocate(centers2(3,nboxes))
        allocate(ilevel2(nboxes),iparenttemp2(nboxes))
        allocate(nchild2(nboxes),ichildtemp2(8,nboxes))
        allocate(ihsfirsttemp2(nboxes),ihslasttemp2(nboxes))
        allocate(isfirsttemp2(nboxes),islasttemp2(nboxes))
        allocate(itfirsttemp2(nboxes),itlasttemp2(nboxes))
        allocate(ihefirsttemp2(nboxes),ihelasttemp2(nboxes))
        allocate(iefirsttemp2(nboxes),ielasttemp2(nboxes))
        allocate(nhungsrc2(nboxes),nhungexp2(nboxes))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,j)
        do ibox = 1,nboxes
          ilevel2(ibox) = ilevel(ibox)
          iparenttemp2(ibox) = iparenttemp(ibox)
          nchild2(ibox) = nchild(ibox)
          ihsfirsttemp2(ibox) = ihsfirsttemp(ibox)
          ihslasttemp2(ibox) = ihslasttemp(ibox)
          isfirsttemp2(ibox) = isfirsttemp(ibox)
          islasttemp2(ibox) = islasttemp(ibox)
          itfirsttemp2(ibox) = itfirsttemp(ibox)
          itlasttemp2(ibox) = itlasttemp(ibox)
          ihefirsttemp2(ibox) = ihefirsttemp(ibox)
          ihelasttemp2(ibox) = ihelasttemp(ibox)
          iefirsttemp2(ibox) = iefirsttemp(ibox)
          ielasttemp2(ibox) = ielasttemp(ibox)
          nhungsrc2(ibox) = nhungsrc(ibox)
          nhungexp2(ibox) = nhungexp(ibox)
          do j=1,3
            centers2(j,ibox) = centers(j,ibox)
          enddo
           do j=1,8
            ichildtemp2(j,ibox) = ichildtemp(j,ibox)
          enddo
         enddo
C$OMP END PARALLEL DO              
        deallocate(centers,ilevel,iparenttemp,nchild,ichildtemp)
        deallocate(ihsfirsttemp,ihslasttemp)
        deallocate(isfirsttemp,islasttemp)
        deallocate(itfirsttemp,itlasttemp)
        deallocate(ihefirsttemp,ihelasttemp)
        deallocate(iefirsttemp,ielasttemp)
        deallocate(nhungsrc,nhungexp)

        allocate(centers(3,nbmax))
        allocate(ilevel(nbmax),iparenttemp(nbmax))
        allocate(nchild(nbmax),ichildtemp(8,nbmax))
        allocate(ihsfirsttemp(nbmax),ihslasttemp(nbmax))
        allocate(isfirsttemp(nbmax),islasttemp(nbmax))
        allocate(itfirsttemp(nbmax),itlasttemp(nbmax))
        allocate(ihefirsttemp(nbmax),ihelasttemp(nbmax))
        allocate(iefirsttemp(nbmax),ielasttemp(nbmax))
        allocate(nhungsrc(nbmax),nhungexp(nbmax))

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,j)
        do ibox = 1,nboxes
          ilevel(ibox) = ilevel2(ibox)
          iparenttemp(ibox) = iparenttemp2(ibox)
          nchild(ibox) = nchild2(ibox)
          ihsfirsttemp(ibox) = ihsfirsttemp2(ibox)
          ihslasttemp(ibox) = ihslasttemp2(ibox)
          isfirsttemp(ibox) = isfirsttemp2(ibox)
          islasttemp(ibox) = islasttemp2(ibox)
          itfirsttemp(ibox) = itfirsttemp2(ibox)
          itlasttemp(ibox) = itlasttemp2(ibox)
          ihefirsttemp(ibox) = ihefirsttemp2(ibox)
          ihelasttemp(ibox) = ihelasttemp2(ibox)
          iefirsttemp(ibox) = iefirsttemp2(ibox)
          ielasttemp(ibox) = ielasttemp2(ibox)
          nhungsrc(ibox) = nhungsrc2(ibox)
          nhungexp(ibox) = nhungexp2(ibox)
          do j=1,3
            centers(j,ibox) = centers2(j,ibox)
          enddo
          do j=1,8
            ichildtemp(j,ibox) = ichildtemp2(j,ibox)
          enddo
        enddo
C$OMP END PARALLEL DO              

        deallocate(centers2,ilevel2,iparenttemp2,nchild2)
        deallocate(ichildtemp2)
        deallocate(ihsfirsttemp2,ihslasttemp2)
        deallocate(isfirsttemp2,islasttemp2)
        deallocate(itfirsttemp2,itlasttemp2)
        deallocate(ihefirsttemp2,ihelasttemp2)
        deallocate(iefirsttemp2,ielasttemp2)
        deallocate(nhungsrc2,nhungexp2)
      endif

c     Set up computation of list1 and list2      
      allocate(nnbors(nbmax))
      allocate(nbors(mnbors,nbmax))

      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo

      call computecoll(nlevels,nboxes,laddr,boxsize,centers,
     1     iparenttemp,nchild,ichildtemp,mnbors,nnbors,nbors)

      if(nlevels.ge.2) then
      call d3hpfixtree(ier,src,ns,radsrc,trg,nt,expc,nexpc,radexp,
     1     nlevels,nboxes,centers,boxsize,nbmax,laddr,ilevel,
     2     iparenttemp,nchild,ichildtemp,mnbors,nnbors,nbors,
     3     isourcetemp,itargettemp,iexpctemp,ihsfirsttemp,ihslasttemp,
     4     isfirsttemp,islasttemp,itfirsttemp,itlasttemp,ihefirsttemp,
     5     ihelasttemp,iefirsttemp,ielasttemp,nhungsrc,nhungexp)

      if(ier.ne.0) return
      endif


      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo
      call computecollisep(nlevels,nboxes,laddr,boxsize,centers,
     1     iparenttemp,nchild,ichildtemp,isep,mnbors,nnbors,nbors)
      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
c     Compute mnlist1, mnlist2, mnlist3, mnlist4      
      call computemnlists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparenttemp,nchild,
     2                   ichildtemp,isep,nnbors,mnbors,nbors,mnlist1,
     3                   mnlist2,mnlist3,mnlist4)


      allocate(nlist1(nboxes),nlist2(nboxes))
      allocate(nlist3(nboxes),nlist4(nboxes))
      allocate(list1(mnlist1,nboxes),list2(mnlist2,nboxes))
      allocate(list3(mnlist3,nboxes),list4(mnlist4,nboxes))
      call computelists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparenttemp,nchild,
     2                   ichildtemp,isep,nnbors,mnbors,nbors,nlist1,
     3                   mnlist1,list1,nlist2,mnlist2,list2,
     4                   nlist3,mnlist3,list3,nlist4,mnlist4,list4)

      allocate(nhunglistsrc(nboxes))

      call computemhung(nlevels,nboxes,laddr,iparenttemp,ilevel,nnbors,
     1  mnbors,nbors,nlist1,mnlist1,list1,nhungsrc,nhunglistsrc,mhung)
      
c
c      temporarily typecast nboxes to integer *8
c
      nboxes8 = nboxes
      ltree = (28+mhung+mnlist1+mnlist2+mnlist3+mnlist4+
     1   mnbors)*nboxes8+2*(nlevels+1)+ns+nt+nexpc

      return
      end
c--------------------------------------------      

      subroutine mkpwlists(isep,nlevels,laddr,boxsize,
     1                   nboxes,centers,mnlist2,nlist2,list2,
     2                   nupm,ndownm,nnorthm,nsouthm,
     3                   neastm,nwestm,nup,uplist,ndown,downlist,
     3                   nnorth,northlist,nsouth,southlist,
     4                   neast,eastlist,nwest,westlist)

c     This subroutine computes the uplist, downlist, eastlist,
c     west list, north list and south list based on the list2 of
c     the tree structure. The up and down list for a box B
c     are the set of boxes in list 2 
c     that are separated by at least isep boxes
c     in the +z direction and -z direction respectively. The north
c     and south list of box B are those boxes which are not in
c     the up and down list and are well separated from the box B
c     by at least isep boxes in the +y and -y direction
c     respectively. The east and west list of box B are those
c     boxes which are in none of up,down,north and south list of
c     the box B and are well separated from box B by at least
c     isep boxes in the +x and -x direction respectively.
c
c     NOTE: to determine nupm,ndownm,nnorthm,nsouthm,neastm and
c           nwestm use the subroutine findnudnsew
c
c     INPUT arguments:
c     isep        in: Integer
c                 separation parameter
c
c     nlevels     in: integer *8
c                 number of levels
c
c     laddr       in: integer *8 (2,0:nlevels)
c                 laddr(1,i) is the first box at level i
c                 laddr(2,i) is the last box at level i
c
c     boxsize     in: double precision(0:nlevels)
c                 boxsize(i) is the size of a box at level i
c
c     nboxes      in: Integer
c                 number of boxes
c
c     centers     in: double precision(3,nboxes)
c                 co-ordinates of the box centers in the
c                 tree structure
c
c     mnlist2     in: integer *8
c                 maximum number of elements in list2 of a box
c  
c     nlist2      in: integer *8(nboxes)
c                 nlist2(i) is the number of boxes in list2
c                 of box i
c
c     list2       in: integer *8(mnlist2,nboxes)
c                 list2(j,i) is the box number of the jth box
c                 in the list2 of box i
c
c     nupm        in: integer *8
c                 max number of boxes in uplist of any box
c
c     ndownm      in: integer *8
c                 max number of boxes in downlist of any box
c
c     nnorthm     in: integer *8
c                 max number of boxes in the north list of any box
c
c     nsouthm     in: integer *8
c                 max number of boxes in the south list of any box
c
c     neastm      in: integer *8
c                 max number of boxes in the east list of any box
c
c     nwestm      in: integer *8
c                 max number of boxes in the west list of any box
c
c     OUTPUT
c     nup         out: integer *8(nboxes)
c                 nup(i) is the number of boxes in the uplist
c                 of box i
c
c     uplist      out: integer *8(nupm,nboxes)
c                 uplist(j,i) is the jth box in the uplist
c                 of box i
c
c     ndown       out: integer *8(nboxes)
c                 ndown(i) is the number of boxes in the downlist
c                 of box i
c
c     downlist    out: integer *8(ndownm,nboxes)
c                 downlist(j,i) is the jth box in the downlist
c                 of box i
c
c     nnorth      out: integer *8(nboxes)
c                 nnorth(i) is the number of boxes in the northlist
c                 of box i
c
c     northlist   out: integer *8(nnorthm,nboxes)
c                 northlist(j,i) is the jth box in the northlist
c                 of box i
c
c     nsouth      out: integer *8(nboxes)
c                 nsouth(i) is the number of boxes in the southlist
c                 of box i
c
c     southlist   out: integer *8(ndownm,nboxes)
c                 southlist(j,i) is the jth box in the southlist
c                 of box i
c
c     neast       out: integer *8(nboxes)
c                 neast(i) is the number of boxes in the eastlist
c                 of box i
c
c     eastlist    out: integer *8(neastm,nboxes)
c                 eastlist(j,i) is the jth box in the eastlist
c                 of box i
c
c     nwest       out: integer *8(nboxes)
c                 nwest(i) is the number of boxes in the westlist
c                 of box i
c
c     westlist    out: integer *8(nwestm,nboxes)
c                 westlist(j,i) is the jth box in the westlist
c                 of box i
c---------------------------------------------------------------

      implicit none
      integer *8 isep,nlevels,nboxes,mnlist2,nlist2(nboxes)
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      integer *8 list2(mnlist2,nboxes)
      integer *8 nup(nboxes),ndown(nboxes)
      integer *8 nnorth(nboxes),nsouth(nboxes)
      integer *8 neast(nboxes),nwest(nboxes)
      integer *8 nupm,ndownm,nnorthm,nsouthm,neastm,nwestm
      integer *8 uplist(nupm,nboxes),downlist(ndownm,nboxes)
      integer *8 northlist(nnorthm,nboxes),southlist(nsouthm,nboxes)
      integer *8 eastlist(neastm,nboxes),westlist(nwestm,nboxes)
      integer *8 ilev,i,ibox,jbox
      double precision centers(3,nboxes)

      do ilev = 0,nlevels
         do ibox = laddr(1,ilev),laddr(2,ilev)
            nup(ibox) = 0
            ndown(ibox) = 0
            nnorth(ibox) = 0
            nsouth(ibox) = 0
            neast(ibox) = 0
            nwest(ibox) = 0
            do i=1,nlist2(ibox)
              jbox = list2(i,ibox)
              if(centers(3,jbox) - centers(3,ibox).ge.
     1           1.01d0*isep*boxsize(ilev)) then
                 nup(ibox) = nup(ibox)+1
                 uplist(nup(ibox),ibox) = jbox
                 goto 1111
              endif
              if(centers(3,jbox) - centers(3,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 ndown(ibox) = ndown(ibox)+1
                 downlist(ndown(ibox),ibox) = jbox
                 goto 1111
              endif

              if(centers(2,jbox) - centers(2,ibox).ge.
     1           1.01d0*isep*boxsize(ilev)) then
                 nnorth(ibox) = nnorth(ibox)+1
                 northlist(nnorth(ibox),ibox) = jbox
                 goto 1111
              endif
              if(centers(2,jbox) - centers(2,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 nsouth(ibox) = nsouth(ibox)+1
                 southlist(nsouth(ibox),ibox) = jbox
                 goto 1111
              endif

              if(centers(1,jbox) - centers(1,ibox).ge.
     1          1.01d0*isep*boxsize(ilev)) then
                 neast(ibox) = neast(ibox)+1
                 eastlist(neast(ibox),ibox) = jbox
                 goto 1111
              endif
              if(centers(1,jbox) - centers(1,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 nwest(ibox) = nwest(ibox)+1
                 westlist(nwest(ibox),ibox) = jbox
                 goto 1111
              endif
1111          continue                 
           enddo
        enddo
      enddo

      return
      end

      subroutine findnudnsew(isep,nlevels,laddr,boxsize,
     1                       nboxes,centers,mnlist2,
     2                       nlist2,list2,nup,ndown,nnorth,
     3                       nsouth,neast,nwest)
  
c     This subroutine computes the maximum number of elements
c     in the uplist,downlist, eastlist, west list, north list
c     and south list based on the list2 of the tree structure.
c     For detailed description on the lists, refer to mkpwlists
c
c     INPUT arguments:
c     isep        in: Integer
c                 separation parameter
c
c     nlevels     in: integer *8
c                 number of levels
c
c     laddr       in: integer *8 (2,0:nlevels)
c                 laddr(1,i) is the first box at level i
c                 laddr(2,i) is the last box at level i
c
c     boxsize     in: double precision(0:nlevels)
c                 boxsize(i) is the size of a box at level i
c
c     nboxes      in: Integer
c                 number of boxes
c
c     centers     in: double precision(3,nboxes)
c                 co-ordinates of the box centers in the
c                 tree structure
c
c     mnlist2     in: integer *8
c                 maximum number of elements in list2 of a box
c  
c     nlist2      in: integer *8(nboxes)
c                 nlist2(i) is the number of boxes in list2
c                 of box i
c
c     list2       in: integer *8(mnlist2,nboxes)
c                 list2(j,i) is the box number of the jth box
c                 in the list2 of box i
c    
c     OUTPUT
c     nup         out: integer *8
c                 max number of boxes in the uplist of any box
c
c     ndown       out: integer *8
c                 max number of boxes in the downlist of any box
c
c     nnorth      out: integer *8
c                 max number of boxes in the northlist of any box
c
c     nsouth      out: integer *8
c                 max number of boxes in the southlist of any box
c
c     neast       out: integer *8
c                 max number of boxes in the eastlist of any box
c
c     nwest       out: integer *8
c                 max number of boxes in the westlist of any box
c
c----------------------------------------------------------------
      implicit none
      integer *8 isep,nlevels,nboxes,mnlist2,nlist2(nboxes)
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      integer *8 list2(mnlist2,nboxes)
      integer *8 nup,ndown,nnorth,nsouth,neast,nwest
      integer *8 nupt,ndownt,nnortht,nsoutht,neastt,nwestt
      integer *8 ilev,i,ibox,jbox
      double precision centers(3,nboxes)

      nup = 0
      ndown = 0
      nnorth = 0
      nsouth = 0
      neast = 0
      nwest = 0
      do ilev = 2,nlevels
         do ibox = laddr(1,ilev),laddr(2,ilev)
            nupt = 0
            ndownt = 0
            nnortht = 0
            nsoutht = 0
            neastt = 0
            nwestt = 0
            do i=1,nlist2(ibox)
              jbox = list2(i,ibox)
              if(centers(3,jbox) - centers(3,ibox).ge.
     1           1.01d0*isep*boxsize(ilev)) then
                 nupt = nupt+1
                 goto 1111
              endif
              if(centers(3,jbox) - centers(3,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 ndownt = ndownt+1
                 goto 1111
              endif

              if(centers(2,jbox) - centers(2,ibox).ge.
     1           1.01d0*isep*boxsize(ilev)) then
                 nnortht = nnortht+1
                 goto 1111
              endif
              if(centers(2,jbox) - centers(2,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 nsoutht = nsoutht+1
                 goto 1111
              endif

              if(centers(1,jbox) - centers(1,ibox).ge.
     1          1.01d0*isep*boxsize(ilev)) then
                 neastt = neastt+1
                 goto 1111
              endif
              if(centers(1,jbox) - centers(1,ibox).le.
     1           -1.01d0*isep*boxsize(ilev)) then
                 nwestt = nwestt+1
                 goto 1111
              endif
1111          continue                 
           enddo
           if(nupt.gt.nup) nup = nupt
           if(ndownt.gt.ndown) ndown = ndownt
           if(nnortht.gt.nnorth) nnorth = nnortht
           if(nsoutht.gt.nsouth) nsouth = nsoutht
           if(neastt.gt.neast) neast = neastt
           if(nwestt.gt.nwest) nwest = nwestt
        enddo
      enddo

      return
      end
c-------------------------------------------------------------      
      subroutine computecoll(nlevels,nboxes,laddr,boxsize,
     1                       centers,iparent,nchild,ichild,
     2                       mnbors,nnbors,nbors)

c     This subroutine computes the colleagues for an adaptive
c     pruned tree. box j is a colleague of box i, if they share a
c     vertex or an edge and the two boxes are at the same
c     level in the tree
c
c     INPUT arguments
c     nlevels     in: integer *8
c                 Number of levels
c
c     nboxes      in: integer *8
c                 Total number of boxes
c
c     laddr       in: integer *8(2,0:nlevels)
c                 indexing array providing access to boxes at
c                 each level. 
c                 the first box on level i is laddr(1,i)
c                 the last box on level i is laddr(2,i)
c
c     boxsize     in: double precision(0:;nlevels)
c                 Array of boxsizes
c 
c     centers     in: double precision(2,nboxes)
c                 array of centers of boxes
c   
c     iparent     in: integer *8(nboxes)
c                 iparent(i) is the box number of the parent of
c                 box i
c
c     nchild      in: integer *8(nboxes)
c                 nchild(i) is the number of children of box i
c
c     ichild      in: integer *8(4,nboxes)
c                 ichild(j,i) is the box id of the jth child of
c                 box i
c
c     mnbors      in: integer *8
c                 max number of neighbors = 27
c----------------------------------------------------------------
c     OUTPUT
c     nnbors      out: integer *8(nboxes)
c                 nnbors(i) is the number of colleague boxes of
c                 box i
c
c     nbors       out: integer *8(mnbors,nboxes)
c                 nbors(j,i) is the box id of the jth colleague
c                 box of box i
c---------------------------------------------------------------
      implicit none
      integer *8 nlevels,nboxes, mnbors
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes), nchild(nboxes), ichild(8,nboxes)
      integer *8 nnbors(nboxes)
      integer *8 nbors(mnbors,nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,dad
      integer *8 i,j,ifirstbox,ilastbox


c     Setting parameters for level = 0
      nnbors(1) = 1
      nbors(1,1) = 1
      do ilev = 1,nlevels
c        Find the first and the last box at level ilev      
         ifirstbox = laddr(1,ilev)
         ilastbox = laddr(2,ilev)
c        Loop over all boxes to evaluate neighbors, list1 and updating
c        hunglists of targets

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox)
         do ibox = ifirstbox,ilastbox
c           Find the parent of the current box         
            dad = iparent(ibox)
c           Loop over the neighbors of the parent box
c           to find out list 1 and list 2
            do i=1,nnbors(dad)
                jbox = nbors(i,dad)
                do j=1,8
c               ichild(j,jbox) is one of the children of the
c               neighbors of the parent of the current
c               box
                   kbox = ichild(j,jbox)
                   if(kbox.gt.0) then
c               Check if kbox is a nearest neighbor or in list 2
                      if((abs(centers(1,kbox)-centers(1,ibox)).le.
     1                   1.05*boxsize(ilev)).and.
     2                   (abs(centers(2,kbox)-centers(2,ibox)).le.
     3                   1.05*boxsize(ilev)).and.
     4                   (abs(centers(3,kbox)-centers(3,ibox)).le.
     5                   1.05*boxsize(ilev))) then
                     
                         nnbors(ibox) = nnbors(ibox)+1
                         nbors(nnbors(ibox),ibox) = kbox
                      endif
                   endif
                enddo
            enddo
c           End of computing colleagues of box i
         enddo
C$OMP END PARALLEL DO         
      enddo

      return
      end
c-------------------------------------------------------------      
      subroutine computecollisep(nlevels,nboxes,laddr,boxsize,
     1                       centers,iparent,nchild,ichild,isep,
     2                       mnbors,nnbors,nbors)

c     This subroutine computes the colleagues for an adaptive
c     pruned tree. box j is a colleague of box i, if they share a
c     vertex or an edge and the two boxes are at the same
c     level in the tree
c
c     INPUT arguments
c     nlevels     in: integer *8
c                 Number of levels
c
c     nboxes      in: integer *8
c                 Total number of boxes
c
c     laddr       in: integer *8(2,0:nlevels)
c                 indexing array providing access to boxes at
c                 each level. 
c                 the first box on level i is laddr(1,i)
c                 the last box on level i is laddr(2,i)
c
c     boxsize     in: double precision(0:;nlevels)
c                 Array of boxsizes
c 
c     centers     in: double precision(2,nboxes)
c                 array of centers of boxes
c   
c     iparent     in: integer *8(nboxes)
c                 iparent(i) is the box number of the parent of
c                 box i
c
c     nchild      in: integer *8(nboxes)
c                 nchild(i) is the number of children of box i
c
c     ichild      in: integer *8(4,nboxes)
c                 ichild(j,i) is the box id of the jth child of
c                 box i
c
c     isep        in: integer *8
c                 separation criterion for neighbors.
c                 neighbor is box at same level satisfying
c                 |c_{i} - c_{j}| leq isep*boxsize(c_{i})
c
c     mnbors      in: integer *8
c                 max number of neighbors = 27
c----------------------------------------------------------------
c     OUTPUT
c     nnbors      out: integer *8(nboxes)
c                 nnbors(i) is the number of colleague boxes of
c                 box i
c
c     nbors       out: integer *8(mnbors,nboxes)
c                 nbors(j,i) is the box id of the jth colleague
c                 box of box i
c---------------------------------------------------------------
      implicit none
      integer *8 nlevels,nboxes, mnbors
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes), nchild(nboxes), ichild(8,nboxes)
      integer *8 nnbors(nboxes)
      integer *8 nbors(mnbors,nboxes)
      integer *8 isep

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,dad
      integer *8 i,j,ifirstbox,ilastbox


c     Setting parameters for level = 0
      nnbors(1) = 1
      nbors(1,1) = 1
      do ilev = 1,nlevels
c        Find the first and the last box at level ilev      
         ifirstbox = laddr(1,ilev)
         ilastbox = laddr(2,ilev)
c        Loop over all boxes to evaluate neighbors, list1 and updating
c        hunglists of targets
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox)
         do ibox = ifirstbox,ilastbox
c           Find the parent of the current box         
            dad = iparent(ibox)
c           Loop over the neighbors of the parent box
c           to find out list 1 and list 2
            do i=1,nnbors(dad)
                jbox = nbors(i,dad)
                do j=1,8
c               ichild(j,jbox) is one of the children of the
c               neighbors of the parent of the current
c               box
                   kbox = ichild(j,jbox)
                   if(kbox.gt.0) then
c               Check if kbox is a nearest neighbor or in list 2
                      if((abs(centers(1,kbox)-centers(1,ibox)).le.
     1                   1.05*isep*boxsize(ilev)).and.
     2                   (abs(centers(2,kbox)-centers(2,ibox)).le.
     3                   1.05*isep*boxsize(ilev)).and.
     4                   (abs(centers(3,kbox)-centers(3,ibox)).le.
     5                   1.05*isep*boxsize(ilev))) then
                     
                         nnbors(ibox) = nnbors(ibox)+1
                         nbors(nnbors(ibox),ibox) = kbox
                      endif
                   endif
                enddo
            enddo
c           End of computing colleagues of box i
         enddo
C$OMP END PARALLEL DO         
      enddo

      return
      end
c-------------------------------------------------------------------      
      subroutine d3hpfixtree(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $              radexp,nlevels,nboxes,
     $              centers,boxsize,nbmax,
     $              laddr,ilevel,iparent,nchild,ichild,
     $              mnbors,nnbors,nbors, 
     $              isource,itarget,iexpc,
     $              ihsfirst,ihslast,
     $              isfirst,islast,
     $              itfirst,itlast,
     $              ihefirst,ihelast,
     $              iefirst,ielast,nhungsrc,
     $              nhungexp)
c     Give an adaptive tree, this subroutine fixes the tree
c     to make it level restricted. A level restricted tree
c     is one where no two boxes that contact each other are
c     more than one level apart. The subroutine corrects
c     a given adaptive tree by adding in new boxes. The
c     process involves flagging down bigger boxes and dividing
c     them and their children as necessary.
c
c     Input arguments
c     src         in: double precision(3,ns)
c                 x and y coordinates of the source locations
c    
c     ns          in: integer *8
c                 number of sources
c
c     radsrc      in: double precision(ns)
c                 radius of sources. A source i is hung
c                 at level ilev 
c                 if radsrc(i)>boxsize(ilev)
c
c     trg        in: double precision(3,nt)
c                 x and y coordinates of target locations
c
c     nt          in: integer *8
c                 number of targets
c
c     expc        in: double precision(3,nexpc)
c                 x and y coordinates of expansion centers
c
c     radexp      in: double precision(nexpc)
c                 radius of expansion centers. An expansion
c                 center i is hung at level ilev if
c                 radexp(i)>boxsize(ilev)
c
c     nlevels     in/out: integer *8
c                 current number of levels in the tree
c                 On output nlevels remains unchanged
c
c     nboxes      in/out: integer *8
c                 current number of boxes in the tree.
c                 On output it is the number of boxes
c                 in the level restricted tree
c
c     centers     in/out: double precision(3,nbmax)
c                 x and y coordinates of the box centers 
c                 in the tree
c
c     boxsize     in: double precision(0:nlevels)
c                 size of the box at any given level
c
c     nbmax       in: integer *8
c                 max number of boxes
c
c     laddr       in/out: integer *8(2,0:nlevels)
c                 laddr(1,i), laddr(2,i) are the first
c                 and the last box at level i
c
c     ilevel      in/out: integer *8(nbmax)
c                 ilevel(i) is the level of box i
c
c     iparent     in/out: integer *8(nbmax)
c                 iparent(i) is the parent of box i
c
c     nchild      in/out: integer *8(nbmax)
c                 nchild(i) is the number of children 
c                 of box i
c
c    ichild       in/out: integer *8(8,nbmax)
c                 ichild(j,i) is the jth child of box i
c
c    nnbors       in/out: integer *8(nbmax)
c                 nnbors(i) is the number of colleagues of box i
c
c    nbors        in/out: integer *8(mnbors,nbmax)
c                 nbors(j,i) is the jth colleague of box i
c
c    isource      in/out: integer *8(ns)
c                 tree sorted array of sources
c
c    itarg        in/out: integer *8(nt)
c                 tree sorted array of targets
c
c    iexpc        in/out: integer *8(nexpc)
c                 tree sorted array of expansion centers
c
c    ihsfirst     in/out: integer *8(nbmax)
c                 ihsfirst(i) is the location in isource
c                 array for the first hung source in box i
c                 
c    ihslast      in/out: integer *8(nbmax)
c                 ihslast(i) is the location in isource
c                 array for the last hung source in box i
c                 
c    isfirst      in/out: integer *8(nbmax)
c                 isfirst(i) is the location in isource
c                 array for the first source in box i
c                 
c    islast       in/out: integer *8(nbmax)
c                 islast(i) is the location in isource
c                 array for the last source in box i
c                 
c    itfirst      in/out: integer *8(nbmax)
c                 itfirst(i) is the location in itarg
c                 array for the first target in box i
c                 
c    itlast       in/out: integer *8(nbmax)
c                 itlast(i) is the location in itarg
c                 array for the last target in box i
c                 
c    ihefirst     in/out: integer *8(nbmax)
c                 ihefirst(i) is the location in iexpc
c                 array for the first hung expansion center in box i
c                 
c    ihelast      in/out: integer *8(nbmax)
c                 ihelast(i) is the location in iexpc
c                 array for the last hung expansion center in box i
c                 
c    iefirst      in/out: integer *8(nbmax)
c                 iefirst(i) is the location in iexpc
c                 array for the first expansion center in box i
c                 
c    ielast       in/out: integer *8(nbmax)
c                 ielast(i) is the location in iexpc
c                 array for the last expansion center in box i
c                
c    nhungsrc     in/out: integer *8(nbmax)
c                 nhungsrc(i) is the number of hung sources in box i
c
c    nhungexp     in/out: integer *8(nbmax)
c                 nhungexp(i) is the number of hung 
c                 expansion centers in box i

      implicit none
c     Calling sequence variable declaration
      integer *8 ier
      integer *8 ns,nt,nexpc
      double precision src(3,ns), trg(3,nt), expc(3,nexpc)
      double precision radsrc(ns),radexp(nexpc)

      integer *8 nlevels,nboxes,nbmax, mnbors
      double precision boxsize(0:nlevels), centers(3,nbmax)

      integer *8 laddr(2,0:nlevels),ilevel(nbmax)
      integer *8 iparent(nbmax)
      integer *8 nchild(nbmax), ichild(8,nbmax)
      integer *8 nnbors(nbmax), nbors(mnbors,nbmax)
      integer *8 isource(ns),itarget(nt),iexpc(nexpc)

      integer *8 ihsfirst(nbmax), ihslast(nbmax)
      integer *8 isfirst(nbmax), islast(nbmax)

      integer *8 itfirst(nbmax), itlast(nbmax)

      integer *8 ihefirst(nbmax), ihelast(nbmax)
      integer *8 iefirst(nbmax), ielast(nbmax)
      
      integer *8 nhungsrc(nbmax), nhungexp(nbmax)

      integer *8, allocatable :: iflag(:)
c     Temporary variables
      integer *8 i,j,k,l
      integer *8 ibox,jbox,kbox,ilev
      integer *8 idad,igranddad
      double precision xdis,ydis,zdis,distest

      integer *8 laddrtail(2,0:nlevels),ict


      allocate(iflag(nbmax))

c     Initialize flag array
      do i=1,nboxes
         iflag(i) = 0
      enddo

c     Flag boxes that violate level restriction by "1"
c     Violatioin refers to any box that is directly touching
c     a box that is more than one level finer
c
c     Method:
c     1) Carry out upward pass. For each box B, look at
c     the colleagues of B's grandparent
c     2) See if any of those colleagues are childless and in
c     contact with B.
c
c     Note that we only need to get up to level two, as
c     we will not find a violation at level 0 and level 1
c
c     For such boxes, we set iflag(i) = 1
c
      do ilev=nlevels,2,-1
c        This is the distance to test if two boxes separated
c        by two levels are touching
         distest = 1.05d0*(boxsize(ilev-1) + boxsize(ilev-2))/2.0d0
         do ibox = laddr(1,ilev),laddr(2,ilev) 
            idad = iparent(ibox)
            igranddad = iparent(idad)
            
c           Loop over colleagues of granddad            
            do i=1,nnbors(igranddad)
               jbox = nbors(i,igranddad)
c              Check if the colleague of grandad
c              is a leaf node. This automatically
c              eliminates the granddad
               if(nchild(jbox).eq.0.and.iflag(jbox).eq.0) then
                   xdis = centers(1,jbox) - centers(1,idad)
                   ydis = centers(2,jbox) - centers(2,idad)
                   zdis = centers(3,jbox) - centers(3,idad)
                   ict = 0
                   if(abs(xdis).le.distest) ict = ict + 1
                   if(abs(ydis).le.distest) ict = ict + 1
                   if(abs(zdis).le.distest) ict = ict + 1
                   if(ict.eq.3) then
                      iflag(jbox) = 1
                   endif
               endif
c              End of checking criteria for the colleague of
c              granddad
            enddo
c           End of looping over colleagues of
c           granddad
         enddo
c        End of looping over boxes at ilev         
      enddo
c     End of looping over levels and flagging boxes

c     Find all boxes that need to be given a flag+
c     A flag+ box will be denoted by setting iflag(box) = 2
c     This refers to any box that is not already flagged and
c     is bigger than and is contacting a flagged box
c     or another box that has already been given a flag +.
c     It is found by performing an upward pass and looking
c     at the flagged box's parents colleagues and a flag+
c     box's parents colleagues and seeing if they are
c     childless and present the case where a bigger box 
c     is contacting a flagged or flag+ box.

      do ilev = nlevels,2,-1
c        This is the distance to test if two boxes separated
c        by one level are touching
         distest = 1.05d0*(boxsize(ilev) + boxsize(ilev-1))/2.0d0
         do ibox = laddr(1,ilev),laddr(2,ilev)
            if(iflag(ibox).eq.1.or.iflag(ibox).eq.2) then
               idad = iparent(ibox)
c              Loop over dad's colleagues               
               do i=1,nnbors(idad)
                  jbox = nbors(i,idad)
c                 Check if the colleague of dad
c                 is a leaf node. This automatically
c                 eliminates the dad
                  if(nchild(jbox).eq.0.and.iflag(jbox).eq.0) then
                     xdis = centers(1,jbox) - centers(1,ibox)
                     ydis = centers(2,jbox) - centers(2,ibox)
                     zdis = centers(3,jbox) - centers(3,ibox)
                     ict = 0
                     if(abs(xdis).le.distest) ict = ict + 1
                     if(abs(ydis).le.distest) ict = ict + 1
                     if(abs(zdis).le.distest) ict = ict + 1
                     if(ict.eq.3) then
                        iflag(jbox) = 2
                     endif
                  endif
c                 End of checking criteria for the colleague of
c                dad
               enddo
c              End of looping over dad's colleagues               
            endif
c           End of checking if current box is relevant for
c           flagging flag+ boxes
         enddo
c        End of looping over boxes at ilev         
      enddo
c     End of looping over levels

c     Subdivide all flag and flag+ boxes. Flag all the children
c     of flagged boxes as flag++. Flag++ boxes are denoted
c     by setting iflag(box) = 3. The flag++ boxes need 
c     to be checked later to see which of them need further
c     refinement. While creating new boxes, we will
c     need to update all the tree structures as well.
c     Note that all the flagged boxes live between
c     levels 1 and nlevels - 2. We process the boxes via a
c     downward pass. We first determine the number of boxes
c     that are going to be subdivided at each level and 
c     everything else accordingly
      do ilev = 0,nlevels
         laddrtail(1,ilev) = 0
         laddrtail(2,ilev) = -1
      enddo
 
      do ilev = 1,nlevels-2
c        First subdivide all the flag and flag+
c        boxes with boxno nboxes+1, nboxes+ 2
c        and so on. In the second step, we reorganize
c        all the structures again to bring it back
c        in the standard format

         laddrtail(1,ilev+1) = nboxes+1

         call subdivide_flag(ier,src,ns,radsrc,trg,nt,
     $                   expc,nexpc,radexp,
     $                   ilev,nboxes,
     $                   centers,boxsize,nbmax,nlevels,
     $                   laddr,ilevel,iparent,nchild,ichild,
     $                   isource,itarget,iexpc,
     $                   ihsfirst,ihslast,
     $                   isfirst,islast,
     $                   itfirst,itlast,
     $                   ihefirst,ihelast,
     $                   iefirst,ielast,nhungsrc,
     $                   nhungexp,iflag)
         if(ier.ne.0) return
         laddrtail(2,ilev+1) = nboxes
      enddo
c     Reorganize the tree to get it back in the standard format

      call reorganizetree(nboxes,centers,nlevels,laddr,laddrtail,
     1                    ilevel,iparent,nchild,ichild,ihsfirst,
     2                    ihslast,isfirst,islast,itfirst,itlast,
     3                    ihefirst,ihelast,iefirst,ielast,
     4                    nhungsrc,nhungexp,iflag)

c     Compute colleague information again      

      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo
      call computecoll(nlevels,nboxes,laddr, boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,mnbors,nnbors,nbors)

c     Processing of flag and flag+ boxes is done
c     Start processing flag++ boxes. We will use a similar
c     strategy as before. We keep checking the flag++
c     boxes that require subdivision if they still
c     violate the level restriction criterion, create
c     the new boxes, append them to the end of the list to begin
c     with and in the end reorganize the tree structure.
c     We shall accomplish this via a downward pass
c     as new boxes that get added in the downward pass
c     will also be processed simultaneously.
c     We shall additionally also need to keep on updating
c     the colleague information as we proceed in the 
c     downward pass

c     Reset the flags array to remove all the flag and flag+
c     cases. This is to ensure reusability of the subdivide
c     _flag routine to handle the flag++ case

      do ibox=1,nboxes
         if(iflag(ibox).ne.3) iflag(ibox) = 0
      enddo
 
      do ilev = 0,nlevels
         laddrtail(1,ilev) = 0
         laddrtail(2,ilev) = -1
      enddo

      do ilev = 2,nlevels-2

c     Step 1: Determine which of the flag++ boxes need
c     further division. In the even a flag++ box needs
c     further subdivision then flag the box with iflag(box) = 1
c     This will again ensure that the subdivide_flag routine
c     will take care of handling the flag++ case
         call updateflags(ilev,nboxes,nlevels,laddr,nchild,ichild,
     1                    mnbors,nnbors,nbors,centers,boxsize,iflag)

         call updateflags(ilev,nboxes,nlevels,laddrtail,nchild,ichild,
     1                    mnbors,nnbors,nbors,centers,boxsize,iflag)
         
c      Step 2: Subdivide all the boxes that need subdivision
c      in the laddr set and the laddrtail set as well
         laddrtail(1,ilev+1) = nboxes + 1
         call subdivide_flag(ier,src,ns,radsrc,trg,nt,
     $                   expc,nexpc,radexp,
     $                   ilev,nboxes,
     $                   centers,boxsize,nbmax,nlevels,
     $                   laddr,ilevel,iparent,nchild,ichild,
     $                   isource,itarget,iexpc,
     $                   ihsfirst,ihslast,
     $                   isfirst,islast,
     $                   itfirst,itlast,
     $                   ihefirst,ihelast,
     $                   iefirst,ielast,nhungsrc,
     $                   nhungexp,iflag)
         if(ier.ne.0) return

         call subdivide_flag(ier,src,ns,radsrc,trg,nt,
     $                   expc,nexpc,radexp,
     $                   ilev,nboxes,
     $                   centers,boxsize,nbmax,nlevels,
     $                   laddrtail,ilevel,iparent,nchild,ichild,
     $                   isource,itarget,iexpc,
     $                   ihsfirst,ihslast,
     $                   isfirst,islast,
     $                   itfirst,itlast,
     $                   ihefirst,ihelast,
     $                   iefirst,ielast,nhungsrc,
     $                   nhungexp,iflag)
          if(ier.ne.0) return
          laddrtail(2,ilev+1) = nboxes         
c      Step 3: Update the colleague information for the newly
c      created boxes
          do ibox = laddrtail(1,ilev+1),laddrtail(2,ilev+1)
            nnbors(ibox) = 0
c           Find the parent of the current box         
            idad = iparent(ibox)
c           Loop over the neighbors of the parent box
c           to find out colleagues
            do i=1,nnbors(idad)
                jbox = nbors(i,idad)
                do j=1,8
c               ichild(j,jbox) is one of the children of the
c               neighbors of the parent of the current
c               box
                   kbox = ichild(j,jbox)
                   if(kbox.gt.0) then
c               Check if kbox is a nearest neighbor or in list 2
                      if((abs(centers(1,kbox)-centers(1,ibox)).le.
     1                   1.05*boxsize(ilev+1)).and.
     2                   (abs(centers(2,kbox)-centers(2,ibox)).le.
     3                   1.05*boxsize(ilev+1)).and.
     4                   abs(centers(3,kbox)-centers(3,ibox)).le.
     5                   1.05*boxsize(ilev+1)) then
                     
                         nnbors(ibox) = nnbors(ibox)+1
                         nbors(nnbors(ibox),ibox) = kbox
                      endif
                   endif
                enddo
            enddo
c           End of computing colleagues of box i
         enddo
      enddo

c     Reorganize tree once again and we are all done      
      call reorganizetree(nboxes,centers,nlevels,laddr,laddrtail,
     1                    ilevel,iparent,nchild,ichild,
     2                    ihsfirst,
     3                    ihslast,isfirst,islast,itfirst,itlast,
     4                    ihefirst,ihelast,iefirst,ielast,
     5                    nhungsrc,nhungexp,iflag)

c     Compute colleague information again      

      do i=1,nboxes
         nnbors(i) = 0
         do j=1,mnbors
            nbors(j,i) = -1
         enddo
      enddo
      call computecoll(nlevels,nboxes,laddr, boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,mnbors,nnbors,nbors)
      
      return
      end
c---------------------------------------------------------------
      subroutine subdivide_flag(ier,src,ns,radsrc,trg,nt,expc,nexpc,
     $                   radexp,
     $                   curlev,nboxes,
     $                   centers,boxsize,nbmax,nlevels,
     $                   laddr,ilevel,iparent,nchild,ichild,
     $                   isource,itarget,iexpc,
     $                   ihsfirst,ihslast,
     $                   isfirst,islast,
     $                   itfirst,itlast,
     $                   ihefirst,ihelast,
     $                   iefirst,ielast,nhungsrc,
     $                   nhungexp,iflag)
      implicit none
      integer *8 ns,nt,nexpc,ier
      integer *8 nlevels,nboxes,nbmax, curlev
      double precision src(3,ns),radsrc(ns)
      double precision trg(3,nt)
      double precision expc(3,nexpc),radexp(nexpc)
      double precision centers(3,nbmax)
      double precision boxsize(0:nlevels)
      integer *8 laddr(2,0:nlevels)
      integer *8 ilevel(nbmax)
      integer *8 iparent(nbmax)
      integer *8 nchild(nbmax)
      integer *8 ichild(8,nbmax)
      integer *8 isource(ns)
      integer *8 itarget(nt)
      integer *8 iexpc(nexpc)
      integer *8 ihsfirst(nbmax)
      integer *8 ihslast(nbmax)
      integer *8 isfirst(nbmax)
      integer *8 islast(nbmax)
      integer *8 itfirst(nbmax)
      integer *8 itlast(nbmax)
      integer *8 ihefirst(nbmax)
      integer *8 ihelast(nbmax)
      integer *8 iefirst(nbmax)
      integer *8 ielast(nbmax)
      integer *8 nhungsrc(nbmax)
      integer *8 nhungexp(nbmax)
      integer *8 iflag(nbmax)
c     Temporary variables
      integer *8 isrctmp(ns),itargtmp(nt),iexpctmp(nexpc)
      integer *8 i,j,i12,i34,istart,jstart,kstart,ii,iii,nss,nee,ntt
      integer *8 ibox,ifirstbox,ilastbox,nbfirst
      integer *8 i56, i78, i1234, i5678
      integer *8 is,it,ie, jj
      integer *8 nsc(8),ntc(8),nh(8),nexpcc(8),nhc(8)
c
c     for every box at level nlevels,
c     sort into children, updating various arrays 
c     perhaps just build tree here paren/child/particle sorting...
c     lists in second call ???
c     
c     allocate temp array for isourcetemp2 itargtemp2
c     after all done, write back to isourcetemp, itargtemp
c     this is O(N) * nlevels work for rewriting.
c     can be fancier I suppose.
c     
      ifirstbox = laddr(1,curlev)
      ilastbox =  laddr(2,curlev)

c
      do ibox = ifirstbox,ilastbox
c        The current box needs to be subdivided if iflag(ibox).gt.0       
         if(iflag(ibox).gt.0) then
c           Based on flagging criterion, the current
c           box needs to be divided. 

c           Allocate temporary array to figure out which child you
c           belong to
c           which child?  1,2,3,4,5,6,7,8? counter ns1,ns2,ns3,ns4,
c           ns5,ns6,ns7,ns8
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0

            i1234 = isfirst(ibox)-1
            i5678 = 0
            do is = isfirst(ibox),islast(ibox)
               if(src(3,isource(is)) - centers(3,ibox).lt.0) then
                  i1234 = i1234+1
                  isource(i1234) = isource(is)
               else
                  i5678 = i5678 + 1
                  isrctmp(i5678) = isource(is)
               endif
            enddo
c           Note at the end of the loop, i1234 is where the particles
c           in part 1234 of the box end

c           Reorder sources to include sources in 5678 in the array
            do i=1,i5678
               isource(i1234+i) = isrctmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = isfirst(ibox)-1
            i34 = 0
            do is = isfirst(ibox),i1234
               if(src(2,isource(is))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  isource(i12) = isource(is)
               else
                  i34 = i34 + 1
                  isrctmp(i34) = isource(is)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder sources to include 34 in the array
            do i=1,i34
               isource(i12+i) = isrctmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do is=i1234+1,islast(ibox)
               if(src(2,isource(is))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  isource(i56) = isource(is)
               else
                  i78 = i78 + 1
                  isrctmp(i78) = isource(is)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               isource(i56+i) = isrctmp(i)
            enddo
c           End of reordering i5678         

            nsc(1) = 0
            nsc(2) = 0
            nsc(3) = 0
            nsc(4) = 0
            nsc(5) = 0
            nsc(6) = 0
            nsc(7) = 0
            nsc(8) = 0
c           Sort into boxes 1 and 2
            do is = isfirst(ibox),i12
               if(src(1,isource(is))-centers(1,ibox).lt.0) then
                  isource(isfirst(ibox)+nsc(1)) = isource(is)
                  nsc(1) = nsc(1) + 1
               else
                  nsc(2) = nsc(2) + 1
                  isrctmp(nsc(2)) = isource(is)
               endif
            enddo
c           Reorder sources so that sources in 2 are at the
c           end of this part of the array
            do i=1,nsc(2)
               isource(isfirst(ibox)+nsc(1)+i-1) = isrctmp(i)
            enddo

c           Sort into boxes 3 and 4
            do is = i12+1, i1234
               if(src(1,isource(is))-centers(1,ibox).lt.0) then
                  isource(i12+1+nsc(3)) = isource(is)
                  nsc(3) = nsc(3) + 1
                else
                   nsc(4) = nsc(4)+1
                   isrctmp(nsc(4)) = isource(is)
                endif
            enddo
c           Reorder sources so that sources in 4 are at the
c           end of this part of the array
            do i=1,nsc(4)
               isource(i12+nsc(3)+i) = isrctmp(i)
            enddo

c           Sort into boxes 5 and 6
            do is = i1234+1,i56
               if(src(1,isource(is))-centers(1,ibox).lt.0) then
                  isource(i1234+1+nsc(5)) = isource(is)
                  nsc(5) = nsc(5) + 1
               else
                  nsc(6) = nsc(6) + 1
                  isrctmp(nsc(6)) = isource(is)
               endif
            enddo
c           Reorder sources so that sources in 6 are at the
c           end of this part of the array
            do i=1,nsc(6)
               isource(i1234+nsc(5)+i) = isrctmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do is=i56+1,islast(ibox)
               if(src(1,isource(is))-centers(1,ibox).lt.0) then
                  isource(i56+1+nsc(7)) = isource(is)
                  nsc(7) = nsc(7) + 1
               else
                  nsc(8) = nsc(8) + 1
                  isrctmp(nsc(8)) = isource(is)
               endif
            enddo
c           Reorder sources so that sources in 8 are at the
c           end of the array
            do i=1,nsc(8)
               isource(i56+nsc(7)+i) = isrctmp(i)
            enddo

            istart = isfirst(ibox)-1
            do j=1,8
c           check hung -> counter nh1,nh2,nh3,nh4,nh5,nh6,nh7,nh8
               ii = 0
               nh(j) = 0
               do i=1,nsc(j)
                  if(radsrc(isource(istart+i)).gt.boxsize(curlev+1))
     1            then     
                     nh(j) = nh(j) + 1
                     isource(istart+nh(j)) = isource(istart+i)
                  else
                     ii = ii+1
                     isrctmp(ii) = isource(istart+i)
                  endif
               enddo
c           Reorder sources to have hung chunks at the star
c           of the sorted sources in the box ibox
                do i=1,ii
                  isource(istart+nh(j)+i) = isrctmp(i)
                enddo
                istart = istart + nsc(j)
            enddo
c           End of sorting sources

c           Sort targets
c           which child?  1,2,3,4,5,6,7,8? counter nt1,nt2,nt3,nt4,
c           nt5,nt6,nt7,nt8
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0
c
            i1234 = itfirst(ibox)-1
            i5678 = 0
            do it = itfirst(ibox),itlast(ibox)
               if(trg(3,itarget(it)) - centers(3,ibox).lt.0) then
                 i1234 = i1234+1
                 itarget(i1234) = itarget(it)
               else
                  i5678 = i5678 + 1
                  itargtmp(i5678) = itarget(it)
               endif
            enddo
c           Reorder sources to include targets in 5678 in the array
            do i=1,i5678
               itarget(i1234+i) = itargtmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = itfirst(ibox)-1
            i34 = 0
            do it = itfirst(ibox),i1234
               if(trg(2,itarget(it))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  itarget(i12) = itarget(it)
               else
                  i34 = i34 + 1
                  itargtmp(i34) = itarget(it)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder targets to include 34 in the array
            do i=1,i34
               itarget(i12+i) = itargtmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do it=i1234+1,itlast(ibox)
               if(trg(2,itarget(it))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  itarget(i56) = itarget(it)
               else
                  i78 = i78 + 1
                  itargtmp(i78) = itarget(it)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               itarget(i56+i) = itargtmp(i)
            enddo
c           End of reordering i5678         

            ntc(1) = 0
            ntc(2) = 0
            ntc(3) = 0
            ntc(4) = 0
            ntc(5) = 0
            ntc(6) = 0
            ntc(7) = 0
            ntc(8) = 0

c           Sort into boxes 1 and 2
            do it = itfirst(ibox),i12
               if(trg(1,itarget(it))-centers(1,ibox).lt.0) then
                  itarget(itfirst(ibox)+ntc(1)) = itarget(it)
                  ntc(1) = ntc(1) + 1
               else
                  ntc(2) = ntc(2) + 1
                  itargtmp(ntc(2)) = itarget(it)
               endif
            enddo
c           Reorder targets so that sources in 2 are at the
c           end of this part of the array
            do i=1,ntc(2)
               itarget(itfirst(ibox)+ntc(1)+i-1) = itargtmp(i)
            enddo
c           Sort into boxes 3 and 4
            do it = i12+1, i1234
               if(trg(1,itarget(it))-centers(1,ibox).lt.0) then
                  itarget(i12+1+ntc(3)) = itarget(it)
                  ntc(3) = ntc(3) + 1
                else
                   ntc(4) = ntc(4)+1
                   itargtmp(ntc(4)) = itarget(it)
                endif
            enddo
c           Reorder targets so that sources in 4 are at the
c           end of this part of the array
            do i=1,ntc(4)
               itarget(i12+ntc(3)+i) = itargtmp(i)
            enddo

c           Sort into boxes 5 and 6
            do it = i1234+1,i56
               if(trg(1,itarget(it))-centers(1,ibox).lt.0) then
                  itarget(i1234+1+ntc(5)) = itarget(it)
                  ntc(5) = ntc(5) + 1
               else
                  ntc(6) = ntc(6) + 1
                  itargtmp(ntc(6)) = itarget(it)
               endif
            enddo
c           Reorder targets so that sources in 6 are at the
c           end of this part of the array
            do i=1,ntc(6)
               itarget(i1234+ntc(5)+i) = itargtmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do it=i56+1,itlast(ibox)
               if(trg(1,itarget(it))-centers(1,ibox).lt.0) then
                  itarget(i56+1+ntc(7)) = itarget(it)
                  ntc(7) = ntc(7) + 1
               else
                  ntc(8) = ntc(8) + 1
                  itargtmp(ntc(8)) = itarget(it)
               endif
            enddo
c           Reorder targets so that sources in 8 are at the
c           end of the array
            do i=1,ntc(8)
               itarget(i56+ntc(7)+i) = itargtmp(i)
            enddo
c           End of sorting targets

c           Sort expansion centers
c           which child?  1,2,3,4,5,6,7,8? counter
c           nexpcc1, nexpcc2, nexpcc3, nexpcc4,
c           nexpcc5, nexpcc6, nexpcc7, nexpcc8,
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0
c
            i1234 = iefirst(ibox)-1
            i5678 = 0
            do ie = iefirst(ibox),ielast(ibox)
               if(expc(3,iexpc(ie)) - centers(3,ibox).lt.0) then
                  i1234 = i1234+1
                  iexpc(i1234) = iexpc(ie)
               else
                  i5678 = i5678 + 1
                  iexpctmp(i5678) = iexpc(ie)
               endif
            enddo

c           Reorder sources to include sources in 5678 in the array
            do i=1,i5678
               iexpc(i1234+i) = iexpctmp(i)
            enddo

c           Sort i1234 into i12 and i34         
            i12 = iefirst(ibox)-1
            i34 = 0
            do ie = iefirst(ibox),i1234
               if(expc(2,iexpc(ie))-centers(2,ibox).lt.0) then
                  i12 = i12 + 1
                  iexpc(i12) = iexpc(ie)
               else
                  i34 = i34 + 1
                  iexpctmp(i34) = iexpc(ie)
               endif
            enddo
c           Note at the end of the loop, i12 is where the particles
c           in part 12 of the box end
c
c           Reorder sources to include 34 in the array
            do i=1,i34
               iexpc(i12+i) = iexpctmp(i)
            enddo

c           sort i5678 into i56 and i78
            i56 = i1234
            i78 = 0
            do ie=i1234+1,ielast(ibox)
               if(expc(2,iexpc(ie))-centers(2,ibox).lt.0) then
                  i56 = i56 + 1
                  iexpc(i56) = iexpc(ie)
               else
                  i78 = i78 + 1
                  iexpctmp(i78) = iexpc(ie)
               endif
            enddo

c           Reorder sources to include 78 in the array
            do i=1,i78
               iexpc(i56+i) = iexpctmp(i)
            enddo
c           End of reordering i5678         

            nexpcc(1) = 0
            nexpcc(2) = 0
            nexpcc(3) = 0
            nexpcc(4) = 0
            nexpcc(5) = 0
            nexpcc(6) = 0
            nexpcc(7) = 0
            nexpcc(8) = 0

c           Sort into boxes 1 and 2
            do ie = iefirst(ibox),i12
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(iefirst(ibox)+nexpcc(1)) = iexpc(ie)
                  nexpcc(1) = nexpcc(1) + 1
               else
                  nexpcc(2) = nexpcc(2) + 1
                  iexpctmp(nexpcc(2)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 2 are at the
c           end of this part of the array
            do i=1,nexpcc(2)
               iexpc(iefirst(ibox)+nexpcc(1)+i-1) = iexpctmp(i)
            enddo
c           Sort into boxes 3 and 4
            do ie = i12+1, i1234
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i12+1+nexpcc(3)) = iexpc(ie)
                  nexpcc(3) = nexpcc(3) + 1
               else
                  nexpcc(4) = nexpcc(4)+1
                  iexpctmp(nexpcc(4)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 4 are at the
c           end of this part of the array
            do i=1,nexpcc(4)
               iexpc(i12+nexpcc(3)+i) = iexpctmp(i)
            enddo

c           Sort into boxes 5 and 6
            do ie = i1234+1,i56
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i1234+1+nexpcc(5)) = iexpc(ie)
                  nexpcc(5) = nexpcc(5) + 1
               else
                  nexpcc(6) = nexpcc(6) + 1
                  iexpctmp(nexpcc(6)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 6 are at the
c           end of this part of the array
            do i=1,nexpcc(6)
               iexpc(i1234+nexpcc(5)+i) = iexpctmp(i)
            enddo
c           End of sorting sources into boxes 5 and 6

c           Sort into boxes 7 and 8
            do ie=i56+1,ielast(ibox)
               if(expc(1,iexpc(ie))-centers(1,ibox).lt.0) then
                  iexpc(i56+1+nexpcc(7)) = iexpc(ie)
                  nexpcc(7) = nexpcc(7) + 1
               else
                  nexpcc(8) = nexpcc(8) + 1
                  iexpctmp(nexpcc(8)) = iexpc(ie)
               endif
            enddo
c           Reorder expc so that sources in 8 are at the
c           end of the array
            do i=1,nexpcc(8)
               iexpc(i56+nexpcc(7)+i) = iexpctmp(i)
            enddo
c           End of sorting expanison centers

            istart = iefirst(ibox)-1
            do j=1,8
c           check hung -> counter nhc1,nhc2,nhc3,nhc4,nhc5,nhc6,nhc7,nhc8
               ii = 0
               nhc(j) = 0
               do i=1,nexpcc(j)
                  if(radexp(iexpc(istart+i)).gt.boxsize(curlev+1))
     1            then     
                     nhc(j) = nhc(j) + 1
                     iexpc(istart+nhc(j)) = iexpc(istart+i)
                  else
                     ii = ii+1
                     iexpctmp(ii) = iexpc(istart+i)
                  endif
               enddo
c           Reorder sources to have hung chunks at the star
c           of the sorted sources in the box ibox
               do i=1,ii
                  iexpc(istart+nhc(j)+i) = iexpctmp(i)
               enddo
               istart = istart + nexpcc(j)
            enddo

            nchild(ibox) = 0
c           Create the required boxes
            istart = isfirst(ibox)
            jstart = itfirst(ibox)
            kstart = iefirst(ibox)
            do i=1,8
               ii = 2
               jj = 2
               if(i.eq.1.or.i.eq.2.or.i.eq.5.or.i.eq.6) ii = 1
               if(i.lt.5) jj = 1
               if(nsc(i)+ntc(i)+nexpcc(i).ge.0) then
c                 Increment total number of boxes               
                  nboxes = nboxes + 1
                  if(nboxes.gt.nbmax) then
                    write(*,*) "Exceeding max number of boxes"
                    write(*,*) "Exiting"
                    ier = 12
                    return
                  endif

c                 Increment number of children for the current box
                  nchild(ibox) = nchild(ibox)+1
c                 Update the array of children for the current box
                  ichild(i,ibox) = nboxes
c                 Update the array of levels for the child box
                  ilevel(nboxes) = curlev+1
c                 Update the array of parents for the child box
                  iparent(nboxes) = ibox
c                 Compute center for the child box
                  centers(1,nboxes) = centers(1,ibox)+(-1)**i*
     1                                boxsize(curlev+1)/2.0
                  centers(2,nboxes) = centers(2,ibox)+(-1)**ii*
     1                               boxsize(curlev+1)/2.0
                  centers(3,nboxes) = centers(3,ibox)+(-1)**jj*
     1                               boxsize(curlev+1)/2.0

                  nchild(nboxes) = 0
                  ichild(1,nboxes) = -1
                  ichild(2,nboxes) = -1
                  ichild(3,nboxes) = -1
                  ichild(4,nboxes) = -1
                  ichild(5,nboxes) = -1
                  ichild(6,nboxes) = -1
                  ichild(7,nboxes) = -1
                  ichild(8,nboxes) = -1
c                 Update arrays ihsfirst,ihslast,isfirst,islast
                  ihsfirst(nboxes) = istart
                  ihslast(nboxes) = istart + nh(i) - 1
                  nhungsrc(nboxes) = nh(i)

                  isfirst(nboxes) = istart + nh(i)
                  islast(nboxes) = istart + nsc(i) - 1

c                 Update arrays itfirst, itlast
                  itfirst(nboxes) = jstart
                  itlast(nboxes) = jstart + ntc(i) - 1

c                 Update arrays ihefirst,ihelast,iefirst,ielast
                  ihefirst(nboxes) = kstart
                  ihelast(nboxes) = kstart + nhc(i)-1
                  nhungexp(nboxes) = nhc(i)

                  iefirst(nboxes) = kstart + nhc(i)
                  ielast(nboxes) = kstart + nexpcc(i) - 1

                  if(iflag(ibox).eq.1) iflag(nboxes) = 3
                  if(iflag(ibox).eq.2) iflag(nboxes) = 0
               endif
               istart = istart + nsc(i)
               jstart = jstart + ntc(i)
               kstart = kstart + nexpcc(i)
            enddo
         endif
      enddo

      return
      end
c-------------------------------------------------------------      
      subroutine reorganizetree(nboxes,centers,nlevels,laddr,laddrtail,
     1                    ilevel,iparent,nchild,ichild,ihsfirst,
     2                    ihslast,isfirst,islast,itfirst,itlast,
     3                    ihefirst,ihelast,iefirst,ielast,
     4                    nhungsrc,nhungexp,iflag)

c    This subroutine reorganizes the current data in all the tree
c    arrays to rearrange them in the standard format.
c    The boxes on input are assumed to be arranged in the following
c    format
c    boxes on level i are the boxes from laddr(1,i) to 
c    laddr(2,i) and also from laddrtail(1,i) to laddrtail(2,i)
c
c    At the end of the sorting, the boxes on level i
c    are arranged from laddr(1,i) to laddr(2,i)  
c
c    INPUT/OUTPUT arguments
c    nboxes         in: integer *8
c                   number of boxes
c
c    centers        in/out: double precision(3,nboxes)
c                   x and y coordinates of the center of boxes
c
c    nlevels        in: integer *8
c                   Number of levels in the tree
c
c    laddr          in/out: integer *8(2,0:nlevels)
c                   boxes at level i are numbered between
c                   laddr(1,i) to laddr(2,i)
c
c    laddrtail      in: integer *8(2,0:nlevels)
c                   new boxes to be added to the tree
c                   structure are numbered from
c                   laddrtail(1,i) to laddrtail(2,i)
c
c     ilevel      in/out: integer *8(nboxes)
c                 ilevel(i) is the level of box i
c
c     iparent     in/out: integer *8(nboxes)
c                 iparent(i) is the parent of box i
c
c     nchild      in/out: integer *8(nboxes)
c                 nchild(i) is the number of children 
c                 of box i
c
c    ichild       in/out: integer *8(8,nboxes)
c                 ichild(j,i) is the jth child of box i
c
c    ihsfirst     in/out: integer *8(nboxes)
c                 ihsfirst(i) is the location in isource
c                 array for the first hung source in box i
c                 
c    ihslast      in/out: integer *8(nboxes)
c                 ihslast(i) is the location in isource
c                 array for the last hung source in box i
c                 
c    isfirst      in/out: integer *8(nboxes)
c                 isfirst(i) is the location in isource
c                 array for the first source in box i
c                 
c    islast       in/out: integer *8(nboxes)
c                 islast(i) is the location in isource
c                 array for the last source in box i
c                 
c    itfirst      in/out: integer *8(nboxes)
c                 itfirst(i) is the location in itarg
c                 array for the first target in box i
c                 
c    itlast       in/out: integer *8(nboxes)
c                 itlast(i) is the location in itarg
c                 array for the last target in box i
c                 
c    ihefirst     in/out: integer *8(nboxes)
c                 ihefirst(i) is the location in iexpc
c                 array for the first hung expansion center in box i
c                 
c    ihelast      in/out: integer *8(nboxes)
c                 ihelast(i) is the location in iexpc
c                 array for the last hung expansion center in box i
c                 
c    iefirst      in/out: integer *8(nboxes)
c                 iefirst(i) is the location in iexpc
c                 array for the first expansion center in box i
c                 
c    ielast       in/out: integer *8(nboxes)
c                 ielast(i) is the location in iexpc
c                 array for the last expansion center in box i
c                
c    nhungsrc     in/out: integer *8(nboxes)
c                 nhungsrc(i) is the number of hung sources in box i
c
c    nhungexp     in/out: integer *8(nboxes)
c                 nhungexp(i) is the number of hung 
c                 expansion centers in box i
c
c    iflag        in/out: integer *8(nboxes)
c                 iflag(i) is a flag for box i required to generate
c                 level restricted tree from adaptive tree

      implicit none
c     Calling sequence variables and temporary variables
      integer *8 nboxes,nlevels
      double precision centers(3,nboxes)
      integer *8 laddr(2,0:nlevels), tladdr(2,0:nlevels)
      integer *8 laddrtail(2,0:nlevels)
      integer *8 ilevel(nboxes)
      integer *8 iparent(nboxes)
      integer *8 nchild(nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 ihsfirst(nboxes)
      integer *8 ihslast(nboxes)
      integer *8 isfirst(nboxes)
      integer *8 islast(nboxes)
      integer *8 itfirst(nboxes)
      integer *8 itlast(nboxes)
      integer *8 ihefirst(nboxes)
      integer *8 ihelast(nboxes)
      integer *8 iefirst(nboxes)
      integer *8 ielast(nboxes)
      integer *8 nhungsrc(nboxes)
      integer *8 nhungexp(nboxes)
      integer *8 iflag(nboxes)



      integer *8, allocatable :: tilevel(:),tiparent(:),tnchild(:)
      integer *8, allocatable :: tichild(:,:),tihsfirst(:),tihslast(:)
      integer *8, allocatable :: tisfirst(:),tislast(:),titfirst(:)
      integer *8, allocatable :: titlast(:),tihefirst(:),tihelast(:)
      integer *8, allocatable :: tiefirst(:),tielast(:),tnhungsrc(:)
      integer *8, allocatable :: tnhungexp(:),tiflag(:),iboxtocurbox(:)

      double precision, allocatable :: tcenters(:,:)

c     Temporary variables
      integer *8 i,j,k,l
      integer *8 ibox,ilev, curbox

      allocate(tcenters(3,nboxes),tilevel(nboxes),tiparent(nboxes))
      allocate(tnchild(nboxes),tichild(8,nboxes),tihsfirst(nboxes))
      allocate(tihslast(nboxes),tisfirst(nboxes),tislast(nboxes))
      allocate(titfirst(nboxes),titlast(nboxes),tihefirst(nboxes))
      allocate(tihelast(nboxes),tiefirst(nboxes),tielast(nboxes))
      allocate(tnhungsrc(nboxes),tnhungexp(nboxes),tiflag(nboxes))
      allocate(iboxtocurbox(nboxes))

      do ilev = 0,nlevels
         tladdr(1,ilev) = laddr(1,ilev)
         tladdr(2,ilev) = laddr(2,ilev)
      enddo

      do ibox=1,nboxes
         tilevel(ibox) = ilevel(ibox)
         tcenters(1,ibox) = centers(1,ibox)
         tcenters(2,ibox) = centers(2,ibox)
         tcenters(3,ibox) = centers(3,ibox)
         tiparent(ibox) = iparent(ibox)
         tnchild(ibox) = nchild(ibox)
         tichild(1,ibox) = ichild(1,ibox)
         tichild(2,ibox) = ichild(2,ibox)
         tichild(3,ibox) = ichild(3,ibox)
         tichild(4,ibox) = ichild(4,ibox)
         tichild(5,ibox) = ichild(5,ibox)
         tichild(6,ibox) = ichild(6,ibox)
         tichild(7,ibox) = ichild(7,ibox)
         tichild(8,ibox) = ichild(8,ibox)
         tihsfirst(ibox) = ihsfirst(ibox)
         tihslast(ibox) = ihslast(ibox)
         tisfirst(ibox) = isfirst(ibox)
         tislast(ibox) = islast(ibox)
         titfirst(ibox) = itfirst(ibox)
         titlast(ibox) = itlast(ibox)
         tihefirst(ibox) = ihefirst(ibox)
         tihelast(ibox) = ihelast(ibox)
         tiefirst(ibox) = iefirst(ibox)
         tielast(ibox) = ielast(ibox)
         tnhungsrc(ibox) = nhungsrc(ibox)
         tnhungexp(ibox) = nhungexp(ibox)
         tiflag(ibox) = iflag(ibox)
      enddo
     
c     Rearrange old arrays now

      do ilev = 0,1
         do ibox = laddr(1,ilev),laddr(2,ilev)
            iboxtocurbox(ibox) = ibox
         enddo
      enddo
      curbox = laddr(1,2)
      do ilev=2,nlevels
         laddr(1,ilev) = curbox
         do ibox = tladdr(1,ilev),tladdr(2,ilev)
            ilevel(curbox) = tilevel(ibox)
            nchild(curbox) = tnchild(ibox)
            centers(1,curbox) = tcenters(1,ibox)
            centers(2,curbox) = tcenters(2,ibox)
            centers(3,curbox) = tcenters(3,ibox)
            ihsfirst(curbox) = tihsfirst(ibox)
            ihslast(curbox) = tihslast(ibox)
            isfirst(curbox) = tisfirst(ibox)
            islast(curbox) = tislast(ibox)
            itfirst(curbox) = titfirst(ibox)
            itlast(curbox) = titlast(ibox)
            ihefirst(curbox) = tihefirst(ibox)
            ihelast(curbox) = tihelast(ibox)
            iefirst(curbox) = tiefirst(ibox)
            ielast(curbox) = tielast(ibox)
            nhungsrc(curbox) = tnhungsrc(ibox)
            nhungexp(curbox) = tnhungexp(ibox)
            iflag(curbox) = tiflag(ibox)
            iboxtocurbox(ibox) = curbox

            curbox = curbox + 1
         enddo
         do ibox = laddrtail(1,ilev),laddrtail(2,ilev)
            ilevel(curbox) = tilevel(ibox)
            centers(1,curbox) = tcenters(1,ibox)
            centers(2,curbox) = tcenters(2,ibox)
            centers(3,curbox) = tcenters(3,ibox)
            nchild(curbox) = tnchild(ibox)
            ihsfirst(curbox) = tihsfirst(ibox)
            ihslast(curbox) = tihslast(ibox)
            isfirst(curbox) = tisfirst(ibox)
            islast(curbox) = tislast(ibox)
            itfirst(curbox) = titfirst(ibox)
            itlast(curbox) = titlast(ibox)
            ihefirst(curbox) = tihefirst(ibox)
            ihelast(curbox) = tihelast(ibox)
            iefirst(curbox) = tiefirst(ibox)
            ielast(curbox) = tielast(ibox)
            nhungsrc(curbox) = tnhungsrc(ibox)
            nhungexp(curbox) = tnhungexp(ibox)
            iflag(curbox) = tiflag(ibox)
            iboxtocurbox(ibox) = curbox

            curbox = curbox + 1
         enddo
         laddr(2,ilev) = curbox-1
      enddo

c     Handle the parent children part of the tree 
c     using the mapping iboxtocurbox

      do ibox=1,nboxes
         if(tiparent(ibox).eq.-1) iparent(iboxtocurbox(ibox)) = -1
         if(tiparent(ibox).gt.0) 
     1    iparent(iboxtocurbox(ibox)) = iboxtocurbox(tiparent(ibox))
         do i=1,8
            if(tichild(i,ibox).eq.-1) ichild(i,iboxtocurbox(ibox)) = -1
            if(tichild(i,ibox).gt.0) 
     1      ichild(i,iboxtocurbox(ibox)) = iboxtocurbox(tichild(i,ibox))
         enddo
      enddo

      return
      end
c-------------------------------------------------------------      
      subroutine updateflags(curlev,nboxes,nlevels,laddr,nchild,ichild,
     1                    mnbors,nnbors,nbors,centers,boxsize,iflag)

c      This subroutine is to check the boxes flagged as flag++
c      and determine which of the boxes need refinement. The flag
c      of the box which need refinement is updated to iflag(box)=1
c      and that of the boxes which do not need refinement is
c      updated to iflag(box) = 0
c
c      INPUT arguments
c      curlev         in: integer *8
c                     the level for which boxes need to be processed
c
c      nboxes         in: integer *8
c                     total number of boxes
c
c      nlevels        in: integer *8
c                     total number of levels
c
c      laddr          in: integer *8(2,0:nlevels)
c                     boxes from laddr(1,ilev) to laddr(2,ilev)
c                     are at level ilev
c
c      nchild         in: integer *8(nboxes)
c                     nchild(ibox) is the number of children
c                     of box ibox
c
c      ichild         in: integer *8(4,nboxes)
c                     ichild(j,ibox) is the box id of the jth
c                     child of box ibox
c
c      mnbors         in: integer *8
c                     max number of neighbors
c
c      nnbors         in: integer *8(nboxes)
c                     nnbors(ibox) is the number of colleagues
c                     of box ibox
c
c      nbors          in: integer *8(mnbors,nboxes)
c                     nbors(j,ibox) is the jth colleague of box
c                     ibox
c
c      centers        in: double precision(3,nboxes)
c                     x and y coordinates of the box centers
c
c      boxsize        in: double precision(0:nlevels)
c                     boxsize(i) is the size of the box at level i
c
c      iflag          in/out: integer *8(nboxes)
c                     iflag(ibox)=3 if it is flag++. iflag(ibox) =1
c                     or 0 at the end of routine depending on
c                     whether box needs to be subdivided or not
c
      implicit none
c     Calling sequence variables
      integer *8 curlev, nboxes, nlevels, mnbors
      integer *8 laddr(2,0:nlevels),nchild(nboxes),ichild(8,nboxes)
      integer *8 nnbors(nboxes), nbors(mnbors,nboxes)
      integer *8 iflag(nboxes)
      double precision centers(3,nboxes),boxsize(0:nlevels)

c     Temporary variables
      integer *8 i,j,k,l,ibox,jbox,kbox,lbox, ict
      double precision distest,xdis,ydis,zdis

      distest = 1.05d0*(boxsize(curlev) + boxsize(curlev+1))/2.0d0
c     Loop over all boxes at the current level      
      do ibox = laddr(1,curlev),laddr(2,curlev)
         if(iflag(ibox).eq.3) then
            iflag(ibox) = 0
c           Loop over colleagues of the current box      
            do i=1,nnbors(ibox)
c              Loop over colleagues of flag++ box        
               jbox = nbors(i,ibox)
              
c              Loop over the children of the colleague box
c              Note we do not need to exclude self from
c              the list of colleagues as a self box which
c              is flag++ does not have any children 
c              and will not enter the next loop
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if(nchild(kbox).gt.0) then
                        xdis = centers(1,kbox) - centers(1,ibox)
                        ydis = centers(2,kbox) - centers(2,ibox)
                        zdis = centers(3,kbox) - centers(3,ibox)
                        ict = 0
                        if(abs(xdis).le.distest) ict = ict + 1
                        if(abs(ydis).le.distest) ict = ict + 1
                        if(abs(zdis).le.distest) ict = ict + 1
                        if(ict.eq.3) then
                           iflag(ibox) = 1
                           goto 1111
                        endif
                     endif
                  endif
c                 End of looping over the children of the child
c                 of the colleague box
               enddo
c              End of looping over the children of the colleague box       
            enddo
c           End of looping over colleagues            
 1111       continue        
         endif
c        End of testing if the current box needs to checked for         
      enddo
c     End of looping over boxes at the current level      

      return
      end
c-----------------------------------------------------------------
      subroutine computemnlists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,isep,nnbors,mnbors,nbors,mnlist1,
     3                   mnlist2,mnlist3,mnlist4)
c     Compute max nuber of boxes in list1,list2,list3,list4
      implicit none
      integer *8 nlevels,nboxes
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes),nchild(nboxes),ichild(8,nboxes)
      integer *8 mnbors,isep
      integer *8 nnbors(nboxes),nbors(mnbors,nboxes)
      integer *8 mnlist1,mnlist2,mnlist3,mnlist4
      integer *8 nlist1(nboxes),nlist2(nboxes),nlist3(nboxes)
      integer *8 nlist4(nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,i,j,k,l
      integer *8 firstbox,lastbox,dad
      double precision xdis,ydis,zdis,distest


C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nboxes
         nlist1(i) = 0
         nlist2(i) = 0
         nlist3(i) = 0
         nlist4(i) = 0
      enddo
C$OMP END PARALLEL DO
      
      nlist1(1) = 1
      nlist2(1) = 0
      nlist3(1) = 0
      nlist4(1) = 0

      do ilev = 1,nlevels
         firstbox = laddr(1,ilev)
         lastbox = laddr(2,ilev)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox,distest,xdis,ydis,zdis)
         do ibox = firstbox,lastbox
            dad = iparent(ibox)
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if((abs(centers(1,kbox)-centers(1,ibox)).ge.
     1                  1.05d0*isep*boxsize(ilev)).or.
     2                  (abs(centers(2,kbox)-centers(2,ibox)).ge.
     3                  1.05d0*isep*boxsize(ilev)).or.
     4                  (abs(centers(3,kbox)-centers(3,ibox)).ge.
     5                  1.05d0*isep*boxsize(ilev))) then

                        nlist2(ibox) = nlist2(ibox) + 1
                     endif
                  endif
               enddo
            enddo
c           Compute list1 and list3 of ibox if it is childless
            if(nchild(ibox).eq.0) then
               do i=1,nnbors(ibox)
                  jbox = nbors(i,ibox)

c
cc                     check for list1 at the same level
c
                  if(nchild(jbox).eq.0) then
                     nlist1(ibox) = nlist1(ibox) + 1
                  endif
c
cc                     check for list1 and list3 at one ilev+1
                  if(nchild(jbox).gt.0) then
                     distest = 1.05d0*(boxsize(ilev)+boxsize(ilev+1))/
     1                         2.0d0*isep
                     do j=1,8
                        kbox = ichild(j,jbox)
                        if(kbox.gt.0) then
                           xdis = dabs(centers(1,kbox)-centers(1,ibox))
                           ydis = dabs(centers(2,kbox)-centers(2,ibox))
                           zdis = dabs(centers(3,kbox)-centers(3,ibox))

                           if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                        zdis.lt.distest) then
                              nlist1(ibox) = nlist1(ibox)+1
                           else
                              nlist3(ibox) = nlist3(ibox)+1
                           endif
                        endif
                     enddo
                  endif
               enddo
c
cc               compute list1 and list4 for boxes at level ilev-1 
               do i=1,nnbors(dad)
                   jbox = nbors(i,dad)
                   if(nchild(jbox).eq.0) then
                      distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                         2.0d0*isep
                      xdis = dabs(centers(1,jbox)-centers(1,ibox))
                      ydis = dabs(centers(2,jbox)-centers(2,ibox))
                      zdis = dabs(centers(3,jbox)-centers(3,ibox))
                      if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                  zdis.lt.distest) then
                         nlist1(ibox) = nlist1(ibox)+1
                      endif
                   endif
               enddo
            endif
c
cc           compute list 4 at level ilev-1
c
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               if(nchild(jbox).eq.0) then
                   distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                 2.0d0*isep
                    xdis = dabs(centers(1,jbox)-centers(1,ibox))
                    ydis = dabs(centers(2,jbox)-centers(2,ibox))
                    zdis = dabs(centers(3,jbox)-centers(3,ibox))
                    if(xdis.gt.distest.or.ydis.gt.distest.or.
     1                 zdis.gt.distest) then
                       nlist4(ibox) = nlist4(ibox)+1
                    endif
               endif
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i) 
C$OMP$REDUCTION(max:mnlist1,mnlist2,mnlist3,mnlist4)      
      do i=1,nboxes
         if(nlist1(i).gt.mnlist1) mnlist1 = nlist1(i)
         if(nlist2(i).gt.mnlist2) mnlist2 = nlist2(i)
         if(nlist3(i).gt.mnlist3) mnlist3 = nlist3(i)
         if(nlist4(i).gt.mnlist4) mnlist4 = nlist4(i)
      enddo
C$OMP END PARALLEL DO      

      return
      end
c---------------------------------------------------------------      
      subroutine computelists(nlevels,nboxes,laddr,boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,isep,nnbors,mnbors,nbors,nlist1,
     3                   mnlist1,list1,nlist2,mnlist2,list2,
     4                   nlist3,mnlist3,list3,nlist4,mnlist4,list4)
c     Compute max nuber of boxes in list1,list2,list3,list4
      implicit none
      integer *8 nlevels,nboxes
      integer *8 laddr(2,0:nlevels)
      double precision boxsize(0:nlevels)
      double precision centers(3,nboxes)
      integer *8 iparent(nboxes),nchild(nboxes),ichild(8,nboxes)
      integer *8 mnbors,isep
      integer *8 nnbors(nboxes),nbors(mnbors,nboxes)
      integer *8 mnlist1,mnlist2,mnlist3,mnlist4
      integer *8 nlist1(nboxes),nlist2(nboxes),nlist3(nboxes)
      integer *8 nlist4(nboxes)
      integer *8 list1(mnlist1,nboxes),list2(mnlist2,nboxes)
      integer *8 list3(mnlist3,nboxes),list4(mnlist4,nboxes)

c     Temp variables
      integer *8 ilev,ibox,jbox,kbox,i,j,k,l
      integer *8 firstbox,lastbox,dad
      double precision xdis,ydis,zdis,distest

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,nboxes
         nlist1(i) = 0
         nlist2(i) = 0
         nlist3(i) = 0
         nlist4(i) = 0
      enddo
C$OMP END PARALLEL DO      
      if(nchild(1).eq.0) then
         nlist1(1) = 1
         list1(1,1) = 1
      else
         nlist1(1) = 0
      endif
      nlist2(1) = 0
      nlist3(1) = 0
      nlist4(1) = 0

      do ilev = 1,nlevels
         firstbox = laddr(1,ilev)
         lastbox = laddr(2,ilev)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,dad,i,jbox,j,kbox,xdis,ydis,zdis,distest)
         do ibox = firstbox,lastbox
            dad = iparent(ibox)
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               do j=1,8
                  kbox = ichild(j,jbox)
                  if(kbox.gt.0) then
                     if((abs(centers(1,kbox)-centers(1,ibox)).ge.
     1                  1.05d0*isep*boxsize(ilev)).or.
     2                  (abs(centers(2,kbox)-centers(2,ibox)).ge.
     3                  1.05d0*isep*boxsize(ilev)).or.
     4                  (abs(centers(3,kbox)-centers(3,ibox)).ge.
     5                  1.05d0*isep*boxsize(ilev))) then

                        nlist2(ibox) = nlist2(ibox) + 1
                        list2(nlist2(ibox),ibox) = kbox
                     endif
                  endif
               enddo
            enddo
c           Compute list1 and list3 of ibox if it is childless
            if(nchild(ibox).eq.0) then
               do i=1,nnbors(ibox)
                  jbox = nbors(i,ibox)

c
cc                boxes in list 1 at the same level
c

                  if(nchild(jbox).eq.0) then
                     nlist1(ibox) = nlist1(ibox) + 1
                     list1(nlist1(ibox),ibox) = jbox
                  else
c
cc                     boxes in list1 and list3 at level ilev+1
c
                     distest = 1.05d0*(boxsize(ilev)+boxsize(ilev+1))/
     1                         2.0d0*isep
                     do j=1,8
                        kbox = ichild(j,jbox)
                        if(kbox.gt.0) then
                           xdis = dabs(centers(1,kbox)-centers(1,ibox))
                           ydis = dabs(centers(2,kbox)-centers(2,ibox))
                           zdis = dabs(centers(3,kbox)-centers(3,ibox))

                           if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                        zdis.lt.distest) then
                              nlist1(ibox) = nlist1(ibox)+1
                              list1(nlist1(ibox),ibox) = kbox
                           else
                              nlist3(ibox) = nlist3(ibox)+1
                              list3(nlist3(ibox),ibox) = kbox
                           endif
                        endif
                     enddo
                  endif
               enddo
c
cc               compute list1 at level ilev-1 
               do i=1,nnbors(dad)
                   jbox = nbors(i,dad)
                   if(nchild(jbox).eq.0) then
                      distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                         2.0d0*isep
                      xdis = dabs(centers(1,jbox)-centers(1,ibox))
                      ydis = dabs(centers(2,jbox)-centers(2,ibox))
                      zdis = dabs(centers(3,jbox)-centers(3,ibox))
                      if(xdis.lt.distest.and.ydis.lt.distest.and.
     1                  zdis.lt.distest) then
                         nlist1(ibox) = nlist1(ibox)+1
                         list1(nlist1(ibox),ibox) = jbox
                      endif
                   endif
                enddo
            endif
c
cc           compute list 4 at level ilev-1
c
            do i=1,nnbors(dad)
               jbox = nbors(i,dad)
               if(nchild(jbox).eq.0) then
                   distest = 1.05d0*(boxsize(ilev)+boxsize(ilev-1))/
     1                 2.0d0*isep
                    xdis = dabs(centers(1,jbox)-centers(1,ibox))
                    ydis = dabs(centers(2,jbox)-centers(2,ibox))
                    zdis = dabs(centers(3,jbox)-centers(3,ibox))
                    if(xdis.gt.distest.or.ydis.gt.distest.or.
     1                 zdis.gt.distest) then
                       nlist4(ibox) = nlist4(ibox)+1
                       list4(nlist4(ibox),ibox)=jbox
                    endif
               endif
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      return
      end
c----------------------------------------------------------------

      subroutine getpwlistall(ibox,bs,nboxes,nnbors,nbors,
     1           nchild,ichild,centers,isep,nuall,uall,ndall,dall,nnall,
     2           nall,nsall,sall,neall,eall,nwall,wall,nu1234,u1234,
     3           nd5678,d5678,nn1256,n1256,ns3478,s3478,ne1357,e1357,
     4           nw2468,w2468,nn12,n12,nn56,n56,ns34,s34,ns78,s78,ne13,
     5           e13,ne57,e57,nw24,w24,nw68,w68,ne1,e1,ne3,e3,ne5,e5,
     6           ne7,e7,nw2,w2,nw4,w4,nw6,w6,nw8,w8)
c-------------------------------------------------------------------
      implicit none
      integer *8 ibox
      double precision boxsize,bs
      integer *8 nboxes,nnbors,nbors(nnbors)
      integer *8 nchild, ichild(8,nboxes)
      double precision centers(3,nboxes)
      integer *8 isep
      integer *8 nuall,ndall,nnall,nsall,neall,nwall,nu1234
      integer *8 nd5678,nn1256,ns3478,ne1357,nw2468
      integer *8 nn12,nn56,ns34,ns78,ne13,ne57,nw24,nw68
      integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8
      integer *8 uall(1),dall(1),nall(1),sall(1),eall(1),wall(1)
      integer *8 u1234(1),d5678(1),n1256(1),s3478(1),e1357(1),w2468(1)
      integer *8 n12(1),n56(1),s34(1),s78(1),e13(1),e57(1),w24(1),w68(1)
      integer *8 e1(1),e3(1),e5(1),e7(1)
      integer *8 w2(1),w4(1),w6(1),w8(1)

      integer *8 jbox,kbox
      integer *8 c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c16
      integer *8 i,j

      nuall = 0
      ndall = 0
      nnall = 0
      nsall = 0
      neall = 0
      nwall = 0
      nu1234 = 0
      nd5678 = 0
      nn1256 = 0
      ns3478 = 0
      ne1357 = 0
      nw2468 = 0
      nn12 = 0
      nn56 = 0
      ns34 = 0
      ns78 = 0
      ne13 = 0
      ne57 = 0
      nw24 = 0
      nw68 = 0
      ne1 = 0
      ne3 = 0
      ne5 = 0
      ne7 = 0
      nw2 = 0
      nw4 = 0
      nw6 = 0
      nw8 = 0
      do i=1,nnbors
         jbox = nbors(i)
         do j=1,8
            kbox = ichild(j,jbox)
            if(kbox.gt.0) then
               c1 = 0
               c2 = 0
               c3 = 0
               c4 = 0
               c5 = 0
               c6 = 0
               c7 = 0
               c8 = 0
               c9 = 0
               c10 = 0
               c11 = 0
               c12 = 0
               if((centers(3,kbox)-centers(3,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c1 = 1
               if((centers(3,kbox)-centers(3,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c2 = 1
               if((centers(2,kbox)-centers(2,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c3 = 1
               if((centers(2,kbox)-centers(2,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c4 = 1
               if((centers(1,kbox)-centers(1,ibox)).ge.
     1              1.01d0*isep*bs+bs/2.0d0) c5 = 1
               if((centers(1,kbox)-centers(1,ibox)).le.
     1              -1.01d0*isep*bs-bs/2.0d0) c6 = 1
               if((centers(3,kbox)-centers(3,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c7 = 1
               if((centers(3,kbox)-centers(3,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c8 = 1
               if((centers(2,kbox)-centers(2,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c9 = 1
               if((centers(2,kbox)-centers(2,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c10 = 1
               if((centers(1,kbox)-centers(1,ibox)).ge.
     1              1.01d0*isep*bs-bs/2.0d0) c11 = 1
               if((centers(1,kbox)-centers(1,ibox)).le.
     1              -1.01d0*isep*bs+bs/2.0d0) c12 = 1
               if(c1.eq.1) then
                  nuall = nuall + 1
                  uall(nuall) = kbox
               endif

               if(c2.eq.1) then
                  ndall = ndall + 1
                  dall(ndall) = kbox
               endif

               if(c3.eq.1.and.c1.eq.0.and.c2.eq.0) then
                  nnall = nnall + 1
                  nall(nnall) = kbox
               endif

               if(c4.eq.1.and.c1.eq.0.and.c2.eq.0) then   
                  nsall = nsall + 1
                  sall(nsall) = kbox
               endif

               if(c5.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1             c4.eq.0) then
                  neall = neall + 1
                  eall(neall) = kbox
               endif

               if(c6.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1            c4.eq.0) then
                  nwall = nwall + 1
                  wall(nwall) = kbox
               endif

               c16 = c1 + c2 + c3 + c4 + c5 +c6
               if(c16.eq.0.and.c7.eq.1) then
                  nu1234 = nu1234 + 1
                  u1234(nu1234) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1) then
                  nd5678 = nd5678 + 1
                  d5678(nd5678) = kbox
               endif

               if(c16.eq.0.and.c9.eq.1.and.c7.eq.0.and.c8.eq.0) then
                  nn1256 = nn1256 + 1
                  n1256(nn1256) = kbox
               endif

               if(c16.eq.0.and.c10.eq.1.and.c7.eq.0.and.c8.eq.0) then
                  ns3478 = ns3478 + 1
                  s3478(ns3478) = kbox
               endif

               if(c16.eq.0.and.c11.eq.1.and.(c7+c8+c9+c10).eq.0) then
                  ne1357 = ne1357 + 1
                  e1357(ne1357) = kbox
               endif

               if(c16.eq.0.and.c12.eq.1.and.(c7+c8+c9+c10).eq.0) then
                  nw2468 = nw2468 + 1
                  w2468(nw2468) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c9.eq.1) then
                  nn12 = nn12 + 1
                  n12(nn12) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c9.eq.1) then
                  nn56 = nn56 + 1
                  n56(nn56) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c10.eq.1) then
                  ns34 = ns34 + 1
                  s34(ns34) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c10.eq.1) then
                  ns78 = ns78 + 1
                  s78(ns78) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c11.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  ne13 = ne13 + 1
                  e13(ne13) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c11.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  ne57 = ne57 + 1
                  e57(ne57) = kbox
               endif

               if(c16.eq.0.and.c8.eq.1.and.c12.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  nw24 = nw24 + 1
                  w24(nw24) = kbox
               endif

               if(c16.eq.0.and.c7.eq.1.and.c12.eq.1
     1           .and.c9.eq.0.and.c10.eq.0) then
                  nw68 = nw68 + 1
                  w68(nw68) = kbox
               endif

               if(c16.eq.0.and.c7.eq.0.and.c10.eq.1.and.c11.eq.1) then
                  ne1 = ne1 + 1
                  e1(ne1) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c9.eq.1.and.c11.eq.1) then
                  ne3 = ne3 + 1
                  e3(ne3) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c10.eq.1.and.c11.eq.1) then
                  ne5 = ne5 + 1
                  e5(ne5) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c9.eq.1.and.c11.eq.1) then
                  ne7 = ne7 + 1
                  e7(ne7) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c10.eq.1.and.c12.eq.1) then
                  nw2 = nw2 + 1
                  w2(nw2) = kbox
               endif
               if(c16.eq.0.and.c7.eq.0.and.c9.eq.1.and.c12.eq.1) then
                  nw4 = nw4 + 1
                  w4(nw4) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c10.eq.1.and.c12.eq.1) then
                  nw6 = nw6 + 1
                  w6(nw6) = kbox
               endif
               if(c16.eq.0.and.c8.eq.0.and.c9.eq.1.and.c12.eq.1) then
                  nw8 = nw8 + 1
                  w8(nw8) = kbox
               endif
            endif
         enddo
      enddo
      

      return
      end
c--------------------------------------------------------------------      

      subroutine getlist3pwlistall(ibox,bs,nboxes,nlist3,list3,
     1           isep,centers,nuall,uall,ndall,dall,nnall,
     2           nall,nsall,sall,neall,eall,nwall,wall)
c-------------------------------------------------------------------
      implicit none
      integer *8 ibox
      integer *8 isep
      integer *8 nboxes,nlist3,list3(nlist3)
      double precision centers(3,nboxes)
      double precision sepdist,bs
      integer *8 nuall,ndall,nnall,nsall,neall,nwall
      integer *8 uall(1),dall(1),nall(1),sall(1),eall(1),wall(1)

      integer *8 jbox
      integer *8 c1,c2,c3,c4,c5,c6
      integer *8 j

      nuall = 0
      ndall = 0
      nnall = 0
      nsall = 0
      neall = 0
      nwall = 0
      sepdist = 1.01d0*isep*bs+bs/2.0d0
      do j=1,nlist3
         jbox = list3(j)
C         print *,"jbox: ",jbox
         if(jbox.gt.0) then
            c1 = 0
            c2 = 0
            c3 = 0
            c4 = 0
            c5 = 0
            c6 = 0
            if((centers(3,jbox)-centers(3,ibox)).ge.sepdist) c1 = 1
            if((centers(3,jbox)-centers(3,ibox)).le.-sepdist) c2 = 1
            if((centers(2,jbox)-centers(2,ibox)).ge.sepdist) c3 = 1
            if((centers(2,jbox)-centers(2,ibox)).le.-sepdist) c4 = 1
            if((centers(1,jbox)-centers(1,ibox)).ge.sepdist) c5 = 1
            if((centers(1,jbox)-centers(1,ibox)).le.-sepdist) c6 = 1

C            print *,c1,c2,c3,c4,c5,c6

            if(c1.eq.1) then
               nuall = nuall + 1
               uall(nuall) = jbox
            endif

            if(c2.eq.1) then
               ndall = ndall + 1
               dall(ndall) = jbox
            endif

            if(c3.eq.1.and.c1.eq.0.and.c2.eq.0) then
               nnall = nnall + 1
               nall(nnall) = jbox
            endif

            if(c4.eq.1.and.c1.eq.0.and.c2.eq.0) then   
               nsall = nsall + 1
               sall(nsall) = jbox
            endif

            if(c5.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1         c4.eq.0) then
               neall = neall + 1
               eall(neall) = jbox
            endif

            if(c6.eq.1.and.c1.eq.0.and.c2.eq.0.and.c3.eq.0.and.
     1         c4.eq.0) then
               nwall = nwall + 1
               wall(nwall) = jbox
            endif
         endif
      enddo
      

      return
      end
c
c
c
c
c--------------------------------------------------------------
c
      subroutine subdividebox(pos,npts,center,boxsize,
     1           isorted,iboxfl,subcenters)
      implicit none
      double precision pos(3,npts)
      double precision center(3)
      double precision subcenters(3,8)
      double precision boxsize
      integer *8 npts
      integer *8 isorted(*)
      integer *8 iboxfl(2,8)

c     Temporary variables
      integer *8 isortedtmp(npts)
      integer *8 i,j,i12,i34,istart,jstart,kstart,ii,iii,nss,nee
      integer *8 jj,irefinebox,ntt
      integer *8 i56, i78, i1234, i5678
      integer *8 ibox,ifirstbox,ilastbox,nbfirst
      integer *8 is,it,ie
      integer *8 nc(8)

      i1234 = 0
      i5678 = 0
      do i = 1,npts
         if(pos(3,i)-center(3).lt.0) then
            i1234 = i1234 + 1
            isorted(i1234) = i
         else
            i5678 = i5678 + 1
            isortedtmp(i5678) = i
         endif
      enddo
      do i=1,i5678
         isorted(i1234+i) = isortedtmp(i)
      enddo

c     Sort i1234 into i12 and i34         
      i12 = 0
      i34 = 0
      do i = 1,i1234
         if(pos(2,isorted(i))-center(2).lt.0) then
            i12 = i12 + 1
            isorted(i12) = isorted(i)
         else
            i34 = i34 + 1
            isortedtmp(i34) = isorted(i)
         endif
      enddo
c     Note at the end of the loop, i12 is where the particles
c     in part 12 of the box end
c
c     Reorder sources to include 34 in the array
      do i=1,i34
         isorted(i12+i) = isortedtmp(i)
      enddo

c     sort i5678 into i56 and i78
      i56 = i1234
      i78 = 0
      do i=i1234+1,npts
         if(pos(2,isorted(i))-center(2).lt.0) then
            i56 = i56 + 1
            isorted(i56) = isorted(i)
         else
            i78 = i78 + 1
            isortedtmp(i78) = isorted(i)
         endif
      enddo
c     Reorder sources to include 78 in the array
      do i=1,i78
         isorted(i56+i) = isortedtmp(i)
      enddo
c     End of reordering i5678         

      nc = 0
c     Sort into boxes 1 and 2
      do i = 1,i12
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(1) = nc(1) + 1
            isorted(nc(1)) = isorted(i)
         else
            nc(2) = nc(2) + 1
            isortedtmp(nc(2)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 2 are at the
c     end of this part of the array
      do i=1,nc(2)
         isorted(nc(1)+i) = isortedtmp(i)
      enddo

c     Sort into boxes 3 and 4
      do i = i12+1, i1234
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(3) = nc(3) + 1
            isorted(i12+nc(3)) = isorted(i)
         else
            nc(4) = nc(4)+1
            isortedtmp(nc(4)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 4 are at the
c     end of this part of the array
      do i=1,nc(4)
         isorted(i12+nc(3)+i) = isortedtmp(i)
      enddo

c     Sort into boxes 5 and 6
      do i = i1234+1,i56
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(5) = nc(5) + 1
            isorted(i1234+nc(5)) = isorted(i)
         else
            nc(6) = nc(6) + 1
            isortedtmp(nc(6)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 6 are at the
c     end of this part of the array
      do i=1,nc(6)
         isorted(i1234+nc(5)+i) = isortedtmp(i)
      enddo
c     End of sorting sources into boxes 5 and 6

c     Sort into boxes 7 and 8
      do i=i56+1,npts
         if(pos(1,isorted(i))-center(1).lt.0) then
            nc(7) = nc(7) + 1
            isorted(i56+nc(7)) = isorted(i)
         else
            nc(8) = nc(8) + 1
            isortedtmp(nc(8)) = isorted(i)
         endif
      enddo
c     Reorder sources so that sources in 8 are at the
c     end of the array
      do i=1,nc(8)
         isorted(i56+nc(7)+i) = isortedtmp(i)
      enddo
      
      istart=1
      iboxfl=0
      subcenters=0.0d0
      do i=1,8
         ii = 2
         jj = 2
         if(i.eq.1.or.i.eq.2.or.i.eq.5.or.i.eq.6) ii = 1
         if(i.lt.5) jj = 1
         if(nc(i).gt.0) then
            subcenters(1,i) = center(1)+(-1)**i*boxsize/2.0d0
            subcenters(2,i) = center(2)+(-1)**ii*boxsize/2.0d0
            subcenters(3,i) = center(3)+(-1)**jj*boxsize/2.0d0

            iboxfl(1,i) = istart
            iboxfl(2,i) = istart+nc(i)-1

            istart = istart+nc(i)
          endif
      enddo

      return
      end
c------------------------------------------------------------------      
c--------------------------------------------------------------------     
c
c
c
c--------------------------------------------------------------------      

      subroutine getlist4pwdir(dir,censrc,centrg,boxsize)
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 dir
      double precision censrc(3)
      double precision centrg(3)
      double precision boxsize
ccc   scopded function variables
      double precision sepdist
      double precision ctmp(3)
      ctmp(1) = censrc(1)-0*boxsize/2.0d0
      ctmp(2) = censrc(2)-0*boxsize/2.0d0
      ctmp(3) = censrc(3)-0*boxsize/2.0d0

      sepdist=1.51d0*boxsize

      if(ctmp(3)-centrg(3).ge.sepdist) then
        dir=1
      else if(ctmp(3)-centrg(3).le.-sepdist) then
        dir=2
      else if(ctmp(2)-centrg(2).ge.sepdist) then
        dir=3
      else if(ctmp(2)-centrg(2).le.-sepdist) then
        dir=4
      else if(ctmp(1)-centrg(1).ge.sepdist) then
        dir=5
      else if(ctmp(1)-centrg(1).le.-sepdist) then
        dir=6
      else
        dir=0
      end if
C      dir=0

      return
      end
      
      subroutine getlist4pwdirtest(dir,censrc,centrg,boxsize)
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 dir
      double precision censrc(3)
      double precision centrg(3)
      double precision boxsize
ccc   scopded function variables
      double precision sepdist
      double precision ctmp(3)
      ctmp(1) = censrc(1)-0*boxsize/2.0d0
      ctmp(2) = censrc(2)-0*boxsize/2.0d0
      ctmp(3) = censrc(3)-0*boxsize/2.0d0

      sepdist=1.51d0*boxsize

      if((ctmp(3)-centrg(3)).ge.sepdist) then
        dir=1
      else if((ctmp(3)-centrg(3)).le.-sepdist) then
        dir=2
      else if((ctmp(2)-centrg(2)).ge.sepdist) then
        dir=3
      else if((ctmp(2)-centrg(2)).le.-sepdist) then
        dir=4
      else if((ctmp(1)-centrg(1)).ge.sepdist) then
        dir=5
      else if((ctmp(1)-centrg(1)).le.-sepdist) then
        dir=6
      else
        dir=0
        print *,"dir:",dir
      end if
C      dir=0

      return
      end

      implicit none
      integer ns
      double precision, allocatable :: source(:,:)
      double complex, allocatable :: charge(:)
      double complex, allocatable :: pot(:)
      double complex, allocatable :: potex(:)

      double precision eps
      double complex eye,zk
      integer i,j,k
      integer ntest,nd
      double precision thresh,ra,erra
      double precision hkrand
      

      data eye/(0.0d0,1.0d0)/

c
cc      initialize printing routine
c
cc      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      print *, "This code is an example fortran driver*"
      write(*,*)
      write(*,*)


      zk = 2.2d0

      ns = 300 000 000   
      print *, "nsources =",ns
      

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(pot(ns))


      eps = 0.5d-3

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources uniformly in the unit cube 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        charge(i) = hkrand(0) + eye*hkrand(0)

        pot(i) = 0
      enddo


      call hfmm3d_s_c_p(eps,zk,ns,source,charge,pot)


      ntest = 10
      allocate(potex(ntest))
      do i=1,ntest 
        potex(i) = 0
      enddo

      thresh = 1.0d-16
      nd = 1
      
      call h3ddirectcp(nd,zk,source,charge,ns,source,ntest,potex,
     1   thresh)
      
      ra = 0
      erra = 0
      do i=1,ntest
        ra = ra + abs(potex(i))**2
        erra = erra + abs(pot(i)-potex(i))**2
      enddo

      erra = sqrt(erra/ra)
      print *, "Relative error in pot=",erra
      


      stop
      end
c----------------------------------------------------------
c
cc
c
c

c
c  This file contains the Laplace FMM wrappers
c
c  The laplace FMM evaluates the following potential
c  and its gradient
c    
c     u_{l}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{l,j}/|x-x_{j}| - 
c         1/(4\pi) v_{l,j}.\nabla (1/|x-x_{j}|)
c
c  Here x_{j} are the source locations, c_{l,j} are the charge strengths,
c  v_{l,j} are the dipole strengths. We refer to the collection of 
c  $x$ at which the potential and its gradient are evaluated as the
c  evaluation points
c
c  This file contains the wrappers to the vectorized routines
c
c  The subroutine names take the following form:
c    lfmm3d_<eval-pts>_<int-ker>_<out>_vec
c
c      <eval-pts>: evaluation points (sources/targets/sources+targets)
c        s: source locations
c        t: target locations
c        st: source and target locations
c
c      <int-ker>: kernel of interaction (charges/dipoles/both)
c        c: charges
c        d: dipoles
c        cd: charges+dipoles
c 
c      <out>: flag for potential/potential+gradient
c        p: potentials
c        g: potentials+gradients
c
c  The wrappers are:
c
c
c  -lfmm3d_s_c_p_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_s_c_g_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_s_c_h_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_s_d_p_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_s_d_g_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_s_d_h_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_s_cd_p_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_s_cd_g_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_s_cd_h_vec
c    - Evaluation points: Sources
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_t_c_p_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_t_c_g_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_t_c_h_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_t_d_p_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_t_d_g_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_t_d_h_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_t_cd_p_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_t_cd_g_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_t_cd_h_vec
c    - Evaluation points: Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_st_c_p_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_st_c_g_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_st_c_h_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_st_d_p_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_st_d_g_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_st_d_h_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c  -lfmm3d_st_cd_p_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential
c-------------------------------------
c  -lfmm3d_st_cd_g_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential and Gradient
c-------------------------------------
c  -lfmm3d_st_cd_h_vec
c    - Evaluation points: Sources and Targets
c    - Interaction kernel: Charges and Dipoles
c    - Outputs requested: Potential, Gradient and Hessians
c-------------------------------------
c

      subroutine lfmm3d_s_c_p_vec(nd,eps,nsource,source,
     1    charge,pot,ier)
      implicit none
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c

      double precision eps
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource)

      double precision pottarg(nd,1)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)


      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_c_g_vec(nd,eps,nsource,source,
     1    charge,pot,grad,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hess(nd,6),hesstarg(nd,6)

      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0

      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_s_c_h_vec(nd,eps,nsource,source,
     1    charge,pot,grad,hess,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision hess(nd,6,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hesstarg(nd,6)

      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0

      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_s_d_p_vec(nd,eps,nsource,source,
     1    dipvec,pot,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource)
      double precision pottarg(nd,1)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0


      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_d_g_vec(nd,eps,nsource,source,
     1    dipvec,pot,grad,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hess(nd,6),hesstarg(nd,6)

      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_d_h_vec(nd,eps,nsource,source,
     1    dipvec,pot,grad,hess,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient, and
c  its Hessians
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision hess(nd,6,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hesstarg(nd,6)

      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_cd_p_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource)
      double precision pottarg(nd,1)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c
c
c
c
c

      subroutine lfmm3d_s_cd_g_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,grad,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c
c

      subroutine lfmm3d_s_cd_h_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,grad,hess,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient, and 
c  its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision hess(nd,6,nsource)
      double precision pottarg(nd,1),gradtarg(nd,3,1)

      double precision hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_c_p_vec(nd,eps,nsource,source,
     1    charge,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,1)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_c_g_vec(nd,eps,nsource,source,
     1    charge,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_c_h_vec(nd,eps,nsource,source,
     1    charge,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient, and
c  its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)
      double precision hesstarg(nd,6,ntarg)

      double precision hess(nd,6)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_t_d_p_vec(nd,eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_t_d_g_vec(nd,eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_d_h_vec(nd,eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)
      double precision hesstarg(nd,6,ntarg)

      double precision hess(nd,6)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_t_cd_p_vec(nd,eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_cd_g_vec(nd,eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_cd_h_vec(nd,eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,1),grad(nd,3,1)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)
      double precision hesstarg(nd,6,ntarg)

      double precision hess(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c

      subroutine lfmm3d_st_c_p_vec(nd,eps,nsource,source,
     1    charge,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 1
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_c_g_vec(nd,eps,nsource,source,
     1    charge,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 2
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c
c

      subroutine lfmm3d_st_c_h_vec(nd,eps,nsource,source,
     1    charge,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,1)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6,nsource),hesstarg(nd,6,ntarg)

      
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 3
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_d_p_vec(nd,eps,nsource,source,
     1    dipvec,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_d_g_vec(nd,eps,nsource,source,
     1    dipvec,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_d_h_vec(nd,eps,nsource,source,
     1    dipvec,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = -\sum_{j=1}^{N} 1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps
      
      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,1)
      
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6,nsource),hesstarg(nd,6,ntarg)

      
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_cd_p_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource)
      double precision pottarg(nd,ntarg)

      double precision grad(nd,3),gradtarg(nd,3)
      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 1

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_cd_g_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
cc    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6),hesstarg(nd,6)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 2

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_cd_h_vec(nd,eps,nsource,source,
     1    charge,dipvec,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) nd,eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u_{\ell}(x) = \sum_{j=1}^{N} 1/(4\pi) c_{\ell,j} \frac{1}{\|x-x_{j}\|} - 
c            1/(4\pi) v_{\ell,j} \cdot \nabla \left( 
c        \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    nd: integer *8
c          number of densities
c    -    eps: double precision
c          precision requested
c    -    nsource: integer *8
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nd,nsource)
c          Charge strengths, $c_{\ell,j}$
c    -    dipvec: double precision(nd,3,nsource)
c          Dipole strengths, $v_{\ell,j}$
c    -    ntarg: integer *8
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c
c    -    pot: double precision(nd,nsource)
c          Potential at source locations, $u_{\ell}(x_{j})$
c    -    grad: double precision(nd,3,nsource)
c          Gradient at source locations, $\nabla u_{\ell}(x_{j})$
c    -    hess: double precision(nd,6,nsource)
c          Hessian at source locations, $\nabla^2 u_{\ell}(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(nd,ntarg)
c          Potential at target locations, $u_{\ell}(t_{i})$
c    -    gradtarg: double precision(nd,3,ntarg)
c          Gradient at target locations, $\nabla u_{\ell}(t_{i})$
c    -    hesstarg: double precision(nd,6,ntarg)
c          Hessian at target locations, $\nabla^2 u_{\ell}(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer *8
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c--------------------------------
c
      implicit none
      double precision eps

      integer *8 nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer *8 nd,iper,ier
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nd,nsource)
      double precision dipvec(nd,3,nsource)

      double precision pot(nd,nsource),grad(nd,3,nsource)
      double precision pottarg(nd,ntarg),gradtarg(nd,3,ntarg)

      double precision hess(nd,6,nsource),hesstarg(nd,6,ntarg)

      
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 3

      ier = 0
      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

c
c     ROTATION VIA RECURSION  
c     good up to order 100 or so.
c
c     Multipole expansions for complex-valued functions.
c
c       rotviarecur is the user callable routine 
c
c       rotviarecur3p_init  - precompute the coefficients of rotation matrix.
c       rotviarecur3p_apply - apply the rotation matrix.
c
c
c
C*****************************************************************
        subroutine rotviarecur(nd,theta,nterms,m1,m2,mpole,ld1,
     1                         marray,ld2)
C*****************************************************************
c
c       Purpose:
c
c	Fast, recursive method for applying rotation matrix about
c	the y-axis determined by angle theta.
c       The rotation matrices for each order (first index) are computed
c       from the lowest to the highest. As each one is generated, it
c       is applied to the input expansion "mpole" and overwritten.
c
c       As a result, it is sufficient to use two arrays rd1 and rd2 for
c       the two term recurrence, rather than storing them for all orders
c       as in the original code. There is some loss in speed
c       if the rotation operator is to be used multiple times, but the 
c       memory savings is often more critical.
c
c       Note that this is just a driver to rotviarecur3s and
c       rotviarecur3t routines, the main purpose of this routine is to
c       have the calling sequence compatible with rotproj.
c
C---------------------------------------------------------------------
c       INPUT:
c
c       nd:     number of multipole expansions
c       theta:  the rotation angle about the y-axis.
c       nterms: order of multipole expansion
c
c       m1    :  max m index for first expansion  
c       m2    :  max m index for second expansion 
C       mpole :  coefficients of original multiple expansion
C       ld1   :  leading dim for mpole (must exceed nterms)
C       ld2   :  leading dim for marray (must exceed nterms)
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       marray   coefficients of rotated expansion.
c       lused    amount of workspace used.
c
C---------------------------------------------------------------------
        implicit none
        integer *8 ld1,ld2,nterms,m1,m2,nd
        integer *8 ldc,ird1,lrd,ird2,isqc,lused,ier
        double precision theta
        double precision, allocatable :: w(:)
        double complex mpole(nd,0:ld1,-ld1:ld1)
        double complex marray(nd,0:ld2,-ld2:ld2)
c
        ldc = nterms
        ird1 = 1
        lrd  = (ldc+1)*(2*ldc+1) + 3
        ird2 = ird1 + lrd
        isqc = ird2 + lrd
        lused = isqc + 2*(2*ldc+1) 
        allocate (w(lused), stat=ier)
        if( ier.ne.0 ) return
c
        if( m1 .lt. nterms .or. m2 .lt. nterms ) then
        call rotviarecur_t(nd,nterms,m1,m2,mpole,ld1,marray,
     1                    ld2,w(ird1),w(ird2),w(isqc),theta,ldc)
        else
        call rotviarecur_s(nd,nterms,m1,m2,mpole,ld1,marray,
     1                    ld2,w(ird1),w(ird2),w(isqc),theta,ldc)
        endif
c
        return
        end
c        
c
c
c
C*****************************************************************
        subroutine rotviarecurp_init(ier,rotmat,ldc,theta)
C*****************************************************************
c
c       Purpose:
c
c       Precompute the coefficients of rotation matrix. 
c
c       Use symmetry properties of rotation matrices. Fortran 90 code.
c
C---------------------------------------------------------------------
c       INPUT:
c
c       theta:  the rotate angle about the y-axis.
c       ldc     dimensions of rotation matrix array
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       ier: error return code
c       rotmat: coefficients of rotation matrix
c
C---------------------------------------------------------------------
      implicit none
      integer *8 ld1,ld2,nterms,m1,m2,ldc
      integer *8 ier,ij,im,imp,m,mp
      double precision theta
      double precision ww,done,ctheta,stheta,hsthta,cthtap,cthtan,d
      double precision precis,scale
      double precision rotmat(0:ldc,0:ldc,-ldc:ldc)
c
      double precision, allocatable :: rd1(:,:)
      double precision, allocatable :: rd2(:,:)
      double precision, allocatable :: sqc(:,:)
c
      data precis/1.0d-20/
c
      allocate (rd1(0:ldc,-ldc:ldc),stat=ier)
          if(ier .ne. 0 ) return
      allocate (rd2(0:ldc,-ldc:ldc),stat=ier)
         if(ier .ne. 0 ) return
      allocate (sqc(0:2*ldc,2),stat=ier)
        if(ier .ne. 0 ) return
c
      ww=1/sqrt(2.0d0)
      do m = 0, 2*ldc 
	    sqc(m,1) = dsqrt(m+0.0d0)
      enddo
      sqc(0,2) = 0.0d0
      if( ldc .gt. 0 ) sqc(1,2) = 0.0d0
      do m = 2, 2*ldc 
	    sqc(m,2) = dsqrt((m+0.0d0)*(m-1)/2.0d0)
      enddo
c
      done=1
      ctheta=dcos(theta)
      if (dabs(ctheta).le.precis) ctheta=0.0d0
      stheta=dsin(-theta)
      if (dabs(stheta).le.precis) stheta=0.0d0
      hsthta=ww*stheta
      cthtap=+2.0d0*ww*dcos(theta/2.0d0)**2
      cthtan=-2.0d0*ww*dsin(theta/2.0d0)**2
c
c     Compute the (0,0,0) term.
c
      rd1(0,0)=done
      rotmat(0,0,0)=rd1(0,0)
c
c ... Loop over first index ij=1,nterms, constructing
c     rotation matrices recursively.
c
      nterms=ldc
      do ij=1,nterms
c
c     For mprime=0, use formula (1).
c
        do im=-ij,-1
	      rd2(0,im)=-sqc(ij-im,2)*rd1(0,im+1)
	      if (im.gt.(1-ij)) then
            rd2(0,im)=rd2(0,im)+sqc(ij+im,2)*rd1(0,im-1)
	      endif
	      rd2(0,im)=rd2(0,im)*hsthta
	      if (im.gt.-ij) then
	        rd2(0,im)=rd2(0,im)+
     1        rd1(0,im)*ctheta*sqc(ij+im,1)*sqc(ij-im,1)
	      endif
          rd2(0,im)=rd2(0,im)/ij
        enddo
c
        rd2(0,0)=rd1(0,0)*ctheta
        if (ij.gt.1) then
          rd2(0,0)=rd2(0,0)+hsthta*sqc(ij,2)*(2*rd1(0,-1))/ij
	    endif
c         
        do im=1,ij
	      rd2(0,im)=rd2(0,-im)
          if( mod(im,2) .eq. 0 ) then
            rd2(im,0)=+rd2(0,im)
          else
            rd2(im,0)=-rd2(0,im)
          endif
        enddo
c
c        For 0<mprime<=j (2nd index) case, use formula (2).
c
        do imp=1,ij
c
          scale=(ww/sqc(ij+imp,2))
          do im=imp,ij
            rd2(imp,+im)=rd1(imp-1,+im-1)*(cthtap*sqc(ij+im,2))
            rd2(imp,-im)=rd1(imp-1,-im+1)*(cthtan*sqc(ij+im,2))
c
            if (im.lt.(ij-1)) then
              rd2(imp,+im)=rd2(imp,+im)-rd1(imp-1,+im+1)*
     $               (cthtan*sqc(ij-im,2))
              rd2(imp,-im)=rd2(imp,-im)-rd1(imp-1,-im-1)*
     $               (cthtap*sqc(ij-im,2))
            endif
c
            if (im.lt.ij) then
              d=(stheta*sqc(ij+im,1)*sqc(ij-im,1))
	          rd2(imp,+im)=rd2(imp,+im)+rd1(imp-1,+im)*d
	          rd2(imp,-im)=rd2(imp,-im)+rd1(imp-1,-im)*d
            endif
c
            rd2(imp,+im)=rd2(imp,+im)*scale
            rd2(imp,-im)=rd2(imp,-im)*scale
c
            if (im.gt.imp) then
              if( mod(imp+im,2) .eq. 0 ) then
                rd2(im,+imp)=+rd2(imp,+im)
                rd2(im,-imp)=+rd2(imp,-im)
              else
                rd2(im,+imp)=-rd2(imp,+im)
                rd2(im,-imp)=-rd2(imp,-im)
              endif
            endif
c
          enddo
c
        enddo
c
        do m=-ij,ij
          do mp=0,ij
            rd1(mp,m) = rd2(mp,m)
            rotmat(mp,ij,m) = rd2(mp,m)
          enddo
        enddo
c
      enddo
      return
      end
c
c
C*****************************************************************
        subroutine rotviarecurp_apply
     $     (theta,nterms,m1,m2,mpole,ld1,marray,ld2,rotmat,ldc)
C*****************************************************************
c
c       Purpose:
c
c	Fast, recursive method for applying rotation matrix about
c	the y-axis determined by angle theta.
c
C---------------------------------------------------------------------
c       INPUT:
c
c       theta:  the rotation angle about the y-axis.
c       nterms: order of multipole expansion
c
c       m1    :  max m index for first expansion  
c       m2    :  max m index for second expansion 
C       mpole :  coefficients of original multiple expansion
C       ld1   :  leading dim for mpole (must exceed nterms)
C       ld2   :  leading dim for marray (must exceed nterms)
c       rotmat:  double precision (0:ldc,0:ldc,-ldc:ldc): rotation matrix 
c       ldc   :  leading dim for rotation matrix (must exceed nterms)
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       marray   coefficients of rotated expansion.
c
C---------------------------------------------------------------------
      implicit none
      integer *8 nterms,m1,m2,ld1,ld2,ldc
      integer *8 ij,m,mp
      double precision theta
      double complex mpole(0:ld1,-ld1:ld1)
      double complex marray(0:ld2,-ld2:ld2)
      double precision rotmat(0:ldc,0:ldc,-ldc:ldc)
c
      if (m1.lt.nterms .or. m2.lt.nterms) then
c
c       ... truncate multipole expansions
c
        do ij=0,nterms
          do m=-ij,ij
            marray(ij,m)=0
          enddo
c
          do m=-min(ij,m2),min(ij,m2)
            marray(ij,m)=mpole(ij,0)*rotmat(0,ij,m) 
            do mp=1,min(ij,m1)
              marray(ij,m)=marray(ij,m)+
     1	            mpole(ij,mp)*rotmat(mp,ij,m)+
     1              mpole(ij,-mp)*rotmat(mp,ij,-m)
            enddo
          enddo
        enddo
      else
c
c       ... apply rotation matrix
c
        do ij=0,nterms
          do m=-ij,ij
            marray(ij,m)=mpole(ij,0)*rotmat(0,ij,m) 
            do mp=1,ij
              marray(ij,m)=marray(ij,m)+
     1	            mpole(ij,mp)*rotmat(mp,ij,m)+
     1              mpole(ij,-mp)*rotmat(mp,ij,-m)
            enddo
          enddo
        enddo
      endif

      return
      end
c        
c
c
c
c
C*****************************************************************
        subroutine rotviarecur_t(nd,nterms,m1,m2,mpole,ld1,marray,
     1                         ld2,rd1,rd2,sqc,theta,ldc)
C*****************************************************************
c
c       Purpose:
c
c	Fast, recursive method for applying rotation matrix about
c	the y-axis determined by angle theta.
c       The rotation matrices for each order (first index) are computed
c       from the lowest to the highest. As each one is generated, it
c       is applied to the input expansion "mpole" and overwritten.
c
c       As a result, it is sufficient to use two arrays rd1 and rd2 for
c       the two term recurrence, rather than storing them for all orders
c       as in the original code. There is some loss in speed
c       if the rotation operator is to be used multiple times, but the 
c       memory savings is often more critical.
c
c       Use symmetry properties of rotation matrices
c
C---------------------------------------------------------------------
c       INPUT:
c
c       nd    : number of multipole expansions
c       nterms: dimension parameter for d - the rotation matrix.
c       m1    : max m index for first expansion. 
c       m2    : max m index for second expansion.
C       mpole   coefficients of original multiple expansion
C       rd1     work space 
C       rd2     work space
c       sqc:    an array contains the square roots of the
c               binomial coefficients.
c       theta:  the rotate angle about the y-axis.
c       ldc     dimensions of sqc array
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       marray  coefficients of rotated expansion.
c
C---------------------------------------------------------------------
      implicit none
      integer *8 ld1,ld2,nterms,m1,m2,ldc,nd,idim
      integer *8 ij,im,imp,m,mp
      double precision theta
      double precision rd1(0:ldc,-ldc:ldc)
      double precision rd2(0:ldc,-ldc:ldc)
      double precision sqc(0:2*ldc,2)
      double precision ww,done,ctheta,stheta,hsthta,cthtap,cthtan,d
      double precision precis,scale
      double complex mpole(nd,0:ld1,-ld1:ld1)
      double complex marray(nd,0:ld2,-ld2:ld2)
c
      data precis/1.0d-20/
c
      ww=1/sqrt(2.0d0)
      do m = 0, 2*ldc 
	    sqc(m,1) = dsqrt(m+0.0d0)
      enddo
      sqc(0,2) = 0.0d0
      if( ldc .gt. 0 ) sqc(1,2) = 0.0d0
      do m = 2, 2*ldc 
	    sqc(m,2) = dsqrt((m+0.0d0)*(m-1)/2.0d0)
      enddo
c
      done=1
      ctheta=dcos(theta)
      if (dabs(ctheta).le.precis) ctheta=0.0d0
      stheta=dsin(-theta)
      if (dabs(stheta).le.precis) stheta=0.0d0
      hsthta=ww*stheta
      cthtap=+2.0d0*ww*dcos(theta/2.0d0)**2
      cthtan=-2.0d0*ww*dsin(theta/2.0d0)**2
c
c     Compute the (0,0,0) term.
c
      rd1(0,0)=done
      
      do idim=1,nd
         marray(idim,0,0)=mpole(idim,0,0)*rd1(0,0)
      enddo
c
c ... Loop over first index ij=1,nterms, constructing
c     rotation matrices recursively.
c
      do ij=1,nterms
c
c     For mprime=0, use formula (1).
c
        do im=-ij,-1
	      rd2(0,im)=-sqc(ij-im,2)*rd1(0,im+1)
	      if (im.gt.(1-ij)) then
            rd2(0,im)=rd2(0,im)+sqc(ij+im,2)*rd1(0,im-1)
          endif
          rd2(0,im)=rd2(0,im)*hsthta
          if (im.gt.-ij) then
            rd2(0,im)=rd2(0,im)+
     1         rd1(0,im)*ctheta*sqc(ij+im,1)*sqc(ij-im,1)
          endif
          rd2(0,im)=rd2(0,im)/ij
        enddo
c
        rd2(0,0)=rd1(0,0)*ctheta
        if (ij.gt.1) then
          rd2(0,0)=rd2(0,0)+hsthta*sqc(ij,2)*(2*rd1(0,-1))/ij
        endif
c         
        do im=1,ij
          rd2(0,im)=rd2(0,-im)
          if( mod(im,2) .eq. 0 ) then
            rd2(im,0)=+rd2(0,im)
          else
            rd2(im,0)=-rd2(0,im)
          endif
        enddo
c
c        For 0<mprime<=j (2nd index) case, use formula (2).
c
        do imp=1,min(ij,min(m1,m2))         
c
          scale=(ww/sqc(ij+imp,2))
c
	      do im=imp,ij
            rd2(imp,+im)=rd1(imp-1,+im-1)*(cthtap*sqc(ij+im,2))
            rd2(imp,-im)=rd1(imp-1,-im+1)*(cthtan*sqc(ij+im,2))
c
            if (im.lt.(ij-1)) then
              rd2(imp,+im)=rd2(imp,+im)-rd1(imp-1,+im+1)*
     $               (cthtan*sqc(ij-im,2))
              rd2(imp,-im)=rd2(imp,-im)-rd1(imp-1,-im-1)*
     $               (cthtap*sqc(ij-im,2))
            endif
c
            if (im.lt.ij) then
              d=(stheta*sqc(ij+im,1)*sqc(ij-im,1))
              rd2(imp,+im)=rd2(imp,+im)+rd1(imp-1,+im)*d
              rd2(imp,-im)=rd2(imp,-im)+rd1(imp-1,-im)*d
            endif
c
            rd2(imp,+im)=rd2(imp,+im)*scale
            rd2(imp,-im)=rd2(imp,-im)*scale
c
            if (im.gt.imp) then
              if( mod(imp+im,2) .eq. 0 ) then
                rd2(im,+imp)=+rd2(imp,+im)
                rd2(im,-imp)=+rd2(imp,-im)
              else
                rd2(im,+imp)=-rd2(imp,+im)
                rd2(im,-imp)=-rd2(imp,-im)
              endif
            endif
c
          enddo
        enddo
c
        do m=-ij,ij
          do idim=1,nd
            marray(idim,ij,m)=0
          enddo
        enddo
c
        do m=-min(ij,m2),min(ij,m2)
          do idim=1,nd
            marray(idim,ij,m)=mpole(idim,ij,0)*rd2(0,m) 
          enddo
          do mp=1,min(ij,m1)
            do idim=1,nd
              marray(idim,ij,m)=marray(idim,ij,m)+
     1	            mpole(idim,ij,mp)*rd2(mp,m)+
     1              mpole(idim,ij,-mp)*rd2(mp,-m)
            enddo
          enddo
        enddo
c
        do m=-ij,ij
          do mp=0,min(ij,min(m1,m2))
  	        rd1(mp,m) = rd2(mp,m)
          enddo
        enddo
      enddo
      return
      end
c
c
C*****************************************************************
        subroutine rotviarecur_s(nd,nterms,m1,m2,mpole,ld1,marray,
     1                         ld2,rd1,rd2,sqc,theta,ldc)
C*****************************************************************
c
c       Purpose:
c
c	Fast, recursive method for applying rotation matrix about
c	the y-axis determined by angle theta.
c       The rotation matrices for each order (first index) are computed
c       from the lowest to the highest. As each one is generated, it
c       is applied to the input expansion "mpole" and overwritten.
c
c       As a result, it is sufficient to use two arrays rd1 and rd2 for
c       the two term recurrence, rather than storing them for all orders
c       as in the original code. There is some loss in speed
c       if the rotation operator is to be used multiple times, but the 
c       memory savings is often more critical.
c
c       Use symmetry properties of rotation matrices
c
c       Parameters m1 and m2 are NOT USED by this routine, use
c       rotviarecur3t instead
c
C---------------------------------------------------------------------
c       INPUT:
c
c       nd    : number of multipole expansions
c       nterms: dimension parameter for d - the rotation matrix.
c       m1    : max m index for first expansion. NOT USED in this routine
c       m2    : max m index for second expansion. NOT USED in this routine
C       mpole   coefficients of original multiple expansion
C       rd1     work space 
C       rd2     work space
c       sqc:    an array contains the square roots of the
c               binomial coefficients.
c       theta:  the rotate angle about the y-axis.
c       ldc     dimensions of sqc array
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       marray  coefficients of rotated expansion.
c
C---------------------------------------------------------------------
      implicit none
      integer *8 ld1,ld2,nterms,m1,m2,ldc,nd,idim
      integer *8 ij,im,imp,m,mp
      double precision theta
      double precision ww,done,ctheta,stheta,hsthta,cthtap,cthtan,d
      double precision precis,scale
      double precision rd1(0:ldc,-ldc:ldc)
      double precision rd2(0:ldc,-ldc:ldc)
      double precision sqc(0:2*ldc,2)
      double complex mpole(nd,0:ld1,-ld1:ld1)
      double complex marray(nd,0:ld2,-ld2:ld2)
c
      data precis/1.0d-20/
c
      ww=1/sqrt(2.0d0)
      do m = 0, 2*ldc 
	    sqc(m,1) = dsqrt(m+0.0d0)
      enddo
	  sqc(0,2) = 0.0d0
	  if( ldc .gt. 0 ) sqc(1,2) = 0.0d0
      do m = 2, 2*ldc 
	    sqc(m,2) = dsqrt((m+0.0d0)*(m-1)/2.0d0)
      enddo

      done=1
      ctheta=dcos(theta)
      if (dabs(ctheta).le.precis) ctheta=0.0d0
      stheta=dsin(-theta)
      if (dabs(stheta).le.precis) stheta=0.0d0
      hsthta=ww*stheta
      cthtap=+2.0d0*ww*dcos(theta/2.0d0)**2
      cthtan=-2.0d0*ww*dsin(theta/2.0d0)**2
c
c     Compute the (0,0,0) term.
c
      rd1(0,0)=done
      do idim=1,nd
        marray(idim,0,0)=mpole(idim,0,0)*rd1(0,0)
      enddo
c
c ... Loop over first index ij=1,nterms, constructing
c     rotation matrices recursively.
c
      do ij=1,nterms
c
c     For mprime=0, use formula (1).
c
        do im=-ij,-1
          rd2(0,im)=-sqc(ij-im,2)*rd1(0,im+1)
          if (im.gt.(1-ij)) then
	        rd2(0,im)=rd2(0,im)+sqc(ij+im,2)*rd1(0,im-1)
          endif
          rd2(0,im)=rd2(0,im)*hsthta
          if (im.gt.-ij) then
            rd2(0,im)=rd2(0,im)+
     1          rd1(0,im)*ctheta*sqc(ij+im,1)*sqc(ij-im,1)
          endif
          rd2(0,im)=rd2(0,im)/ij
        enddo
c
        rd2(0,0)=rd1(0,0)*ctheta
        if (ij.gt.1) then
          rd2(0,0)=rd2(0,0)+hsthta*sqc(ij,2)*(2*rd1(0,-1))/ij
        endif
c         
        do im=1,ij
          rd2(0,im)=rd2(0,-im)
          if( mod(im,2) .eq. 0 ) then
            rd2(im,0)=+rd2(0,im)
          else
            rd2(im,0)=-rd2(0,im)
          endif
        enddo
c
c        For 0<mprime<=j (2nd index) case, use formula (2).
c
        do imp=1,ij
          scale=(ww/sqc(ij+imp,2))
	      do im=imp,ij
c
            rd2(imp,+im)=rd1(imp-1,+im-1)*(cthtap*sqc(ij+im,2))
            rd2(imp,-im)=rd1(imp-1,-im+1)*(cthtan*sqc(ij+im,2))
c
            if (im.lt.(ij-1)) then
              rd2(imp,+im)=rd2(imp,+im)-rd1(imp-1,+im+1)*
     $               (cthtan*sqc(ij-im,2))
              rd2(imp,-im)=rd2(imp,-im)-rd1(imp-1,-im-1)*
     $               (cthtap*sqc(ij-im,2))
            endif
c
            if (im.lt.ij) then
              d=(stheta*sqc(ij+im,1)*sqc(ij-im,1))
	          rd2(imp,+im)=rd2(imp,+im)+rd1(imp-1,+im)*d
	          rd2(imp,-im)=rd2(imp,-im)+rd1(imp-1,-im)*d
            endif
c
            rd2(imp,+im)=rd2(imp,+im)*scale
            rd2(imp,-im)=rd2(imp,-im)*scale
c
            if (im.gt.imp) then
              if( mod(imp+im,2) .eq. 0 ) then
                rd2(im,+imp)=+rd2(imp,+im)
                rd2(im,-imp)=+rd2(imp,-im)
              else
                rd2(im,+imp)=-rd2(imp,+im)
                rd2(im,-imp)=-rd2(imp,-im)
              endif
            endif
          enddo
        enddo
c
        do m=-ij,ij
          do idim=1,nd
            marray(idim,ij,m)=mpole(idim,ij,0)*rd2(0,m)
          enddo
          do mp=1,ij   
            do idim=1,nd
              marray(idim,ij,m)=marray(idim,ij,m)+
     1	          mpole(idim,ij,mp)*rd2(mp,m)+
     1            mpole(idim,ij,-mp)*rd2(mp,-m)
            enddo
          enddo
        enddo
c
        do m=-ij,ij
          do mp=0,ij
            rd1(mp,m) = rd2(mp,m)
          enddo
        enddo
      enddo

      return
      end
c

c        routines for determining length of multipole and 
c         local expansions based on size of box in wavelengths
c
c-----------------------------------------------------------------------------
c
c      h3dterms - determine number of terms in mpole expansions for box
c           of size "size" with Helmholtz parameter zk.
c
c      h3dterms_list2 - build the number of terms table for all boxes 
c           in list 2
c
c-----------------------------------------------------------------------------
c
c
c
      subroutine h3dterms(size, zk, eps, nterms)
      implicit real *8 (a-h,o-z)
c
c     Determine number of terms in mpole expansions for box of size
c     "size" with Helmholtz parameter zk.
c
c     The method is based on examining the decay of h_n * j_n.
c
c     Maximum number of terms is 1000, which 
c     works for boxes up to 160 wavelengths in size     
c
c
c-----------------------------------------------------------------------------
c
      integer *8 nterms, ntmax, ifder
      complex *16  zk, z1, z2, z3, jfun(0:5000), ht0,
     1             ht1, ht2, fjder(0:1), ztmp,
     1             hfun(0:5000), fhder(0:1)
c
c
      z1 = (zk*size)*1.5d0
c
c       the code will run out memory if frequency is too small 
c       set frequency to something more reasonable, nterms is 
c       approximately the same for all small frequencies
c       
c
      ntmax = 5000
      ifder = 0
      rscale = 1.0d0
      if (cdabs(zk*size) .lt. 1.0d0) rscale = cdabs(zk*size)
      call h3dall(ntmax,z1,rscale,hfun,ifder,fhder)
      z2 = (zk*size) * dsqrt(3d0)/2.0d0

      call besseljs3d(ntmax, z2, rscale, jfun, ifder, fjder)

c
      xtemp1 = cdabs(jfun(0)*hfun(0))
      xtemp2 = cdabs(jfun(1)*hfun(1))
      xtemp0 = xtemp1+xtemp2


      nterms = 1
      do j = 2, ntmax
        xtemp1 = cdabs(jfun(j)*hfun(j))
        xtemp2 = cdabs(jfun(j-1)*hfun(j-1))
        xtemp = (xtemp1+xtemp2)*abs(hfun(0))*abs(zk)
        if(xtemp .lt. eps*xtemp0)then
          nterms = j + 1
          return
        endif
c
      enddo
c
c       ... computational box is too big, set nterms to 5000
c
        nterms=5000
c
      return
      end
c
c
c
c
c
      subroutine h3dterms_far(size, zk, eps, nterms)
      implicit real *8 (a-h,o-z)
c
c
c     Determine number of terms in mpole expansions for box of size
c     "size" with Helmholtz parameter zk. 
c
c     The method is based on examining the decay of h_n * j_n.
c
c     This routine assumes slightly larger separation of boxes: the
c     first unit box is located at the origin and the second box is
c     located at (3,0,0).
c
c     Maximum number of terms is 1000, which 
c     works for boxes up to 160 wavelengths in size     
c
c
c-----------------------------------------------------------------------------
c
      integer *8 nterms, ntmax, ifder
      complex *16  zk, z1, z2, z3, jfun(0:2000), ht0,
     1             ht1, ht2, fjder(0:1), ztmp,
     1             hfun(0:2000), fhder(0:1)
c
      z1 = (zk*size)*2.5d0
c
c       the code will run out memory if frequency is too small 
c       set frequency to something more reasonable, nterms is 
c       approximately the same for all small frequencies
c       
ccc        if( abs(z1) .lt. 1d-6 ) z1=1d-6
c
      ntmax = 1000
      ifder = 0
      rscale = 1.0d0
      if (cdabs(zk*size) .lt. 1.0d0) rscale = cdabs(zk*size)
      call h3dall(ntmax,z1,rscale,hfun,ifder,fhder)
      z2 = (zk*size) * dsqrt(3d0)/2.d0
c
      ier1 = 0
c
      call besseljs3d(ntmax, z2, rscale, jfun, ifder, fjder)
c
      xtemp1 = cdabs(jfun(0)*hfun(0))
      xtemp2 = cdabs(jfun(1)*hfun(1))
      xtemp0 = xtemp1+xtemp2
      nterms = 1
      do j = 2, ntmax
        xtemp1 = cdabs(jfun(j)*hfun(j))
        xtemp2 = cdabs(jfun(j-1)*hfun(j-1))
        xtemp = xtemp1+xtemp2
        if(xtemp .lt. eps*xtemp0)then
          nterms = j + 1
          return
        endif
      enddo
c
c       ... computational box is too big, set nterms to 1000
c
        nterms=1000
c
      return
      end
c
c
c
c

!
!--------------------------------------------------------------------
!
! A fast multi-particle scattering code, based on the code in
! hfmm3d.f of the Flatiron Institute FMM3D library.
!
! Original skeleton code by Manas Rachh, Leslie Greengard, etc.
! FMPS re-write by Mike O'Neil, 2019
! oneil@cims.nyu.edu
!
! The input is assumed to be a collection of multipole expansions,
! each of arbitrary order, and the output is a collection of local
! expansions at the same locations (and of the same order) which take
! into account the potentials from all other multipole expansions.
!
! It is assume that all multipole expansions are well-separated, so
! that even those in LIST 1 can be translated.
!
! We use 1/(4\pi) exp(ikr)/r for the Green's function.
!
!--------------------------------------------------------------------
!

subroutine hfmm3d_mps(nd, eps, zk, nmpole, cmpole, rmpole, mterms, &
    mpole, impole, local, ier)
  !, &
  !  ntarg, targ)
  !-----------------------------------------------------------------------
  !   INPUT PARAMETERS:
  !
  !   nd:    in: integer *8
  !             number of densities
  !   
  !   eps:   in: double precision
  !             requested precision
  !
  !   zk:    in: double complex
  !               helmholtz parameter                
  !
  !   nsource in: integer *8  
  !                number of sources
  !
  !   source  in: double precision (3,nsource)
  !                source(k,j) is the kth component of the jth
  !                source locations
  !
  !
  !     nmpole:  in: integer *8
  !              number of multipole expansion centers
  !
  !     cmpole:  in: double precision (3,nmpole)
  !              multipole expansion centers
  !
  !     rmpole:  in: double precision (nmpole)
  !              scaling factors for each multipole expansion
  !
  !     mterms:  in: integer *8 (nmpole)
  !              order of the multipole expansions, each expansion
  !              can be of a different order
  !
  !     mpole:   in: double complex (nd,*)
  !              coefficients in the multipole expansions
  !
  !     impole:  in: integer *8 (nmpole)
  !              indexing array for mpole, the ith expansion is at
  !              location mpole(1,impole(i)) and is of order mterms(i)
  !
  !     OUTPUT parameters:
  !
  !     local:   out: double complex ()
  !              local expansions at each center, due to all incoming
  !              multipole expansions (self is ignored). The orders
  !              are the same as for the incoming mpole.
  !     ier:     out: integer *8
  !              error flag
  !              ier = 0, successful execution
  !              ier = 4, failed to allocate multipole/local expansion
  !              ier = 8, failed to allocate plane wave expansion
  !
  !------------------------------------------------------------------
  
  implicit none

  integer *8 nd

  double complex zk
  double precision eps

  integer *8 :: nmpole, mterms(nmpole), impole(nmpole)
  double precision :: cmpole(3,nmpole), rmpole(nmpole)
  double complex :: mpole(*)
  double complex :: local(*)
  

  ! Tree variables
  integer *8 idivflag,ndiv,isep,nboxes,nbmax,nlevels
  integer *8 ltree
  integer *8 nlmax,nlmin,iper,ifunif
  integer *8 ntarg  
  integer *8 ipointer(8)
  integer *8, allocatable :: itree(:)
  double precision :: targ(3)
  double precision, allocatable :: treecenters(:,:),boxsize(:)
  integer *8, allocatable :: isrcse(:,:),itargse(:,:),iexpcse(:,:)
  integer *8, allocatable :: isrc(:)
  integer *8 iexpc,itarg

  !
  ! temporary sorted arrays
  !
  integer *8 :: lmpole, mt, ilen

  integer *8, allocatable :: mtermssort(:), impolesort(:)
  double precision, allocatable :: cmpolesort(:,:)
  double precision, allocatable :: rmpolesort(:)
  double complex, allocatable :: mpolesort(:)
  double complex, allocatable :: localsort(:)
  
  !
  !  temporary fmm arrays
  !
  double precision epsfmm
  integer *8, allocatable :: nterms(:)
  integer *8, allocatable :: iaddr(:,:)
  double precision, allocatable :: scales(:)
  double precision, allocatable :: rmlexp(:)

  integer *8 lmptemp,nmax
  integer *8 lmptot
  double precision, allocatable :: mptemp(:),mptemp2(:)

  !
  !       temporary variables not used in particle code
  !
  double precision expc(3),scjsort(1),radexp
  double complex texpssort(100)
  double precision expcsort(3),radssort(1)
  integer *8 ntj,nexpc,nadd, npts, perm, ptr, ifunsort

  !
  !        other temporary variables
  !
  integer *8 :: i, j, l, ijk, iert,ifprint,ilev,idim,ier
  integer *8 :: nlege, lw7, lused7
  double precision :: wlege(40000)
  double precision time1,time2,omp_get_wtime,second
  integer *8 ndim


  !
  !
  ! ifprint is an internal information printing flag.  Suppressed if
  ! ifprint=0.  Prints timing breakdown and other things if ifprint=1.
  !      
  ifprint=1
  print *, 'ndiv still needs to be optimized'
  ndiv = 1

  if(ifprint.ge.1) print *, "ndiv =",ndiv



  nexpc = 0
  radexp = 0
  nadd = 0
  ntj = 0

  !
  ! set tree flags
  !
  isep = 1
  nlmax = 200
  nlevels = 0
  nboxes = 0
  ltree = 0

  idivflag = 0




  !
  ! memory management code for constructing level restricted tree
  !
  iert = 0

  ntarg = 0
  targ(1) = 0
  targ(2) = 0
  targ(3) = 0
!
!!      set tree flags
! 
  nlmax = 51
  nlevels = 0
  nboxes = 0
  ltree = 0
  nlmin = 0
  ifunif = 0
  iper = 0

!
!!     memory management code for contructing level restricted tree
  call pts_tree_mem(cmpole,nmpole,targ,ntarg,idivflag,ndiv, &
     nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree)
      

  allocate(itree(ltree))
  allocate(boxsize(0:nlevels))
  allocate(treecenters(3,nboxes))

  call pts_tree_build(cmpole,nmpole,targ,ntarg,idivflag,ndiv, &
     nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree,itree,ipointer, &
     treecenters,boxsize)
      

  allocate(isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes))
  allocate(isrc(nmpole))

  call pts_tree_sort(nmpole,cmpole,itree,ltree,nboxes,nlevels, &
    ipointer,treecenters,isrc,isrcse)


!
!   End of tree build
!

  if(ifprint.ge.1) print *, "nlevels=",nlevels
  if(ifprint.ge.1) print *, ltree/1.0d9


  !
  !     Allocate sorted source and target arrays      
  !
  
  allocate(scales(0:nlevels),nterms(0:nlevels))
  do ilev = 0,nlevels
    scales(ilev) = boxsize(ilev)
  enddo

  !
  !compute length of expansions at each level      
  !
  nmax = 0
  do i=0,nlevels
    call h3dterms(boxsize(i),zk,eps,nterms(i))
    if(nterms(i).gt.nmax) nmax = nterms(i)
  enddo


  !       
  ! Multipole and local expansions will be held in workspace in
  ! locations pointed to by array iaddr(2,nboxes).
  !
  ! iiaddr is pointer to iaddr array, itself contained in workspace.
  ! imptemp is pointer for single expansion (dimensioned by nmax)
  !
  ! ... allocate iaddr and temporary arrays
  !

  allocate(iaddr(2,nboxes))
  lmptemp = (nmax+1)*(2*nmax+1)*2*nd
  allocate(mptemp(lmptemp),mptemp2(lmptemp))


  !
  ! reorder multipole expansions, their centers, and rscales
  !
  allocate(cmpolesort(3,nmpole))
  allocate(rmpolesort(nmpole))
  allocate(impolesort(nmpole))
  allocate(mtermssort(nmpole))

  lmpole = 0
  do i = 1,nmpole
    lmpole = lmpole + (mterms(i)+1)*(2*mterms(i)+1)
  end do
  lmpole = nd*lmpole
  
  allocate(mpolesort(lmpole) )

  ndim = 3
  call dreorderf(ndim, nmpole, cmpole, cmpolesort, isrc)
  ndim = 1
  call dreorderf(ndim, nmpole, rmpole, rmpolesort, isrc)
  call ireorderf(ndim, nmpole, mterms, mtermssort, isrc)


  impolesort(1) = 1  
  do i = 1,nmpole

    mt = mtermssort(i)
    ilen = (mt+1)*(2*mt+1)

    ijk = 1
    do j = 1,ilen
      do l = 1,nd
        mpolesort(impolesort(i)+ijk-1) = &
            mpole(impole(isrc(i))+ijk-1)
        ijk = ijk + 1
      end do
    end do

    if (i .lt. nmpole) impolesort(i+1) = impolesort(i) + nd*ilen
   
  end do


  !
  ! allocate memory need by multipole, local expansions at all
  ! levels
  !
  ! irmlexp is pointer for workspace need by various fmm routines
  !
  call mpalloc(nd,itree(ipointer(1)),iaddr,nlevels,lmptot,nterms)
  if(ifprint.ge. 1) print *, "lmptot =",lmptot/1.0d9
  ier = 0
  allocate(rmlexp(lmptot),stat=iert)
  if(iert.ne.0) then
    print *, "Cannot allocate mpole expansion workspace"
    print *, "lmptot=", lmptot
    ier = 4
    return
  endif

  allocate( localsort(lmpole) )
  

  !
  ! Memory allocation is complete. 
  ! Call main fmm routine
  !
  call cpu_time(time1)
  !$ time1=omp_get_wtime()
  call hfmm3dmain_mps(nd, eps, zk, &
      nmpole, cmpolesort, rmpolesort, mtermssort, mpolesort, &
      impolesort, localsort, &
      iaddr,rmlexp,lmptot,mptemp,mptemp2,lmptemp, &
      itree,ltree,ipointer,ndiv,nlevels, &
      nboxes,iper,boxsize, treecenters, isrcse, &
      scales,itree(ipointer(1)),nterms,ier )
  if(ier.ne.0) return

  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  if( ifprint .eq. 1 ) call prin2('time in fmm main=*', &
      time2-time1,1)

  !
  ! now unsort the local expansions
  !
  do i = 1,nmpole

    mt = mtermssort(i)
    ilen = (mt+1)*(2*mt+1)

    ijk = 1
    do j = 1,ilen
      do l = 1,nd
        local(impole(isrc(i))+ijk-1) = &
            localsort(impolesort(i)+ijk-1) 
        ijk = ijk + 1
      end do
    end do
  end do


  return
end subroutine hfmm3d_mps





subroutine hfmm3dmain_mps(nd, eps, zk, &
    nmpole, cmpolesort, rmpolesort, mtermssort, mpolesort, &
    impolesort, localsort, &
    iaddr, rmlexp, lmptot, mptemp, mptemp2, lmptemp, &
    itree, ltree, ipointer, ndiv, nlevels, &
    nboxes, iper, boxsize, centers, isrcse, &
    rscales, laddr, nterms, ier )
  implicit none

  !
  ! INPUT variables
  !
  integer *8 :: nd, ndiv,nlevels
  double precision :: eps
  double complex :: zk,zk2

  ! input multipole stuff
  integer *8 :: nmpole, mtermssort(nmpole)
  double precision :: cmpolesort(3,nmpole), rmpolesort(nmpole)
  double complex :: mpolesort(*)
  integer *8 :: impolesort(nmpole)

  ! storage stuff for tree and multipole expansions
  integer *8 :: lmptemp, nboxes
  integer *8 :: iaddr(2,nboxes), lmptot
  double precision :: rmlexp(lmptot)
  double precision :: mptemp(lmptemp)
  double precision :: mptemp2(lmptemp)

  ! tree variables
  integer *8 :: isep,iper
  integer *8 :: ltree
  integer *8 :: laddr(2,0:nlevels)
  integer *8 :: nboxesperlevel(0:nlevels)
  integer *8 :: nboxesoffset(0:nlevels)
  integer *8 :: iboxlev
  integer *8 :: nterms(0:nlevels)
  integer *8 :: ipointer(8)
  integer *8 :: itree(ltree)
  integer *8 :: mnbors,mnlist1, mnlist2,mnlist3,mnlist4
  integer *8 :: isrcse(2,nmpole)
  integer *8, allocatable :: nlist1(:),list1(:,:)
  integer *8, allocatable :: nlist2(:),list2(:,:)
  integer *8, allocatable :: nlist3(:),list3(:,:)
  integer *8, allocatable :: nlist4(:),list4(:,:)
  double precision :: rscales(0:nlevels)
  double precision :: boxsize(0:nlevels)
  double precision :: centers(3,nboxes)

  !
  ! OUTPUT variables
  !
  double complex :: localsort(*)


  !
  ! LOCAL variables
  !

  ! pw stuff
  integer *8 nuall,ndall,nnall,nsall,neall,nwall
  integer *8 nu1234,nd5678,nn1256,ns3478,ne1357,nw2468
  integer *8 nn12,nn56,ns34,ns78,ne13,ne57,nw24,nw68
  integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8
  integer *8 uall(200),dall(200),nall(120),sall(120),eall(72),wall(72)
  integer *8 u1234(36),d5678(36),n1256(24),s3478(24)
  integer *8 e1357(16),w2468(16),n12(20),n56(20),s34(20),s78(20)
  integer *8 e13(20),e57(20),w24(20),w68(20)
  integer *8 e1(20),e3(5),e5(5),e7(5),w2(5),w4(5),w6(5),w8(5)
  integer *8 ntmax, nexpmax, nlams, nmax, nthmax, nphmax
  integer *8 nn,nnn
  integer *8 nexptot, nexptotp
  integer *8, allocatable :: nfourier(:), nphysical(:)

  double precision :: r1
  double precision, allocatable :: carray(:,:), dc(:,:)
  double precision, allocatable :: rdplus(:,:,:)
  double precision, allocatable :: rdminus(:,:,:), rdsq3(:,:,:)
  double precision, allocatable :: rdmsq3(:,:,:)
  double precision, allocatable :: zmone(:)
  double precision, allocatable :: rsc(:)

  double complex, allocatable :: rdminus2(:,:,:),zeyep(:)
  double complex, allocatable :: rdplus2(:,:,:)
  double complex, allocatable :: rlams(:),whts(:)
  double complex, allocatable :: rlsc(:,:,:)
  double complex, allocatable :: xshift(:,:),yshift(:,:),zshift(:,:)
  double complex, allocatable :: fexp(:),fexpback(:)
  double complex, allocatable :: mexp(:,:,:,:)
  double complex, allocatable :: tmp(:,:,:),tmp2(:,:,:)
  double complex, allocatable :: mexpf1(:,:),mexpf2(:,:)
  double complex, allocatable :: mexpp1(:,:),mexpp2(:,:)
  double complex, allocatable :: mexppall(:,:,:)

  ! temp variables
  integer *8 i,j,k,l,ii,jj,kk,ll,idim
  integer *8 ibox,jbox,ilev,npts,npts0
  integer *8 nchild
  integer *8 istart,iend,istartt,iendt,istarte,iende
  integer *8 istarts,iends, iloc
  integer *8 jstart,jend
  integer *8 ifprint,ifwrite
  integer *8 ifpgh
  integer *8 ix,iy,iz
  integer *8 nlege, lw7, lused7, itype
  integer *8 ctr,ifinit2
  integer *8 nquad2
  integer *8 maX_nodes
  integer *8 iert, ifpw, ifmp
  integer *8 istart0,istart1,istartm1,nprin
  integer *8 nlfbox,ier, ifstep2, mt, ltot


  integer *8 cntlist4
  integer *8, allocatable :: list4ct(:),ilist4(:),nlist4tmp(:)
  double complex pgboxwexp(100)
  integer *8 :: bigint
  double precision d,time1,time2,omp_get_wtime
  double precision timeinfo(10)
  double precision rtmp
  double precision wlege(40000)
  double precision thresh
  double precision alphaj
  double precision radius
  double precision pi
  double precision :: rtmp1,rtmp2,rtmp3,rtmp4, done
  double precision, allocatable :: xnodes(:),wts(:)
  double complex zmul
  double complex eye, ztmp,zmult
  double complex :: ima, cd, cd1(10), cd2(10), work(100000)

  data ima/(0.0d0,1.0d0)/


  mnlist1 = 0
  mnlist2 = 0
  mnlist3 = 0
  mnlist4 = 0
  mnbors = 27

  isep = 1
      
  call computemnlists(nlevels,nboxes,itree(ipointer(1)),boxsize, &
    centers,itree(ipointer(3)),itree(ipointer(4)), &
    itree(ipointer(5)),isep,itree(ipointer(6)),mnbors, &
    itree(ipointer(7)),iper,mnlist1,mnlist2,mnlist3,mnlist4)
      
  allocate(list1(mnlist1,nboxes),nlist1(nboxes))
  allocate(list2(mnlist2,nboxes),nlist2(nboxes))
  allocate(list3(mnlist3,nboxes),nlist3(nboxes))
  allocate(list4(mnlist4,nboxes),nlist4(nboxes))

  call computelists(nlevels,nboxes,itree(ipointer(1)),boxsize, &
    centers,itree(ipointer(3)),itree(ipointer(4)), &
    itree(ipointer(5)),isep,itree(ipointer(6)),mnbors, &
    itree(ipointer(7)),iper,nlist1,mnlist1,list1,nlist2, &
    mnlist2,list2,nlist3,mnlist3,list3,nlist4,mnlist4,list4)
      
  ntmax = 1000
  allocate(nfourier(ntmax),nphysical(ntmax))
  allocate(rlams(ntmax),whts(ntmax))

  cntlist4 = 0
  allocate(list4ct(nboxes))
  allocate(ilist4(nboxes),nlist4tmp(nboxes))

  !$omp parallel do default(shared) private(i)
  do i=1,nboxes
    list4ct(i) = 0
    ilist4(i) = 0
    nlist4tmp(i) = 0
  enddo
  !$omp end parallel do

  done = 1
  pi = 4.0d0*atan(done)

  nmax = 0
  do i=0,nlevels
    if(nmax.lt.nterms(i)) nmax = nterms(i)
  enddo

  allocate(rsc(0:nmax))

  !
  ! threshold for computing interactions:
  !
  ! interactions will be ignored for all pairs of sources and targets
  ! which satisfy |r| < thresh where r is the disance between them
  !
  thresh = 2.0d0**(-51)*boxsize(0)

  call prini(6,13)
  write(13,*) 'interaction threshold = ', thresh


  allocate(zeyep(-nmax:nmax),zmone(0:2*nmax))

  zeyep(0) = 1
  zmult = -ima
  do i=1,nmax
    zeyep(i) = zeyep(i-1)*zmult
    zeyep(-i) = zeyep(-i+1)/zmult
  enddo


  zmone(0) = 1
  do i=1,2*nmax
    zmone(i) = -zmone(i-1)
  enddo

  !
  ! ifprint is an internal information printing flag. 
  ! Suppressed if ifprint=0.
  ! Prints timing breakdown and other things if ifprint=1.
  ! Prints timing breakdown, list information, and other things if ifprint=2.
  !       
  ifprint=1
  do i=1,10
    timeinfo(i)=0
  enddo

  max_nodes = 10000
  allocate(xnodes(max_nodes))
  allocate(wts(max_nodes))

  !
  ! ... set all multipole and local expansions to zero
  !
  do ilev = 0,nlevels
    nboxesperlevel(ilev) = laddr(2,ilev)-laddr(1,ilev)+1
    if(ilev.eq.0) then
      nboxesoffset(ilev) = 0
    else
      nboxesoffset(ilev) = nboxesoffset(ilev-1) + &
                           nboxesperlevel(ilev-1)
    endif
    !$omp parallel do default(shared) private(ibox)
    do ibox = laddr(1,ilev),laddr(2,ilev)
      call mpzero(nd,rmlexp(iaddr(1,ibox)),nterms(ilev))
      call mpzero(nd,rmlexp(iaddr(2,ibox)),nterms(ilev))
    enddo
    !$omp end parallel do          
  enddo

  ltot = 0
  !$omp parallel do default(shared) private(l,mt)  &
  !$omp reduction(+:ltot)
  do l = 1,nmpole
    mt = mtermssort(l)
    ltot = ltot + (mt+1)*(2*mt+1)
  end do
  !$omp end parallel do

  
  !$omp parallel do default (shared) private(l)
  do l = 1,ltot*nd
      localsort(l) = 0
  end do
  !$omp end parallel do
  


  ! initialize legendre function evaluation routines
  nlege = nmax+10
  lw7 = (nlege+1)**2*4
  call ylgndrfwini(nlege,wlege,lw7,lused7)


  !
  ! ----- Step 1: Shift incoming multipole expansions to the center
  ! of each leaf-node box -----
  !
  if(ifprint .ge. 1) call prinf('=== STEP 1 (shift mp) ====*',i,0)

  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  do ilev=2,nlevels

    nquad2 = nterms(ilev)*2.5
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2,xnodes,wts,ifinit2)

    !!!!!!!!!
    ! this radius has a fudge factor in it, debug in future
    !!!!!!!!!
    radius = boxsize(ilev)/2*sqrt(3.0d0)*1.5d0
    
      !$omp parallel do default(shared) &
      !$omp   private(ibox,npts,istart,iend,nchild,i)
      do ibox = laddr(1,ilev),laddr(2,ilev)

        istart = isrcse(1,ibox) 
        iend = isrcse(2,ibox) 
        npts = iend-istart+1
        
        nchild = itree(ipointer(4)+ibox-1)

        if((npts.gt.0) .and. (nchild.eq.0)) then
          
          do i = istart,iend
            call h3dmpmp(nd, zk, rmpolesort(i), cmpolesort(1,i), &
                mpolesort(impolesort(i)), mtermssort(i), &
                rscales(ilev), centers(1,ibox), &
                rmlexp(iaddr(1,ibox)), nterms(ilev), &
                radius, xnodes, wts, nquad2)
          end do
        
        endif
      enddo
      !$omp end parallel do            

  enddo

  call cpu_time(time2)
  !$ time2 = omp_get_wtime()
  timeinfo(1)=time2-time1



  !
  ! ----- Step 2: List 3 interactions, non-adjacent nearfield of all
  ! boxes, do these translations directly right now
  !

  if(ifprint.ge.1) &
      call prinf('=== STEP 2 (form lo) ===*',i,0)
  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  
  do ilev=2,nlevels

    nquad2 = nterms(ilev)*2.5
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2,xnodes,wts,ifinit2)
    radius = boxsize(ilev)/2*sqrt(3.0d0)

    !$omp parallel do default(shared) &
    !$omp   private(ibox,jbox,istart,iend,npts,i,j) &
    !$omp   schedule(dynamic)
    do ibox=laddr(1,ilev),laddr(2,ilev)
      do i=1,nlist4(ibox)
        jbox = list4(i,ibox) 

        !
        ! Form local expansion for all boxes in list3 of the current
        ! box
        !
        istart = isrcse(1,jbox) 
        iend = isrcse(2,jbox) 
        npts = iend-istart+1
        if(npts.gt.0) then
          do j = istart,iend
            call h3dmploc(nd, zk, rmpolesort(j), cmpolesort(1,j), &
                mpolesort(impolesort(j)), mtermssort(j), &
                rscales(ilev), centers(1,ibox), &
                rmlexp(iaddr(2,ibox)), nterms(ilev), &
                radius, xnodes, wts, nquad2)
          end do
        endif
      enddo
    enddo
    !$omp end parallel do
  enddo

  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(2)=time2-time1

  !
  ! A further optimization could be done, which translations initial
  ! multipole expansions directly to the center of the parent box,
  ! eliminating Step 1
  !


  !
  ! Step 3: Upward pass, multipole-to-multipole merges
  !
  
  if(ifprint .ge. 1) call prinf('=== STEP 3 (merge mp) ====*',i,0)

  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  do ilev=nlevels-1,0,-1
    nquad2 = nterms(ilev)*2.5
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2,xnodes,wts,ifinit2)
    radius = boxsize(ilev)/2*sqrt(3.0d0)

    !$omp parallel do default(shared) &
    !$omp     private(ibox,i,jbox,istart,iend,npts)
    do ibox = laddr(1,ilev),laddr(2,ilev)
      do i=1,8
        jbox = itree(ipointer(5)+8*(ibox-1)+i-1)

        if(jbox.gt.0) then
          istart = isrcse(1,jbox) 
          iend = isrcse(2,jbox) 
          npts = iend-istart+1

          if(npts .gt. 0) then
            call h3dmpmp(nd,zk,rscales(ilev+1), &
                centers(1,jbox),rmlexp(iaddr(1,jbox)), &
                nterms(ilev+1),rscales(ilev),centers(1,ibox), &
                rmlexp(iaddr(1,ibox)),nterms(ilev), &
                radius,xnodes,wts,nquad2)
          endif
        endif
      enddo
    enddo
    !$omp end parallel do          
  enddo

  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(3)=time2-time1

  !
  ! ----- Step 4: Crossward pass, multipole-to-local -----
  ! Note: This is generally the most expensive component of the FMM
  !
  if (ifprint .ge. 1) &
      call prinf('=== Step 4 (mp to loc) ===*',i,0)

  call cpu_time(time1)
  !$ time1=omp_get_wtime()


  !
  ! Set the below flag depending on whether you want planewave
  ! translations or standard point-and-shoot translations
  !
  ifpw = 1
  ifmp = 0

  if ( (ifprint .ge. 1) .and. (ifmp .eq. 1) ) &
      call prinf('=== doing point and shoots... ===*',i,0)

  if ( (ifprint .ge. 1) .and. (ifmp .eq. 0) ) &
      call prinf('=== doing plane waves... ===*',i,0)

  
  if (ifpw .eq. 1) then

    !if (ifprint .ge. 1) &
    !    call prinf('=== doing plane waves... ===*',i,0)
    
    do ilev = 2,nlevels

      ! load the necessary quadrature for plane waves
      zk2 = zk*boxsize(ilev)
      if ( (real(zk2).le.16*pi) .and. (dimag(zk2).le.12*pi) &
          .and. (ifmp .eq. 0) ) then
        ier = 0

        ! get new pw quadrature
        call hwts3e(ier,eps,zk2,rlams,whts,nlams)
        call hnumfour(eps,zk2,nlams,nfourier)
        call hnumphys(eps,zk2,nlams,nphysical)

        nphmax = 0
        nthmax = 0
        nexptotp = 0
        nexptot = 0
        nn = 0
        do i=1,nlams
          nexptotp = nexptotp + nphysical(i)
          nexptot = nexptot + 2*nfourier(i)+1
          nn = nn + nfourier(i)*nphysical(i)
          if(nfourier(i).gt.nthmax) nthmax = nfourier(i)
          if(nphysical(i).gt.nphmax) nphmax = nphysical(i)
        enddo

        allocate(fexp(nn),fexpback(nn))

        allocate(xshift(-5:5,nexptotp))
        allocate(yshift(-5:5,nexptotp))
        allocate(zshift(5,nexptotp))
        allocate(rlsc(0:nterms(ilev),0:nterms(ilev),nlams))
        allocate(tmp(nd,0:nterms(ilev),-nterms(ilev):nterms(ilev)))
        allocate(tmp2(nd,0:nterms(ilev),-nterms(ilev):nterms(ilev)))

        allocate(mexpf1(nd,nexptot),mexpf2(nd,nexptot), &
            mexpp1(nd,nexptotp))
        allocate(mexpp2(nd,nexptotp),mexppall(nd,nexptotp,16))


        ! NOTE: there can be some additional memory savings here
        bigint = 0
        bigint = nboxesperlevel(ilev)
        !bigint = nboxes
        bigint = bigint*6
        bigint = bigint*nexptotp*nd

        !if(ifprint.ge.1) print *, "mexp memory=",bigint/1.0d9


        !allocate(mexp(nd,nexptotp,nboxes,6),stat=iert)
        allocate(mexp(nd,nexptotp,nboxesperlevel(ilev),6),stat=iert)
        if(iert.ne.0) then
          print *, "Cannot allocate pw expansion workspace"
          print *, "bigint=", bigint
          ier = 8
          return
        endif


        nn = nterms(ilev)
        allocate(carray(4*nn+1,4*nn+1))
        allocate(dc(0:4*nn,0:4*nn))
        allocate(rdplus(0:nn,0:nn,-nn:nn))
        allocate(rdminus(0:nn,0:nn,-nn:nn))
        allocate(rdsq3(0:nn,0:nn,-nn:nn))
        allocate(rdmsq3(0:nn,0:nn,-nn:nn))


        ! generate rotation matrices and carray
        call getpwrotmat(nn,carray,rdplus,rdminus,rdsq3,rdmsq3,dc)

        call hrlscini(rlsc,nlams,rlams,rscales(ilev),zk2,nterms(ilev))
        call hmkexps(rlams,nlams,nphysical,nexptotp,zk2,xshift, &
            yshift,zshift)

        call hmkfexp(nlams,nfourier,nphysical,fexp,fexpback)

        !
        ! initialize mexp
        !
        !$omp parallel do default(shared) private(idim,i,j,k)
        do k=1,6
          do i=1,nboxesperlevel(ilev)
          !do i=1,nboxes
            do j=1,nexptotp
              do idim=1,nd
                mexp(idim,j,i,k) = 0.0d0
              enddo
            enddo
          enddo
        enddo
        !$omp end parallel do    

        !
        ! compute powers of scaling parameter for rescaling the
        ! multipole expansions
        !
        !!      r1 = rscales(ilev)
        r1 = 1.0d0
        rsc(0) = 1.0d0
        do i=1,nterms(ilev)
          rsc(i) = rsc(i-1)*r1
        enddo

        !
        ! create multipole to plane wave expansion for all boxes at this
        ! level
        !
        !$omp parallel do default (shared) &
        !$omp    private(ibox,iboxlev,istart,iend,npts,tmp,mexpf1,mexpf2,tmp2)
        do ibox = laddr(1,ilev),laddr(2,ilev)
          istart = isrcse(1,ibox) 
          iend = isrcse(2,ibox) 
          npts = iend - istart+1
          if(npts.gt.0) then

            ! rescale multipole expansion
            call mpscale(nd,nterms(ilev),rmlexp(iaddr(1,ibox)), &
                rsc,tmp)

            call hmpoletoexp(nd,tmp,nterms(ilev), &
                nlams,nfourier,nexptot,mexpf1,mexpf2,rlsc) 

            iboxlev = ibox - nboxesoffset(ilev)
            call hftophys(nd,mexpf1,nlams,nfourier,nphysical, &
                mexp(1,1,iboxlev,1),fexp)           

            call hftophys(nd,mexpf2,nlams,nfourier,nphysical, &
                mexp(1,1,iboxlev,2),fexp)


            ! form mexpnorth, mexpsouth for current box

            ! Rotate mpole for computing mexpnorth and
            ! mexpsouth
            call rotztoy(nd,nterms(ilev),tmp, &
                tmp2,rdminus)

            call hmpoletoexp(nd,tmp2,nterms(ilev),nlams, &
                nfourier,nexptot,mexpf1,mexpf2,rlsc)

            call hftophys(nd,mexpf1,nlams,nfourier, &
                nphysical,mexp(1,1,iboxlev,3),fexp)           

            call hftophys(nd,mexpf2,nlams,nfourier, &
                nphysical,mexp(1,1,iboxlev,4),fexp)   


            ! Rotate mpole for computing mexpeast, mexpwest
            call rotztox(nd,nterms(ilev),tmp, &
                tmp2,rdplus)
            call hmpoletoexp(nd,tmp2,nterms(ilev),nlams, &
                nfourier,nexptot,mexpf1,mexpf2,rlsc)

            call hftophys(nd,mexpf1,nlams,nfourier, &
                nphysical,mexp(1,1,iboxlev,5),fexp)

            call hftophys(nd,mexpf2,nlams,nfourier, &
                nphysical,mexp(1,1,iboxlev,6),fexp)           

          endif
        enddo
        !$omp end parallel do       

        !
        ! Loop over parent boxes and ship plane wave expansions to the
        ! first child of parent boxes.
        !
        ! The codes are now written from a gathering perspective so the
        ! first child of the parent is the one recieving all the local
        ! expansions coming from all the lists
        !

        !$omp parallel do default (shared) &
        !$omp private(ibox,istart,iend,npts,nchild) &
        !$omp private(mexpf1,mexpf2,mexpp1,mexpp2,mexppall) &
        !$omp private(nuall,uall,ndall,dall,nnall,nall,nsall,sall) &
        !$omp private(neall,eall,nwall,wall,nu1234,u1234,nd5678,d5678)&
        !$omp private(nn1256,n1256,ns3478,s3478,ne1357,e1357,nw2468,w2468)&
        !$omp private(nn12,n12,nn56,n56,ns34,s34,ns78,s78,ne13,e13,ne57,e57)&
        !$omp private(nw24,w24,nw68,w68,ne1,e1,ne3,e3,ne5,e5,ne7,e7)&
        !$omp private(nw2,w2,nw4,w4,nw6,w6,nw8,w8)
        do ibox = laddr(1,ilev-1),laddr(2,ilev-1)

          npts = 0
          nchild = itree(ipointer(4)+ibox-1)
          istart = isrcse(1,ibox)
          iend = isrcse(2,ibox) 
          npts = npts + iend-istart+1

          if ((npts.gt.0) .and. (nchild.gt.0)) then

            call getpwlistall(ibox,boxsize(ilev),nboxes, &
                itree(ipointer(6)+ibox-1),itree(ipointer(7)+ &
                mnbors*(ibox-1)),nchild,itree(ipointer(5)),centers, &
                isep,nuall,uall,ndall,dall,nnall,nall,nsall,sall, &
                neall,eall,nwall,wall,nu1234,u1234,nd5678,d5678, &
                nn1256,n1256,ns3478,s3478,ne1357,e1357,nw2468,w2468, &
                nn12,n12,nn56,n56,ns34,s34,ns78,s78,ne13,e13,ne57, &
                e57,nw24,w24,nw68,w68,ne1,e1,ne3,e3,ne5,e5,ne7,e7, &
                nw2,w2,nw4,w4,nw6,w6,nw8,w8)


            call hprocessudexp(nd,zk2,ibox,ilev,nboxes,centers, &
                itree(ipointer(5)),rscales(ilev),boxsize(ilev), &
                nterms(ilev), &
                iaddr,rmlexp,rlams,whts, &
                nlams,nfourier,nphysical,nthmax,nexptot,nexptotp, &
                mexp, &
                nuall,uall,nu1234,u1234,ndall,dall,nd5678,d5678, &
                mexpf1,mexpf2,mexpp1,mexpp2,mexppall(1,1,1), &
                mexppall(1,1,2),mexppall(1,1,3),mexppall(1,1,4), &
                xshift,yshift,zshift,fexpback,rlsc,pgboxwexp,cntlist4, &
                list4ct,nlist4tmp,list4,mnlist4, &
                nboxesperlevel(ilev),nboxesoffset(ilev))


            call hprocessnsexp(nd,zk2,ibox,ilev,nboxes,centers,&
                itree(ipointer(5)),rscales(ilev),boxsize(ilev), &
                nterms(ilev),&
                iaddr,rmlexp,rlams,whts,&
                nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,&
                nnall,nall,nn1256,n1256,nn12,n12,nn56,n56,nsall,sall,&
                ns3478,s3478,ns34,s34,ns78,s78,&
                mexpf1,mexpf2,mexpp1,mexpp2,mexppall(1,1,1),&
                mexppall(1,1,2),mexppall(1,1,3),mexppall(1,1,4),&
                mexppall(1,1,5),mexppall(1,1,6),mexppall(1,1,7),&
                mexppall(1,1,8),rdplus,xshift,yshift,zshift, &
                fexpback,rlsc,pgboxwexp,cntlist4, list4ct, &
                nlist4tmp,list4,mnlist4, &
                nboxesperlevel(ilev),nboxesoffset(ilev))

            call hprocessewexp(nd,zk2,ibox,ilev,nboxes,centers,&
                itree(ipointer(5)),rscales(ilev),boxsize(ilev),&
                nterms(ilev),&
                iaddr,rmlexp,rlams,whts,&
                nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,&
                neall,eall,ne1357,e1357,ne13,e13,ne57,e57,ne1,e1,&
                ne3,e3,ne5,e5,ne7,e7,nwall,wall,&
                nw2468,w2468,nw24,w24,nw68,w68,&
                nw2,w2,nw4,w4,nw6,w6,nw8,w8,&
                mexpf1,mexpf2,mexpp1,mexpp2,mexppall(1,1,1),&
                mexppall(1,1,2),mexppall(1,1,3),mexppall(1,1,4),&
                mexppall(1,1,5),mexppall(1,1,6),&
                mexppall(1,1,7),mexppall(1,1,8),mexppall(1,1,9),&
                mexppall(1,1,10),mexppall(1,1,11),mexppall(1,1,12),&
                mexppall(1,1,13),mexppall(1,1,14),mexppall(1,1,15),&
                mexppall(1,1,16),rdminus,xshift,yshift,zshift,&
                fexpback,rlsc,pgboxwexp,cntlist4,list4ct, &
                nlist4tmp,list4,mnlist4, &
                nboxesperlevel(ilev),nboxesoffset(ilev))
          endif
        enddo
        !$omp end parallel do        

        deallocate(xshift,yshift,zshift,rlsc,tmp,tmp2)
        deallocate(carray,dc,rdplus,rdminus,rdsq3,rdmsq3)

        deallocate(mexpf1,mexpf2,mexpp1,mexpp2,mexppall,mexp)
        deallocate(fexp,fexpback)

      else

        !print *, 'in else statement in mploc, double check and debug'
        !stop

        nquad2 = nterms(ilev)*2.2d0
        nquad2 = max(6,nquad2)
        ifinit2 = 1
        ier = 0

        call legewhts(nquad2,xnodes,wts,ifinit2)

        radius = boxsize(ilev)/2*sqrt(3.0d0)
        !$omp parallel do default(shared) &
        !$omp     private(ibox,istart,iend,npts,i,jbox)
        do ibox = laddr(1,ilev),laddr(2,ilev)

          npts = 0
          istart = isrcse(1,ibox) 
          iend = isrcse(2,ibox) 
          npts = npts + iend-istart+1

          if(npts.gt.0) then
            do i =1,nlist2(ibox)
              jbox = list2(i,ibox) 
              istart = isrcse(1,jbox) 
              iend = isrcse(2,jbox)
              npts = iend-istart+1

              if(npts.gt.0) then
                call h3dmploc(nd,zk,rscales(ilev), &
                    centers(1,jbox), &
                    rmlexp(iaddr(1,jbox)),nterms(ilev), &
                    rscales(ilev),centers(1,ibox), &
                    rmlexp(iaddr(2,ibox)),nterms(ilev), &
                    radius,xnodes,wts,nquad2)
              endif
            enddo
          endif
        enddo
        !$omp end parallel do        
      endif
    enddo

  else

    !
    ! if here, then process MP2LOC using standard point and shoot
    ! translations
    !
    if (ifprint .ge. 1) &
        call prinf('=== doing p&s ... ===*',i,0)

    do ilev = 2,nlevels

      nquad2 = nterms(ilev)*2
      nquad2 = max(6,nquad2)
      ifinit2 = 1
      call legewhts(nquad2,xnodes,wts,ifinit2)
      radius = boxsize(ilev)/2*sqrt(3.0d0)

 !$omp parallel do default(shared) private(ibox,npts,istart,iend,i) &
 !$omp private(jbox)
      do ibox = laddr(1,ilev),laddr(2,ilev)
        npts = 0
        istart = isrcse(1,ibox) 
        iend = isrcse(2,ibox)
        npts = npts + iend-istart+1

        if (npts .gt. 0) then
          do i =1,nlist2(ibox)
            jbox = list2(i,ibox) 
            istart = isrcse(1,jbox) 
            iend = isrcse(2,jbox)
            npts = iend-istart+1

            if(npts.gt.0) then
              call h3dmploc(nd,zk,rscales(ilev), &
                  centers(1,jbox), &
                  rmlexp(iaddr(1,jbox)),nterms(ilev), &
                  rscales(ilev),centers(1,ibox), &
                  rmlexp(iaddr(2,ibox)),nterms(ilev), &
                  radius,xnodes,wts,nquad2)
            endif
          enddo
        end if
      end do
  !$omp end parallel do    
      
    
    end do

  end if

  



  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(4) = time2-time1




  !
  ! ----- Step 5: Downward pass, local-to-local -----
  !
  if(ifprint.ge.1) call prinf('=== Step 5 (split loc) ===*',i,0)

  call cpu_time(time1)
  !$ time1=omp_get_wtime()
  do ilev = 2,nlevels-1

    nquad2 = nterms(ilev)*2
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2,xnodes,wts,ifinit2)
    radius = boxsize(ilev+1)/2*sqrt(3.0d0)

    !$omp parallel do default(shared) &
    !$omp     private(ibox,i,jbox,istart,iend,npts)
    do ibox = laddr(1,ilev),laddr(2,ilev)

      npts = 0

      istart = isrcse(1,ibox) 
      iend = isrcse(2,ibox)
      npts = npts + iend-istart+1

      if (npts .gt. 0) then
        do i=1,8
          jbox = itree(ipointer(5)+8*(ibox-1)+i-1)
          if(jbox.gt.0) then
            call h3dlocloc(nd,zk,rscales(ilev), &
                centers(1,ibox),rmlexp(iaddr(2,ibox)), &
                nterms(ilev),rscales(ilev+1),centers(1,jbox), &
                rmlexp(iaddr(2,jbox)),nterms(ilev+1), &
                radius,xnodes,wts,nquad2)
          endif
        enddo
      endif
    enddo
    !$omp end parallel do         
  enddo
  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(5) = time2-time1


  
  !
  ! Step 6: Ship multipole expansions to local expansion in List 4
  !
  if(ifprint.ge.1) call prinf('=== step 6 (mp eval) ===*',i,0)
  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  do ilev=1,nlevels

    nquad2 = nterms(ilev)*2
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2,xnodes,wts,ifinit2)
    radius = boxsize(ilev)/2*sqrt(3.0d0)/2

    !$omp parallel do default(shared) &
    !$omp   private(ibox,istart,iend,npts,i,jbox,j) &
    !$omp   schedule(dynamic)
    do ibox=laddr(1,ilev),laddr(2,ilev)
      istart = isrcse(1,ibox) 
      iend = isrcse(2,ibox) 

      npts = iend-istart+1

      do i=1,nlist3(ibox)
        jbox = list3(i,ibox) 
        do j = istart,iend
          call h3dmploc(nd, zk, rscales(ilev+1), centers(1,jbox), &
              rmlexp(iaddr(1,jbox)),nterms(ilev+1), &
              rmpolesort(j), cmpolesort(1,j), &
              localsort(impolesort(j)), mtermssort(j), &
              radius, xnodes, wts, nquad2)
        end do
      enddo
    enddo
    !$omp end parallel do          

  enddo

  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(6) = time2-time1




  !
  ! Step 7: Shift local expansions in leaf nodes to the correct
  ! respective multipole expansion centers
  !
  if(ifprint.ge.1) &
      call prinf('=== Step 7 (LOC to CEN) ===*',i,0)
  print *, 'dont forget to check box radius for translation...'

  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  do ilev = 0,nlevels

    nquad2 = nterms(ilev)*2
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2, xnodes, wts, ifinit2)
    radius = boxsize(ilev)/2*sqrt(3.0d0)

    !$omp parallel do default(shared) &
    !$omp   private(ibox,nchild,istart,iend,npts,i) schedule(dynamic)
    do ibox = laddr(1,ilev),laddr(2,ilev)

      nchild=itree(ipointer(4)+ibox-1)

      if(nchild.eq.0) then 
        istart = isrcse(1,ibox) 
        iend = isrcse(2,ibox) 
        npts = iend-istart+1

        do i = istart,iend
          call h3dlocloc(nd, zk, rscales(ilev), &
              centers(1,ibox), rmlexp(iaddr(2,ibox)), &
              nterms(ilev), rmpolesort(i), cmpolesort(1,i), &
              localsort(impolesort(i)), mtermssort(i), &
              radius, xnodes, wts, nquad2)
        end do
        
      endif

    enddo
    !$omp end parallel do

  enddo

  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(7) = time2 - time1



  
  !
  ! Step 8: Direct multipole to local translations for nearfield
  !
  if(ifprint .ge. 1) call prinf('=== STEP 8 (direct) =====*',i,0)

  call cpu_time(time1)
  !$ time1=omp_get_wtime()

  do ilev=0,nlevels

    nquad2 = nterms(ilev)*2
    nquad2 = max(6,nquad2)
    ifinit2 = 1
    call legewhts(nquad2, xnodes, wts, ifinit2)
    radius = boxsize(ilev)/2*sqrt(3.0d0)/2/2

    !
    ! do final mploc translations for nearfield, which are assumed to
    ! be valid translations, despite them being in the nearfield
    !

    !$omp parallel do default(shared) &
    !$omp   private(ibox,istarts,iends,npts0,i) &
    !$omp   private(jbox,jstart,jend,npts,d,j,iloc)
    do ibox = laddr(1,ilev),laddr(2,ilev)
      istarts = isrcse(1,ibox) 
      iends = isrcse(2,ibox)
      npts0 = iends-istarts+1

      do iloc = istarts,iends

        do i=1,nlist1(ibox)
          jbox = list1(i,ibox) 
          jstart = isrcse(1,jbox) 
          jend = isrcse(2,jbox)
          npts = jend-jstart+1

          do j = jstart,jend

            d = (cmpolesort(1,j)-cmpolesort(1,iloc))**2 &
                + (cmpolesort(2,j)-cmpolesort(2,iloc))**2 &
                + (cmpolesort(3,j)-cmpolesort(3,iloc))**2
            d = sqrt(d)

            if (d .gt. thresh) then
              call h3dmploc(nd, zk, rmpolesort(j),&
                  cmpolesort(1,j), &
                  mpolesort(impolesort(j)), mtermssort(j), &
                  rmpolesort(iloc), cmpolesort(1,iloc), &
                  localsort(impolesort(iloc)), mtermssort(iloc), &
                  radius, xnodes, wts, nquad2)
            else
              if (j .ne. iloc) then
                print *, 'two MP centers closer than thresh... '
                print *, 'thresh = ', thresh
                print *, 'bombing code!!'
                stop
              end if
            end if

          end do


        enddo
      end do


    enddo
    !$omp end parallel do            

  enddo

  
  call cpu_time(time2)
  !$ time2=omp_get_wtime()
  timeinfo(8) = time2-time1

  
  d = 0
  do i = 1,8
    d = d + timeinfo(i)
  enddo

  if (ifprint .eq. 1) then
    print *
    print *
    write(6,'(a)') '                             Time    Perct'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 1: SHIFT MPs           ',&
        timeinfo(1), ' ', timeinfo(1)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 2: FORM LOCAL (LIST 3) ',&
        timeinfo(2), ' ', timeinfo(2)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 3: MERGE MPs           ',&
        timeinfo(3), ' ', timeinfo(3)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 4: MP to LOCAL         ',&
        timeinfo(4), ' ', timeinfo(4)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 5: SPLIT LOCAL         ',&
        timeinfo(5), ' ', timeinfo(5)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 6: MP EVAL (LIST 4)    ',&
        timeinfo(6), ' ', timeinfo(6)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 7: EVAL LOCALS         ',&
        timeinfo(7), ' ', timeinfo(7)/d*100, '%'
    write(6,'(a,f6.3,a,f6.2,a)') 'Step 8: DIRECT EVAL         ',&
        timeinfo(8), ' ', timeinfo(8)/d*100, '%'
    write(6,'(a,f6.3)') 'Total time required         ', d
    print *
    print *
  end if


  return
end subroutine hfmm3dmain_mps

c
c        This file contains a set of subroutines for the handling 
c        of Legendre expansions. It contains 19 subroutines that are 
c        user-callable. Following is a brief description of these 
c        subroutines.
c
c   legeexps - constructs Legendre nodes, and  corresponding Gaussian
c        weights. Also constructs the matrix v converting the 
c         coefficients of a legendre expansion into its values at 
c         the n Gaussian nodes, and its inverse u, converting the
c         values of a function at n Gaussian nodes into the
c         coefficients of the corresponding Legendre series.
c
c   legepol - evaluates a single Legendre polynomial (together
c         with its derivative) at the user-provided point
c
c   legepols - evaluates a bunch of Legendre polynomials
c         at the user-provided point
c   legepls2 - an accelerated version of legepols, evaluating a 
c         Legendre polynomials at the user-provided point; maximum
c         order of the polynomials to be evaluated is 290
c
c   legepolders - evaluates a bunch of Legendre polynomials
c         at the user-provided point, and the derivatives of the 
c         said polynomials 
c   legeinmt - for the user-specified n, constructs the matrices of 
c        spectral indefinite integration differentiation on the n 
c        Gaussian nodes on the interval [-1,1]. 
c
c   legeinte - computes the indefinite integral of the legendre 
c        expansion polin getting the expansion polout
c
c   legediff -  differentiates the legendre expansion polin getting 
c        the expansion polout
c
c   legefder - computes the value and the derivative of a Legendre 
c        expansion at point X in interval [-1,1]; this subroutine 
c        is not designed to be very efficient, but it does not
c        use any exdternally supplied arrays
c
c   legefde2 - the same as legefder, except it is desigmed to be 
c        fairly efficient; it uses externally supplied arrays
c        that are precomputed
c   
c   legeexev - computes the value of a Legendre expansion with 
c        at point X in interval [-1,1]; same as legefder, but does
c        not compute the derivative of the expansion
c
c   legeexe2 - the same as legeexev, except it is desigmed to be 
c        fairly efficient; it uses externally supplied arrays
c        that are precomputed
c
c   lematrin - constructs the matrix interpolating functions from 
c        the n-point Gaussian grid on the interval [-1,1] to an 
c        arbitrary m-point grid (the nodes of the latter are
c        user-provided)
c   
c   levecin - constructs the coefficients of the standard 
c        interpolation formula connecting the values of a 
c        function at n Gaussian nodes on the interval [a,b] with
c        its value at the point x \in R^1
c
c   legeodev - evaluates at the point x a Legendre expansion
c        having only odd-numbered elements; this is a fairly 
c        efficient code, using external arrays that are 
c        precomputed
c
c   legeevev - evaluates at the point x a Legendre expansion
c        having only even-numbered elements; this is a fairly 
c        efficient code, using external arrays that are 
c        precomputed
c
c   legepeven - evaluates even-numbered Legendre polynomials 
c        of the argument x; this is a fairly efficient code, 
c        using external arrays that are precomputed
c
c   legepodd - evaluates odd-numbered Legendre polynomials 
c        of the argument x; this is a fairly efficient code, 
c        using external arrays that are precomputed
c
C   legefdeq - computes the value and the derivative of a
c        Legendre Q-expansion with coefficients coefs
C     at point X in interval (-1,1); please note that this is
c     the evil twin of the subroutine legefder, evaluating the
c     proper (P-function) Legendre expansion; this subroutine 
c        is not designed to be very efficient, but it does not
c        use any exdternally supplied arrays
c
c   legeq - calculates the values and derivatives of a bunch 
c        of Legendre Q-functions at the user-specified point 
c        x on the interval (-1,1)
c
c   legeqs - calculates the value and the derivative of a single
c        Legendre Q-function at the user-specified point 
c        x on the interval (-1,1)
c
c   legecfde - computes the value and the derivative of a Legendre 
c        expansion with complex coefficients at point X in interval 
c        [-1,1]; this subroutine is not designed to be very efficient, 
c        but it does not use any exdternally supplied arrays. This is
c        a complex version of the subroutine legefder.
c
c   legecfd2 - the same as legecfde, except it is designed to be 
c        fairly efficient; it uses externally supplied arrays
c        that are precomputed. This is a complex version of the 
c        subroutine legefde2.
c
c   legecva2 - the same as legecfd2, except it is does not evaluate
c        the derivative of the function
c
c
        subroutine legeexps(itype,n,x,u,v,whts)
        implicit double precision (a-h,o-z)
        dimension x(*),whts(*),u(n,n),v(n,n)
c
c         this subroutine constructs the gaussiaqn nodes 
c         on the interval [-1,1], and the weights for the 
c         corresponding order n quadrature. it also constructs
c         the matrix v converting the coefficients
c         of a legendre expansion into its values at the n
c         gaussian nodes, and its inverse u, converting the
c         values of a function at n gaussian nodes into the
c         coefficients of the corresponding legendre series.
c         no attempt has been made to make this code efficient, 
c         but its speed is normally sufficient, and it is 
c         mercifully short.
c
c                 input parameters:
c
c  itype - the type of the calculation to be performed
c          itype=0 means that only the gaussian nodes are 
c                  to be constructed. 
c          itype=1 means that only the nodes and the weights 
c                  are to be constructed
c          itype=2 means that the nodes, the weights, and
c                  the matrices u, v are to be constructed
c  n - the number of gaussian nodes and weights to be generated
c  
c                 output parameters:
c
c  x - the order n gaussian nodes - computed independently
c          of the value of itype.
c  u - the n*n matrix converting the  values at of a polynomial of order
c         n-1 at n legendre nodes into the coefficients of its 
c         legendre expansion - computed only in itype=2
c  v - the n*n matrix converting the coefficients
c         of an n-term legendre expansion into its values at
c         n legendre nodes (note that v is the inverse of u)
c          - computed only in itype=2
c  whts - the corresponding quadrature weights - computed only 
c         if itype .ge. 1
c
c       . . . construct the nodes and the weights of the n-point gaussian 
c             quadrature
c
        ifwhts=0
        if(itype. gt. 0) ifwhts=1
        call legewhts(n,x,whts,ifwhts)
c
c       construct the matrix of values of the legendre polynomials
c       at these nodes        
c
        if(itype .ne. 2) return
        do 1400 i=1,n
c
        call legepols(x(i),n-1,u(1,i) )
 1400 continue
c
        do 1800 i=1,n
        do 1600 j=1,n
        v(i,j)=u(j,i)
 1600 continue
 1800 continue
c
c       now, v converts coefficients of a legendre expansion
c       into its values at the gaussian nodes. construct its 
c       inverse u, converting the values of a function at 
c       gaussian nodes into the coefficients of a legendre 
c       expansion of that function
c
        do 2800 i=1,n
        d=1
        d=d*(2*i-1)/2
        do 2600 j=1,n
        u(i,j)=v(j,i)*whts(j)*d
 2600 continue
 2800 continue
        return
        end
c
c
c
c
c
        subroutine legewhts_old(n,ts,whts,ifwhts)
        implicit double precision (a-h,o-z)
        dimension ts(*),whts(*)
c
c        this subroutine constructs the nodes and the
c        weights of the n-point gaussian quadrature on 
c        the interval [-1,1]
c
c                input parameters:
c
c  n - the number of nodes in the quadrature
c
c                output parameters:
c
c  ts - the nodes of the n-point gaussian quadrature
c  w - the weights of the n-point gaussian quadrature
c
c       . . . construct the array of initial approximations
c             to the roots of the n-th legendre polynomial
c
        eps=1.0d-14
        ZERO=0
        DONE=1
        pi=datan(done)*4
        h=pi/(2*n) 
        do 1200 i=1,n
        t=(2*i-1)*h
        ts(n-i+1)=dcos(t)
1200  CONTINUE
c
c         use newton to find all roots of the legendre polynomial
c
        ts(n/2+1)=0
        do 2000 i=1,n/2
c
        xk=ts(i)
        ifout=0
        deltold=1
        do 1400 k=1,10
        call legepol(xk,n,pol,der)
        delta=-pol/der
ccccc         call prin2('delta=*',delta,1)
        xk=xk+delta
        if(abs(delta) .lt. eps) ifout=ifout+1
c
cccc        call prin2('delta=*',delta,1)

        
        if(ifout .eq. 3) goto 1600
 1400 continue
 1600 continue
        ts(i)=xk
        ts(n-i+1)=-xk
 2000 continue
c
c       now, use the explicit integral formulae 
c       to obtain the weights
c
        if(ifwhts .eq. 0) return
        a=-1
        b=1
        do 2200 i=1,n/2+1
        call prodend(a,ts,n,i,fm)
        call prodend(b,ts,n,i,fp)
        whts(i)=fp-fm
        whts(n-i+1)=whts(i)
 2200 continue
        return
        end
c
c
c
c
c
        subroutine legewhts(n,ts,whts,ifwhts)
        implicit double precision (a-h,o-z)
        dimension ts(*),whts(*)
c
c        this subroutine constructs the nodes and the
c        weights of the n-point gaussian quadrature on 
c        the interval [-1,1]
c
c                input parameters:
c
c  n - the number of nodes in the quadrature
c
c                output parameters:
c
c  ts - the nodes of the n-point gaussian quadrature
c  w - the weights of the n-point gaussian quadrature
c
c       . . . construct the array of initial approximations
c             to the roots of the n-th legendre polynomial
c
        eps=1.0d-14
        done = 1
        pi=datan(done)*4
        h=pi/(2.0d0*n)


        do i=1,n
          t=(2*i-1)*h
          ts(n-i+1)=cos(t)
        enddo

c
c         use newton to find all roots of the legendre polynomial
c
        ts(n/2+1)=0
        do 2000 i=1,n/2
c
        xk=ts(i)
        ifout=0
        deltold=1
        do 1400 k=1,10
        call legepol_sum(xk,n,pol,der,sum)
        delta=-pol/der
        xk=xk+delta
        if(abs(delta) .lt. eps) ifout=ifout+1
c
        if(ifout .eq. 3) goto 1600
 1400 continue
 1600 continue
        ts(i)=xk
        ts(n-i+1)=-xk
 2000 continue
c     
c        construct the weights via the orthogonality relation
c
        if(ifwhts .eq. 0) return
c
        do 2400 i=1,(n+1)/2
        call legepol_sum(ts(i),n,pol,der,sum)
        whts(i)=1/sum
        whts(n-i+1)=whts(i)
 2400 continue
c
        return
        end
c
c
c
c
c
        subroutine legepol_sum(x,n,pol,der,sum)
        implicit double precision (a-h,o-z)
c
        done=1
        sum=0 
c
        pkm1=1
        pk=x
        sum=sum+pkm1**2 /2
        sum=sum+pk**2 *(1+done/2)
c
        pk=1
        pkp1=x
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200

        sum=0 
c
        pol=1
        der=0
        sum=sum+pol**2 /2
        if(n .eq. 0) return
c
        pol=x
        der=1
        sum=sum+pol**2*(1+done/2)
        return
 1200 continue
c
c       n is greater than 1. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
        sum=sum+pkp1**2*(k+1+done/2)
 2000 continue
c
c        calculate the derivative
c
        pol=pkp1
        der=n*(x*pkp1-pk)/(x**2-1)
        return
        end
c
c
c
c
c
        subroutine legepol(x,n,pol,der)
        implicit double precision (a-h,o-z)
c
        pkm1=1
        pk=x
c
        pk=1
        pkp1=x
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
        pol=1
        der=0
        if(n .eq. 0) return
c
        pol=x
        der=1
        return
 1200 continue
c
c       n is greater than 1. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
 2000 continue
c
c        calculate the derivative
c
        pol=pkp1
        der=n*(x*pkp1-pk)/(x**2-1)
        return
        end
c
c
c
c
c
        subroutine prodend(x,xs,n,i,f)
        implicit double precision (a-h,o-z)
        dimension xs(*)
c
c      evaluate the product
c
        f=1
        dlarge=1.0d20
        dsmall=f/dlarge
c
        large=0
        do 2000 j=1,n
        dd=dabs(f)
        if( dd .gt. dsmall) goto 1200
         f=f*10000
         large=large-1
 1200 continue
c
        if( dd .lt. dlarge) goto 1400
        f=f/10000
        large=large+1
 1400 continue
        if(j .eq. i) goto 2000
        f=f*(x-xs(j))/(xs(i)-xs(j))
 2000 continue
        d10000=10000
        f=f*d10000**large
        f=f**2*(x-xs(i))
        return
        end
c
c
c
c
c
        subroutine legepols(x,n,pols)
        implicit double precision (a-h,o-z)
        dimension pols(*)
c
        pkm1=1
        pk=x
c
        pk=1
        pkp1=x
c
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
        pols(1)=1
        if(n .eq. 0) return
c
        pols(2)=x
        return
 1200 continue
c
        pols(1)=1
        pols(2)=x
c
c       n is greater than 2. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
        pols(k+2)=pkp1
 2000 continue
c
        return
        end

c
c
c
c
c
      SUBROUTINE legepolders(X,VALs,ders,N)
      IMPLICIT double precision (A-H,O-Z)
      double precision vals(*),ders(*)
C
C     This subroutine computes the values and the derivatives
c     of n+1 first Legendre polynomials at the point x 
C     in interval [-1,1].
c
c                input parameters:
c
C     X = evaluation point
C     N  = order of expansion 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VALs = computed values of Legendre polynomials
C     ders = computed values of the derivatives
C
C


        done=1
        pjm2=1
        pjm1=x
        derjm2=0
        derjm1=1
c
        vals(1)=1
        ders(1)=0
c
        vals(2)=x
        ders(2)=1
c
        DO 600 J = 2,N
c
        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
        derj=(2*j-1)*(pjm1+x*derjm1)-(j-1)*derjm2
c
        derj=derj/j

        vals(j+1)=pj
        ders(j+1)=derj
c 
        pjm2=pjm1
        pjm1=pj
        derjm2=derjm1
        derjm1=derj
 600   CONTINUE
c
      RETURN
      END
c
c
c
c
c
        subroutine legepls2(x,n,pols)
        implicit double precision (a-h,o-z)
        dimension pols(*),pjcoefs1(2000),pjcoefs2(300)
        save
        data ifcalled/0/
c
c        if need be - initialize the arrays pjcoefs1, pjcoefs2
c
        if(ifcalled .eq. 1) goto 1100
c
        done=1
        ninit=290
        do 1050 j=2,ninit
c
        pjcoefs1(j)=(2*j-done)/j
        pjcoefs2(j)=-(j-done)/j
c
 1050 continue
c 
        ifcalled=1
 1100 continue

        pkm1=1
        pk=x
c
        pk=1
        pkp1=x
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
        pols(1)=1
        if(n .eq. 0) return
c
        pols(2)=x
        return
 1200 continue
c
        pols(1)=1
        pols(2)=x
c
c       n is greater than 2. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
        pkp1=x*pk*pjcoefs1(k+1)+pkm1*pjcoefs2(k+1)
        pols(k+2)=pkp1
 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legeinmt(n,ainte,adiff,x,whts,endinter,
     1      itype,w)
        implicit double precision (a-h,o-z)
        dimension ainte(*),w(*),x(*),whts(*),adiff(*),endinter(*)
c
c
c        for the user-specified n, this subroutine constructs
c        the matrices of spectral indefinite integration and/or
c        spectral differentiation on the n Gaussian nodes 
c        on the interval [-1,1]. Actually, this is omnly a 
c        memory management routine. All the actual work is done
c        by the subroutine legeinm0 (see)
c
c                           input parameters:
c
c  n - the number of Gaussian nodes on the interval [-1,1]
c  itype - the type of the calculation to be performed
c          EXPLANATION: 
c       itype=1 means that only the matrix ainte will 
c               be constructed
c       itype=2 means that only the matrix adiff will 
c               be constructed
c       itype=3 means that both matrices ainte and adiff
c               will be constructed
c
c                           output paramaters:
c
c  ainte - the matrix of spectral indefinite integration on 
c          the Gaussian nodes
c  adiff - the matrix of spectral differentiation on 
c          the Gaussian nodes
c  x - the n Gaussian nodes on the intervl [-1,1]
c  whts - the n Gaussian weights on the interval [-1,1]
c  endinter - the interpolation coefficients converting the 
c          values of a function at n Gaussian nodes into its
c          value at 1 (the right end of the interval)
c
c                           work arrays:
c
c  w - must be 3* n**2 + 2*n +50 *8 locations long
c
c        . . . allocate memory for the construction of the integrating
c              matrix
c
        ipolin=1
        lpolin=n+5
c
        ipolout=ipolin+lpolin
        lpolout=n+5
c
        iu=ipolout+lpolout
        lu=n**2+1
c
        iv=iu+lu
        lv=n**2+1
c
        iw=iv+lv
        lw=n**2+1
c
        ltot=iw+lw
c
c        construct the integrating matrix
c
        call legeinm0(n,ainte,adiff,w(ipolin),w(ipolout),
     1      x,whts,w(iu),w(iv),w(iw),itype,endinter)
c
        return
        end
c
c
c
c
c
        subroutine legeinm0(n,ainte,adiff,polin,polout,
     1      x,whts,u,v,w,itype,endinter)
        implicit double precision (a-h,o-z)
        dimension ainte(n,n),u(n,n),v(n,n),w(n,n),
     1      endinter(*),x(n),whts(n),polin(n),polout(n),
     2      adiff(n,n)
c
c        for the user-specified n, this subroutine constructs
c        the matrices of spectral indefinite integration and/or
c        spectral differentiation on the n Gaussian nodes 
c        on the interval [-1,1]
c
c                           input parameters:
c
c  n - the number of Gaussian nodes on the interval [-1,1]
c  itype - the type of the calculation to be performed
c          EXPLANATION: 
c       itype=1 means that only the matrix ainte will 
c               be constructed
c       itype=2 means that only the matrix adiff will 
c               be constructed
c       itype=3 means that both matrices ainte and adiff
c               will be constructed
c
c                           output paramaters:
c
c  ainte - the matrix of spectral indefinite integration on 
c          the Gaussian nodes
c  adiff - the matrix of spectral differentiation on 
c          the Gaussian nodes
c  x - the n Gaussian nodes on the intervl [-1,1]
c  whts - the n Gaussian weights on the interval [-1,1]
c
c                           work arrays:
c
c  polin, polout - must be n+3 double precision locations each
c
c  u, v, w - must be n**2+1 double precision locations each
c
c        . . . construct the matrices of the forward and inverse 
c              Legendre transforms
c
        itype2=2
        call legeexps(itype2,n,x,u,v,whts)
c
cccc         call prin2('after legeexps, u=*',u,n*n)
c
c        if the user so requested,
c        construct the matrix converting the coefficients of
c        the Legendre series of a function into the coefficients
c        of the indefinite integral of that function
c
        if(itype. eq. 2) goto 2000
c
        do 1600 i=1,n
c
        do 1200 j=1,n+2
        polin(j)=0
 1200 continue
c
        polin(i)=1
c
        call legeinte(polin,n,polout)
c
        do 1400 j=1,n
        ainte(j,i)=polout(j)
 1400 continue
c
 1600 continue
c
cccc         call prin2('ainte initially is*',ainte,n*n)
c
c        multiply the three, obtaining the integrating matrix
c
        call matmul(ainte,u,w,n)
        call matmul(v,w,ainte,n)
c
 2000 continue
c
c        if the user so requested,
c        construct the matrix converting the coefficients of
c        the Legendre series of a function into the coefficients
c        of the derivative of that function
c
        if(itype. eq. 1) goto 3000
c
        do 2600 i=1,n
c
        do 2200 j=1,n+2
        polin(j)=0
 2200 continue
c
        polin(i)=1
c
        call legediff(polin,n,polout)
c
        do 2400 j=1,n
        adiff(j,i)=polout(j)
cccc        ainte(i,j)=polout(j)
 2400 continue
c
 2600 continue
c
cccc         call prin2('adiff initially is*',adiff,n*n)
c
c        multiply the three, obtaining the integrating matrix
c
        call matmul(adiff,u,w,n)
        call matmul(v,w,adiff,n)
c
 3000 continue
c
c        construct the vector of interpolation coefficients
c        converting the values of a polynomial at the Gaussian
c        nodes into its value at the right end of the interval
c
        do 3400 i=1,n
c
        d=0
        do 3200 j=1,n
        d=d+u(j,i)
 3200 continue
        endinter(i)=d
 3400 continue
c
        return
        end
c
c
c
c
c
        subroutine legeinte(polin,n,polout)
        implicit double precision (a-h,o-z)
        dimension polin(*),polout(*)
c
c       this subroutine computes the indefinite integral of the 
c       legendre expansion polin getting the expansion polout
c
c
c                       input parameters:
c
c  polin - the legendre expansion to be integrated
c  n - the order of the expansion polin 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c         also nothe that the order of the integrated expansion is
c         n+1 (who could think!)
c
c                       output parameters:
c
c  polout - the legendre expansion of the integral of the function 
c         represented by the expansion polin
c
        do 1200 i=1,n+2
        polout(i)=0
 1200 continue
c
        do 2000 k=2,n+1
        j=k-1
c
cccc        polout(k+1)=polin(k)/(2*j+1)+polout(k+1)
        polout(k+1)=polin(k)/(2*j+1)
        polout(k-1)=-polin(k)/(2*j+1)+polout(k-1)
c
 2000 continue
c
        polout(2)=polin(1)+polout(2)
c
        dd=0
        sss=-1
        do 2200 k=2,n+1
c
        dd=dd+polout(k)*sss
        sss=-sss
 2200 continue
c
ccc        call prin2('dd=*',dd,1)
        polout(1)=-dd
c
        return
        end
c
c
c
c
c
        subroutine legediff(polin,n,polout)
        implicit double precision (a-h,o-z)
        dimension polin(*),polout(*)
c
c       this subroutine differentiates the legendre 
c       expansion polin getting the expansion polout
c
c
c                       input parameters:
c
c  polin - the legendre expansion to be differentiated
c  n - the order of the expansion polin 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c         also nothe that the order of the integrated expansion is
c         n+1 (who could think!)
c
c                       output parameters:
c
c  polout - the legendre expansion of the derivative of the function 
c         represented by the expansion polin
c
        do 1200 k=1,n+1
        polout(k)=0
 1200 continue
c
        pk=polin(n+1)
        pkm1=polin(n)
        pkm2=0
        do 2000 k=n+1,2,-1
c
        j=k-1
c         
        polout(k-1)=pk*(2*j-1)
        if(k .ge. 3) pkm2=polin(k-2)+pk
c
        pk=pkm1
        pkm1=pkm2
c
 2000 continue
         return
         end
c
c
c
c
c
      SUBROUTINE legeFDER(X,VAL,der,PEXP,N)
      IMPLICIT double precision (A-H,O-Z)
      double precision PEXP(*)
C
C     This subroutine computes the value and the derivative
c     of a gaussian expansion with coefficients PEXP
C     at point X in interval [-1,1].
c
c                input parameters:
c
C     X = evaluation point
C     PEXP = expansion coefficients
C     N  = order of expansion 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VAL = computed value
C     der = computed value of the derivative
C
C


        done=1
        pjm2=1
        pjm1=x
        derjm2=0
        derjm1=1
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 600 J = 2,N
c
        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
        val=val+pexp(j+1)*pj
c
        derj=(2*j-1)*(pjm1+x*derjm1)-(j-1)*derjm2
c
        derj=derj/j
        der=der+pexp(j+1)*derj
c 
        pjm2=pjm1
        pjm1=pj
        derjm2=derjm1
        derjm1=derj
 600   CONTINUE
c
      RETURN
      END


c
c
c
c
c
      SUBROUTINE legeFDE2(X,VAL,der,PEXP,N,
     1    pjcoefs1,pjcoefs2,ninit)
      IMPLICIT double precision (A-H,O-Z)
      double precision PEXP(*),pjcoefs1(*),pjcoefs2(*)
c
C     This subroutine computes the value and the derivative
c     of a gaussian expansion with coefficients PEXP
C     at point X in interval [-1,1].
c
c                input parameters:
c
C  X - evaluation point
C  PEXP - expansion coefficients
C  N  - order of expansion 
c  pjcoefs1, pjcoefs2 - two arrays precomputed on a previous call 
c      on a previous call to this subroutine. Please note that this
c      is only an input parameter if the parameter ninit (see below) 
c      has been set to 0; otherwise, these are output parameters
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit
c       elements of each of the arrays pjcoefs1, pjcoefs2. On the first 
c       call to this subroutine, ninit should be set to the maximum 
c       order n for which this subroutine might have to be called; 
c       on subsequent calls, ninit should be set to 0. PLEASE NOTE 
c       THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEEXE2. If these arrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C  VAL - computed value
C  der - computed value of the derivative
C
C
        if(ninit .eq. 0) goto 1400
c
        done=1
        do 1200 j=2,ninit
c
        pjcoefs1(j)=(2*j-done)/j
        pjcoefs2(j)=-(j-done)/j
c
 1200 continue
c 
        ifcalled=1
 1400 continue
c
        pjm2=1
        pjm1=x
        derjm2=0
        derjm1=1
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 1600 J = 2,N
c
cccc        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
c
        pj= pjcoefs1(j)*x*pjm1+pjcoefs2(j)*pjm2


        val=val+pexp(j+1)*pj
c
cccc        derj=(2*j-1)*(pjm1+x*derjm1)-(j-1)*derjm2
        derj=pjcoefs1(j)*(pjm1+x*derjm1)+pjcoefs2(j)*derjm2

ccc         call prin2('derj=*',derj,1)


cccc        derj=derj/j
        der=der+pexp(j+1)*derj
c 
        pjm2=pjm1
        pjm1=pj
        derjm2=derjm1
        derjm1=derj
 1600   CONTINUE
c
      RETURN
      END
c
c
c
c
c
      SUBROUTINE legeexev(X,VAL,PEXP,N)
      IMPLICIT double precision (A-H,O-Z)
      double precision PEXP(*)
C
C     This subroutine computes the value o a Legendre
c     expansion with coefficients PEXP at point X in interval [-1,1]
C
c                input parameters:
c
C     X = evaluation point
C     PEXP = expansion coefficients
C     N  = order of expansion 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VAL = computed value
C
        done=1
        pjm2=1
        pjm1=x
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 600 J = 2,N
c
        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
        val=val+pexp(j+1)*pj
c
        pjm2=pjm1
        pjm1=pj
 600   CONTINUE
c
        RETURN
        END
c
c
c
c
c
      SUBROUTINE legeexe2(X,VAL,PEXP,N,
     1      pjcoefs1,pjcoefs2,ninit)
      IMPLICIT double precision (A-H,O-Z)
      double precision PEXP(*),pjcoefs1(*),pjcoefs2(*)
c
C     This subroutine computes the value o a Legendre
c     expansion with coefficients PEXP at point X in interval [-1,1]
C
c                input parameters:
c
C     X = evaluation point
C     PEXP = expansion coefficients
C     N  = order of expansion 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VAL = computed value
C
        done=1
        if(ninit .eq. 0) goto 1400
c
        done=1
        do 1200 j=2,ninit
c
        pjcoefs1(j)=(2*j-done)/j
        pjcoefs2(j)=-(j-done)/j
c
 1200 continue
c 
        ifcalled=1
 1400 continue
c
        pjm2=1
        pjm1=x
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 600 J = 2,N
c
        pj= pjcoefs1(j)*x*pjm1+pjcoefs2(j)*pjm2

cccc        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
        val=val+pexp(j+1)*pj
c
        pjm2=pjm1
        pjm1=pj
 600   CONTINUE
c
        RETURN
        END
c
c
c
c
c
        subroutine lematrin(n,m,xs,amatrint,ts,w)
        implicit double precision (a-h,o-z)
        dimension amatrint(m,n),xs(*),w(*),ts(*)
c
c
c        This subroutine constructs the matrix interpolating
c        functions from the n-point Gaussian grid on the interval [-1,1]
c        to an arbitrary m-point grid (the nodes of the latter are
c        user-provided)
c
c                 Input parameters:
c
c  n - the number of interpolation nodes
c  m - the number of nodes to which the functions will be interpolated
c  xs - the points at which the function is to be interpolated
c
c                  Output parameters:
c
c  amatrint - the m \times n matrix conerting the values of a function
c        at the n Legendre nodes into its values at m user-specified
c        (arbitrary) nodes
c  ts - the n Gaussian nodes on the interval [-1,1]
c
c                  Work arrays:
c
c  w - must be at least 2*n**2+n + 100 double precision locations long 
c

        icoefs=1
        lcoefs=n+2
c
        iu=icoefs+lcoefs
        lu=n**2+10
c
        iv=iu+lu
c
        ifinit=1
        do 2000 i=1,m
c
        call levecin(n,xs(i),ts,w(iu),w(iv),w(icoefs),ifinit)
c
        do 1400 j=1,n
        amatrint(i,j)=w(j)
 1400 continue
c
        ifinit=0
 2000 continue
c
        return
        end

c
c
c
c
c
        subroutine levecin(n,x,ts,u,v,coefs,ifinit)
        implicit double precision (a-h,o-z)
        dimension u(n,n),v(n,n),ts(*),coefs(*)
c
c        This subroutine constructs the coefficients of the 
c        standard interpolation formula connecting the values of a 
c        function at n Gaussian nodes on the interval [a,b] with
c        its value at the point x \in R^1
c
c                 Input parameters:
c
c  n - the number of interpolation nodes
c  x - the points at which the function is to be interpolated
c  ts - the n Gaussian nodes on the interval [-1,1]; please note that
c        it is an input parameter only if the parameter ifinit (see 
c        below) has been set to 1; otherwise, it is an output parameter
c  u - the n*n matrix converting the  values at of a polynomial of order
c         n-1 at n legendre nodes into the coefficients of its 
c        legendre expansion; please note that
c        it is an input parameter only if the parameter ifinit (see 
c        below) has been set to 1; otherwise, it is an output parameter
c  ifinit - an integer parameter telling the subroutine whether it should
c        initialize the Legendre expander; 
c     ifinit=1 will cause the subroutine to perform the initialization
c     ifinit=0 will cause the subroutine to  skip the initialization
c
c                  Output parameters:
c
c  coefs - the interpolation coefficients
c
c                 Work arrays: 
c
c  v - must be at least n*n double precision locations long
c
c       . . . construct the n Gausian nodes on the interval [-1,1]; 
c             also the corresponding Gaussian expansion-evaluation 
c             matrices
c
        itype=2
        if(ifinit .ne.0) call legeexps(itype,n,ts,u,v,coefs)
c
c       evaluate the n Legendre polynomials at the point where the
c       functions will have to be interpolated
c
        call legepols(x,n+1,v)
c
c       apply the interpolation matrix to the ector of values 
c       of polynomials from the right 
c
        call lematvec(u,v,coefs,n)
        return
        end
c
c
c
c
c
        subroutine lematvec(a,x,y,n)
        implicit double precision (a-h,o-z)
        dimension a(n,n),x(n),y(n)
c
        do 1400 i=1,n
        d=0
        do 1200 j=1,n
        d=d+a(j,i)*x(j)
 1200 continue
        y(i)=d
 1400 continue
        return
        end
c
c
c
c
c
        subroutine matmul(a,b,c,n)
        implicit double precision (a-h,o-z)
        dimension a(n,n),b(n,n),c(n,n)
c
        do 2000 i=1,n
        do 1800 j=1,n
        d=0
        do 1600 k=1,n
        d=d+a(i,k)*b(k,j)
 1600 continue
        c(i,j)=d
 1800 continue
 2000 continue
        return
c
c
c
c
        entry matmua(a,b,c,n)
ccc          call prin2('in matmua, a=*',a,n**2)
ccc          call prin2('in matmua, b=*',b,n**2)
        do 3000 i=1,n
        do 2800 j=1,n
        d=0
        do 2600 k=1,n
        d=d+a(i,k)*b(j,k)
 2600 continue
        c(i,j)=d
 2800 continue
 3000 continue
ccc          call prin2('exiting, c=*',c,n**2)
        return
        end

c
c
c
c
c
        subroutine legeodev(x,nn,coefs,val,ninit,
     1      coepnm1,coepnp1,coexpnp1)
        implicit double precision (a-h,o-z)
        dimension coepnm1(*),coepnp1(*),
     1            coexpnp1(*),coefs(*)
c
c
c       This subroutine evaluates at the point x a Legendre expansion
c       having only odd-numbered elements
c
c                  Input parameters:
c
c  x - point on the interval [-1,1] at which the Legendre expansion 
c       is to be evaluated
c  nn - order of the expansion to be evaluated
c  coefs - odd-numbered coefficients of the Legendre expansion
c       to be evaluated at the point x (nn/2+2 of them things)
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit/2+2
c                  (or so) elements of each of the arrays  coepnm1,
c       coepnp1, coexpnp1. On the first call to this subroutine, ninit 
c       should be set to the maximum order nn for which this subroutine 
c       might have to be called; on subsequent calls, ninit should be 
c       set to 0. PLEASE NOTE THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEPODD. IF these arrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are input arrays only if ninit 
c       (see above) has been set to 0; otherwise, these are output arrays.
c 
c                  Output parameters:
c
c  val - the value at the point x of the Legendre expansion with 
c       coefficients coefs (see above) 
c    EXPLANATION: On exit from the subroutine, pols(1) = P_0 (x),
c       pols(2) = P_2(x), pols(3) =P_4(x),  etc.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are output parameters only if ninit 
c       (see above) has not been set to 0; otherwise, these are input 
c       parameters
c 
c       
        if(ninit .eq. 0) goto 1400
        done=1
        n=0
        i=0
c
        do 1200 nnn=2,ninit,2
c
        n=n+2
        i=i+1
c
        coepnm1(i)=-(5*n+7*(n*done)**2+2*(n*done)**3)
        coepnp1(i)=-(9+24*n+18*(n*done)**2+4*(n*done)**3)
        coexpnp1(i)=15+46*n+36*(n*done)**2+8*(n*done)**3
c
        d=(2+n*done)*(3+n*done)*(1+2*n*done)
        coepnm1(i)=coepnm1(i)/d
        coepnp1(i)=coepnp1(i)/d
        coexpnp1(i)=coexpnp1(i)/d
c
 1200 continue
c
 1400 continue
c
        x22=x**2
c
        pi=x
        pip1=x*(2.5d0*x22-1.5d0)
c
        val=coefs(1)*pi+coefs(2)*pip1

        do 2000 i=1,nn/2-2
c
        pip2 = coepnm1(i)*pi +
     1      (coepnp1(i)+coexpnp1(i)*x22)*pip1
c
        val=val+coefs(i+2)*pip2
c
        pi=pip1
        pip1=pip2


 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legeevev(x,nn,coefs,val,ninit,
     1      coepnm1,coepnp1,coexpnp1)
        implicit double precision (a-h,o-z)
        dimension coepnm1(*),coepnp1(*),
     1            coexpnp1(*),coefs(*)
c
c
c       This subroutine evaluates at the point x a Legendre expansion
c       having only even-numbered elements
c
c                  Input parameters:
c
c  x - point on the interval [-1,1] at which the Legendre expansion 
c       is to be evaluated
c  nn - order of the expansion to be evaluated
c  coefs - even-numbered coefficients of the Legendre expansion
c       to be evaluated at the point x (nn/2+2 of them things)
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit/2+2
c                  (or so) elements of each of the arrays  coepnm1,
c       coepnp1, coexpnp1. On the first call to this subroutine, ninit 
c       should be set to the maximum order nn for which this subroutine 
c       might have to be called; on subsequent calls, ninit should be 
c       set to 0. PLEASE NOTE THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEPEVEN. IF these aqrrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are input arrays only if ninit 
c       (see above) has been set to 0; otherwise, these are output arrays.
c 
c                  Output parameters:
c
c  val - the value at the point x of the Legendre expansion with 
c       coefficients coefs (see above) 
c    EXPLANATION: On exit from the subroutine, pols(1) = P_0 (x),
c       pols(2) = P_2(x), pols(3) =P_4(x),  etc.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are output parameters only if ninit 
c       (see above) has not been set to 0; otherwise, these are input 
c       parameters
c       
        if(ninit .eq. 0) goto 1400
c
        done=1
        n=-1
        i=0
        do 1200 nnn=1,ninit,2
c
        n=n+2
        i=i+1
c
        coepnm1(i)=-(5*n+7*(n*done)**2+2*(n*done)**3)
        coepnp1(i)=-(9+24*n+18*(n*done)**2+4*(n*done)**3)
        coexpnp1(i)=15+46*n+36*(n*done)**2+8*(n*done)**3
c
        d=(2+n*done)*(3+n*done)*(1+2*n*done)
        coepnm1(i)=coepnm1(i)/d
        coepnp1(i)=coepnp1(i)/d
        coexpnp1(i)=coexpnp1(i)/d
c
 1200 continue
c
 1400 continue
c
        x22=x**2
c
        pi=1
        pip1=1.5d0*x22-0.5d0
c
        val=coefs(1)+coefs(2)*pip1
c
c       n is greater than 2. conduct recursion
c
        do 2000 i=1,nn/2-2
c
        pip2 = coepnm1(i)*pi +
     1      (coepnp1(i)+coexpnp1(i)*x22) *pip1
        val=val+coefs(i+2)*pip2
c
        pi=pip1
        pip1=pip2
c
 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legepeven(x,nn,pols,ninit,
     1      coepnm1,coepnp1,coexpnp1)
        implicit double precision (a-h,o-z)
        dimension pols(*),coepnm1(*),coepnp1(*),
     1            coexpnp1(*)
c
c       This subroutine evaluates even-numbered Legendre polynomials 
c       of the argument x, up to order nn+1
c
c                  Input parameters:
c
c  x - the argument for which the Legendre polynomials are 
c       to be evaluated
c  nn - the maximum order for which the Legendre polynomials are
c       to be evaluated
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine ill initialize the first ninit/2+2
c                  (or so) elements of each of the arrays  coepnm1,
c       coepnp1, coexpnp1. On the first call to this subroutine, ninit 
c       should be set to the maximum order nn for which this subroutine 
c       might have to be called; on subsequent calls, ninit should be 
c       set to 0.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are input arrays only if ninit 
c       (see above) has been set to 0; otherwise, these are output arrays.
c       PLEASE NOTE THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEEVEV. IF these aqrrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c 
c                  Output parameters:
c
c  pols - even-numbered Legendre polynomials of the input parameter x
c         (nn/2+2 of them things)
c    EXPLANATION: On exit from the subroutine, pols(1) = P_0 (x),
c       pols(2) = P_2(x), pols(3) =P_4(x),  etc.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are output parameters only if ninit 
c       (see above) has not been set to 0; otherwise, these are input 
c       parameters. PLEASE NOTE THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEEVEV. If these arrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c 
c       
        if(ninit .eq. 0) goto 1400
c
        done=1
        n=-1
        i=0
        do 1200 nnn=1,ninit,2
c
        n=n+2
        i=i+1
c
        coepnm1(i)=-(5*n+7*(n*done)**2+2*(n*done)**3)
        coepnp1(i)=-(9+24*n+18*(n*done)**2+4*(n*done)**3)
        coexpnp1(i)=15+46*n+36*(n*done)**2+8*(n*done)**3
c
        d=(2+n*done)*(3+n*done)*(1+2*n*done)
        coepnm1(i)=coepnm1(i)/d
        coepnp1(i)=coepnp1(i)/d
        coexpnp1(i)=coexpnp1(i)/d
c
 1200 continue
c
 1400 continue
c
        x22=x**2
c
        pols(1)=1
        pols(2)=1.5d0*x22-0.5d0
c
c       n is greater than 2. conduct recursion
c
        do 2000 i=1,nn/2
c
        pols(i+2) = coepnm1(i)*pols(i) +
     1      (coepnp1(i)+coexpnp1(i)*x22) *pols(i+1)
c
 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legepodd(x,nn,pols,ninit,
     1      coepnm1,coepnp1,coexpnp1)
        implicit double precision (a-h,o-z)
        dimension pols(*),coepnm1(*),coepnp1(*),
     1            coexpnp1(*)
c
c       This subroutine evaluates odd-numbered Legendre polynomials 
c       of the argument x, up to order nn+1
c
c                  Input parameters:
c
c  x - the argument for which the Legendre polynomials are 
c       to be evaluated
c  nn - the maximum order for which the Legendre polynomials are
c       to be evaluated
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit/2+2
c                  (or so) elements of each of the arrays  coepnm1,
c       coepnp1, coexpnp1. On the first call to this subroutine, ninit 
c       should be set to the maximum order nn for which this subroutine 
c       might have to be called; on subsequent calls, ninit should be 
c       set to 0.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are input arrays only if ninit 
c       (see above) has been set to 0; otherwise, these are output arrays.
c 
c                  Output parameters:
c
c  pols - the odd-numbered Legendre polynomials of the input parameter x
c         (nn/2+2 of them things)
c    EXPLANATION: On exit from the subroutine, pols(1) = P_1(x),
c       pols(2) = P_3(x), pols(3) = P_5 (x), etc.
c  coepnm1,coepnp1,coexpnp1 - should be nn/2+4 double precision elements long 
c       each. Please note that these are output parameters only if ninit 
c       (see above) has not been set to 0; otherwise, these are input 
c       parameters. PLEASE NOTE THAT THAT THESE ARRAYS USED BY THIS 
c       SUBROUTINE ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES 
c       SUSED BY THE UBROUTINE LEGEODEV. IF these arrays have been 
c       initialized by one of these two subroutines, they do not need 
c       to be initialized by the other one.
c       
        if(ninit .eq. 0) goto 1400
        done=1
        n=0
        i=0
c
        do 1200 nnn=2,ninit,2
c
        n=n+2
        i=i+1
c
        coepnm1(i)=-(5*n+7*(n*done)**2+2*(n*done)**3)
        coepnp1(i)=-(9+24*n+18*(n*done)**2+4*(n*done)**3)
        coexpnp1(i)=15+46*n+36*(n*done)**2+8*(n*done)**3
c
        d=(2+n*done)*(3+n*done)*(1+2*n*done)
        coepnm1(i)=coepnm1(i)/d
        coepnp1(i)=coepnp1(i)/d
        coexpnp1(i)=coexpnp1(i)/d
c
 1200 continue
c
 1400 continue
c
        x22=x**2
c
        pols(1)=x
        pols(2)=x*(2.5d0*x22-1.5d0)
c
        do 2000 i=1,nn/2
c
        pols(i+2) = coepnm1(i)*pols(i) +
     1      (coepnp1(i)+coexpnp1(i)*x22)*pols(i+1)
c
 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legefdeq(x,val,der,coefs,n)
        implicit double precision (a-h,o-z)
        dimension coefs(*)
C
C     This subroutine computes the value and the derivative
c     of a Legendre Q-expansion with coefficients coefs
C     at point X in interval (-1,1); please note that this is
c     the evil twin of the subroutine legefder, evaluating the
c     proper (P-function) Legendre expansion
c
c                input parameters:
c
C  X = evaluation point
C  coefs = expansion coefficients
C  N  = order of expansion 
c
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VAL = computed value
C     der = computed value of the derivative
C
c
        val=0
        der=0
c
        d= log( (1+x) /(1-x) ) /2
        pkm1=d
        pk=d*x-1
c
        pk=d
        pkp1=d*x-1

        derk=(1/(1+x)+1/(1-x)) /2
        derkp1=d + derk *x 
c
        val=coefs(1)*pk+coefs(2)*pkp1
        der=coefs(1)*derk+coefs(2)*derkp1
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
c
        if(n .eq. 0) return
c
        return
 1200 continue
c
c       n is greater than 2. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
c
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
c
        derkm1=derk
        derk=derkp1
c
        derkp1= ( (2*k+1)*pk+(2*k+1)*x*derk - k*derkm1 )/(k+1)
c
        val=val+coefs(k+2)*pkp1
        der=der+coefs(k+2)*derkp1
c
 2000 continue
c
        return
        end
c
c
c
c
c
        subroutine legeqs(x,n,pols,ders)
        implicit double precision (a-h,o-z)
        dimension pols(*),ders(*)
c
c       This subroutine calculates the values and derivatives of 
c       a bunch of Legendre Q-functions at the user-specified point 
c       x on the interval (-1,1)
c
c                     Input parameters:
c
c  x - the point on the interval [-1,1] where the Q-functions and 
c       their derivatives are to be evaluated
c  n - the highest order for which the functions are to be evaluated
c  
c                     Output parameters:
c
c  pols - the values of the Q-functions (the evil twins of the 
c       Legeendre polynomials) at the point x (n+1 of them things)
c  ders - the derivatives of the Q-functions (the evil twins of the 
c       Legeendre polynomials) at the point x (n+1 of them things)
c  
c
        d= log( (1+x) /(1-x) ) /2
        pkm1=d
        pk=d*x-1
c
        pk=d
        pkp1=d*x-1

        derk=(1/(1+x)+1/(1-x)) /2
        derkp1=d + derk *x 
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
        pols(1)=pk
        ders(1)=derk
        if(n .eq. 0) return
c
        pols(2)=pkp1
        ders(2)=derkp1
        return
 1200 continue
c
        pols(1)=pk
        pols(2)=pkp1
c
c       n is greater than 2. conduct recursion
c
        ders(1)=derk
        ders(2)=derkp1
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
c
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
        pols(k+2)=pkp1
c
        derkm1=derk
        derk=derkp1
c
        derkp1= ( (2*k+1)*pk+(2*k+1)*x*derk - k*derkm1 )/(k+1)
        ders(k+2)=derkp1
 2000 continue
c
        return
        end
c
c
c
c
c


        subroutine legeq(x,n,pol,der)
        implicit double precision (a-h,o-z)
c
c       This subroutine calculates the value and derivative of 
c       a Legendre Q-function at the user-specified point 
c       x on the interval (-1,1)
c
c
c                     Input parameters:
c
c  x - the point on the interval [-1,1] where the Q-functions and 
c       their derivatives are to be evaluated
c  n - the order for which the function is to be evaluated
c  
c                     Output parameters:
c
c  pol - the value of the n-th Q-function (the evil twin of the 
c       Legeendre polynomial) at the point x 
c  ders - the derivatives of the Q-function at the point x 
c  
c
        d= log( (1+x) /(1-x) ) /2
        pk=d
        pkp1=d*x-1
c
c        if n=0 or n=1 - exit
c
        if(n .ge. 2) goto 1200
        pol=d

        der=(1/(1+x)+1/(1-x)) /2

        if(n .eq. 0) return
c
        pol=pkp1
        der=d + der *x 
        return
 1200 continue
c
c       n is greater than 1. conduct recursion
c
        do 2000 k=1,n-1
        pkm1=pk
        pk=pkp1
        pkp1=( (2*k+1)*x*pk-k*pkm1 )/(k+1)
 2000 continue
c
c        calculate the derivative
c
        pol=pkp1
        der=n*(x*pkp1-pk)/(x**2-1)
        return
        end

c
c
c
c
c
      SUBROUTINE legecFDE(X,VAL,der,PEXP,N)
      IMPLICIT double precision (A-H,O-Z)
      double complex PEXP(*),val,der
C
C     This subroutine computes the value and the derivative
c     of a gaussian expansion with complex coefficients PEXP
C     at point X in interval [-1,1].
c
c                input parameters:
c
C     X = evaluation point
C     PEXP = expansion coefficients
C     N  = order of expansion 
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C     VAL = computed value
C     der = computed value of the derivative
C
C
        done=1
        pjm2=1
        pjm1=x
        derjm2=0
        derjm1=1
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 600 J = 2,N
c
        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
        val=val+pexp(j+1)*pj
c
        derj=(2*j-1)*(pjm1+x*derjm1)-(j-1)*derjm2
c
        derj=derj/j
        der=der+pexp(j+1)*derj
c 
        pjm2=pjm1
        pjm1=pj
        derjm2=derjm1
        derjm1=derj
 600   CONTINUE
c
      RETURN
      END
c
c
c
c
c
      SUBROUTINE legecFD2(X,VAL,der,PEXP,N,
     1    pjcoefs1,pjcoefs2,ninit)
      IMPLICIT double precision (A-H,O-Z)
      double precision pjcoefs1(*),pjcoefs2(*)
      double complex PEXP(*),val,der
c
C     This subroutine computes the value and the derivative
c     of a Legendre expansion with complex coefficients PEXP
C     at point X in interval [-1,1].
c
c                input parameters:
c
C  X - evaluation point
C  PEXP - expansion coefficients
C  N  - order of expansion 
c  pjcoefs1, pjcoefs2 - two arrays precomputed on a previous call 
c      on a previous call to this subroutine. Please note that this
c      is only an input parameter if the parameter ninit (see below) 
c      has been set to 0; otherwise, these are output parameters
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit
c       elements of each of the arrays pjcoefs1, pjcoefs2. On the first 
c       call to this subroutine, ninit should be set to the maximum 
c       order n for which this subroutine might have to be called; 
c       on subsequent calls, ninit should be set to 0. PLEASE NOTE 
c       THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEEXE2. If these arrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C  VAL - computed value
C  der - computed value of the derivative
C
        if(ninit .eq. 0) goto 1400
c
        done=1
        do 1200 j=2,ninit
c
        pjcoefs1(j)=(2*j-done)/j
        pjcoefs2(j)=-(j-done)/j
c
 1200 continue
c 
        ifcalled=1
 1400 continue
c
        pjm2=1
        pjm1=x
        derjm2=0
        derjm1=1
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
        der=pexp(2)
c
        DO 1600 J = 2,N
c
cccc        pj= ( (2*j-1)*x*pjm1-(j-1)*pjm2 ) / j
c
        pj= pjcoefs1(j)*x*pjm1+pjcoefs2(j)*pjm2


        val=val+pexp(j+1)*pj
c
cccc        derj=(2*j-1)*(pjm1+x*derjm1)-(j-1)*derjm2
        derj=pjcoefs1(j)*(pjm1+x*derjm1)+pjcoefs2(j)*derjm2

ccc         call prin2('derj=*',derj,1)


cccc        derj=derj/j
        der=der+pexp(j+1)*derj
c 
        pjm2=pjm1
        pjm1=pj
        derjm2=derjm1
        derjm1=derj
 1600   CONTINUE
c
      RETURN
      END
c
c
c
c
c
      SUBROUTINE legecva2(X,VAL,PEXP,N,
     1    pjcoefs1,pjcoefs2,ninit)
      IMPLICIT double precision (A-H,O-Z)
      double precision pjcoefs1(*),pjcoefs2(*)
      double complex PEXP(*),val
c
C     This subroutine computes the value of a Legendre expansion 
c     with complex coefficients PEXP at point X in interval [-1,1].
c
c                input parameters:
c
C  X - evaluation point
C  PEXP - expansion coefficients
C  N  - order of expansion 
c  pjcoefs1, pjcoefs2 - two arrays precomputed on a previous call 
c      on a previous call to this subroutine. Please note that this
c      is only an input parameter if the parameter ninit (see below) 
c      has been set to 0; otherwise, these are output parameters
c  ninit - tells the subroutine whether and to what maximum order the 
c       arrays coepnm1,coepnp1,coexpnp1 should be initialized.
c     EXPLANATION: The subroutine will initialize the first ninit
c       elements of each of the arrays pjcoefs1, pjcoefs2. On the first 
c       call to this subroutine, ninit should be set to the maximum 
c       order n for which this subroutine might have to be called; 
c       on subsequent calls, ninit should be set to 0. PLEASE NOTE 
c       THAT THAT THESE ARRAYS USED BY THIS SUBROUTINE
c       ARE IDENTICAL TO THE ARRAYS WITH THE SAME NAMES USED BY THE 
c       SUBROUTINE LEGEEXE2. If these arrays have been initialized
c       by one of these two subroutines, they do not need to be 
c       initialized by the other one.
c
c   IMPORTANT NOTE: n is {\bf the order of the expansion, which is
c         one less than the number of terms in the expansion!!}
c
c                output parameters:
c
C  VAL - computed value
C
        if(ninit .eq. 0) goto 1400
c
        done=1
        do 1200 j=2,ninit
c
        pjcoefs1(j)=(2*j-done)/j
        pjcoefs2(j)=-(j-done)/j
c
 1200 continue
c 
        ifcalled=1
 1400 continue
c
        pjm2=1
        pjm1=x
c
        val=pexp(1)*pjm2+pexp(2)*pjm1      
c
        DO 1600 J = 2,N
c
        pj= pjcoefs1(j)*x*pjm1+pjcoefs2(j)*pjm2
        val=val+pexp(j+1)*pj
c
        pjm2=pjm1
        pjm1=pj
 1600   CONTINUE
c
      RETURN
      END

cc Copyright (C) 2009-2012: Leslie Greengard and Zydrunas Gimbutas
cc Contact: greengard@cims.nyu.edu
cc 
cc This software is being released under a modified FreeBSD license
cc (see COPYING in home directory). 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     This is the third release of the FMM3D library, together with
c     associated subroutines, which computes N-body interactions
c     governed by the Laplace or Helmholtz equations.
c  
c
      program testhelm
      implicit real *8 (a-h,o-z)
      implicit integer *8 (i-n)
      real *8, allocatable :: source(:,:),dipvec(:,:)
      complex *16, allocatable :: charge(:),dipstr(:)
      complex *16, allocatable :: pot(:),fld(:,:)

      complex *16, allocatable :: pot2(:),fld2(:,:)
        
      real *8, allocatable :: targ(:,:)
      complex *16, allocatable :: pottarg(:),fldtarg(:,:)
      complex *16, allocatable :: pottarg2(:),fldtarg2(:,:)
        
      complex *16 ptemp,ftemp(3)
c       
      complex *16 ima
      complex *16 zk
      data ima/(0.0d0,1.0d0)/
c
      done=1
      pi=4*atan(done)

      write(*,*) "============================="
      write(*,*) "Example fortran driver for legacy drivers"
      write(*,*) "On output tests potential at a few sources and targs"
c
c     Initialize simple printing routines. The parameters to prini
c     define output file numbers using standard Fortran conventions.
c
c     Calling prini(6,13) causes printing to the screen and to 
c     file fort.13.     
c
      call prini(6,13)
c
      nsource= 10000

      allocate(source(3,nsource),charge(nsource))
      allocate(dipstr(nsource),dipvec(3,nsource))
      allocate(pot(nsource),fld(3,nsource))
c
c     set Helmholtz parameter  (used only by H3D prefix routines)
c
      zk = 1.0d0 + ima*0.1d0
c
c     construct randomly located charge distribution on a unit sphere
c 
      d=hkrand(0)
      do i=1,nsource
        theta=hkrand(0)*pi
        phi=hkrand(0)*2*pi
        source(1,i)=.5d0*cos(phi)*sin(theta)
        source(2,i)=.5d0*sin(phi)*sin(theta)
        source(3,i)=.5d0*cos(theta)
      enddo
c
c     construct target distribution on a target unit sphere 
c
      ntarg=nsource
      allocate(targ(3,ntarg),pottarg(ntarg),fldtarg(3,ntarg))
      do i=1,ntarg
        theta=hkrand(0)*pi
        phi=hkrand(0)*2*pi
        targ(1,i)=.5d0*cos(phi)*sin(theta) 
        targ(2,i)=.5d0*sin(phi)*sin(theta)
        targ(3,i)=.5d0*cos(theta)
      enddo
c
c       
c     set precision flag
c
      iprec=1
c       
c     set source type flags and output flags
c
      ifpot=1
      iffld=0
c
      ifcharge=1
      ifdipole=1
c
      ifpottarg=1
      iffldtarg=0
c
c       set source strengths
c
      if (ifcharge .eq. 1 ) then
        do i=1,nsource
          charge(i)=hkrand(0) + ima*hkrand(0)
        enddo
      endif
c
      if (ifdipole .eq. 1) then
        do i=1,nsource
          dipstr(i)=hkrand(0) + ima*hkrand(0)
          dipvec(1,i)=hkrand(0)
          dipvec(2,i)=hkrand(0)
          dipvec(3,i)=hkrand(0)
        enddo
      endif

c
c     initialize timing call
c
        call cpu_time(t1)
C$        t1=omp_get_wtime()
c       
c     call FMM3D routine for sources and targets
c
        call hfmm3dparttarg(ier,iprec, zk,
     $     nsource,source,ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld,ntarg,targ,
     $     ifpottarg,pottarg,iffldtarg,fldtarg)

c       
c     get time for FMM call
c
        call cpu_time(t2)
C$        t2=omp_get_wtime()
c       
c       
      call prinf('nsource=*',nsource,1)
      call prinf('ntarg=*',ntarg,1)
      call prin2('after fmm, time (sec)=*',t2-t1,1)
      call prin2('after fmm, speed (points+targets/sec)=*',
     $     (nsource+ntarg)/(t2-t1),1)
c       
c     call direct calculation with subset of points to assess accuracy
c
      m=min(nsource,100)
c
c     ifprint=0 suppresses printing of source locations
c     ifprint=1 turns on printing of source locations
c
      ifprint=0
      if (ifprint .eq. 1) then
        call prin2('source=*',source,3*6)
      endif

      if (ifprint .eq. 1) then
        if( ifpot.eq.1 ) call prin2('after fmm, pot=*',pot,2*m)
        if( iffld.eq.1 ) call prin2('after fmm, fld=*',fld,3*2*m)
      endif

c
c       for direct calculation, initialize pot2,fld2 arrays to zero.
c
      allocate(pot2(m),fld2(3,m))
      do i=1,m
        if (ifpot .eq. 1) pot2(i)=0
        if (iffld .eq. 1) then
          fld2(1,i)=0
          fld2(2,i)=0
          fld2(3,i)=0
        endif
      enddo


      ifpottmp = 0
      iffldtmp = 0

        call cpu_time(t1)
C$        t1=omp_get_wtime()
     
      
      call prinf('m=*',m,1)
      call prinf('nsource=*',nsource,1)
      call prin2('source=*',source,12)
      call prinf('ifcharge=*',ifcharge,1)
      call prinf('ifdipole=*',ifdipole,1)
      call prinf('m=*',m,1)
      call prinf('ifpot=*',ifpot,1)
      call prinf('iffld=*',iffld,1)
      call h3dpartdirect(zk,nsource,source,ifcharge,charge,ifdipole,
     1       dipstr,dipvec,ifpottmp,pot2,iffldtmp,fld2,m,source,
     2       ifpot,pot2,iffld,fld2)

      
        call cpu_time(t2)
C$        t2=omp_get_wtime()
c
c       ifprint=1 turns on printing of first m values of potential and field
c
        if (ifprint .eq. 1) then
           if( ifpot.eq.1 ) call prin2('directly, pot=*',pot2,2*m)
           if( iffld.eq.1 ) call prin2('directly, fld=*',fld2,3*2*m)
        endif
c
        call prin2('directly, estimated time (sec)=*',
     $     (t2-t1)*dble(nsource)/dble(m),1)
        call prin2('directly, estimated speed (points/sec)=*',
     $     m/(t2-t1),1)
c       
        if (ifpot .eq. 1)  then
           call h3derror(pot,pot2,m,aerr,rerr)
           call prin2('relative L2 error in potential=*',rerr,1)
        endif
c
        if (iffld .eq. 1) then
           call h3derror(fld,fld2,3*m,aerr,rerr)
           call prin2('relative L2 error in field=*',rerr,1)
        endif

c
c
c          now evaluate potential directly at targets
c

      m=min(ntarg,100)
      allocate(pottarg2(m),fldtarg2(3,m))

      do i=1,m
        if (ifpottarg .eq. 1) pottarg2(i)=0
        if (iffldtarg .eq. 1) then
          fldtarg2(1,i)=0
          fldtarg2(2,i)=0
          fldtarg2(3,i)=0
        endif

      enddo




        call cpu_time(t1)
C$        t1=omp_get_wtime()
c
      call h3dpartdirect(zk,nsource,source,ifcharge,charge,ifdipole,
     1       dipstr,dipvec,ifpottmp,pot2,iffldtmp,fld2,m,targ,
     2       ifpottarg,pottarg2,iffldtarg,fldtarg2)
        call cpu_time(t2)
C$        t2=omp_get_wtime()
c
c
c
        if (ifprint .eq. 1) then
           if( ifpottarg.eq.1 ) 
     $        call prin2('after fmm, pottarg=*',pottarg,2*m)
           if( iffldtarg.eq.1 ) 
     $        call prin2('after fmm, fldtarg=*',fldtarg,3*2*m)
        endif

        if (ifprint .eq. 1) then
           if (ifpottarg .eq. 1) 
     $        call prin2('directly, pottarg=*',pottarg2,2*m)
           if( iffldtarg.eq.1 ) 
     $        call prin2('directly, fldtarg=*',fldtarg2,3*2*m)
        endif
c
        call prin2('directly, estimated time (sec)=*',
     $     (t2-t1)*dble(ntarg)/dble(m),1)
        call prin2('directly, estimated speed (targets/sec)=*',
     $     m/(t2-t1),1)
c       
        if (ifpottarg .eq. 1) then
           call h3derror(pottarg,pottarg2,m,aerr,rerr)
           call prin2('relative L2 error in target potential=*',rerr,1)
        endif
c
        if (iffldtarg .eq. 1) then
           call h3derror(fldtarg,fldtarg2,3*m,aerr,rerr)
           call prin2('relative L2 error in target field=*',rerr,1)
        endif
c       
        stop
        end
c
c
c
c
        subroutine h3derror(pot1,pot2,n,ae,re)
        implicit real *8 (a-h,o-z)
c
c       evaluate absolute and relative errors
c
        complex *16 pot1(n),pot2(n)
c
        d=0
        a=0
c       
        do i=1,n
           d=d+abs(pot1(i)-pot2(i))**2
           a=a+abs(pot1(i))**2
        enddo
c       
        d=d/n
        d=sqrt(d)
        a=a/n
        a=sqrt(a)
c       
        ae=d
        re=d/a
c       
        return
        end
c
c
c

c      This file contains the direct evaluation kernels for Laplace FMM
c
c      l3ddirectcp: direct calculation of potential for a collection
c                     of charge sources to a collection of targets
c 
c      l3ddirectcg: direct calculation of potential and gradients 
c                   for a collection of charge sources to a 
c                   collection of targets
c 
c      l3ddirectch: direct calculation of potential, gradients and
c                   hessians for a collection of charge sources to a
c                   collection of targets
c 
c      l3ddirectdp: direct calculation of potential for a collection
c                     of dipole sources to a collection of targets
c 
c      l3ddirectdg: direct calculation of potential and gradients 
c                   for a collection of dipole sources to a 
c                   collection of targets
c 
c      l3ddirectdh: direct calculation of potential, gradients and
c                   hessians for a collection of dipole sources to a
c                   collection of targets
c 
c      l3ddirectcdp: direct calculation of potential for a collection
c                     of charge and dipole sources to a collection 
c                     of targets
c 
c      l3ddirectcdg: direct calculation of potential and gradients 
c                   for a collection of charge and dipole sources to 
c                   a collection of targets
c
c      l3ddirectcdh: direct calculation of potential, gradients and
c                   hessians for a collection of charge and dipole
c                   sources to a collection of targets
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcp(nd,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} /|x-x_{j}|
c                        j
c                 
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,ztmp,threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim

      threshsq = thresh**2
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          ztmp = inv4pi/sqrt(dd)
          do idim=1,nd
            pot(idim,i) = pot(idim,i) + charge(idim,j)*ztmp
          enddo
 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcg(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} /|x-x_{j}| 
c                        j
c                 
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} /|x-x_{j}|) 
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,cd,cd1,ztmp1,ztmp2,ztmp3
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim


      threshsq = thresh**2 
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000
          cd = inv4pi/sqrt(dd)
          cd1 = -cd/dd
          ztmp1 = cd1*zdiff(1)
          ztmp2 = cd1*zdiff(2)
          ztmp3 = cd1*zdiff(3)
          do idim=1,nd
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            grad(idim,1,i) = grad(idim,1,i) + ztmp1*charge(idim,j)
            grad(idim,2,i) = grad(idim,2,i) + ztmp2*charge(idim,j)
            grad(idim,3,i) = grad(idim,3,i) + ztmp3*charge(idim,j)
          enddo
 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectch(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} /|x-x_{j}| 
c                        j
c                 
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} /|x-x_{j}|) 
c
c     hess(x) = hess(x) + Hessian(sum 1/(4\pi) q_{j} /|x-x_{j}|) 
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,cd,cd1,cd2,ztmp1,ztmp2,ztmp3
      real *8 htmp1,htmp2,htmp3,htmp4,htmp5,htmp6
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim


      threshsq = thresh**2 
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000
          cd = inv4pi/sqrt(dd)
          cd1 = -cd/dd
          cd2 = -cd1/dd
          ztmp1 = cd1*zdiff(1)
          ztmp2 = cd1*zdiff(2)
          ztmp3 = cd1*zdiff(3)
          htmp1 = cd2*(3*zdiff(1)*zdiff(1)-dd)
          htmp2 = cd2*(3*zdiff(2)*zdiff(2)-dd)
          htmp3 = cd2*(3*zdiff(3)*zdiff(3)-dd)
          htmp4 = cd2*3*zdiff(1)*zdiff(2)
          htmp5 = cd2*3*zdiff(1)*zdiff(3)
          htmp6 = cd2*3*zdiff(2)*zdiff(3)
          do idim=1,nd
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            grad(idim,1,i) = grad(idim,1,i) + ztmp1*charge(idim,j)
            grad(idim,2,i) = grad(idim,2,i) + ztmp2*charge(idim,j)
            grad(idim,3,i) = grad(idim,3,i) + ztmp3*charge(idim,j)
            hess(idim,1,i) = hess(idim,1,i) + htmp1*charge(idim,j)
            hess(idim,2,i) = hess(idim,2,i) + htmp2*charge(idim,j)
            hess(idim,3,i) = hess(idim,3,i) + htmp3*charge(idim,j)
            hess(idim,4,i) = hess(idim,4,i) + htmp4*charge(idim,j)
            hess(idim,5,i) = hess(idim,5,i) + htmp5*charge(idim,j)
            hess(idim,6,i) = hess(idim,6,i) + htmp6*charge(idim,j)
          enddo
 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j} 
c   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,cd,dotprod
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          cd = inv4pi/sqrt(dd)/dd

          do idim=1,nd
            dotprod = zdiff(1)*dipvec(idim,1,j) + 
     1          zdiff(2)*dipvec(idim,2,j)+
     1          zdiff(3)*dipvec(idim,3,j)
            pot(idim,i) = pot(idim,i) + cd*dotprod
          enddo

 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdg(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) d_{j} \nabla 1/|x-x_{j}| \cdot v_{j}
c                        j
c   
c     grad(x) = grad(x) + Gradient( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv,dinv2,dotprod
      real *8 cd,cd2,cd3,cd4
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          dinv2 = 1/dd
          dinv = sqrt(dinv2)
          cd = inv4pi*dinv
          cd2 = -cd*dinv2
          cd3 = -3*cd*dinv2*dinv2

          do idim=1,nd
          
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j))
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
          enddo
 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdh(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) d_{j} \nabla 1/|x-x_{j}| \cdot v_{j}
c                        j
c   
c     grad(x) = grad(x) + Gradient( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c     hess(x) = hess(x) + Hessian( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated gradient at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv,dinv2,dotprod
      real *8 cd,cd2,cd3,cd4,cd5,dx,dy,dz
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      integer *8 i,j,idim

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          dinv2 = 1/dd
          dinv = sqrt(dinv2)
          cd = inv4pi*dinv
          cd2 = -cd*dinv2
          cd3 = -3*cd*dinv2*dinv2
          cd5 = -cd3
c
          dx = zdiff(1)*dinv
          dy = zdiff(2)*dinv
          dz = zdiff(3)*dinv

          do idim=1,nd
          
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j))
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
            hess(idim,1,i)= hess(idim,1,i) + 
     1      (dotprod*(5*dx*dx-1)-
     2      (dipvec(idim,1,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(1)))*cd5
            hess(idim,2,i)= hess(idim,2,i) + 
     1      (dotprod*(5*dy*dy-1)-
     2      (dipvec(idim,2,j)*zdiff(2)+dipvec(idim,2,j)*zdiff(2)))*cd5
            hess(idim,3,i)= hess(idim,3,i) + 
     1      (dotprod*(5*dz*dz-1)-
     2      (dipvec(idim,3,j)*zdiff(3)+dipvec(idim,3,j)*zdiff(3)))*cd5
            hess(idim,4,i)= hess(idim,4,i) + 
     1      (dotprod*(5*dx*dy)-
     2      (dipvec(idim,2,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(2)))*cd5
            hess(idim,5,i)= hess(idim,5,i) + 
     1      (dotprod*(5*dx*dz)-
     2      (dipvec(idim,3,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(3)))*cd5
            hess(idim,6,i)= hess(idim,6,i) + 
     1      (dotprod*(5*dy*dz)-
     2      (dipvec(idim,3,j)*zdiff(2)+dipvec(idim,2,j)*zdiff(3)))*cd5
          enddo
 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv2,dotprod,cd,cd1
      integer *8 i,j,idim
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          dinv2 = 1/dd 
          cd = inv4pi*sqrt(dinv2)
          cd1 = cd*dinv2

          do idim=1,nd
            pot(idim,i) = pot(idim,i) + charge(idim,j)*cd

            dotprod = zdiff(1)*dipvec(idim,1,j) + 
     1          zdiff(2)*dipvec(idim,2,j)+
     1          zdiff(3)*dipvec(idim,3,j)
            pot(idim,i) = pot(idim,i) + cd1*dotprod
          enddo

 1000     continue
        enddo
      enddo


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdg(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                                    j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv,dinv2,dotprod,cd,cd2,cd3,cd4
      integer *8 i,j,idim
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          dinv2 = 1/dd
          cd = inv4pi*sqrt(dinv2)
          cd2 = -cd*dinv2
          cd3 = -3*cd*dinv2*dinv2

          do idim=1,nd
          
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j))
     2         + cd2*charge(idim,j)*zdiff(1) 
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
     2         + cd2*charge(idim,j)*zdiff(2) 
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
     2         + cd2*charge(idim,j)*zdiff(3)
          enddo
 1000     continue
        enddo
      enddo

      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdh(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                                    j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated Hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      integer *8 i,j,idim
      real *8 zdiff(3),dd,d,dinv,dinv2,dotprod,cd,cd2,cd3,cd4,cd5
      real *8 htmp1,htmp2,htmp3,htmp4,htmp5,htmp6,dx,dy,dz
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      threshsq = thresh**2

      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          if(dd.lt.threshsq) goto 1000

          dinv2 = 1/dd
          dinv = sqrt(dinv2)
          cd = inv4pi*dinv
          cd2 = -cd*dinv2
          cd3 = -3*cd*dinv2*dinv2
c
          cd4 = -cd2/dd
c
          cd5 = -cd3
          dx = zdiff(1)*dinv
          dy = zdiff(2)*dinv
          dz = zdiff(3)*dinv
c
          htmp1 = cd4*(3*zdiff(1)*zdiff(1)-dd)
          htmp2 = cd4*(3*zdiff(2)*zdiff(2)-dd)
          htmp3 = cd4*(3*zdiff(3)*zdiff(3)-dd)
          htmp4 = cd4*3*zdiff(1)*zdiff(2)
          htmp5 = cd4*3*zdiff(1)*zdiff(3)
          htmp6 = cd4*3*zdiff(2)*zdiff(3)
          do idim=1,nd
          
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j))
     2         + cd2*charge(idim,j)*zdiff(1) 
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
     2         + cd2*charge(idim,j)*zdiff(2) 
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
     2         + cd2*charge(idim,j)*zdiff(3)
            hess(idim,1,i) = hess(idim,1,i)+htmp1*charge(idim,j)+
     1      (dotprod*(5*dx*dx-1)-
     2      (dipvec(idim,1,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(1)))*cd5
            hess(idim,2,i) = hess(idim,2,i)+htmp2*charge(idim,j)+
     1      (dotprod*(5*dy*dy-1)-
     2      (dipvec(idim,2,j)*zdiff(2)+dipvec(idim,2,j)*zdiff(2)))*cd5
            hess(idim,3,i) = hess(idim,3,i)+htmp3*charge(idim,j)+
     1      (dotprod*(5*dz*dz-1)-
     2      (dipvec(idim,3,j)*zdiff(3)+dipvec(idim,3,j)*zdiff(3)))*cd5
            hess(idim,4,i) = hess(idim,4,i)+htmp4*charge(idim,j)+
     1      (dotprod*(5*dx*dy)-
     2      (dipvec(idim,2,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(2)))*cd5
            hess(idim,5,i) = hess(idim,5,i)+htmp5*charge(idim,j)+
     1      (dotprod*(5*dx*dz)-
     2      (dipvec(idim,3,j)*zdiff(1)+dipvec(idim,1,j)*zdiff(3)))*cd5
            hess(idim,6,i) = hess(idim,6,i)+htmp6*charge(idim,j)+
     1      (dotprod*(5*dy*dz)-
     2      (dipvec(idim,3,j)*zdiff(2)+dipvec(idim,2,j)*zdiff(3)))*cd5
          enddo
 1000     continue
        enddo
      enddo
      return
      end

program test_hfmm3d_mp2loc
  implicit double precision (a-h,o-z)
  
  character(len=72) str1
  
  integer *8 :: ns, nt, nc, nlege, ns1, n1, ntm, npts
  integer *8 :: i,j,k,ntest,nd,idim,ntot,ijk,lw,lused
  integer *8 :: ifcharge,ifdipole,ifpgh,ifpghtarg
  integer *8 :: ipass(18),len1,ntests,isum
  integer *8, allocatable :: nterms(:), impole(:)
  
  double precision :: eps, err, hkrand, dnorms(1000), force(10)
  double precision, allocatable :: source(:,:), targ(:,:)
  double precision, allocatable :: centers(:,:)
  double precision, allocatable :: wlege(:), rscales(:)
  
  double complex :: eye, zk, ima
  double complex, allocatable :: charge(:,:)
  double complex, allocatable :: dipvec(:,:,:)
  double complex, allocatable :: pot(:,:), pot2(:,:), pottarg(:,:)
  double complex, allocatable :: grad(:,:,:),gradtarg(:,:,:)
  double complex, allocatable :: hess(:,:,:),hesstarg(:,:,:)
  double complex, allocatable :: mpole(:), local(:)


  data eye/(0.0d0,1.0d0)/
  ima = (0,1)
  done = 1
  pi = 4*atan(done)

  !
  ! initialize printing routine
  !
  call prini(6,13)

  nd = 3


  n1 = 3
  ns = n1**3
  nc = ns

  call prinf('ns = *', ns, 1)
  call prinf('nc = *', nc, 1)
  
  nt = 19

  allocate(source(3,ns),targ(3,nt), centers(3,nc))
  allocate(charge(nd,ns),dipvec(nd,3,ns))
  allocate(pot(nd,ns), pot2(nd,ns))
  allocate(grad(nd,3,ns))
  allocate(hess(nd,6,ns))

  allocate(pottarg(nd,nt))
  allocate(gradtarg(nd,3,nt))
  allocate(hesstarg(nd,6,nt))
  eps = 0.5d-9

  write(*,*) "=========================================="
  write(*,*) "Testing suite for hfmm3d_mps"
  write(*,'(a,e12.5)') "Requested precision = ",eps

  boxsize = 1
  dlam = 1/boxsize
  zk = 2*pi/dlam + eye*0.02d0

  call prin2('boxsize in wavelengths = *', boxsize, 1)
  call prin2('dlam = *', dlam, 1)
  call prin2('zk = *', zk, 2)

  !
  ! generate sources uniformly in the unit cube 
  !
  h = 1.0d0/(n1+1)
  ijk = 0
  do i = 1,n1
    do j = 1,n1
      do k = 1,n1
        ijk = ijk + 1
        source(1,ijk) = h*i
        source(2,ijk) = h*j
        source(3,ijk) = h*k
      end do
    end do
  end do
  
  
  dnorm = 0
  do i=1,ns
    !source(1,i) = hkrand(0)**2
    !source(2,i) = hkrand(0)**2
    !source(3,i) = hkrand(0)**2

    do idim=1,nd

      charge(idim,i) = hkrand(0) + eye*hkrand(0)
      dnorm = dnorm + abs(charge(idim,i))**2
      
      dipvec(idim,1,i) = hkrand(0) + eye*hkrand(0)
      dipvec(idim,2,i) = hkrand(0) + eye*hkrand(0)
      dipvec(idim,3,i) = hkrand(0) + eye*hkrand(0)

      pot(idim,i) = 0
      grad(idim,1,i) = 0
      grad(idim,2,i) = 0
      grad(idim,3,i) = 0
    enddo
  enddo

  dnorm = sqrt(dnorm)
  do i=1,ns
    do idim = 1,nd
      charge(idim,i) = charge(idim,i)/dnorm
    end do
  end do
  

  ! call prin2('min source separation = *', ssep, 1)
  
  shift = h/1000
  call prin2('shift = *', shift, 1)
  do i = 1,ns
    centers(1,i) = source(1,i) + shift
    centers(2,i) = source(2,i)
    centers(3,i) = source(3,i)
  end do

  !call prin2('centers = *', centers, 3*nc)

  !
  ! now form a multipole expansion at each center
  !
  allocate(nterms(nc), impole(nc))

  ntm = 7
  ntot = 0
  do i = 1,nc
    nterms(i) = ntm + 2*cos(pi/2*i)
    ntot = ntot + (nterms(i)+1)*(2*nterms(i)+1)
  end do

  allocate(mpole(nd*ntot))

  impole(1) = 1
  do i = 1,nc-1
    ilen = (nterms(i)+1)*(2*nterms(i)+1)
    impole(i+1) = impole(i) + nd*ilen
  end do

  
  nlege = 400
  lw = 5*(nlege+1)**2
  allocate( wlege(lw) )

  call prinf('before ylgndrfwini, lw = *', lw, 1)
  call ylgndrfwini(nlege, wlege, lw, lused)
  call prinf('after ylgndrfwini, lused = *', lused, 1)

  call zinitialize(nd*ntot, mpole)
  
  ns1 = 1
  rscale = 1
  sc = abs(zk)*shift
  if (sc .lt. 1) rscale = sc

  call prin2('rscale = *', rscale, 1)
  
  allocate(rscales(nc))
  do i = 1,nc
    rscales(i) = rscale
    call h3dformmpc(nd, zk, rscale, source(1,i), charge(1,i), &
        ns1, centers(1,i), nterms(i), mpole(impole(i)), &
        wlege, nlege)
  end do

  
  !
  ! do the direct calculation
  !
  thresh = 1.0d-15
  ifcharge = 1
  ifdipole = 0
  ifpgh = 1
  ntarg = 0
  ifpghtarg = 0
  call hfmm3d(nd, eps, zk, ns, source, ifcharge, &
      charge, ifdipole, dipvec, iper, ifpgh, pot, grad, hess, ntarg, &
      targ, ifpghtarg, pottarg, gradtarg, hesstarg, ier)
  
  call prin2('via fmm, potential = *', pot, 10)

  
  allocate(local(nd*ntot))
  
  !
  ! now test source to source, charge, 
  ! with potentials
  !
  print *
  print *
  print *
  write(6,*) 'testing multipoles to locals'
  write(6,*) 'input: multipole expansions'
  write(6,*) 'output: local expansions'
  write(6,*) 
  write(6,*) 


  call hfmm3d_mps(nd, eps, zk, &
      nc, centers, rscales, nterms, mpole, impole, local,ier)

  call zinitialize(nd*nc, pot2)
  npts = 1
  do i = 1,nc
    call h3dtaevalp(nd, zk, rscales(i), &
        centers(1,i), local(impole(i)), &
        nterms(i), source(1,i), npts, pot2(1,i), &
        wlege, nlege)
  end do
  
  call prin2('from hfmm3d_mps, potential = *', pot2, 10)

  err = 0
  dnorm = 0
  do j = 1,nc
    do i = 1,nd
      err = err + abs(pot(i,j)-pot2(i,j))**2
      dnorm = dnorm + abs(pot(i,j))**2
      pot2(i,j) = pot2(i,j) - pot(i,j)
    end do
  end do

  !call prin2('diff = *', pot2, 2*nd*ns)
  !call prin2('err = *', err, 1)
  !call prin2('dnorm = *', dnorm, 1)
  
  err = sqrt(err/dnorm)
  call prin2('l2 rel err=*',err,1)

  open(unit=33,file='print_testres.txt',access='append')
  isuccess = 0
  ntest = 1
  if(err.lt.eps) isuccess = 1

  write(33,'(a,i1,a,i1,a)') 'Successfully completed ', &
    isuccess,' out of ',ntest,' tests in helm3d_mps testing suite'
  close(33)

  
  

  stop
end program



! ----------------------------------------------------------
! 
! This is the end of the debugging code.
!
! ----------------------------------------------------------
subroutine prinmp(str, mpole, nterms)
  implicit double precision (a-h,o-z)
  character (len=*) :: str
  double complex :: mpole(0:nterms, -nterms:nterms)
  double complex :: tmp(-10000:10000)

  print *, trim(str)

  do n = 0,nterms
    print *
    write(6,'(a,i2,a,i2,a,i2)') 'n = ', n, '  m = ', -n, '...', n
    do m = -nterms,nterms
      tmp(m) = mpole(n,m)
    end do
    call prin2('coefs = *', tmp(-n), 2*n+1)
  end do
  
  return
end subroutine prinmp



subroutine zinitialize(len, zs)
  implicit double precision (a-h,o-z)
  integer *8 len,i
  double complex :: zs(len)

  do i = 1,len
    zs(i) = 0
  end do
  return
end subroutine zinitialize





subroutine comperr_vec(nd,zk,ns,source,ifcharge,charge,ifdipole, &
    dipvec,ifpgh,pot,grad,nt,targ,ifpghtarg,pottarg, &
    gradtarg,ntest,err)

  implicit none
  double complex zk
  integer *8 ns,nt,ifcharge,ifdipole,ifpgh,ifpghtarg

  integer *8 nd
  double precision source(3,*),targ(3,*)
  double complex dipvec(nd,3,*)
  double complex charge(nd,*)

  double complex pot(nd,*),pottarg(nd,*),grad(nd,3,*), &
      gradtarg(nd,3,*)

  integer *8 i,j,ntest,idim

  double precision err,ra

  double complex potex(nd,ntest),gradex(nd,3,ntest), &
      pottargex(nd,ntest),gradtargex(nd,3,ntest)

  double precision thresh

  err = 0 
  do i=1,ntest
    do idim=1,nd
      potex(idim,i) = 0
      pottargex(idim,i) = 0

      gradex(idim,1,i) = 0
      gradex(idim,2,i) = 0
      gradex(idim,3,i) = 0

      gradtargex(idim,1,i) = 0
      gradtargex(idim,2,i) = 0
      gradtargex(idim,3,i) = 0
    enddo
  enddo

  thresh = 1.0d-16

  if(ifcharge.eq.1.and.ifdipole.eq.0) then
    if(ifpgh.eq.1) then
      call h3ddirectcp(nd,zk,source,charge,ns,source,ntest, &
          potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectcg(nd,zk,source,charge,ns,source,ntest, &
          potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectcp(nd,zk,source,charge,ns,targ,ntest, &
          pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectcg(nd,zk,source,charge,ns,targ,ntest, &
          pottargex,gradtargex,thresh)
    endif
  endif

  if(ifcharge.eq.0.and.ifdipole.eq.1) then
    if(ifpgh.eq.1) then
      call h3ddirectdp(nd,zk,source,dipvec, &
          ns,source,ntest,potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectdg(nd,zk,source,dipvec, &
          ns,source,ntest,potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectdp(nd,zk,source,dipvec, &
          ns,targ,ntest,pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectdg(nd,zk,source,dipvec, &
          ns,targ,ntest,pottargex,gradtargex,thresh)
    endif
  endif

  if(ifcharge.eq.1.and.ifdipole.eq.1) then
    if(ifpgh.eq.1) then
      call h3ddirectcdp(nd,zk,source,charge,dipvec, &
          ns,source,ntest,potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectcdg(nd,zk,source,charge,dipvec, &
          ns,source,ntest,potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectcdp(nd,zk,source,charge,dipvec, &
          ns,targ,ntest,pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectcdg(nd,zk,source,charge,dipvec, &
          ns,targ,ntest,pottargex,gradtargex,thresh)
    endif
  endif

  err = 0
  ra = 0

  if(ifpgh.eq.1) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(potex(idim,i))**2
        err = err + abs(pot(idim,i)-potex(idim,i))**2
      enddo
    enddo
  endif

  if(ifpgh.eq.2) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(potex(idim,i))**2
        ra = ra + abs(gradex(idim,1,i))**2
        ra = ra + abs(gradex(idim,2,i))**2
        ra = ra + abs(gradex(idim,3,i))**2

        err = err + abs(pot(idim,i)-potex(idim,i))**2
        err = err + abs(grad(idim,1,i)-gradex(idim,1,i))**2
        err = err + abs(grad(idim,2,i)-gradex(idim,2,i))**2
        err = err + abs(grad(idim,3,i)-gradex(idim,3,i))**2
      enddo
    enddo
  endif


  if(ifpghtarg.eq.1) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(pottargex(idim,i))**2
        err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
      enddo
    enddo
  endif

  if(ifpghtarg.eq.2) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(pottargex(idim,i))**2
        ra = ra + abs(gradtargex(idim,1,i))**2
        ra = ra + abs(gradtargex(idim,2,i))**2
        ra = ra + abs(gradtargex(idim,3,i))**2

        err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
        err = err + abs(gradtarg(idim,1,i)-gradtargex(idim,1,i))**2
        err = err + abs(gradtarg(idim,2,i)-gradtargex(idim,2,i))**2
        err = err + abs(gradtarg(idim,3,i)-gradtargex(idim,3,i))**2
      enddo
    enddo
  endif

  err = sqrt(err/ra)
  return
end subroutine comperr_vec

      implicit none
      integer *8 ns,nt,nd
      double precision, allocatable :: source(:,:),targ(:,:)
      double complex, allocatable :: charge(:,:),dipvec(:,:,:)
      double complex, allocatable :: pot(:,:)
      double complex, allocatable :: pottarg(:,:)

      double precision eps
      double complex eye,zk
      integer *8 i,j,k,idim,ier
      double precision hkrand,pi,thet,phi
      

      data eye/(0.0d0,1.0d0)/

      pi = 4.0d0*atan(1.0d0)

c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      call prin2("This code is an example fortran driver*",i,0)
      call prin2("On output, the code prints sample pot,pottarg*",i,0)
      write(*,*)
      write(*,*)

      zk = 2.2d0

      ns = 10000
      nt = 10000
      
      nd = 1

      allocate(source(3,ns))
      allocate(targ(3,nt))
      allocate(charge(nd,ns))
      allocate(dipvec(nd,3,ns))
      allocate(pot(nd,ns))
      allocate(pottarg(nd,nt))


      eps = 0.51d-3

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source+targ, charges+dipoles, pot
c



c
cc      generate sources uniformly on the sphere 
c
c
      do i=1,ns
        thet = hkrand(0)*pi
        phi = hkrand(0)*2*pi
        source(1,i) = sin(thet)*cos(phi) 
        source(2,i) = sin(thet)*sin(phi)
        source(3,i) = cos(thet)

        do idim=1,nd
          charge(idim,i) = hkrand(0) + eye*hkrand(0)
          dipvec(idim,1,i) = hkrand(0) + eye*hkrand(0)
          dipvec(idim,2,i) = hkrand(0) + eye*hkrand(0)
          dipvec(idim,3,i) = hkrand(0) + eye*hkrand(0)
          pot(idim,i) = 0
        enddo
      enddo

      do i=1,nt
        targ(1,i) = source(1,i) + 10.0d0
        targ(2,i) = source(2,i)
        targ(3,i) = source(3,i)

        do idim=1,nd
          pottarg(idim,i) = 0
        enddo
      enddo


       call hfmm3d_st_cd_p_vec(nd,eps,zk,ns,source,charge,
     1      dipvec,pot,nt,targ,pottarg,ier)

       call prin2("potential at sources=*",pot,12)
       call prin2("potential at targets=*",pottarg,12)


      stop
      end
c----------------------------------------------------------
c
cc
c
c

c
c
c        a collection of common subroutines used in the fmm
c           
c          mpalloc - allocate workspace for multipole and local
c                     expansions
c
c          dreorderf - permute a real array with given permutation
c
c          dreroderi - pertmute a real array with inverse of
c                      given permutation
c 
c          drescale - rescale a vector with a scalar
c 
c          mpzero - zero out a multipole/local expansion
c  
c          mpadd - add a multipole expansion to an existing one
c
c          mpscale - scale multipole expansion coeffs 
c
c          cart2polar - cartesian to polar coordinates
c
c          getpwrotmat - get a collection of rotation matrices
c                  for pw stuff
c
c          getsqrtbinomialcoeffs - get square root of binomial
c                         coeffs array
c          bnlcft - binomial coeffs and square roots
c          fstrtn - generate rotation matrix
c          geterrstr - error string generator for something
c
c
c
      subroutine mpalloc(nd,laddr,iaddr,nlevels,lmptot,nterms)
c     This subroutine determines the size of the array
c     to be allocated for the multipole expansions
c     iaddr(1,i) points to the starting location of the multipole
c     expansion of box i and iaddr(2,i) points to the local
c     expansion of box i
c  
c     Input arguments
c     nd          in: Integer
c                 number of expansions per box            
c 
c     laddr       in: Integer(2,0:nlevels)
c                 indexing array provinding access to boxes at each
c                 level
c
c     nlevels     in: Integer
c                 Total numner of levels
c     
c     nterms      in: Integer(0:nlevels)
c                 Number of terms requried in expansions at each
c                 level
c
c------------------------------------------------------------------
c     Output arguments
c     iaddr       out: Integer *8(2,nboxes)
c                 Points the multipole and local expansions in box i
c 
c     lmptot      out: Integer *8
c                 Total length of expansions array required
c------------------------------------------------------------------

      implicit none
      integer *8 nlevels,nterms(0:nlevels),nd
      integer *8 iaddr(2,*), lmptot 
      integer *8 laddr(2,0:nlevels)
      integer *8 ibox,i,iptr
      integer *8 istart,nn,itmp

      istart = 1
      do i = 0,nlevels

        nn = (2*nterms(i)+1)*2*(nterms(i)+1)*nd 
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,itmp)

         do ibox = laddr(1,i),laddr(2,i)
c            Allocate memory for the multipole expansion         

             itmp = ibox-laddr(1,i)
             iaddr(1,ibox) = istart + itmp*2*nn

c            Allocate memory for the local expansion
             iaddr(2,ibox) = istart + itmp*2*nn + nn
         enddo
C$OMP END PARALLEL DO         
         istart = istart + (laddr(2,i)-laddr(1,i)+1)*2*nn
      enddo
      lmptot = istart

      return
      end
c----------------------------------------------------------------     

      subroutine dreorderf(ndim,n,arr,arrsort,iarr)
c
cc       this subroutine sorts the array arr and stores
c        it in arrsort using the sorting order defined by
c        iarr
c
c        arrsort(j,i) = arr(j,iarr(i)), j =1,2,\ldots ndim
c                                       i=1,2,\ldots n
c

      implicit none
      integer *8 ndim,idim,i,n
      double precision arr(ndim,*),arrsort(ndim,*)
      integer *8 iarr(*)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)      
      do i=1,n
         do idim=1,ndim
            arrsort(idim,i) = arr(idim,iarr(i))
         enddo
      enddo
C$OMP END PARALLEL DO      

      return
      end
c--------------------------------------------------
      subroutine dreorderi(ndim,n,arr,arrsort,iarr)
c
cc       this subroutine sorts the array arr and stores
c        it in arrsort using the inverse of the
c        sorting order defined by
c        iarr.
c
c        Note that this subroutine is the inverse of 
c        dreorderf
c
c        arrsort(j,iarr(i)) = arr(j,i), j =1,2,\ldots ndim
c                                       i=1,2,\ldots n
c

      implicit none
      integer *8 i,idim,ndim,n
      double precision arr(ndim,*),arrsort(ndim,*)
      integer *8 iarr(*)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)      
      do i=1,n
         do idim=1,ndim
            arrsort(idim,iarr(i)) = arr(idim,i)
         enddo
      enddo
C$OMP END PARALLEL DO      

      return
      end
c----------------------------------------------------------      





      subroutine ireorderf(ndim,n,arr,arrsort,iarr)
c
cc       this subroutine sorts the array arr and stores
c        it in arrsort using the sorting order defined by
c        iarr
c
c        arrsort(j,i) = arr(j,iarr(i)), j =1,2,\ldots ndim
c                                       i=1,2,\ldots n
c

      implicit none
      integer *8 ndim,idim,i,n
      integer *8 arr(ndim,*),arrsort(ndim,*)
      integer *8 iarr(*)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)      
      do i=1,n
         do idim=1,ndim
            arrsort(idim,i) = arr(idim,iarr(i))
         enddo
      enddo
C$OMP END PARALLEL DO      

      return
      end
c--------------------------------------------------
      subroutine ireorderi(ndim,n,arr,arrsort,iarr)
c
cc       this subroutine sorts the array arr and stores
c        it in arrsort using the inverse of the
c        sorting order defined by
c        iarr.
c
c        Note that this subroutine is the inverse of 
c        dreorderf
c
c        arrsort(j,iarr(i)) = arr(j,i), j =1,2,\ldots ndim
c                                       i=1,2,\ldots n
c

      implicit none
      integer *8 i,idim,ndim,n
      integer *8 arr(ndim,*),arrsort(ndim,*)
      integer *8 iarr(*)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)      
      do i=1,n
         do idim=1,ndim
            arrsort(idim,iarr(i)) = arr(idim,i)
         enddo
      enddo
C$OMP END PARALLEL DO      

      return
      end
c
c
c
c
c
c
      subroutine drescale(n,a,r)
      implicit none
      integer *8 i,n
      real *8 a(n),r

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,n
        a(i) = a(i)*r
      enddo
C$OMP END PARALLEL DO

      


      return
      end





      subroutine mpzero(nd,mpole,nterms)
c
cc      this subroutine zeros out a collection of 
c       multipole expansions
c
c       input:
c       nd     in:integer *8
c              number of expansions
c
c       nterms in:integer *8
c              number of terms in the expansions
c
c       inout:
c       mpole  inout: double complex(nd,0:nterms,-nterms:nterms)
c              multipole expansions to be zeroed out
c
      implicit none
      integer *8 nd, i,j,nterms,idim
      double complex mpole(nd,0:nterms,-nterms:nterms)

      do i=-nterms,nterms
        do j=0,nterms
          do idim=1,nd
            mpole(idim,j,i) = 0
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
      subroutine mpadd(nd,mpolein,mpoleout,nterms)
c
cc      this subroutine add mpolein to mpoleout 
c
c       input:
c       nd     in:integer *8
c              number of expansions
c
c       nterms in:integer *8
c              number of terms in the expansions
c
c       mpolein in: complex *16(nd,0;nterms,-nterms:nterms)
c               multipole expansion to be added
c
c       inout:
c       mpoleout  inout: double complex(nd,0:nterms,-nterms:nterms)
c              multipole expansions to which mpolein is to be added
c
      implicit none
      integer *8 nd, i,j,nterms,idim
      double complex mpolein(nd,0:nterms,-nterms:nterms)
      double complex mpoleout(nd,0:nterms,-nterms:nterms)

      do i=-nterms,nterms
        do j=0,nterms
          do idim=1,nd
            mpoleout(idim,j,i) = mpoleout(idim,j,i) + mpolein(idim,j,i)
          enddo
        enddo
      enddo

      return
      end
c----------------------------------------------------------------

      subroutine mpscale(nd,nterms,mpolein,rsc,mpoleout)
c
cc      this subroutine rescales a multipole 
c       expansion where mpoleout(i,j) = mpolein(i,j)*rscalepow(i)
c
c       input
c       nd      in: integer *8
c               number of multipole expansions
c
c       nterms  in: integer *8
c               number of terms in the expansion
c    
c       rsc     in: double precision(0:nterms)
c               scaling factor for the multipole expansions            
c
c       mpolein   in: double complex(nd,0:nterms,-nterms:nterms)
c                input multipole expansions
c
c       output
c       mpoleout  out: double complex(nd,0:nterms,-nterms:nterms)
c                output multipole expansions
c
      implicit none
      integer *8 nd,nterms,i,j,idim
      double precision rsc(0:nterms)
      double complex mpolein(nd,0:nterms,-nterms:nterms)
      double complex mpoleout(nd,0:nterms,-nterms:nterms)

      do j=-nterms,nterms
        do i=0,nterms
          do idim=1,nd
            mpoleout(idim,i,j) = mpolein(idim,i,j)*rsc(i)
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c**********************************************************************
      subroutine cart2polar(zat,r,theta,phi)
c**********************************************************************
c
c     Convert from Cartesian to polar coordinates.
c
c-----------------------------------------------------------------------
c     INPUT:
c
c	zat   :  Cartesian vector
c
c-----------------------------------------------------------------------
c     OUTPUT:
c
c	r     :  |zat|
c	theta : angle subtended with respect to z-axis
c	phi   : angle of (zat(1),zat(2)) subtended with 
c               respect to x-axis
c
c-----------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      real *8 zat(3)
      complex *16 ephi,eye
      data eye/(0.0d0,1.0d0)/
c
c 
      r= sqrt(zat(1)**2+zat(2)**2+zat(3)**2)
      proj = sqrt(zat(1)**2+zat(2)**2)
c
      theta = datan2(proj,zat(3))
      if( abs(zat(1)) .eq. 0 .and. abs(zat(2)) .eq. 0 ) then
      phi = 0
      else
      phi = datan2(zat(2),zat(1))
      endif
      return
      end
c
c
c
c
c
      subroutine getsqrtbinomialcoeffs(n,dc)
      implicit none
      integer *8 i,j,n
      real *8 dc(0:n,0:n)
      real *8, allocatable :: d(:,:)
      allocate(d(0:n,0:n))

      do i=0,n
        do j=0,n
          d(i,j) = 0
          dc(i,j) = 0
        enddo
      enddo

      do i=0,n
        d(i,0) = 1
        dc(i,0) = 1
      enddo
      do i=1,n
        d(i,i) = 1
        dc(i,i) = 1
        do j=i+1,n
          d(j,i) =d(j-1,i)+d(j-1,i-1)
          dc(j,i) = sqrt(d(j,i))
        enddo
      enddo

      return
      end



c***********************************************************************
      subroutine getpwrotmat(nterms,carray,rdpi2,rdmpi2,rdsq3,rdmsq3,
     1   dc)
c***********************************************************************
      implicit double precision (a-h,o-z)
      integer *8 nterms
      double precision pi
      double precision carray(0:4*nterms,0:4*nterms)
      double precision dc(0:4*nterms,0:4*nterms)
      double precision rdpi2(0:nterms,0:nterms,-nterms:nterms) 
      double precision rdmpi2(0:nterms,0:nterms,-nterms:nterms) 
      double precision rdsq3(0:nterms,0:nterms,-nterms:nterms) 
      double precision rdmsq3(0:nterms,0:nterms,-nterms:nterms) 
c
c----- call initialization routines
c
      call prini(6,13)
      pi = 4*datan(1.0d0)
c
      call bnlcft(carray,dc,4*nterms)
      theta = pi/2.0d0
      call fstrtn(nterms,rdpi2,dc,theta)
      theta = -pi/2.0d0
      call fstrtn(nterms,rdmpi2,dc,theta)
      theta = dacos(dsqrt(3.0d0)/3.0d0)
      call fstrtn(nterms,rdsq3,dc,theta)
      theta = dacos(-dsqrt(3.0d0)/3.0d0)
      call fstrtn(nterms,rdmsq3,dc,theta)
      return
      end
c
c***********************************************************************
      subroutine zflip(nterms,mpole,mrotate)
c***********************************************************************
      implicit double precision (a-h,o-z)
      integer *8 nterms,l,m
      double complex mpole(0:nterms,0:nterms)
      double complex mrotate(0:nterms,0:nterms)
c
      do 200 l=0,nterms,2
         do 100 m=0,l
            mrotate(l,m)=dconjg(mpole(l,m))
100      continue
200   continue
      do 400 l=1,nterms,2
         do 300 m=0,l
            mrotate(l,m)=-dconjg(mpole(l,m))
300      continue
400   continue
ccc      call prinf(' mrotate is *',nterms,0)
ccc      call prinm(mrotate,nterms)
      return
      end
c***********************************************************************
      subroutine prinout(mpole,ll,nterms)
c***********************************************************************
c
c     printing routine displays multipole moments one degree (l)
c     at a time , from m = 0 to m = l  .
c
c***********************************************************************
      integer *8 nterms,l,ll,m
      double complex mpole(0:nterms,0:nterms)
c
      do 100 l = 0,ll
	 write(6,1000)(mpole(l,m),m=0,ll)
	 write(13,1000)(mpole(l,m),m=0,ll)
ccc	 write(6,1001)
ccc	 write(13,1001)
100   continue
1000  format(6d12.5)
1001  format(/)
      return
      end
c
c***********************************************************************
      subroutine bnlcft(c, sqc, nterms)
c***********************************************************************
c
c     usage:
c           computes the binomial coefficients c_nterms^n, where
c           n=0,1,2,...,nterms.
c     input:
c           nterms: an integer *8 indicates the number we are going
c                 to choose from.
c     output:
c           c:    an array consists of the binomial coefficients.
c           sqc:   an array consists of the square root of the
c                 binormial coefficients.
c
c***********************************************************************
c
      implicit double precision (a-h,o-z)
      integer *8 nterms,n,m
      double precision c(0:nterms,0:nterms)
      double precision sqc(0:nterms,0:nterms)
c
      do 100 n=0,nterms
        c(n,0)=1.0d0
        sqc(n,0)=1.0d0
100   continue
      do 300 m=1,nterms
         c(m,m)=1.0d0
         sqc(m,m)=1.0d0
         do 200 n=m+1,nterms
            c(n,m)=c(n-1,m)+c(n-1,m-1)
            sqc(n,m)=dsqrt(c(n,m))
200      continue
300   continue
c
      return
      end
c
c***********************************************************************
      subroutine fstrtn(nterms,d,sqc,theta)
c***********************************************************************
c
c     usage:
c           implement the fast version of rotation matrices from
c           the recurrences formulas.
c     input:
c           nterms: an integer *8 indicates the dimension of d.
c           sqc:    an array contains the square root of the
c                   binormial coefficients.
c           theta:  the rotate angle about the y-axis.
c     output:
c           d:      an array which contains the rotation matrix.
c                   note: only half of d are evaluated, the other
c                   half can be obtained by using the symmetricity.
c
c***********************************************************************
c
c---------------declares of fstrtn--------------------------------------
c
      implicit double precision (a-h,o-z)
      integer *8 nterms,ij,im,imp
c
ccc     parameter (nterms=8)
ccc     double precision d(0:nterms,-nterms:nterms,-nterms:nterms)
ccc     double precision c(0:4*nterms, 0:4*nterms)
c
      double precision d(0:nterms,0:nterms,-nterms:nterms)
      double precision sqc(0:4*nterms, 0:4*nterms)
      double precision ctheta, stheta, hsthta
      double precision cthtap, cthtan, theta, precis
c
      data precis/1.0d-19/
      data ww/0.7071067811865476d+00/
c
c---------------executions of fstrtn------------------------------------
c
      ctheta=dcos(theta)
      if (dabs(ctheta).le.precis) ctheta=0.0d0
      stheta=dsin(-theta)
      if (dabs(stheta).le.precis) stheta=0.0d0
c     stheta=dsqrt(1.0d0-ctheta*ctheta)
      hsthta=ww*stheta
      cthtap=ww*(1.0d0+ctheta)
      cthtan=-ww*(1.0d0-ctheta)
c
c     initial setup for some coefficient matrix.
c
c     call bnlcft(c, sqc, 4*nterms)
c
      d(0,0,0)=1.0d0
c
      do 1000 ij=1,nterms
c        if (ij.ge.3) stop
c
c     compute the result for m=0 case, use formula (1).
c
         do 200 im=-ij,-1
            d(ij,0,im)=-sqc(ij-im,2)*d(ij-1,0,im+1)
            if (im.gt.(1-ij)) then
               d(ij,0,im)=d(ij,0,im)+sqc(ij+im,2)*d(ij-1,0,im-1)
            endif
            d(ij,0,im)=d(ij,0,im)*hsthta
            if (im.gt.-ij) then
               d(ij,0,im)=d(ij,0,im)+
     1           d(ij-1,0,im)*ctheta*sqc(ij+im,1)*sqc(ij-im,1)
            endif
            d(ij,0,im)=d(ij,0,im)/ij
200      continue
c
         d(ij,0,0)=d(ij-1,0,0)*ctheta
         if (ij.gt.1) then
            d(ij,0,0)=d(ij,0,0)+hsthta*sqc(ij,2)*(d(ij-1,0,-1)+
     1                 d(ij-1,0,1))/ij
         endif
c
         do 400 im=1,ij
            d(ij,0,im)=-sqc(ij+im,2)*d(ij-1,0,im-1)
            if (im.lt.(ij-1)) then
               d(ij,0,im)=d(ij,0,im)+sqc(ij-im,2)*d(ij-1,0,im+1)
            endif 
            d(ij,0,im)=d(ij,0,im)*hsthta
            if (im.lt.ij) then
               d(ij,0,im)=d(ij,0,im)+
     1           d(ij-1,0,im)*ctheta*sqc(ij+im,1)*sqc(ij-im,1)
            endif
            d(ij,0,im)=d(ij,0,im)/ij
400      continue
c
c     compute the result for 0<m<=j case, use formula (2).
c
         do 800 imp=1,ij
            do 500 im=-ij,-1
               d(ij,imp,im)=d(ij-1,imp-1,im+1)*cthtan*sqc(ij-im,2)
               if (im.gt.(1-ij)) then
                  d(ij,imp,im)=d(ij,imp,im)-
     1             d(ij-1,imp-1,im-1)*cthtap*sqc(ij+im,2)
               endif
               if (im.gt.-ij) then
                  d(ij,imp,im)=d(ij,imp,im)+
     1             d(ij-1,imp-1,im)*stheta*sqc(ij+im,1)*sqc(ij-im,1)
               endif 
               d(ij,imp,im)=d(ij,imp,im)*ww/sqc(ij+imp,2)
500         continue
c
            d(ij,imp,0)=ij*stheta*d(ij-1,imp-1,0)
            if (ij.gt.1) then
               d(ij,imp,0)=d(ij,imp,0)-sqc(ij,2)*(
     1            d(ij-1,imp-1,-1)*cthtap+d(ij-1,imp-1,1)*cthtan)
            endif
            d(ij,imp,0)=d(ij,imp,0)*ww/sqc(ij+imp,2)
c
            do 600 im=1,ij
               d(ij,imp,im)=d(ij-1,imp-1,im-1)*cthtap*sqc(ij+im,2)
               if (im.lt.(ij-1)) then
                  d(ij,imp,im)=d(ij,imp,im)-
     1             d(ij-1,imp-1,im+1)*cthtan*sqc(ij-im,2)
               endif
               if (im.lt.ij) then
                  d(ij,imp,im)=d(ij,imp,im)+
     1             d(ij-1,imp-1,im)*stheta*sqc(ij+im,1)*sqc(ij-im,1)
               endif
               d(ij,imp,im)=d(ij,imp,im)*ww/sqc(ij+imp,2)
600         continue
c
c     use symmetricity, i.e. formula (3.80) in biedenharn & loucks
c     book, to compute the lower part of the matrix
c
c           do im=-ij,ij
c              d(ij,-imp,im)=d(ij,imp,-im)
c           enddo
c
800      continue
1000  continue
c
c
      return
      end
c
c-------------------------------------------------------
      subroutine geterrstr(ifcharge,ifdipole,ifpgh,ifpghtarg,str1,len1)
      implicit real *8 (a-h,o-z)
      integer *8 ifcharge,ifdipole,ifpgh,ifpghtarg,len1
      character(len=*) str1
      character(len=13) str2
      character(len=14) str3
      character(len=19) str4
      character(len=30) str5

      str2 = "Failed src to"
      len1 = 13
      if(ifpgh.gt.0.and.ifpghtarg.eq.0) then
        str3 = " src,"
        len1 = len1+5  
      endif
      if(ifpgh.eq.0.and.ifpghtarg.gt.0) then
        str3 = " targ,"
        len1 = len1+6
      endif
      if(ifpgh.gt.0.and.ifpghtarg.gt.0) then
        str3 = " src and targ,"
        len1 = len1+14
      endif

      if(ifcharge.eq.1.and.ifdipole.eq.0) then
        str4=" charge,"
        len1 = len1+8
      endif
      
      if(ifcharge.eq.0.and.ifdipole.eq.1) then
        str4=" dipole,"
        len1 = len1+8
      endif
      
      if(ifcharge.eq.1.and.ifdipole.eq.1) then
        str4=" charge and dipole,"
        len1 = len1+19
      endif

      if(ifpgh.eq.1.or.ifpghtarg.eq.1) then
        str5=" pot test"
        len1 = len1 + 9
      endif
      
      if(ifpgh.eq.2.or.ifpghtarg.eq.2) then
        str5=" pot and grad test"
        len1 = len1 + 18
      endif

      if(ipgh.eq.3.or.ifpghtarg.eq.3) then
        str5=" pot, grad, and hess test"
        len1 = len1+25
      endif

      str1 = str2//trim(str3)//trim(str4)//trim(str5)

      return
      end

c
c  This file contains a suite of evaluation codes for associated 
c  Legendre functions with various scalings, arguent types, etc.
c  Following is a brief description of the user-callable subroutines.
c  (FORTRAN 77 VERSION).
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Simple routines for real argument.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndr - evaluate normalized Legendre functions
c
c       ylgndr2 - evaluate normalized Legendre functions 
c                 and their derivatives
c
c       ylgndr2s - evaluate normalized Legendre functions and their
c            derivatives with scaling. 
c            For m>0, the Ynm(x) values are scaled by 1/sqrt(1-x^2),
c            For m>0, the Ynm(x) derivatives with respect to x are 
c            scaled by sqrt(1-x^2).
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Simple routines for real argument (not scaled by sqrt(2*n+1))
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndru - evaluate normalized Legendre functions
c
c       ylgndru2 - evaluate normalized Legendre functions 
c                 and their derivatives
c
c       ylgndru2s - evaluate normalized Legendre functions and their
c            derivatives with scaling. 
c            For m>0, the Ynm(x) values are scaled by 1/sqrt(1-x^2),
c            For m>0, the Ynm(x) derivatives with respect to x are 
c            scaled by sqrt(1-x^2).
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Simple routines for real argument
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndr2sm - evaluate normalized Legendre functions and their
c            derivatives with scaling. 
c            For m>0, the Ynm(x) values are scaled by 1/sqrt(1-x^2)**m,
c            For m>0, the Ynm(x) derivatives with respect to x are 
c            scaled by 1/sqrt(1-x^2)**(m-2).
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Accelerated codes with precompution for real argument.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndrini - precomputation routine for recursion coefficients.
c                   Used by "fast" routines ylgndrf, ylgndr2f, ylgndr2sf.
c
c       ylgndrf - faster evaluation of normalized Legendre functions. 
c                 Requires prior call to ylgndrini.
c
c       ylgndr2f - faster evaluation of normalized Legendre functions 
c                  and their derivatives. 
c                  Requires prior call to ylgndrini.
c
c       ylgndr2sf - faster evaluation of  normalized Legendre functions 
c                   and their derivatives (with scaling as in ylgndr2s).
c                   Requires prior call to ylgndrini.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Accelerated codes with precompution for real argument.       
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndrfex - faster evaluation of normalized Legendre functions. 
c                 Requires prior call to ylgndrini.
c                 In this routine, internal scaling by 10^(-id) is used
c                 to handle recurrence underflow near the poles.
c
c       ylgndr2fex - faster evaluation of normalized Legendre functions 
c                  and their derivatives. 
c                  Requires prior call to ylgndrini.
c                 In this routine, internal scaling by 10^(-id) is used
c                 to handle recurrence underflow near the poles.
c
c       ylgndr2sfex - faster evaluation of  normalized Legendre functions 
c                   and their derivatives (with scaling as in ylgndr2s).
c                   Requires prior call to ylgndrini.
c                 In this routine, internal scaling by 10^(-id) is used
c                 to handle recurrence underflow near the poles.
c
c   ylgndrfe, ylgndr2fe, ylgndr2sfe are the corresponding low-level
c   routines that do not post-multiply function values and derivatives 
c   by the scaling factors 10^(id). 
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Simple codes for complex argument.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       zylgndr - evaluate normalized Legendre functions 
c                 of a complex argument
c
c       zylgndr2 - evaluate normalized Legendre functions 
c                  of a complex argument and their derivatives 
c
c       zylgndr2s - evaluate normalized Legendre functions 
c                  of a complex argument and their derivatives 
c                  (with scaling as in ylgndr2s)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Accelerated codes with precompution for complex argument.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       zylgndrf - faster evaluation of normalized Legendre functions 
c                  of a complex argument.
c                  Requires prior call to ylgndrini.
c
c       zylgndr2f - faster evaluation of normalized Legendre functions 
c                   of a complex argument and their derivatives.
c                   Requires prior call to ylgndrini.
c
c       zylgndr2sf - faster evaluation of normalized Legendre functions 
c                    of a complex argument and their derivatives 
c                   (with scaling as in ylgndr2s).
c                   Requires prior call to ylgndrini.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Miscellaneous, special purpose codes.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       zylgndrbr - evaluate normalized Legendre functions of a 
c            complex argument with modified branch cut.
c
c       zylgndrsc - evaluate normalized Legendre functions of a complex
c            argument with scaling to prevent overflow for large values
c            of z.
c
c       ylgndrpm, ylgndrpm_opt - Given Y_nm(x), return Y_nm(-x)
c
c       ylgndr2pm, ylgndrpm_opt - Given Y_nm(x) and Y'_nm(x), 
c                                 return Y_nm(-x) and Y'_nm(-x)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Truncated evaluation routines: computation carried out for
c       orders up to specified parameter rather than max degree.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndr2s_trunc - evaluate normalized Legendre functions and their
c            derivatives (with scaling as in ylgndr2s), 
c            BUT recursion carried out only to m = m2 rather than nmax.
c
c       ylgndrf_trunc - faster evaluation of normalized Legendre functions. 
c            Same as ylgndrf, BUT recursion carried out only to m = m2 
c            rather than nmax.
c            Requires prior call to ylgndrini.
c
c       ylgndr2f_trunc - faster evaluation of  normalized Legendre 
c            functions and their derivatives. Same as ylgndr2f, 
c            BUT recursion carried out only to m = m2 rather than nmax.
c
c       ylgndr2sf_trunc - faster evaluation of normalized Legendre 
c            functions and their derivatives (with scaling). 
c            Same as ylgndr2sf, BUT recursion carried out only to 
c            m = m2 rather than nmax.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Accelerated codes with precompution for real argument: 
c       precomputation is done only once for orders up to nmax, 
c       the routines are able to revert to simple routines for
c       higher orders
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       ylgndrfwini - precomputation routine for recursion coefficients.
c                   Used by "fast" routines ylgndrfw, ylgndr2fw, ylgndr2sfw.
c
c       ylgndrfw - faster evaluation of normalized Legendre functions. 
c                 Requires prior call to ylgndrfwini.
c
c       ylgndr2fw - faster evaluation of normalized Legendre functions 
c                  and their derivatives. 
c                  Requires prior call to ylgndrfwini.
c
c       ylgndr2sfw - faster evaluation of  normalized Legendre functions 
c                   and their derivatives (with scaling as in ylgndr2s).
c                   Requires prior call to ylgndrfwini.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       (not scaled by sqrt(2*n+1))
c
c       ylgndrufw - faster evaluation of normalized Legendre functions. 
c                 Requires prior call to ylgndrfwini.
c
c       ylgndru2fw - faster evaluation of normalized Legendre functions 
c                  and their derivatives. 
c                  Requires prior call to ylgndrfwini.
c
c       ylgndru2sfw - faster evaluation of  normalized Legendre functions 
c                   and their derivatives (with scaling as in ylgndr2s).
c                   Requires prior call to ylgndrfwini.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     CODES
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine ylgndr(nmax, x, y)
      implicit none
c
c     Evaluate normalized Legendre functions defined as:
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                 must be non-negative
c     x                    -1 <= x <= 1
c     y(0:nmax,0:nmax)     resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x)
c     for 0 <= n <= nmax  and  0 <= m <= n.  Other elements of y
c     will contain undefined values.
c
cf2py intent(in) nmax
cf2py intent(in) x
cf2py intent(out) y

      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), u
c
c
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndr2(nmax, x, y, d)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x
cf2py intent(out) y,d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
c
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndr2s(nmax, x, y, d)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     For m>0, 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x
cf2py intent(out) y,d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      do n=m+2, nmax
        y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+(1-x**2)*y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+(1-x**2)*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
      subroutine ylgndru(nmax, x, y)
      implicit none
c
c     Evaluate normalized Legendre functions defined as:
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                 must be non-negative
c     x                    -1 <= x <= 1
c     y(0:nmax,0:nmax)     resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x)
c     for 0 <= n <= nmax  and  0 <= m <= n.  Other elements of y
c     will contain undefined values.
c
cf2py intent(in) nmax
cf2py intent(in) x
cf2py intent(out) y

      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), u
c
c
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c      do n=0, nmax
c	 do m=0, n
c	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
c         enddo
c      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndru2(nmax, x, y, d)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x
cf2py intent(out) y,d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
c
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c      do n=0, nmax
c	 do m=0, n
c	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
c	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
c         enddo
c      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndru2s(nmax, x, y, d)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     For m>0, 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x
cf2py intent(out) y,d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
c
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      do n=m+2, nmax
        y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+u2*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c      do n=0, nmax
c	 do m=0, n
c	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
c	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
c         enddo
c      enddo
      return
      end
c
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
c
      subroutine ylgndr2sm(nmax, x, y, d)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     For m>0, 
c          the functions are scaled by 1/sqrt(1-x**2)**m
c          the derivatives are scaled by 1/sqrt(1-x**2)**(m-2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x
cf2py intent(out) y,d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
c
      u=-sqrt((1-x))*sqrt((1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      do n=m+2, nmax
        y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+u2*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       faster version for real argument 
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
      subroutine ylgndrini(nmax, rat1, rat2)
      implicit none
c
c     Precompute the recurrence coefficients for the fast
c     evaluation of normalized Legendre functions and their derivatives
c    
c     Parameters:
c       nmax                      must be non-negative
c       rat1(0:nmax,0:nmax)       recurrence coefficient
c       rat2(0:nmax,0:nmax)       recurrence coefficient
c
cf2py intent(in) nmax
cf2py intent(out) rat1, rat2
c
      integer *8 nmax, m, n
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      rat1(0,0)=1
      rat2(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  rat1(m,m)=sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  rat2(m,m)=1
	 if (m.lt.nmax)  rat1(m+1,m)=sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  rat2(m+1,m)=1
	 do n=m+2, nmax
	    rat1(n,m)=(2*n-1)
            rat2(n,m)=sqrt((n+m-1.0d0)*(n-m-1.0d0))
	    rat1(n,m)=rat1(n,m)/sqrt(dble(n-m)*(n+m))
	    rat2(n,m)=rat2(n,m)/sqrt(dble(n-m)*(n+m))
         enddo
      enddo
c
c      do m=0, nmax
c	 do n=m, nmax
c            rat1(m,n)=rat1(n,m)
c            rat2(m,n)=rat2(n,m)
c         enddo
c      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndrf(nmax, x, y, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nmax, x, rat1, rat2
cf2py intent(out) y
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2f(nmax, x, y, d, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
c
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sf(nmax, x, y, d, rat1, rat2)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      do n=m+2, nmax
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndru2sf(nmax, x, y, d, rat1, rat2)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) =  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx =  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, n, m
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      do n=m+2, nmax
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
c      do n=0, nmax
c	 do m=0, n
c	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
c	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
c        enddo
c      enddo
      return
      end
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       complex valued Legendre functions
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
      subroutine zylgndr(nmax, z, y)
      implicit none
c
c     Evaluate normalized Legendre function for complex argument
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(z)
c     for 0 <= n <= nmax  and  0 <= m <= n.  Other elements of y
c     will contain undefined values.
c
cf2py intent(in) nmax, z
cf2py intent(out) y
c
      integer *8 nmax
      double complex z, y(0:nmax,0:nmax)
c
      integer *8 m,n
      double complex u
c
      u=-sqrt(1-z*z)
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*z*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine zylgndr2(nmax, z, y, d)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c       for complex argument
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values, double complex
c     d(0:nmax,0:nmax)      resulting derivative values, double complex
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention is valid for the derivative.
c
cf2py intent(in) nmax, z
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double complex z, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
      u=-sqrt(1-z*z)
      du=-z/u
      y(0,0)=1
      d(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*z/u**2
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  d(m+1,m)=(z*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*z*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(z*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine zylgndr2s(nmax, z, y, d)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(z) with m>0 
c          the functions are scaled by 1/sqrt(1-z**2)
c          the derivatives are scaled by sqrt(1-z**2)
c
c
c      Ynm(z) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(z)
c
c      d Ynm(z) / dz = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(z) / dz
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(z) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, z
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double complex z, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u
      double complex ztmp

      u=-sqrt(1-z*z)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(z*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      do n=m+2, nmax
        y(n,m)=((2*n-1)*z*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(z*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*z
c
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(z*d(m,m)+(1-z**2)*y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*z*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(z*d(n-1,m)+(1-z**2)*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine zylgndrf(nmax, z, y, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(z) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(z)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(z) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nmax, z, rat1, rat2
cf2py intent(out) y
c
      integer *8 nmax, m, n
      double complex z, y(0:nmax,0:nmax), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt(1-z*z)
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*z*y(n-1,m)-rat2(n,m)*y(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine zylgndr2f(nmax, z, y, d, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(z) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(z)
c
c      d Ynm(z) / dz = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(z) / dz
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(z) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, z, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double complex z, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt(1-z*z)
      du=z/sqrt(1-z*z)
      y(0,0)=1
      d(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=(d(m-1,m-1)*u+du)*rat1(m,m)
ccc	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*z/u**2
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  d(m+1,m)=(z*d(m,m)+y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*z*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(z*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine zylgndr2sf(nmax, z, y, d, rat1, rat2)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(z) with m>0 
c          the functions are scaled by 1/sqrt(1-z**2)
c          the derivatives are scaled by sqrt(1-z**2)
c
c
c      Ynm(z) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(z)
c
c      d Ynm(z) / dz = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(z) / dz
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(z) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, z, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, n
      double complex z, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt(1-z*z)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*rat1(m+1,m)
      if (m.lt.nmax)  d(m+1,m)=(z*d(m,m)+y(m,m))*rat1(m+1,m)
      do n=m+2, nmax
        y(n,m)=rat1(n,m)*z*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(z*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*z
c
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(z*d(m,m)+(1-z**2)*y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*z*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(z*d(n-1,m)+(1-z**2)*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       complex valued Legendre functions, modified branch cut
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
      subroutine zylgndrbr(nmax, z, y)
      implicit none
c
c     Evaluate normalized Legendre function for complex argument
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     z                     double complex
c     y(0:nmax,0:nmax)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(z)
c     for 0 <= n <= nmax  and  0 <= m <= n.  Other elements of y
c     will contain undefined values.
c
c       Modified branch cut at (0,+i) 
c
cf2py intent(in) nmax, z
cf2py intent(out) y
c
      integer *8 nmax
      double complex z, y(0:nmax,0:nmax)
c
      integer *8 m,n
      double complex u
c
      u=-sqrt(1-z*z)
c
c     branch cut at (0,+i), select the lower branch 
c     of complex square root
c
c      if( imag(1-z*z) .gt. 0 .and. real(1-z*z) .lt. 0) u=+sqrt(1-z*z)
      if( dimag(1-z*z) .gt. 0 .and. real(1-z*z) .lt. 0) u=+sqrt(1-z*z)
ccc      call prin2('in zylgndrbr, u=*', -u, 2)
ccc      call prin2('in zylgndrbr, 1-z^2=*', 1-z*z, 2)
c
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.lt.nmax)  y(m+1,m)=z*y(m,m)*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*z*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       complex valued Legendre functions (scaled)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
c
      subroutine zylgndrsc(nmax, z,scale, ysc)
      implicit none
c
c     Evaluate scaled versions of zylgndr.  zylgndr is the complex version
c     of the normalized Legendre function.  Scaling removes the possible
c     conditioning errors from zylgndr evaluated at large arguments.
c
c     y_nm = scale**(-n) * ysc_nm
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                      must be non-negative
c     z (double complex)            double complex argument
c     scale (real*8)
c          looks like scale wants to be O(1/z) and scale<1.
c     ysc(0:nmax,0:nmax)        resulting function values
c
cf2py intent(in) nmax, z, scale
cf2py intent(out) ysc
c
      integer *8 nmax
      double complex z, ysc(0:nmax,0:nmax)
      real*8 scale
c
      integer *8 m,n
      double complex u,ztmp
c
      ztmp = 1-z*z
      u=-sqrt(ztmp)
c      if(abs(imag(z)).le.1.0d-16.and.abs(real(z)).gt.1) then
c        if(imag(u).lt.0) u = dconjg(u)
      if(abs(dimag(z)).le.1.0d-16.and.abs(real(z)).gt.1) then
        if(dimag(u).lt.0) u = dconjg(u)
      endif
      ysc(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  then
            ysc(m,m)=ysc(m-1,m-1)*scale*u*sqrt((2*m-1.0d0)/(2*m))
c           call prinf('m=*',m,1)
c           call prin2('ysc(m,m)=*',ysc(m,m),2)
         endif
	 if (m.lt.nmax)  then
            ysc(m+1,m)=z*scale*ysc(m,m)*sqrt(2*m+1.0d0)
         endif
	 do n=m+2, nmax
	    ysc(n,m)=((2*n-1)*scale*z*ysc(n-1,m) - 
     1           sqrt((n+m-1.0d0)*(n-m-1.0d0))*scale**2*ysc(n-2,m))
     2           /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    ysc(n,m)=ysc(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       truncated recurrences for Legendre functions:
c    
c       Ynm(theta) for n = 0,nmax  but m = -m2,...,m2  with m2 < nmax.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
      subroutine ylgndr2s_trunc(nmax, m2, x, y, d)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, m2, x
cf2py intent(out) y, d
c
      integer *8 nmax, m, m2, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      do n=m+2, nmax
        y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, m2
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+(1-x**2)*y(m,m))*sqrt(2*m+1.0d0)
	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+(1-x**2)*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, min(n,m2)
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
c
      subroutine ylgndrf_trunc(nmax, m2, x, y, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., min(m2,n).
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nmax, m2, x, rat1, rat2
cf2py intent(out) y
c
      integer *8 nmax, m, m2, n
      double precision x, y(0:nmax,0:nmax), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, m2
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, min(n,m2)
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2f_trunc(nmax, m2, x, y, d, rat1, rat2)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c    
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c    
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c    
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., min(m2,n).
c    
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c    
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, m2, x, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, m2, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do m=0, m2
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, min(n,m2)
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sf_trunc(nmax, m2, x, y, d, rat1, rat2)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., min(n,m2).
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, m2, x, rat1, rat2
cf2py intent(out) y, d
c
      integer *8 nmax, m, m2, n
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
c
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      do n=m+2, nmax
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, m2
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nmax
	 do m=0, min(n,m2)
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       Symmetries for Legendre functions
c    
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
        subroutine ylgndrpm(nterms,y)
        implicit none
        integer *8 n,m,nterms
        double precision y(0:nterms,0:nterms)
c
c       Given Y_nm(x), return Y_nm(-x)
c
        do n=0,nterms
           do m=0,n
              if( mod(n+m,2) .eq. 1 ) y(n,m)=-y(n,m)
           enddo       
        enddo
c
        return
        end
c
c
c
c
c
        subroutine ylgndr2pm(nterms,y,d)
        implicit none
        integer *8 nterms,n,m
        double precision y(0:nterms,0:nterms)
        double precision d(0:nterms,0:nterms)
c
c       Given Y_nm(x), return Y_nm(-x)
c       Given Y'_nm(x), return Y'_nm(-x)
c
cf2py intent(in) nterms, y
cf2py intent(out) d
c
        do n=0,nterms
           do m=0,n
              if( mod(n+m,2) .eq. 1 ) y(n,m)=-y(n,m)
              if( mod(n+m,2) .eq. 0 ) d(n,m)=-d(n,m)
           enddo       
        enddo
c
        return
        end
c
c
c
c
c
        subroutine ylgndrpm_opt(nterms,y)
        implicit none
        integer *8 nterms,n,m
        double precision y(0:nterms,0:nterms)
c
c       Given Y_nm(x), return Y_nm(-x)
c
        do n=0,nterms,2
           do m=1,n,2
              y(n,m)=-y(n,m)
           enddo       
        enddo
c
        do n=1,nterms,2
           do m=0,n,2
              y(n,m)=-y(n,m)
           enddo       
        enddo
c
        return
        end
c
c
c
c
c
        subroutine ylgndr2pm_opt(nterms,y,d)
        implicit none
        integer *8 nterms,n,m
        double precision y(0:nterms,0:nterms)
        double precision d(0:nterms,0:nterms)
c
c       Given Y_nm(x), return Y_nm(-x)
c       Given Y'_nm(x), return Y'_nm(-x)
c
cf2py intent(in) nterms, y
cf2py intent(out) d
c
        do n=0,nterms,2
           do m=0,n,2
              d(n,m)=-d(n,m)
           enddo       
           do m=1,n,2
              y(n,m)=-y(n,m)
           enddo       
        enddo
c
        do n=1,nterms,2
           do m=0,n,2
              y(n,m)=-y(n,m)
           enddo       
           do m=1,n,2
              d(n,m)=-d(n,m)
           enddo       
        enddo
c
        return
        end
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       fast version of real valued Legendre functions, with storage
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
      subroutine ylgndrfwini(nmax, w, lw, lused)
      implicit none
c
c     Precompute the recurrence coefficients for the fast
c     evaluation of normalized Legendre functions and their derivatives
c    
c     Parameters:
c       nmax             must be non-negative
c       w                  contains rat1 and rat2 arrays
c
      integer *8 nmax,irat1,irat2,lw,lused
      double precision w(*)
c
cf2py intent(in) nmax, lw
cf2py intent(out) w, lused
c
      irat1=1
      irat2=1+(nmax+1)**2
      lused=2*(nmax+1)**2
      if( lused .gt. lw ) return
      
      call ylgndrini(nmax, w(irat1), w(irat2))
      return
      end
c
c
c
c
c
      subroutine ylgndrfw(nterms, x, y, w, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)          resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), w(*)
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndrfw0(nterms, x, y, w(irat1), w(irat2), nmax)
      else
        call ylgndr(nterms, x, y)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2fw(nterms, x, y, d, w, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y, d
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision w(*)    
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndr2fw0(nterms, x, y, d, w(irat1), w(irat2), nmax)
      else
        call ylgndr2(nterms, x, y, d)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sfw(nterms, x, y, d, w, nmax)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y, d
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision w(*)
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndr2sfw0(nterms, x, y, d, w(irat1), w(irat2), nmax)
      else
        call ylgndr2s(nterms, x, y, d)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndrfw0(nterms, x, y, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y
c
      integer *8 nterms,nmax,m,n
      double precision x, y(0:nterms,0:nterms), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, nterms
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 do n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         enddo
      enddo
c
      do n=0, nterms
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2fw0(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, m, n
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do m=0, nterms
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nterms)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
	 do n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      do n=0, nterms
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sfw0(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, m, n
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nterms)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      do n=m+2, nterms
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nterms
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nterms)  
ccc     $      d(m+1,m)=(x*d(m,m)+(1-x**2)*y(m,m))*rat1(m+1,m)
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 do n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
ccc	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+(1-x**2)*y(n-1,m))-
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
         enddo
      enddo
      do n=0, nterms
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndrufw(nterms, x, y, w, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)          resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), w(*)
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndrufw0(nterms, x, y, w(irat1), w(irat2), nmax)
      else
        call ylgndru(nterms, x, y)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndru2fw(nterms, x, y, d, w, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y, d
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision w(*)
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndru2fw0(nterms, x, y, d, w(irat1), w(irat2), nmax)
      else
        call ylgndru2(nterms, x, y, d)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndru2sfw(nterms, x, y, d, w, nmax)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, w, nmax
cf2py intent(out) y, d
c
      integer *8 nterms,nmax,irat1,irat2
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision w(*)
c
      if( nterms .le. nmax ) then
        irat1=1
        irat2=1+(nmax+1)**2
        call ylgndru2sfw0(nterms, x, y, d, w(irat1), w(irat2), nmax)
      else
        call ylgndru2s(nterms, x, y, d)
      endif
c
      return
      end
c
c
c
c
c
      subroutine ylgndrufw0_old(nterms, x, y, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do 10 m=0, nterms
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 do 20 n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
 20      continue
 10   continue
c
      return
      end
c
c
c
c
c
      subroutine ylgndrufw0(nterms, x, y, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)

      y(0,0)=1
      if( nterms .eq. 0 ) return

      y(1,0)=x*y(0,0)*rat1(1,0)

      u=-sqrt((1-x)*(1+x))
      do m=1, nterms-1
	 y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      enddo

      y(nterms,nterms)=y(nterms-1,nterms-1)*u*rat1(nterms,nterms)

c      do m=0, nterms-1
c	 do n=m+2, nterms
c	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
c         enddo
c      enddo

      do n=2, nterms
         do m=0, n-2
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndru2fw0_old(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      do 10 m=0, nterms
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nterms)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
	 do 20 n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
 20      continue
 10   continue
c
      return
      end
c
c
c
c
c
      subroutine ylgndru2fw0(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)

      y(0,0)=1
      d(0,0)=0
      if( nterms .eq. 0 ) return

      y(1,0)=x*y(0,0)*rat1(1,0)
      d(1,0)=(x*d(0,0)+y(0,0))*rat1(1,0)

      u=-sqrt((1-x)*(1+x))
      u2=(1-x)*(1+x)
      do m=1, nterms-1
         y(m,m)=y(m-1,m-1)*u*rat1(m,m)
         d(m,m)=y(m,m)*(-m)*x/u2
         y(m+1,m)=x*y(m,m)*rat1(m+1,m)
         d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
      enddo

      y(nterms,nterms)=y(nterms-1,nterms-1)*u*rat1(nterms,nterms)
      d(nterms,nterms)=y(nterms,nterms)*(-nterms*x)

      do n=2, nterms
         do m=0, n-2
         y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndru2sfw0_old(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nterms)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      do 120 n=m+2, nterms
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
120   continue
c
c       ... then, evaluate scaled associated Legendre functions
c
      do 210 m=1, nterms
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
c
	 if (m.lt.nterms)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nterms)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 do 220 n=m+2, nterms
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
220      continue
210   continue
c
      return
      end
c
c
c

      subroutine ylgndru2sfw0(nterms, x, y, d, rat1, rat2, nmax)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c
c      Ynm(x) = sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nterms
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nterms                      must be non-negative
c     x                         -1 <= x <= 1
c     y(0:nterms,0:nterms)      resulting function values
c     d(0:nterms,0:nterms)      resulting derivative values
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nterms and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nterms, x, rat1, rat2, nmax
cf2py intent(out) y, d
c
      integer *8 nterms, nmax, n, m
      double precision x, y(0:nterms,0:nterms), d(0:nterms,0:nterms)
      double precision u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)

      y(0,0)=1
      d(0,0)=0
      if( nterms .eq. 0 ) return

      y(1,0)=x*y(0,0)*rat1(1,0)
      d(1,0)=(x*d(0,0)+y(0,0))*rat1(1,0)

      u=-sqrt((1-x)*(1+x))
      u2=(1-x)*(1+x)
      do m=1, nterms-1
         if( m .eq. 1 ) y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
         if( m .gt. 1 ) y(m,m)=y(m-1,m-1)*u*rat1(m,m)
         d(m,m)=y(m,m)*(-m)*x
         y(m+1,m)=x*y(m,m)*rat1(m+1,m)
         d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
      enddo

      y(nterms,nterms)=y(nterms-1,nterms-1)*u*rat1(nterms,nterms)
      d(nterms,nterms)=y(nterms,nterms)*(-nterms*x)

      do n=2, nterms
         m=0
         y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
         do m=1, n-2
         y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
         d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-rat2(n,m)*d(n-2,m)
         enddo
      enddo
c
      return
      end
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
      subroutine ylgndr2smi(nmax, x, y, d, id)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     For m>0, 
c          the functions are scaled by 1/sqrt(1-x**2)**m
c          the derivatives are scaled by 1/sqrt(1-x**2)**(m-2)
c
c      scaled by 10^(-id) to handle underflow/overflow
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c     id(0:nmax,0:nmax)     external scaling factor 10^(-id)
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, id
cf2py intent(out) y,d
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
c
      u=-sqrt((1-x))*sqrt((1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*sqrt(2*m+1.0d0)
      id(0,m)=0
      id(1,m)=0
      do n=m+2, nmax
        y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        d(n,m)=((2*n-1)*(x*d(n-1,m)+y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
        id(n,m)=id(n-1,m)
        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        d(n,m)=d(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        d(n-1,m)=d(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        d(n,m)=d(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        d(n-1,m)=d(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif
      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*(-1)*sqrt((2*m-1.0d0)/(2*m))
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
	 if (m.gt.0)  id(m,m)=id(m-1,m-1)
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*sqrt(2*m+1.0d0)
	 if (m.lt.nmax)  id(m+1,m)=id(m,m)

        if( abs(y(m,m)) .gt. 1d+50) then
        y(m,m)=y(m,m)/1d50
        d(m,m)=d(m,m)/1d50
        id(m,m)=id(m,m)+50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)/1d50
        d(m+1,m)=d(m+1,m)/1d50
        id(m+1,m)=id(m+1,m)+50
        endif
        endif
c
        if( abs(y(m,m)) .lt. 1d-50) then
        y(m,m)=y(m,m)*1d50
        d(m,m)=d(m,m)*1d50
        id(m,m)=id(m,m)-50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)*1d50
        d(m+1,m)=d(m+1,m)*1d50
        id(m+1,m)=id(m+1,m)-50
        endif
        endif
c

	 do n=m+2, nmax
	    y(n,m)=((2*n-1)*x*y(n-1,m) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*y(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
	    d(n,m)=((2*n-1)*(x*d(n-1,m)+u2*y(n-1,m)) - 
     1               sqrt((n+m-1.0d0)*(n-m-1.0d0))*d(n-2,m))
     2               /sqrt((n-m+0.0d0)*(n+m))
            id(n,m)=id(n-1,m)

        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        d(n,m)=d(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        d(n-1,m)=d(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        d(n,m)=d(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        d(n-1,m)=d(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif

         enddo
      enddo
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c       real valued Legendre functions, with scaling factor
c       to handle underflow near the poles
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
      subroutine ylgndrfe(nmax, x, y, rat1, rat2, id)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      scaled by 10^(-id) to handle underflow/overflow
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     id(0:nmax,0:nmax)     external scaling factor 10^(-id)
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), u
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      y(0,0)=1
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  id(m,m)=id(m-1,m-1)
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  id(m+1,m)=id(m,m)

        if( abs(y(m,m)) .gt. 1d+50) then
        y(m,m)=y(m,m)/1d50
        id(m,m)=id(m,m)+50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)/1d50
        id(m+1,m)=id(m+1,m)+50
        endif
        endif
c
        if( abs(y(m,m)) .lt. 1d-50) then
        y(m,m)=y(m,m)*1d50
        id(m,m)=id(m,m)-50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)*1d50
        id(m+1,m)=id(m+1,m)-50
        endif
        endif

	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
            id(n,m)=id(n-1,m)

        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif

         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2fe(nmax, x, y, d, rat1, rat2, id)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      scaled by 10^(-id) to handle underflow/overflow
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c     id(0:nmax,0:nmax)     external scaling factor 10^(-id)
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y, d
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
c
      u=-sqrt((1-x)*(1+x))
      du=x/sqrt((1-x)*(1+x))
      y(0,0)=1
      d(0,0)=0
      id(0,0)=0
      do m=0, nmax
	 if (m.gt.0)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x/u**2
	 if (m.gt.0)  id(m,m)=id(m-1,m-1)
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
	 if (m.lt.nmax)  id(m+1,m)=id(m,m)

        if( abs(y(m,m)) .gt. 1d+50) then
        y(m,m)=y(m,m)/1d50
        d(m,m)=d(m,m)/1d50
        id(m,m)=id(m,m)+50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)/1d50
        d(m+1,m)=d(m+1,m)/1d50
        id(m+1,m)=id(m+1,m)+50
        endif
        endif
c
        if( abs(y(m,m)) .lt. 1d-50) then
        y(m,m)=y(m,m)*1d50
        d(m,m)=d(m,m)*1d50
        id(m,m)=id(m,m)-50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)*1d50
        d(m+1,m)=d(m+1,m)*1d50
        id(m+1,m)=id(m+1,m)-50
        endif
        endif

	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
            id(n,m)=id(n-1,m)

        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        d(n,m)=d(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        d(n-1,m)=d(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        d(n,m)=d(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        d(n-1,m)=d(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif

         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sfe(nmax, x, y, d, rat1, rat2, id)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c      scaled by 10^(-id) to handle underflow/overflow
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c     id(0:nmax,0:nmax)     external scaling factor 10^(-id)
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y, d
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
      u=-sqrt((1-x)*(1+x))
      u2 = (1-x)*(1+x)
      y(0,0)=1
      d(0,0)=0
      id(0,0)=0
c
c       ... first, evaluate standard Legendre polynomials
c
      m=0
      if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
      if (m.lt.nmax)  d(m+1,m)=(x*d(m,m)+y(m,m))*rat1(m+1,m)
      if (m.lt.nmax)  id(m+1,m)=id(m,m)

      do n=m+2, nmax
        y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
        d(n,m)=rat1(n,m)*(x*d(n-1,m)+y(n-1,m))-rat2(n,m)*d(n-2,m)
        id(n,m)=id(n-1,m)

        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        d(n,m)=d(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        d(n-1,m)=d(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        d(n,m)=d(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        d(n-1,m)=d(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif

      enddo
c
c       ... then, evaluate scaled associated Legendre functions
c
      do m=1, nmax
c
	 if (m.eq.1)  y(m,m)=y(m-1,m-1)*(-1)*rat1(m,m)
	 if (m.gt.1)  y(m,m)=y(m-1,m-1)*u*rat1(m,m)
	 if (m.gt.0)  d(m,m)=y(m,m)*(-m)*x
	 if (m.gt.0)  id(m,m)=id(m-1,m-1)
c
	 if (m.lt.nmax)  y(m+1,m)=x*y(m,m)*rat1(m+1,m)
	 if (m.lt.nmax)  
     $      d(m+1,m)=(x*d(m,m)+u2*y(m,m))*rat1(m+1,m)
	 if (m.lt.nmax)  id(m+1,m)=id(m,m)

        if( abs(y(m,m)) .gt. 1d+50) then
        y(m,m)=y(m,m)/1d50
        d(m,m)=d(m,m)/1d50
        id(m,m)=id(m,m)+50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)/1d50
        d(m+1,m)=d(m+1,m)/1d50
        id(m+1,m)=id(m+1,m)+50
        endif
        endif
c
        if( abs(y(m,m)) .lt. 1d-50) then
        y(m,m)=y(m,m)*1d50
        d(m,m)=d(m,m)*1d50
        id(m,m)=id(m,m)-50
        if (m.lt.nmax) then
        y(m+1,m)=y(m+1,m)*1d50
        d(m+1,m)=d(m+1,m)*1d50
        id(m+1,m)=id(m+1,m)-50
        endif
        endif


	 do n=m+2, nmax
	    y(n,m)=rat1(n,m)*x*y(n-1,m)-rat2(n,m)*y(n-2,m)
	    d(n,m)=rat1(n,m)*(x*d(n-1,m)+u2*y(n-1,m))-
     $         rat2(n,m)*d(n-2,m)
            id(n,m)=id(n-1,m)

        if( abs(y(n,m)) .gt. 1d+50) then
        y(n,m)=y(n,m)/1d50
        d(n,m)=d(n,m)/1d50
        id(n,m)=id(n,m)+50
        y(n-1,m)=y(n-1,m)/1d50
        d(n-1,m)=d(n-1,m)/1d50
        id(n-1,m)=id(n-1,m)+50
        endif
        if( abs(y(n,m)) .lt. 1d-50) then
        y(n,m)=y(n,m)*1d50
        d(n,m)=d(n,m)*1d50
        id(n,m)=id(n,m)-50
        y(n-1,m)=y(n-1,m)*1d50
        d(n-1,m)=d(n-1,m)*1d50
        id(n-1,m)=id(n-1,m)-50
        endif

         enddo
      enddo
c
      do n=0, nmax
	 do m=0, n
	    y(n,m)=y(n,m)*sqrt(2*n+1.0d0)
	    d(n,m)=d(n,m)*sqrt(2*n+1.0d0)
         enddo
      enddo
      return
      end
c
c
c
c
c
      subroutine ylgndrfex(nmax, x, y, rat1, rat2, id)
      implicit none
c
c     Evaluate normalized Legendre functions
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     id(0:nmax,0:nmax)     internal scaling factor 10^(-id)
c
c     In this routine, intermediary values are scaled 
c     by 10^(-id) to handle recurrence underflow/overflow
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. 
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), u, sc
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)

      call ylgndrfe(nmax, x, y, rat1, rat2, id)

      do m=0, nmax
         do n=m, nmax
            sc = 10d0**(id(n,m))
	    y(n,m)=y(n,m)*sc
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2fex(nmax, x, y, d, rat1, rat2, id)
      implicit none
c
c     Evaluate normalized Legendre functions and their derivatives
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c     id(0:nmax,0:nmax)     internal scaling factor 10^(-id)
c
c     In this routine, intermediary values are scaled 
c     by 10^(-id) to handle recurrence underflow/overflow
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y, d
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, du, sc
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)
c
      call ylgndr2fe(nmax, x, y, d, rat1, rat2, id)

      do m=0, nmax
         do n=m, nmax
            sc = 10d0**(id(n,m))
	    y(n,m)=y(n,m)*sc
	    d(n,m)=d(n,m)*sc 
         enddo
      enddo
c
      return
      end
c
c
c
c
c
      subroutine ylgndr2sfex(nmax, x, y, d, rat1, rat2, id)
      implicit none
c
c     Evaluate scaled normalized Legendre functions and their derivatives
c
c     Only for Ynm(x) with m>0 
c          the functions are scaled by 1/sqrt(1-x**2)
c          the derivatives are scaled by sqrt(1-x**2)
c
c      Ynm(x) = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) Pnm(x)
c
c      d Ynm(x) / dx = sqrt(2n+1)  sqrt( (n-m)!/ (n+m)! ) d Pnm(x) / dx
c
c     for n = 0, 1, 2,..., nmax
c     and  m = 0, 1,..., n.
c
c     Parameters:
c     nmax                  must be non-negative
c     x                     -1 <= x <= 1
c     y(0:nmax,0:nmax)      resulting function values
c     d(0:nmax,0:nmax)      resulting derivative values
c     id(0:nmax,0:nmax)     internal scaling factor 10^(-id)
c
c     In this routine, intermediary values are scaled 
c     by 10^(-id) to handle recurrence underflow/overflow
c
c     Upon return, y(n,m) will contain the function value Ynm(x) for 0
c     <= n <= nmax and 0 <= m <= n.  Other elements of y will contain
c     undefined values. The same convention for the derivatives.
c
cf2py intent(in) nmax, x, rat1, rat2, id
cf2py intent(out) y, d
c
      integer *8 nmax, m, n, id(0:nmax,0:nmax)
      double precision x, y(0:nmax,0:nmax), d(0:nmax,0:nmax), u, u2, sc
      double precision rat1(0:nmax,0:nmax), rat2(0:nmax,0:nmax)

      call ylgndr2sfe(nmax, x, y, d, rat1, rat2, id)

      do m=0, nmax
         do n=m, nmax
            sc = 10d0**(id(n,m))
	    y(n,m)=y(n,m)*sc
	    d(n,m)=d(n,m)*sc
         enddo
      enddo
c
      return
      end
c
c
c
c
c

      implicit none
      integer *8 ns
      double precision, allocatable :: source(:,:)
      double complex, allocatable :: charge(:)
      double complex, allocatable :: pot(:)
      double complex, allocatable :: grad(:,:)

      double precision eps
      double complex eye,zk
      integer *8 i,j,k,ier
      double precision hkrand
      

      data eye/(0.0d0,1.0d0)/

c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      call prin2("This code is an example fortran driver*",i,0)
      call prin2("On output, the code prints sample pot,grad*",i,0)
      write(*,*)
      write(*,*)


      zk = 2.2d0
      zk = 3.1418

      ns = 30000
      

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(pot(ns))
      allocate(grad(3,ns))


      eps = 0.5d-9

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources with distribution unif^2 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        charge(i) = hkrand(0) + eye*hkrand(0)

        pot(i) = 0
        grad(1,i) = 0
        grad(2,i) = 0
        grad(3,i) = 0 
      enddo


      call hfmm3d_s_c_g(eps,zk,ns,source,charge,
     1      pot,grad,ier)
      call prin2("pot at sources=*",pot,12)
      call prin2("grad at sources=*",grad,12)


      stop
      end
c----------------------------------------------------------
c
cc
c
c

c
cc      plane wave routines for Helmholtz 3D FMM
c 
c***********************************************************************
      subroutine hrlscini(rlsc,nlambs,rlams,rsc,zk,nterms)
c***********************************************************************
c
c       this subroutine computes p_{n,m}(i\sqrt(\lambda^2 - k^2)/k) (-i)^n
c       for all combinations of \lambda,n,m required for plane wave
c       routines in a Helmholtz fmm
c
c       input:
c       nlambs -     number of discretization nodes in lambda quadrature
c       rlams -      location of discretization nodes in lambda
c                    quadrature. Note here rlams stores sqrt(\lambda^2 -
c                    k^2)
c       rsc -        scaling parameter for ynm
c       zk -         Helmholtz parameter(k)
c       nterms -     max n for which p_{n,m}'s need to be computed
c
c       output:
c       rlsc(0:nterms,0:nterms,nlambs) -  rlsc(n,m,nl) = p_{n,m}(
c                                             i rlams(nl)/zk) (-i)^n
c
c
      implicit real *8 (a-h,o-z)
      integer *8 nlambs,nterms,i,j,l,nl,iin,im
      complex *16 rlsc(0:nterms,0:nterms,nlambs),rlams(nlambs)
      complex *16 zmult,ipow(0:nterms),ima,zk
      real *8 rsc,rsctmp

      done = 1
      ima = dcmplx(0,done)
      zmult = dcmplx(0,-done)
      ipow(0) = done

      do 900 i=1,nterms

      ipow(i) = ipow(i-1)*zmult

900   continue    

      do i=1,nlambs
        do j=0,nterms
          do l=0,nterms
            rlsc(l,j,i) = 0
          enddo
        enddo
      enddo
c
      do 2000 nl = 1,nlambs

      zmult = ima*rlams(nl)/zk
      call zylgndrsc(nterms,zmult,rsc,rlsc(0,0,nl))
cc      call zylgndr(nterms,zmult,rlsc(0,0,nl))

      do 1900 iin=1,nterms
      do 1800 im=0,nterms

      rlsc(iin,im,nl) = rlsc(iin,im,nl)*ipow(iin)

 1800 continue
 1900 continue
      

2000  continue
      return
      end
c***********************************************************************
      subroutine hmkexps(rlams,nlambs,numphys,nexptotp,zk,xs,ys,zs)
      implicit real *8 (a-h,o-z)
      integer *8  nlambs,numphys(nlambs),nexptotp,ntot,nl,mth
      integer *8  ncurrent
      complex *16 ima,zk,rk
      complex *16 xs(-5:5,nexptotp)
      complex *16 ys(-5:5,nexptotp)
      complex *16 zs(5,nexptotp),rlams(nlambs)
      real *8   u
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine computes the tables of exponentials needed
c     for translating exponential representations of harmonic
c     functions, discretized via normans quadratures.
c
c     u   = \int_0^\infty e^{-\lambda z}
c           \int_0^{2\pi} e^{i\lambda(x cos(u)+y sin(u))}
c           mexpphys(lambda,u) du dlambda
c
c     mexpphys(*):  discrete values of the moment function 
c                   m(\lambda,u), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c     on input:
c
c     rlams(nlambs)   discretization points in lambda integral.
c                     Note rlams stores \sqrt(\lambda^2 - k^2)
c     nlambs          number of discret. pts. in lambda integral
c     numphys(j)     number of nodes in u integral needed 
c                    for corresponding lambda =  lambda_j. 
c     nexptotp        sum_j numphys(j)
c     zk              Helmholtz parameter (k)
c
c     on output:
c
c     xs(-1,nexptotp)   e^{-i \lambda_j (cos(u_k)}  in above ordering
c     xs(-2,nexptotp)   e^{-i \lambda_j (2 cos(u_k)}  in above ordering.
c     xs(-3,nexptotp)   e^{-i \lambda_j (3 cos(u_k)}  in above ordering.
c     xs(-4,nexptotp)   e^{-i \lambda_j (4 cos(u_k)}  in above ordering.
c     xs(-5,nexptotp)   e^{-i \lambda_j (5 cos(u_k)}  in above ordering.
c     xs(1,nexptotp)   e^{i \lambda_j (cos(u_k)}  in above ordering
c     xs(2,nexptotp)   e^{i \lambda_j (2 cos(u_k)}  in above ordering.
c     xs(3,nexptotp)   e^{i \lambda_j (3 cos(u_k)}  in above ordering.
c     xs(4,nexptotp)   e^{i \lambda_j (4 cos(u_k)}  in above ordering.
c     xs(5,nexptotp)   e^{i \lambda_j (5 cos(u_k)}  in above ordering.
c     ys(-1,nexptotp)   e^{i \lambda_j (sin(u_k)}  in above ordering.
c     ys(-2,nexptotp)   e^{i \lambda_j (2 sin(u_k)}  in above ordering.
c     ys(-3,nexptotp)   e^{i \lambda_j (3 sin(u_k)}  in above ordering.
c     ys(-4,nexptotp)   e^{i \lambda_j (4 sin(u_k)}  in above ordering.
c     ys(-5,nexptotp)   e^{i \lambda_j (5 sin(u_k)}  in above ordering.
c     ys(1,nexptotp)   e^{i \lambda_j (sin(u_k)}  in above ordering.
c     ys(2,nexptotp)   e^{i \lambda_j (2 sin(u_k)}  in above ordering.
c     ys(3,nexptotp)   e^{i \lambda_j (3 sin(u_k)}  in above ordering.
c     ys(4,nexptotp)   e^{i \lambda_j (4 sin(u_k)}  in above ordering.
c     ys(5,nexptotp)   e^{i \lambda_j (5 sin(u_k)}  in above ordering.
c     zs(1,nexptotp)   e^{-\sqrt(\lambda_j^2-k^2)}     in above ordering.
c     zs(2,nexptotp)    e^{-2 \sqrt(\lambda_j^2-k^2)}   in above ordering. 
c     zs(3,nexptotp)    e^{-3 \sqrt(\lambda_j^2-k^2)}   in above ordering. 
c     zs(4,nexptotp)    e^{-4 \sqrt(\lambda_j^2-k^2)}   in above ordering. 
c     zs(5,nexptotp)    e^{-5 \sqrt(\lambda_j^2-k^2)}   in above ordering. 
c------------------------------------------------------------
c      
c     loop over each lambda value 
c
      pi = 4*datan(1.0d0)
      ntot = 0
      do 400 nl = 1,nlambs
         hu=2*pi/numphys(nl)

         rk = sqrt(rlams(nl)**2 + zk**2)

         do 200 mth = 1,numphys(nl)
            u = (mth-1)*hu
            ncurrent = ntot+mth
            zs(1,ncurrent) = exp(-rlams(nl) )
            zs(2,ncurrent) = exp(-2.0d0*rlams(nl) )
            zs(3,ncurrent) = exp(-3.0d0*rlams(nl) )
            zs(4,ncurrent) = exp(-4.0d0*rlams(nl) )
            zs(5,ncurrent) = exp(-5.0d0*rlams(nl) )
            xs(-1,ncurrent) = exp(-ima*rk*cos(u))
            xs(-2,ncurrent) = exp(-ima*rk*2.0d0*cos(u))
            xs(-3,ncurrent) = exp(-ima*rk*3.0d0*cos(u))
            xs(-4,ncurrent) = exp(-ima*rk*4.0d0*cos(u))
            xs(-5,ncurrent) = exp(-ima*rk*5.0d0*cos(u))
            xs(0,ncurrent) = 1
            xs(1,ncurrent) = exp(ima*rk*cos(u))
            xs(2,ncurrent) = exp(ima*rk*2.0d0*cos(u))
            xs(3,ncurrent) = exp(ima*rk*3.0d0*cos(u))
            xs(4,ncurrent) = exp(ima*rk*4.0d0*cos(u))
            xs(5,ncurrent) = exp(ima*rk*5.0d0*cos(u))
            ys(-1,ncurrent) = exp(-ima*rk*dsin(u))
            ys(-2,ncurrent) = exp(-ima*rk*2.0d0*dsin(u))
            ys(-3,ncurrent) = exp(-ima*rk*3.0d0*dsin(u))
            ys(-4,ncurrent) = exp(-ima*rk*4.0d0*dsin(u))
            ys(-5,ncurrent) = exp(-ima*rk*5.0d0*dsin(u))
            ys(0,ncurrent) = 1
            ys(1,ncurrent) = exp(ima*rk*dsin(u))
            ys(2,ncurrent) = exp(ima*rk*2.0d0*dsin(u))
            ys(3,ncurrent) = exp(ima*rk*3.0d0*dsin(u))
            ys(4,ncurrent) = exp(ima*rk*4.0d0*dsin(u))
            ys(5,ncurrent) = exp(ima*rk*5.0d0*dsin(u))
200      continue
         ntot = ntot+numphys(nl)
400   continue
      return
      end
c***********************************************************************
      subroutine hmkfexp(nlambs,numfour,numphys,fexp,fexp2)
      implicit real *8 (a-h,o-z)
      double complex ima
      double complex fexp(*),fexp2(*)
      integer *8  nlambs,numphys(*),numfour(*)
      integer *8 next,i,j,mm,nalpha
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine computes the tables of exponentials needed
c     for mapping from fourier to physical domain. 
c     in order to minimize storage, they are organized in a 
c     one-dimenional array corresponding to the order in which they
c     are accessed by subroutine ftophys.
c    
c***********************************************************************
      pi = 4*datan(1.0d0)

      next = 1

      do i=1,nlambs
        nalpha = numphys(i)
        halpha=2*pi/nalpha

        do j=1,nalpha
          do mm = 1,numfour(i)
            alpha=(j-1)*halpha
            fexp(next) = exp(ima*mm*alpha)
            next = next + 1
          enddo
        enddo
      enddo


      next = 1
      do i=1,nlambs
 
        nalpha = numphys(i)
        halpha=2*pi/nalpha
        do mm = 1,numfour(i)
          do j=1,nalpha
            alpha=(j-1)*halpha
            fexp2(next) = exp(-ima*mm*alpha)
	        next = next + 1
          enddo
        enddo
      enddo


      return
      end
c***********************************************************************

      subroutine hmpoletoexp(nd,mpole,nterms,nlambs,numtets,nexptot,
     1                mexpupf,mexpdownf,rlsc)

c     This subroutine converts a multipole expansion into the
c     corresponding exponential moment function mexp for
c     both the +z direction and the -z direction
c
c     U(x,y,z) = \sum_{n=0}^{nterms} \sum_{m=-n,n} mpole(n,m)
c                P_n^m (\cos(\theta)) e^{i m \phi} h_{n} (kr)
c  
c              = (1/2\pi) \int_{0}^{\infty} e^{-\sqrt(\lambda^2-k^2) z}
c                \int_{0}^{2\pi} e^{i \lambda (x \cos(\alpha) +
c                y \sin(\alpha))} mexpup(\lambda,\alpha)
c                d\alpha d\lambda
c 
c     for the +z direction and
c
c              = (1/2\pi) \int_{0}^{\infty} e^{\sqrt(\lambda^2-k^2) z}
c                \int_{0}^{2\pi} e^{-i \lambda (x \cos(\alpha) +
c                y \sin(\alpha))} mexpdown(\lambda,\alpha)
c                d\alpha d\lambda
c 
c     for the -z direction
c
c     NOTE: The expression for -z corresponds to the mapping
c     (x,y,z) -> (-x,-y,-z), ie reflection through
c     the origin.
c
c     NOTE 2: The multipole expansion is assumed to have been
c     rescaled so that the box containing the sources has unit
c     dimension
c
c     NOTE 3: Since we store the exponential moment function in
c     Fourier domain (w.r.t the \alpha variable) we compute
c 
c     M_\lambda(m) = (i)**m (-i)**n \sum_{n=m}^{N} P_{n,m}(i
c                       \sqrt(\lambda^2 -k^2)/k) mpole(n,m)
c      
c
c     INPUT arguments
c     nd          in: integer *8
c                 number of multipole expansions       
c     
c     mpole       in: complex *16 (nd,0:nterms, -nterms:nterms)
c                 The multipole expansion 
c  
c     nterms:     in: integer *8
c                 Order of the multipole expansion
c
c     nlambs      in: integer *8
c                 number of discretization points in the \lambda
c                 integral
c
c     numtets     in: integer *8(nlambs)
c                 number of fourier modes needed in expansion
c                 of \alpha variable for each \lambda variable
c
c     nexptot     in: integer *8
c                 nexptot = \sum_{j} numtets(j)
c
c     rlsc        in: real *8(nlambs, 0:nterms, 0:nterms)
c                 scaled discretization points in the \lambda
c                 integral
c
c     OUTPUT 
c     mexpupf     out: complex *16 (nd,nexptot)
c                 Fourier coefficients of the function
c                 mexpup(\lambda,\alpha) for successive
c                 discrete lambda values. They are ordered as
c                 follows
c
c                 mexpupf(1,...., 2*numtets(1)+1) = fourier modes
c                             for \lambda_1
c                 a_{0},a_{1},a_{-1},a_{2},a_{-2},...,a_{numtets(1)},
c                 a_{-numtets(1)}
c
c                 mexpupf(2*numtets(1)+2,...., numtets(2) = fourier
c                 modes for \lambda_2
c
c                 ETC
c
c     mexpdownf   out: complex *16 (nd,nexptot)
c                 Fourier coefficients of the function 
c                 mexpdown(\lambda,\alpha) for successive
c                 discrete \lambda values
c---------------------------------------------------------------

      implicit none
      integer *8 nd
      integer *8 nterms,nlambs,numtets(nlambs),nexptot
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      complex *16 mexpupf(nd,nexptot)
      complex *16 mexpdownf(nd,nexptot)
      complex *16, allocatable :: ztmp1(:),ztmp2(:),ztmp3(:),ztmp4(:)
      complex *16 zeyep
      complex *16 rlsc(0:nterms,0:nterms,nlambs)

c     Temp variables
      real *8 sgn
      integer *8 ntot,ncurrent,nl,mth,nm,idim

      allocate(ztmp1(nd),ztmp2(nd),ztmp3(nd),ztmp4(nd))

      ntot = 0
      do nl=1,nlambs
         sgn = 1.0d0

         do idim=1,nd
           ztmp1(idim) = 0
           ztmp2(idim) = 0
         enddo

         mth = 0 
         ncurrent = ntot + 1

         do nm = mth,nterms,2
            do idim=1,nd
              ztmp1(idim) = ztmp1(idim) + 
     1            rlsc(nm,mth,nl)*mpole(idim,nm,mth)
            enddo
         enddo

         do nm=mth+1,nterms,2
            do idim=1,nd
              ztmp2(idim) = ztmp2(idim) + 
     1            rlsc(nm,mth,nl)*mpole(idim,nm,mth)
            enddo
         enddo

         do idim=1,nd
           mexpupf(idim,ncurrent) = ztmp1(idim)+ztmp2(idim)
           mexpdownf(idim,ncurrent) = sgn*(ztmp1(idim)-ztmp2(idim))
         enddo

         do mth = 1,numtets(nl)
            ncurrent = ntot + 2*mth

            do idim=1,nd
              ztmp1(idim) = 0
              ztmp2(idim) = 0
              ztmp3(idim) = 0
              ztmp4(idim) = 0
            enddo

            sgn = -sgn
            do nm = mth,nterms,2
               do idim=1,nd
                  ztmp1(idim) = ztmp1(idim) + 
     1                rlsc(nm,mth,nl)*mpole(idim,nm,mth)
                  ztmp3(idim) = ztmp3(idim) + 
     1                rlsc(nm,mth,nl)*mpole(idim,nm,-mth)
               enddo
            enddo

            do nm=mth+1,nterms,2
               do idim=1,nd
                 ztmp2(idim) = ztmp2(idim) + 
     1              rlsc(nm,mth,nl)*mpole(idim,nm,mth)
                 ztmp4(idim) = ztmp4(idim) + 
     1              rlsc(nm,mth,nl)*mpole(idim,nm,-mth)
               enddo
            enddo

            do idim=1,nd
              mexpupf(idim,ncurrent) = ztmp1(idim)+ztmp2(idim)
              mexpdownf(idim,ncurrent) = sgn*(ztmp1(idim)-ztmp2(idim))

              mexpupf(idim,ncurrent+1) = ztmp3(idim)+ztmp4(idim)
              mexpdownf(idim,ncurrent+1) = sgn*(ztmp3(idim)-ztmp4(idim))
            enddo
         enddo
         ntot = ntot + 2*numtets(nl)+1
      enddo

      return
      end

c-----------------------------------------------------------------      
      subroutine hexptolocal(nd,local,nterms,zk,rlambs,whts,nlambs,
     1       numtets,nthmax,nexptot,lexp1f,lexp2f,scale,rlsc)
c-----------------------------------------------------------------
c     This sburoutine converts the Fourier representation of
c     an exponential moment function into a local
c     multipole expansion (with respect to the same box center)
c
c     (+z direction and -z combined)
c
c     u(x,y,z) = \int_{0}^{\infty} e^{-\sqrt(\lambda-k^2) z}
c                \int_{0}^{2\pi} e^{i\lambda(x\cos(\alpha) +
c                y\sin(\alpha))} lexp1 (\lambda,\alpha) 
c                P_{n,m}(i \sqrt(\lambda^2 -k^2)/k) \lambda/
c                \sqrt(\lambda^2 - k^2)
c                d\lambda
c                d\alpha
c
c              = \sum_{0}^{nterms} \sum_{m=-n,n} local(n,m) Y_n^m
c                 (\cos(\theta)) e^{i m \phi} r^{n}
c
c     INPUT arguments
c     nd               in: integer *8
c                      number of local expansions
c     nterms           in: integer *8
c                      Order of local expansion
c
c     zk               in: complex *16
c                      Helmholtz parameter
c
c     rlambs           in: complex *16(nlambs)
c                      discretization points in the \lambda integral
c
c     whts             in: complex *16(nlambs)
c                      quadrature weights in \lambda integral
c
c     nlambs           in: integer *8
c                      number of discretization points in \lambda
c                      integral
c
c     numtets          in: integer *8(nlambs)
c                      number of fourier modes in expansion of
c                      \alpha variable for \lambda_j
c
c     nthmax           in: integer *8
c                      max_j numtets(j)
c
c     nexptot          in: integer *8
c                      sum_j numtets(j)
c                      
c
c     lexp1f           complex *16(nd,nexptot)
c                      Fourier coefficients of the function 
c                      lexp1 for discrete \lambda values in the +z
c                      direction.
c
c                      They are ordered as follows:
c
c                      lexp1f(1,...,2*numtets(1)+1) = Fourier modes
c                      for \lambda_1
c                      a_{0},a_{1},a_{-1},a_{2},a_{-2},...a_{numtets(1)},
c                      a_{-numtets(1)}
c                      lexp1f(2*numtets(1)+2,...,numtets(2) = Fourier
c                      modes for \lambda_2 etc
c
c     lexp2f           complex *16(nd,nexptot)
c                      Fourier coefficients of the function 
c                      lexp2 for discrete \lambda values in the -z
c                      direction.
c
c                      They are ordered as follows:
c
c                      lexp2f(1,...,2*numtets(1)+1) = Fourier modes
c                      for \lambda_1
c                      a_{0},a_{1},a_{-1},a_{2},a_{-2},...a_{numtets(1)},
c                      a_{-numtets(1)}
c                      lexp2f(2*numtets(1)+2,...,numtets(2) = Fourier
c                      modes for \lambda_2 etc
c
c     scale            in: real *8
c                      scaling parameter for local expansion
c
c     OUTPUT
c     local(nd,0:nterms,-nterms:nterms): output local expansion of order
c                                     nterms
        
      implicit none
      integer *8 nterms,nlambs,numtets(nlambs),nexptot,nthmax,nd
      integer *8 ncurrent,ntot,nl,ncurrent2
      complex *16 local(nd,0:nterms,-nterms:nterms)
      complex *16 ima,zmult
      complex *16 lexp1f(nd,nexptot),lexp2f(nd,nexptot)
      complex *16 rlambs(nlambs), whts(nlambs)
      complex *16 rlsc(0:nterms,0:nterms,nlambs),ztmp
      complex *16 zk,zk2
      real *8 scale, rscale(0:nterms)
    
c     Temporary variables
      integer *8 i, nm, mth, j, mmax,idim
      real *8 done

      done = 1
      ima = cmplx(0,done)
      zk2 = 1/(ima*zk)

      rscale(0) = 1

      do nm=0,nterms

         if(nm.gt.0) then

         rscale(nm) = rscale(nm-1)*scale

         endif

         do mth = -nterms,nterms
            do idim=1,nd
              local(idim,nm,mth) = 0.0d0
            enddo
         enddo
      enddo

      ntot = 0
      do nl=1,nlambs
c        Add contributions to local expansion
         do nm=0,nterms,2
            mmax = numtets(nl)
            if(mmax.gt.nm) mmax = nm

            ncurrent = ntot+1
            ztmp = rlsc(nm,0,nl)*whts(nl)
            do idim=1,nd
               local(idim,nm,0) = local(idim,nm,0)+
     1            (lexp2f(idim,ncurrent)+
     1            lexp1f(idim,ncurrent))*ztmp
            enddo
            do mth=1,mmax
               ncurrent = ntot+2*mth
               ncurrent2 = ntot+2*mth+1

               ztmp = rlsc(nm,mth,nl)*whts(nl)
               do idim=1,nd
                  local(idim,nm,mth) = local(idim,nm,mth)+
     1             (lexp2f(idim,ncurrent)+
     1             lexp1f(idim,ncurrent))*ztmp
                  local(idim,nm,-mth) = local(idim,nm,-mth)+
     1              (lexp2f(idim,ncurrent2)+
     1             lexp1f(idim,ncurrent2))*ztmp
               enddo
            enddo
         enddo
         do nm=1,nterms,2
            mmax = numtets(nl) 
            if(mmax.gt.nm) mmax = nm
            ncurrent = ntot+1

            ztmp = rlsc(nm,0,nl)*whts(nl)
            do idim=1,nd
              local(idim,nm,0) = local(idim,nm,0)+
     1           (lexp2f(idim,ncurrent)-
     1           lexp1f(idim,ncurrent))*ztmp
            enddo
            do mth =1,mmax
               ncurrent = ntot+2*mth
               ncurrent2 = ntot+2*mth+1
               ztmp = rlsc(nm,mth,nl)*whts(nl)
               do idim=1,nd
                 local(idim,nm,mth) = local(idim,nm,mth)+
     1            (lexp2f(idim,ncurrent)-
     1            lexp1f(idim,ncurrent))*ztmp
                 local(idim,nm,-mth) = local(idim,nm,-mth)+
     1             (lexp2f(idim,ncurrent2)-
     1             lexp1f(idim,ncurrent2))*ztmp
               enddo
            enddo
         enddo
         ntot = ntot + 2*numtets(nl)+1
      enddo

      ztmp = zk2
      do nm=0,nterms
         do mth = -nm,nm
              
            do idim=1,nd
              local(idim,nm,mth) = local(idim,nm,mth)*ztmp
            enddo
         enddo
      enddo

      return
      end
c***********************************************************************
      subroutine hphystof(nd,mexpf,nlambs,numfour,numphys,mexpphys,
     1   fexp2)
c***********************************************************************
      implicit real *8 (a-h,o-z)
      integer *8 nd,idim
      complex *16 mexpf(nd,*)
      complex *16 mexpphys(nd,*),ima
      complex *16 fexp2(*)
      real *8, allocatable :: alphas(:)
      integer *8  nlambs,numfour(nlambs),numphys(nlambs)
      integer *8 nftot,nptot,next,i,j,nalpha,ival,mm
      data ima/(0.0d0,1.0d0)/
c***********************************************************************
c
c     this subroutine converts the discretized exponential moment function
c     into its fourier expansion.
c
c     on input:
c
c     nd:   number of expansions 
c     mexpphys(nd,*):  discrete values of the moment function 
c                   m(\lambda,\alpha), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c     nlambs:        number of discretization pts. in lambda integral
c     numfour(j):   number of fourier modes in the expansion
c                      of the function m(\lambda_j,\alpha)
c     on output:
c
c     mexpf(nd,*):     fourier coefficients of the function 
c                   mexp(lambda,alpha) for discrete lambda values. 
c                   they are ordered as follows:
c
c               mexpf(1,...,2*numfour(1)+1) = fourier modes for lambda_1
c               a_{0},a_{1},a_{-1},a_{2},a_{-2},...a_{numfour(1)},
c                   a_{-numfour(1)}
c               mexpf(2*numfour(1)+2,...,numfour(2)) = fourier modes
c                                              for lambda_2
c               etc.
c
c------------------------------------------------------------
      done=1.0d0

      allocate(alphas(0:3000))
c
c
      pi=datan(done)*4
      nftot = 0
      nptot  = 0
      next  = 1

      do i=1,nlambs
        nalpha = numphys(i)
        halpha=2*pi/nalpha

        do j=1,nalpha
          alphas(j)=(j-1)*halpha
        enddo

        do idim=1,nd
          mexpf(idim,nftot+1) = 0.0d0
        enddo
        do ival=1,nalpha
           do idim=1,nd
              mexpf(idim,nftot+1) = mexpf(idim,nftot+1) + 
     1            mexpphys(idim,nptot+ival)
           enddo
        enddo

        do idim=1,nd
           mexpf(idim,nftot+1) = mexpf(idim,nftot+1)/nalpha
        enddo
        do mm = 1,numfour(i)

           do idim=1,nd
              mexpf(idim,nftot+2*mm) = 0.0d0
              mexpf(idim,nftot+2*mm+1) = 0.0d0
           enddo

           do ival=1,nalpha
              do idim=1,nd
                 mexpf(idim,nftot+2*mm) = mexpf(idim,nftot+2*mm) +
     1            fexp2(next)*mexpphys(idim,nptot+ival)
                mexpf(idim,nftot+2*mm+1) = mexpf(idim,nftot+2*mm+1) +
     1            conjg(fexp2(next))*mexpphys(idim,nptot+ival)
               enddo
               next = next+1
           enddo
           do idim=1,nd
              mexpf(idim,nftot+2*mm) = mexpf(idim,nftot+2*mm)/nalpha
              mexpf(idim,nftot+2*mm+1) = mexpf(idim,nftot+2*mm+1)/nalpha
           enddo
        enddo
        nftot = nftot+2*numfour(i)+1
        nptot = nptot+numphys(i)
      enddo

      return
      end
c
c********************************************************************
      subroutine hftophys(nd,mexpf,nlambs,numfour,numphys,mexpphys,fexp)
c***********************************************************************
      implicit real *8 (a-h,o-z)
      integer *8 nd,idim,nftot,nptot,next,i,ival,mm
      complex *16 mexpf(nd,*)
      complex *16 mexpphys(nd,*),ima,ctmp
      complex *16 fexp(*)
      real *8, allocatable :: alphas(:) 
      integer *8  nlambs,numfour(nlambs),numphys(nlambs)
      data ima/(0.0d0,1.0d0)/
c***********************************************************************
c
c     this subroutine evaluates the fourier expansion of the
c     exponential moment function m(\lambda,\alpha) at equispaced
c     nodes.
c
c     on input:
c
c     nd      :     number of expansions
c     mexpf(nd,*):     fourier coefficients of the function 
c                   mexp(lambda,alpha) for discrete lambda values. 
c                   they are ordered as follows:
c
c               mexpf(1,...,2*numfour(1)+1) = fourier modes for lambda_1
c               a_{0},a_{1},a_{-1},a_{2},a_{-2},...,a_{numfour(1)},
c               a_{-numfour(1)}
c               mexpf(2*numfour(1)+2,...,numfour(2)) = fourier modes
c                                              for lambda_2
c               etc.
c
c     nlambs:        number of discretization pts. in lambda integral
c     numfour(j):   number of fourier modes in the expansion
c                      of the function m(\lambda_j,\alpha)
c     fexp =      precomputed array of exponentials needed for
c                  fourier series evaluation
c
c     on output:
c
c     mexpphys(nd,*):  discrete values of the moment function 
c                   m(\lambda,\alpha), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c------------------------------------------------------------
      done=1.0d0

      allocate(alphas(0:3000))
c
c
      pi=datan(done)*4
      nftot = 0
      nptot  = 0
      next = 1
      do i=1,nlambs
        do ival=1,numphys(i)
           do idim=1,nd
             mexpphys(idim,nptot+ival) = mexpf(idim,nftot+1)
           enddo
           do mm = 1,numfour(i)
              do idim=1,nd
                ctmp = mexpf(idim,nftot+2*mm)*fexp(next)
                ctmp = ctmp + mexpf(idim,nftot+2*mm+1)*conjg(fexp(next))
                mexpphys(idim,nptot+ival) = mexpphys(idim,nptot+ival) + 
     1              ctmp
              enddo
              next = next + 1
           enddo
         enddo

         nftot = nftot+2*numfour(i)+1
         nptot = nptot+numphys(i)
      enddo


      return
      end
c----------------------------------------------------------      

      subroutine hprocessudexp(nd,zk2,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nuall,uall,
     3           nu1234,u1234,ndall,dall,nd5678,d5678,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpuall,mexpu5678,mexpdall,
     5           mexpd1234,xs,ys,zs,fexpback,rlsc,
     6           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4,
     7           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
       implicit none
       integer *8 nd,idim
       integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
       integer *8 nphysical(nlams),nfourier(nlams)
       integer *8 iaddr(2,nboxes)
       integer *8 ichild(8,nboxes)
       integer *8 nexptot,nexptotp,nmax
       integer *8 nuall,ndall,nu1234,nd5678
       integer *8 uall(*),dall(*),u1234(*),d5678(*)
       real *8 rscale,bs
       complex *16 zk2
       complex *16 rlams(*),whts(*)
       complex *16 tloc(nd,0:nterms,-nterms:nterms)
       integer *8 nboxesilev
       integer *8 mexpoffset
       complex *16 mexp(nd,nexptotp,nboxesilev,6)
c       complex *16 mexp(nd,nexptotp,nboxes,6)
       real *8 rmlexp(*),centers(3,*)
       complex *16 mexpup(nd,nexptot),mexpdown(nd,nexptot)
       complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
       complex *16 mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
       complex *16 mexpd1234(nd,nexptotp),mexpu5678(nd,nexptotp)
       complex *16 xs(-5:5,nexptotp),ys(-5:5,nexptotp),zs(5,nexptotp)
       complex *16 rlsc(0:nterms,0:nterms,nlams)
       complex *16 fexpback(*)
       integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
       integer *8 nlist4
       double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
       integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,kbox
       complex *16 ztmp,ztmp2,zmul

     
       real *8 ctmp(3)



       do i=1,nexptotp
         do idim=1,nd
           mexpuall(idim,i) = 0
           mexpdall(idim,i) = 0
           mexpu5678(idim,i) = 0
           mexpd1234(idim,i) = 0
         enddo
       enddo
      
   
       ctmp(1) = centers(1,ibox) - bs/2.0d0
       ctmp(2) = centers(2,ibox) - bs/2.0d0
       ctmp(3) = centers(3,ibox) - bs/2.0d0
       
       do i=1,nuall
          jbox = uall(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
             do idim=1,nd
               mexpdall(idim,j) = mexpdall(idim,j) + 
     1              mexp(idim,j,jbox,2)*zmul
             enddo
          enddo
       enddo

       do i=1,nu1234
          jbox = u1234(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
             do idim=1,nd
               mexpd1234(idim,j) = mexpd1234(idim,j) + 
     1            mexp(idim,j,jbox,2)*zmul
             enddo
          enddo
       enddo

       do i=1,ndall
          jbox = dall(i)

          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
             do idim=1,nd
                mexpuall(idim,j) = mexpuall(idim,j) + 
     1              mexp(idim,j,jbox,1)*zmul
             enddo
          enddo
       enddo

       do i=1,nd5678
          jbox = d5678(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
             do idim=1,nd
               mexpu5678(idim,j) = mexpu5678(idim,j) + 
     1            mexp(idim,j,jbox,1)*zmul
             enddo
          enddo
       enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
       jbox = ichild(1,ibox)

       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)
            mexpdownphys(idim,i) = mexpdall(idim,i) + mexpd1234(idim,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 2
       jbox = ichild(2,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
             mexpupphys(idim,i)  = mexpuall(idim,i)*xs(1,i)
             mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1            mexpd1234(idim,i))*xs(-1,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif
  
c      add contributions due to child 3
       jbox = ichild(3,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1           mexpd1234(idim,i))*ys(-1,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 4
       jbox = ichild(4,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
             mexpupphys(idim,i)  = mexpuall(idim,i)*ztmp
             mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1            mexpd1234(idim,i))*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 5
       jbox = ichild(5,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = 1/zs(1,i)

          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1         mexpu5678(idim,i))*zs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 6
       jbox = ichild(6,ibox)

       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1           mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 7
 
       jbox = ichild(7,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)

          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1          mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 8
       jbox = ichild(8,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1         mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

       endif

      return
      end
c--------------------------------------------------------------------      

      subroutine hprocessnsexp(nd,zk2,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nnall,nall,
     3           nn1256,n1256,nn12,n12,nn56,n56,
     4           nsall,sall,ns3478,s3478,ns34,s34,ns78,s78,mexpup,
     5           mexpdown,mexpupphys,mexpdownphys,
     6           mexpnall,mexpn3478,mexpn34,mexpn78,mexpsall,
     7           mexps1256,mexps12,mexps56,rdplus,
     8           xs,ys,zs,fexpback,rlsc,
     9           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4,
     9           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      process north south expansions for box ibox
c-------------------------------------------------------------------
       implicit none
       integer *8 nd,idim
       integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
       integer *8 nphysical(nlams),nfourier(nlams)
       integer *8 iaddr(2,nboxes)
       integer *8 ichild(8,nboxes)
       integer *8 nexptot,nexptotp,nmax
       integer *8 nnall,nsall,nn1256,ns3478,nn12,nn56,ns34,ns78
       integer *8 nall(*),sall(*),n1256(*),s3478(*)
       integer *8 n12(*),n56(*),s34(*),s78(*)
       real *8 rscale,bs
       complex *16 zk2
       complex *16 rlams(*),whts(*)
       complex *16 tloc(nd,0:nterms,-nterms:nterms)
       complex *16, allocatable :: tloc2(:,:,:)
       integer *8 nboxesilev
       integer *8 mexpoffset
       complex *16 mexp(nd,nexptotp,nboxesilev,6)
c       complex *16 mexp(nd,nexptotp,nboxes,6)
       real *8 rdplus(0:nterms,0:nterms,-nterms:nterms)
       real *8 rmlexp(*),centers(3,*)
       complex *16 mexpup(nd,nexptot),mexpdown(nd,nexptot)
       complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
       complex *16 mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
       complex *16 mexps1256(nd,nexptotp),mexpn3478(nd,nexptotp)
       complex *16 mexps12(nd,nexptotp),mexps56(nd,nexptotp)
       complex *16 mexpn34(nd,nexptotp),mexpn78(nd,nexptotp)
       complex *16 xs(-5:5,nexptotp),ys(-5:5,nexptotp),zs(5,nexptotp)
       complex *16 rlsc(0:nterms,0:nterms,nlams)
       complex *16 fexpback(*)
       integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
       integer *8 nlist4
       double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
       integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,kbox
       complex *16 ztmp,zmul,ztmp2

     
       real *8 ctmp(3)
       allocate(tloc2(nd,0:nterms,-nterms:nterms))
       

       do i=1,nexptotp
         do idim=1,nd
           mexpnall(idim,i) = 0
           mexpsall(idim,i) = 0
           mexpn3478(idim,i) = 0
           mexpn34(idim,i) = 0
           mexpn78(idim,i) = 0
           mexps1256(idim,i) = 0
           mexps12(idim,i) = 0
           mexps56(idim,i) = 0
         enddo
       enddo
      
   
       ctmp(1) = centers(1,ibox) - bs/2.0d0
       ctmp(2) = centers(2,ibox) - bs/2.0d0
       ctmp(3) = centers(3,ibox) - bs/2.0d0
       
       do i=1,nnall
          jbox = nall(i)

          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
             do idim=1,nd
               mexpsall(idim,j) = mexpsall(idim,j) + 
     1            mexp(idim,j,jbox,4)*zmul
             enddo
          enddo

       enddo

       do i=1,nn1256
          jbox = n1256(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
             do idim=1,nd
               mexps1256(idim,j) = mexps1256(idim,j) + 
     1             mexp(idim,j,jbox,4)*zmul
             enddo
          enddo
       enddo

       do i=1,nn12
          jbox = n12(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
             do idim=1,nd
               mexps12(idim,j) = mexps12(idim,j) + 
     1           mexp(idim,j,jbox,4)*zmul
             enddo
          enddo
       enddo


       do i=1,nn56
          jbox = n56(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
             do idim=1,nd
               mexps56(idim,j) = mexps56(idim,j) + 
     1             mexp(idim,j,jbox,4)*zmul
             enddo
          enddo
       enddo


       do i=1,nsall
          jbox = sall(i)

          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
             do idim=1,nd
               mexpnall(idim,j) = mexpnall(idim,j) + 
     1            mexp(idim,j,jbox,3)*zmul
             enddo
          enddo
       enddo

       do i=1,ns3478
          jbox = s3478(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
             do idim=1,nd
               mexpn3478(idim,j) = mexpn3478(idim,j) + 
     1             mexp(idim,j,jbox,3)*zmul
             enddo
          enddo
       enddo

       do i=1,ns34
          jbox = s34(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
             do idim=1,nd
               mexpn34(idim,j) = mexpn34(idim,j) + 
     1            mexp(idim,j,jbox,3)*zmul
             enddo
          enddo
       enddo

       do i=1,ns78
          jbox = s78(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
             do idim=1,nd
               mexpn78(idim,j) = mexpn78(idim,j) + 
     1            mexp(idim,j,jbox,3)*zmul
             enddo
          enddo
       enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
       jbox = ichild(1,ibox)

       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)
            mexpdownphys(idim,i) = mexpsall(idim,i) + 
     1         mexps1256(idim,i) + mexps12(idim,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 2
       jbox = ichild(2,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1           mexps1256(idim,i) + mexps12(idim,i))*ys(-1,i)      
         enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif
  
c      add contributions due to child 3
       jbox = ichild(3,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+
     1         mexpn34(idim,i)+mexpn3478(idim,i))*zs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp      
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 4
       jbox = ichild(4,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+
     1         mexpn34(idim,i)+mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 5
       jbox = ichild(5,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp

          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1          mexps1256(idim,i) + mexps56(idim,i))*xs(-1,i)      
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 6
       jbox = ichild(6,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
         ztmp = ys(1,i)*xs(1,i)
         ztmp2 = ys(-1,i)*xs(-1,i)
         do idim=1,nd
           mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
           mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1        mexps1256(idim,i) + mexps56(idim,i))*ztmp2
         enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 7
 
       jbox = ichild(7,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
         ztmp = xs(1,i)*zs(1,i)
         ztmp2 = xs(-1,i)/zs(1,i)
         do idim=1,nd
           mexpupphys(idim,i)  = (mexpnall(idim,i)+
     1        mexpn78(idim,i)+mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
         enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 8
       jbox = ichild(8,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
         ztmp = ys(1,i)*zs(1,i)*xs(1,i)
         ztmp2 = ys(-1,i)/zs(1,i)*xs(-1,i)
         do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+
     1         mexpn78(idim,i)+mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2
         enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

      return
      end
c--------------------------------------------------------------------      

      subroutine hprocessewexp(nd,zk2,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,neall,eall,
     3           ne1357,e1357,ne13,e13,ne57,e57,ne1,e1,ne3,e3,ne5,e5,
     4           ne7,e7,nwall,wall,nw2468,w2468,nw24,w24,nw68,w68,
     5           nw2,w2,nw4,w4,nw6,w6,nw8,w8,
     6           mexpup,mexpdown,mexpupphys,mexpdownphys,
     7           mexpeall,mexpe2468,mexpe24,mexpe68,mexpe2,mexpe4,
     8           mexpe6,mexpe8,mexpwall,mexpw1357,mexpw13,mexpw57,
     9           mexpw1,mexpw3,mexpw5,mexpw7,rdminus,
     9           xs,ys,zs,fexpback,rlsc,
     9           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4,
     9           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      process east west expansions for box ibox
c-------------------------------------------------------------------
       implicit none
       integer *8 nd
       integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
       integer *8 nphysical(nlams),nfourier(nlams)
       integer *8 iaddr(2,nboxes)
       integer *8 ichild(8,nboxes)
       integer *8 nexptot,nexptotp,nmax
       integer *8 neall,nwall,ne1357,nw2468,ne13,ne57,nw24,nw68
       integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8
       integer *8 eall(*),wall(*),e1357(*),w2468(*)
       integer *8 e13(*),e57(*),w24(*),w68(*)
       integer *8 e1(*),e3(*),e5(*),e7(*),w2(*),w4(*),w6(*),w8(*)
       real *8 rscale,bs
       complex *16 zk2
       complex *16 rlams(*),whts(*)
       complex *16 tloc(nd,0:nterms,-nterms:nterms)
       complex *16, allocatable :: tloc2(:,:,:)
       integer *8 nboxesilev
       integer *8 mexpoffset
       complex *16 mexp(nd,nexptotp,nboxesilev,6)
c       complex *16 mexp(nd,nexptotp,nboxes,6)
       real *8 rdminus(0:nterms,0:nterms,-nterms:nterms)
       real *8 rmlexp(*),centers(3,*)
       complex *16 mexpup(nd,nexptot),mexpdown(nd,nexptot)
       complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
       complex *16 mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
       complex *16 mexpw1357(nd,nexptotp),mexpe2468(nd,nexptotp)
       complex *16 mexpw13(nd,nexptotp),mexpw57(nd,nexptotp)
       complex *16 mexpe24(nd,nexptotp),mexpe68(nd,nexptotp)
       complex *16 mexpw1(nd,nexptotp),mexpw3(nd,nexptotp)
       complex *16 mexpw5(nd,nexptotp),mexpw7(nd,nexptotp)
       complex *16 mexpe2(nd,nexptotp),mexpe4(nd,nexptotp)
       complex *16 mexpe6(nd,nexptotp),mexpe8(nd,nexptotp)
       complex *16 xs(-5:5,nexptotp),ys(-5:5,nexptotp),zs(5,nexptotp)
       complex *16 rlsc(0:nterms,0:nterms,nlams)
       complex *16 fexpback(*)
       integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
       integer *8 nlist4
       double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
       integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,l,idim,kbox
       complex *16 ztmp,zmul,ztmp2

     
       real *8 ctmp(3)

       allocate(tloc2(nd,0:nterms,-nterms:nterms))


       do i=1,nexptotp
         do idim=1,nd
           mexpeall(idim,i) = 0
           mexpwall(idim,i) = 0
           mexpe2468(idim,i) = 0
           mexpe24(idim,i) = 0
           mexpe68(idim,i) = 0
           mexpe2(idim,i) = 0
           mexpe4(idim,i) = 0
           mexpe6(idim,i) = 0
           mexpe8(idim,i) = 0
           mexpw1357(idim,i) = 0
           mexpw13(idim,i) = 0
           mexpw57(idim,i) = 0
           mexpw1(idim,i) = 0
           mexpw3(idim,i) = 0
           mexpw5(idim,i) = 0
           mexpw7(idim,i) = 0
         enddo
       enddo
      
   
       ctmp(1) = centers(1,ibox) - bs/2.0d0
       ctmp(2) = centers(2,ibox) - bs/2.0d0
       ctmp(3) = centers(3,ibox) - bs/2.0d0
       
       do i=1,neall
          jbox = eall(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpwall(idim,j) = mexpwall(idim,j) + 
     1             mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo

       do i=1,ne1357
          jbox = e1357(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw1357(idim,j) = mexpw1357(idim,j) + 
     1             mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo

       do i=1,ne13
          jbox = e13(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw13(idim,j) = mexpw13(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo


       do i=1,ne57
          jbox = e57(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw57(idim,j) = mexpw57(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo

       do i=1,ne1
          jbox = e1(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw1(idim,j) = mexpw1(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo


       do i=1,ne3
          jbox = e3(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw3(idim,j) = mexpw3(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo

       do i=1,ne5
          jbox = e5(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw5(idim,j) = mexpw5(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo


       do i=1,ne7
          jbox = e7(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
             do idim=1,nd
               mexpw7(idim,j) = mexpw7(idim,j) + 
     1            mexp(idim,j,jbox,6)*zmul
             enddo
          enddo
       enddo

       do i=1,nwall
          jbox = wall(i)

          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpeall(idim,j) = mexpeall(idim,j) + 
     1             mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

       do i=1,nw2468
          jbox = w2468(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe2468(idim,j) = mexpe2468(idim,j) + 
     1            mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

       do i=1,nw24
          jbox = w24(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe24(idim,j) = mexpe24(idim,j) + 
     1             mexp(idim,j,jbox,5)*zmul
             enddo
          enddo

       enddo

       

       do i=1,nw68
          jbox = w68(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe68(idim,j) = mexpe68(idim,j) + 
     1             mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

       do i=1,nw2
          jbox = w2(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe2(idim,j) = mexpe2(idim,j) + 
     1            mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo


       do i=1,nw4
          jbox = w4(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe4(idim,j) = mexpe4(idim,j) + 
     1            mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

       do i=1,nw6
          jbox = w6(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe6(idim,j) = mexpe6(idim,j) + 
     1            mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

       do i=1,nw8
          jbox = w8(i)
          ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
          iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
          iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
          jbox = jbox - mexpoffset
          do j=1,nexptotp
             zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
             do idim=1,nd
               mexpe8(idim,j) = mexpe8(idim,j) + 
     1            mexp(idim,j,jbox,5)*zmul
             enddo
          enddo
       enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
       jbox = ichild(1,ibox)

       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
             mexpupphys(idim,i)  = mexpeall(idim,i)
             mexpdownphys(idim,i) = mexpwall(idim,i)+mexpw1357(idim,i)+
     1                mexpw13(idim,i)+mexpw1(idim,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 2
       jbox = ichild(2,ibox)

       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1          mexpe24(idim,i)+mexpe2(idim,i))*zs(1,i)      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif
  
c      add contributions due to child 3
       jbox = ichild(3,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1                mexpw13(idim,i)+mexpw3(idim,i))*ys(-1,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 4
       jbox = ichild(4,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1               mexpe24(idim,i)+mexpe4(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 5
       jbox = ichild(5,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*xs(-1,i)
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1            mexpw57(idim,i)+mexpw5(idim,i))*xs(1,i)
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 6
       jbox = ichild(6,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*xs(-1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1              mexpe68(idim,i)+mexpe6(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 7
 
       jbox = ichild(7,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)

          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1            mexpw57(idim,i)+mexpw7(idim,i))*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

c      add contributions due to child 8
       jbox = ichild(8,ibox)
       if(jbox.gt.0) then

       do i=1,nexptotp
          ztmp = zs(1,i)*xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1            mexpe68(idim,i)+mexpe8(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
       enddo

       nlist4=nlist4s(jbox)
       do i=1,nlist4
         kbox=ilist4((jbox-1)*mnlist4+i)
         call h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1        list4(kbox),nexptotp,xs,ys,zs,
     2        centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
       enddo

       call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

       endif

      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine hprocesslist3udexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,nuall,uall,
     3           ndall,dall,mexpuall,mexpdall,
     5           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptot,nexptotp
      integer *8 nuall,ndall
      integer *8 uall(*),dall(*)
      double precision bs
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,nboxes)
      double complex mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j
      double precision rtmp
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)


      do i=1,nexptotp
        do idim=1,nd
          mexpuall(idim,i) = 0
          mexpdall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
  
      
      do i=1,nuall
        jbox = uall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpdall(idim,j) = mexpdall(idim,j) + 
     1                         mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo

      do i=1,ndall
        jbox = dall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpuall(idim,j) = mexpuall(idim,j) + 
     1                         mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo


      return
      end
c--------------------------------------------------------------------      

      subroutine hprocesslist3nsexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,nnall,nall,
     3           nsall,sall,mexpnall,mexpsall,
     5           xs,ys,zs)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptotp
      integer *8 nnall,nsall
      integer *8 nall(*),sall(*)
      double precision bs
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,*)
      double complex mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,idim
      double complex ztmp,zmul,ztmp2
      double precision rtmp
    
      double precision ctmp(3)


      do i=1,nexptotp
        do idim=1,nd
          mexpnall(idim,i) = 0
          mexpsall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,nnall
        jbox = nall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
           zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
           do idim=1,nd
             mexpsall(idim,j) = mexpsall(idim,j) + 
     1                          mexp(idim,j,jbox,4)*zmul
           enddo
        enddo

      enddo

      do i=1,nsall
        jbox = sall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpnall(idim,j) = mexpnall(idim,j) + 
     1                         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

      return
      end
c--------------------------------------------------------------------      

      subroutine hprocesslist3ewexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,neall,eall,nwall,wall,
     4           mexpeall,mexpwall,xs,ys,zs)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptotp
      integer *8 neall,nwall
      integer *8 eall(*),wall(*)
      double precision bs
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,*)
      double complex mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,l,idim
      double complex ztmp,zmul,ztmp2
      double complex rtmp
     
      double precision ctmp(3)


      do i=1,nexptotp
        do idim=1,nd
          mexpeall(idim,i) = 0
          mexpwall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,neall
        jbox = eall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpwall(idim,j) = mexpwall(idim,j) + 
     1                         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,nwall
        jbox = wall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpeall(idim,j) = mexpeall(idim,j) + 
     1                         mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo


      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ud_eval_p(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1   rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz,zsc,rk
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      zsc = -ima/zk2

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))



      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize


        do i=1,nlam
          zexp(i) = exp(-z*rlams(i))*whts(i)
          zexpinv(i) = exp(z*rlams(i))*whts(i)
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          rk = sqrt(rlams(il)**2 + zk2**2)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rk*(x*cos(alpha) + y*sin(alpha)))
            cc2(iphys) = exp(-ima*rk*(x*cos(alpha) + y*sin(alpha)))
          enddo

          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = 
     1            (mexpupphys(idim,ii)*zexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys))*hh
              pot(idim,itarg) = pot(idim,itarg) + rz*zsc 
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ns_eval_p(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1   rlams,whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz,zsc,rk
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))

      zsc = -ima/zk2


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          zexp(i) = exp(-y*rlams(i))*whts(i)
          zexpinv(i) = exp(y*rlams(i))*whts(i)
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          rk = sqrt(rlams(il)**2 + zk2**2)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rk*(z*cos(alpha) + x*sin(alpha)))
            cc2(iphys) = exp(-ima*rk*(z*cos(alpha) + x*sin(alpha)))
          enddo


          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = 
     1            (mexpupphys(idim,ii)*zexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys))*hh
              pot(idim,itarg) = pot(idim,itarg) + rz*zsc 
            enddo
          enddo
          istart = istart + nphys(il)

        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ew_eval_p(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1   rlams,whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz,zsc,rk
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))

      zsc = -ima/zk2

      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize


        do i=1,nlam
          zexp(i) = exp(-x*rlams(i))*whts(i)
          zexpinv(i) = exp(x*rlams(i))*whts(i)
        enddo



        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          rk = sqrt(rlams(il)**2 + zk2**2)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rk*(-z*cos(alpha) + y*sin(alpha)))
            cc2(iphys) = exp(ima*rk*(z*cos(alpha) - y*sin(alpha)))
          enddo

          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = 
     1            (mexpupphys(idim,ii)*zexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys))*hh
              pot(idim,itarg) = pot(idim,itarg) + rz*zsc 
            enddo
          enddo
          istart = istart + nphys(il)

        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ud_eval_g(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1   rlams,whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,
     2   grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 grad(nd,3,ntarg),whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2,zsc,rk
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize
      zsc = -ima/zk2


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          zexp(i) = exp(-z*rlams(i))*whts(i)
          zexpinv(i) = exp(z*rlams(i))*whts(i)
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          rk = sqrt(rlams(il)**2 + zk2**2)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rk*cos(alpha)*ima
            crs(iphys) = rk*sin(alpha)*ima
            cc(iphys) = exp(crc(iphys)*x + crs(iphys)*y)
            cc2(iphys) = exp(-(crc(iphys)*x + crs(iphys)*y))
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*zexp(il)*cc(iphys)*hh*zsc
              rz2 = mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys)*hh*zsc
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + rz
              grad(idim,1,itarg) = grad(idim,1,itarg) + 
     1            (rz1-rz2)*crc(iphys)*binv
              grad(idim,2,itarg) = grad(idim,2,itarg) + 
     1            (rz1-rz2)*crs(iphys)*binv
              grad(idim,3,itarg) = grad(idim,3,itarg) - 
     1            (rz1-rz2)*binv*rlams(il)
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ns_eval_g(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1  rlams,whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,
     2  grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 grad(nd,3,ntarg),whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2,zsc,rk
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize

      zsc = -ima/zk2

      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          zexp(i) = exp(-y*rlams(i))*whts(i)
          zexpinv(i) = exp(y*rlams(i))*whts(i)
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          rk = sqrt(rlams(il)**2 + zk2**2) 

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rk*cos(alpha)*ima
            crs(iphys) = rk*sin(alpha)*ima
            cc(iphys) = exp(crc(iphys)*z + crs(iphys)*x)
            cc2(iphys) = exp(-(crc(iphys)*z + crs(iphys)*x))
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*zexp(il)*cc(iphys)*hh*zsc
              rz2 = mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys)*hh*zsc
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + rz
              grad(idim,1,itarg) = grad(idim,1,itarg) + 
     1            (rz1-rz2)*crs(iphys)*binv
              grad(idim,2,itarg) = grad(idim,2,itarg) - 
     1            (rz1-rz2)*binv*rlams(il)
              grad(idim,3,itarg) = grad(idim,3,itarg) + 
     1            (rz1-rz2)*crc(iphys)*binv

            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine hpw_ew_eval_g(nd,zk2,center,boxsize,ntarg,targ,nlam,
     1  rlams,whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,
     2  grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg)
      complex *16 rlams(nlam),pot(nd,ntarg)
      complex *16 grad(nd,3,ntarg),whts(nlam),zk2
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:),cc2(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2,rk,zsc
      complex *16, allocatable :: zexp(:),zexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(zexp(nlam),zexpinv(nlam),cc(nphmax),cc2(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize
      zsc = -ima/zk2


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          zexp(i) = exp(-x*rlams(i))*whts(i)
          zexpinv(i) = exp(x*rlams(i))*whts(i)
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)
          
          rk = sqrt(rlams(il)**2 + zk2**2)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rk*cos(alpha)*ima
            crs(iphys) = rk*sin(alpha)*ima
            cc(iphys) = exp(-crc(iphys)*z + crs(iphys)*y)
            cc2(iphys) = exp(crc(iphys)*z - crs(iphys)*y)
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*zexp(il)*cc(iphys)*hh*zsc
              rz2 = mexpdownphys(idim,ii)*zexpinv(il)*cc2(iphys)*hh*zsc
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + rz
              grad(idim,1,itarg) = grad(idim,1,itarg) - 
     1            (rz1-rz2)*binv*rlams(il)
              grad(idim,2,itarg) = grad(idim,2,itarg) + 
     1            (rz1-rz2)*crs(iphys)*binv
              grad(idim,3,itarg) = grad(idim,3,itarg) - 
     1            (rz1-rz2)*crc(iphys)*binv

            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c----------------------------------------------------------------------
      subroutine h3dlist4pw(ilev,zk,nd,nexptotp,nexptot,nterms,nn,
     1           nlams,nlege,nlevels,ifcharge,ifdipole,list4,isrcse,
     2           laddr,nfourier,nphysical,
     3           rdminus,rdplus,rlsc,
     4           rscales,boxsize,xshift,yshift,zshift,
     5           sourcesort,chargesort,dipvecsort,centers,fexp,
     6           mexpf1,mexpf2,tmp,tmp2,wlege,rlams,rsc,pgboxwexp,
     7           cntlist4)
      implicit none
cccccc input/output variables
      integer *8 ilev
      integer *8 nd
      integer *8 nexptotp,nexptot
      integer *8 nterms,nn,nlams,nlege,nlevels,cntlist4
      integer *8 ifcharge,ifdipole
      integer *8 list4(*),laddr(2,0:nlevels)
      integer *8 isrcse(2,*)
      integer *8 nfourier(*)
      integer *8 nphysical(*)
      double precision rdminus(0:nn,0:nn,-nn:nn)
      double precision rdplus(0:nn,0:nn,-nn:nn)
      double precision rscales
      double precision boxsize
      double precision sourcesort(3,*)
      double precision centers(3,*)
      double precision wlege(40000)
      double precision rsc(*)
      double complex rlsc(0:nterms,0:nterms,nlams)
      double complex xshift(-5:5,nexptotp)
      double complex yshift(-5:5,nexptotp)
      double complex zshift(5,nexptotp)
      double complex zk
      double complex chargesort(nd,*)
      double complex dipvecsort(nd,3,*)
      double complex fexp(*)
      double complex mexpf1(nd,nexptot,*)
      double complex mexpf2(nd,nexptot,*)
      double complex tmp(nd,0:nterms,-nterms:nterms,*)
      double complex tmp2(nd,0:nterms,-nterms:nterms,*)
      double complex rlams(*)
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)
cccccc scoped function variables
      integer *8 ibox,jbox,i,idim,nlist3
      integer *8 istart,iend,npts,jstart,jend,npts0
      integer *8, allocatable :: gboxfl(:,:)
      integer *8, allocatable :: gboxind(:)
      double precision, allocatable :: gboxsubcenters(:,:)
      double precision time1,time2,omp_get_wtime
      double precision, allocatable :: gboxsort(:,:)
      double complex, allocatable :: gboxmexp(:,:)
      double complex, allocatable ::  gboxwexp(:,:,:,:)
      double complex, allocatable :: gboxcgsort(:,:)
      double complex, allocatable :: gboxdpsort(:,:,:)
      integer *8 nthd,ithd
      integer *8 omp_get_max_threads,omp_get_thread_num
      nthd = 1
C$    nthd=omp_get_max_threads()
      
      call cpu_time(time1)
C$    time1=omp_get_wtime()
      pgboxwexp=0d0
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,jbox,jstart,jend,npts,npts0,i)
C$OMP$PRIVATE(gboxind,gboxsort,gboxfl,gboxsubcenters)
C$OMP$PRIVATE(gboxcgsort,gboxdpsort,gboxwexp,gboxmexp)
C$OMP$PRIVATE(ithd)
      do ibox=laddr(1,ilev),laddr(2,ilev)
        ithd = 0
C$      ithd=omp_get_thread_num()
        ithd = ithd + 1
        if(list4(ibox).gt.0) then
          istart=isrcse(1,ibox)
          iend=isrcse(2,ibox)
          npts = iend-istart+1
          if(npts.gt.0) then
            allocate(gboxfl(2,8))
            allocate(gboxsubcenters(3,8))
            allocate(gboxind(npts))
            allocate(gboxsort(3,npts))
            allocate(gboxmexp(nd*(nterms+1)*(2*nterms+1),8))
            allocate(gboxwexp(nd,nexptotp,6,8))
            call subdividebox(sourcesort(1,istart),npts,
     1           centers(1,ibox),boxsize,
     2           gboxind,gboxfl,gboxsubcenters)
            call dreorderf(int8(3),npts,sourcesort(1,istart),
     1           gboxsort,gboxind)
            if(ifcharge.eq.1) then
              allocate(gboxcgsort(nd,npts))
              call dreorderf(2*nd,npts,chargesort(1,istart),
     1             gboxcgsort,gboxind)
            endif
            if(ifdipole.eq.1) then
              allocate(gboxdpsort(nd,3,npts))
              call dreorderf(6*nd,npts,dipvecsort(1,1,istart),
     1             gboxdpsort,gboxind)
            endif
cccccc bad code, note gboxmexp is an array not scalar
            gboxmexp=0
            do i=1,8
              if(gboxfl(1,i).gt.0) then
                jstart=gboxfl(1,i)
                jend=gboxfl(2,i)
                npts0=jend-jstart+1
                jbox=list4(ibox)
                if(npts0.gt.0) then
                  if(ifcharge.eq.1.and.ifdipole.eq.0) then
                    call h3dformmpc(nd,zk,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxcgsort(1,jstart),
     3                   npts0,gboxsubcenters(1,i),nterms,
     4                   gboxmexp(1,i),wlege,nlege)          
                  endif
                  if(ifcharge.eq.0.and.ifdipole.eq.1) then
                    call h3dformmpd(nd,zk,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxdpsort(1,1,jstart),
     3                   npts0,gboxsubcenters(1,i),nterms,
     4                   gboxmexp(1,i),wlege,nlege)          
                  endif
                  if(ifcharge.eq.1.and.ifdipole.eq.1) then
                    call h3dformmpcd(nd,zk,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxcgsort(1,jstart),
     3                   gboxdpsort(1,1,jstart),
     4                   npts0,gboxsubcenters(1,i),nterms,
     5                   gboxmexp(1,i),wlege,nlege)          
                  endif
ccc    convert to plane wave
                  call mpscale(nd,nterms,gboxmexp(1,i),
     1                 rsc,tmp(1,0,-nterms,ithd))
c
cc                process up down for current box
c
                  call hmpoletoexp(nd,tmp(1,0,-nterms,ithd),nterms,
     1                 nlams,nfourier,
     2                 nexptot,mexpf1(1,1,ithd),mexpf2(1,1,ithd),rlsc)

                  call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,1,i),fexp)

                  call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,2,i),fexp)

                  call hprocessgboxudexp(nd,gboxwexp(1,1,1,i),
     1                 gboxwexp(1,1,2,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,1),
     3                 pgboxwexp(1,1,jbox,2),
     4                 xshift,yshift,zshift)
c
cc                process north-south for current box
c
                  call rotztoy(nd,nterms,tmp(1,0,-nterms,ithd),
     1                 tmp2(1,0,-nterms,ithd),rdminus)
                  call hmpoletoexp(nd,tmp2(1,0,-nterms,ithd),
     1                 nterms,nlams,nfourier,
     2                 nexptot,mexpf1(1,1,ithd),mexpf2(1,1,ithd),rlsc)

                  call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,3,i),fexp)

                  call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,4,i),fexp)

                  call hprocessgboxnsexp(nd,gboxwexp(1,1,3,i),
     1                 gboxwexp(1,1,4,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,3),
     3                 pgboxwexp(1,1,jbox,4),
     4                 xshift,yshift,zshift)

c
cc                process east-west for current box

                  call rotztox(nd,nterms,tmp(1,0,-nterms,ithd),
     1                 tmp2(1,0,-nterms,ithd),rdplus)
                  call hmpoletoexp(nd,tmp2(1,0,-nterms,ithd),
     1                 nterms,nlams,nfourier,
     2                 nexptot,mexpf1(1,1,ithd),mexpf2(1,1,ithd),rlsc)

                  call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,5,i),fexp)

                  call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1                 nphysical,gboxwexp(1,1,6,i),fexp)
                
                  call hprocessgboxewexp(nd,gboxwexp(1,1,5,i),
     1                 gboxwexp(1,1,6,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,5),
     3                 pgboxwexp(1,1,jbox,6),
     4                 xshift,yshift,zshift)
                endif
              endif
            enddo
            deallocate(gboxfl,gboxsubcenters)
            deallocate(gboxind,gboxsort)
            if(ifcharge.eq.1) then
              deallocate(gboxcgsort)
            endif
            if(ifdipole.eq.1) then
              deallocate(gboxdpsort)
            endif
            deallocate(gboxmexp)
            deallocate(gboxwexp)
          endif
        endif
      enddo
C$OMP END PARALLEL DO
      call cpu_time(time2)
C$    time2=omp_get_wtime()
      return
      end
c
c
c
c
c
c
c
c--------------------------------------------------------------------
      subroutine hprocessgboxudexp(nd,mexpugbox,mexpdgbox,jbox,
     1           nexptotp,mexpuall,mexpdall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpugbox(nd,nexptotp)
      double complex mexpdgbox(nd,nexptotp)
      double complex mexpuall(nd,nexptotp)
      double complex mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + mexpugbox(idim,i)
            mexpdall(idim,i) = mexpdall(idim,i) + mexpdgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*xs(-1,i)
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*xs(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) +
     1                         mexpugbox(idim,i)*ys(-1,i)
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          ztmp = 1.0d0/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine hprocessgboxnsexp(nd,mexpngbox,mexpsgbox,jbox,
     1           nexptotp,mexpnall,mexpsall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpngbox(nd,nexptotp)
      double complex mexpsgbox(nd,nexptotp)
      double complex mexpnall(nd,nexptotp)
      double complex mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + mexpngbox(idim,i)
            mexpsall(idim,i) = mexpsall(idim,i) + mexpsgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ys(-1,i)
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) +
     1                         mexpngbox(idim,i)*ztmp
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*xs(-1,i)
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*xs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine hprocessgboxewexp(nd,mexpegbox,mexpwgbox,jbox,
     1           nexptotp,mexpeall,mexpwall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpegbox(nd,nexptotp)
      double complex mexpwgbox(nd,nexptotp)
      double complex mexpeall(nd,nexptotp)
      double complex mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + mexpegbox(idim,i)
            mexpwall(idim,i) = mexpwall(idim,i) + mexpwgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) +
     1                         mexpegbox(idim,i)*ys(-1,i)
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*xs(1,i)
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*xs(-1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*zs(1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)*zs(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------   c
c--------------------------------------------------------------------   c
c
c--------------------------------------------------------------------
      subroutine h3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1           jbox,nexptotp,xs,ys,zs,
     2           censrc,centrg,boxsize,dirtype,cntlist4)
c--------------------------------------------------------------------
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 nd
      integer *8 nexptotp
      integer *8 jbox
      integer *8 cntlist4
      integer dirtype
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double precision boxsize
      double precision censrc(3),centrg(3)
ccc   scoped function variables
      integer *8 dir
      integer *8 i,ix,iy,iz,idim
      double complex zmul
      double precision ctmp(3)


      call getlist4pwdir(dir,censrc,centrg,boxsize)

      ctmp(1) = censrc(1) - boxsize/2.0d0
      ctmp(2) = censrc(2) - boxsize/2.0d0
      ctmp(3) = censrc(3) - boxsize/2.0d0

      if(dir.eq.1.and.dirtype.eq.1) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(iz,i)*xs(ix,i)*ys(iy,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,2)*zmul
          enddo
        enddo
      else if(dir.eq.2.and.dirtype.eq.1) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-iz,i)*xs(-ix,i)*ys(-iy,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,1)*zmul
          enddo
        enddo
      else if(dir.eq.3.and.dirtype.eq.2) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(iy,i)*xs(iz,i)*ys(ix,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,4)*zmul
          enddo
        enddo
      else if(dir.eq.4.and.dirtype.eq.2) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-iy,i)*xs(-iz,i)*ys(-ix,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,3)*zmul
          enddo
        enddo
      else if(dir.eq.5.and.dirtype.eq.3) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(ix,i)*xs(-iz,i)*ys(iy,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,6)*zmul
          enddo
        enddo
      else if(dir.eq.6.and.dirtype.eq.3) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-ix,i)*xs(iz,i)*ys(-iy,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,5)*zmul
          enddo
        enddo
      else
C        print *,"dir:",dir
      endif
       
      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine hprocesslist3udexplong(nd,zk2,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nuall,uall,
     3           ndall,dall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpuall,mexpdall,
     5           xs,ys,zs,fexpback,rlsc,
     6           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 nuall,ndall
      integer *8 uall(*),dall(*)
      double precision rscale
      double complex rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)  
      integer *8 nboxesilev
      integer *8 mexpoffset
      double complex mexp(nd,nexptotp,nboxesilev,6)
c      double complex mexp(nd,nexptotp,nboxes,6)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex rlsc(0:nterms,0:nterms,nlams)
      double complex fexpback(*)
      double complex zk2

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpuall(idim,i) = 0
          mexpdall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
  
      
      do i=1,nuall
        jbox = uall(i)
C        print *,"ulist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        jbox = jbox - mexpoffset
        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpdall(idim,j) = mexpdall(idim,j) + 
     1                         mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo

      do i=1,ndall
        jbox = dall(i)
C        print *,"dlist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale

        jbox = jbox - mexpoffset
        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpuall(idim,j) = mexpuall(idim,j) + 
     1                         mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo
  
C      print *,mexpuall
C      print *,mexpdall


c
cc       move contributions to the children
c

      jbox=1
c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1                mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1                mexpdownphys,fexpback)

C        print *,tloc
        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

c
c         NOTE: fix rscpow to be 1/rscpow
c
        call mpadd(nd,tloc,rmlexp(1,1),nterms)
      endif
      
c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*xs(-1,i)
          enddo
        enddo
 
        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(1,2),nterms)

      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*ys(-1,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpadd(nd,tloc,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpadd(nd,tloc,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = 1.0d0/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*zs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpadd(nd,tloc,rmlexp(1,5),nterms)

      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)

      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(1,6),nterms)


      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(1,7),nterms)

      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpadd(nd,tloc,rmlexp(1,8),nterms)

      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine hprocesslist3nsexplong(nd,zk2,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nnall,nall,
     3           nsall,sall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpnall,mexpsall,
     5           rdplus,xs,ys,zs,fexpback,rlsc,
     6           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 nnall,nsall
      integer *8 nall(*),sall(*)
      double precision rscale
      double complex rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)
      double complex, allocatable :: tloc2(:,:,:)
      integer *8 nboxesilev
      integer *8 mexpoffset
      double complex mexp(nd,nexptotp,nboxesilev,6)
c      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdplus(0:nterms,0:nterms,-nterms:nterms)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex rlsc(0:nterms,0:nterms,nlams)
      double complex fexpback(*)
      double complex zk2

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,idim
      double complex ztmp,zmul,ztmp2
    
      double precision ctmp(3)
      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpnall(idim,i) = 0
          mexpsall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
       
      do i=1,nnall
        jbox = nall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        jbox = jbox - mexpoffset
        do j=1,nexptotp
           zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
           do idim=1,nd
             mexpsall(idim,j) = mexpsall(idim,j) + 
     1                          mexp(idim,j,jbox,4)*zmul
           enddo
        enddo

      enddo

      do i=1,nsall
        jbox = sall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        jbox = jbox - mexpoffset
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpnall(idim,j) = mexpnall(idim,j) + 
     1                         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      jbox=1
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,1),nterms)

      endif

c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*ys(-1,i)      
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,2),nterms)


      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*zs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*xs(-1,i)      
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,5),nterms)

      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,6),nterms)
      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpadd(nd,tloc2,rmlexp(1,7),nterms)
      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)


        call mpadd(nd,tloc2,rmlexp(1,8),nterms)
      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine hprocesslist3ewexplong(nd,zk2,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,neall,eall,
     3           nwall,wall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpeall,mexpwall,
     5           rdminus,xs,ys,zs,fexpback,rlsc,
     6           nboxesilev,mexpoffset)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 neall,nwall
      integer *8 eall(*),wall(*)
      double precision rscale
      double complex rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:),tloc2(:,:,:)
      integer *8 nboxesilev
      integer *8 mexpoffset
      double complex mexp(nd,nexptotp,nboxesilev,6)
c      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdminus(0:nterms,0:nterms,-nterms:nterms)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double complex zs(5,nexptotp)
      double complex rlsc(0:nterms,0:nterms,nlams)
      double complex fexpback(*)
      double complex zk2

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,l,idim
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpeall(idim,i) = 0
          mexpwall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
       
      do i=1,neall
        jbox = eall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        jbox = jbox - mexpoffset
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpwall(idim,j) = mexpwall(idim,j) + 
     1                         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,nwall
        jbox = wall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale

         
        jbox = jbox - mexpoffset
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpeall(idim,j) = mexpeall(idim,j) + 
     1                         mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      jbox=1
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,1),nterms)

      endif

c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*zs(1,i)      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,2),nterms)

      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)*ys(-1,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*xs(-1,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)*xs(1,i)
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,5),nterms)
      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*zs(1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,6),nterms)
      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,7),nterms)

      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)*zs(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call hphystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call hphystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call hexptolocal(nd,tloc,nterms,zk2,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpadd(nd,tloc2,rmlexp(1,8),nterms)

      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine lndiv(eps,ns,nt,ifcharge,ifdipole,ifpgh,
     1   ifpghtarg,ndiv,idivflag)
c
c
c       this subroutine estimates ndiv and idivflag 
c       based on geometry parameters
c       
c
      implicit none
      real *8 eps
      integer *8 ns,nt,ifcharge,ifdipole,ifpgh,ifpghtarg,ndiv
      integer *8 idivflag

      idivflag = 0


       if(eps.ge.0.5d-0) then
         ndiv = 300
       else if(eps.ge.0.5d-1) then
         ndiv = 300
       else if(eps.ge.0.5d-2) then
         ndiv = 300
       else if(eps.ge.0.5d-3) then
         ndiv = 300
       else if(eps.ge.0.5d-6) then
         ndiv = 1000
       else if(eps.ge.0.5d-9) then
         ndiv = 1000
       else if(eps.ge.0.5d-12) then
         ndiv = 1000
       else if(eps.ge.0.5d-15) then
         ndiv = 1000
       else
         ndiv = ns+nt
       endif


      return
      end

c       
c       
c       Generalized helmholtz FMM in R^3: evaluate all pairwise particle
c       interactions (ignoring self-interaction) 
c       and interactions with targets 
c
c       We use 1/(4\pi) * exp(ikr)/r for the Green's function.
c
c   
c-----------------------------------------------------------
        subroutine hfmm3d(nd,eps,zk,nsource,source,ifcharge,
     $    charge,ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,
     $    targ,ifpghtarg,pottarg,gradtarg,hesstarg,ier)
c-----------------------------------------------------------------------
c   INPUT PARAMETERS:
c
c   nd:    in: integer *8
c             number of densities
c   
c   eps:   in: double precision
c             requested precision
c
c   zk:    in: double complex
c               helmholtz parameter                
c
c   nsource in: integer *8  
c                number of sources
c
c   source  in: double precision (3,nsource)
c                source(k,j) is the kth component of the jth
c                source locations
c
c   ifcharge  in: integer *8  
c             charge computation flag
c              ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c 
c   charge    in: double complex (nd,nsource) 
c              charge strengths
c
c   ifdipole   in: integer *8
c              dipole computation flag
c              ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c
c   dipvec   in: double precision (nd,3,nsource) 
c              dipole orientation vectors
c   iper    in: integer *8
c             flag for periodic implmentations. Currently unused
c   ifpgh   in: integer *8
c              flag for evaluating potential/gradient at the sources
c              ifpgh = 1, only potential is evaluated
c              ifpgh = 2, potential and gradients are evaluated
c
c
c   ntarg  in: integer *8  
c                 number of targs 
c
c   targ  in: double precision (3,ntarg)
c               targ(k,j) is the kth component of the jth
c               targ location
c
c   ifpghtarg   in: integer *8
c              flag for evaluating potential/gradient at the targs
c              ifpghtarg = 1, only potential is evaluated
c              ifpghtarg = 2, potential and gradient are evaluated
c
c
c     OUTPUT parameters:
c
c   pot:    out: double complex(nd,nsource) 
c               potential at the source locations
c
c   grad:   out: double complex(nd,3,nsource)
c               gradient at the source locations
c
c   hess    out: double complex(nd,6,nsource)
c               hessian at the source locations
c
c   pottarg:    out: double complex(nd,ntarg) 
c               potential at the targ locations
c
c   gradtarg:   out: double complex(nd,3,ntarg)
c               gradient at the targ locations
c
c   hesstarg    out: double complex(nd,6,ntarg)
c                hessian at the target locations
c
c   ier         out: integer *8
c                error flag
c                ier = 0, for successful execution
c                ier = 4, if failed to allocate workspace
c                      for multipole and local expansions
c                ier = 8, if failed to allocate workspace
c                      for plane wave expansions
c     
c------------------------------------------------------------------

      implicit none

      integer *8 nd,ndim
      integer *8 iper
      integer *8 ier

      double complex zk
      double precision eps

      integer *8 ifcharge,ifdipole
      integer *8 ifpgh,ifpghtarg

      integer *8 nsource,ntarg

      double precision source(3,nsource),targ(3,ntarg)
      double complex charge(nd,*)

      double complex dipvec(nd,3,*)

      double complex pot(nd,*),grad(nd,3,*),
     1     pottarg(nd,3,*),
     1     gradtarg(nd,3,*),hess(nd,6,*),hesstarg(nd,6,*)
      
      double precision timeinfo(6)

c       Tree variables
      integer *8 mhung,idivflag,ndiv,isep,nboxes,nbmax,nlevels
      integer *8 nlmax
      integer *8 mnbors
      integer *8 ifunif,nlmin
      integer *8 ipointer(8),ltree
      integer *8, allocatable :: itree(:)
      integer *8, allocatable :: isrcse(:,:),itargse(:,:),isrc(:)
      integer *8, allocatable :: itarg(:)
      integer *8, allocatable :: iexpcse(:,:)
      integer *8 iexpc
      double precision, allocatable :: treecenters(:,:),boxsize(:)
      double precision b0,b0inv,b0inv2,b0inv3
      double complex zkfmm
      double precision xmin, xmax, ymin, ymax, zmin, zmax, pi, dbsize
      double precision bs0, sizey, sizez

c
cc      temporary sorted arrays
c
      double precision, allocatable :: sourcesort(:,:),targsort(:,:)
      double complex, allocatable :: chargesort(:,:)
      double complex, allocatable :: dipvecsort(:,:,:)

      double complex, allocatable :: potsort(:,:),gradsort(:,:,:),
     1       hesssort(:,:,:)
      double complex, allocatable :: pottargsort(:,:),
     1    gradtargsort(:,:,:),hesstargsort(:,:,:)

c
cc       temporary fmm arrays
c
      double precision epsfmm
      integer *8, allocatable :: nterms(:)
      integer *8, allocatable :: iaddr(:,:)
      double precision, allocatable :: scales(:)
      double precision, allocatable :: rmlexp(:)

      integer *8 nmax
      integer *8 lmptot

c
cc       temporary variables not used in particle code
c
      double precision expc(3),scjsort(1),radexp
      double complex texpssort(100)
      double precision expcsort(3),radssort(1)
      integer *8 ntj,nexpc,nadd,ifnear

c
cc        other temporary variables
c
      integer *8 i,iert,ifprint,ilev,idim
      double precision time1,time2,omp_get_wtime,second

       
c
c
c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c      
      ifprint=0

c
c       turn on computation of list 1
c
      ifnear = 1

c
c  Determine the computational boxsize
c

      xmin = source(1,1)
      xmax = source(1,1)
      ymin = source(2,1)
      ymax = source(2,1)
      zmin = source(3,1)
      zmax = source(3,1)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,nsource
        if(source(1,i).lt.xmin) xmin = source(1,i)
        if(source(1,i).gt.xmax) xmax = source(1,i)
        if(source(2,i).lt.ymin) ymin = source(2,i)
        if(source(2,i).gt.ymax) ymax = source(2,i)
        if(source(3,i).lt.zmin) zmin = source(3,i)
        if(source(3,i).gt.zmax) zmax = source(3,i)
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,ntarg
        if(targ(1,i).lt.xmin) xmin = targ(1,i)
        if(targ(1,i).gt.xmax) xmax = targ(1,i)
        if(targ(2,i).lt.ymin) ymin = targ(2,i)
        if(targ(2,i).gt.ymax) ymax = targ(2,i)
        if(targ(3,i).lt.zmin) zmin = targ(3,i)
        if(targ(3,i).gt.zmax) zmax = targ(3,i)
      enddo
C$OMP END PARALLEL DO      

      bs0 = (xmax - xmin)
      sizey = (ymax - ymin)
      sizez = (zmax - zmin)
      if(sizey.gt.bs0) bs0 = sizey
      if(sizez.gt.bs0) bs0 = sizez

      pi = atan(1.0d0)*4.0d0

      dbsize = real(zk)*bs0/2/pi
      
c
cc        set criterion for box subdivision
c
      call hndiv(dbsize,eps,nsource,ntarg,ifcharge,ifdipole,ifpgh,
     1   ifpghtarg,ndiv,idivflag) 

      nexpc = 0
      nadd = 0
      ntj = 0
c
cc      set tree flags
c 
      nlmax = 51
      nlevels = 0
      nboxes = 0
      ltree = 0
      nlmin = 0
      iper = 0
      ifunif = 0
      ndim = 3

c
cc     memory management code for contructing level restricted tree
      call pts_tree_mem(source,nsource,targ,ntarg,idivflag,ndiv,nlmin,
     1  nlmax,iper,ifunif,nlevels,nboxes,ltree)
      
        if(ifprint.ge.1) print *, ltree/1.0d9

        allocate(itree(ltree))
        allocate(boxsize(0:nlevels))
        allocate(treecenters(3,nboxes))

c       Call tree code
      call pts_tree_build(source,nsource,targ,ntarg,idivflag,ndiv,
     1  nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree,itree,ipointer,
     2  treecenters,boxsize)
      

      allocate(isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes))
      allocate(isrc(nsource),itarg(ntarg))

      call pts_tree_sort(nsource,source,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,isrc,isrcse)

      call pts_tree_sort(ntarg,targ,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,itarg,itargse)
      
      call pts_tree_sort(nexpc,expc,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,iexpc,iexpcse)

c
c   End of tree build
c


c
c  Set rescaling parameters
c
      b0 = boxsize(0)
      b0inv = 1.0d0/b0
      b0inv2 = b0inv**2


c     Allocate sorted source and target arrays      

      allocate(sourcesort(3,nsource))
      allocate(targsort(3,ntarg))
      if(ifcharge.eq.1) allocate(chargesort(nd,nsource))
      if(ifdipole.eq.1) then
         allocate(dipvecsort(nd,3,nsource))
      endif

      if(ifpgh.eq.1) then 
        allocate(potsort(nd,nsource),gradsort(nd,3,1),hesssort(nd,6,1))
      else if(ifpgh.eq.2) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,1))
      else if(ifpgh.eq.3) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,nsource))
      else
        allocate(potsort(nd,1),gradsort(nd,3,1),hesssort(nd,6,1))
      endif

      if(ifpghtarg.eq.1) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,1),
     1      hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.2) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.3) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,ntarg))
      else
        allocate(pottargsort(nd,1),gradtargsort(nd,3,1),
     1     hesstargsort(nd,6,1))
      endif

      allocate(nterms(0:nlevels)) 
c
cc      initialize potential and gradient at source
c       locations
c
      if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)

        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif


      if(ifpgh.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
            hesssort(idim,1,i) = 0
            hesssort(idim,2,i) = 0
            hesssort(idim,3,i) = 0
            hesssort(idim,4,i) = 0
            hesssort(idim,5,i) = 0
            hesssort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif



c
cc       initialize potential and gradient  at targ
c        locations
c
      if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
            hesstargsort(idim,1,i) = 0
            hesstargsort(idim,2,i) = 0
            hesstargsort(idim,3,i) = 0
            hesstargsort(idim,4,i) = 0
            hesstargsort(idim,5,i) = 0
            hesstargsort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

c
cc       reorder sources
c
      call dreorderf(ndim,nsource,source,sourcesort,isrc)
      call drescale(3*nsource,sourcesort,b0inv)
      if(ifcharge.eq.1) then
        call dreorderf(2*nd,nsource,charge,chargesort,isrc)
        call drescale(2*nd*nsource,chargesort,b0inv)
      endif

      if(ifdipole.eq.1) then
         call dreorderf(6*nd,nsource,dipvec,dipvecsort,isrc)
         call drescale(6*nd*nsource,dipvecsort,b0inv2)
      endif

c
cc      reorder targs
c
      call dreorderf(ndim,ntarg,targ,targsort,itarg)
      call drescale(3*ntarg,targsort,b0inv)
c
c  update tree centers and boxsize
c
      call drescale(3*nboxes,treecenters,b0inv)
      call drescale(nlevels+1,boxsize,b0inv)

      zkfmm = zk*b0

c
c     scaling factor for multipole and local expansions at all levels
c
      allocate(scales(0:nlevels))
      do ilev = 0,nlevels
       scales(ilev) = boxsize(ilev)*abs(zkfmm)
       if(scales(ilev).gt.1) scales(ilev) = 1
      enddo


c     Compute length of expansions at each level      
      nmax = 0
      if(ifprint.ge.1) call prin2('boxsize=*',boxsize,nlevels+1)
      if(ifprint.ge.1) call prin2('zkfmm=*',zkfmm,2)
      do i=0,nlevels
         call h3dterms(boxsize(i),zkfmm,eps,nterms(i))
         if(nterms(i).gt.nmax) nmax = nterms(i)
      enddo
      if(ifprint.ge.1) call prinf('nlevels=*',nlevels,1)
      if(ifprint.ge.1) call prinf('nterms=*',nterms,nlevels+1)
c       
c     Multipole and local expansions will be held in workspace
c     in locations pointed to by array iaddr(2,nboxes).
c
c     iiaddr is pointer to iaddr array, itself contained in workspace.
c
c       ... allocate iaddr and temporary arrays
c

      allocate(iaddr(2,nboxes))

c
c     allocate memory need by multipole, local expansions at all
c     levels
c     irmlexp is pointer for workspace need by various fmm routines,
c
      call mpalloc(nd,itree(ipointer(1)),iaddr,nlevels,lmptot,nterms)
      if(ifprint.ge. 1) print *, "lmptot =",lmptot/1.0d9

      ier = 0
      allocate(rmlexp(lmptot),stat=iert)
      if(iert.ne.0) then
         print *, "Cannot allocate mpole expansion workspace"
         print *, "lmptot=", lmptot
         ier = 4
         return
      endif


c     Memory allocation is complete.
c     Call main fmm routine
c
      call cpu_time(time1)
C$    time1=omp_get_wtime()
      call hfmm3dmain(nd,eps,zkfmm,
     $   nsource,sourcesort,
     $   ifcharge,chargesort,
     $   ifdipole,dipvecsort,
     $   ntarg,targsort,nexpc,expcsort,radssort,
     $   iaddr,rmlexp,lmptot,
     $   itree,ltree,ipointer,ndiv,nlevels,
     $   nboxes,iper,boxsize,treecenters,isrcse,itargse,iexpcse,
     $   scales,itree(ipointer(1)),nterms,
     $   ifpgh,potsort,gradsort,hesssort,ifpghtarg,pottargsort,
     $   gradtargsort,hesstargsort,ntj,texpssort,scjsort,ifnear,
     $   timeinfo,ier)

      if(ier.ne.0) return


      call cpu_time(time2)
C$    time2=omp_get_wtime()
      if( ifprint .eq. 1 ) call prin2('time in fmm main=*',
     1   time2-time1,1)


      if(ifpgh.ge.1) then
        call dreorderi(2*nd,nsource,potsort,pot,isrc)
      endif
      if(ifpgh.ge.2) then 
        call dreorderi(6*nd,nsource,gradsort,grad,isrc)
        call drescale(6*nd*nsource,grad,b0inv)
      endif

      if(ifpgh.ge.3) then 
        call dreorderi(12*nd,nsource,hesssort,hess,isrc)
        call drescale(12*nd*nsource,hess,b0inv2)
      endif


      if(ifpghtarg.ge.1) then
        call dreorderi(2*nd,ntarg,pottargsort,pottarg,itarg)
      endif

      if(ifpghtarg.ge.2) then
        call dreorderi(6*nd,ntarg,gradtargsort,gradtarg,itarg)
        call drescale(6*nd*ntarg,gradtarg,b0inv)
      endif

      if(ifpghtarg.ge.3) then
        call dreorderi(12*nd,ntarg,hesstargsort,hesstarg,itarg)
        call drescale(12*nd*ntarg,hesstarg,b0inv2)
      endif


      return
      end
c
c
      subroutine hfmm3dmain(nd,eps,zk,
     $     nsource,sourcesort,
     $     ifcharge,chargesort,
     $     ifdipole,dipvecsort,
     $     ntarg,targsort,nexpc,expcsort,radssort,
     $     iaddr,rmlexp,lmptot,
     $     itree,ltree,ipointer,ndiv,nlevels, 
     $     nboxes,iper,boxsize,centers,isrcse,itargse,iexpcse,
     $     rscales,laddr,nterms,ifpgh,pot,grad,hess,
     $     ifpghtarg,pottarg,gradtarg,hesstarg,
     $     ntj,jsort,scjsort,ifnear,timeinfo,ier)


      implicit none

      integer *8 nd,ndim
      integer *8 ier
      double precision eps
      integer *8 nsource,ntarg, nexpc
      integer *8 ndiv,nlevels

      integer *8 ifcharge,ifdipole
      integer *8 ifpgh,ifpghtarg

      double complex zk,zk2

      double precision sourcesort(3,nsource)

      double complex chargesort(nd,*)
      double complex dipvecsort(nd,3,*)

      double precision targsort(3,ntarg)

      double complex pot(nd,*),grad(nd,3,*),hess(nd,6,*)
      double complex pottarg(nd,*),gradtarg(nd,3,*),hesstarg(nd,6,*)

      integer *8 ntj
      integer *8 ifnear
      double precision expcsort(3,nexpc)
      double complex jsort(nd,0:ntj,-ntj:ntj,nexpc)


      integer *8 nboxes
      integer *8 iaddr(2,nboxes), lmptot
      double precision rmlexp(lmptot)
       
      double precision timeinfo(6)
      double precision centers(3,nboxes)
c
cc      tree variables
c
      integer *8 isep,iper
      integer *8 laddr(2,0:nlevels)
      integer *8 nboxesperlevel(0:nlevels)
      integer *8 nboxesoffset(0:nlevels)
      integer *8 iboxlev
      integer *8 nterms(0:nlevels)
      integer *8 ipointer(8),ltree
      integer *8 itree(ltree)
      double precision rscales(0:nlevels)
      double precision boxsize(0:nlevels)
      integer *8 isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes)
      integer *8, allocatable :: nlist1(:),list1(:,:)
      integer *8, allocatable :: nlist2(:),list2(:,:)
      integer *8, allocatable :: nlist3(:),list3(:,:)
      integer *8, allocatable :: nlist4(:),list4(:,:)

c
cc      pw stuff
c
      integer *8 nuall,ndall,nnall,nsall,neall,nwall
      integer *8 nu1234,nd5678,nn1256,ns3478,ne1357,nw2468
      integer *8 nn12,nn56,ns34,ns78,ne13,ne57,nw24,nw68
      integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8

      integer *8, allocatable :: uall(:,:),dall(:,:),nall(:,:)
      integer *8, allocatable :: sall(:,:),eall(:,:),wall(:,:)
      integer *8, allocatable :: u1234(:,:),d5678(:,:)
      integer *8, allocatable :: n1256(:,:),s3478(:,:)
      integer *8, allocatable :: e1357(:,:),w2468(:,:)
      integer *8, allocatable :: n12(:,:),n56(:,:),s34(:,:),s78(:,:)
      integer *8, allocatable :: e13(:,:),e57(:,:),w24(:,:),w68(:,:)
      integer *8, allocatable :: e1(:,:),e3(:,:),e5(:,:),e7(:,:)
      integer *8, allocatable :: w2(:,:),w4(:,:),w6(:,:),w8(:,:)

      integer *8 ntmax, nexpmax, nlams, nmax, nthmax, nphmax
      double precision, allocatable :: carray(:,:), dc(:,:)
      double precision, allocatable :: rdplus(:,:,:)
      double precision, allocatable :: rdminus(:,:,:), rdsq3(:,:,:)
      double precision, allocatable :: rdmsq3(:,:,:)
      double complex, allocatable :: rdminus2(:,:,:),zeyep(:)
      double complex, allocatable :: rdplus2(:,:,:)
      double precision, allocatable :: zmone(:)
      integer *8 nn,nnn
  
      double complex, allocatable :: rlams(:),whts(:)

      double complex, allocatable :: rlsc(:,:,:)
      integer *8, allocatable :: nfourier(:), nphysical(:)
      integer *8 nexptot, nexptotp
      double complex, allocatable :: xshift(:,:),yshift(:,:),zshift(:,:)

      double complex, allocatable :: fexp(:),fexpback(:)

      double complex, allocatable :: mexp(:,:,:,:)
      double complex, allocatable :: tmp(:,:,:,:),tmp2(:,:,:,:)
      double complex, allocatable :: mexpf1(:,:,:),mexpf2(:,:,:)
      double complex, allocatable :: mexpp1(:,:,:),mexpp2(:,:,:),
     1    mexppall(:,:,:,:)

      double precision, allocatable :: rsc(:)
      double precision r1

      double precision scjsort(nexpc),radssort(nexpc)

c     temp variables
      integer *8 i,j,k,l,ii,jj,kk,ll,idim
      integer *8 ibox,jbox,ilev,npts,npts0
      integer *8 nchild

      integer *8 istart,iend,istartt,iendt,istarte,iende
      integer *8 istarts,iends
      integer *8 jstart,jend

      integer *8 ifprint,ifwrite

      integer *8 ifhesstarg
      double precision d,time1,time2,omp_get_wtime

      double precision sourcetmp(3)
      double complex chargetmp(nd)

      integer *8 ix,iy,iz
      double precision rtmp
      double complex zmul

      integer *8 nlege, lw7, lused7, itype
      double precision, allocatable :: wlege(:)

      double precision thresh

      integer *8 mnbors,mnlist1, mnlist2,mnlist3,mnlist4
      double complex eye, ztmp,zmult
      double precision alphaj
      integer *8 ctr,ifinit2
      double precision, allocatable :: xnodes(:),wts(:)
      double precision radius
      integer *8 nquad2
      integer *8 maX_nodes
      double precision pi
      
      integer *8 istart0,istart1,istartm1,nprin
      double precision rtmp1,rtmp2,rtmp3,rtmp4
      double precision ctmp(3)
      double complex ima

c     list 3 variables
      double complex, allocatable :: iboxlexp(:,:,:)
      double precision, allocatable :: iboxsubcenters(:,:,:)
      double complex, allocatable :: iboxpot(:,:,:)
      double complex, allocatable :: iboxgrad(:,:,:,:)
      double precision, allocatable :: iboxsrc(:,:,:)
      integer *8, allocatable :: iboxsrcind(:,:)
      integer *8, allocatable :: iboxfl(:,:,:)
c     end of list 3 variables
c     list 4 variables
      integer *8 cntlist4
      integer *8, allocatable :: list4ct(:),ilist4(:)
      double complex, allocatable :: pgboxwexp(:,:,:,:)


c     end of list 4 variables

      integer *8 bigint
      double precision zkiupbound,zi,zkrupbound,rz
      integer *8 ilevcutoff

      integer *8 iert
      data ima/(0.0d0,1.0d0)/

      integer *8 nlfbox
      integer *8 nthd,ithd
      integer *8 omp_get_max_threads,omp_get_thread_num
      integer *8 ntotl1
      nthd = 1
C$    nthd=omp_get_max_threads()


      ntmax = 1000
      allocate(nfourier(ntmax),nphysical(ntmax))
      allocate(rlams(ntmax),whts(ntmax))

      pi = 4.0d0*atan(1.0d0)
c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c     Prints timing breakdown, list information, and other things if ifprint=2.
c       
        ifprint=0
c
c   initialize various tree lists
c
      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
      mnbors = 27

      isep = 1
      ndim = 3
      
      call computemnlists(nlevels,nboxes,itree(ipointer(1)),boxsize,
     1  centers,itree(ipointer(3)),itree(ipointer(4)),
     2  itree(ipointer(5)),isep,itree(ipointer(6)),mnbors,
     2  itree(ipointer(7)),iper,mnlist1,mnlist2,mnlist3,mnlist4)
      
      allocate(list1(mnlist1,nboxes),nlist1(nboxes))
      allocate(list2(mnlist2,nboxes),nlist2(nboxes))
      allocate(list3(mnlist3,nboxes),nlist3(nboxes))
      allocate(list4(mnlist4,nboxes),nlist4(nboxes))

      call computelists(nlevels,nboxes,itree(ipointer(1)),boxsize,
     1  centers,itree(ipointer(3)),itree(ipointer(4)),
     2  itree(ipointer(5)),isep,itree(ipointer(6)),mnbors,
     3  itree(ipointer(7)),iper,nlist1,mnlist1,list1,nlist2,
     4  mnlist2,list2,nlist3,mnlist3,list3,
     4  nlist4,mnlist4,list4)
      

c
c      If imaginary part is greater than 12*pi
c    don't do any multipole/local work
c

      zkiupbound = 12*pi
      zkrupbound = 16*pi
      zi = dimag(zk)

      ilevcutoff = -1

      nmax = 0
      do i=0,nlevels
         if(nmax.lt.nterms(i)) nmax = nterms(i)
         rz = exp(-zi*boxsize(i))/boxsize(i)
         if(rz.lt.eps) ilevcutoff = i
      enddo

      if(ifprint.ge.1) print *, "ilevcutoff=",ilevcutoff

      allocate(rsc(0:nmax))

c
cc     threshold for computing interactions,
c      interactions will be ignored
c      for all pairs of sources and targets
c      which satisfy |r| < thresh
c      where r is the disance between them

      thresh = 2.0d0**(-51)*boxsize(0)

      if(ifprint.ge.1) print *, "thresh=",thresh

      

      allocate(zeyep(-nmax:nmax),zmone(0:2*nmax))
      
      zeyep(0) = 1
      zmult = -ima
      do i=1,nmax
         zeyep(i) = zeyep(i-1)*zmult
         zeyep(-i) = zeyep(-i+1)/zmult
      enddo


      zmone(0) = 1
      do i=1,2*nmax
         zmone(i) = -zmone(i-1)
      enddo

c
c
c     ... set the expansion coefficients to zero
c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,k,idim)
      do i=1,nexpc
         do k=-ntj,ntj
           do j = 0,ntj
              do idim=1,nd
                jsort(idim,j,k,i)=0
              enddo
           enddo
         enddo
      enddo
C$OMP END PARALLEL DO

c       
      do i=1,6
        timeinfo(i)=0
      enddo
        
      max_nodes = 10000
      allocate(xnodes(max_nodes))
      allocate(wts(max_nodes))


c
c       ... set all multipole and local expansions to zero
c
      do ilev = 0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox)
         do ibox = laddr(1,ilev),laddr(2,ilev)
            call mpzero(nd,rmlexp(iaddr(1,ibox)),nterms(ilev))
            call mpzero(nd,rmlexp(iaddr(2,ibox)),nterms(ilev))
         enddo
C$OMP END PARALLEL DO          
       enddo


c
ccc       set scjsort
c
      do ilev=0,nlevels
         nboxesperlevel(ilev) = laddr(2,ilev)-laddr(1,ilev)+1
         if(ilev.eq.0) then
            nboxesoffset(ilev) = 0
         else
            nboxesoffset(ilev) = nboxesoffset(ilev-1)+
     1                           nboxesperlevel(ilev-1)
         endif
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i)
         do ibox=laddr(1,ilev),laddr(2,ilev)
            nchild = itree(ipointer(4)+ibox-1)
            if(nchild.gt.0) then
               istart = iexpcse(1,ibox)
               iend = iexpcse(2,ibox)
               do i=istart,iend
                  scjsort(i) = rscales(ilev)
                  radssort(i) = min(radssort(i),boxsize(ilev)/32*
     1                            sqrt(3.0d0))
               enddo
            endif
         enddo
C$OMP END PARALLEL DO
      enddo


c    initialize legendre function evaluation routines
      nlege = nmax + 10
      lw7 = (nlege+1)**2*4
      allocate(wlege(lw7))
      call ylgndrfwini(nlege,wlege,lw7,lused7)

      allocate(list4ct(nboxes))
      allocate(ilist4(nboxes))
      do i=1,nboxes
        list4ct(i)=0
        ilist4(i)=0
      enddo
      cntlist4=0

c
c
      if(ifprint .ge. 1) 
     $   call prinf('=== STEP 1 (form mp) ====*',i,0)
        call cpu_time(time1)
C$        time1=omp_get_wtime()
c
c       ... step 1, locate all charges, assign them to boxes, and
c       form multipole expansions



      do ilev=2,nlevels
        if(ilev.gt.ilevcutoff) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = iend-istart+1

              nchild = itree(ipointer(4)+ibox-1)

              if(npts.gt.0.and.nchild.eq.0) then
                call h3dformmpc(nd,zk,rscales(ilev),
     1          sourcesort(1,istart),chargesort(1,istart),npts,
     2          centers(1,ibox),nterms(ilev),
     3          rmlexp(iaddr(1,ibox)),wlege,nlege)          
              endif
            enddo
C$OMP END PARALLEL DO            
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = iend-istart+1

              nchild = itree(ipointer(4)+ibox-1)

              if(npts.gt.0.and.nchild.eq.0) then
                call h3dformmpd(nd,zk,rscales(ilev),
     1          sourcesort(1,istart),
     2          dipvecsort(1,1,istart),npts,
     2          centers(1,ibox),nterms(ilev),
     3          rmlexp(iaddr(1,ibox)),wlege,nlege)          
              endif
            enddo
C$OMP END PARALLEL DO            
          endif

          if(ifdipole.eq.1.and.ifcharge.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = iend-istart+1

              nchild = itree(ipointer(4)+ibox-1)

              if(npts.gt.0.and.nchild.eq.0) then
                call h3dformmpcd(nd,zk,rscales(ilev),
     1          sourcesort(1,istart),chargesort(1,istart),
     2          dipvecsort(1,1,istart),npts,
     2          centers(1,ibox),nterms(ilev),
     3          rmlexp(iaddr(1,ibox)),wlege,nlege)          
              endif
            enddo
C$OMP END PARALLEL DO          
          endif
        endif
      enddo

      call cpu_time(time2)
C$    time2=omp_get_wtime()
      timeinfo(1)=time2-time1

c       
      if(ifprint .ge. 1)
     $      call prinf('=== STEP 2 (merge mp) ====*',i,0)
      call cpu_time(time1)
C$    time1=omp_get_wtime()
c


      do ilev=nlevels-1,1,-1
        if(ilev.gt.ilevcutoff) then
          nquad2 = nterms(ilev)*2.5
          nquad2 = max(6,nquad2)
          ifinit2 = 1
          call legewhts(nquad2,xnodes,wts,ifinit2)
          radius = boxsize(ilev)/2*sqrt(3.0d0)

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,i,jbox,istart,iend,npts)
          do ibox = laddr(1,ilev),laddr(2,ilev)
            do i=1,8
              jbox = itree(ipointer(5)+8*(ibox-1)+i-1)
              if(jbox.gt.0) then
                istart = isrcse(1,jbox)
                iend = isrcse(2,jbox)
                npts = iend-istart+1

                if(npts.gt.0) then
                  call h3dmpmp(nd,zk,rscales(ilev+1),
     1              centers(1,jbox),rmlexp(iaddr(1,jbox)),
     2              nterms(ilev+1),rscales(ilev),centers(1,ibox),
     3              rmlexp(iaddr(1,ibox)),nterms(ilev),
     4              radius,xnodes,wts,nquad2)
                endif
              endif
            enddo
          enddo
C$OMP END PARALLEL DO
        endif
      enddo

      call cpu_time(time2)
C$    time2=omp_get_wtime()
      timeinfo(2)=time2-time1



      if(ifprint.ge.1)
     $    call prinf('=== Step 3 (mp to loc+mpeval+formta) ===*',i,0)
c      ... step 3, convert multipole expansions into local
c       expansions and big to small far and small to far big

      call cpu_time(time1)
C$    time1=omp_get_wtime()
c     init uall,dall,...,etc arrays
      allocate(uall(200,nthd),dall(200,nthd),nall(120,nthd))
      allocate(sall(120,nthd),eall(72,nthd),wall(72,nthd))
      allocate(u1234(36,nthd),d5678(36,nthd),n1256(24,nthd))
      allocate(s3478(24,nthd))
      allocate(e1357(16,nthd),w2468(16,nthd),n12(20,nthd))
      allocate(n56(20,nthd),s34(20,nthd),s78(20,nthd))
      allocate(e13(20,nthd),e57(20,nthd),w24(20,nthd),w68(20,nthd))
      allocate(e1(20,nthd),e3(5,nthd),e5(5,nthd),e7(5,nthd),w2(5,nthd))
      allocate(w4(5,nthd),w6(5,nthd),w8(5,nthd))


c
c  figure out allocations needed for iboxsrc,iboxsrcind,iboxpot
c  and so on
c
      nmax = 0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,istart,iend,npts)
C$OMP$REDUCTION(max:nmax)
      do ibox=1,nboxes
        if(nlist3(ibox).gt.0) then
          istart = isrcse(1,ibox)
          iend = isrcse(2,ibox)
          npts = iend-istart+1
          if(npts.gt.nmax) nmax = npts

          istart = itargse(1,ibox)
          iend = itargse(2,ibox)
          npts = iend - istart + 1
          if(npts.gt.nmax) nmax = npts
        endif
      enddo
C$OMP END PARALLEL DO

      allocate(iboxsrcind(nmax,nthd))
      allocate(iboxsrc(3,nmax,nthd))
      allocate(iboxpot(nd,nmax,nthd))
      allocate(iboxgrad(nd,3,nmax,nthd))
      allocate(iboxsubcenters(3,8,nthd))
      allocate(iboxfl(2,8,nthd))




      do ilev = 2,nlevels
        allocate(iboxlexp(nd*(nterms(ilev)+1)*
     1           (2*nterms(ilev)+1),8,nthd))
        zk2 = zk*boxsize(ilev)
        if(real(zk2).le.zkrupbound.and.dimag(zk2).lt.zkiupbound.and.
     1        ilev.gt.ilevcutoff) then
c             get new pw quadrature
            
          ier = 0
          call hwts3e(ier,eps,zk2,rlams,whts,nlams)
          call hnumfour(eps,zk2,nlams,nfourier)
          call hnumphys(eps,zk2,nlams,nphysical)
            
          nphmax = 0
          nthmax = 0
          nexptotp = 0
          nexptot = 0
          nn = 0
          do i=1,nlams
            nexptotp = nexptotp + nphysical(i)
            nexptot = nexptot + 2*nfourier(i)+1
            nn = nn + nfourier(i)*nphysical(i)
            if(nfourier(i).gt.nthmax) nthmax = nfourier(i)
            if(nphysical(i).gt.nphmax) nphmax = nphysical(i)
          enddo
          allocate(fexp(nn),fexpback(nn))

          allocate(xshift(-5:5,nexptotp))
          allocate(yshift(-5:5,nexptotp))
          allocate(zshift(5,nexptotp))
          allocate(rlsc(0:nterms(ilev),0:nterms(ilev),nlams))
          allocate(tmp(nd,0:nterms(ilev),
     1            -nterms(ilev):nterms(ilev),nthd))
          allocate(tmp2(nd,0:nterms(ilev),
     1            -nterms(ilev):nterms(ilev),nthd))
 
          allocate(mexpf1(nd,nexptot,nthd),mexpf2(nd,nexptot,nthd),
     1          mexpp1(nd,nexptotp,nthd))
          allocate(mexpp2(nd,nexptotp,nthd),
     1          mexppall(nd,nexptotp,16,nthd))

          bigint = 0
c          bigint = nboxes
          bigint = nboxesperlevel(ilev)
          bigint = bigint*6
          bigint = bigint*nexptotp*nd

          if(ifprint.ge.1) print *, "mexp memory=",bigint/1.0d9


c          allocate(mexp(nd,nexptotp,nboxes,6),stat=iert)
          allocate(mexp(nd,nexptotp,nboxesperlevel(ilev),6),stat=iert)
          if(iert.ne.0) then
            print *, "Cannot allocate pw expansion workspace"
            print *, "bigint=", bigint
            ier = 8
            return
          endif


          nn = nterms(ilev)
          allocate(carray(4*nn+1,4*nn+1))
          allocate(dc(0:4*nn,0:4*nn))
          allocate(rdplus(0:nn,0:nn,-nn:nn))
          allocate(rdminus(0:nn,0:nn,-nn:nn))
          allocate(rdsq3(0:nn,0:nn,-nn:nn))
          allocate(rdmsq3(0:nn,0:nn,-nn:nn))

c     generate rotation matrices and carray
          call getpwrotmat(nn,carray,rdplus,rdminus,rdsq3,rdmsq3,dc)


          call hrlscini(rlsc,nlams,rlams,rscales(ilev),zk2,
     1         nterms(ilev))
          call hmkexps(rlams,nlams,nphysical,nexptotp,zk2,xshift,
     1           yshift,zshift)
          call hmkfexp(nlams,nfourier,nphysical,fexp,fexpback)

c
cc      zero out mexp
c
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(idim,i,j,k)
          do k=1,6
c            do i=1,nboxes
            do i=1,nboxesperlevel(ilev)
              do j=1,nexptotp
                do idim=1,nd
                  mexp(idim,j,i,k) = 0.0d0
                enddo
              enddo
            enddo
          enddo
C$OMP END PARALLEL DO    

c
c         note: the scaling for helmholtz has been eliminated
c         since it is taken care in the scaling of the legendre
c         functions
c
          r1 = 1.0d0
          rsc(0) = 1.0d0
          do i=1,nterms(ilev)
            rsc(i) = rsc(i-1)*r1
          enddo

c      generate ilev+1 list4 type box plane wave expansion
          cntlist4=0
          do ibox=laddr(1,ilev-1),laddr(2,ilev-1)
            
            if(nlist3(ibox).gt.0) then
              cntlist4=cntlist4+1
              list4ct(ibox)=cntlist4
            endif
          enddo
          allocate(pgboxwexp(nd,nexptotp,cntlist4,6))
          if(ifprint.ge.1) print *,"cntlist4:",cntlist4,"ilev:",ilev

          call h3dlist4pw(ilev-1,zk,nd,nexptotp,nexptot,nterms(ilev),
     1       nn,nlams,nlege,nlevels,ifcharge,ifdipole,list4ct,isrcse,
     2       laddr,nfourier,nphysical,
     3       rdminus,rdplus,rlsc,
     4       rscales(ilev),boxsize(ilev),xshift,yshift,zshift,
     5       sourcesort,chargesort,dipvecsort,centers,fexp,
     6       mexpf1,mexpf2,tmp,tmp2,wlege,rlams,rsc,pgboxwexp,
     7       cntlist4)

c
cc         create multipole to plane wave expansion for
c          all boxes at this level
c
C$OMP PARALLEL DO DEFAULT (SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,iboxlev)
C$OMP$PRIVATE(ithd)
          do ibox = laddr(1,ilev),laddr(2,ilev)
            ithd = 0
C$          ithd=omp_get_thread_num()
            ithd = ithd + 1
            istart = isrcse(1,ibox)
            iend = isrcse(2,ibox)
            npts = iend - istart+1
            if(npts.gt.0) then

c           rescale multipole expansion
              call mpscale(nd,nterms(ilev),rmlexp(iaddr(1,ibox)),
     1               rsc,tmp(1,0,-nterms(ilev),ithd))
                
              call hmpoletoexp(nd,tmp(1,0,-nterms(ilev),ithd),
     1          nterms(ilev),nlams,nfourier,nexptot,mexpf1(1,1,ithd),
     2          mexpf2(1,1,ithd),rlsc) 

              iboxlev = ibox - nboxesoffset(ilev)
              call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1             nphysical,mexp(1,1,iboxlev,1),fexp)           

              call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1             nphysical,mexp(1,1,iboxlev,2),fexp)


c          form mexpnorth, mexpsouth for current box

c          Rotate mpole for computing mexpnorth and
c          mexpsouth
              call rotztoy(nd,nterms(ilev),tmp(1,0,-nterms(ilev),ithd),
     1                           tmp2(1,0,-nterms(ilev),ithd),rdminus)

              call hmpoletoexp(nd,tmp2(1,0,-nterms(ilev),ithd),
     1                  nterms(ilev),nlams,
     2                  nfourier,nexptot,mexpf1(1,1,ithd),
     3                  mexpf2(1,1,ithd),rlsc)

              call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1                 nphysical,mexp(1,1,iboxlev,3),fexp)           

              call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1                 nphysical,mexp(1,1,iboxlev,4),fexp)   


c         Rotate mpole for computing mexpeast, mexpwest
              call rotztox(nd,nterms(ilev),tmp(1,0,-nterms(ilev),ithd),
     1                            tmp2(1,0,-nterms(ilev),ithd),rdplus)
              call hmpoletoexp(nd,tmp2(1,0,-nterms(ilev),ithd),
     1                  nterms(ilev),nlams,
     2                  nfourier,nexptot,mexpf1(1,1,ithd),
     3                  mexpf2(1,1,ithd),rlsc)

              call hftophys(nd,mexpf1(1,1,ithd),nlams,nfourier,
     1                 nphysical,mexp(1,1,iboxlev,5),fexp)

              call hftophys(nd,mexpf2(1,1,ithd),nlams,nfourier,
     1                 nphysical,mexp(1,1,iboxlev,6),fexp)           

            endif
          enddo
C$OMP END PARALLEL DO       
           
c
cc         loop over parent boxes and ship plane wave
c          expansions to the first child of parent 
c          boxes. 
c          The codes are now written from a gathering perspective
c
c          so the first child of the parent is the one
c          recieving all the local expansions
c          coming from all the lists
c
c          
c

C$OMP PARALLEL DO DEFAULT (SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,nchild)
C$OMP$PRIVATE(nuall,ndall,nnall,nsall)
C$OMP$PRIVATE(neall,nwall,nu1234,nd5678)
C$OMP$PRIVATE(nn1256,ns3478,ne1357,nw2468)
C$OMP$PRIVATE(nn12,nn56,ns34,ns78,ne13,ne57)
C$OMP$PRIVATE(nw24,nw68,ne1,ne3,ne5,ne7)
C$OMP$PRIVATE(nw2,nw4,nw6,nw8)
C$OMP$PRIVATE(npts0,ctmp,jstart,jend,i)
C$OMP$PRIVATE(ithd)
          do ibox = laddr(1,ilev-1),laddr(2,ilev-1)
            ithd = 0
C$          ithd=omp_get_thread_num()
            ithd = ithd + 1
            npts = 0
            if(ifpghtarg.gt.0) then
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = npts + iend-istart+1
            endif

            istart = iexpcse(1,ibox)
            iend = iexpcse(2,ibox)
            npts = npts + iend-istart+1

            nchild = itree(ipointer(4)+ibox-1)

            if(ifpgh.gt.0) then
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = npts + iend-istart+1
            endif


            if(npts.gt.0.and.nchild.gt.0) then
              call getpwlistall(ibox,boxsize(ilev),nboxes,
     1           itree(ipointer(6)+ibox-1),itree(ipointer(7)+
     2           mnbors*(ibox-1)),nchild,itree(ipointer(5)),centers,
     3           isep,nuall,uall(1,ithd),ndall,dall(1,ithd),
     4           nnall,nall(1,ithd),nsall,sall(1,ithd),
     5           neall,eall(1,ithd),nwall,wall(1,ithd),
     6           nu1234,u1234(1,ithd),nd5678,d5678(1,ithd),
     7           nn1256,n1256(1,ithd),ns3478,s3478(1,ithd),
     8           ne1357,e1357(1,ithd),nw2468,w2468(1,ithd),
     9           nn12,n12(1,ithd),nn56,n56(1,ithd),ns34,s34(1,ithd),
     9           ns78,s78(1,ithd),ne13,e13(1,ithd),ne57,e57(1,ithd),
     9           nw24,w24(1,ithd),nw68,w68(1,ithd),ne1,e1(1,ithd),
     9           ne3,e3(1,ithd),ne5,e5(1,ithd),ne7,e7(1,ithd),
     9           nw2,w2(1,ithd),nw4,w4(1,ithd),nw6,w6(1,ithd),
     9           nw8,w8(1,ithd))


              call hprocessudexp(nd,zk2,ibox,ilev,nboxes,centers,
     1            itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2            nterms(ilev),iaddr,rmlexp,rlams,whts,
     3            nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4            nuall,uall(1,ithd),nu1234,u1234(1,ithd),
     5            ndall,dall(1,ithd),nd5678,d5678(1,ithd),
     6            mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     7            mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     8            mexppall(1,1,1,ithd),
     9            mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9            mexppall(1,1,4,ithd),
     9            xshift,yshift,zshift,fexpback,rlsc,
     9            pgboxwexp,cntlist4,list4ct,
     9            nlist4,list4,mnlist4,
     9            nboxesperlevel(ilev),nboxesoffset(ilev))


              call hprocessnsexp(nd,zk2,ibox,ilev,nboxes,centers,
     1            itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2            nterms(ilev),iaddr,rmlexp,rlams,whts,
     3            nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4            nnall,nall(1,ithd),nn1256,n1256(1,ithd),
     5            nn12,n12(1,ithd),nn56,n56(1,ithd),nsall,sall(1,ithd),
     5            ns3478,s3478(1,ithd),ns34,s34(1,ithd),
     6            ns78,s78(1,ithd),
     7            mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     8            mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     9            mexppall(1,1,1,ithd),
     9            mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9            mexppall(1,1,4,ithd),
     9            mexppall(1,1,5,ithd),mexppall(1,1,6,ithd),
     9            mexppall(1,1,7,ithd),
     9            mexppall(1,1,8,ithd),rdplus,xshift,yshift,zshift,
     9            fexpback,rlsc,
     9            pgboxwexp,cntlist4,list4ct,
     9            nlist4,list4,mnlist4,
     9            nboxesperlevel(ilev),nboxesoffset(ilev))

              call hprocessewexp(nd,zk2,ibox,ilev,nboxes,centers,
     1            itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2            nterms(ilev),iaddr,rmlexp,rlams,whts,
     3            nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4            neall,eall(1,ithd),ne1357,e1357(1,ithd),
     5            ne13,e13(1,ithd),ne57,e57(1,ithd),ne1,e1(1,ithd),
     5            ne3,e3(1,ithd),ne5,e5(1,ithd),
     6            ne7,e7(1,ithd),nwall,wall(1,ithd),
     7            nw2468,w2468(1,ithd),
     8            nw24,w24(1,ithd),nw68,w68(1,ithd),
     9            nw2,w2(1,ithd),nw4,w4(1,ithd),nw6,w6(1,ithd),
     9            nw8,w8(1,ithd),
     9            mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     9            mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     9            mexppall(1,1,1,ithd),
     9            mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9            mexppall(1,1,4,ithd),
     9            mexppall(1,1,5,ithd),mexppall(1,1,6,ithd),
     9            mexppall(1,1,7,ithd),mexppall(1,1,8,ithd),
     9            mexppall(1,1,9,ithd),
     9            mexppall(1,1,10,ithd),mexppall(1,1,11,ithd),
     9            mexppall(1,1,12,ithd),
     9            mexppall(1,1,13,ithd),mexppall(1,1,14,ithd),
     9            mexppall(1,1,15,ithd),
     9            mexppall(1,1,16,ithd),rdminus,xshift,yshift,zshift,
     9            fexpback,rlsc,pgboxwexp,cntlist4,list4ct,
     9            nlist4,list4,mnlist4,
     9            nboxesperlevel(ilev),nboxesoffset(ilev))
            endif


c
c      handle mp eval
c

            if(nlist3(ibox).gt.0.and.npts.gt.0) then
              call getlist3pwlistall(ibox,boxsize(ilev),nboxes,
     1              nlist3(ibox),list3(1,ibox),isep,
     2              centers,nuall,uall(1,ithd),ndall,dall(1,ithd),
     3              nnall,nall(1,ithd),
     4              nsall,sall(1,ithd),neall,eall(1,ithd),
     5              nwall,wall(1,ithd))
                 

              do i=1,8
                call mpzero(nd,iboxlexp(1,i,ithd),nterms(ilev))
              enddo

              call hprocesslist3udexplong(nd,zk2,ibox,nboxes,centers,
     1               boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),
     2               rlams,whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3               nexptotp,mexp,nuall,uall(1,ithd),
     4               ndall,dall(1,ithd),
     5               mexpf1(1,1,ithd),mexpf2(1,1,ithd),mexpp1(1,1,ithd),
     6               mexpp2(1,1,ithd),
     7               mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),
     8               xshift,yshift,zshift,fexpback,rlsc,
     9               nboxesperlevel(ilev),nboxesoffset(ilev))

              call hprocesslist3nsexplong(nd,zk2,ibox,nboxes,centers,
     1           boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),rlams,
     2           whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3           nexptotp,mexp,nnall,nall(1,ithd),nsall,sall(1,ithd),
     4           mexpf1(1,1,ithd),mexpf2(1,1,ithd),mexpp1(1,1,ithd),
     5           mexpp2(1,1,ithd),
     6           mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),rdplus,
     7           xshift,yshift,zshift,fexpback,rlsc,
     9           nboxesperlevel(ilev),nboxesoffset(ilev))

              call hprocesslist3ewexplong(nd,zk2,ibox,nboxes,centers,
     1              boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),
     2              rlams,whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3              nexptotp,mexp,neall,eall(1,ithd),nwall,wall(1,ithd),
     4              mexpf1(1,1,ithd),mexpf2(1,1,ithd),mexpp1(1,1,ithd),
     6              mexpp2(1,1,ithd),
     7              mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),rdminus,
     8              xshift,yshift,zshift,fexpback,rlsc,
     9              nboxesperlevel(ilev),nboxesoffset(ilev))

              if(ifpgh.eq.1) then
                istart = isrcse(1,ibox)
                iend = isrcse(2,ibox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(sourcesort(1,istart),npts,
     1                    centers(1,ibox),boxsize(ilev),
     2                    iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                    iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,sourcesort(1,istart),
     1                    iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(2*nd,npts,pot(1,istart),
     1                    iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call h3dtaevalp(nd,zk,rscales(ilev),
     1                    iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                    nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                    iboxpot(1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(2*nd,npts,iboxpot(1,1,ithd),
     1              pot(1,istart),iboxsrcind(1,ithd))
                endif
              endif

              if(ifpgh.eq.2) then
                istart = isrcse(1,ibox)
                iend = isrcse(2,ibox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(sourcesort(1,istart),npts,
     1                    centers(1,ibox),boxsize(ilev),
     2                    iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                    iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,sourcesort(1,istart),
     1                    iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(2*nd,npts,pot(1,istart),
     1                    iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(6*nd,npts,grad(1,1,istart),
     1                   iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call h3dtaevalg(nd,zk,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),
     4                     iboxgrad(1,1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(2*nd,npts,iboxpot(1,1,ithd),
     1               pot(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(6*nd,npts,iboxgrad(1,1,1,ithd),
     1               grad(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif

              if(ifpghtarg.eq.1) then
                istart = itargse(1,ibox)
                iend = itargse(2,ibox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(targsort(1,istart),npts,
     1                   centers(1,ibox),boxsize(ilev),
     2                   iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                   iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,targsort(1,istart),
     1                   iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(2*nd,npts,pottarg(1,istart),
     1                   iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call h3dtaevalp(nd,zk,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(2*nd,npts,iboxpot(1,1,ithd),
     1                pottarg(1,istart),iboxsrcind(1,ithd))
                endif
              endif
   
              if(ifpghtarg.eq.2) then
                istart = itargse(1,ibox)
                iend = itargse(2,ibox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(targsort(1,istart),npts,
     1                   centers(1,ibox),boxsize(ilev),
     2                   iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                   iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,targsort(1,istart),
     1                   iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(2*nd,npts,pottarg(1,istart),
     1                   iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(6*nd,npts,gradtarg(1,1,istart),
     1                    iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call h3dtaevalg(nd,zk,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),
     4                     iboxgrad(1,1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(2*nd,npts,iboxpot(1,1,ithd),
     1               pottarg(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(6*nd,npts,iboxgrad(1,1,1,ithd),
     1                    gradtarg(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif
            endif
          enddo
C$OMP END PARALLEL DO        

          deallocate(xshift,yshift,zshift,rlsc,tmp,tmp2)
          deallocate(carray,dc,rdplus,rdminus,rdsq3,rdmsq3)
          deallocate(mexpf1,mexpf2,mexpp1,mexpp2,mexppall,mexp)
          deallocate(fexp,fexpback)
          deallocate(pgboxwexp)


        else if((real(zk2).gt.zkrupbound.or.dimag(zk2).gt.zkiupbound).
     1            and.ilev.gt.ilevcutoff) then
          nquad2 = nterms(ilev)*2.2
          if(ifprint.ge.1) print *, "In point and shoot regime"
          nquad2 = max(6,nquad2)

          ifinit2 = 1
          ier = 0

          call legewhts(nquad2,xnodes,wts,ifinit2)

          radius = boxsize(ilev)/2*sqrt(3.0d0)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,i,jbox)
          do ibox = laddr(1,ilev),laddr(2,ilev)
            npts = 0
            if(ifpghtarg.gt.0) then
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = npts + iend - istart + 1
            endif

            istart = iexpcse(1,ibox)
            iend = iexpcse(2,ibox)
            npts = npts + iend-istart+1

            if(ifpgh.gt.0) then
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = npts + iend-istart+1
            endif


            
            if(npts.gt.0) then
              do i=1,nlist2(ibox)
                jbox = list2(i,ibox)

                istart = isrcse(1,jbox)
                iend = isrcse(2,jbox)
                npts = iend-istart+1

                if(npts.gt.0) then
                  call h3dmploc(nd,zk,rscales(ilev),centers(1,jbox),
     1                  rmlexp(iaddr(1,jbox)),nterms(ilev),
     2                  rscales(ilev),centers(1,ibox),
     2                  rmlexp(iaddr(2,ibox)),nterms(ilev),
     3                  radius,xnodes,wts,nquad2)
                endif
              enddo
            endif
          enddo
C$OMP END PARALLEL DO     

c
c
c         handle list 3 interactions at this level
c


          if(ifpgh.eq.1) then         
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,i,jbox)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev-1),laddr(2,ilev-1)
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = iend-istart+1

              do i=1,nlist3(ibox)
                jbox = list3(i,ibox) 
                call h3dmpevalp(nd,zk,rscales(ilev),centers(1,jbox),
     1            rmlexp(iaddr(1,jbox)),nterms(ilev),
     2            sourcesort(1,istart),npts,pot(1,istart),wlege,nlege,
     3            thresh)
              enddo
            enddo
C$OMP END PARALLEL DO          
          endif

          if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,i,jbox)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev-1),laddr(2,ilev-1)
              
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)

              npts = iend-istart+1

              do i=1,nlist3(ibox)
                jbox = list3(i,ibox)
                call h3dmpevalg(nd,zk,rscales(ilev),centers(1,jbox),
     1             rmlexp(iaddr(1,jbox)),nterms(ilev),
     2             sourcesort(1,istart),npts,pot(1,istart),
     3             grad(1,1,istart),wlege,nlege,thresh)
              enddo
            enddo
C$OMP END PARALLEL DO          
          endif

          if(ifpghtarg.eq.1) then         
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,i,jbox)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev-1),laddr(2,ilev-1)
              
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)

              npts = iend-istart+1

              do i=1,nlist3(ibox)
                jbox = list3(i,ibox)
                call h3dmpevalp(nd,zk,rscales(ilev),centers(1,jbox),
     1             rmlexp(iaddr(1,jbox)),nterms(ilev),
     2             targsort(1,istart),npts,pottarg(1,istart),
     3             wlege,nlege,thresh)
              enddo
            enddo
C$OMP END PARALLEL DO          
          endif

          if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,i,jbox)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev-1),laddr(2,ilev-1)
              
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)

              npts = iend-istart+1

              do i=1,nlist3(ibox)
                jbox = list3(i,ibox)
                call h3dmpevalg(nd,zk,rscales(ilev),centers(1,jbox),
     1             rmlexp(iaddr(1,jbox)),nterms(ilev),
     2             targsort(1,istart),npts,pottarg(1,istart),
     3             gradtarg(1,1,istart),wlege,nlege,thresh)
              enddo
            enddo
C$OMP END PARALLEL DO
          endif
        endif
        deallocate(iboxlexp)
      enddo

c
c    handle list 4 interactions not handled by plane waves
c    due to high frequency
c
    
      if(ifcharge.eq.1.and.ifdipole.eq.0) then
        do ilev=1,nlevels
          zk2 = zk*boxsize(ilev)
          if((real(zk2).gt.zkrupbound.or.dimag(zk2).gt.zkiupbound).
     1            and.ilev.gt.ilevcutoff) then

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,jbox,istart,iend,npts,i)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              
              do i=1,nlist4(ibox)
                jbox = list4(i,ibox)

c              Form local expansion for all boxes in list3
c              of the current box


                istart = isrcse(1,jbox)
                iend = isrcse(2,jbox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call h3dformtac(nd,zk,rscales(ilev),
     1              sourcesort(1,istart),chargesort(1,istart),npts,
     2              centers(1,ibox),nterms(ilev),
     3              rmlexp(iaddr(2,ibox)),wlege,nlege)
                endif
              enddo
            enddo
C$OMP END PARALLEL DO
          endif
        enddo
      endif

    
      if(ifcharge.eq.0.and.ifdipole.eq.1) then
        do ilev=1,nlevels
          zk2 = zk*boxsize(ilev)
          if((real(zk2).gt.zkrupbound.or.dimag(zk2).gt.zkiupbound).
     1            and.ilev.gt.ilevcutoff) then

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,jbox,istart,iend,npts,i)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              
              do i=1,nlist4(ibox)
                jbox = list4(i,ibox)

c              Form local expansion for all boxes in list3
c              of the current box


                istart = isrcse(1,jbox)
                iend = isrcse(2,jbox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call h3dformtad(nd,zk,rscales(ilev),
     1              sourcesort(1,istart),dipvecsort(1,1,istart),npts,
     2              centers(1,ibox),nterms(ilev),
     3              rmlexp(iaddr(2,ibox)),wlege,nlege)
                endif
              enddo
            enddo
C$OMP END PARALLEL DO
          endif
        enddo
      endif

    
      if(ifcharge.eq.1.and.ifdipole.eq.1) then
        do ilev=1,nlevels
          zk2 = zk*boxsize(ilev)
          if((real(zk2).gt.zkrupbound.or.dimag(zk2).gt.zkiupbound).
     1            and.ilev.gt.ilevcutoff) then

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,jbox,istart,iend,npts,i)
C$OMP$SCHEDULE(DYNAMIC)
            do ibox=laddr(1,ilev),laddr(2,ilev)
              
              do i=1,nlist4(ibox)
                jbox = list4(i,ibox)

c              Form local expansion for all boxes in list3
c              of the current box


                istart = isrcse(1,jbox)
                iend = isrcse(2,jbox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call h3dformtacd(nd,zk,rscales(ilev),
     1              sourcesort(1,istart),chargesort(1,istart),
     2              dipvecsort(1,1,istart),npts,
     2              centers(1,ibox),nterms(ilev),
     3              rmlexp(iaddr(2,ibox)),wlege,nlege)
                endif
              enddo
            enddo
C$OMP END PARALLEL DO
          endif
        enddo
      endif

      deallocate(uall,dall,nall,sall,eall,wall,u1234,d5678,n1256)
      deallocate(s3478,e1357,w2468,n12,n56,s34,s78)
      deallocate(e13,e57,w24,w68,e1,e3,e5,e7,w2,w4,w6,w8)
      call cpu_time(time2)
C$    time2=omp_get_wtime()
      timeinfo(3) = time2-time1


      if(ifprint.ge.1)
     $    call prinf('=== Step 4 (split loc) ===*',i,0)

      call cpu_time(time1)
C$        time1=omp_get_wtime()
      do ilev = 1,nlevels-1
        if(ilev.gt.ilevcutoff) then
          nquad2 = nterms(ilev)*2
          nquad2 = max(6,nquad2)
          ifinit2 = 1
          call legewhts(nquad2,xnodes,wts,ifinit2)
          radius = boxsize(ilev+1)/2*sqrt(3.0d0)

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,i,jbox,istart,iend,npts)
          do ibox = laddr(1,ilev),laddr(2,ilev)

            npts = 0

            if(ifpghtarg.gt.0) then
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = npts + iend-istart+1
            endif

            istart = iexpcse(1,ibox)
            iend = iexpcse(2,ibox)
            npts = npts + iend-istart+1

            if(ifpgh.gt.0) then
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = npts + iend-istart+1
            endif

            if(npts.gt.0) then
              do i=1,8
                jbox = itree(ipointer(5)+8*(ibox-1)+i-1)
                if(jbox.gt.0) then
                  call h3dlocloc(nd,zk,rscales(ilev),
     1                centers(1,ibox),rmlexp(iaddr(2,ibox)),
     2                nterms(ilev),rscales(ilev+1),centers(1,jbox),
     3                rmlexp(iaddr(2,jbox)),nterms(ilev+1),
     4                radius,xnodes,wts,nquad2)
                endif
              enddo
            endif
          enddo
C$OMP END PARALLEL DO         
        endif
      enddo
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(4) = time2-time1


      if(ifprint.ge.1)
     $    call prinf('=== step 5 (eval lo) ===*',i,0)

c     ... step 5, evaluate all local expansions
c

      nquad2 = 2*ntj
      nquad2 = max(6,nquad2)
      ifinit2 = 1

      call legewhts(nquad2,xnodes,wts,ifinit2)
      call cpu_time(time1)
C$        time1=omp_get_wtime()
C

c
cc       shift local expansion to local epxanion at expansion centers
c        (note: this part is not relevant for particle codes.
c        it is relevant only for qbx codes)

      do ilev = 0,nlevels
        if(ilev.gt.ilevcutoff) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = iexpcse(1,ibox)
              iend = iexpcse(2,ibox)
              do i=istart,iend
                call h3dlocloc(nd,zk,rscales(ilev),
     1          centers(1,ibox),rmlexp(iaddr(2,ibox)),
     2          nterms(ilev),rscales(ilev),expcsort(1,i),
     3          jsort(1,0,-ntj,i),ntj,radssort(i),xnodes,wts,nquad2)
              enddo
            endif
          enddo
C$OMP END PARALLEL DO
        endif
      enddo

c
cc        evaluate local expansion at source and target
c         locations
c
      do ilev = 0,nlevels
        if(zi*boxsize(ilev).lt.zkiupbound) then
          if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              nchild=itree(ipointer(4)+ibox-1)
              if(nchild.eq.0) then 
                istart = isrcse(1,ibox)
                iend = isrcse(2,ibox)
                npts = iend-istart+1
                call h3dtaevalp(nd,zk,rscales(ilev),centers(1,ibox),
     1           rmlexp(iaddr(2,ibox)),nterms(ilev),
     2           sourcesort(1,istart),npts,pot(1,istart),wlege,nlege)
              endif
            enddo
C$OMP END PARALLEL DO          
          endif

          if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              nchild=itree(ipointer(4)+ibox-1)
              if(nchild.eq.0) then 
                istart = isrcse(1,ibox)
                iend = isrcse(2,ibox)
                npts = iend-istart+1
                call h3dtaevalg(nd,zk,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),sourcesort(1,istart),
     2         npts,pot(1,istart),grad(1,1,istart),wlege,nlege)
              endif
            enddo
C$OMP END PARALLEL DO         
          endif

          if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              nchild=itree(ipointer(4)+ibox-1)
              if(nchild.eq.0) then 
                istart = itargse(1,ibox)
                iend = itargse(2,ibox)
                npts = iend-istart+1
                call h3dtaevalp(nd,zk,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),targsort(1,istart),
     2         npts,pottarg(1,istart),wlege,nlege)
              endif
            enddo
C$OMP END PARALLEL DO         
          endif

          if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              nchild=itree(ipointer(4)+ibox-1)
              if(nchild.eq.0) then 
                istart = itargse(1,ibox)
                iend = itargse(2,ibox)
                npts = iend-istart+1

                call h3dtaevalg(nd,zk,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),targsort(1,istart),
     2         npts,pottarg(1,istart),gradtarg(1,1,istart),wlege,nlege)
              endif
            enddo
C$OMP END PARALLEL DO         
          endif
        endif
      enddo
    
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(5) = time2 - time1


      if(ifprint .ge. 1)
     $     call prinf('=== STEP 6 (direct) =====*',i,0)
      call cpu_time(time1)
C$        time1=omp_get_wtime()

      if(ifnear.eq.0) goto 1000
c
cc       directly form local expansions for list1 sources
c        at expansion centers. 
c        (note: this part is not relevant for particle codes.
c         It is relevant only for qbx codes)


      do ilev=0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarte,iende,i,jbox)
C$OMP$PRIVATE(jstart,jend)
        do ibox = laddr(1,ilev),laddr(2,ilev)
          istarte = iexpcse(1,ibox)
          iende = iexpcse(2,ibox)
          do i =1,nlist1(ibox)
            jbox = list1(i,ibox)
            jstart = isrcse(1,jbox)
            jend = isrcse(2,jbox)

            call hfmm3dexpc_direct(nd,zk,jstart,jend,istarte,
     1         iende,sourcesort,ifcharge,chargesort,ifdipole,
     2         dipvecsort,expcsort,jsort,scjsort,ntj,
     3         wlege,nlege)
          enddo
        enddo
C$OMP END PARALLEL DO
      enddo

c
cc        directly evaluate potential at sources and targets 
c         due to sources in list1

      ntotl1 = 0
      do ilev=0,nlevels
c
cc           evaluate at the sources
c

        if(ifpgh.eq.1) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$REDUCTION(+:ntotl1)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                ntotl1 = ntotl1 + npts*npts0
                call h3ddirectcp(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO            
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectdp(nd,zk,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcdp(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpgh.eq.2) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcg(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectdg(nd,zk,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)       
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcdg(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpghtarg.eq.1) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcp(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectdp(nd,zk,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcdp(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpghtarg.eq.2) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcg(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectdg(nd,zk,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call h3ddirectcdg(nd,zk,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif
      enddo

 1000 continue      
 
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(6) = time2-time1
      if(ifprint.ge.1) call prin2('timeinfo=*',timeinfo,6)
      if(ifprint.ge.1) print *, ntotl1
      d = 0
      do i = 1,6
         d = d + timeinfo(i)
      enddo

      if(ifprint.ge.1) call prin2('sum(timeinfo)=*',d,1)


      return
      end


c------------------------------------------------------------------
      subroutine hfmm3dexpc_direct(nd,zk,istart,iend,jstart,
     $     jend,source,ifcharge,charge,ifdipole,
     $     dipvec,targ,texps,scj,ntj,wlege,nlege)
c---------------------------------------------------------------
c     This subroutine adds the local expansions due to sources
c     istart to iend in the source array at the expansion centers
c     jstart to jend in the target array to the existing local
c     expansions
c
c     INPUT arguments
c------------------------------------------------------------------
c     nd           in: integer *8
c                  number of charge densities
c 
c     zk           in: double complex
c                  helmholtz parameter
c
c     istart       in:Integer
c                  Starting index in source array whose expansions
c                  we wish to add
c
c     iend         in:Integer
c                  Last index in source array whose expansions
c                  we wish to add
c
c     jstart       in: Integer
c                  First index in target array at which we
c                  wish to compute the expansions
c 
c     jend         in:Integer
c                  Last index in target array at which we wish
c                  to compute the expansions
c 
c     source       in: double precision(3,ns)
c                  Source locations
c
c     ifcharge     in: Integer
c                  flag for including expansions due to charges
c                  The expansion due to charges will be included
c                  if ifcharge == 1
c
c     charge       in: double complex
c                  Charge at the source locations
c
c     ifdipole     in: Integer
c                 flag for including expansions due to dipoles
c                 The expansion due to dipoles will be included
c                 if ifdipole == 1
c
c     dipvec      in: double complex(3,ns)
c                 Dipole orientation vector at the source locations
c
c     targ        in: double precision(3,nexpc)
c                 Expansion center locations
c
c     scj         in: double precision(nexpc)
c                 scaling parameters for local expansions
c
c     ntj         in: Integer
c                 Number of terms in expansion
c
c     wlege       in: double precision(0:nlege,0:nlege)
c                 precomputed array of recurrence relation
c                 coeffs for Ynm calculation.
c
c    nlege        in: integer *8
c                 dimension parameter for wlege
c------------------------------------------------------------
c     OUTPUT
c
c   Updated expansions at the targets
c   texps : coeffs for local expansions
c-------------------------------------------------------               
        implicit none
c
        integer *8 istart,iend,jstart,jend,ns,j, nlege
        integer *8 nd
        integer *8 ifcharge,ifdipole,ier
        double complex zk
        double precision source(3,*)
        double precision wlege(0:nlege,0:nlege)
        double complex charge(nd,*)
        double complex dipvec(nd,3,*)
        double precision targ(3,*),scj(*)

        integer *8 nlevels,ntj
c
        double complex texps(nd,0:ntj,-ntj:ntj,*)
        
c
        ns = iend - istart + 1
        if(ifcharge.eq.1.and.ifdipole.eq.0) then
          do j=jstart,jend
            call h3dformtac(nd,zk,scj(j),
     1        source(1,istart),charge(1,istart),ns,
     2        targ(1,j),ntj,texps(1,0,-ntj,j),wlege,nlege)
           enddo
         endif

         if(ifcharge.eq.0.and.ifdipole.eq.1) then
          do j=jstart,jend
            call h3dformtad(nd,zk,scj(j),
     1        source(1,istart),
     2        dipvec(1,1,istart),ns,targ(1,j),ntj,texps(1,0,-ntj,j),
     3        wlege,nlege)
           enddo
         endif

         if(ifcharge.eq.1.and.ifdipole.eq.1) then
          do j=jstart,jend
            call h3dformtacd(nd,zk,scj(j),
     1        source(1,istart),charge(1,istart),
     2        dipvec(1,1,istart),ns,targ(1,j),ntj,texps(1,0,-ntj,j),
     3        wlege,nlege)
           enddo
         endif

c
        return
        end
c------------------------------------------------------------------     

c 
c 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 
c       this is the end of the debugging code and the beginning of the
c       printing subroutines proper
c 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 
c 
c       This file contains 18 user-callable subroutines: prini, prin,
c       prin2, prin2_long, prinq, prinq_long, prinf, prinf_long, prinf2,
c       prina, prinl1, prini_flush, prini_off, prini_on, msgmerge,
c       fileflush, mach_zero, and length.  The following is a brief
c       description of these subroutines.
c
c   prini - Initialize the printing routines with two I/O units
c
c   prin - Print a real*4 array, 6 numbers per line
c
c   prin2 - Print a real*8 array, 6 numbers per line
c
c   prin2_long - Print a real*8 array, 2 numbers per line
c
c   prinq - Print a real*16 array, 6 numbers per line
c
c   prinq_long - Print a real*16 array, 2 numbers per line
c
c   prinf - Print an integer*4 array, 10 numbers per line
c
c   prinf_long - Print an integer*4 array, 6 numbers per line
c
c   prinf2 - Print an integer*2 array, 10 numbers per line
c
c   prina - Print a string
c
c   prinl1 - Print a logical*1 array, 20 logical values per line
c
c   prini_flush - Flush the output buffers for the I/O units provided to prini
c       
c   prini_off - Turn the printing off
c
c   prini_on - Turn the printing back on
c
c
c       This file also provides the following utility subroutines.
c
c   msgmerge - Merge two strings, omitting trailing blanks
c
c   fileflush - Flush the output buffer for the specified I/O unit
c
c   mach_zero - Compute the machine epsilon for real*8 calculations
c
c   length - Compute the length of a string minus trailing blanks
c 
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c 
c 
c 
        SUBROUTINE PRINI(IP1,IQ1)
        save
        CHARACTER MES*(*), AA(1)
        REAL *4 A(1)
        REAL *8 A2(1)
        REAL *8 A4(1)
ccc        REAL *16 A4(1)
        INTEGER *4 IA(1)
        INTEGER *2 IA2(1)
        logical *1 la(1)
        integer ison
        data ison/1/

        IP=IP1
        IQ=IQ1
  
        RETURN
  
C 
C 
C 
C 
C 
        ENTRY PRIN(MES,A,N)
        if (ison .le. 0) return
        CALL  MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1200)(A(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1200)(A(J),J=1,N)
 1200 FORMAT(6(2X,E11.5))
         RETURN
C 
C 
C 
C 
        ENTRY PRIN2(MES,A2,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1400)(A2(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1400)(A2(J),J=1,N)
 1400 FORMAT(6(2X,E11.5))
        RETURN
C 
C 
C 
C 
        ENTRY PRIN2_long(MES,A2,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1450)(A2(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1450)(A2(J),J=1,N)
 1450 FORMAT(2(2X,E22.16))
        RETURN
C 
C 
C 
C 
        ENTRY PRINQ(MES,A4,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1500)(A4(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1500)(A4(J),J=1,N)
 1500 FORMAT(6(2X,e11.5))
        RETURN
C 
C 
C 
C 
        ENTRY PRINQ_long(MES,A4,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1550)(A4(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1550)(A4(J),J=1,N)
 1550 FORMAT(2(2X,E22.16))
        RETURN
C 
C 
C 
C 
        ENTRY PRINF(MES,IA,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1600)(IA(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1600)(IA(J),J=1,N)
 1600 FORMAT(10(1X,I7))
        RETURN
C 
C 
C 
C 
        ENTRY PRINF_long(MES,IA,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1700)(IA(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1700)(IA(J),J=1,N)
 1700 FORMAT(6(2X,I11))
        RETURN
C 
C 
C 
C 
        ENTRY PRINF2(MES,IA2,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,1600)(IA2(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,1600)(IA2(J),J=1,N)
        RETURN
C 
C 
C 
C 
        ENTRY PRINA(MES,AA,N)
        if (ison .le. 0) return
        CALL MESSPR(MES,IP,IQ)
 2000 FORMAT(1X,80A1)
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,2000)(AA(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,2000)(AA(J),J=1,N)
        RETURN
C 
C 
C 
C 
        entry prinl1(mes,la,n)
        if (ison .le. 0) return
        CALL MESSPR(MES,ip,iq)
 2200 format(20L3)
c
        IF(IP.NE.0 .AND. N.NE.0) WRITE(IP,2200)(lA(J),J=1,N)
        IF(IQ.NE.0 .AND. N.NE.0) WRITE(IQ,2200)(lA(J),J=1,N)
c
        return
c
c
c
c
        entry prini_flush()

        if (ip.ne.0 .and. ip.ne.6) call fileflush(ip)
        if (iq.ne.0 .and. iq.ne.6) call fileflush(iq)

        return
c
c
c
c
        entry prini_off()
        ison=0

        return
c
c
c
c
        entry prini_on()
        ison=1

        return
        end
c 
c 
c 
c 
c 
        SUBROUTINE MESSPR(MES,IP,IQ)
        save
        CHARACTER mes*(*), ast*1
        data ast/'*'/
C 
C         DETERMINE THE LENGTH OF THE MESSAGE
C 
        i1=length(mes)
        IF(MES(i1:i1).EQ. ast) i1=i1-1

         IF ( (I1.NE.0) .AND. (IP.NE.0) )
     1     WRITE(IP,1800) mes(1:i1)
         IF ( (I1.NE.0) .AND. (IQ.NE.0) )
     1     WRITE(IQ,1800) mes(1:i1)
 1800 FORMAT(1X,A)
         RETURN
         END
C 
C 
C 
C 
C 
        subroutine msgmerge(a,b,c)
        save
        character a*(*),b*(*),c*(*),ast
        data ast/'*'/
c 
        la=length(a)
        if(a(la:la) .eq. ast) la=la-1

        c=a(1:la)

        lb=length(b)
        if(b(lb:lb) .eq. ast) lb=lb-1

        c(la+1:)=b(1:lb)

        return
        end
c 
c 
c 
c 
c 
  
        subroutine fileflush(iw)
        implicit real *8 (a-h,o-z)
c
ccc        call prinf('flushing unit',iw,1)
c 
        save
        close(iw)
        open(iw,status='old')
        do 1400 i=1,1000000
c 
        read(iw,1200,end=1600)
 1200 format(1a1)
 1400 continue
 1600 continue
c
        backspace iw
c 
        return
        end
  
c 
c 
c 
c 
c  
        subroutine mach_zero(zero_mach7)
        implicit real *8 (a-h,o-z)
        data isinit/-7/
        save

        zero_mach7=zero_mach
        if (isinit .eq. 1) return
c
c
ccc        call prinf('computing zero_mach...',0,0)

        zero_mach=100       
c
        d1=1.1d0
        d=1.11d0
        do 1200 i=1,10000
c

        d=d/2
        d2=d1+d
        d4=sin(sin(d1)-sin(d2))
c
        if(d4 .eq. 0) goto 1400
c
 1200 continue
 1400 continue
c
        zero_mach=d
        isinit=1
c
c
        zero_mach7=zero_mach

        return
        end
c
c
c
c
c
      INTEGER FUNCTION LENGTH(STRING)
*Returns length of string ignoring trailing blanks
      CHARACTER*(*) STRING
      DO 15, I = LEN(STRING), 1, -1
      IF(STRING(I:I) .NE. ' ') GO TO 20
15    CONTINUE
20    LENGTH = I
      END
        

c
c     This file contains the Stokes direct kernel evaluators
c
c**********************************************************************
c      
c     We take the following conventions for the Stokes kernels
c
c     For a source y and target x, let r_i = x_i-y_i
c     and let r = sqrt(r_1^2 + r_2^2 + r_3^2)
c
c     The Stokeslet, G_{ij}, and its associated pressure tensor, P_j,
c     are
c
c     G_{ij}(x,y) = 1/(8\pi)*(r_i r_j)/r^3 + 1/(8\pi)*delta_{ij}/r
c     P_j(x,y) = 1/(4\pi) * r_j/r^3
c
c     The (Type I) stresslet, T_{ijk}, and its associated pressure
c     tensor, PI_{jk}, are
c     
c     T_{ijk}(x,y) = 3/(4\pi) r_i r_j r_k/ r^5
c     PI_{jk} = -1/(2\pi) delta_{jk} + 3/(2\pi) r_j r_k/r^5      
c
c     The rotlet, R_{ijk}, and its associated pressure tensor, Q_{jk}, are
c
c     R_{ijk}(x,y) = -\delta_{ik} r_j/(4\pi r^3) + \delta_{ij} r_k/(4\pi r^3)
c     Q_{jk} = 0;
c
c     The doublet, D_{ijk}, and its associated pressure tensor, L_{jk}, are
c
c     D_{ijk}(x,y) = -\delta_{jk} r_i/(4\pi r^3) - \delta_{ik} r_j/(4\\pi r^3) + \delta_{ij} r_k/(4\pi r^3) + 3 r_i r_j r_k/ (4\pi r^5)
c     L_{jk} = -1/(2\pi) \delta_{jk} + 3 r_j r_k/(2\pi r^5)


      subroutine st3ddirectstokg(nd,sources,stoklet,ns,targ,nt,
     1     pot,pre,grad,thresh)
cf2py  intent(in) nd
cf2py  intent(in) sources
cf2py  intent(in) stoklet
cf2py  intent(in) ns
cf2py  intent(in) targ
cf2py  intent(in) nt
cf2py  intent(in) thresh
cf2py  intent(out) pot,pre,grad
c
c     This subroutine evaluates the potential and gradient due
c     to a collection of Stokeslet and stresslet sources and adds
c     to existing quantities (see definitions at top of file).
c
c       pot(x) = pot(x) + sum_m G_{ij}(x,y^{(m)}) sigma^{(m)}_j
c
c       pre(x) = sum_m P_j(x,y^m) sigma^{(m)}_j
c
c       grad(x) = Grad[sum_m G_{ij}(x,y^m) sigma^{(m)}_j
c      
c     where sigma^{(m)} is the Stokeslet charge, mu^{(m)} is the
c     stresslet charge, and nu^{(m)} is the stresslet orientation
c     (note that each of these is a 3 vector per source point y^{(m)}).
c     For x a source point, the self-interaction in the sum is omitted. 
c
c
c-----------------------------------------------------------------------
      
c     INPUT:
c     
c     nd in: integer *8
c        number of densities
c     
c     nsource in: integer *8  
c        number of sources
c
c     source  in: double precision (3,nsource)
c        source(k,j) is the kth component of the jth
c        source location
c
c     stoklet in: double precision (nd,3,nsource) 
c        Stokeslet charge strengths (sigma vectors above)
c
c     ntarg   in: integer *8  
c        number of targs 
c
c     targ    in: double precision (3,ntarg)
c        targ(k,j) is the kth component of the jth
c        targ location
c     
c     thresh in: double precision
c        threshold for updating potential,
c        potential at target won't be updated if
c        |t - s| <= thresh, where t is the target
c        location and, and s is the source location 
c
c-----------------------------------------------------------------------
c
c   OUTPUT:
c
c     pot out: double precision(nd,3,ntarg) 
c        velocity at the targets
c      
c     pre out: double precision(nd,ntarg)
c        pressure at the targets
c      
c     grad out: double precision(nd,3,3,ntarg) 
c        gradient of velocity at the targets
c        gradtarg(l,i,j,k) is the ith component of the
c        gradient of the jth component of the velocity
c        for the lth density at the kth target
c
c     TODO: implement other stresslet options
c------------------------------------------------------------------
      implicit none

      integer *8 nd, ns, nt
      real *8 sources(3,ns),targ(3,nt)
      real *8 stoklet(nd,3,ns)
      real *8 pot(nd,3,nt),pre(nd,nt),grad(nd,3,3,nt)
      real *8 thresh
      
c     local

      real *8 zdiff(3), d1, d2, d3, tempx1, tempx2, tempx3
      real *8 pl, pv, dmu(3), dnu(3), temp, r, r2, r3, r5
      real *8 dmunu      
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      integer *8 i, j, idim, l

      threshsq = thresh**2


c     stokeslet contribution
      
      do i = 1,nt
         do j = 1,ns
            zdiff(1) = targ(1,i)-sources(1,j)
            zdiff(2) = targ(2,i)-sources(2,j)
            zdiff(3) = targ(3,i)-sources(3,j)

            r2 = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
            if (r2 .lt. threshsq) goto 10

            r = sqrt(r2)
            r3 = r*r2
            
            do idim = 1,nd

               pot(idim,1,i) = pot(idim,1,i) +
     1                         stoklet(idim,1,j)/(2*r)*inv4pi
               pot(idim,2,i) = pot(idim,2,i) +
     1                         stoklet(idim,2,j)/(2*r)*inv4pi
               pot(idim,3,i) = pot(idim,3,i) +
     1                         stoklet(idim,3,j)/(2*r)*inv4pi
               
               pl = (zdiff(1)*stoklet(idim,1,j) +
     1              zdiff(2)*stoklet(idim,2,j) +
     2              zdiff(3)*stoklet(idim,3,j))/(r3*2)
               
               pl = pl * inv4pi
               pot(idim,1,i) = pot(idim,1,i) + zdiff(1)*pl
               pot(idim,2,i) = pot(idim,2,i) + zdiff(2)*pl
               pot(idim,3,i) = pot(idim,3,i) + zdiff(3)*pl

               grad(idim,1,1,i) = grad(idim,1,1,i) + pl
               grad(idim,2,2,i) = grad(idim,2,2,i) + pl
               grad(idim,3,3,i) = grad(idim,3,3,i) + pl               

               d1 = stoklet(idim,1,j)/(r3*2)*inv4pi -
     1              zdiff(1)*pl*3.0d0/r2
               d2 = stoklet(idim,2,j)/(r3*2)*inv4pi -
     1              zdiff(2)*pl*3.0d0/r2
               d3 = stoklet(idim,3,j)/(r3*2)*inv4pi -
     1              zdiff(3)*pl*3.0d0/r2
               
               grad(idim,1,1,i) = grad(idim,1,1,i) + d1*zdiff(1)
               grad(idim,2,1,i) = grad(idim,2,1,i) + d2*zdiff(1)
               grad(idim,3,1,i) = grad(idim,3,1,i) + d3*zdiff(1)
               grad(idim,1,2,i) = grad(idim,1,2,i) + d1*zdiff(2)
               grad(idim,2,2,i) = grad(idim,2,2,i) + d2*zdiff(2)
               grad(idim,3,2,i) = grad(idim,3,2,i) + d3*zdiff(2)
               grad(idim,1,3,i) = grad(idim,1,3,i) + d1*zdiff(3)
               grad(idim,2,3,i) = grad(idim,2,3,i) + d2*zdiff(3)
               grad(idim,3,3,i) = grad(idim,3,3,i) + d3*zdiff(3)

               d1 = -stoklet(idim,1,j)/(2*r3)*inv4pi
               d2 = -stoklet(idim,2,j)/(2*r3)*inv4pi
               d3 = -stoklet(idim,3,j)/(2*r3)*inv4pi               
               
               grad(idim,1,1,i) = grad(idim,1,1,i) + zdiff(1)*d1
               grad(idim,2,1,i) = grad(idim,2,1,i) + zdiff(2)*d1
               grad(idim,3,1,i) = grad(idim,3,1,i) + zdiff(3)*d1
               grad(idim,1,2,i) = grad(idim,1,2,i) + zdiff(1)*d2
               grad(idim,2,2,i) = grad(idim,2,2,i) + zdiff(2)*d2
               grad(idim,3,2,i) = grad(idim,3,2,i) + zdiff(3)*d2
               grad(idim,1,3,i) = grad(idim,1,3,i) + zdiff(1)*d3
               grad(idim,2,3,i) = grad(idim,2,3,i) + zdiff(2)*d3
               grad(idim,3,3,i) = grad(idim,3,3,i) + zdiff(3)*d3

               pre(idim,i) = pre(idim,i) + pl*2

               
            enddo
 10         continue
         enddo
      enddo

      
      return
      end

      subroutine st3ddirectstokstrsg(nd,sources,stoklet,istress,
     1     strslet,strsvec,ns,targ,nt,pot,pre,grad,thresh)
cf2py  intent(in) nd
cf2py  intent(in) sources
cf2py  intent(in) stoklet,istress
cf2py  intent(in) strslet,strsvec
cf2py  intent(in) ns
cf2py  intent(in) targ
cf2py  intent(in) nt
cf2py  intent(in) thresh
cf2py  intent(out) pot,pre,grad
c
c     This subroutine evaluates the potential and gradient due
c     to a collection of Stokeslet and stresslet sources and adds
c     to existing quantities (see definitions at top of file).
c
c       pot(x) = pot(x) + sum_m G_{ij}(x,y^{(m)}) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k
c
c       pre(x) = sum_m P_j(x,y^m) sigma^{(m)}_j
c          + sum_m T_{ijk}(x,y^{(m)}) PI_{jk} mu^{(m)}_j nu^{(m)}_k
c
c       grad(x) = Grad[sum_m G_{ij}(x,y^m) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k]
c      
c     where sigma^{(m)} is the Stokeslet charge, mu^{(m)} is the
c     stresslet charge, and nu^{(m)} is the stresslet orientation
c     (note that each of these is a 3 vector per source point y^{(m)}).
c     For x a source point, the self-interaction in the sum is omitted. 
c
c
c-----------------------------------------------------------------------
      
c     INPUT:
c     
c     nd in: integer *8
c        number of densities
c     
c     nsource in: integer *8  
c        number of sources
c
c     source  in: double precision (3,nsource)
c        source(k,j) is the kth component of the jth
c        source location
c
c     stoklet in: double precision (nd,3,nsource) 
c        Stokeslet charge strengths (sigma vectors above)
c
c     istress in: integer *8
c        stresslet computation flag
c           istress = 1   =>  include standard stresslet
c                               (type I)
c     
c           NOT YET IMPLEMENTED
c      
c           ifstress = 2   =>  include symmetric stresslet
c                                   (type II)
c           ifstress = 3   =>  include rotlet
c           ifstress = 4   =>  include Stokes doublet
c                      otherwise do not include
c
c     strslet  in: double precision (nd,3,nsource) 
c        stresslet strengths (mu vectors above)
c
c     strsvec  in: double precision (nd,3,nsource)   
c        stresslet orientations (nu vectors above)
c      
c     ntarg   in: integer *8  
c        number of targs 
c
c     targ    in: double precision (3,ntarg)
c        targ(k,j) is the kth component of the jth
c        targ location
c     
c     thresh in: double precision
c        threshold for updating potential,
c        potential at target won't be updated if
c        |t - s| <= thresh, where t is the target
c        location and, and s is the source location 
c
c-----------------------------------------------------------------------
c
c   OUTPUT:
c
c     pot out: double precision(nd,3,ntarg) 
c        velocity at the targets
c      
c     pre out: double precision(nd,ntarg)
c        pressure at the targets
c      
c     grad out: double precision(nd,3,3,ntarg) 
c        gradient of velocity at the targets
c        gradtarg(l,i,j,k) is the ith component of the
c        gradient of the jth component of the velocity
c        for the lth density at the kth target
c
c     TODO: implement other stresslet options
c------------------------------------------------------------------
      implicit none

      integer *8 nd, ns, nt, istress
      real *8 sources(3,ns),targ(3,nt),strslet(nd,3,ns)
      real *8 strsvec(nd,3,ns),stoklet(nd,3,ns)
      real *8 pot(nd,3,nt),pre(nd,nt),grad(nd,3,3,nt)
      real *8 thresh
      
c     local

      real *8 zdiff(3), d1, d2, d3, tempx1, tempx2, tempx3
      real *8 pl, pv, dmu(3), dnu(3), temp, r, r2, r3, r5
      real *8 dmunu      
      real *8 threshsq
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      integer *8 i, j, idim, l


      call st3ddirectstokg(nd,sources,stoklet,ns,targ,nt,
     1     pot,pre,grad,thresh)

      
      threshsq = thresh**2


      if (istress .ne. 1) goto 100

c     type I stresslet
      
      do i = 1,nt
         do j = 1,ns
            zdiff(1) = targ(1,i)-sources(1,j)
            zdiff(2) = targ(2,i)-sources(2,j)
            zdiff(3) = targ(3,i)-sources(3,j)

            r2 = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
            if (r2 .lt. threshsq) goto 20

            r = sqrt(r2)
            r3 = r*r2
            r5 = r3*r2
            
            do idim = 1,nd

               dmu(1) = strslet(idim,1,j)
               dmu(2) = strslet(idim,2,j)
               dmu(3) = strslet(idim,3,j)
               dnu(1) = strsvec(idim,1,j)
               dnu(2) = strsvec(idim,2,j)
               dnu(3) = strsvec(idim,3,j)

               pl = zdiff(1)*dmu(1) + zdiff(2)*dmu(2) + zdiff(3)*dmu(3)
               pv = zdiff(1)*dnu(1) + zdiff(2)*dnu(2) + zdiff(3)*dnu(3)

               temp = 3.0d0*pl*pv/r5
               temp = temp * inv4pi
               
               pot(idim,1,i) = pot(idim,1,i) + zdiff(1)*temp
               pot(idim,2,i) = pot(idim,2,i) + zdiff(2)*temp
               pot(idim,3,i) = pot(idim,3,i) + zdiff(3)*temp

               tempx1 = 3.0d0*(dmu(1)*pv + dnu(1)*pl -
     1              5.0d0*zdiff(1)*pl*pv/r2)/ r5
               tempx2 = 3.0d0*(dmu(2)*pv + dnu(2)*pl -
     1              5.0d0*zdiff(2)*pl*pv/r2)/ r5
               tempx3 = 3.0d0*(dmu(3)*pv + dnu(3)*pl -
     1              5.0d0*zdiff(3)*pl*pv/r2)/ r5

               tempx1 = tempx1 * inv4pi
               tempx2 = tempx2 * inv4pi
               tempx3 = tempx3 * inv4pi

               grad(idim,1,1,i) = grad(idim,1,1,i) + temp
               grad(idim,1,1,i) = grad(idim,1,1,i) + zdiff(1)*tempx1
               grad(idim,2,1,i) = grad(idim,2,1,i) + zdiff(1)*tempx2
               grad(idim,3,1,i) = grad(idim,3,1,i) + zdiff(1)*tempx3
               
               grad(idim,2,2,i) = grad(idim,2,2,i) + temp
               grad(idim,1,2,i) = grad(idim,1,2,i) + zdiff(2)*tempx1
               grad(idim,2,2,i) = grad(idim,2,2,i) + zdiff(2)*tempx2
               grad(idim,3,2,i) = grad(idim,3,2,i) + zdiff(2)*tempx3
               
               grad(idim,3,3,i) = grad(idim,3,3,i) + temp
               grad(idim,1,3,i) = grad(idim,1,3,i) + zdiff(3)*tempx1
               grad(idim,2,3,i) = grad(idim,2,3,i) + zdiff(3)*tempx2
               grad(idim,3,3,i) = grad(idim,3,3,i) + zdiff(3)*tempx3

               dmunu = dmu(1)*dnu(1) + dmu(2)*dnu(2) + dmu(3)*dnu(3)
               dmunu = dmunu * inv4pi
               
               pre(idim,i) = pre(idim,i) - 2.0d0*dmunu/r3 + 2.0d0*temp
            enddo
            
 20         continue
         enddo
      enddo
      
      return
      
 100  continue
      
      return
      end
      


      subroutine st3ddirectstokstrsrotdoubg(nd,sources,stoklet,istress,
     1     strslet,strsvec,irotlet,rotlet,rotvec,
     2     idoublet,doublet,doubvec,
     3     ns,targ,nt,pot,pre,grad,thresh)
cf2py  intent(in) nd
cf2py  intent(in) sources
cf2py  intent(in) stoklet,istress
cf2py  intent(in) strslet,strsvec
cf2py  intent(in) irotlet,rotlet,rotvec
cf2py  intent(in) idoublet,doublet,doubvec
cf2py  intent(in) ns
cf2py  intent(in) targ
cf2py  intent(in) nt
cf2py  intent(in) thresh
cf2py  intent(out) pot,pre,grad
c
c     This subroutine evaluates the potential and gradient due
c     to a collection of Stokeslet and stresslet sources and adds
c     to existing quantities (see definitions at top of file).
c
c       pot(x) = pot(x) + sum_m G_{ij}(x,y^{(m)}) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k
c                + sum_m R_{ijk}(x,y^{(m)}) rlet^{(m)}_j rvec^{(m)}_k
c                + sum_m D_{ijk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c       pre(x) = sum_m P_j(x,y^m) sigma^{(m)}_j
c                + sum_m PI_{jk} mu^{(m)}_j nu^{(m)}_k
c                + sum_m L_{jk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c       grad(x) = Grad[sum_m G_{ij}(x,y^m) sigma^{(m)}_j
c                + sum_m T_{ijk}(x,y^{(m)}) mu^{(m)}_j nu^{(m)}_k]
c                + sum_m R_{ijk}(x,y^{(m)}) rlet^{(m)}_j rvec^{(m)}_k
c                + sum_m D_{ijk}(x,y^{(m)}) dlet^{(m)}_j dvec^{(m)}_k
c
c     where sigma^{(m)} is the Stokeslet charge, mu^{(m)} is the
c     stresslet charge, nu^{(m)} is the stresslet orientation
c     rlet^{(m)} is the rotlet strength, rvec^{(m)} is the rotlet
c     dlet^{(m)} is the doublet strength, and dvec^{(m)} is the doublet
c     (note that each of these is a 3 vector per source point y^{(m)}).
c     For x a source point, the self-interaction in the sum is omitted.
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd in: integer *8
c        number of densities
c
c     nsource in: integer *8
c        number of sources
c
c     source  in: double precision (3,nsource)
c        source(k,j) is the kth component of the jth
c        source location
c
c     stoklet in: double precision (nd,3,nsource)
c        Stokeslet charge strengths (sigma vectors above)
c
c     istress in: integer *8
c        stresslet computation flag
c           istress = 1   =>  include standard stresslet
c                               (type I)
c
c           NOT YET IMPLEMENTED
c
c           istress = 2   =>  include symmetric stresslet
c                                   (type II)
c           istress = 3   =>  include rotlet
c           istress = 4   =>  include Stokes doublet
c                      otherwise do not include
c
c     strslet  in: double precision (nd,3,nsource)
c        stresslet strengths (mu vectors above)
c
c     strsvec  in: double precision (nd,3,nsource)
c        stresslet orientations (nu vectors above)
c
c     irotlet in: integer *8
c
c     rotlet  in: double precision (nd,3,nsource)
c        rotlet strengths
c
c     rotvec  in: double precision (nd,3,nsource)
c        rotlet orientations
c
c     idoublet in: integer *8
c
c     doublet  in: double precision (nd,3,nsource)
c        doublet strengths
c
c     doubvec  in: double precision (nd,3,nsource)
c        doublet orientations
c
c     ntarg   in: integer *8
c        number of targs
c
c     targ    in: double precision (3,ntarg)
c        targ(k,j) is the kth component of the jth
c        targ location
c
c     thresh in: double precision
c        threshold for updating potential,
c        potential at target won't be updated if
c        |t - s| <= thresh, where t is the target
c        location and, and s is the source location
c
c-----------------------------------------------------------------------
c
c   OUTPUT:
c
c     pot out: double precision(nd,3,ntarg)
c        velocity at the targets
c
c     pre out: double precision(nd,ntarg)
c        pressure at the targets
c
c     grad out: double precision(nd,3,3,ntarg)
c        gradient of velocity at the targets
c        gradtarg(l,i,j,k) is the ith component of the
c        gradient of the jth component of the velocity
c        for the lth density at the kth target
c
c     TODO: implement other stresslet options
c------------------------------------------------------------------
      implicit none

      integer *8 nd, ns, nt, istress, irotlet, idoublet
      real *8 sources(3,ns),targ(3,nt),strslet(nd,3,ns)
      real *8 rotlet(nd,3,ns),rotvec(nd,3,ns)
      real *8 doublet(nd,3,ns),doubvec(nd,3,ns)
      real *8 strsvec(nd,3,ns),stoklet(nd,3,ns)
      real *8 pot(nd,3,nt),pre(nd,nt),grad(nd,3,3,nt)
      real *8 thresh, threshsq
c     local
      real *8 zdiff(3), tempx1, tempx2, tempx3
      real *8 pl, pv, dmu(3), dnu(3), temp, r, r2, r3, r5
      real *8 r3inv
      real *8 rpl, rpv, dpl, dpv, dlv
      real *8 rlet(3),rvec(3),dlet(3),dvec(3)
      real *8 dmunu
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      integer *8 i, j, idim, l

      if (istress .ne. 1) then
         call st3ddirectstokg(nd,sources,stoklet,ns,targ,nt,
     1        pot,pre,grad,thresh)
      else
         call st3ddirectstokstrsg(nd,sources,stoklet,istress,
     1        strslet,strsvec,ns,targ,nt,pot,pre,grad,thresh)
      endif

      threshsq = thresh**2

      if (irotlet .ne. 1 .and. idoublet .ne. 1) goto 100

c     rotlet and doublet
      do i = 1,nt
         do j = 1,ns
            zdiff(1) = targ(1,i)-sources(1,j)
            zdiff(2) = targ(2,i)-sources(2,j)
            zdiff(3) = targ(3,i)-sources(3,j)

            r2 = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
            if (r2 .lt. threshsq) goto 20

            r = sqrt(r2)
            r3 = r*r2
            r5 = r3*r2
            r3inv = inv4pi/r3
            do idim = 1,nd

               if (irotlet .eq. 1) then
                  rlet(1) = rotlet(idim,1,j)
                  rlet(2) = rotlet(idim,2,j)
                  rlet(3) = rotlet(idim,3,j)
                  rvec(1) = rotvec(idim,1,j)
                  rvec(2) = rotvec(idim,2,j)
                  rvec(3) = rotvec(idim,3,j)

                  rpl = zdiff(1)*rlet(1) + zdiff(2)*rlet(2) +
     1                  zdiff(3)*rlet(3)
                  rpv = zdiff(1)*rvec(1) + zdiff(2)*rvec(2) +
     1                  zdiff(3)*rvec(3)

                  pot(idim,1,i) = pot(idim,1,i) - rvec(1)*rpl*r3inv +
     1                            rlet(1)*rpv*r3inv
                  pot(idim,2,i) = pot(idim,2,i) - rvec(2)*rpl*r3inv +
     1                            rlet(2)*rpv*r3inv
                  pot(idim,3,i) = pot(idim,3,i) - rvec(3)*rpl*r3inv +
     1                            rlet(3)*rpv*r3inv

                  tempx1 = -(rlet(1) - 3.0d0*zdiff(1)*rpl/r2) * r3inv
                  tempx2 = -(rlet(2) - 3.0d0*zdiff(2)*rpl/r2) * r3inv
                  tempx3 = -(rlet(3) - 3.0d0*zdiff(3)*rpl/r2) * r3inv

                  grad(idim,1,1,i) = grad(idim,1,1,i) + rvec(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + rvec(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + rvec(1)*tempx3

                  grad(idim,1,2,i) = grad(idim,1,2,i) + rvec(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + rvec(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + rvec(2)*tempx3

                  grad(idim,1,3,i) = grad(idim,1,3,i) + rvec(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + rvec(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + rvec(3)*tempx3

                  tempx1 = (rvec(1) - 3.0d0*zdiff(1)*rpv/r2) * r3inv
                  tempx2 = (rvec(2) - 3.0d0*zdiff(2)*rpv/r2) * r3inv
                  tempx3 = (rvec(3) - 3.0d0*zdiff(3)*rpv/r2) * r3inv

                  grad(idim,1,1,i) = grad(idim,1,1,i) + rlet(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + rlet(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + rlet(1)*tempx3

                  grad(idim,1,2,i) = grad(idim,1,2,i) + rlet(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + rlet(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + rlet(2)*tempx3

                  grad(idim,1,3,i) = grad(idim,1,3,i) + rlet(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + rlet(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + rlet(3)*tempx3
               endif

               if (idoublet .eq. 1) then
                  dlet(1) = doublet(idim,1,j)
                  dlet(2) = doublet(idim,2,j)
                  dlet(3) = doublet(idim,3,j)
                  dvec(1) = doubvec(idim,1,j)
                  dvec(2) = doubvec(idim,2,j)
                  dvec(3) = doubvec(idim,3,j)

                  dpl = zdiff(1)*dlet(1) + zdiff(2)*dlet(2) +
     1                  zdiff(3)*dlet(3)
                  dpv = zdiff(1)*dvec(1) + zdiff(2)*dvec(2) +
     1                  zdiff(3)*dvec(3)
                  dlv = dlet(1)*dvec(1) + dlet(2)*dvec(2) +
     1                  dlet(3)*dvec(3)

                  temp = 3.0d0*dpl*dpv*inv4pi/r5

                  pot(idim,1,i) = pot(idim,1,i) - zdiff(1)*dlv*r3inv -
     1                            dvec(1)*dpl*r3inv + dlet(1)*dpv*r3inv+
     2                            zdiff(1)*temp
                  pot(idim,2,i) = pot(idim,2,i) - zdiff(2)*dlv*r3inv -
     1                            dvec(2)*dpl*r3inv + dlet(2)*dpv*r3inv+
     2                            zdiff(2)*temp
                  pot(idim,3,i) = pot(idim,3,i) - zdiff(3)*dlv*r3inv -
     1                            dvec(3)*dpl*r3inv + dlet(3)*dpv*r3inv+
     2                            zdiff(3)*temp

                  tempx1 = 3.0d0*(dlet(1)*dpv + dvec(1)*dpl -
     1                 5.0d0*zdiff(1)*dpl*dpv/r2)*inv4pi/r5
                  tempx2 = 3.0d0*(dlet(2)*dpv + dvec(2)*dpl -
     1                 5.0d0*zdiff(2)*dpl*dpv/r2)*inv4pi/r5
                  tempx3 = 3.0d0*(dlet(3)*dpv + dvec(3)*dpl -
     1                 5.0d0*zdiff(3)*dpl*dpv/r2)*inv4pi/r5

                  grad(idim,1,1,i) = grad(idim,1,1,i) + temp
                  grad(idim,1,1,i) = grad(idim,1,1,i) + zdiff(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + zdiff(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + zdiff(1)*tempx3

                  grad(idim,2,2,i) = grad(idim,2,2,i) + temp
                  grad(idim,1,2,i) = grad(idim,1,2,i) + zdiff(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + zdiff(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + zdiff(2)*tempx3

                  grad(idim,3,3,i) = grad(idim,3,3,i) + temp
                  grad(idim,1,3,i) = grad(idim,1,3,i) + zdiff(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + zdiff(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + zdiff(3)*tempx3

                  tempx1 = -(dlet(1) - 3.0d0*zdiff(1)*dpl/r2) * r3inv
                  tempx2 = -(dlet(2) - 3.0d0*zdiff(2)*dpl/r2) * r3inv
                  tempx3 = -(dlet(3) - 3.0d0*zdiff(3)*dpl/r2) * r3inv

                  grad(idim,1,1,i) = grad(idim,1,1,i) + dvec(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + dvec(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + dvec(1)*tempx3

                  grad(idim,1,2,i) = grad(idim,1,2,i) + dvec(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + dvec(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + dvec(2)*tempx3

                  grad(idim,1,3,i) = grad(idim,1,3,i) + dvec(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + dvec(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + dvec(3)*tempx3

                  tempx1 = (dvec(1) - 3.0d0*zdiff(1)*dpv/r2) * r3inv
                  tempx2 = (dvec(2) - 3.0d0*zdiff(2)*dpv/r2) * r3inv
                  tempx3 = (dvec(3) - 3.0d0*zdiff(3)*dpv/r2) * r3inv

                  grad(idim,1,1,i) = grad(idim,1,1,i) + dlet(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + dlet(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + dlet(1)*tempx3

                  grad(idim,1,2,i) = grad(idim,1,2,i) + dlet(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + dlet(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + dlet(2)*tempx3

                  grad(idim,1,3,i) = grad(idim,1,3,i) + dlet(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + dlet(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + dlet(3)*tempx3

                  tempx1 = 3.0d0*zdiff(1)*dlv*inv4pi/r5
                  tempx2 = 3.0d0*zdiff(2)*dlv*inv4pi/r5
                  tempx3 = 3.0d0*zdiff(3)*dlv*inv4pi/r5

                  grad(idim,1,1,i) = grad(idim,1,1,i) - dlv*r3inv
                  grad(idim,1,1,i) = grad(idim,1,1,i) + zdiff(1)*tempx1
                  grad(idim,2,1,i) = grad(idim,2,1,i) + zdiff(1)*tempx2
                  grad(idim,3,1,i) = grad(idim,3,1,i) + zdiff(1)*tempx3

                  grad(idim,2,2,i) = grad(idim,2,2,i) - dlv*r3inv
                  grad(idim,1,2,i) = grad(idim,1,2,i) + zdiff(2)*tempx1
                  grad(idim,2,2,i) = grad(idim,2,2,i) + zdiff(2)*tempx2
                  grad(idim,3,2,i) = grad(idim,3,2,i) + zdiff(2)*tempx3

                  grad(idim,3,3,i) = grad(idim,3,3,i) - dlv*r3inv
                  grad(idim,1,3,i) = grad(idim,1,3,i) + zdiff(3)*tempx1
                  grad(idim,2,3,i) = grad(idim,2,3,i) + zdiff(3)*tempx2
                  grad(idim,3,3,i) = grad(idim,3,3,i) + zdiff(3)*tempx3

                  pre(idim,i) = pre(idim,i) - 2.0d0*dlv*r3inv
     1                                      + 2.0d0*temp
               endif

            enddo

 20         continue
         enddo
      enddo

      return

 100  continue

      return
      end

c
c     This file contains the translation operators for the helmholtz 
c     3D FMM
c
c     h3dmpmp - shift center of multipole expansion
c     h3dmploc - convert multipole expansion to a local expansion
c     h3dlocloc - shift center of local expansion  
c
C***********************************************************************
      subroutine h3dmpmp(nd,wavek,sc1,x0y0z0,mpole,nterms,
     1           sc2,xnynzn,mpolen,nterms2,
     2           radius,xnodes,wts,nquad)
C***********************************************************************
C
C
C     Usage:
C
C           Shift center of multipole expansion mpole, and add output 
C           multipole expansion.
C           This is a reasonably fast "point and shoot" version which
C           first rotates the coordinate system, then shifts
C           along the Z-axis, and then rotates back to the original
C           coordinates.
C           
C           NOTE: the output multipole expansion is not initialized
C              in this routine and the shifted 
C              multipole expansion is directly added to it
C              
C           
C
C---------------------------------------------------------------------
C     INPUT:
C
C           nd     = number of multipole expansions
C           wavek  = Helmholtz parameter
C           sc1     = scaling parameter for mpole expansion
C           x0y0z0 = center of original multiple expansion
C           mpole  = coefficients of original multiple expansion
C           nterms = order of multipole expansion
C           sc2     = scaling parameter for shifted expansion
C           xnynzn = center of shifted expansion
C           nterms2 = order of shifted expansion
C           radius  = radius of sphere on which mpole expansion is
C                     computed
C           xnodes  = Legendre nodes (precomputed)
C           wts     = Legendre weights (precomputed)
C           nquad   = number of quadrature nodes in theta direction
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C           mpolen = coefficients of shifted mpole expansion
C
C
C***********************************************************************
      implicit none
c
cc      calling sequence variables
c
      integer *8  nterms,nterms2,nquad,nd
      real *8 x0y0z0(3),xnynzn(3)
      real *8 radius,xnodes(nquad),wts(nquad)
      real *8 sc1,sc2
      complex *16 wavek
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      complex *16 mpolen(nd,0:nterms2,-nterms2:nterms2)

c
cc      temporary variables
c
      complex *16, allocatable :: marray(:,:,:),marray1(:,:,:)
      complex *16, allocatable :: mptemp(:,:,:),mp2(:,:,:)
      complex *16, allocatable :: ephi(:),phitemp(:,:,:)
      complex *16, allocatable :: phitempn(:,:,:)
      complex *16, allocatable :: fhs(:),fhder(:)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16 imag

      integer *8  nq, ldc,idim
      real *8 rshift
      real *8 d,theta,ctheta,phi,rvec(3)
      integer *8  l,m,jnew,knew


      data imag/(0.0d0,1.0d0)/
C
      ldc = max(nterms,nterms2)
      nq = max(nquad,2*ldc+2)

      allocate(marray(nd,0:ldc,-ldc:ldc))
      allocate(marray1(nd,0:nterms,-nterms:nterms))
      allocate(mptemp(nd,0:nterms2,-nterms2:nterms2))
      allocate(mp2(nd,0:nterms2,-nterms2:nterms2))
      allocate(ephi(-ldc-1:ldc+1))
      allocate(phitemp(nd,nq,-ldc:ldc))
      allocate(phitempn(nd,nq,-ldc:ldc))
      allocate(fhs(0:ldc),fhder(0:ldc))
      allocate(ynm(0:ldc,0:ldc),ynmd(0:ldc,0:ldc))

C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)

      call cart2polar(rvec,d,theta,phi)

      ephi(1) = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(-1)=dconjg(ephi(1))
c
c----- create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo
c
c----- a rotation of THETA radians about the Yprime axis after PHI
c      radians about the z-axis.
c      The PHI rotation is carried out on the fly by multiplying 
c      mpole and ephi inside the following loop. 
c
      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               marray1(idim,l,m)=mpole(idim,l,m)*ephi(m)
            enddo
         enddo
      enddo

      if( nterms .ge. 30 ) then 
         call rotviaproj(nd,theta,nterms,nterms,nterms,marray1,
     1         nterms,marray,ldc)
      else
         call rotviarecur(nd,theta,nterms,nterms,nterms,marray1,
     1           nterms,marray,ldc)
      endif

c
c
c----- shift the mpole expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      do l=0,nterms2
         do m=-l,l
           do idim=1,nd
              mptemp(idim,l,m) = 0
              mp2(idim,l,m) = 0
           enddo
         enddo
      enddo



      rshift = d
      call h3dmpmpzshift
     $   (nd,wavek,sc1,marray,ldc,nterms,sc2,mptemp,
     1           nterms2,nterms2,radius,rshift,xnodes,wts,nquad,
     2           ynm,ynmd,mp2,phitemp,phitempn,fhs,fhder)
c
c
c     Reverse THETA rotation.
c     I.e. rotation of -THETA radians about Yprime axis.
c
      if( nterms2 .ge. 30 ) then
         call rotviaproj(nd,-theta,nterms2,nterms,nterms2,mptemp,
     1           nterms2,marray,ldc)
      else
         call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,mptemp,
     1           nterms2,marray,ldc)
      endif
c
c
c----- rotate back PHI radians about the Z-axis in the above system
c         and add to existing expansion mpolen
c
      do l=0,nterms2
         do m=-l,l
            do idim=1,nd
              mpolen(idim,l,m)=mpolen(idim,l,m) + 
     1           ephi(-m)*marray(idim,l,m)
            enddo
         enddo
      enddo

      return
      end
c
c
c
c
c
c
c***********************************************************************
      subroutine h3dmpmpzshift
     $     (nd,zk,scale,mpole,lmp,nterms,scale2,mpolen,
     1      lmpn,nterms2,radius,zshift,xnodes,wts,nquad,ynm,
     2      ynmd,mp2,phitemp,phitempn,fhs,fhder)
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a multipole expansion centered at (0,0,zhift).
c     The expansion is rescaled to that of the shifted expansion.
c
c INPUT:
c
c     nd       : number of multipole expansions
c     zk       : Helmholtz coefficient
c     scale    : scale parameter for mpole
c     mpole    : coefficients of original multipole exp.
c     lmp      : leading dim of mpole (may be a work array)
c     nterms   : number of terms in the orig. expansion
c
c     scale2   : scale parameter for new expansion (mpolen)
c     lmpn     : leading dim of shifted (may be work array)
c     nterms2  : number of terms in output expansion
c     radius   : radius of sphere on which mpole is evaluated
c                           in projeciton step
c     zshift   : shifting distance along z-axis
c                              (always assumed positive)
C     xnodes   : Legendre nodes (precomputed)
C     wts      : Legendre weights (precomputed)
C     nquad    : number of quadrature nodes in theta direction
c
c OUTPUT:
c
c     mpolen  (complex *16)  : coefficients of shifted exp.
c
c***********************************************************************
      implicit real *8 (a-h,o-z)
      integer *8 nterms,nterms2,nquad,ier,lmp,lmpn,ldc,iynm,lynm,nd
      real *8   zshift,scale,scale2,radius
      real *8   xnodes(*),wts(*)
      real *8   ynm(0:nterms,0:nterms)
      real *8   ynmd(0:nterms,0:nterms)
      complex *16 phitemp(nd,nquad,-nterms:nterms)
      complex *16 phitempn(nd,nquad,-nterms:nterms)
      complex *16 fhs(0:nterms2)
      complex *16 fhder(0:nterms2)
      complex *16 mpole(nd,0:lmp,-lmp:lmp),zk
      complex *16 mpolen(nd,0:lmpn,-lmpn:lmpn)
      complex *16 mp2(nd,0:lmpn,-lmpn:lmpn)
c
c     local allocated workspace arrays - no more passed workspace
c
      real *8, allocatable :: rat1(:,:),rat2(:,:)
c
      integer *8 l,m,jnew,knew
C
C----- shift along z-axis by evaluating field on target sphere and
C     projecting onto spherical harmonics and scaling by j_n(kR).
C
C    OPTIMIZATION NOTES:
C
C    Suppose you are shifting from a very small sphere to the center
C    of a very large sphere (nterms2 >> nterms).
C    Then, ALONG THE Z-AXIS, the number of azimuthal modes that
C    need to be computed is only nterms (not nterms2). 
C    Subroutines h3dmpevalspherenm, h3dprojlocnmsep allow for this.
C    The final step of the point and shoot algorithm then distributes
C    these nterms (azimuthal) modes to nterms2 (azimuthal) in the
C    "laboratory frame".
C
C    cost is (nterms^2 x nterms2) rather than (nterms x nterms2^2)
C

        ldc = max(nterms,nterms2)

        allocate(rat1(0:ldc,0:ldc))
        allocate(rat2(0:ldc,0:ldc))


      call h3dmpevalsphere(nd,mpole,zk,scale,
     1     zshift,radius,nterms,lmp,ynm,ynmd,
     2     phitemp,phitempn,nquad,xnodes,fhs,fhder,rat1,rat2)
      call h3dprojloc
     $   (nd,nterms2,lmpn,nquad,nterms,xnodes,wts,
     1     phitemp,phitempn,mpolen,mp2,ynm,rat1,rat2)
      call h3drescalemp(nd,nterms2,lmpn,mpolen,radius,zk,
     1               scale2,fhs,fhder)
      return
      end
c
c
c
c
c
C***********************************************************************
      subroutine h3dmploc(nd,wavek,sc1,x0y0z0,mpole,nterms,
     1           sc2,xnynzn,local,nterms2,
     2           radius,xnodes,wts,nquad)
C***********************************************************************
C
C           Converts multipole expansion and adds to a local expansion
C           This is a reasonably fast "point and shoot" version which
C           first rotates the coordinate system, then shifts along
C           the Z-axis, and then rotates back to the original
C           coordinates.
C
C           NOTE: the output local expansion is not initialized
C              in this routine and the shifted 
C              multipole expansion is directly added to it
C
C---------------------------------------------------------------------
C     INPUT:
C
C           nd     = number of expansions
C           wavek  = Helmholtz parameter
C           sc1     = scaling parameter for mpole expansion
C           x0y0z0 = center of original multiple expansion
C           mpole  = coefficients of original multiple expansion
C           nterms = order of multipole expansion
C           sc2     = scaling parameter for local expansion
C           xnynzn = center of shifted local expansion
C           nterms2 = order of local expansion
C           radius  = radius of sphere on which local expansion is
C                     computed
C           xnodes  = Legendre nodes (precomputed)
C           wts     = Legendre weights (precomputed)
C           nquad   = number of quadrature nodes in theta direction.
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C           local = coefficients of shifted local expansion
C
C***********************************************************************
C
      implicit none

c
cc       calling sequence variables

      integer *8 nterms,nterms2,nquad,nd
      real *8 x0y0z0(3),xnynzn(3)
      real *8 xnodes(nquad),wts(nquad),radius
      real *8 sc1,sc2
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      complex *16 local(nd,0:nterms2,-nterms2:nterms2)
      complex *16 wavek

c
cc      temporary variables
c
      complex *16, allocatable :: marray(:,:,:),marray1(:,:,:)
      complex *16, allocatable :: mptemp(:,:,:),mp2(:,:,:)
      complex *16, allocatable :: ephi(:),phitemp(:,:,:)
      complex *16, allocatable :: phitempn(:,:,:)
      complex *16, allocatable :: fhs(:),fhder(:)
      complex *16, allocatable :: fjs(:),fjder(:)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16 imag

      integer *8  nq, ldc,idim
      real *8 rshift
      real *8 d,theta,ctheta,phi,rvec(3)
      integer *8  l,m,jnew,knew
c
      data imag/(0.0d0,1.0d0)/
C
      ldc = max(nterms,nterms2)
      nq = max(nquad,2*ldc+2)

      allocate(marray(nd,0:ldc,-ldc:ldc))
      allocate(mp2(nd,0:ldc,-ldc:ldc))
      allocate(marray1(nd,0:nterms,-nterms:nterms))
      allocate(mptemp(nd,0:nterms2,-nterms2:nterms2))
      allocate(ephi(-ldc-1:ldc+1))
      allocate(phitemp(nd,nq,-ldc:ldc))
      allocate(phitempn(nd,nq,-ldc:ldc))
      allocate(fhs(0:ldc),fhder(0:ldc))
      allocate(ynm(0:ldc,0:ldc),ynmd(0:ldc,0:ldc))
      allocate(fjs(0:nterms2),fjder(0:nterms2))

C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)
      call cart2polar(rvec,d,theta,phi)
c
      ephi(1) = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(-1)=dconjg(ephi(1))
c
c     create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo
c
c     a rotation of THETA radians about the Yprime axis after PHI
c     radians about the z-axis.
      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               marray1(idim,l,m)  = mpole(idim,l,m)*ephi(m)
            enddo
         enddo
      enddo

      do l=0,nterms2
         do m=-l,l
            do idim=1,nd
               mptemp(idim,l,m)=0.0d0
            enddo
         enddo
      enddo

c
      if( nterms .ge. 30 ) then
         call rotviaproj(nd,theta,nterms,nterms,nterms,marray1,
     1       nterms,marray,ldc)
      else
         call rotviarecur(nd,theta,nterms,nterms,nterms,marray1,
     1          nterms,marray,ldc)
      endif

c
c----- shift the local expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      rshift = d
      call h3dmploczshift(nd,wavek,marray,sc1,ldc,nterms,mptemp,
     1      sc2,nterms2,nterms2,radius,rshift,xnodes,wts,nquad,
     2      ynm,ynmd,mp2,phitemp,phitempn,fhs,fhder,fjs,fjder)

c
c     reverse THETA rotation. 
c     I.e. rotation of -THETA radians about the Yprime axis.
c
      if( nterms2 .ge. 30 ) then
         call rotviaproj(nd,-theta,nterms2,nterms2,nterms2,mptemp,
     1          nterms2,marray,ldc)
      else
         call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,mptemp,
     1          nterms2,marray,ldc)
      endif
c
c----- rotate back PHI radians about the Z-axis in the above system.
c
      do l=0,nterms2
         do m=-l,l
            do idim=1,nd
               local(idim,l,m)=local(idim,l,m) + 
     1             ephi(-m)*marray(idim,l,m)
            enddo
         enddo
      enddo


      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine h3dmploczshift
     $     (nd,zk,mpole,scale,lmp,nterms,local,
     1      scale2,lmpn,nterms2,radius,zshift,xnodes,wts,nquad,
     2      ynm,ynmd,mp2,phitemp,phitempn,fhs,fhder,fjs,fjder)
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a local expansion centered at (0,0,zhift).
c     The expansion is rescaled to that of the local expansion.
c
C---------------------------------------------------------------------
c     INPUT:
c
c     nd       : number of expansions
c     zk       : Helmholtz parameter
c     mpole    : coefficients of original multipole exp.
c     scale    : scale parameter for mpole
c     lmp      : leading dim of mpole (may be a work array)
c     nterms   : number of terms in original expansion
c
c     scale2   : scale parameter for local
c     lmpn     : leading dim of local (may be a work array)
c     nterms2  : number of terms in output local exp.
c     radius   : radius of sphere about new center on which field
c                is evaluated
c     zshift   : shifting distance along z-axis
c                             (always assumed positive)
C     xnodes  = Legendre nodes (precomputed)
C     wts     = Legendre weights (precomputed)
C     nquad   = number of quadrature nodes in theta direction.
c
C---------------------------------------------------------------------
c     OUTPUT:
c
c     local    : coefficients of shifted local exp.
c
C---------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      integer *8 nterms,nterms2,nquad,nd,lmp,lmpn
      integer *8 l,lw,m,jnew,knew
      real *8 zshift
      real *8 xnodes(*),wts(*)
      real *8 ynm(0:nterms,0:nterms)
      real *8 ynmd(0:nterms,0:nterms)
      complex *16 phitemp(nd,nquad,-nterms:nterms)
      complex *16 phitempn(nd,nquad,-nterms:nterms)
      complex *16 mp2(nd,0:lmpn,-lmpn:lmpn)
      complex *16 fhs(0:nterms)
      complex *16 fhder(0:nterms)
      complex *16 fjs(0:nterms2)
      complex *16 fjder(0:nterms2)
      complex *16 mpole(nd,0:lmp,-lmp:lmp),zk
      complex *16 local(nd,0:lmpn,-lmpn:lmpn)
c
c     local allocated workspace array
c
      real *8, allocatable :: rat1(:,:),rat2(:,:)
c

        ldc = max(nterms,nterms2)
        allocate(rat1(0:ldc,0:ldc))
        allocate(rat2(0:ldc,0:ldc))
C
C----- shift along z-axis by evaluating field on target sphere and
C     projecting onto spherical harmonics and scaling by j_n(kR).
C
      call h3dmpevalsphere(nd,mpole,zk,scale,zshift,radius,
     2     nterms,lmp,ynm,ynmd,phitemp,phitempn,nquad,xnodes,
     3     fhs,fhder,rat1,rat2)
      call h3dprojloc
     $   (nd,nterms2,lmpn,nquad,nterms,xnodes,wts,
     1     phitemp,phitempn,local,mp2,ynm,rat1,rat2)
      call h3drescaleloc(nd,nterms2,lmpn,local,mp2,radius,zk,scale2,
     2     fjs,fjder)

      return
      end
c      
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dlocloc(nd,wavek,sc1,x0y0z0,locold,nterms,
     1           sc2,xnynzn,local,nterms2,
     2           radius,xnodes,wts,nquad)
C***********************************************************************
C
C
C     Usage:
C
C           Shift center of a local expansion and add to output local
C           expansion.
C           This is a reasonably fast "point and shoot" version which
C           first rotates the coordinate system, then shifts along
C           the Z-axis, and then rotates back to the original
C           coordinates.
C           
C           NOTE: the output local expansion is not initialized
C              in this routine and the shifted 
C              local expansion is directly added to it
C
C     Input:
C
C           nd     = number of local expansions
C           wavek  = Helmholtz parameter
C           sc1     = scaling parameter for locold expansion
C           x0y0z0 = center of original expansion
C           locold  = coefficients of original expansion
C           nterms = order of original expansion
C           sc2     = scaling parameter for local expansion
C           xnynzn = center of shifted expansion
C
C           nterms2 = order of shifted expansion
C           radius  = radius of sphere on which local expansion is
C                     computed
C           xnodes  = Legendre nodes (precomputed)
C           wts     = Legendre weights (precomputed)
C           nquad   = number of quadrature nodes used (really nquad**2)
C                     should be about 2*nterms2
C
C     Output:
C
C           local = coefficients of shifted expansion
C
C***********************************************************************
      implicit none
     
c
cc      calling sequence variables
c
      integer *8 nterms,nterms2,nquad,nd
      real *8 x0y0z0(3),xnynzn(3)
      real *8 xnodes(nquad),wts(nquad),radius
      real *8 sc1,sc2
      complex *16 locold(nd,0:nterms,-nterms:nterms)
      complex *16 local(nd,0:nterms2,-nterms2:nterms2)
      complex *16 wavek
c
cc      temporary variables
c
      complex *16, allocatable :: marray(:,:,:),marray1(:,:,:)
      complex *16, allocatable :: mptemp(:,:,:),mp2(:,:,:)
      complex *16, allocatable :: ephi(:),phitemp(:,:,:)
      complex *16, allocatable :: phitempn(:,:,:)
      complex *16, allocatable :: fjs(:),fjder(:)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16 imag, ephi1

      integer *8  nq, ldc,idim
      real *8 rshift
      real *8 d,theta,ctheta,phi,rvec(3)
      integer *8  l,m,jnew,knew
c
      data imag/(0.0d0,1.0d0)/
C
      ldc = max(nterms,nterms2)
      nq = max(nquad,2*ldc+2)

      allocate(marray(nd,0:ldc,-ldc:ldc))
      allocate(mp2(nd,0:ldc,-ldc:ldc))
      allocate(marray1(nd,0:nterms,-nterms:nterms))
      allocate(mptemp(nd,0:nterms2,-nterms2:nterms2))
      allocate(ephi(-ldc-1:ldc+1))
      allocate(phitemp(nd,nq,-ldc:ldc))
      allocate(phitempn(nd,nq,-ldc:ldc))
      allocate(ynm(0:ldc,0:ldc),ynmd(0:ldc,0:ldc))

      allocate(fjs(0:ldc),fjder(0:ldc))
C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)
      call cart2polar(rvec,d,theta,phi)
c
      ephi1 = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(1)=ephi1
      ephi(-1)=dconjg(ephi1)
c
c----- create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo
c
c
c      a rotation of THETA radians about the Yprime-axis after PHI
c      radians about the z-axis.
c      The PHI rotation is carried out on the fly by multiplying 
c      locold and ephi inside the following loop. 
c

      
      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               marray1(idim,l,m) = locold(idim,l,m)*ephi(m)
            enddo
         enddo
      enddo
      do l=0,nterms2
         do m=-l,l
            do idim=1,nd
               mptemp(idim,l,m)=0.0d0
            enddo
         enddo
      enddo

      if( nterms .ge. 30 ) then
         call rotviaproj(nd,theta,nterms,nterms,nterms2,marray1,
     1      nterms,marray,ldc)
      else
         call rotviarecur(nd,theta,nterms,nterms,nterms2,marray1,
     1         nterms,marray,ldc)
      endif
c
c----- shift the local expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      rshift = d
       call h3dlocloczshift(nd,wavek,sc1,marray,ldc,nterms,sc2,mptemp,
     1       nterms2,nterms2,radius,rshift,xnodes,wts,nquad,ynm,ynmd,
     2       mp2,phitemp,phitempn,fjs,fjder)


c
c      reverse THETA rotation.
c      I.e. rotation of -THETA about Yprime axis.
c
      if( nterms2 .ge. 30 ) then
         call rotviaproj(nd,-theta,nterms2,nterms2,nterms2,mptemp,
     1         nterms2,marray,ldc)
      else
         call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,mptemp,
     1         nterms2,marray,ldc)
      endif
c
c----- rotate back PHI radians about the Z-axis in the above system.
c
      do l=0,nterms2
         do m=-l,l
            do idim=1,nd
               local(idim,l,m)=local(idim,l,m) + 
     1            ephi(-m)*marray(idim,l,m)
            enddo
         enddo
      enddo

      return
      end
c
c
c
c
c***********************************************************************
      subroutine h3dlocloczshift
     $     (nd,zk,scale,locold,lmp,nterms,scale2,
     1      local,lmpn,nterms2,radius,zshift,xnodes,wts,nquad,
     2      ynm,ynmd,mp2,phitemp,phitempn,fjs,fjder) 
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a local expansion centered at (0,0,zhift).
c     The expansion is rescaled to that of the local expansion.
c
c     INPUT:
c
c     nd       : number of local expansions
c     zk       : Helmholtz parameter
c     scale    : scaling parameter for locold
c     locold   : coefficients of original multipole exp.
c     lmp      : leading dim of locold (may be a work array)
c     nterms   : number of terms in the orig. expansion
c     scale2   : scaling parameter for output expansion (local)
c
c     lmpn     : leading dim of local (may be a work array)
c     nterms2  : number of terms in output local exp.
C     radius   : radius of sphere on which local expansion is
C                computed
c     zshift   : shifting distance along z-axis (assumed positive)
C     xnodes   : Legendre nodes (precomputed)
C     wts      : Legendre weights (precomputed)
C     nquad    : number of quadrature nodes used (really nquad**2)
C                     should be about 2*nterms2
c
c     OUTPUT:
c
c     local    : coefficients of shifted local exp.
c     ier      : error return code
c                 CURRENTLY NOT USED
c
c***********************************************************************
      implicit real *8 (a-h,o-z)
      integer *8 nterms,nterms2,nquad,ier,l,lw,m,jnew,knew,nd
      integer *8 lmp,lmpn
      real *8 zshift
      real *8 xnodes(nquad),wts(nquad)
      real *8 ynm(0:lmp,0:lmp)
      real *8 ynmd(0:lmp,0:lmp)
      complex *16 phitemp(nd,nquad,-nterms2:nterms2)
      complex *16 phitempn(nd,nquad,-nterms2:nterms2)
      complex *16 mp2(nd,0:lmp,-lmp:lmp)
      complex *16 fjs(0:lmp)
      complex *16 fjder(0:lmp)
      complex *16 locold(nd,0:lmp,-lmp:lmp),zk
      complex *16 local(nd,0:lmpn,-lmpn:lmpn)
c
c     local allocated workspace arrays - no more passed workspace
c
      real *8, allocatable :: w(:)
c
        
        ldc = max(nterms,nterms2)
        irat1=1
        lrat1=(ldc+1)**2
        irat2=irat1+lrat1
        lrat2=(ldc+1)**2
        lused=irat2+lrat2
        allocate (w(lused))
C
C
C----- shift along z-axis by evaluating field on target sphere and
C     projecting onto spherical harmonics and scaling by j_n(kR).
C
C    OPTIMIZATION NOTES:
C
C    Suppose you are shifting from a very large sphere to a very
C    small sphere (nterms >> nterms2).
C    Then, ALONG THE Z-AXIS, the number of azimuthal modes that
C    need to be computed is only nterms2 (not nterms). 
C    Subroutines h3dlocevalspherestab, h3dprojlocsepstab allow for this.
C
C    cost is (nterms2^2 x nterms) rather than (nterms2 x nterms^2)
C
C
C

      call h3dlocevalsphere(nd,locold,zk,scale,
     1      zshift,radius,nterms,nterms2,
     1     lmp,ynm,ynmd,phitemp,phitempn,nquad,xnodes,fjs,
     1     fjder,w(irat1),w(irat2))

      call h3dprojloc
     $   (nd,nterms2,lmpn,nquad,nterms2,xnodes,wts,
     1     phitemp,phitempn,local,mp2,ynm,w(irat1),w(irat2))

      call h3drescaleloc(nd,nterms2,lmpn,local,mp2,
     1      radius,zk,scale2,fjs,fjder)
      


      return
      end
C
C

program test_hfmm3d_adjoint

  implicit double precision (a-h,o-z)

  double precision :: center0(3), center1(3)
  double precision :: xnodes(10000), wts(10000)
  
  double complex :: zk, ima, zrat, zrat1

  double complex, allocatable :: mpole0(:,:,:), mpole1(:,:,:)
  double complex, allocatable :: mpmpmat(:,:,:,:)
  double complex, allocatable :: loclocmat(:,:,:,:)
  

  ima = (0,1)
  done = 1
  pi = 4*atan(done)

  !
  ! initialize printing routine
  !
  call prini(6,13)

  ! set the vectorization parameter
  nd = 1

  ! --------------
  ! construct the transpose operator for mp2mp
  !
  nterms0 = 20
  nterms1 = nterms0
  allocate( mpole0(nd,0:nterms0,-nterms0:nterms0) )
  allocate( mpole1(nd,0:nterms1,-nterms1:nterms1) )

  do m = -nterms0,nterms0
    do l = 0,nterms0
      do i = 1,nd
        mpole0(i,l,m) = 0
      end do
    end do
  end do

  do m = -nterms1,nterms1
    do l = 0,nterms1
      do i = 1,nd
        mpole1(i,l,m) = 0
      end do
    end do
  end do
  
  center0(1) = .5d0
  center0(2) = .5d0
  center0(3) = .5d0

  center1(1) = 1
  center1(2) = 1
  center1(3) = 1

  dlam = 1
  zk = 2*pi*dlam + ima/10000

  ! now construct the translation matrix directly

  sc0 = 1
  sc1 = 1
  radius = sqrt(3.0d0)*2

  nquad = nterms1*10
  nquad = max(6,nquad)
  ifinit = 1
  call legewhts(nquad, xnodes, wts, ifinit)

  allocate( mpmpmat(0:nterms1,-nterms1:nterms1,0:nterms0, &
      -nterms0:nterms0) )

  do m0 = -nterms0,nterms0
    do l0 = 0,nterms0
      do m1 = -nterms1,nterms1
        do l1 = 0,nterms1
          mpmpmat(l1,m1,l0,m0) = 0
        end do
      end do
    end do
  end do
  
  
  do l0 = 0,nterms0
    do m0 = -l0,l0
      mpole0(1,l0,m0) = 1
      call h3dmpmp(nd, zk, sc0, center0, mpole0, nterms0, &
          sc1, center1, mpole1, nterms1, &
          radius, xnodes, wts, nquad)
      mpole0(1,l0,m0) = 0

      do l1 = 0,nterms1
        do m1 = -l1,l1
          mpmpmat(l1,m1,l0,m0) = mpole1(1,l1,m1)
        end do
      end do

    end do
  end do

  ll0 = 1
  mm0 = 1
  ll1 = 2
  mm1 = 1
  call prin2('from mpmpmat, entry = *', mpmpmat(ll1,mm1,ll0,mm0), 2)
  !call prin2('from mpmpmat, entry+1 = *', mpmpmat(ll1+1,mm1,ll0,mm0), 2)


  ! now do the locloc mat

  allocate( loclocmat(0:nterms0,-nterms0:nterms0,0:nterms1, &
      -nterms1:nterms1) )

  do m1 = -nterms1,nterms1
    do l1 = 0,nterms1
      do m0 = -nterms0,nterms0
        do l0 = 0,nterms0
          loclocmat(l0,m0,l1,m1) = 0
        end do
      end do
    end do
  end do

  ! zero out the mpole expansions again
  do m = -nterms0,nterms0
    do l = 0,nterms0
      do i = 1,nd
        mpole0(i,l,m) = 0
      end do
    end do
  end do

  do m = -nterms1,nterms1
    do l = 0,nterms1
      do i = 1,nd
        mpole1(i,l,m) = 0
      end do
    end do
  end do

  
  ! construct the locloc matrix
  radius = sqrt(3.0d0)
  do l1 = 0,nterms1
    do m1 = -l1,l1
      mpole0(1,l1,m1) = 1
      !call h3dlocloc(nd, zk, sc1, center1, mpole1, nterms1, &
      !    sc0, center0, mpole0, nterms0, &
      !    radius, xnodes, wts, nquad)
      call h3dlocloc(nd, zk, sc0, center0, mpole0, nterms0, &
          sc1, center1, mpole1, nterms1, &
          radius, xnodes, wts, nquad)
      mpole0(1,l1,m1) = 0

      do l0 = 0,nterms0
        do m0 = -l0,l0
          loclocmat(l0,m0,l1,m1) = mpole1(1,l0,m0)
        end do
      end do
      
    end do
  end do

  call prin2('from loclocmat, entry = *',  &
      loclocmat(ll1,mm1,ll0,mm0), 2)

  zrat = mpmpmat(ll1,mm1,ll0,mm0)/loclocmat(ll1,mm1,ll0,mm0)
      
  ! call prin2('from loclocmat, transpose entry = *', &
  !     loclocmat(ll0,mm0,ll1,mm1), 2)

  ! call prin2('from loclocmat, transpose entry+1 = *', &
  !     loclocmat(ll0,mm0,ll1+1,mm1), 2)

  !zrat = mpmpmat(ll1,mm1,ll0,mm0)/loclocmat(ll0,mm0,ll1,mm1)
  !zrat1 = mpmpmat(ll1+1,mm1,ll0,mm0)/loclocmat(ll0,mm0,ll1+1,mm1)

  call prin2('ratio = *', zrat, 2)
  !call prin2('ratio1 = *', zrat1, 2)
  
  stop
end program 



! ----------------------------------------------------------
! 
! This is the end of the debugging code.
!
! ----------------------------------------------------------
subroutine prinmp(str, mpole, nterms)
  implicit double precision (a-h,o-z)
  character (len=*) :: str
  double complex :: mpole(0:nterms, -nterms:nterms)
  double complex :: tmp(-10000:10000)

  print *, trim(str)

  do n = 0,nterms
    print *
    write(6,'(a,i2,a,i2,a,i2)') 'n = ', n, '  m = ', -n, '...', n
    do m = -nterms,nterms
      tmp(m) = mpole(n,m)
    end do
    call prin2('coefs = *', tmp(-n), 2*n+1)
  end do
  
  return
end subroutine prinmp



subroutine zinitialize(len, zs)
  implicit double precision (a-h,o-z)
  double complex :: zs(len)

  do i = 1,len
    zs(i) = 0
  end do
  return
end subroutine zinitialize





subroutine comperr_vec(nd,zk,ns,source,ifcharge,charge,ifdipole, &
    dipvec,ifpgh,pot,grad,nt,targ,ifpghtarg,pottarg, &
    gradtarg,ntest,err)

  implicit none
  double complex zk
  integer ns,nt,ifcharge,ifdipole,ifpgh,ifpghtarg

  double precision source(3,*),targ(3,*)
  double complex dipvec(nd,3,*)
  double complex charge(nd,*)

  double complex pot(nd,*),pottarg(nd,*),grad(nd,3,*), &
      gradtarg(nd,3,*)

  integer i,j,ntest,nd,idim

  double precision err,ra

  double complex potex(nd,ntest),gradex(nd,3,ntest), &
      pottargex(nd,ntest),gradtargex(nd,3,ntest)

  double precision thresh

  err = 0 
  do i=1,ntest
    do idim=1,nd
      potex(idim,i) = 0
      pottargex(idim,i) = 0

      gradex(idim,1,i) = 0
      gradex(idim,2,i) = 0
      gradex(idim,3,i) = 0

      gradtargex(idim,1,i) = 0
      gradtargex(idim,2,i) = 0
      gradtargex(idim,3,i) = 0
    enddo
  enddo

  thresh = 1.0d-16

  if(ifcharge.eq.1.and.ifdipole.eq.0) then
    if(ifpgh.eq.1) then
      call h3ddirectcp(nd,zk,source,charge,ns,source,ntest, &
          potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectcg(nd,zk,source,charge,ns,source,ntest, &
          potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectcp(nd,zk,source,charge,ns,targ,ntest, &
          pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectcg(nd,zk,source,charge,ns,targ,ntest, &
          pottargex,gradtargex,thresh)
    endif
  endif

  if(ifcharge.eq.0.and.ifdipole.eq.1) then
    if(ifpgh.eq.1) then
      call h3ddirectdp(nd,zk,source,dipvec, &
          ns,source,ntest,potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectdg(nd,zk,source,dipvec, &
          ns,source,ntest,potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectdp(nd,zk,source,dipvec, &
          ns,targ,ntest,pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectdg(nd,zk,source,dipvec, &
          ns,targ,ntest,pottargex,gradtargex,thresh)
    endif
  endif

  if(ifcharge.eq.1.and.ifdipole.eq.1) then
    if(ifpgh.eq.1) then
      call h3ddirectcdp(nd,zk,source,charge,dipvec, &
          ns,source,ntest,potex,thresh)
    endif

    if(ifpgh.eq.2) then
      call h3ddirectcdg(nd,zk,source,charge,dipvec, &
          ns,source,ntest,potex,gradex,thresh)
    endif

    if(ifpghtarg.eq.1) then
      call h3ddirectcdp(nd,zk,source,charge,dipvec, &
          ns,targ,ntest,pottargex,thresh)
    endif

    if(ifpghtarg.eq.2) then
      call h3ddirectcdg(nd,zk,source,charge,dipvec, &
          ns,targ,ntest,pottargex,gradtargex,thresh)
    endif
  endif

  err = 0
  ra = 0

  if(ifpgh.eq.1) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(potex(idim,i))**2
        err = err + abs(pot(idim,i)-potex(idim,i))**2
      enddo
    enddo
  endif

  if(ifpgh.eq.2) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(potex(idim,i))**2
        ra = ra + abs(gradex(idim,1,i))**2
        ra = ra + abs(gradex(idim,2,i))**2
        ra = ra + abs(gradex(idim,3,i))**2

        err = err + abs(pot(idim,i)-potex(idim,i))**2
        err = err + abs(grad(idim,1,i)-gradex(idim,1,i))**2
        err = err + abs(grad(idim,2,i)-gradex(idim,2,i))**2
        err = err + abs(grad(idim,3,i)-gradex(idim,3,i))**2
      enddo
    enddo
  endif


  if(ifpghtarg.eq.1) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(pottargex(idim,i))**2
        err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
      enddo
    enddo
  endif

  if(ifpghtarg.eq.2) then
    do i=1,ntest
      do idim=1,nd
        ra = ra + abs(pottargex(idim,i))**2
        ra = ra + abs(gradtargex(idim,1,i))**2
        ra = ra + abs(gradtargex(idim,2,i))**2
        ra = ra + abs(gradtargex(idim,3,i))**2

        err = err + abs(pottarg(idim,i)-pottargex(idim,i))**2
        err = err + abs(gradtarg(idim,1,i)-gradtargex(idim,1,i))**2
        err = err + abs(gradtarg(idim,2,i)-gradtargex(idim,2,i))**2
        err = err + abs(gradtarg(idim,3,i)-gradtargex(idim,3,i))**2
      enddo
    enddo
  endif

  err = sqrt(err/ra)
  return
end subroutine comperr_vec

c
c
c    Subroutine library for shifting via projection     
c
C***********************************************************************
      subroutine h3drescalemp(nd,nterms,lmp,mpole,
     1           radius,zk0,scale,fhs,fhder)
C***********************************************************************
C
C     This subroutine rescales a spherical harmonic expansion
C     on the surface by h_n(zk0 * radius), converting 
C     a surface function to the corresponding Hankel expansion
C     in the exterior.
C
C---------------------------------------------------------------------
C     INPUT:
C
C           nd     = number of expansions
C           nterms = order of spherical harmonic expansion
C           mpole = coefficients of s.h. expansion
C           radius = sphere radius
C           zk0 = Helmholtz parameter
C           scale = scale parameter for expansions
C           w       = workspace of length lw
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C           mpole = rescaled by 1/h_n(zk0* radius) 
C
C---------------------------------------------------------------------
      implicit none
      integer *8 lmp
      integer *8 nterms,ier,nd,idim
      integer *8 l,m,jj,kk
      integer *8 lwfhs,ifder
      real *8 radius,scale
      complex *16 mpole(nd,0:lmp,-lmp:lmp)
      complex *16 ephi,imag,emul,sum,zmul
      complex *16 fhs(0:nterms),fhder(0:nterms)
      complex *16 zk0,z
      data imag/(0.0d0,1.0d0)/
C
      z = zk0*radius
      ifder = 0
      call h3dall(nterms,z,scale,fhs,
     1             ifder,fhder)
      do l=0,nterms
         do m=-l,l
            zmul = 1/fhs(l)
            do idim=1,nd
	          mpole(idim,l,m) = mpole(idim,l,m)*zmul
            enddo
         enddo
      enddo
      return
      end
c
C
C
C***********************************************************************
      subroutine h3drescaleloc(nd,nterms,lmp,local,localn,
     1           radius,zk0,scale,fjs,fjder)
C***********************************************************************
C
C     This subroutine takes as input the potential and its normal
C     derivative on a sphere of radius RADIUS and returns the 
C     j-expansion coefficients consist with the data (in a least
C     squares sense). That is 
C
C           phi  = sum local(n,m) j_n Y_n^m  ->
C           phin = sum local(n,m) zk0 *j_n' Y_n^m and
C
C           local(n,m) * j_n        = phi_n^m
C           local(n,m) * j_n' *zk0  = phin_n^m
C
C     The 1x1 normal equations are:
C
C           local(n,m)* ( j_n**2 + (zk0* j_n')**2) = 
C                 
C                          j_n * phi_n^m + zk0 * j_n' * phin_n^m.
C                   
C---------------------------------------------------------------------
C     INPUT:
C
C           nd     = number of local expansions
C           nterms = order of spherical harmonic expansion
C           local = coefficients of s.h. expansion of phi
C           localn = coefficients of s.h. expansion of dphi/dn
C           radius = sphere radius
C           zk0 = Helmholtz parameter
C           scale = scale parameter for expansions
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C           local = computed as above.
C
C---------------------------------------------------------------------
      implicit none
      integer *8 nterms,ier,nd,idim
      integer *8 lmp
      integer *8 l,m,jj,kk
      integer *8 lwfhs,ifder
      real *8 radius,scale
      complex *16 fjs(0:nterms)
      complex *16 fjder(0:nterms)
      complex *16 local(nd,0:lmp,-lmp:lmp)
      complex *16 localn(nd,0:lmp,-lmp:lmp)
      complex *16 ephi,imag,emul,sum,zmul
      complex *16 zk0,z,zh,zhn
      data imag/(0.0d0,1.0d0)/
C
C
      z = zk0*radius
      ifder = 1
      call besseljs3d(nterms,z,scale,fjs,ifder,fjder)
c
      do l=0,nterms
        do m=-l,l
          zh = fjs(l)
          zhn = fjder(l)*zk0
          zmul = 1/(zh*zh + zhn*zhn)
          do idim=1,nd
            local(idim,l,m) = (zh*local(idim,l,m) + 
     1           zhn*localn(idim,l,m))*zmul
          enddo
        enddo
      enddo

      return
      end
c
C
C
C
C
C
C
C
C***********************************************************************
      subroutine h3dlocevalsphere(nd,local,zk,scale,zshift,radius,
     1           nterms,nterms2,lmp,ynm,ynmd,phitemp,phitempn,
     2           nquad,xnodes,fjs,fjder,rat1,rat2)
C***********************************************************************
C
C     This subroutine evaluates a local expansion on a target
C     sphere at a distance (0,0,zshift) from the origin of radius 
C     "radius".
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd       : number of local expansions
C     local    : coefficients of original multipole exp.
C     zk       : Helmholtz parameter
C     scale    : scaling parameter
C     zshift   : shift distance along z-axis.
C     radius   : radius of sphere about (0,0,zshift)
C                              where phival is computed.
C     nterms   : number of terms in the orig. expansion
C     nterms2  : number of terms in exp on target sphere
C     lmp      : dimension param for local expansion
C     ynm      : storage for Ynm out to nterms.
C     nquad    : number of quadrature nodes
C                              on target sphere is nquad*nquad.
C     xnodes   : Legendre nodes x_j = cos theta_j.
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     phitemp(k,i,j)  : jth mode of phi at ith quad node, for kth expansion 
C     phitempn(k,i,j) : jth mode of phi at ith quad node, for kth expansion
C
C***********************************************************************
      implicit none
      integer *8 lmp,ier
      integer *8 nterms,nd,idim,nterms2,nquad
      integer *8 l,m,jnew,knew,jj,n,ifder,iffld
      real *8 radius,scale
      real *8 zshift, targ(3), center(3)
      real *8 xnodes(nquad)
      real *8 ynm(0:nterms,0:nterms)
      real *8 ynmd(0:nterms,0:nterms)
      real *8 ctheta,cthetaj,rj,rn,stheta,pi,sthetaj
      real *8 thetan
      complex *16 local(nd,0:lmp,-lmp:lmp)
      complex *16 phitemp(nd,nquad,-nterms2:nterms2)
      complex *16 phitempn(nd,nquad,-nterms2:nterms2)
      complex *16 imag,pot,fld(3), zk,z,uval,unval,ur,utheta
      complex *16 ephi1,ephik,ephi,fjs(0:nterms),fjder(0:nterms),ztmp1
      complex *16 ut1,ut2,ut3
      real *8 rat1(0:nterms,0:nterms),rat2(0:nterms,0:nterms)
      data imag/(0.0d0,1.0d0)/
C
C----- shift along z-axis.
C      note that everything is scaled.
C
      ier = 0
      pi = 4.0d0*datan(1.0d0)
      center(1) = 0.0d0
      center(2) = 0.0d0
      center(3) = 0.0d0
      iffld = 1
      ifder = 1
      do jj=1,nquad
        do m=-nterms2,nterms2
          do idim=1,nd
            phitemp(idim,jj,m) = 0.0d0
            phitempn(idim,jj,m) = 0.0d0
          enddo
        enddo
      enddo
      call ylgndrini(nterms,rat1,rat2)
      do jj=1,nquad
        ctheta = xnodes(jj)
        stheta = dsqrt(1.0d0 - ctheta**2)
        rj = (zshift+ radius*ctheta)**2 + (radius*stheta)**2
        rj = dsqrt(rj)
        cthetaj = (zshift+radius*ctheta)/rj
        sthetaj = dsqrt(1.0d0-cthetaj**2)
        rn = sthetaj*stheta + cthetaj*ctheta
        thetan = (cthetaj*stheta - sthetaj*ctheta)/rj
        z = zk*rj
        call ylgndr2sf(nterms,cthetaj,ynm,ynmd,rat1,rat2)
        call besseljs3d(nterms,z,scale,fjs,ifder,fjder)
	    do n = 0,nterms
	      fjder(n) = fjder(n)*zk
        enddo
	    do n = 1,nterms
	      do m = 1,n
	        ynm(n,m) = ynm(n,m)*sthetaj
          enddo
        enddo

        ztmp1 = fjder(0)*rn
        do idim=1,nd
          phitemp(idim,jj,0) = local(idim,0,0)*fjs(0)
          phitempn(idim,jj,0) = local(idim,0,0)*ztmp1
        enddo

        do n=1,nterms
          ztmp1 = fjs(n)*ynm(n,0)
          ut1 = fjder(n)*rn
          ut2 = fjs(n)*thetan
          ut3 = ut1*ynm(n,0)-ut2*ynmd(n,0)*sthetaj

          do idim=1,nd
            phitemp(idim,jj,0) = phitemp(idim,jj,0) +
     1                  local(idim,n,0)*ztmp1
            phitempn(idim,jj,0) = phitempn(idim,jj,0)+
     1          ut3*local(idim,n,0)
          enddo
c
          do m=1,min(n,nterms2)
c
            ztmp1 = fjs(n)*ynm(n,m)
            ut3 = ut1*ynm(n,m)-ut2*ynmd(n,m)

            do idim=1,nd
              phitemp(idim,jj,m) = phitemp(idim,jj,m) + 
     1                local(idim,n,m)*ztmp1
              phitemp(idim,jj,-m) = phitemp(idim,jj,-m) +
     1                local(idim,n,-m)*ztmp1
              phitempn(idim,jj,m) = phitempn(idim,jj,m) +
     1             ut3*local(idim,n,m)
              phitempn(idim,jj,-m) = phitempn(idim,jj,-m) + 
     1             ut3*local(idim,n,-m)
            enddo
          enddo
        enddo
      enddo
c
      return
      end
C
C
C
C
c
c
c
C***********************************************************************
      subroutine h3dmpevalsphere(nd,mpole,zk,scale,zshift,
     1           radius,nterms,lmp,ynm,ynmd,phitemp,phitempn,
     2           nquad,xnodes,fhs,fhder,rat1,rat2)
C***********************************************************************
C
C     This subroutine evaluates a multipole expansion on a target
C     sphere at a distance (0,0,zshift) from the origin of radius 
C     "radius".
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd       : number of multipole expansions
C     mpole    : coefficients of original multipole exp.
C     zk       : Helmholtz parameter
C     scale    : mpole scaling parameter
C     zshift   : shift distance along z-axis.
C     radius   : radius of sphere about (0,0,zshift)
C                              where phival is computed.
C     nterms   : number of terms in the orig. expansion
C     lmp      : dimension param for mpole
C     ynm      : storage for assoc Legendre functions
C     ynmd     : storage for derivs of assoc Legendre functions
C     nquad    : number of quadrature nodes in theta
C     xnodes   : Legendre nodes x_j = cos theta_j.
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     phitemp  : nquad by (-nterms,nterms)
C     phitempn : nquad by (-nterms,nterms)
C
C---------------------------------------------------------------------
      implicit none
      integer *8 lmp,n
      integer *8 nterms,nd,idim
      integer *8 l,m,jnew,knew,nquad
      integer *8 ifder,iffld,i,jj
      real *8 zshift, targ(3), center(3)
      real *8 xnodes(nquad)
      real *8 ynm(0:nterms,0:nterms)
      real *8 ynmd(0:nterms,0:nterms)
      real *8 radius,scale
      real *8 ctheta,cthetaj,pi,rj,rn,stheta,sthetaj,thetan
      complex *16 mpole(nd,0:lmp,-lmp:lmp)
      complex *16 phitemp(nd,nquad,-nterms:nterms)
      complex *16 phitempn(nd,nquad,-nterms:nterms)
      complex *16 imag,pot,fld(3), zk,z,uval,unval,ur,utheta,ut1,ut2
      complex *16 ut3,ephi1,ephik,ephi,fhs(0:nterms),fhder(0:nterms)
      complex *16 ztmp1
      real *8 rat1(0:nterms,0:nterms),rat2(0:nterms,0:nterms)
      data imag/(0.0d0,1.0d0)/
C
C----- shift along z-axis.
C      note that everything is scaled.
C
      pi = 4.0d0*datan(1.0d0)
      center(1) = 0.0d0
      center(2) = 0.0d0
      center(3) = 0.0d0
      iffld = 1
      ifder = 1
      do jj=1,nquad
        do m=-nterms,nterms
          do idim=1,nd
            phitemp(idim,jj,m) = 0.0d0
            phitempn(idim,jj,m) = 0.0d0
          enddo
        enddo
      enddo
      call ylgndrini(nterms,rat1,rat2)
      do jj=1,nquad
	    ctheta = xnodes(jj)
	    stheta = dsqrt(1.0d0 - ctheta**2)
        rj = (zshift+ radius*ctheta)**2 + (radius*stheta)**2
        rj = dsqrt(rj)
	    cthetaj = (zshift+radius*ctheta)/rj
	    sthetaj = dsqrt(1.0d0 - cthetaj**2)
	    rn = sthetaj*stheta + cthetaj*ctheta
	    thetan = (cthetaj*stheta - ctheta*sthetaj)/rj
	    z = zk*rj
	    call ylgndr2sf(nterms,cthetaj,ynm,ynmd,rat1,rat2)
	    call h3dall(nterms,z,scale,fhs,ifder,fhder)
        do i = 0,nterms
	      fhder(i) = fhder(i)*zk
        enddo
        do n=1,nterms
	      do m = 1,n
  	        ynm(n,m) = ynm(n,m)*sthetaj
          enddo
        enddo

        ztmp1 = fhder(0)*rn

        do idim=1,nd
          phitemp(idim,jj,0) = mpole(idim,0,0)*fhs(0)
          phitempn(idim,jj,0) = mpole(idim,0,0)*ztmp1
        enddo
	    do n=1,nterms
          ztmp1 = fhs(n)*ynm(n,0)
	      ut1 = fhder(n)*rn
	      ut2 = fhs(n)*thetan
	      ut3 = ut1*ynm(n,0)-ut2*ynmd(n,0)*sthetaj

          do idim=1,nd
            phitemp(idim,jj,0) = phitemp(idim,jj,0) +
     1                  mpole(idim,n,0)*ztmp1
	        phitempn(idim,jj,0) = phitempn(idim,jj,0) + 
     1          ut3*mpole(idim,n,0)
          enddo 
          do m=1,n
	        ztmp1 = fhs(n)*ynm(n,m)
	        ut3 = ut1*ynm(n,m)-ut2*ynmd(n,m)
            do idim=1,nd
  	          phitemp(idim,jj,m) = phitemp(idim,jj,m) +
     1                   mpole(idim,n,m)*ztmp1
	          phitemp(idim,jj,-m) = phitemp(idim,jj,-m) +
     1                   mpole(idim,n,-m)*ztmp1
	          phitempn(idim,jj,m) = phitempn(idim,jj,m) + 
     1            ut3*mpole(idim,n,m)
	          phitempn(idim,jj,-m) = phitempn(idim,jj,-m) + 
     1             ut3*mpole(idim,n,-m)
             enddo
	      enddo
	    enddo
      enddo
c
      return
      end
C
C
C
C
C
C
C***********************************************************************
      subroutine h3dprojloc(nd,nterms,ldl,nquadn,ntold,xnodes,wts,
     1           phitemp,phitempn,local,local2,ynm,rat1,rat2)
C***********************************************************************
C
C     compute spherical harmonic expansion on unit sphere
C     of function tabulated at nquadn*nquadm grid points.
C
C---------------------------------------------------------------------
C     INPUT:
C
C           nd = number of expansions
C           nterms = order of spherical harmonic expansion
C           ldl = order of spherical harmonic expansion
C           nquadn = number of quadrature nodes in polar angle (theta).
C           ntold = number of modes in azimuthal direction.
C           xnodes = quad nodes in theta (polar angle) - nquadn of them
C           wts  = quad weights in theta (polar angle)
C           phitemp, phitempn = tabulated function and normal deriv
C                    phitemp(i,j) = jth mode of phi at ith quad node.
C                    phivaln(i,j) = jth mode of phi at ith quad node.
C
C           marray  = workspace 
C           ynm     = workspace for assoc Legendre functions
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C           local  = coefficients of s.h. expansion for phi
C           local2 = coefficients of s.h. expansion for dphi/dn
C
C    NOTE:
C
C    yrecursion.f produces Ynm with a nonstandard scaling:
C    (without the 1/sqrt(4*pi)). Thus the orthogonality relation
C    is
C             \int_S  Y_nm Y_n'm'*  dA = delta(n) delta(m) * 4*pi. 
C
C   In the first loop below, you see
C
C	    marray(jj,m) = sum/(2*nquad)
C
C   The latter has incorporated the 1/(4*pi) normalization factor
C   into the azimuthal quadrature weight (2*pi/nquad).
C
C---------------------------------------------------------------------
      implicit none
      integer *8 nterms,nquadn,nquadm,ier,nd,idim
      integer *8 l,m,jj,kk,ntold,ldl,n
      real *8 wts(nquadn),xnodes(nquadn)
      real *8 ynm(0:nterms,0:nterms)
      real *8 cthetaj,pi
      complex *16 zk
      complex *16 local(nd,0:ldl,-ldl:ldl)
      complex *16 local2(nd,0:ldl,-ldl:ldl)
      complex *16 phitemp(nd,nquadn,-ntold:ntold)
      complex *16 phitempn(nd,nquadn,-ntold:ntold)
      complex *16 ephi,imag,emul,sum,emul1
      complex *16, allocatable :: zmul(:),zmul2(:)
      real *8 rat1(0:nterms,0:nterms),rat2(0:nterms,0:nterms)
      data imag/(0.0d0,1.0d0)/
C
      pi = 4.0d0*datan(1.0d0)

      allocate(zmul(nd),zmul2(nd))
c
c     initialize local exp to zero
c
      do l = 0,ldl
        do m = -l,l
          do idim=1,nd
            local(idim,l,m) = 0.0d0
            local2(idim,l,m) = 0.0d0
          enddo
        enddo
      enddo
c
c     get local exp
c
c
      call ylgndrini(nterms,rat1,rat2)
      do jj=1,nquadn
        cthetaj = xnodes(jj)
        call ylgndrf(nterms,cthetaj,ynm,rat1,rat2)
        do m=-ntold,ntold
          do idim=1,nd 
            zmul(idim) = phitemp(idim,jj,m)*wts(jj)/2.0d0
            zmul2(idim) = phitempn(idim,jj,m)*wts(jj)/2.0d0
          enddo
          do l=abs(m),nterms
            do idim=1,nd
              local(idim,l,m) = local(idim,l,m) + 
     1            zmul(idim)*ynm(l,abs(m))
              local2(idim,l,m) = local2(idim,l,m) + 
     1            zmul2(idim)*ynm(l,abs(m))
            enddo
          enddo
        enddo
      enddo
c
      return
      end
c
c
c
C
C
c
c
c
c

c
c    This file contains the translation operator for the Laplacd
c      3D FMM
c
c     l3mpmp - shift center of multipole expansion
c     l3dmploc - convert multipole expansion to a local expansion
c     l3locloc - shift center of local expansion
c
c
C
c
C***********************************************************************
      subroutine l3dmpmp(nd,sc1,x0y0z0,mpole,nterms,sc2,
     1           xnynzn,mpolen,nterms2,dc,lca)
C***********************************************************************
C
C     Usage:
C
C     Shift center of multipole expansion mpole and add to output
C     This is a reasonably fast "point and shoot" version which
C     first rotates the coordinate system, then doing the shifting
C     along the Z-axis, and then rotating back to the original
C     coordinates.
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd      : number of mulitpole expansions 
C     sc1     : scaling parameter for mpole expansion
C     x0y0z0  : center of original multiple expansion
C     mpole   : coefficients of original multiple expansion
C     nterms  : order of multipole expansion
C     sc2     : scaling parameter for shifted expansion
C     xnynzn  : center of shifted expansion
C     nterms2 : order of shifted expansion
C     dc      : square root of binomial coefficients
C     lca     : length of binomial coefficients
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     mpolen  : coefficients of shifted expansion
C
C***********************************************************************
C
      implicit none
      integer *8  nterms, lw, lused, ier, nq, nquad, nquse,ldc,nterms2
      integer *8 lca
      integer *8 idim,nd
      double precision x0y0z0(3),xnynzn(3)
      double precision rshift
      double precision d,theta,ctheta,phi,sc1,sc2,rvec(3)
      double precision dc(0:lca,0:lca)
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex mpolen(nd,0:nterms2,-nterms2:nterms2)
      double complex, allocatable :: marray1(:,:,:)
      double complex, allocatable :: marray(:,:,:)
      double complex, allocatable :: ephi(:)
c
      double complex imag
      integer *8  l,m,jnew,knew
      data imag/(0.0d0,1.0d0)/
C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)
      call cart2polar(rvec,d,theta,phi)

      ldc = max(nterms,nterms2)
      allocate(marray1(nd,0:ldc,-ldc:ldc))
      allocate(marray(nd,0:ldc,-ldc:ldc))
      allocate(ephi(-ldc-1:ldc+1))

c
      ephi(1) = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(-1)=dconjg(ephi(1))
c
c----- create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo
c
c----- a rotation of THETA radians about the Yprime axis after PHI
c      radians about the z-axis.
c      The PHI rotation is carried out on the fly by multiplying 
c      mpole and ephi inside the following loop. 
c
      do l=0,nterms
        do m=-l,l
          do idim=1,nd
            marray1(idim,l,m)=mpole(idim,l,m)*ephi(m)
          enddo
        enddo
      enddo


      if(nterms.ge.30) then
        call rotviaproj(nd,theta,nterms,nterms,nterms,marray1,
     1         ldc,marray,ldc)
      else
        call rotviarecur(nd,theta,nterms,nterms,nterms,marray1,
     1        ldc,marray,ldc)
      endif

      
c
c
c----- shift the mpole expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      rshift = d
      call l3dmpmpzshift(nd,sc1,marray,ldc,nterms,sc2,marray1,
     1           ldc,nterms2,rshift,dc,lca)
c
c
c     Reverse THETA rotation.
c     I.e. rotation of -THETA radians about Yprime axis.
c

      if(nterms2.ge.30) then
        call rotviaproj(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1        ldc,marray,ldc)
      else
        call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1        ldc,marray,ldc)
      endif
c
c
c----- rotate back PHI radians about the Z-axis in the above system.
c
      do l=0,nterms2
        do m=-l,l
          do idim=1,nd
            mpolen(idim,l,m)=mpolen(idim,l,m)+ephi(-m)*marray(idim,l,m)
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c**********************************************************************
      subroutine l3dmpmpzshift(nd,scale,mpole,lmp,nterms,scale2,mpolen,
     1      lmpn,nterms2,zshift,dc,lca)
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a multipole expansion centered at (0,0,zshift).
c     The expansion is rescaled to that of the shifted expansion.
c
c     INPUT:
c
c     nd       : number of multipole expansions
c     scale    : scale parameter for mpole
c     mpole    : coefficients of original multipole exp.
c     lmp      : leading dim of mpole (may be a work array)
c     nterms   : number of terms in the orig. expansion
c     scale2   : scale parameter for new expansion (mpolen)
c     lmpn     : leading dim of shifted (may be work array)
c     nterms2  : number of terms in output expansion
c     zshift   : shifting distance along z-axis
c                              (always assumed positive)
c     dc       : square root of binomial coefficients
c     lca      : length of binomial coefficient array
c
c     OUTPUT:
c
c     mpolen  (double complex)  : coefficients of shifted exp.
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 l0,nmax,nterms,nterms2,nquad,ier,lmp,lmpn,ldc,nd
      integer *8 lca
      integer *8 l,m,jnew,knew,i,idim
      double precision d,zshift,scale,scale2,rat
      double precision, allocatable :: rscpow(:)
      double complex mpole(nd,0:lmp,-lmp:lmp)
      double complex mpolen(nd,0:lmpn,-lmpn:lmpn)
      double precision dc(0:lca,0:lca)
      double precision, allocatable :: fr(:)
C
C----- shift along z-axis
C
      nmax = max(nterms,nterms2)
      allocate(fr(0:nmax))
c
      fr(0) = 1.0d0
      d = -zshift/scale
      fr(1) = d
      do l=2,nmax
         fr(l) = fr(l-1)*d
      enddo

      d = scale/scale2
      allocate(rscpow(nterms2))
      rscpow(1) = d
      do i=2,nterms2
        rscpow(i) = rscpow(i-1)*d
      enddo
c
      do jnew = 0,nterms2
        l0 = max(0,jnew-nterms)
        do knew = -jnew,jnew
          do idim=1,nd
            mpolen(idim,jnew,knew) = 0.0d0
          enddo
	      do l=l0,jnew-abs(knew)
            do idim=1,nd
              mpolen(idim,jnew,knew)=mpolen(idim,jnew,knew)+
     1              mpole(idim,jnew-l,knew)*fr(l)*dc(jnew-knew,l)*
     2              dc(jnew+knew,l)
            enddo
          enddo
        enddo
      enddo

      do jnew = 1,nterms2
        do knew = -jnew,jnew
          do idim=1,nd
            mpolen(idim,jnew,knew)=mpolen(idim,jnew,knew)*rscpow(jnew)
          enddo
        enddo
      enddo

      return
      end
C
c
c
c
c
C***********************************************************************
      subroutine l3dmploc(nd,sc1,x0y0z0,mpole,nterms,
     1           sc2,xnynzn,local,nterms2,dc,lca)
C***********************************************************************

C     USAGE:
C
C           Convert multipole expansion to a local expansion and add
C           to existing expansion
C           This is a reasonably fast "point and shoot" version which
C           first rotates the coordinate system, then doing the shifting
C           along the Z-axis, and then rotating back to the original
C           coordinates.
C
C---------------------------------------------------------------------
C     INPUT:
C     nd         number of multipole expansions
C     sc1        scaling parameter for mpole expansion
C     x0y0z0     center of original multiple expansion
C     mpole      coefficients of original multiple expansion
C     nterms     order of multipole expansion
C     sc2        scaling parameter for local expansion
C     xnynzn     center of shifted local expansion
C     nterms2    order of local expansion
C     dc         precomputed square roots of binomial coefficients
C     lca        length of precomputed binomial coefficients
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     local      coefficients of shifted local expansion
C---------------------------------------------------------------------
      implicit none
      integer *8 idim,nd,lca
      integer *8  nterms,ier,l,m,jnew,knew,nterms2,ldc,mp
      double precision d,theta,ctheta,phi,sc1,sc2
      double precision x0y0z0(3),xnynzn(3)
      double precision rvec(3)
      double precision rshift
      double precision dc(0:lca,0:lca)
      double complex, allocatable :: marray1(:,:,:),marray(:,:,:),
     1    ephi(:)
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex local(nd,0:nterms2,-nterms2:nterms2)
      double complex imag
      data imag/(0.0d0,1.0d0)/
C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)
      call cart2polar(rvec,d,theta,phi)
c

      ldc = max(nterms,nterms2)
      allocate(ephi(-ldc-1:ldc+1))
      allocate(marray(nd,0:ldc,-ldc:ldc),marray1(nd,0:ldc,-ldc:ldc))

      ephi(1) = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(-1)=dconjg(ephi(1))
c
c     create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo
c
c     a rotation of THETA radians about the Yprime axis after PHI
c     radians about the z-axis.
c     The PHI rotation is carried out on the fly by multiplying 
c     mpole and ephi inside the following loop. 
c
      do l=0,nterms
        do mp=-l,l
          do idim=1,nd  
            marray1(idim,l,mp) = mpole(idim,l,mp)*ephi(mp)
          enddo
        enddo
      enddo

      if(nterms.ge.30) then
        call rotviaproj(nd,theta,nterms,nterms,nterms,marray1,
     1     ldc,marray,ldc)
      else
        call rotviarecur(nd,theta,nterms,nterms,nterms,marray1,
     1     ldc,marray,ldc)
      endif
c
c
c----- shift the local expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      rshift = d
      call l3dmploczshift(nd,marray,sc1,ldc,nterms,marray1,
     1      sc2,ldc,nterms2,rshift,dc,lca)

c
c     reverse THETA rotation. 
c     I.e. rotation of -THETA radians about the Yprime axis.
c
      if(nterms.ge.30) then
        call rotviaproj(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1     ldc,marray,ldc)
      else
        call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1     ldc,marray,ldc)
      endif
c
c----- rotate back PHI radians about the Z-axis in the above system.
c
      do l=0,nterms2
        do m=-l,l
          do idim=1,nd
            local(idim,l,m)=local(idim,l,m)+ephi(-m)*marray(idim,l,m)
          enddo
        enddo
      enddo

      return
      end
c
c
c***********************************************************************
      subroutine l3dmploczshift(nd,mpole,scale,lmp,nterms,local,
     2      scale2,lmpn,nterms2,zshift,dc,lca)
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a local expansion centered at (0,0,zhift).
c     The expansion is rescaled to that of the local expansion.
c
C---------------------------------------------------------------------
c     INPUT:
c     nd       : number of multipole expansions
c     mpole    : coefficients of original multipole exp.
c     scale    : scale parameter for mpole
c     lmp      : leading dim of mpole (may be a work array)
c     nterms   : number of terms in original expansion
c
c     scale2   : scale parameter for local
c     lmpn     : leading dim of local (may be a work array)
c     nterms2  : number of terms in output local exp.
c     zshift   : shifting distance along z-axis
c                             (always assumed positive)
c     dc       : square root of binomial coefficients
c     lca      : length of dc
c
C---------------------------------------------------------------------
c     OUTPUT:
c
c     local    : coefficients of shifted local exp.
C---------------------------------------------------------------------
      implicit none
      integer *8 idim,nd,lca
      integer *8 nterms,nterms2,nquad,ier
      integer *8 l,lw,m,jnew,knew,kk,ll,msign,nmax,lmpn,lmp
      double precision scale,scale2
      double precision zshift,d
      double precision dc(0:lca,0:lca)
      double precision, allocatable :: fr(:)
      double precision, allocatable :: rscpow(:)
      double complex mpole(nd,0:lmp,-lmp:lmp)
      double complex local(nd,0:lmpn,-lmpn:lmpn)
C
C----- shift along z-axis by evaluating field on target sphere and
C     projecting onto spherical harmonics and scaling by j_n(kR).
C
      nmax = max(nterms,nterms2)
      allocate(rscpow(nmax),fr(0:2*nmax))
c
      d = 1.0d0/zshift
      fr(0) = d
      d = d*scale
      fr(1) = fr(0)*d
      do l=2,2*nmax
        fr(l) = fr(l-1)*d
      enddo

      d = scale2/scale
      rscpow(1) = d
      do l=2,nmax
        rscpow(l) = rscpow(l-1)*d
      enddo
c
      do jnew = 0,nterms2
        do knew = -jnew,jnew
          do idim=1,nd
            local(idim,jnew,knew) = 0.0d0
          enddo
          kk  =abs(knew)
          msign = (-1)**(jnew+knew)
          do l=kk,nterms
            ll=l+jnew
            do idim=1,nd
              local(idim,jnew,knew)=local(idim,jnew,knew)+
     1          mpole(idim,l,knew)*fr(ll)*dc(ll,l-knew)*
     2          dc(ll,l+knew)*msign
            enddo 
          enddo
        enddo
      enddo

      do jnew = 1,nterms2
        do knew = -jnew,jnew
          do idim=1,nd
            local(idim,jnew,knew)=local(idim,jnew,knew)*rscpow(jnew)
          enddo
        enddo
      enddo

      return
      end
C
c
c
c
c
c
C***********************************************************************
C     Local -> Local routines
C***********************************************************************
c
c
C***********************************************************************
      subroutine l3dlocloc(nd,sc1,x0y0z0,locold,nterms,sc2,
     1           xnynzn,local,nterms2,dc,lda)
C***********************************************************************
C
C     Usage:
C
C           Shifts center of a local expansion and add to existing
C           expansion
C           This is a reasonably fast "point and shoot" version which
C           first rotates the coordinate system, then doing the shifting
C           along the Z-axis, and then rotating back to the original
C           coordinates.
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd      : number of local expansions
C     sc1     : scaling parameter for locold expansion
C     x0y0z0  : center of original multiple expansion
C     locold  : coefficients of original multiple expansion
C     nterms  : order of original local expansion
C     sc2     : scaling parameter for local expansion
C     xnynzn  : center of shifted local expansion
C     nterms2 : order of new local expansion
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     local   : coefficients of shifted local expansion
C
C***********************************************************************
C
      implicit none
      integer *8 idim,lda,nd
      integer *8 nterms,ier,l,m,jnew,knew,nterms2,ldc,mp
      double precision x0y0z0(3),xnynzn(3),rvec(3)
      double precision d,theta,ctheta,phi,sc1,sc2
      double precision dc(0:lda,0:lda)
      double precision rshift
      double complex locold(nd,0:nterms,-nterms:nterms)
      double complex local(nd,0:nterms2,-nterms2:nterms2)
      double complex, allocatable :: marray(:,:,:),marray1(:,:,:),
     1                  ephi(:)
      double complex imag,ephi1
      data imag/(0.0d0,1.0d0)/
C
      rvec(1) = xnynzn(1) - x0y0z0(1)
      rvec(2) = xnynzn(2) - x0y0z0(2)
      rvec(3) = xnynzn(3) - x0y0z0(3)

      call cart2polar(rvec,d,theta,phi)

      ldc = max(nterms,nterms2)
      allocate(ephi(-ldc-1:ldc+1))

      ephi1 = exp(imag*phi)
      ephi(0)=1.0d0
      ephi(1)=ephi1
      ephi(-1)=dconjg(ephi1)
c
c----- create array of powers e^(i*m*phi).
c
      do l = 1,ldc
         ephi(l+1) = ephi(l)*ephi(1)
         ephi(-1-l) = dconjg(ephi(l+1))
      enddo

      allocate(marray(nd,0:ldc,-ldc:ldc),marray1(nd,0:ldc,-ldc:ldc))
c
c      a rotation of THETA radians about the Yprime-axis after PHI
c      radians about the z-axis.
c      The PHI rotation is carried out on the fly by multiplying 
c      locold and ephi inside the following loop. 
c
      do l=0,nterms
        do mp=-l,l
          do idim=1,nd
            marray1(idim,l,mp) = locold(idim,l,mp)*ephi(mp)
          enddo
        enddo
      enddo


      if(nterms.ge.30) then
        call rotviaproj(nd,theta,nterms,nterms,nterms,marray1,
     1     ldc,marray,ldc)
      else
        call rotviarecur(nd,theta,nterms,nterms,nterms,marray1,
     1     ldc,marray,ldc)
      endif
c
c----- shift the local expansion from X0Y0Z0 to XNYNZN along
c      the Z-axis.
c
      rshift = d
       call l3dlocloczshift(nd,sc1,marray,ldc,nterms,sc2,marray1,
     1           ldc,nterms2,rshift,dc,lda)
c
c     reverse THETA rotation. 
c     I.e. rotation of -THETA radians about the Yprime axis.
c
      if(nterms.ge.30) then
        call rotviaproj(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1     ldc,marray,ldc)
      else
        call rotviarecur(nd,-theta,nterms2,nterms2,nterms2,marray1,
     1     ldc,marray,ldc)
      endif
c
c----- rotate back PHI radians about the Z-axis in the above system.
c
      do l=0,nterms2
        do m=-l,l
          do idim=1,nd
            local(idim,l,m)=local(idim,l,m)+ephi(-m)*marray(idim,l,m)
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c***********************************************************************
      subroutine l3dlocloczshift(nd,scale,locold,lmp,nterms,scale2,
     1  local,lmpn,nterms2,zshift,dc,lda) 
c***********************************************************************
c
c     This subroutine converts a multipole expansion centered at the 
c     origin to a local expansion centered at (0,0,zhift).
c     The expansion is rescaled to that of the local expansion.
c
c     INPUT:
c
c     nd       : number of local expansions
c     scale    : scaling parameter for locold
c     locold   : coefficients of original multipole exp.
c     lmp      : leading dim of locold (may be a work array)
c     nterms   : number of terms in the orig. expansion
c
c     scale2   : scaling parameter for output expansion (local)
c     lmpn     : leading dim of local (may be a work array)
c     nterms2  : number of terms in output local exp.
c     zshift   : shifting distance along z-axis (assumed positive)
c
c     OUTPUT:
c
c     local    : coefficients of shifted local exp.
c-----------------------------------------------------------------------
      implicit none
      integer *8 idim,nd,lda
      integer *8 nmax,nterms,nterms2,nquad,ier,l,lw,m,jnew,knew
      integer *8 lmp,lmpn,ll
      double precision  zshift,d
      double precision  scale,scale2
      double precision, allocatable :: fr(:),rscpow(:)
      double complex locold(nd,0:lmp,-lmp:lmp)
      double complex local(nd,0:lmpn,-lmpn:lmpn)
      double precision dc(0:lda,0:lda)
C
C----- shift along z-axis 
C
      nmax = max(nterms,nterms2)
      
      allocate(fr(0:nmax),rscpow(nmax))
c
c
      d = zshift
      fr(0) = 1.0d0
      d = d/scale
      fr(1) = d
      do l=2,nterms
         fr(l) = fr(l-1)*d
      enddo

      d = scale2/scale
      rscpow(1) = d
      do l=2,nterms2
        rscpow(l) = rscpow(l-1)*d
      enddo

      do jnew = 0,nterms2
        do knew = -jnew,jnew
          if(jnew.le.nterms) then
            do idim=1,nd
              local(idim,jnew,knew) = locold(idim,jnew,knew)
            enddo
          else
            do idim=1,nd
              local(idim,jnew,knew) = 0.0d0 
            enddo
          endif

          do l=1,nterms-jnew
            ll = l+jnew
            do idim=1,nd
              local(idim,jnew,knew)=local(idim,jnew,knew)+
     1         locold(idim,ll,knew)*fr(l)*dc(ll+knew,l)*dc(ll-knew,l)
            enddo
          enddo
        enddo
      enddo

      do jnew = 1,nterms2
        do knew = -jnew,jnew
          do idim=1,nd
            local(idim,jnew,knew)=local(idim,jnew,knew)*rscpow(jnew)
          enddo
        enddo
      enddo

      return
      end
c

      subroutine hndiv(dbsize,eps,ns,nt,ifcharge,ifdipole,ifpgh,
     1   ifpghtarg,ndiv,idivflag)
c
c
c       this subroutine estimates ndiv and idivflag 
c       based on geometry parameters
c     
c       TODO: better way to choose ndiv based on boxsize
c
c
      implicit none
      real *8 eps,dbsize,rfac
      integer *8 ns,nt,ifcharge,ifdipole,ifpgh,ifpghtarg,ndiv
      integer *8 idivflag

      idivflag = 0
      rfac = 1.0d0
      if (dbsize.gt.8) rfac = (dbsize/8)**1.5d0

       if(eps.ge.0.5d-0) then
         ndiv = ceiling(40*rfac)
       else if(eps.ge.0.5d-1) then
         ndiv = ceiling(40*rfac)
       else if(eps.ge.0.5d-2) then
         ndiv = ceiling(40*rfac)
       else if(eps.ge.0.5d-3) then
         ndiv = ceiling(120*rfac)
       else if(eps.ge.0.5d-6) then
         ndiv = ceiling(300*rfac)
       else if(eps.ge.0.5d-9) then
         ndiv = ceiling(600*rfac)
       else if(eps.ge.0.5d-12) then
         ndiv = ceiling(900*rfac)
       else if(eps.ge.0.5d-15) then
         ndiv = ceiling(1050*rfac)
       else
         ndiv = ns+nt
       endif

       ndiv = min(ndiv,10000)

      return
      end

c
c
c
c
c   generate level restricted tree based on resolving points
c    (Currently only supports, sorting on sources, sorting on
c      targets, or sorting on sources and targets)
c
c   There is additional functionality to further subdivide
c    an existing tree based on resolving a function, 
c      this functionality tree will be added in later
c
c   This code has the following user callable routines
c      pts_tree_mem -> returns memory requirements for creating
c         a tree based on max number of sources/targets
c         in a box (tree length
c         number of boxes, number of levels)
c      pts_tree_mem_bbox -> same as pts_tree_mem, but 
c         the center and boxsize at level0 are specified. 
c         pts_tree_mem, under the hood calls pts_tree_mem_lev0.
c         The purpose of this routine is to allow a specfied 
c         bounding box, independent of input source and target
c         locations.
c      pts_tree_build -> Make the actual tree, returns centers of boxes,
c        colleague info, pts sorted on leaf boxes
c      pts_tree_build_bbox -> Same as pts_tree_build, but bounding
c        box at root level specified
c
c      iptr(1) - laddr
c      iptr(2) - ilevel
c      iptr(3) - iparent
c      iptr(4) - nchild
c      iptr(5) - ichild
c      iptr(6) - ncoll
c      iptr(7) - coll
c      iptr(8) - ltree
c   
c 


      subroutine estimate_bounding_box(src, ns, targ, nt, bs0, cen0)
c----------------------------------------
c  estimate bounding box for a given collection of sources and targets 
c
c  input parameters:
c    - src: real *8 (3,ns)
c        source locations
c    - ns: integer *8
c        number of sources
c    - targ: real *8 (3,nt) 
c        target locations
c    - nt: integer *8
c        number of targets
c   
c  output parameters:
c    - bs0: real *8
c        size of bounding box at root level
c    - cen0: real *8 (3)
c        center of bounding box at root level
c------------------------------------------
      implicit none
      integer *8, intent(in) :: ns, nt
      real *8, intent(in) :: src(3,ns), targ(3,nt)
      real *8, intent(out) :: bs0, cen0(3)

      integer *8 i
      real *8 sizey, sizez
      real *8 xmin, xmax, ymin, ymax, zmin, zmax

c
c     step 1: find enclosing box
c
      xmin = src(1,1)
      xmax = src(1,1)
      ymin = src(2,1)
      ymax = src(2,1)
      zmin = src(3,1)
      zmax = src(3,1)
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,ns
        if(src(1,i).lt.xmin) xmin = src(1,i)
        if(src(1,i).gt.xmax) xmax = src(1,i)
        if(src(2,i).lt.ymin) ymin = src(2,i)
        if(src(2,i).gt.ymax) ymax = src(2,i)
        if(src(3,i).lt.zmin) zmin = src(3,i)
        if(src(3,i).gt.zmax) zmax = src(3,i)
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$REDUCTION(min:xmin,ymin,zmin)
C$OMP$REDUCTION(max:xmax,ymax,zmax)
      do i=1,nt
        if(targ(1,i).lt.xmin) xmin = targ(1,i)
        if(targ(1,i).gt.xmax) xmax = targ(1,i)
        if(targ(2,i).lt.ymin) ymin = targ(2,i)
        if(targ(2,i).gt.ymax) ymax = targ(2,i)
        if(targ(3,i).lt.zmin) zmin = targ(3,i)
        if(targ(3,i).gt.zmax) zmax = targ(3,i)
      enddo
C$OMP END PARALLEL DO      

      bs0 = (xmax - xmin)
      sizey = (ymax - ymin)
      sizez = (zmax - zmin)
      if(sizey.gt.bs0) bs0 = sizey
      if(sizez.gt.bs0) bs0 = sizez
      
      cen0(1) = (xmin + xmax)/2
      cen0(2) = (ymin + ymax)/2
      cen0(3) = (zmin + zmax)/2


      
      return
      end
c
c
c
c
c
c
      subroutine pts_tree_mem(src, ns, targ, nt, idivflag, ndiv,
     1    nlmin, nlmax, ifunif, iper, nlevels, nboxes, ltree)
c
c
c
c----------------------------------------
c  get memory requirements for the tree, where bounding box is 
c  determined from the src and target locations
c
c  input parameters:
c    - src: real *8 (3,ns)
c        source locations
c    - ns: integer *8
c        number of sources
c    - targ: real *8 (3,nt) 
c        target locations
c    - nt: integer *8
c        number of targets
c    - idivflag: integer *8
c        subdivision criterion
c          * divflag = 0 -> subdivide on sources only
c          * idivflag = 1 -> subdivide on targets only
c          * idivflag = 2 -> subdivide on max(sources+targets)
c    - ndiv: integer *8
c        subdivide if relevant number of particles
c        per box is greater than ndiv
c    - nlmin: integer *8
c        minimum number of levels of uniform refinement.
c        Note that empty boxes are not pruned along the way
c    - nlmax: integer *8
c        max number of levels
c    - ifunif: integer *8
c        flag for creating uniform pruned tree
c        Tree is uniform if ifunif=1 (Currently pruned part
c        under construction)
c    - iper: integer *8
c        flag for periodic implementations. Currently unused.
c        Feature under construction
c
c        
c  output parameters
c    - nlevels: integer *8
c        number of levels
c    - nboxes: integer *8
c        number of boxes
c    - ltree: integer *8
c        length of tree
c----------------------------------
c
     

      implicit none
      integer *8, intent(in) :: ns, nt, idivflag, ndiv, nlmin, nlmax
      integer *8, intent(in) :: ifunif, iper
      integer *8, intent(out) :: nboxes, nlevels
      integer *8, intent(out) :: ltree
      double precision, intent(in) :: src(3,ns),targ(3,nt)
      double precision bs0, cen0(3)

      call estimate_bounding_box(src, ns, targ, nt, bs0, cen0)

      call pts_tree_mem_bbox(src, ns, targ, nt, idivflag, ndiv,
     1    nlmin, nlmax, ifunif, iper, bs0, cen0, nlevels, nboxes,
     2    ltree)
      

      return
      end
c
c
c
c
c
      subroutine pts_tree_mem_bbox(src, ns, targ, nt, idivflag, ndiv,
     1    nlmin, nlmax, ifunif, iper, bs0, cen0, nlevels, nboxes,
     2    ltree)
c
c
c
c----------------------------------------
c  get memory requirements for the tree, where bounding box is user
c  specifed
c
c  input parameters:
c    - src: real *8 (3,ns)
c        source locations
c    - ns: integer *8
c        number of sources
c    - targ: real *8 (3,nt) 
c        target locations
c    - nt: integer *8
c        number of targets
c    - idivflag: integer *8
c        subdivision criterion
c          * divflag = 0 -> subdivide on sources only
c          * idivflag = 1 -> subdivide on targets only
c          * idivflag = 2 -> subdivide on max(sources+targets)
c    - ndiv: integer *8
c        subdivide if relevant number of particles
c        per box is greater than ndiv
c    - nlmin: integer *8
c        minimum number of levels of uniform refinement.
c        Note that empty boxes are not pruned along the way
c    - nlmax: integer *8
c        max number of levels
c    - ifunif: integer *8
c        flag for creating uniform pruned tree
c        Tree is uniform if ifunif=1 (Currently pruned part
c        under construction)
c    - iper: integer *8
c        flag for periodic implementations. Currently unused.
c        Feature under construction
c    - bs0: real *8
c        size of bounding box at root level
c    - cen0: real *8 (3)
c        center of bounding box at root level
c
c        
c  output parameters
c    - nlevels: integer *8
c        number of levels
c    - nboxes: integer *8
c        number of boxes
c    - ltree: integer *8
c        length of tree
c----------------------------------
c
     

      implicit none
      integer *8 nlevels,nboxes,idivflag
      integer *8 ltree,nboxes8
      integer *8 nbmax,nbtot
      integer *8 ns,nt,ndiv
      integer *8 nlmin,iper,ifunif
      integer *8 nlmax
      double precision src(3,ns),targ(3,nt)
      double precision bs0, cen0(3)


      integer *8, allocatable :: laddr(:,:),ilevel(:),iparent(:),
     1                           nchild(:)
      integer *8, allocatable :: ichild(:,:),ncoll(:),icoll(:,:)
      double precision, allocatable :: centers(:,:)
      integer *8, allocatable :: nbors(:,:),nnbors(:)

      integer *8, allocatable :: isrc(:),itarg(:),isrcse(:,:),
     1                           itargse(:,:)

      integer *8, allocatable :: ilevel2(:),iparent2(:),nchild2(:),
     1    ichild2(:,:),isrcse2(:,:),itargse2(:,:)
      double precision, allocatable :: centers2(:,:)

      integer *8 i,itype,j

      double precision, allocatable :: centerstmp(:,:,:)
      double precision, allocatable :: boxsize(:)
      integer *8, allocatable :: irefinebox(:)

      double precision rsc
      integer *8 nbloc,nbctr,nbadd,irefine,ilev,ifirstbox,ilastbox
      integer *8 iii
      integer *8 ibox,nn,nss,ntt

      double precision dfac

      nbmax = 100000

      allocate(boxsize(0:nlmax))

      
      allocate(laddr(2,0:nlmax),ilevel(nbmax),iparent(nbmax))
      allocate(nchild(nbmax),ichild(8,nbmax))

      allocate(centers(3,nbmax),isrcse(2,nbmax),itargse(2,nbmax))
      allocate(isrc(ns),itarg(nt))

      boxsize(0) = bs0
      centers(1,1) = cen0(1)
      centers(2,1) = cen0(2)
      centers(3,1) = cen0(3)

c
c      set tree info for level 0
c
      laddr(1,0) = 1
      laddr(2,0) = 1
      ilevel(1) = 0
      iparent(1) = -1
      nchild(1) = 0
      do i=1,8
        ichild(i,1) = -1
      enddo


      isrcse(1,1) = 1
      isrcse(2,1) = ns
      
      itargse(1,1) = 1
      itargse(2,1) = nt

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,ns
        isrc(i) = i
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,nt
        itarg(i) = i
      enddo
C$OMP END PARALLEL DO      


      nbctr = 1


      do ilev=0,nlmax-1
        irefine = 0

        ifirstbox = laddr(1,ilev) 
        ilastbox = laddr(2,ilev)

        nbloc = ilastbox-ifirstbox+1

        allocate(irefinebox(nbloc))
c
c          determine which boxes need to be refined
c


        if(ilev.ge.nlmin) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,nss,ntt,nn)
          do i=1,nbloc
            irefinebox(i) = 0
            ibox = ifirstbox + i-1
            nss = isrcse(2,ibox)-isrcse(1,ibox)+1
            ntt = itargse(2,ibox)-itargse(1,ibox)+1
            if(idivflag.eq.0) nn = nss
            if(idivflag.eq.1) nn = ntt
            if(idivflag.eq.2) nn = max(ntt,nss)

            if(nn.gt.ndiv) irefinebox(i) = 1
          enddo
C$OMP END PARALLEL DO        

          irefine = maxval(irefinebox(1:nbloc))
          if(ifunif.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)         
            do i=1,nbloc
              irefinebox(i) = irefine
            enddo
C$OMP END PARALLEL DO            
          endif
        else
C$OMP PARALLEL DO DEFAULT(SHARED)        
          do i=1,nbloc
            irefinebox(i) = 1
          enddo
C$OMP END PARALLEL DO         
          irefine = 1
        endif

c
c
c          figure out if current set of boxes is sufficient
c

        nbadd = 0 
C$OMP PARALLEL DO DEFAULT(SHARED) REDUCTION(+:nbadd)        
        do i=1,nbloc
          if(irefinebox(i).eq.1) nbadd = nbadd+8
        enddo
C$OMP END PARALLEL DO        

        nbtot = nbctr+nbadd

c
c         if current memory is not sufficient reallocate
c
        if(nbtot.gt.nbmax) then
          print *, "Reallocating"
          allocate(centers2(3,nbmax),ilevel2(nbmax),iparent2(nbmax))
          allocate(nchild2(nbmax),ichild2(8,nbmax),isrcse2(2,nbmax))
          allocate(itargse2(2,nbmax))

          call tree_copy(nbctr,centers,ilevel,iparent,nchild,
     1            ichild,centers2,ilevel2,iparent2,
     2            nchild2,ichild2)

C$OMP PARALLEL DO DEFAULT(SHARED)     
          do i=1,nbctr
            isrcse2(1,i) = isrcse(1,i)
            isrcse2(2,i) = isrcse(2,i)
            itargse2(1,i) = itargse(1,i)
            itargse2(2,i) = itargse(2,i)
          enddo
C$OMP END PARALLEL DO          


          deallocate(centers,ilevel,iparent,nchild,ichild,
     1        isrcse,itargse)

          nbmax = nbtot
          allocate(centers(3,nbmax),ilevel(nbmax),iparent(nbmax))
          allocate(nchild(nbmax),ichild(8,nbmax),isrcse(2,nbmax))
          allocate(itargse(2,nbmax))


          call tree_copy(nbctr,centers2,ilevel2,iparent2,
     1            nchild2,ichild2,centers,ilevel,iparent,nchild,ichild)

C$OMP PARALLEL DO DEFAULT(SHARED)
          do i=1,nbctr
            isrcse(1,i) = isrcse2(1,i)
            isrcse(2,i) = isrcse2(2,i)
            itargse(1,i) = itargse2(1,i)
            itargse(2,i) = itargse2(2,i)
          enddo
C$OMP END PARALLEL DO          

          deallocate(centers2,ilevel2,iparent2,nchild2,ichild2,
     1       isrcse2,itargse2)
        endif


        if(irefine.eq.1) then
          boxsize(ilev+1) = boxsize(ilev)/2
          laddr(1,ilev+1) = nbctr+1

          call tree_refine_boxes(irefinebox,nbmax,
     1       ifirstbox,nbloc,centers,boxsize(ilev+1),nbctr,ilev+1,
     2       ilevel,iparent,nchild,ichild)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,ibox) 
          do i=1,nbloc
            ibox = ifirstbox+i-1
            if(irefinebox(i).eq.1) then
              call sort_pts_to_children(ibox,nbmax,centers,ichild,
     1            src,ns,isrc,isrcse)
              call sort_pts_to_children(ibox,nbmax,centers,ichild,
     1            targ,nt,itarg,itargse)
            endif
          enddo
C$OMP END PARALLEL DO          

          laddr(2,ilev+1) = nbctr
        else
          exit
        endif

        deallocate(irefinebox)
      enddo

      nboxes = nbctr
      nlevels = ilev

      if(nlevels.ge.2.and.ifunif.ne.1) then

        nbtot = 16*nboxes
        if(nbtot.gt.nbmax) then
          allocate(centers2(3,nbmax),ilevel2(nbmax),iparent2(nbmax))
          allocate(nchild2(nbmax),ichild2(8,nbmax),isrcse2(2,nbmax))
          allocate(itargse2(2,nbmax))
          call tree_copy(nbctr,centers,ilevel,iparent,nchild,
     1            ichild,centers2,ilevel2,iparent2,
     2            nchild2,ichild2)

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)     
          do i=1,nbctr
            isrcse2(1,i) = isrcse(1,i)
            isrcse2(2,i) = isrcse(2,i)
            itargse2(1,i) = itargse(1,i)
            itargse2(2,i) = itargse(2,i)
          enddo
C$OMP END PARALLEL DO          

          deallocate(centers,ilevel,iparent,nchild,ichild,
     1        isrcse,itargse)

          nbmax = nbtot
          allocate(centers(3,nbmax),ilevel(nbmax),iparent(nbmax))
          allocate(nchild(nbmax),ichild(8,nbmax),isrcse(2,nbmax))
          allocate(itargse(2,nbmax))


          call tree_copy(nbctr,centers2,ilevel2,iparent2,
     1            nchild2,ichild2,centers,ilevel,iparent,nchild,ichild)

C$OMP PARALLEL DO DEFAULT(SHARED)     
          do i=1,nbctr
            isrcse(1,i) = isrcse2(1,i)
            isrcse(2,i) = isrcse2(2,i)
            itargse(1,i) = itargse2(1,i)
            itargse(2,i) = itargse2(2,i)
          enddo
C$OMP END PARALLEL DO          

          deallocate(centers2,ilevel2,iparent2,nchild2,ichild2,
     1       isrcse2,itargse2)

        endif

        allocate(nnbors(nbmax))
        allocate(nbors(27,nbmax))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
        do i=1,nboxes
          nnbors(i) = 0
          do j=1,27
            nbors(j,i) = -1
          enddo
        enddo
C$OMP END PARALLEL DO        

        call computecoll(nlevels,nboxes,laddr,boxsize,centers,
     1        iparent,nchild,ichild,iper,nnbors,nbors)

        if(nlevels.ge.2.and.ifunif.ne.1) then
          call pts_tree_fix_lr(centers,nlevels,nboxes,boxsize,nbmax,
     1      nlmax,iper,laddr,ilevel,iparent,nchild,ichild,nnbors,nbors)
        endif

      endif
      nboxes8 = nboxes
      ltree = 39*nboxes8 + 2*(nlevels+1) 


      return
      end
c
c
c
c
c

      subroutine pts_tree_build(src, ns, targ, nt, idivflag, ndiv,
     1  nlmin, nlmax, ifunif, iper, nlevels, nboxes, ltree, 
     2  itree, iptr, centers, boxsize)
c
c
c
c----------------------------------------
c  build tree with prespecified bounding box
c
c
c  input parameters:
c    - src: real *8 (3,ns)
c        source locations
c    - ns: integer
c        number of sources
c    - targ: real *8 (3,nt) 
c        target locations
c    - nt: integer *8
c        number of targets
c    - idivflag: integer *8
c        subdivision criterion
c          * divflag = 0 -> subdivide on sources only
c          * idivflag = 1 -> subdivide on targets only
c          * idivflag = 2 -> subdivide on max(sources+targets)
c    - ndiv: integer *8
c        subdivide if relevant number of particles
c        per box is greater than ndiv
c    - nlmin: integer *8
c        minimum number of levels of uniform refinement.
c        Note that empty boxes are not pruned along the way
c    - nlmax: integer *8
c        max number of levels
c    - ifunif: integer *8
c        flag for creating uniform pruned tree
c        Tree is uniform if ifunif=1 (Currently pruned part
c        under construction)
c    - iper: integer *8
c        flag for periodic implementations. Currently unused.
c        Feature under construction
c    - nlevels: integer *8
c        number of levels
c    - nboxes: integer *8
c        number of boxes
c    - ltree: integer *8
c        length of tree array
c
c  output:
c    - itree: integer *8(ltree)
c        tree info
c    - iptr: integer *8 (8)
c        * iptr(1) - laddr
c        * iptr(2) - ilevel
c        * iptr(3) - iparent
c        * iptr(4) - nchild
c        * iptr(5) - ichild
c        * iptr(6) - ncoll
c        * iptr(7) - coll
c        * iptr(8) - ltree
c    - centers: double precision (3,nboxes)
c        xy coordinates of box centers in the oct tree
c    - boxsize: double precision (0:nlevels)
c        size of box at each of the levels
c
      implicit none
      integer *8, intent(in) :: ns, nt, idivflag, ndiv, nlmin, nlmax
      integer *8, intent(in) :: ifunif, iper, nlevels, nboxes
      integer *8, intent(in) :: ltree
      real *8, intent(in) :: src(3,ns), targ(3,nt)

      integer *8, intent(out) :: iptr(8)
      integer *8, intent(out) :: itree(ltree)
      real *8, intent(out) :: boxsize(0:nlevels), centers(3,nboxes)
      
      real *8 bs0, cen0(3)
      
      
      call estimate_bounding_box(src, ns, targ, nt, bs0, cen0)

      call pts_tree_build_bbox(src, ns, targ, nt, idivflag, ndiv,
     1  nlmin, nlmax, ifunif, iper, nlevels, nboxes, bs0, cen0, ltree, 
     2  itree, iptr, centers, boxsize)


      return
      end
c
c
c
c
c

      subroutine pts_tree_build_bbox(src, ns, targ, nt, idivflag, ndiv,
     1  nlmin, nlmax, ifunif, iper, nlevels, nboxes, bs0, cen0, ltree, 
     2  itree, iptr, centers, boxsize)
c
c
c
c----------------------------------------
c  build tree with prespecified bounding box
c
c
c  input parameters:
c    - src: real *8 (3,ns)
c        source locations
c    - ns: integer *8
c        number of sources
c    - targ: real *8 (3,nt) 
c        target locations
c    - nt: integer *8
c        number of targets
c    - idivflag: integer *8
c        subdivision criterion
c          * divflag = 0 -> subdivide on sources only
c          * idivflag = 1 -> subdivide on targets only
c          * idivflag = 2 -> subdivide on max(sources+targets)
c    - ndiv: integer *8
c        subdivide if relevant number of particles
c        per box is greater than ndiv
c    - nlmin: integer *8
c        minimum number of levels of uniform refinement.
c        Note that empty boxes are not pruned along the way
c    - nlmax: integer *8
c        max number of levels
c    - ifunif: integer *8
c        flag for creating uniform pruned tree
c        Tree is uniform if ifunif=1 (Currently pruned part
c        under construction)
c    - iper: integer *8
c        flag for periodic implementations. Currently unused.
c        Feature under construction
c    - nlevels: integer *8
c        number of levels
c    - nboxes: integer *8
c        number of boxes
c    - bs0: real *8
c        size of bounding box at root level
c    - cen0: real *8 (3)
c        center of bounding box at root level
c    - ltree: integer *8
c        length of tree array
c
c  output:
c    - itree: integer *8(ltree)
c        tree info
c    - iptr: integer *8 (8)
c        * iptr(1) - laddr
c        * iptr(2) - ilevel
c        * iptr(3) - iparent
c        * iptr(4) - nchild
c        * iptr(5) - ichild
c        * iptr(6) - ncoll
c        * iptr(7) - coll
c        * iptr(8) - ltree
c    - centers: double precision (3,nboxes)
c        xy coordinates of box centers in the oct tree
c    - boxsize: double precision (0:nlevels)
c        size of box at each of the levels
c

      implicit none
      integer *8 nlevels,nboxes,ns,nt,idivflag,ndiv
      integer *8 iptr(8),ltree
      integer *8 itree(ltree),iper
      integer *8 ifunif,nlmin,nlmax
      double precision centers(3,nboxes),src(3,ns),targ(3,nt)
      integer *8, allocatable :: irefinebox(:)
      double precision boxsize(0:nlevels)
      double precision bs0, cen0(3)
      integer *8, allocatable :: isrc(:),itarg(:),isrcse(:,:),
     1                           itargse(:,:)

      integer *8 i,ilev,irefine,itype,nbmax,npbox,npc,ii
      integer *8 ifirstbox,ilastbox,nbctr,nbloc
      double precision rsc

      double precision ra
      integer *8 j,nboxes0
      integer *8 ibox,nn,nss,ntt

c
      iptr(1) = 1
      iptr(2) = 2*(nlevels+1)+1
      iptr(3) = iptr(2) + nboxes
      iptr(4) = iptr(3) + nboxes
      iptr(5) = iptr(4) + nboxes
      iptr(6) = iptr(5) + 8*nboxes
      iptr(7) = iptr(6) + nboxes
      iptr(8) = iptr(7) + 27*nboxes

      boxsize(0) = bs0
      centers(1,1) = cen0(1)
      centers(2,1) = cen0(2)
      centers(3,1) = cen0(3)

      allocate(isrc(ns),itarg(nt),isrcse(2,nboxes),itargse(2,nboxes))

c
c      set tree info for level 0
c
      itree(1) = 1
      itree(2) = 1
      itree(iptr(2)) = 0
      itree(iptr(3)) = -1
      itree(iptr(4)) = 0
      do i=1,8
        itree(iptr(5)+i-1) = -1
      enddo


      isrcse(1,1) = 1
      isrcse(2,1) = ns
      itargse(1,1) = 1
      itargse(2,1) = nt

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,ns
        isrc(i) = i
      enddo
C$OMP END PARALLEL DO      

C$OMP PARALLEL DO DEFAULT(SHARED)
      do i=1,nt
        itarg(i) = i
      enddo
C$OMP END PARALLEL DO      


c
c       Reset nlevels, nboxes
c
      nbctr = 1

      do ilev=0,nlevels-1
        irefine = 0

        ifirstbox = itree(2*ilev+1) 
        ilastbox = itree(2*ilev+2)

        nbloc = ilastbox-ifirstbox+1
        allocate(irefinebox(nbloc))

c
c          determine which boxes need to be refined
c
c       
        if(ilev.ge.nlmin) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,ibox,nss,ntt,nn)
          do i=1,nbloc
            irefinebox(i) = 0
            ibox = ifirstbox + i-1
            nss = isrcse(2,ibox)-isrcse(1,ibox)+1
            ntt = itargse(2,ibox)-itargse(1,ibox)+1
          
            if(idivflag.eq.0) nn = nss
            if(idivflag.eq.1) nn = ntt
            if(idivflag.eq.2) nn = max(ntt,nss)

            if(nn.gt.ndiv) irefinebox(i) = 1
          enddo
C$OMP END PARALLEL DO        
          irefine = maxval(irefinebox(1:nbloc))

          if(ifunif.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
            do i=1,nbloc
              irefinebox(i) = irefine
            enddo
C$OMP END PARALLEL DO 
          endif
        else
C$OMP PARALLEL DO DEFAULT(SHARED)
          do i=1,nbloc
            irefinebox(i) = 1
          enddo
C$OMP END PARALLEL DO 
          irefine = 1
        endif
        

        if(irefine.eq.1) then
          boxsize(ilev+1) = boxsize(ilev)/2
          itree(2*ilev+3) = nbctr+1

          call tree_refine_boxes(irefinebox,nboxes,
     1       ifirstbox,nbloc,centers,boxsize(ilev+1),nbctr,ilev+1,
     2       itree(iptr(2)),itree(iptr(3)),itree(iptr(4)),
     3       itree(iptr(5)))

c
c     re sort points in refined boxes
c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,ibox)
          do i=1,nbloc
            ibox = ifirstbox+i-1
            if(irefinebox(i).eq.1) then
              call sort_pts_to_children(ibox,nboxes,centers,
     1          itree(iptr(5)),src,ns,isrc,isrcse)
              call sort_pts_to_children(ibox,nboxes,centers,
     1          itree(iptr(5)),targ,nt,itarg,itargse)
            endif
          enddo
C$OMP END PARALLEL DO          

          
          itree(2*ilev+4) = nbctr
        else
          exit
        endif

        deallocate(irefinebox)
      enddo

      nboxes0 = nbctr
      nlevels = ilev


C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
      do i=1,nboxes0
        itree(iptr(6)+i-1) = 0
        do j=1,27
          itree(iptr(7)+27*(i-1)+j-1) = -1
        enddo
      enddo
C$OMP END PARALLEL DO      


      call computecoll(nlevels,nboxes0,itree(iptr(1)),boxsize,centers,
     1        itree(iptr(3)),itree(iptr(4)),itree(iptr(5)),iper,
     2        itree(iptr(6)),itree(iptr(7)))

      if(nlevels.ge.2.and.ifunif.ne.1) then
         call pts_tree_fix_lr(centers,nlevels,
     1         nboxes0,boxsize,nboxes,nlevels,iper,itree(iptr(1)),
     2         itree(iptr(2)),itree(iptr(3)),itree(iptr(4)),
     3         itree(iptr(5)),itree(iptr(6)),itree(iptr(7)))

      endif

      return
      end
c
c
c
c
c
      subroutine sort_pts_to_children(ibox, nboxes, centers,
     1   ichild, src, ns, isrc, isrcse)
      implicit double precision (a-h,o-z)
      integer *8 nboxes,ibox, ns
      double precision centers(3,nboxes),src(3,ns)
      integer *8 isrc(ns),isrcse(2,nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 iss, nsc(8)
      integer *8, allocatable :: isrctmp(:)

c           Allocate temporary array to figure out which child you
c           belong to
c           which child?  1,2,3,4,5,6,7,8? counter ns1,ns2,ns3,ns4,
c           ns5,ns6,ns7,ns8
c           The box nomenclature is as follows
c           3   4       7  8       <--- Looking down in z direction
c           1   2       5  6
c
c           If the parent box center is at the origin then the centers
c           of box i have co-ordinates
c           1     x<0,y<0,z<0
c           2     x>0,y<0,z<0
c           3     x<0,y>0,z<0
c           4     x>0,y>0,z<0
c           5     x<0,y<0,z>0
c           6     x>0,y<0,z>0
c           7     x<0,y>0,z>0
c           8     x>0,y>0,z>0
c

      i1234 = isrcse(1,ibox)-1
      i5678 = 0
      npts = isrcse(2,ibox)-isrcse(1,ibox)+1
      allocate(isrctmp(npts))

      do iss=isrcse(1,ibox),isrcse(2,ibox)
        if(src(3,isrc(iss))-centers(3,ibox).lt.0) then
          i1234 = i1234+1
          isrc(i1234) = isrc(iss)
        else
          i5678 = i5678 + 1
          isrctmp(i5678) = isrc(iss)
        endif
      enddo

c
c           reorder sources
c
      do i=1,i5678
        isrc(i1234+i) = isrctmp(i)
      enddo


c
c     sort i1234 to i12 and i34
c
      i12 = isrcse(1,ibox)-1
      i34 = 0
      do iss=isrcse(1,ibox),i1234
        if(src(2,isrc(iss))-centers(2,ibox).lt.0) then
          i12 = i12+1
          isrc(i12) = isrc(iss)
        else
          i34 = i34 + 1
          isrctmp(i34) = isrc(iss)
        endif
      enddo
c
c  reorder sources to include 34 in the array
c
      do i=1,i34
        isrc(i12+i) = isrctmp(i)
      enddo

c
c    sort i5678 into i56 and i78
c
      i56 = i1234
      i78 = 0
      do iss=i1234+1,isrcse(2,ibox)
        if(src(2,isrc(iss))-centers(2,ibox).lt.0) then
          i56 = i56+1
          isrc(i56) = isrc(iss)
        else
          i78 = i78 + 1
          isrctmp(i78) = isrc(iss)
        endif
      enddo

c     reorder sources to include 78 in the array      
      do i=1,i78
        isrc(i56+i) = isrctmp(i)
      enddo

      nsc(1) = 0
      nsc(2) = 0
      nsc(3) = 0
      nsc(4) = 0
      nsc(5) = 0
      nsc(6) = 0
      nsc(7) = 0
      nsc(8) = 0
c
c       sort into boxes 1,2
c
      do iss = isrcse(1,ibox),i12
        if(src(1,isrc(iss))-centers(1,ibox).lt.0) then
          isrc(isrcse(1,ibox)+nsc(1)) = isrc(iss)
          nsc(1) = nsc(1)+1
        else
          nsc(2) = nsc(2) + 1
          isrctmp(nsc(2)) = isrc(iss)
        endif
      enddo
c
c      reorder sources so that sources in 2 are at end of array
c
      do i=1,nsc(2)
        isrc(isrcse(1,ibox)+nsc(1)+i-1) = isrctmp(i)
      enddo
c
c    sort intow boxes 3,4 
c 
      do iss=i12+1,i1234
        if(src(1,isrc(iss))-centers(1,ibox).lt.0) then
          isrc(i12+1+nsc(3)) = isrc(iss)
          nsc(3) = nsc(3) + 1
        else
          nsc(4) = nsc(4) + 1
          isrctmp(nsc(4)) = isrc(iss)
        endif
      enddo

      do i=1,nsc(4)
        isrc(i12+nsc(3)+i) = isrctmp(i)
      enddo

c
c   sort into boxes 5,6
c
      do iss=i1234+1,i56
        if(src(1,isrc(iss))-centers(1,ibox).lt.0) then
          isrc(i1234+1+nsc(5)) = isrc(iss)
          nsc(5) = nsc(5) + 1
        else
          nsc(6) = nsc(6) + 1
          isrctmp(nsc(6)) = isrc(iss)
        endif
      enddo

      do i=1,nsc(6)
        isrc(i1234+nsc(5)+i) = isrctmp(i)
      enddo
c
c   End of sorting sources into boxes 5 and 6
c

c
c    sort into boxes 7 and 8
c
      do iss=i56+1,isrcse(2,ibox)
        if(src(1,isrc(iss))-centers(1,ibox).lt.0) then
          isrc(i56+1+nsc(7)) = isrc(iss)
          nsc(7) = nsc(7) + 1
        else
          nsc(8) = nsc(8) + 1
          isrctmp(nsc(8)) = isrc(iss)
        endif
      enddo

      do i=1,nsc(8)
        isrc(i56+nsc(7)+i) = isrctmp(i)
      enddo
c
c   End of sorting sources into boxes 5 and 6


      istart = isrcse(1,ibox)
      do i=1,8
        jbox = ichild(i,ibox)
        isrcse(1,jbox) = istart
        isrcse(2,jbox) = istart + nsc(i)-1
        istart = istart + nsc(i)
      enddo

c
c

      return
      end
c       
c
c-------------------------------------------------------------      
      subroutine pts_tree_fix_lr(centers,nlevels,nboxes,
     1       boxsize,nbmax,nlmax,iper,laddr,ilevel,iparent,nchild,
     2       ichild,nnbors,nbors)
c
c
c       convert an adaptive tree into a level restricted tree
c
      implicit none
      integer *8 nlevels,nboxes,nlmax
      integer *8 nbmax,iper
      double precision centers(3,nbmax),boxsize(0:nlmax)
      integer *8 laddr(2,0:nlmax),ilevel(nbmax),iparent(nbmax)
      integer *8 nchild(nbmax),ichild(8,nbmax),nnbors(nbmax)
      integer *8 nbors(27,nbmax)
      integer *8 laddrtail(2,0:nlmax),isum
      integer *8, allocatable :: iflag(:)

      integer *8 i,j,k,l,ibox,jbox,kbox,ilev,idad,igranddad
      integer *8 nbloc,ict
      double precision xdis,ydis,zdis,distest

      allocate(iflag(nbmax))

c     Initialize flag array
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nboxes
         iflag(i) = 0
      enddo
C$OMP END PARALLEL DO     



c     Flag boxes that violate level restriction by "1"
c     Violatioin refers to any box that is directly touching
c     a box that is more than one level finer
c
c     Method:
c     1) Carry out upward pass. For each box B, look at
c     the colleagues of B's grandparent
c     2) See if any of those colleagues are childless and in
c     contact with B.
c
c     Note that we only need to get up to level two, as
c     we will not find a violation at level 0 and level 1
c
c     For such boxes, we set iflag(i) = 1
c
      do ilev=nlevels,2,-1
c        This is the distance to test if two boxes separated
c        by two levels are touching
         distest = 1.05d0*(boxsize(ilev-1) + boxsize(ilev-2))/2.0d0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,idad,igranddad,i,jbox)         
C$OMP$ PRIVATE(ict,xdis,ydis,zdis)
         do ibox = laddr(1,ilev),laddr(2,ilev) 
            idad = iparent(ibox)
            igranddad = iparent(idad)
            
c           Loop over colleagues of granddad            
            do i=1,nnbors(igranddad)
               jbox = nbors(i,igranddad)
c              Check if the colleague of grandad
c              is a leaf node. This automatically
c              eliminates the granddad
               if(nchild(jbox).eq.0.and.iflag(jbox).eq.0) then
                   xdis = centers(1,jbox) - centers(1,idad)
                   ydis = centers(2,jbox) - centers(2,idad)
                   zdis = centers(3,jbox) - centers(3,idad)
                   ict = 0
                   if(abs(xdis).le.distest) ict = ict + 1
                   if(abs(ydis).le.distest) ict = ict + 1
                   if(abs(zdis).le.distest) ict = ict + 1
                   if(ict.eq.3) then
                      iflag(jbox) = 1
                   endif
               endif
c              End of checking criteria for the colleague of
c              granddad
            enddo
c           End of looping over colleagues of
c           granddad
         enddo
c        End of looping over boxes at ilev         
C$OMP END PARALLEL DO
      enddo
c     End of looping over levels and flagging boxes


c     Find all boxes that need to be given a flag+
c     A flag+ box will be denoted by setting iflag(box) = 2
c     This refers to any box that is not already flagged and
c     is bigger than and is contacting a flagged box
c     or another box that has already been given a flag +.
c     It is found by performing an upward pass and looking
c     at the flagged box's parents colleagues and a flag+
c     box's parents colleagues and seeing if they are
c     childless and present the case where a bigger box 
c     is contacting a flagged or flag+ box.

      do ilev = nlevels,1,-1
c        This is the distance to test if two boxes separated
c        by one level are touching
         distest = 1.05d0*(boxsize(ilev) + boxsize(ilev-1))/2.0d0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,idad,i,jbox,xdis,ydis)
C$OMP$PRIVATE(zdis,ict)
         do ibox = laddr(1,ilev),laddr(2,ilev)
            if(iflag(ibox).eq.1.or.iflag(ibox).eq.2) then
               idad = iparent(ibox)
c              Loop over dad's colleagues               
               do i=1,nnbors(idad)
                  jbox = nbors(i,idad)
c                 Check if the colleague of dad
c                 is a leaf node. This automatically
c                 eliminates the dad
                  if(nchild(jbox).eq.0.and.iflag(jbox).eq.0) then
                     xdis = centers(1,jbox) - centers(1,ibox)
                     ydis = centers(2,jbox) - centers(2,ibox)
                     zdis = centers(3,jbox) - centers(3,ibox)
                     ict = 0
                     if(abs(xdis).le.distest) ict = ict + 1
                     if(abs(ydis).le.distest) ict = ict + 1
                     if(abs(zdis).le.distest) ict = ict + 1
                     if(ict.eq.3) then
                        iflag(jbox) = 2
                     endif
                  endif
c                 End of checking criteria for the colleague of
c                dad
               enddo
c              End of looping over dad's colleagues               
            endif
c           End of checking if current box is relevant for
c           flagging flag+ boxes
         enddo
c        End of looping over boxes at ilev        
C$OMP END PARALLEL DO 
      enddo
c     End of looping over levels

c     Subdivide all flag and flag+ boxes. Flag all the children
c     of flagged boxes as flag++. Flag++ boxes are denoted
c     by setting iflag(box) = 3. The flag++ boxes need 
c     to be checked later to see which of them need further
c     refinement. While creating new boxes, we will
c     need to update all the tree structures as well.
c     Note that all the flagged boxes live between
c     levels 1 and nlevels - 2. We process the boxes via a
c     downward pass. We first determine the number of boxes
c     that are going to be subdivided at each level and 
c     everything else accordingly
      do ilev = 0,nlevels
         laddrtail(1,ilev) = 0
         laddrtail(2,ilev) = -1
      enddo

 
      do ilev = 1,nlevels-2
c        First subdivide all the flag and flag+
c        boxes with boxno nboxes+1, nboxes+ 2
c        and so on. In the second step, we reorganize
c        all the structures again to bring it back
c        in the standard format

         laddrtail(1,ilev+1) = nboxes+1


         nbloc = laddr(2,ilev)-laddr(1,ilev)+1
         call tree_refine_boxes_flag(iflag,nbmax,laddr(1,ilev),
     1    nbloc,centers,boxsize(ilev+1),nboxes,ilev,ilevel,iparent,
     2    nchild,ichild)


         laddrtail(2,ilev+1) = nboxes
      enddo
c     Reorganize the tree to get it back in the standard format

      call pts_tree_reorg(nboxes,centers,nlevels,laddr,
     1          laddrtail,ilevel,iparent,nchild,ichild,
     2          iflag)

c     Compute colleague information again      

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
      do i=1,nboxes
         nnbors(i) = 0
         do j=1,27
            nbors(j,i) = -1
         enddo
      enddo
C$OMP END PARALLEL DO      
      call computecoll(nlevels,nboxes,laddr, boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,iper,nnbors,nbors)

c     Processing of flag and flag+ boxes is done
c     Start processing flag++ boxes. We will use a similar
c     strategy as before. We keep checking the flag++
c     boxes that require subdivision if they still
c     violate the level restriction criterion, create
c     the new boxes, append them to the end of the list to begin
c     with and in the end reorganize the tree structure.
c     We shall accomplish this via a downward pass
c     as new boxes that get added in the downward pass
c     will also be processed simultaneously.
c     We shall additionally also need to keep on updating
c     the colleague information as we proceed in the 
c     downward pass

c     Reset the flags array to remove all the flag and flag+
c     cases. This is to ensure reusability of the subdivide
c     _flag routine to handle the flag++ case

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox)
      do ibox=1,nboxes
         if(iflag(ibox).ne.3) iflag(ibox) = 0
      enddo
C$OMP END PARALLEL DO      
 
      do ilev = 0,nlevels
         laddrtail(1,ilev) = 0
         laddrtail(2,ilev) = -1
      enddo


      do ilev = 2,nlevels-2

c     Step 1: Determine which of the flag++ boxes need
c     further division. In the even a flag++ box needs
c     further subdivision then flag the box with iflag(box) = 1
c     This will again ensure that the subdivide_flag routine
c     will take care of handling the flag++ case
         call updateflags(ilev,nboxes,nlevels,laddr,nchild,ichild,
     1                    nnbors,nbors,centers,boxsize,iflag)

         call updateflags(ilev,nboxes,nlevels,laddrtail,nchild,ichild,
     1                    nnbors,nbors,centers,boxsize,iflag)
        
c      Step 2: Subdivide all the boxes that need subdivision
c      in the laddr set and the laddrtail set as well
         laddrtail(1,ilev+1) = nboxes + 1

         nbloc = laddr(2,ilev)-laddr(1,ilev)+1
         call tree_refine_boxes_flag(iflag,nbmax,laddr(1,ilev),
     1    nbloc,centers,boxsize(ilev+1),nboxes,ilev,ilevel,iparent,
     2    nchild,ichild)

         nbloc = laddrtail(2,ilev)-laddrtail(1,ilev)+1
         call tree_refine_boxes_flag(iflag,nbmax,laddrtail(1,ilev),
     1    nbloc,centers,boxsize(ilev+1),nboxes,ilev,ilevel,iparent,
     2    nchild,ichild)

         laddrtail(2,ilev+1) = nboxes         
c      Step 3: Update the colleague information for the newly
c      created boxes

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,i,idad,jbox,j,kbox)
          do ibox = laddrtail(1,ilev+1),laddrtail(2,ilev+1)
            nnbors(ibox) = 0
c           Find the parent of the current box         
            idad = iparent(ibox)
c           Loop over the neighbors of the parent box
c           to find out colleagues
            do i=1,nnbors(idad)
                jbox = nbors(i,idad)
                do j=1,8
c               ichild(j,jbox) is one of the children of the
c               neighbors of the parent of the current
c               box
                   kbox = ichild(j,jbox)
                   if(kbox.gt.0) then
c               Check if kbox is a nearest neighbor or in list 2
                      if((abs(centers(1,kbox)-centers(1,ibox)).le.
     1                   1.05*boxsize(ilev+1)).and.
     2                   (abs(centers(2,kbox)-centers(2,ibox)).le.
     3                   1.05*boxsize(ilev+1)).and.
     2                   (abs(centers(3,kbox)-centers(3,ibox)).le.
     3                   1.05*boxsize(ilev+1))) then
                     
                         nnbors(ibox) = nnbors(ibox)+1
                         nbors(nnbors(ibox),ibox) = kbox
                      endif
                   endif
                enddo
            enddo
c           End of computing colleagues of box i
         enddo
C$OMP END PARALLEL DO         
      enddo

c     Reorganize tree once again and we are all done      
      call pts_tree_reorg(nboxes,centers,nlevels,laddr,
     1          laddrtail,ilevel,iparent,nchild,ichild,
     2          iflag)

c     Compute colleague information again      

C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
      do i=1,nboxes
         nnbors(i) = 0
         do j=1,27
            nbors(j,i) = -1
         enddo
      enddo
C$OMP END PARALLEL DO    

      call computecoll(nlevels,nboxes,laddr, boxsize,
     1                   centers,iparent,nchild,
     2                   ichild,iper,nnbors,nbors)
      

      return
      end
      

c-------------------------------------------------------------      

      subroutine pts_tree_reorg(nboxes,centers,nlevels,laddr,
     1     laddrtail,ilevel,iparent,nchild,ichild,iflag)

c    This subroutine reorganizes the current data in all the tree
c    arrays to rearrange them in the standard format.
c    The boxes on input are assumed to be arranged in the following
c    format
c    boxes on level i are the boxes from laddr(1,i) to 
c    laddr(2,i) and also from laddrtail(1,i) to laddrtail(2,i)
c
c    At the end of the sorting, the boxes on level i
c    are arranged from laddr(1,i) to laddr(2,i)  
c
c    INPUT/OUTPUT arguments
c    nboxes         in: integer *8
c                   number of boxes
c
c    centers        in/out: double precision(3,nboxes)
c                   x and y coordinates of the center of boxes
c
c    nlevels        in: integer *8
c                   Number of levels in the tree
c
c    laddr          in/out: integer *8(2,0:nlevels)
c                   boxes at level i are numbered between
c                   laddr(1,i) to laddr(2,i)
c
c    laddrtail      in: integer *8(2,0:nlevels)
c                   new boxes to be added to the tree
c                   structure are numbered from
c                   laddrtail(1,i) to laddrtail(2,i)
c
c    ilevel      in/out: integer *8(nboxes)
c                ilevel(i) is the level of box i
c
c    iparent     in/out: integer *8(nboxes)
c                 iparent(i) is the parent of box i
c
c    nchild      in/out: integer *8(nboxes)
c                nchild(i) is the number of children 
c                of box i
c
c    ichild       in/out: integer *8(4,nboxes)
c                 ichild(j,i) is the jth child of box i
c
c    iflag        in/out: integer *8(nboxes)
c                 iflag(i) is a flag for box i required to generate
c                 level restricted tree from adaptive tree

      implicit none
c     Calling sequence variables and temporary variables
      integer *8 nboxes,nlevels
      double precision centers(3,nboxes)
      integer *8 laddr(2,0:nlevels), tladdr(2,0:nlevels)
      integer *8 laddrtail(2,0:nlevels)
      integer *8 ilevel(nboxes)
      integer *8 iparent(nboxes)
      integer *8 nchild(nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 iflag(nboxes)
      
      integer *8, allocatable :: tilevel(:),tiparent(:),tnchild(:)
      integer *8, allocatable :: tichild(:,:),tiflag(:)
      integer *8, allocatable :: iboxtocurbox(:),ilevptr(:),ilevptr2(:)

      double precision, allocatable :: tcenters(:,:)



c     Temporary variables
      integer *8 i,j,k,l
      integer *8 ibox,ilev, curbox,idim,nblev

      allocate(tilevel(nboxes),tiparent(nboxes),tnchild(nboxes))
      allocate(tichild(8,nboxes),tiflag(nboxes),iboxtocurbox(nboxes))
      allocate(tcenters(3,nboxes))

      do ilev = 0,nlevels
         tladdr(1,ilev) = laddr(1,ilev)
         tladdr(2,ilev) = laddr(2,ilev)
      enddo
      call tree_copy(nboxes,centers,ilevel,iparent,nchild,
     1            ichild,tcenters,tilevel,tiparent,
     2            tnchild,tichild)

      do ibox=1,nboxes
         tiflag(ibox) = iflag(ibox)
      enddo
     
c     Rearrange old arrays now

      do ilev = 0,1
         do ibox = laddr(1,ilev),laddr(2,ilev)
           iboxtocurbox(ibox) = ibox
         enddo
      enddo

      allocate(ilevptr(nlevels+1),ilevptr2(nlevels))

      ilevptr(2) = laddr(1,2)

      do ilev=2,nlevels
        nblev = laddr(2,ilev)-laddr(1,ilev)+1
        ilevptr2(ilev) = ilevptr(ilev) + nblev
        nblev = laddrtail(2,ilev)-laddrtail(1,ilev)+1
        ilevptr(ilev+1) = ilevptr2(ilev) + nblev
      enddo

      curbox = laddr(1,2)
      do ilev=2,nlevels
         laddr(1,ilev) = curbox
         do ibox = tladdr(1,ilev),tladdr(2,ilev)
            ilevel(curbox) = tilevel(ibox)
            nchild(curbox) = tnchild(ibox)
            centers(1,curbox) = tcenters(1,ibox)
            centers(2,curbox) = tcenters(2,ibox)
            centers(3,curbox) = tcenters(3,ibox)
            iflag(curbox) = tiflag(ibox)
            iboxtocurbox(ibox) = curbox

            curbox = curbox + 1
         enddo
         do ibox = laddrtail(1,ilev),laddrtail(2,ilev)
            ilevel(curbox) = tilevel(ibox)
            centers(1,curbox) = tcenters(1,ibox)
            centers(2,curbox) = tcenters(2,ibox)
            centers(3,curbox) = tcenters(3,ibox)
            nchild(curbox) = tnchild(ibox)
            iflag(curbox) = tiflag(ibox)
            iboxtocurbox(ibox) = curbox

            curbox = curbox + 1
         enddo
         laddr(2,ilev) = curbox-1
      enddo

c     Handle the parent children part of the tree 
c     using the mapping iboxtocurbox

      do ibox=1,nboxes
         if(tiparent(ibox).eq.-1) iparent(iboxtocurbox(ibox)) = -1
         if(tiparent(ibox).gt.0) 
     1    iparent(iboxtocurbox(ibox)) = iboxtocurbox(tiparent(ibox))
         do i=1,8
            if(tichild(i,ibox).eq.-1) ichild(i,iboxtocurbox(ibox)) = -1
            if(tichild(i,ibox).gt.0) 
     1      ichild(i,iboxtocurbox(ibox)) = iboxtocurbox(tichild(i,ibox))
         enddo
      enddo

      return
      end
c
c
c
c
c
c
      subroutine pts_tree_sort(n,xys,itree,ltree,nboxes,nlevels,
     1   iptr,centers,ixy,ixyse)
      implicit none
      integer *8 iptr(8),ltree,ibox,ilev
      integer *8 i,n,nboxes,nlevels,itree(ltree)
      integer *8 ixy(n),ixyse(2,nboxes)
      double precision xys(3,n),centers(3,nboxes)

      do i=1,n
        ixy(i) = i
      enddo

      ixyse(1,1) = 1
      ixyse(2,1) = n

      do ilev = 0,nlevels-1
        do ibox=itree(2*ilev+1),itree(2*ilev+2)
          if(itree(iptr(4)+ibox-1).gt.0) then
            call sort_pts_to_children(ibox,nboxes,centers,
     1          itree(iptr(5)),xys,n,ixy,ixyse)
          endif
        enddo
      enddo

      return
      end

c
c      This file contains the basic subroutines for 
c      forming and evaluating multipole (partial wave) expansions.
c
c
c      Remarks on scaling conventions.
c
c      1)  Hankel and Bessel functions are consistently scaled as
c       	hvec(n)= h_n(z)*scale^(n)
c       	jvec(n)= j_n(z)/scale^(n)
c
c          scale should be of the order of |z| if |z| < 1. Otherwise,
c          scale should be set to 1.
c
c
c      2) There are many definitions of the spherical harmonics,
c         which differ in terms of normalization constants. We
c         adopt the following convention:
c
c         For m>0, we define Y_n^m according to 
c
c         Y_n^m = \sqrt{2n+1} \sqrt{\frac{ (n-m)!}{(n+m)!}} \cdot
c                 P_n^m(\cos \theta)  e^{i m phi} 
c         and
c 
c         Y_n^-m = dconjg( Y_n^m )
c    
c         We omit the Condon-Shortley phase factor (-1)^m in the 
c         definition of Y_n^m for m<0. 
c
c         We also omit the factor \sqrt{\frac{1}{4 \pi}}, so that
c         the Y_n^m are orthogonal on the unit sphere but not 
c         orthonormal.  
c         More precisely, 
c
c                 \int_S Y_n^m Y_n^m d\Omega = 4 \pi. 
c
c         Using our standard definition, the addition theorem takes 
c         the simple form 
c
c         1/(4\pi) e^( i k r}/(ikr) = 
c         \sum_n \sum_m 1/(4\pi) j_n(k|S|) Y_l^m*(S) h_n(k|T|) Y_l^m(T)
c
c
c-----------------------------------------------------------------------
c
c      h3dmpevalp: computes potential
c                 due to a multipole expansion
c                 at a collection of targets.
c
c      h3dmpevalg: computes potential and gradients
c                          due to a multipole expansion
c                          at a collection of targets
c
c      h3dformmpc: creates multipole expansion due to 
c                 a collection of charges
c
c      h3dformmpd: creates multipole expansion due to 
c                 a collection of dipoles
c
c      h3dformmpcd: creates multipole expansion due
c                                to a collection of charges
c                                and dipoles
c
c      h3dtaevalp: computes potential
c                 due to a local expansion
c                 at a collection of targets.
c
c      h3dtaevalg: computes potential and gradients
c                          due to a local expansion
c                          at a collection of targets
c
c      h3dformtac: creates local expansion due to 
c                 a collection of charges
c
c      h3dformtad: creates local expansion due to 
c                 a collection of dipoles
c
c      h3dformtacd: creates local expansion due
c                                to a collection of charges
c                                and dipoles
c
c**********************************************************************
      subroutine h3dmpevalp(nd,zk,rscale,center,mpole,nterms,ztarg,
     1            ntarg,pot,wlege,nlege,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential
c     of an outgoing partial wave expansion and adds to existing
c     quantities.
c
c     pot = pot + sum sum  mpole(n,m) h_n(k r) Y_nm(theta,phi)
c                  n   m
c                 
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision 
c           where boxsize(0) is the size of the computation domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     zk     :    Helmholtz parameter
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    multipole expansion in 2d matrix format
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c     thresh :    threshold for computing outgoing expansion,
c                 potential at target won't be updated if
c                 |t - c| <= thresh, where t is the target
c                 location and, and c is the expansion center
c                 location
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
c
cc      calling sequence variables
c
      integer *8 ntarg,nterms,nlege,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      complex *16 zk,pot(nd,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(*),thresh

c
cc      temporary variables
c
      integer *8 idim
      complex *16, allocatable :: ephi(:),fhs(:)
      real *8, allocatable :: ynm(:,:)
      real *8 zdiff(3),done
      real *8 ctheta,stheta,r,theta,phi,cphi,sphi
      complex *16 ephi1,ur,utheta,uphi
      complex *16 eye
      complex *16 ztmp1,ztmp2,ztmp3,ztmpsum,z
      complex *16 fhder
      integer *8 itarg,i,m,n,ifder
      data eye/(0.0d0,1.0d0)/

      done = 1
      ifder = 0

      allocate(ephi(-nterms-1:nterms+1))
      allocate(fhs(0:nterms))
      allocate(ynm(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta= dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
        if (r.lt.thresh)  goto 1000
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms+1
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions:
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
c
c
c     get the Hankel functions:
c
        z=zk*r
        call h3dall(nterms,z,rscale,fhs,ifder,fhder)

        do idim=1,nd
          pot(idim,itarg)=pot(idim,itarg)+mpole(idim,0,0)*fhs(0)
        enddo
        do n=1,nterms
          ztmp1 = fhs(n)*ynm(n,0)
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+mpole(idim,n,0)*ztmp1
          enddo
          do m=1,n
            ztmp1=fhs(n)*ynm(n,m)
            do idim=1,nd
              ztmp2 = mpole(idim,n,m)*ephi(m) 
              ztmp3 = mpole(idim,n,-m)*ephi(-m)
              ztmpsum = ztmp2+ztmp3
              pot(idim,itarg)=pot(idim,itarg)+ztmp1*ztmpsum
            enddo
          enddo
        enddo
 1000 continue        
      enddo

      return
      end
c
c
c
c
c
c
c**********************************************************************
      subroutine h3dmpevalg(nd,zk,rscale,center,mpole,nterms,ztarg,
     1            ntarg,pot,grad,wlege,nlege,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential, and gradient
c     of an outgoing partial wave expansion and adds to existing
c     quantities.
c
c     pot = pot + sum sum  mpole(n,m) h_n(k r) Y_nm(theta,phi)
c                  n   m
c                 
c     grad = grad + Gradient( sum sum  mpole(n,m) h_n(k r) Y_nm(theta,phi))
c                              n   m
c      If r < thresh 
c          then the subroutine does not update the potential and gradient
c          (recommended value = boxsize(0)*machine precision
c            where boxsize(0) is the size of the computational domain) 
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     zk     :    Helmholtz parameter
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    multipole expansion
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c     thresh :    threshold for computing outgoing expansion,
c                 potential at target won't be updated if
c                 |t - c| <= thresh, where t is the target
c                 location and, and c is the expansion center
c                 location
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad    :   updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
c
cc      calling sequence variables
c
      integer *8 ntarg,nterms,nlege,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      complex *16 zk,pot(nd,ntarg),grad(nd,3,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(*),thresh

c
cc      temporary variables
c
      complex *16, allocatable :: ephi(:),fhs(:),fhder(:)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      real *8 zdiff(3),done
      real *8 r, theta,phi,ctheta,stheta,cphi,sphi
      real *8 rx,ry,rz
      real *8 phix,phiy,phiz
      real *8 thetax,thetay,thetaz,dtmp
      complex *16 ephi1,ur(nd),utheta(nd),uphi(nd)
      complex *16 eye
      complex *16 ztmp1,ztmp2,ztmp3,ztmpsum,z
      complex *16 ztmp4,ztmp5,ztmp6
      integer *8 itarg,i,m,n,ifder,idim
      data eye/(0.0d0,1.0d0)/

      done = 1
      ifder = 1

      allocate(ephi(-nterms-1:nterms+1))
      allocate(fhs(0:nterms),fhder(0:nterms))
      allocate(ynm(0:nterms,0:nterms))
      allocate(ynmd(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta) 
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
        if (r.lt.thresh) goto 1000
c        
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms+1
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions:
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r
        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r
        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0
c
c
c
c     get the Hankel functions:
c
        z=zk*r
        call h3dall(nterms,z,rscale,fhs,ifder,fhder)

c     initialize computed values and 
c     scale derivatives of Hankel functions so that they are
c     derivatives with respect to r.
c
        do n=0,nterms
          fhder(n)=fhder(n)*zk
        enddo

        do idim=1,nd
          ur(idim) = mpole(idim,0,0)*fhder(0)
          utheta(idim) = 0.0d0
          uphi(idim) = 0.0d0
          pot(idim,itarg)=pot(idim,itarg)+mpole(idim,0,0)*fhs(0)
        enddo

        do n=1,nterms
          ztmp1 = fhs(n)*ynm(n,0)
          ztmp2 = fhder(n)*ynm(n,0)
          ztmp3 = -fhs(n)*ynmd(n,0)*stheta
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+mpole(idim,n,0)*ztmp1
            ur(idim) = ur(idim) + mpole(idim,n,0)*ztmp2
            utheta(idim) = utheta(idim) + mpole(idim,n,0)*ztmp3
          enddo
          do m=1,n
            ztmp1=fhs(n)*ynm(n,m)*stheta
            ztmp4 = fhder(n)*ynm(n,m)*stheta
            ztmp5 = -fhs(n)*ynmd(n,m)
            ztmp6 = eye*m*fhs(n)*ynm(n,m)

            do idim=1,nd
              ztmp2 = mpole(idim,n,m)*ephi(m) 
              ztmp3 = mpole(idim,n,-m)*ephi(-m)
              ztmpsum = ztmp2+ztmp3
              pot(idim,itarg)=pot(idim,itarg)+ztmp1*ztmpsum
              ur(idim) = ur(idim) + ztmp4*ztmpsum
              utheta(idim) = utheta(idim) + ztmp5*ztmpsum
              ztmpsum = ztmp2 - ztmp3
              uphi(idim) = uphi(idim) + ztmp6*ztmpsum
            enddo
          enddo
        enddo
        do idim=1,nd
          grad(idim,1,itarg) = grad(idim,1,itarg) + ur(idim)*rx + 
     1               utheta(idim)*thetax + uphi(idim)*phix
          grad(idim,2,itarg) = grad(idim,2,itarg) + ur(idim)*ry + 
     1               utheta(idim)*thetay + uphi(idim)*phiy
          grad(idim,3,itarg) = grad(idim,3,itarg) + ur(idim)*rz + 
     1               utheta(idim)*thetaz + uphi(idim)*phiz
        enddo
 1000 continue        
      enddo

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dformmpc(nd,zk,rscale,sources,charge,
     1            ns,center,nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Adds to multipole (h) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(ns)      : charge strengths
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the h-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 charge(nd,ns)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:)
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16, allocatable :: fjs(:),fjder(:),ephi(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder,idim

      ifder=0
      allocate(fjs(0:nterms),fjder(0:nterms),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)

c
c     get Bessel functions
c
        z=zk*r
        call besseljs3d(nterms,z,rscale,fjs,ifder,fjder)
c
c
c     multiply all jn by charge strength and (i*k).
c
        do n = 0,nterms
          fjs(n) = fjs(n)*zkeye
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c       1/(4\pi) e^( i k r}/r = 
c         (ik) \sum_n \sum_m 1/(4\pi) j_n(k|S|) Ylm*(S) h_n(k|T|)Ylm(T)
c
c     so contribution is 1/(4\pi) j_n(k|S|) times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c     The factor (i*k) is taken care of already above
c 
        do idim=1,nd
          mpole(idim,0,0)= mpole(idim,0,0) + fjs(0)*charge(idim,isrc)
        enddo
        do n=1,nterms
          ztmp = ynm(n,0)*fjs(n)
          do idim=1,nd
            mpole(idim,n,0)= mpole(idim,n,0) + ztmp*charge(idim,isrc)
          enddo
          do m=1,n
            ztmp=ynm(n,m)*fjs(n)
            do idim=1,nd
              mpole(idim,n,m)= mpole(idim,n,m) +
     1           ztmp*ephi(-m)*charge(idim,isrc)
              mpole(idim,n,-m)= mpole(idim,n,-m) + 
     1           ztmp*ephi(m)*charge(idim,isrc)
            enddo
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dformmpd(nd,zk,rscale,sources,
     1            dipvec,ns,center,nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Adds to multipole (h) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     dipvec(3,ns)    : dipole orientation vectors
C     ns              : number of sources
C     center(3)       : expansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the h-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 dipvec(nd,3,ns)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16, allocatable :: ephi(:),fjs(:),fjder(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye,ztmp1
      complex *16 fjsuse
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8 rx,thetax,phix,ry,thetay,phiy,rz,thetaz,phiz
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 ux,uy,uz,ur,utheta,uphi,zzz
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder,idim

      ifder=1

      allocate(fjs(0:nterms+1),fjder(0:nterms+1),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms),ynmd(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)

c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c     In thetax, thetaty, phix, phiy we leave out the 1/r factors in the 
c     change of variables to avoid blow-up at the origin.
c     For the n=0 mode, it is not relevant. For n>0 modes,
c     we use the recurrence relation 
c
c     (2n+1)fjs_n(kr)/(kr) = fjs(n+1)*rscale + fjs(n-1)/rscale
c
c     to avoid division by r. The variable fjsuse is set to fjs(n)/r:
c
c           fjsuse = fjs(n+1)*rscale + fjs(n-1)/rscale
c	    fjsuse = wavek*fjsuse/(2*n+1.0d0)
c

        rx = stheta*cphi
        thetax = ctheta*cphi
        phix = -sphi

        ry = stheta*sphi
        thetay = ctheta*sphi
        phiy = cphi

        rz = ctheta
        thetaz = -stheta
        phiz = 0.0d0
        
        
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     get Bessel functions:
c
        z=zk*r
        call besseljs3d(nterms+1,z,rscale,fjs,ifder,fjder)
c
c
c     multiply all jn by  (i*k).
c
        do n = 0,nterms
          fjs(n) = fjs(n)*zkeye
          fjder(n) = fjder(n)*zkeye*zk
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c       1/(4\pi) e^( i k r}/r = 
c         (ik) \sum_n \sum_m 1/(4\pi) j_n(k|S|) Ylm*(S) h_n(k|T|)Ylm(T)
c
c     so contribution is 1/(4\pi) j_n(k|S|) times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c     The factor (i*k) is taken care of already above
c

        ur = ynm(0,0)*fjder(0)
        do idim=1,nd
          zzz = ur*(dipvec(idim,1,isrc)*rx + dipvec(idim,2,isrc)*ry +
     1          dipvec(idim,3,isrc)*rz)
          mpole(idim,0,0)= mpole(idim,0,0)+ zzz
        enddo
        do n=1,nterms
          fjsuse = fjs(n+1)*rscale + fjs(n-1)/rscale
          fjsuse = fjsuse*zk/(2*n+1.0d0)
          ur = ynm(n,0)*fjder(n)
          utheta = -fjsuse*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax
          uy = ur*ry + utheta*thetay
          uz = ur*rz + utheta*thetaz
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy +
     1               dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + zzz 
          enddo
          do m=1,n
            ur = fjder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fjsuse*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fjsuse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              mpole(idim,n, m)= mpole(idim,n, m) + zzz
            enddo

            ur = fjder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fjsuse*ynmd(n,m)
            uphi = eye*m*ephi(m)*fjsuse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux+dipvec(idim,2,isrc)*uy + 
     1           dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m) + 
     1           zzz
            enddo
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
c**********************************************************************
c
c
c
c
C***********************************************************************
      subroutine h3dformmpcd(nd,zk,rscale,sources,charge,
     1            dipvec,ns,center,nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Adds to multipole (h) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(ns)      : charge strengths
C     dipvec(3,ns)    : dipole orientation vectors
C     ns              : number of sources
C     center(3)       : expansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the h-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 charge(nd,ns)
      complex *16 dipvec(nd,3,ns)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16, allocatable :: ephi(:),fjs(:),fjder(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye,ztmp1
      complex *16 fjsuse
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8 rx,thetax,phix,ry,thetay,phiy,rz,thetaz,phiz
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 ux,uy,uz,ur,utheta,uphi,zzz
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder,idim

      ifder=1

      allocate(fjs(0:nterms+1),fjder(0:nterms+1),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms),ynmd(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)

c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c     In thetax, thetaty, phix, phiy we leave out the 1/r factors in the 
c     change of variables to avoid blow-up at the origin.
c     For the n=0 mode, it is not relevant. For n>0 modes,
c     we use the recurrence relation 
c
c     (2n+1)fjs_n(kr)/(kr) = fjs(n+1)*rscale + fjs(n-1)/rscale
c
c     to avoid division by r. The variable fjsuse is set to fjs(n)/r:
c
c           fjsuse = fjs(n+1)*rscale + fjs(n-1)/rscale
c	    fjsuse = wavek*fjsuse/(2*n+1.0d0)
c

        rx = stheta*cphi
        thetax = ctheta*cphi
        phix = -sphi

        ry = stheta*sphi
        thetay = ctheta*sphi
        phiy = cphi

        rz = ctheta
        thetaz = -stheta
        phiz = 0.0d0
        
        
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     get Bessel functions:
c
        z=zk*r
        call besseljs3d(nterms+1,z,rscale,fjs,ifder,fjder)
c
c
c     multiply all jn by  (i*k).
c
        do n = 0,nterms
          fjs(n) = fjs(n)*zkeye
          fjder(n) = fjder(n)*zkeye*zk
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) e^( i k r}/r = 
c         (ik) \sum_n \sum_m 1/(4\pi) j_n(k|S|) Ylm*(S) h_n(k|T|)Ylm(T)
c
c     so contribution is 1/(4\pi) j_n(k|S|) times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c     The factor (i*k) is taken care of already above
c

        ur = ynm(0,0)*fjder(0)
        do idim=1,nd
          zzz = ur*(dipvec(idim,1,isrc)*rx + dipvec(idim,2,isrc)*ry +
     1          dipvec(idim,3,isrc)*rz)
          mpole(idim,0,0)= mpole(idim,0,0) + 
     1        fjs(0)*charge(idim,isrc) + zzz
        enddo
        do n=1,nterms
          fjsuse = fjs(n+1)*rscale + fjs(n-1)/rscale
          fjsuse = fjsuse*zk/(2*n+1.0d0)
          ur = ynm(n,0)*fjder(n)
          utheta = -fjsuse*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax
          uy = ur*ry + utheta*thetay
          uz = ur*rz + utheta*thetaz
          ztmp = ynm(n,0)*fjs(n)
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy +
     1               dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + ztmp*charge(idim,isrc)+
     1                    zzz       
          enddo
          do m=1,n
            ztmp=ynm(n,m)*stheta*fjs(n)
            ztmp1 = ztmp*ephi(-m)
            ur = fjder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fjsuse*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fjsuse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              mpole(idim,n, m)= mpole(idim,n, m) +
     1        ztmp1*charge(idim,isrc) + zzz
            enddo

            ztmp1=ztmp*ephi(m)
            ur = fjder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fjsuse*ynmd(n,m)
            uphi = eye*m*ephi(m)*fjsuse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux+dipvec(idim,2,isrc)*uy + 
     1           dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m) + 
     1           ztmp1*charge(idim,isrc) + zzz
            enddo
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
c**********************************************************************
      subroutine h3dtaevalp(nd,zk,rscale,center,locexp,nterms,ztarg,
     1            ntarg,pot,wlege,nlege)
c**********************************************************************
c
c     This subroutine evaluates the potential
c     of an incoming partial wave expansion and adds to existing
c     quantities.
c
c     pot = pot + sum sum  locexp(n,m) j_n(k r) Y_nm(theta,phi)
c                  n   m
c                 
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c            where boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of local expansions
c     zk     :    Helmholtz parameter
c     rscale :    scaling parameter 
c     center :    expansion center
c     lcoexp :    local expansion
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
c
cc      calling sequence variables
c
      integer *8 ntarg,nterms,nlege,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      complex *16 zk,pot(nd,ntarg)
      complex *16 locexp(nd,0:nterms,-nterms:nterms)
      real *8 wlege(*)

c
cc      temporary variables
c
      complex *16, allocatable :: ephi(:),fjs(:)
      real *8, allocatable :: ynm(:,:)
      real *8 zdiff(3),done
      real *8 ctheta,stheta,r,theta,phi,cphi,sphi
      complex *16 ephi1,ur,utheta,uphi
      complex *16 eye
      complex *16 ztmp1,ztmp2,ztmp3,ztmpsum,z
      complex *16 fjder
      integer *8 itarg,i,m,n,ifder,idim
      data eye/(0.0d0,1.0d0)/

      done = 1
      ifder = 0

      allocate(ephi(-nterms-1:nterms+1))
      allocate(fjs(0:nterms))
      allocate(ynm(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta= dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms+1
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions:
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
c
c
c     get the Bessel functions:
c
        z=zk*r
        call besseljs3d(nterms,z,rscale,fjs,ifder,fjder)

        do idim=1,nd
          pot(idim,itarg)=pot(idim,itarg)+locexp(idim,0,0)*fjs(0)
        enddo
        do n=1,nterms
          ztmp1 = fjs(n)*ynm(n,0)
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+locexp(idim,n,0)*ztmp1
          enddo
          do m=1,n
	        ztmp1=fjs(n)*ynm(n,m)
            do idim=1,nd
              ztmpsum = locexp(idim,n,m)*ephi(m) + 
     1            locexp(idim,n,-m)*ephi(-m)
              pot(idim,itarg)=pot(idim,itarg)+ztmp1*ztmpsum
            enddo
          enddo
        enddo
 1000 continue        
      enddo

      return
      end
c
c
c
c
c
c
c**********************************************************************
      subroutine h3dtaevalg(nd,zk,rscale,center,locexp,nterms,
     1            ztarg,ntarg,pot,grad,wlege,nlege)
c**********************************************************************
c
c     This subroutine evaluates the potential, and gradient
c     of an incoming partial wave expansion and adds to existing
c     quantities.
c
c     pot = pot + sum sum  locexp(n,m) j_n(k r) Y_nm(theta,phi)
c                  n   m
c                 
c     grad = grad + Gradient( sum sum  locexp(n,m) j_n(k r) Y_nm(theta,phi))
c                              n   m
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of local expansions
c     zk     :    Helmholtz parameter
c     rscale :    scaling parameter 
c     center :    expansion center
c     locexp :    multipole expansion
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad    :   updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
c
cc      calling sequence variables
c
      integer *8 ntarg,nterms,nlege,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      complex *16 zk,pot(nd,ntarg),grad(nd,3,ntarg)
      complex *16 locexp(nd,0:nterms,-nterms:nterms)
      real *8 wlege(*),thresh

c
cc      temporary variables
c
      complex *16, allocatable :: ephi(:),fjs(:),fjder(:)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      real *8 zdiff(3),done
      real *8 r, theta,phi,ctheta,stheta,cphi,sphi
      real *8 rx,ry,rz
      real *8 phix,phiy,phiz
      real *8 thetax,thetay,thetaz,dtmp
      complex *16 ephi1,ur(nd),utheta(nd),uphi(nd)
      complex *16 fjsuse
      complex *16 eye
      complex *16 ztmp1,ztmp2,ztmp3,ztmpsum,z
      complex *16 ztmp4,ztmp5,ztmp6
      integer *8 itarg,i,m,n,ifder,idim
      data eye/(0.0d0,1.0d0)/

      done = 1
      ifder = 1

      allocate(ephi(-nterms-1:nterms+1))
      allocate(fjs(0:nterms+1),fjder(0:nterms+1))
      allocate(ynm(0:nterms,0:nterms))
      allocate(ynmd(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta) 
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms+1
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions:
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
        rx = stheta*cphi
        thetax = ctheta*cphi
        phix = -sphi
        ry = stheta*sphi
        thetay = ctheta*sphi
        phiy = cphi
        rz = ctheta
        thetaz = -stheta
        phiz = 0.0d0
c
c
c
c     get the Bessel functions:
c
        z=zk*r
        call besseljs3d(nterms+1,z,rscale,fjs,ifder,fjder)

c     initialize computed values and 
c     scale derivatives of Hankel functions so that they are
c     derivatives with respect to r.
c
        do n=0,nterms
          fjder(n)=fjder(n)*zk
        enddo

        do idim=1,nd
          ur(idim) = locexp(idim,0,0)*fjder(0)
          utheta(idim) = 0.0d0
          uphi(idim) = 0.0d0
          pot(idim,itarg)=pot(idim,itarg)+locexp(idim,0,0)*fjs(0)
        enddo

        do n=1,nterms
          fjsuse = fjs(n+1)*rscale + fjs(n-1)/rscale
          fjsuse = fjsuse*zk/(2*n+1.0d0)
          ztmp1 = fjs(n)*ynm(n,0)
          ztmp2 = fjder(n)*ynm(n,0)
          ztmp3 = -fjsuse*ynmd(n,0)*stheta
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+locexp(idim,n,0)*ztmp1
	        ur(idim) = ur(idim) + locexp(idim,n,0)*ztmp2
            utheta(idim) = utheta(idim) + locexp(idim,n,0)*ztmp3
          enddo
          do m=1,n
	        ztmp1=fjs(n)*ynm(n,m)*stheta
            ztmp4 = fjder(n)*ynm(n,m)*stheta
            ztmp5 = -fjsuse*ynmd(n,m)
            ztmp6 = eye*m*fjsuse*ynm(n,m)

            do idim=1,nd
              ztmp2 = locexp(idim,n,m)*ephi(m) 
	          ztmp3 = locexp(idim,n,-m)*ephi(-m)
	          ztmpsum = ztmp2+ztmp3
              pot(idim,itarg)=pot(idim,itarg) + ztmp1*ztmpsum
	          ur(idim) = ur(idim) + ztmp4*ztmpsum
	          utheta(idim) = utheta(idim) + ztmp5*ztmpsum
	          ztmpsum = ztmp2 - ztmp3
	          uphi(idim) = uphi(idim) + ztmp6*ztmpsum
            enddo
          enddo
        enddo
        do idim=1,nd
          grad(idim,1,itarg) = grad(idim,1,itarg)+ur(idim)*rx + 
     1          utheta(idim)*thetax + uphi(idim)*phix
          grad(idim,2,itarg) = grad(idim,2,itarg)+ur(idim)*ry + 
     1          utheta(idim)*thetay + uphi(idim)*phiy
          grad(idim,3,itarg) = grad(idim,3,itarg)+ur(idim)*rz + 
     1          utheta(idim)*thetaz + uphi(idim)*phiz

        enddo
      enddo

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dformtac(nd,zk,rscale,sources,charge,
     1            ns,center,nterms,locexp,wlege,nlege)
C***********************************************************************
C
C     Adds to local (j) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of local expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(ns)      : charge strengths
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     locexp          : coeffs of the j-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 charge(nd,ns)
      complex *16 locexp(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:)
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16, allocatable :: fhs(:),fhder(:),ephi(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder,idim

      ifder=0
      allocate(fhs(0:nterms),fhder(0:nterms),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)

c
c     get Hankel functions
c
        z=zk*r
        call h3dall(nterms,z,rscale,fhs,ifder,fhder)
c
c
c     multiply all hn by charge strength and 1/(4\pi)*(i*k).
c
        do n = 0,nterms
          fhs(n) = fhs(n)*zkeye
        enddo
c
c
c     Compute contribution to locexp coefficients.
c
        do idim=1,nd
          locexp(idim,0,0)= locexp(idim,0,0) + fhs(0)*charge(idim,isrc)
        enddo
        do n=1,nterms
          ztmp = ynm(n,0)*fhs(n)
          do idim=1,nd
            locexp(idim,n,0)= locexp(idim,n,0) + ztmp*charge(idim,isrc)
          enddo
          do m=1,n
            ztmp=ynm(n,m)*fhs(n)
            do idim=1,nd
              locexp(idim,n, m)= locexp(idim,n, m) + 
     1            ztmp*ephi(-m)*charge(idim,isrc)
              locexp(idim,n,-m)= locexp(idim,n,-m) + 
     1           ztmp*ephi(m)*charge(idim,isrc)
            enddo
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dformtad(nd,zk,rscale,sources,
     1            dipvec,ns,center,nterms,locexp,wlege,nlege)
C***********************************************************************
C
C     Adds to multipole (h) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of local expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     dipvec(3,ns)    : dipole orientation vectors
C     ns              : number of sources
C     center(3)       : expansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     locexp          : coeffs of the h-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 dipvec(nd,3,ns)
      complex *16 locexp(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16, allocatable :: ephi(:),fhs(:),fhder(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye,ztmp1
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8 rx,thetax,phix,ry,thetay,phiy,rz,thetaz,phiz
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 ux,uy,uz,ur,utheta,uphi,zzz
      integer *8 idim
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder

      ifder=1

      allocate(fhs(0:nterms),fhder(0:nterms),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms),ynmd(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)

c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c

        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r

        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r

        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0
        
        
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     get Hankel functions:
c
        z=zk*r
        call h3dall(nterms,z,rscale,fhs,ifder,fhder)
c
c
c     multiply all hn by 1/(4\pi) (i*k).
c
        do n = 0,nterms
          fhs(n) = fhs(n)*zkeye
          fhder(n) = fhder(n)*zkeye*zk
        enddo
c
c
c     Compute contribution to locexp coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) e^( i k r}/r = 
c         (ik) \sum_n \sum_m 1/(4\pi) j_n(k|T|) Ylm*(T) h_n(k|S|)Ylm(S)
c
c     so contribution is 1/(4\pi) j_n(k|S|) times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c     The factor (i*k) is taken care of already above
c

        ur = ynm(0,0)*fhder(0)
        do idim=1,nd
          zzz = ur*(dipvec(idim,1,isrc)*rx + dipvec(idim,2,isrc)*ry +
     1          dipvec(idim,3,isrc)*rz)
          locexp(idim,0,0)= locexp(idim,0,0)+zzz
        enddo
        do n=1,nterms
          ur = ynm(n,0)*fhder(n)
          utheta = -fhs(n)*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax
          uy = ur*ry + utheta*thetay
          uz = ur*rz + utheta*thetaz

          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy +
     1             dipvec(idim,3,isrc)*uz
            locexp(idim,n,0)= locexp(idim,n,0)+zzz   
          enddo
          do m=1,n
            ur = fhder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fhs(n)*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fhs(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              locexp(idim,n,m)= locexp(idim,n,m)+zzz
            enddo

            ur = fhder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fhs(n)*ynmd(n,m)
            uphi = eye*m*ephi(m)*fhs(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              locexp(idim,n,-m)= locexp(idim,n,-m)+
     1            zzz
            enddo
          enddo
        enddo
      enddo

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine h3dformtacd(nd,zk,rscale,sources,charge,
     1            dipvec,ns,center,nterms,locexp,wlege,nlege)
C***********************************************************************
C
C     Adds to multipole (h) expansion about CENTER due to NS sources 
C     located at SOURCES(3,*) 
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of local expansions
C     zk              : Helmholtz parameter 
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(ns)      : charge strengths
C     dipvec(3,ns)    : dipole orientation vectors
C     ns              : number of sources
C     center(3)       : expansion center
C     nterms          : order of multipole expansion
c     wlege           : precomputed array of scaling coeffs for Pnm
c     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     locexp          : coeffs of the h-expansion
c
c-----------------------------------------------------------------------
      implicit none
      integer *8 ns,nterms,nlege,nd
      complex *16 zk
      real *8 rscale,sources(3,ns),center(3),wlege(*)
      complex *16 charge(nd,ns)
      complex *16 dipvec(nd,3,ns)
      complex *16 locexp(nd,0:nterms,-nterms:nterms)
c
cc      temporary variables
c
c
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),ynmd(:,:)
      complex *16, allocatable :: ephi(:),fhs(:),fhder(:)
      complex *16 ephi1,ephi1inv
      complex *16 z,ztmp,zkeye,eye,ztmp1
      real *8 r,theta,phi
      real *8 ctheta,stheta,cphi,sphi
      real *8 rx,thetax,phix,ry,thetay,phiy,rz,thetaz,phiz
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 ux,uy,uz,ur,utheta,uphi,zzz
      integer *8 idim
      data eye/(0.0d0,1.0d0)/

      integer *8 isrc,i,m,n,ifder

      ifder=1

      allocate(fhs(0:nterms),fhder(0:nterms),ephi(-nterms:nterms))
      allocate(ynm(0:nterms,0:nterms),ynmd(0:nterms,0:nterms))

      zkeye = eye*zk*inv4pi


      do isrc=1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)

        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)

c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c

        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r

        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r

        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0
        
        
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        do i=2,nterms
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
c
c     get the associated Legendre functions
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
c
c     get Hankel functions:
c
        z=zk*r
        call h3dall(nterms,z,rscale,fhs,ifder,fhder)
c
c
c     multiply all hn by 1/(4\pi) (i*k).
c
        do n = 0,nterms
          fhs(n) = fhs(n)*zkeye
          fhder(n) = fhder(n)*zkeye*zk
        enddo
c
c
c     Compute contribution to locexp coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) e^( i k r}/r = 
c         (ik) \sum_n \sum_m 1/(4\pi) j_n(k|T|) Ylm*(T) h_n(k|S|)Ylm(S)
c
c     so contribution is 1/(4\pi) j_n(k|S|) times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c     The factor (i*k) is taken care of already above
c

        ur = ynm(0,0)*fhder(0)
        do idim=1,nd
          zzz = ur*(dipvec(idim,1,isrc)*rx + dipvec(idim,2,isrc)*ry +
     1          dipvec(idim,3,isrc)*rz)
          locexp(idim,0,0)= locexp(idim,0,0)+fhs(0)*charge(idim,isrc)+
     1       zzz
        enddo
        do n=1,nterms
          ur = ynm(n,0)*fhder(n)
          utheta = -fhs(n)*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax
          uy = ur*ry + utheta*thetay
          uz = ur*rz + utheta*thetaz

          ztmp = fhs(n)*ynm(n,0)
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy +
     1             dipvec(idim,3,isrc)*uz
            locexp(idim,n,0)= locexp(idim,n,0) + 
     1             ztmp*charge(idim,isrc) + zzz       
          enddo
          do m=1,n
            ztmp=ynm(n,m)*stheta*fhs(n)
            ztmp1 = ztmp*ephi(-m)

            ur = fhder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fhs(n)*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fhs(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              locexp(idim,n,m)= locexp(idim,n,m) + 
     1           ztmp1*charge(idim,isrc) + zzz
            enddo

            ztmp1 = ztmp*ephi(m)
            ur = fhder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fhs(n)*ynmd(n,m)
            uphi = eye*m*ephi(m)*fhs(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1             dipvec(idim,3,isrc)*uz
              locexp(idim,n,-m)= locexp(idim,n,-m) + 
     1             ztmp1*charge(idim,isrc) +  zzz
            enddo
          enddo
        enddo
      enddo

      return
      end
c

c
c      TESTING SUITE FOR STOKES KERNELS rotlet and doublet
c
      implicit none
      real *8 ztrg(3),source(3,20),targ(3,20),targ2(3,20)
      real *8 errgrad(3,20), pert(3), dmu(3), dnu(3)
      real *8 rlet(3), rvec(3)

      real *8, allocatable :: pot(:,:), pre(:), grad(:,:,:)
      real *8, allocatable :: pot2(:,:), pre2(:), grad2(:,:,:)
      real *8, allocatable :: pot3(:,:), pre3(:), grad3(:,:,:)
      real *8, allocatable :: pot4(:,:), pre4(:), grad4(:,:,:)
      real *8, allocatable :: pot_src(:,:),pre_src(:),grad_src(:,:,:)
      real *8, allocatable :: pot_diff(:,:), grad_diff(:,:,:)

      real *8, allocatable :: potl(:,:), gradl(:,:,:)

      real *8, allocatable :: stoklet(:,:), strslet(:,:)
      real *8, allocatable :: strsvec(:,:)
      real *8, allocatable :: charge(:,:), dipvec(:,:,:)
      real *8, allocatable :: rotstr(:,:), rotvec(:,:)
      real *8, allocatable :: doubstr(:,:), doubvec(:,:)
      real *8 df,done,pi,h,thresh,errmax,gave1,gave2,gave3


      integer *8 ipass(4)
      integer *8 istoklet, istress, irotlet, idoublet
      integer *8 i,j,k,nd,ns,nt,ntest,nd1,ier,isum
      integer *8 ifppgreg, ifppregtarg
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1
      pi=4.0*atan(done)
      call prini(6,13)
      write(*,*) "=========================================="
      write(*,*) "Testing suite for stokkernels rotlet and doublet"

      open(unit=33,file='print_testres.txt',access='append')

      ntest = 4
      do i=1,ntest
        ipass(i) = 0
      enddo


      ns = 12
      nt = 12

      allocate(stoklet(3,ns),strslet(3,ns),strsvec(3,ns))
      allocate(rotstr(3,ns),rotvec(3,ns))
      allocate(doubstr(3,ns),doubvec(3,ns))

      do i = 1,ns
         source(1,i) = cos(i*done)
         source(2,i) = cos(10*i*done)
         source(3,i) = cos(100*i*done)
         stoklet(1,i) = 0.0d0
         stoklet(2,i) = 0.0d0
         stoklet(3,i) = 0.0d0
         strslet(1,i) = 0.0d0
         strslet(2,i) = 0.0d0
         strslet(3,i) = 0.0d0
         strsvec(1,i) = 0.0d0
         strsvec(2,i) = 0.0d0
         strsvec(3,i) = 0.0d0
         rotstr(1,i) = sin(4*i*done)
         rotstr(2,i) = sin(44*i*done)
         rotstr(3,i) = sin(444*i*done)
         rotvec(1,i) = sin(5*i*done)
         rotvec(2,i) = sin(55*i*done)
         rotvec(3,i) = sin(555*i*done)
         doubstr(1,i) = sin(3*i*done)
         doubstr(2,i) = sin(33*i*done)
         doubstr(3,i) = sin(333*i*done)
         doubvec(1,i) = sin(4*i*done)
         doubvec(2,i) = sin(44*i*done)
         doubvec(3,i) = sin(444*i*done)
      enddo

c      call prin2('src *',source,3*ns)
c      call prin2('stoklet *',stoklet,3*ns)
c      call prin2('strslet *',strslet,3*ns)
c      call prin2('strsvec *',strsvec,3*ns)
c

      h = 1d-5
      pert(1) = cos(1000*done)
      pert(2) = cos(2000*done)
      pert(3) = cos(3000*done)

      do i = 1,nt
         targ(1,i) = cos(12*i*done)
         targ(2,i) = cos(123*i*done)
         targ(3,i) = cos(1234*i*done)
         targ2(1,i) = targ(1,i) + h*pert(1)
         targ2(2,i) = targ(2,i) + h*pert(2)
         targ2(3,i) = targ(3,i) + h*pert(3)
      enddo

      allocate(pot(3,nt),pre(nt),grad(3,3,nt))
      allocate(pot2(3,nt),pre2(nt),grad2(3,3,nt))
      allocate(pot3(3,nt),pre3(nt),grad3(3,3,nt))
      allocate(pot4(3,nt),pre4(nt),grad4(3,3,nt))
      allocate(pot_src(3,ns),pre_src(ns),grad_src(3,3,ns))
      allocate(pot_diff(3,nt))
      allocate(grad_diff(3,3,nt))

c     test gradient of rotlet formula

      thresh = 1d-15
      nd1 = 1

      do i = 1,nt
         pre(i) = 0
         pot(1,i) = 0
         pot(2,i) = 0
         pot(3,i) = 0
         grad(1,1,i) = 0
         grad(2,1,i) = 0
         grad(3,1,i) = 0
         grad(1,2,i) = 0
         grad(2,2,i) = 0
         grad(3,2,i) = 0
         grad(1,3,i) = 0
         grad(2,3,i) = 0
         grad(3,3,i) = 0
         pre2(i) = 0
         pot2(1,i) = 0
         pot2(2,i) = 0
         pot2(3,i) = 0
         grad2(1,1,i) = 0
         grad2(2,1,i) = 0
         grad2(3,1,i) = 0
         grad2(1,2,i) = 0
         grad2(2,2,i) = 0
         grad2(3,2,i) = 0
         grad2(1,3,i) = 0
         grad2(2,3,i) = 0
         grad2(3,3,i) = 0
         pre3(i) = 0
         pot3(1,i) = 0
         pot3(2,i) = 0
         pot3(3,i) = 0
         grad3(1,1,i) = 0
         grad3(2,1,i) = 0
         grad3(3,1,i) = 0
         grad3(1,2,i) = 0
         grad3(2,2,i) = 0
         grad3(3,2,i) = 0
         grad3(1,3,i) = 0
         grad3(2,3,i) = 0
         grad3(3,3,i) = 0
         pre4(i) = 0
         pot4(1,i) = 0
         pot4(2,i) = 0
         pot4(3,i) = 0
         grad4(1,1,i) = 0
         grad4(2,1,i) = 0
         grad4(3,1,i) = 0
         grad4(1,2,i) = 0
         grad4(2,2,i) = 0
         grad4(3,2,i) = 0
         grad4(1,3,i) = 0
         grad4(2,3,i) = 0
         grad4(3,3,i) = 0
      enddo

      do i = 1,ns
         pre_src(i) = 0
         pot_src(1,i) = 0
         pot_src(2,i) = 0
         pot_src(3,i) = 0
         grad_src(1,1,i) = 0
         grad_src(2,1,i) = 0
         grad_src(3,1,i) = 0
         grad_src(1,2,i) = 0
         grad_src(2,2,i) = 0
         grad_src(3,2,i) = 0
         grad_src(1,3,i) = 0
         grad_src(2,3,i) = 0
         grad_src(3,3,i) = 0
      enddo

      errmax = 0

      istoklet = 0
      istress = 0
      irotlet = 1
      idoublet = 1
      call st3ddirectstokstrsrotdoubg(nd1,source,stoklet,istress,
     1     strslet,strsvec,irotlet,rotstr,rotvec,
     2     idoublet,doubstr,doubvec,
     3     ns,targ,nt,pot,pre,grad,thresh)
      call st3ddirectstokstrsrotdoubg(nd1,source,stoklet,istress,
     1     strslet,strsvec,irotlet,rotstr,rotvec,
     2     idoublet,doubstr,doubvec,
     3     ns,targ2,nt,pot2,pre2,grad2,thresh)


      do i = 1,nt
         df = pot2(1,i) - pot(1,i)
         gave1 = (grad(1,1,i) + grad2(1,1,i))/2.0d0
         gave2 = (grad(2,1,i) + grad2(2,1,i))/2.0d0
         gave3 = (grad(3,1,i) + grad2(3,1,i))/2.0d0         
         errgrad(1,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(2,i) - pot(2,i)
         gave1 = (grad(1,2,i) + grad2(1,2,i))/2.0d0
         gave2 = (grad(2,2,i) + grad2(2,2,i))/2.0d0
         gave3 = (grad(3,2,i) + grad2(3,2,i))/2.0d0         
         errgrad(2,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(3,i) - pot(3,i)
         gave1 = (grad(1,3,i) + grad2(1,3,i))/2.0d0
         gave2 = (grad(2,3,i) + grad2(2,3,i))/2.0d0
         gave3 = (grad(3,3,i) + grad2(3,3,i))/2.0d0         
         errgrad(3,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         errmax = max(errmax,errgrad(1,i))
         errmax = max(errmax,errgrad(2,i))
         errmax = max(errmax,errgrad(3,i))                  
         
      enddo

      call prin2('err grad (rotlet+doublet) * direct',errgrad,3*nt)

      if (errmax .lt. 1d-6) ipass(1) = 1

      errmax = 0
      ifppgreg = 1
      ifppregtarg = 3
      call stfmm3d(nd1,1d-12,ns,source,istoklet,stoklet,
     1     istress,strslet,strsvec,
     2     irotlet,rotstr,rotvec,
     3     idoublet,doubstr,doubvec,
     4     ifppgreg,pot_src,pre_src,grad_src,
     5     nt,targ,ifppregtarg,pot3,pre3,grad3,ier)
      call stfmm3d(nd1,1d-12,ns,source,istoklet,stoklet,
     1     istress,strslet,strsvec,
     2     irotlet,rotstr,rotvec,
     3     idoublet,doubstr,doubvec,
     4     ifppgreg,pot_src,pre_src,grad_src,
     5     nt,targ2,ifppregtarg,pot4,pre4,grad4,ier)

      do i = 1,nt
         df = pot4(1,i) - pot3(1,i)
         gave1 = (grad3(1,1,i) + grad4(1,1,i))/2.0d0
         gave2 = (grad3(2,1,i) + grad4(2,1,i))/2.0d0
         gave3 = (grad3(3,1,i) + grad4(3,1,i))/2.0d0
         errgrad(1,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot4(2,i) - pot3(2,i)
         gave1 = (grad3(1,2,i) + grad4(1,2,i))/2.0d0
         gave2 = (grad3(2,2,i) + grad4(2,2,i))/2.0d0
         gave3 = (grad3(3,2,i) + grad4(3,2,i))/2.0d0
         errgrad(2,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot4(3,i) - pot3(3,i)
         gave1 = (grad3(1,3,i) + grad4(1,3,i))/2.0d0
         gave2 = (grad3(2,3,i) + grad4(2,3,i))/2.0d0
         gave3 = (grad3(3,3,i) + grad4(3,3,i))/2.0d0
         errgrad(3,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         errmax = max(errmax,errgrad(1,i))
         errmax = max(errmax,errgrad(2,i))
         errmax = max(errmax,errgrad(3,i))
      enddo

      call prin2('err grad (rotlet+doublet) * fmm',errgrad,3*nt)

      if (errmax .lt. 1d-6) ipass(2) = 1

      errmax = 0
      do i = 1,nt
         do j = 1,3
            pot_diff(j,i) = abs(pot3(j,i) - pot(j,i))
            errmax = max(errmax,pot_diff(j,i))
         enddo
      enddo

      call prin2('pot diff',pot_diff,3*nt)

      if (errmax .lt. 1d-10) ipass(3) = 1

      errmax = 0
      do i = 1,nt
         do j = 1,3
            do k = 1,3
               grad_diff(k,j,i) = abs(grad3(k,j,i) - grad(k,j,i))
               errmax = max(errmax,grad_diff(k,j,i))
            enddo
         enddo
      enddo

      call prin2('grad diff',grad_diff,3*3*nt)

      if (errmax .lt. 1d-10) ipass(4) = 1

      isum = 0
      do i=1,ntest
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,
     2   ' tests in stokkernels rotlet doublet testing suite'
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,
     2   ' tests in stokkernels rotlet doublet testing suite'
      close(33)


      stop
      end
c
c
c
c
c
c
      subroutine errprint(pot,opot,fld,ofld,errs)
      implicit real *8 (a-h,o-z)
      real *8 pot,opot,fld(3),ofld(3)
      real *8 errs(2)
 1000  format(4D15.5)
      err = 0
      ddd = 0
      err = err + abs(fld(1)-ofld(1))**2
      err = err + abs(fld(2)-ofld(2))**2
      err = err + abs(fld(3)-ofld(3))**2
      ddd = ddd + abs(ofld(1))**2
      ddd = ddd + abs(ofld(2))**2
      ddd = ddd + abs(ofld(3))**2
      err = sqrt(err)
      ddd = sqrt(ddd)

      err1 = abs(pot-opot)/abs(opot)
      write(*,'(a,e11.4,a,e11.4)')
     1     'pot error=',err1,'   grad error=',err/ddd

      errs(1) = err1
      errs(2) = err/ddd

      return
      end

C  Copyright (c) 1992-2013 The University of Tennessee and The University
C                          of Tennessee Research Foundation.  All rights
C                          reserved.
C  Copyright (c) 2000-2013 The University of California Berkeley. All
C                          rights reserved.
C  Copyright (c) 2006-2013 The University of Colorado Denver.  All rights
C                          reserved.
C  
C  $COPYRIGHT$
C  
C  Additional copyrights may follow
C  
C  $HEADER$
C  
C  Redistribution and use in source and binary forms, with or without
C  modification, are permitted provided that the following conditions are
C  met:
C  
C  - Redistributions of source code must retain the above copyright
C    notice, this list of conditions and the following disclaimer.
C  
C  - Redistributions in binary form must reproduce the above copyright
C    notice, this list of conditions and the following disclaimer listed
C    in this license in the documentation and/or other materials
C    provided with the distribution.
C  
C  - Neither the name of the copyright holders nor the names of its
C    contributors may be used to endorse or promote products derived from
C    this software without specific prior written permission.
C  
C  The copyright holders provide no reassurances that the source code
C  provided does not infringe any patent, copyright, or any other
C  intellectual property rights of third parties.  The copyright holders
C  disclaim any liability to any recipient for claims brought against
C  recipient by any third party for infringement of that parties
C  intellectual property rights.
C  
C  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
C  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
C  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
C  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
C  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
C  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
C  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
C  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
C  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
C  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
C  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
C
       DOUBLE PRECISION FUNCTION DLARAN( ISEED )
*
*  -- LAPACK auxiliary routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     February 29, 1992
*
*     .. Array Arguments ..
      INTEGER            ISEED( 4 )
*     ..
*
*  Purpose
*  =======
*
*  DLARAN returns a random real number from a uniform (0,1)
*  distribution.
*
*  Arguments
*  =========
*
*  ISEED   (input/output) INTEGER array, dimension (4)
*          On entry, the seed of the random number generator; the array
*          elements must be between 0 and 4095, and ISEED(4) must be
*          odd.
*          On exit, the seed is updated.
*
*  Further Details
*  ===============
*
*  This routine uses a multiplicative congruential method with modulus
*  2**48 and multiplier 33952834046453 (see G.S.Fishman,
*  'Multiplicative congruential random number generators with modulus
*  2**b: an exhaustive analysis for b = 32 and a partial analysis for
*  b = 48', Math. Comp. 189, pp 331-344, 1990).
*
*  48-bit integers are stored in 4 integer array elements with 12 bits
*  per element. Hence the routine is portable across machines with
*  integers of 32 bits or more.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            M1, M2, M3, M4
      PARAMETER          ( M1 = 494, M2 = 322, M3 = 2508, M4 = 2549 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      INTEGER            IPW2
      DOUBLE PRECISION   R
      PARAMETER          ( IPW2 = 4096, R = ONE / IPW2 )
*     ..
*     .. Local Scalars ..
      INTEGER            IT1, IT2, IT3, IT4
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MOD
*     ..
*     .. Executable Statements ..
*
*     multiply the seed by the multiplier modulo 2**48
*
      IT4 = ISEED( 4 )*M4
      IT3 = IT4 / IPW2
      IT4 = IT4 - IPW2*IT3
      IT3 = IT3 + ISEED( 3 )*M4 + ISEED( 4 )*M3
      IT2 = IT3 / IPW2
      IT3 = IT3 - IPW2*IT2
      IT2 = IT2 + ISEED( 2 )*M4 + ISEED( 3 )*M3 + ISEED( 4 )*M2
      IT1 = IT2 / IPW2
      IT2 = IT2 - IPW2*IT1
      IT1 = IT1 + ISEED( 1 )*M4 + ISEED( 2 )*M3 + ISEED( 3 )*M2 +
     $      ISEED( 4 )*M1
      IT1 = MOD( IT1, IPW2 )
*
*     return updated seed
*
      ISEED( 1 ) = IT1
      ISEED( 2 ) = IT2
      ISEED( 3 ) = IT3
      ISEED( 4 ) = IT4
*
*     convert 48-bit integer to a real number in the interval (0,1)
*
      DLARAN = R*( DBLE( IT1 )+R*( DBLE( IT2 )+R*( DBLE( IT3 )+R*
     $         ( DBLE( IT4 ) ) ) ) )
      RETURN
*
*     End of DLARAN
*
      END

      implicit real *8 (a-h,o-z)
      integer *8 ns,nt,nd,nttest,i,j,l,ntests
      integer *8 ifE,ifdivE,ifcurlE,ifa_vect,ifb_vect,iflambda,ier
      double complex zk
      double precision, allocatable :: sources(:,:),targs(:,:)
      double complex, allocatable :: a_vect(:,:,:),lambda(:,:)
      double complex, allocatable :: b_vect(:,:,:)
      double complex, allocatable :: E(:,:,:),divE(:,:),curlE(:,:,:)
      double complex, allocatable :: Eex(:,:,:),divEex(:,:)
      double complex, allocatable :: curlEex(:,:,:)
      double complex ima
      double precision thresh
      double precision t1,t2,omp_get_wtime
      integer *8 ipass(10)
      data ima/(0.0d0,1.0d0)/

      ns = 4001
      nt = 3998

      nd = 2
      zk = 1.1d0 + ima*0.1d0

      allocate(sources(3,ns))
      allocate(a_vect(nd,3,ns),b_vect(nd,3,ns),lambda(nd,ns))

      allocate(targs(3,nt),E(nd,3,nt),divE(nd,nt),curlE(nd,3,nt))

      nttest = 10
      allocate(Eex(nd,3,nttest),divEex(nd,nttest),curlEex(nd,3,nttest))


c
cc  generate sourcrs in the unit cube
c

c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l)
      do i=1,ns 
        sources(1,i) = hkrand(0)**2
        sources(2,i) = hkrand(0)**2
        sources(3,i) = hkrand(0)**2
        do l=1,3
          do j=1,nd
            a_vect(j,l,i) = hkrand(0) + ima*hkrand(0)
            b_vect(j,l,i) = hkrand(0) + ima*hkrand(0)
          enddo
        enddo

        do j=1,nd
          lambda(j,i) = hkrand(0) + ima*hkrand(0)
        enddo
      enddo
C$OMP END PARALLEL DO      

c
c   generate targets in the unit cube
c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
      do i=1,nt
        targs(1,i) = hkrand(0)**2 
        targs(2,i) = hkrand(0)**2
        targs(3,i) = hkrand(0)**2
      enddo
C$OMP END PARALLEL DO      

      eps = 1.0d-3
      write(*,*) "=========================================="
      write(*,*) "Testing suite for hfmm3d"
      write(*,'(a,e11.4)') "Requested precision = ",eps

      open(unit=33,file='print_testres.txt',access='append')

      ntests = 6
      do i=1,ntests
        ipass(i) = 0
      enddo

c
cc  test b_vect 
cc   with fields
c
      write(6,*) 'interaction: b'
      write(6,*) 'output: fields'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 0
      ifcurlE = 0
      ifa_vect = 0
      ifb_vect = 1
      iflambda = 0

      call cpu_time(t1)
C$      t1 = omp_get_wtime()      

      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)

      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1
      
      thresh = 1.0d-16

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
          enddo
        enddo
      enddo


      
      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      ra = 0
      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
          enddo
        enddo
      enddo

      erra = sqrt(erra/ra)
      call prin2('rel error in field=*',erra,1)
      if(erra.lt.eps) ipass(1) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="
c
cc  test b_vect 
cc   with fields, divergence and curl
c
      write(6,*) 'interaction: b'
      write(6,*) 'output: fields, divergence, and curl'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 1
      ifcurlE = 1
      ifa_vect = 0
      ifb_vect = 1
      iflambda = 0

      call cpu_time(t1)
C$      t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)

      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1
      thresh = 1.0d-16

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
            curlEex(j,l,i) = 0
          enddo
        enddo

        do j=1,nd
          divEex(j,i) = 0
        enddo
      enddo

      
      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      errc = 0
      errd = 0
      ra = 0
      rc = 0
      rd = 0

      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            rc = rc + abs(curlEex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
            errc = errc + abs(curlEex(j,l,i)-curlE(j,l,i))**2
          enddo
        enddo

        do j=1,nd
          rd = rd + abs(divEex(j,i))**2
          errd = errd + abs(divEex(j,i)-divE(j,i))**2
        enddo
      enddo

      erra = sqrt(erra/ra)
      errd = sqrt(errd/rd)
      errc = sqrt(errc/rc)

      call prin2('rel error in field=*',erra,1)
      call prin2('rel error in divergence=*',errd,1)
      call prin2('rel error in curl=*',errc,1)
      if(erra.lt.eps.and.errd.lt.eps.and.errc.lt.eps) ipass(2) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="

c
cc  test a_vect, lambda 
cc   with fields
c
      write(6,*) 'interaction: a,lambda'
      write(6,*) 'output: fields'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 0
      ifcurlE = 0
      ifa_vect = 1
      ifb_vect = 0
      iflambda = 1

      call cpu_time(t1)
C$     t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)
      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1

      thresh = 1.0d-16
      

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
          enddo
        enddo
      enddo

      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      ra = 0
      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
          enddo
        enddo
      enddo

      erra = sqrt(erra/ra)
      call prin2('rel error in field=*',erra,1)
      if(erra.lt.eps) ipass(3) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="
c
cc  test a_vect, lambda 
cc   with fields, divergence and curl
c

      write(6,*) 'interaction: a,lambda'
      write(6,*) 'output: fields, divergence, and curl'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 1
      ifcurlE = 1
      ifa_vect = 1
      ifb_vect = 0
      iflambda = 1

      call cpu_time(t1)
C$     t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)

      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1
      thresh = 1.0d-16
      

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
            curlEex(j,l,i) = 0
          enddo
        enddo

        do j=1,nd
          divEex(j,i) = 0
        enddo
      enddo

      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      errc = 0
      errd = 0
      ra = 0
      rc = 0
      rd = 0

      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            rc = rc + abs(curlEex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
            errc = errc + abs(curlEex(j,l,i)-curlE(j,l,i))**2
          enddo
        enddo

        do j=1,nd
          rd = rd + abs(divEex(j,i))**2
          errd = errd + abs(divEex(j,i)-divE(j,i))**2
        enddo
      enddo

      erra = sqrt(erra/ra)
      errd = sqrt(errd/rd)
      errc = sqrt(errc/rc)

      call prin2('rel error in field=*',erra,1)
      call prin2('rel error in divergence=*',errd,1)
      call prin2('rel error in curl=*',errc,1)
      if(erra.lt.eps.and.errd.lt.eps.and.errc.lt.eps) ipass(4) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="

c
cc  test b_vect,a_vect, lambda 
cc   with fields
c
      write(6,*) 'interaction: b,a,lambda'
      write(6,*) 'output: fields'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 0
      ifcurlE = 0
      ifa_vect = 1
      ifb_vect = 1
      iflambda = 1

      call cpu_time(t1)
C$     t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)

      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1
      thresh = 1.0d-16

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
          enddo
        enddo
      enddo
      
      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      ra = 0
      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
          enddo
        enddo
      enddo

      erra = sqrt(erra/ra)
      call prin2('rel error in field=*',erra,1)
      if(erra.lt.eps) ipass(5) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="
c
cc  test b_vect,a_vect, lambda 
cc   with fields, divergence and curl
c
      write(6,*) 'interaction: b,a,lambda'
      write(6,*) 'output: fields, divergence, and curl'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 1
      ifcurlE = 1
      ifa_vect = 1
      ifb_vect = 1
      iflambda = 1

      call cpu_time(t1)
C$     t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1  b_vect,iflambda,lambda,nt,targs,ifE,E,ifcurlE,curlE,
     2  ifdivE,divE,ier)

      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
      call prin2('time=*',t2-t1,1)
      write(14,*) "time=",t2-t1
      thresh = 1.0d-16
      

      do i=1,nttest
        do l=1,3
          do j=1,nd
            Eex(j,l,i) = 0
            curlEex(j,l,i) = 0
          enddo
        enddo

        do j=1,nd
          divEex(j,i) = 0
        enddo
      enddo

      call em3ddirect(nd,zk,ns,sources,ifa_vect,a_vect,ifb_vect,
     1 b_vect,iflambda,lambda,nttest,targs,ifE,Eex,ifcurlE,curlEex,
     2 ifdivE,divEex,thresh)
      
      erra = 0
      errc = 0
      errd = 0
      ra = 0
      rc = 0
      rd = 0

      do i=1,nttest
        do l=1,3
          do j=1,nd
            ra = ra + abs(Eex(j,l,i))**2
            rc = rc + abs(curlEex(j,l,i))**2
            erra = erra + abs(Eex(j,l,i)-E(j,l,i))**2
            errc = errc + abs(curlEex(j,l,i)-curlE(j,l,i))**2
          enddo
        enddo

        do j=1,nd
          rd = rd + abs(divEex(j,i))**2
          errd = errd + abs(divEex(j,i)-divE(j,i))**2
        enddo
      enddo

      erra = sqrt(erra/ra)
      errd = sqrt(errd/rd)
      errc = sqrt(errc/rc)

      call prin2('rel error in field=*',erra,1)
      call prin2('rel error in divergence=*',errd,1)
      call prin2('rel error in curl=*',errc,1)
      if(erra.lt.eps.and.errd.lt.eps.and.errc.lt.eps) ipass(6) = 1
      write(6,*)
      write(6,*)
      write(6,*) "====================="

      isum = 0
      do i=1,ntests
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i2,a,i2,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in emfmm3d testing suite'
      write(33,'(a,i2,a,i2,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in emfmm3d testing suite'
      close(33)
      

      stop

      

      stop
      end

c   These file contains the legacy FMM wrappers from the previous version
c     of fmmlib3d
c
c   
c
c     This file contains the main FMM routines and some related
c     subroutines for evaluating Helmholtz potentials and fields due to
c     point charges and dipoles.  (FORTRAN 90 VERSION)
c
c     hfmm3dpart - Helmholtz FMM in R^3: evaluate all pairwise particle
c         interactions (ignoring self-interaction)
c
c     hfmm3dpartself - Helmholtz FMM in R^3: evaluate all pairwise particle
c         interactions (ignoring self-interaction)
c
c     hfmm3dparttarg - Helmholtz FMM in R^3: evaluate all pairwise
c         particle interactions (ignoring self-interaction) +
c         interactions with targets
c
c     h3dpartdirect - Helmholtz interactions in R^3:  evaluate all
c         pairwise particle interactions (ignoring self-interaction) +
c         interactions with targets via direct O(N^2) algorithm
c
c
c
c
        subroutine hfmm3dpart(ier,iprec,zk,nsource,source,
     $     ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld)
        implicit real *8 (a-h,o-z)
        integer *8 ier,iprec,nsource,ifcharge,ifdipole
        integer *8 ifpot,iffld,ifpottarg,iffldtarg,ntarg
c              
c              
c       Helmholtz FMM in R^3: evaluate all pairwise particle
c       interactions (ignoring self-interaction). 
c       We use 1/(4\pi) (exp(ikr)/r) for the Green's function.
c       Self-interactions are not included.
c   
c       The main FMM routine permits both evaluation at sources
c       and at a collection of targets. 
c       This subroutine is used to simplify the user interface 
c       (by setting the number of targets to zero) and calling the more 
c       general FMM.
c
c       See below for explanation of calling sequence arguments.
c  
c
        dimension source(3,1)
        complex *16 charge(1),zk
        complex *16 dipstr(1)
        dimension dipvec(3,1)
        complex *16 ima
        complex *16 pot(1)
        complex *16 fld(3,1)
        dimension w(1)
c
        dimension targ(3,1)
        complex *16 pottarg(1)
        complex *16 fldtarg(3,1)        
c
        data ima/(0.0d0,1.0d0)/
c       
        ntarg=0
        ifpottarg=0
        iffldtarg=0
c
        call hfmm3dparttarg(ier,iprec,zk,nsource,source,
     $     ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld,
     $     ntarg,targ,ifpottarg,pottarg,iffldtarg,fldtarg)
c
        return
        end
c
c
c
c
c
        subroutine hfmm3dpartself(ier,iprec,zk,nsource,source,
     $     ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld)
        implicit real *8 (a-h,o-z)
c              
c              
c       Helmholtz FMM in R^3: evaluate all pairwise particle
c       interactions (ignoring self-interaction).
c       We use 1/(4\pi) (exp(ikr)/r) for the Green's function.
c       Self-interactions are not included.
c   
c       The main FMM routine permits both evaluation at sources
c       and at a collection of targets. 
c       This subroutine is used to simplify the user interface 
c       (by setting the number of targets to zero) and calling the more 
c       general FMM.
c
c       See below for explanation of calling sequence arguments.
c  
c
        integer *8 ier,iprec,nsource,ifcharge,ifdipole
        integer *8 ifpot,iffld,ntarg,ifpottarg,iffldtarg
        dimension source(3,1)
        complex *16 charge(1),zk
        complex *16 dipstr(1)
        dimension dipvec(3,1)
        complex *16 ima
        complex *16 pot(1)
        complex *16 fld(3,1)
        dimension w(1)
c
        dimension targ(3,1)
        complex *16 pottarg(1)
        complex *16 fldtarg(3,1)        
c
        data ima/(0.0d0,1.0d0)/
c       
        ntarg=0
        ifpottarg=0
        iffldtarg=0
c
        call hfmm3dparttarg(ier,iprec,zk,nsource,source,
     $     ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld,
     $     ntarg,targ,ifpottarg,pottarg,iffldtarg,fldtarg)
c
        return
        end
c
c
c
c
c

      subroutine hfmm3dparttarg(ier,iprec,zk,nsource,source,
     $     ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld,ntarg,targ,ifpottarg,pottarg,
     $     iffldtarg,fldtarg)
      implicit none
c       
c       Helmholtz FMM in R^3: evaluate all pairwise particle
c       interactions (ignoring self-interaction) 
c       and interactions with targets.
c
c       We use 1/(4\pi) (exp(ikr)/r) for the Green's function.
c       Self-interactions are not included.
c   
c       This is primarily a memory management code. 
c       The actual work is carried out in subroutine hfmm3dparttargmain.
c
c       INPUT PARAMETERS:
c
c       iprec:  FMM precision flag
c
c                 -2 => tolerance =.5d0
c                 -1 => tolerance =.5d-1
c                  0 => tolerance =.5d-2
c                  1 => tolerance =.5d-3
c                  2 => tolerance =.5d-6
c                  3 => tolerance =.5d-9
c                  4 => tolerance =.5d-12
c                  5 => tolerance =.5d-15
c
c       zk: complex *16: Helmholtz parameter
c       nsource: integer *8:  number of sources
c       source: real *8 (3,nsource):  source locations
c       ifcharge:  charge computation flag
c                  ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c       charge: complex *16 (nsource): charge strengths
c       ifdipole:  dipole computation flag
c                  ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c       dipstr: complex *16 (nsource): dipole strengths
c       dipvec: real *8 (3,nsource): dipole orientation vectors. 
c
c       ifpot:  potential flag (1=compute potential, otherwise no)
c       iffld:  field flag (1=compute field, otherwise no)
c       ntarget: integer *8:  number of targets
c       target: real *8 (3,ntarget):  target locations
c       ifpottarg:  target potential flag 
c                   (1=compute potential, otherwise no)
c       iffldtarg:  target field flag 
c                   (1=compute field, otherwise no)
c
c       OUTPUT PARAMETERS:
c
c       ier   =  error return code (currently unused)
c
c       pot: complex *16 (nsource): potential at source locations
c       fld: complex *16 (3,nsource): field (-gradient) at source locations
c       pottarg: complex *16 (ntarget): potential at target locations 
c       fldtarg: complex *16 (3,ntarget): field (-gradient) at target locations 
c
      integer *8 ier,iprec,nsource,iper
      integer *8 ifcharge,ifdipole
      double complex zk
      double precision source(3,nsource)
      
      double complex charge(nsource),dipstr(nsource)
      double precision dipvec(3,nsource)

      integer *8 ntarg
      integer *8 ifpot,iffld,ifpottarg,iffldtarg
      double complex  pot(nsource),fld(3,nsource)
      double complex  pottarg(ntarg),fldtarg(3,ntarg)

      integer *8 nd,ifpgh,ifpghtarg
      double precision targ(3,ntarg)
      double complex, allocatable :: dipvec_in(:,:)
      double complex, allocatable :: pottmp(:),gradtmp(:,:)
      double complex, allocatable :: pottargtmp(:),gradtargtmp(:,:)

      double complex hess(6),hesstarg(6)
      double precision eps

      integer *8 i
     
c     set fmm tolerance based on iprec flag.
c
      if( iprec .eq. -2 ) eps=.5d-0 
      if( iprec .eq. -1 ) eps=.5d-1
      if( iprec .eq. 0 ) eps=.5d-2
      if( iprec .eq. 1 ) eps=.5d-3
      if( iprec .eq. 2 ) eps=.5d-6
      if( iprec .eq. 3 ) eps=.5d-9
      if( iprec .eq. 4 ) eps=.5d-12
      if( iprec .eq. 5 ) eps=.5d-15
      if( iprec .eq. 6 ) eps=0


      if(ifdipole.eq.1) then
         allocate(dipvec_in(3,nsource))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
         do i=1,nsource
           dipvec_in(1,i) = dipstr(i)*dipvec(1,i)
           dipvec_in(2,i) = dipstr(i)*dipvec(2,i)
           dipvec_in(3,i) = dipstr(i)*dipvec(3,i)
         enddo
C$OMP END PARALLEL DO        
      endif
      if(ifdipole.ne.1) allocate(dipvec_in(3,1))


      if(ifpot.eq.1) ifpgh = 1
      if(iffld.eq.1) ifpgh = 2

      if(ifpgh.eq.1) then
        allocate(pottmp(nsource),gradtmp(3,1))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,nsource
          pottmp(i) = 0
        enddo
C$OMP END PARALLEL DO        
        gradtmp(1,1)= 0
        gradtmp(2,1)= 0
        gradtmp(3,1)= 0
      endif
      if(ifpgh.eq.2) then
        allocate(pottmp(nsource),gradtmp(3,nsource))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,nsource
          pottmp(i) = 0
          gradtmp(1,i)= 0
          gradtmp(2,i)= 0
          gradtmp(3,i)= 0
        enddo
C$OMP END PARALLEL DO        
      endif

      if(ifpottarg.eq.1) ifpghtarg = 1
      if(iffldtarg.eq.1) ifpghtarg = 2

      if(ifpghtarg.eq.1) then
        allocate(pottargtmp(nsource),gradtargtmp(3,1))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,ntarg
          pottargtmp(i) = 0
        enddo
C$OMP END PARALLEL DO        
        gradtargtmp(1,1)= 0
        gradtargtmp(2,1)= 0
        gradtargtmp(3,1)= 0
      endif
      if(ifpghtarg.eq.2) then
        allocate(pottargtmp(nsource),gradtargtmp(3,nsource))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,ntarg
          pottargtmp(i) = 0
          gradtargtmp(1,i)= 0
          gradtargtmp(2,i)= 0
          gradtargtmp(3,i)= 0
        enddo
C$OMP END PARALLEL DO        
      endif

      nd = 1
      ier = 0

      call hfmm3d(nd,eps,zk,nsource,source,ifcharge,charge,
     1  ifdipole,dipvec_in,iper,ifpgh,pottmp,gradtmp,hess,ntarg,
     2  targ,ifpghtarg,pottargtmp,gradtargtmp,hesstarg,ier)

      if(ifpot.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,nsource
          pot(i) = pottmp(i)
        enddo
C$OMP END PARALLEL DO        
      endif
      if(iffld.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,nsource
          fld(1,i) = -gradtmp(1,i)
          fld(2,i) = -gradtmp(2,i)
          fld(3,i) = -gradtmp(3,i)
        enddo
C$OMP END PARALLEL DO        
      endif

      if(ifpottarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,ntarg
          pottarg(i) = pottargtmp(i)
        enddo
C$OMP END PARALLEL DO        
      endif
      if(iffldtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)      
        do i=1,ntarg
          fldtarg(1,i) = -gradtargtmp(1,i)
          fldtarg(2,i) = -gradtargtmp(2,i)
          fldtarg(3,i) = -gradtargtmp(3,i)
        enddo
C$OMP END PARALLEL DO        
      endif


      return
      end


      subroutine h3dpartdirect(zk,ns,
     $    source,ifcharge,charge,ifdipole,dipstr,dipvec,
     $     ifpot,pot,iffld,fld,nt,
     $     targ,ifpottarg,pottarg,iffldtarg,fldtarg)

      implicit none
c
c       Helmholtz interactions in R^3: evaluate all pairwise particle
c       interactions (ignoring self-interaction) 
c       and interactions with targets via direct O(N^2) algorithm.
c
c       We use 1/(4\pi) (exp(ikr)/r) for the Green's function.
c       Self-interactions are not-included.
c   
c       INPUT PARAMETERS:
c
c       zk: complex *16: Helmholtz parameter
c       ns: integer *8:  number of sources
c       source: real *8 (3,nsource):  source locations
c       ifcharge:  charge computation flag
c                  ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c       charge: complex *16 (nsource): charge strengths
c       ifdipole:  dipole computation flag
c                  ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c       dipstr: complex *16 (nsource): dipole strengths
c       dipvec: real *8 (3,nsource): dipole orientation vectors. 
c
c       ifpot:  potential flag (1=compute potential, otherwise no)
c       iffld:  field flag (1=compute field, otherwise no)
c       nt: integer *8:  number of targets
c       targ: real *8 (3,nt):  target locations
c       ifpottarg:  target potential flag 
c                   (1=compute potential, otherwise no)
c       iffldtarg:  target field flag 
c                   (1=compute field, otherwise no)
c
c       OUTPUT PARAMETERS:
c
c       pot: complex *16 (nsource): potential at source locations
c       fld: complex *16 (3,nsource): field (-gradient) at source locations
c       pottarg: complex *16 (nt): potential at target locations 
c       fldtarg: complex *16 (3,nt): field (-gradient) at target locations 
c
      double complex zk
      integer *8 ns,ifcharge,ifdipole,ifpot,iffld,nt
      integer *8 ifpottarg,iffldtarg
      double precision source(3,*), targ(3,*)
      double complex charge(*),dipstr(*)
      double precision dipvec(3,*)
      double complex pot(*),fld(3,*),pottarg(*),fldtarg(3,*)

      double complex, allocatable :: pottmp(:),gradtmp(:,:)
      double complex, allocatable :: pottargtmp(:),gradtargtmp(:,:)

      double complex, allocatable :: dipvec_in(:,:)
      double precision thresh

      integer *8 i,j,nd,n
      integer *8 ifpgh,ifpghtarg

      double precision xmin,xmax,ymin,ymax,zmin,zmax
      double precision bsize,btmp,sizex,sizey,sizez

      ifpgh = 0
      ifpghtarg = 0

      if(ifpot.eq.1) ifpgh = 1
      if(iffld.eq.1) ifpgh = 2

      if(ifpottarg.eq.1) ifpghtarg = 1
      if(iffldtarg.eq.1) ifpghtarg = 2

      if(ifpgh.eq.1) allocate(pottmp(ns),gradtmp(3,1))
      if(ifpgh.eq.2) allocate(pottmp(ns),gradtmp(3,ns))

      if(ifpghtarg.eq.1) allocate(pottargtmp(nt),gradtargtmp(3,1))
      if(ifpghtarg.eq.2) allocate(pottargtmp(nt),gradtargtmp(3,nt))


      if(ifdipole.eq.1) then
        allocate(dipvec_in(3,ns))
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,ns
          dipvec_in(1,i) = dipstr(i)*dipvec(1,i)
          dipvec_in(2,i) = dipstr(i)*dipvec(2,i)
          dipvec_in(3,i) = dipstr(i)*dipvec(3,i)
        enddo
C$OMP END PARALLEL DO
      endif

      

      if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,ns
          pottmp(i) = 0
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,ns
          pottmp(i) = 0
          gradtmp(1,i) = 0
          gradtmp(2,i) = 0
          gradtmp(3,i) = 0
        enddo
C$OMP END PARALLEL DO
      endif


      if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,nt
          pottargtmp(i) = 0
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,nt
          pottargtmp(i) = 0
          gradtargtmp(1,i) = 0
          gradtargtmp(2,i) = 0
          gradtargtmp(3,i) = 0
        enddo
C$OMP END PARALLEL DO
      endif

c
c      compute threshold based on boxsize
c


      nd = 1

      xmin = source(1,1)
      xmax = source(1,1)
      ymin = source(2,1)
      ymax = source(2,1)
      zmin = source(3,1)
      zmax = source(3,1)

      do i=1,ns
        if(source(1,i).lt.xmin) xmin = source(1,i)
        if(source(1,i).gt.xmax) xmax = source(1,i)
        if(source(2,i).lt.ymin) ymin = source(2,i)
        if(source(2,i).gt.ymax) ymax = source(2,i)
        if(source(3,i).lt.zmin) zmin = source(3,i)
        if(source(3,i).gt.zmax) zmax = source(3,i)
      enddo

      do i=1,nt
        if(targ(1,i).lt.xmin) xmin = targ(1,i)
        if(targ(1,i).gt.xmax) xmax = targ(1,i)
        if(targ(2,i).lt.ymin) ymin = targ(2,i)
        if(targ(2,i).gt.ymax) ymax = targ(2,i)
        if(targ(3,i).lt.zmin) zmin = targ(3,i)
        if(targ(3,i).gt.zmax) zmax = targ(3,i)
      enddo

      sizex = xmax-xmin
      sizey = ymax-ymin
      sizez = zmax-zmin

      bsize = sizex
      if(sizey.gt.bsize) bsize = sizey
      if(sizez.gt.bsize) bsize = sizez

      btmp = sqrt(sizex**2+sizey**2+sizez**2)
      if(bsize/btmp.le.1.0d-16) then
        write(*,*) "Nothing to compute"
        write(*,*) "Sources and targets cannot be distinguished"
        write(*,*) "Exiting"
        return
      endif
      thresh = bsize*2.0d0**(-51)




c
c      compute potential at source
c 
      n = 1
      if(ifcharge.eq.1.and.ifdipole.eq.0) then

        if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectcp(nd,zk,source,charge,ns,
     1            source(1,i),n,pottmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectcg(nd,zk,source,charge,ns,
     1            source(1,i),n,pottmp(i),gradtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif
        

        if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectcp(nd,zk,source,charge,ns,
     1            targ(1,i),n,pottargtmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectcg(nd,zk,source,charge,ns,
     1            targ(1,i),n,pottargtmp(i),
     2            gradtargtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif
      endif

      if(ifcharge.eq.0.and.ifdipole.eq.1) then

        if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectdp(nd,zk,source,dipvec_in,ns,
     1            source(1,i),n,pottmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectdg(nd,zk,source,dipvec_in,ns,
     1            source(1,i),n,pottmp(i),gradtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif
        

        if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectdp(nd,zk,source,dipvec_in,ns,
     1            targ(1,i),n,pottargtmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectdg(nd,zk,source,dipvec_in,ns,
     1            targ(1,i),n,pottargtmp(i),
     2            gradtargtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

      endif

      if(ifcharge.eq.1.and.ifdipole.eq.1) then

        if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectcdp(nd,zk,source,charge,dipvec_in,ns,
     1            source(1,i),n,pottmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,ns
            call h3ddirectcdg(nd,zk,source,charge,dipvec_in,ns,
     1            source(1,i),n,pottmp(i),gradtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif
        

        if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectcdp(nd,zk,source,charge,dipvec_in,ns,
     1            targ(1,i),n,pottargtmp(i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

        if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
          do i=1,nt
            call h3ddirectcdg(nd,zk,source,charge,dipvec_in,ns,
     1            targ(1,i),n,pottargtmp(i),
     2            gradtargtmp(1,i),thresh)
          enddo
C$OMP END PARALLEL DO
        endif

      endif

c
c       extract output arrays
c
      
      if(ifpot.eq.1) then 
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,ns
           pot(i) = pottmp(i)
        enddo
C$OMP END PARALLEL DO
      endif
 
      if(iffld.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,ns
           fld(1,i) = -gradtmp(1,i)
           fld(2,i) = -gradtmp(2,i)
           fld(3,i) = -gradtmp(3,i)
        enddo
C$OMP END PARALLEL DO
      endif
 
      
      if(ifpottarg.eq.1) then 
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,nt
           pottarg(i) = pottargtmp(i)
        enddo
C$OMP END PARALLEL DO
      endif
 
      if(iffldtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i)
        do i=1,nt
           fldtarg(1,i) = -gradtargtmp(1,i)
           fldtarg(2,i) = -gradtargtmp(2,i)
           fldtarg(3,i) = -gradtargtmp(3,i)
        enddo
C$OMP END PARALLEL DO
      endif
 
      return
      end
       
      

c
c      TESTING SUITE FOR STOKES FMM:  June 18th, 2020
c
c

c$    use omp_lib
      implicit real *8 (a-h,o-z)
      
      real *8, allocatable :: pot(:,:), pre(:), grad(:,:,:)
      real *8, allocatable :: source(:,:), targ(:,:)
      real *8, allocatable :: pot2(:,:), pre2(:), grad2(:,:,:)      
      real *8, allocatable :: pottarg(:,:), pretarg(:), gradtarg(:,:,:)
      real *8, allocatable :: pottarg2(:,:),pretarg2(:),gradtarg2(:,:,:)

      real *8, allocatable :: stoklet(:,:), strslet(:,:)
      real *8, allocatable :: strsvec(:,:)
      real *8, allocatable :: rotlet(:,:), rotvec(:,:)
      real *8, allocatable :: doublet(:,:), doubvec(:,:)
      
      integer *8 ipass(10)
      integer *8 nd,ns,nt,ifstoklet,ifstrslet,ifppreg,ifppregtarg,ier
      integer *8 i,j,k,ntests,istress,ntest
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1
      pi=4.0*atan(done)
      call prini(6,13)
      write(*,*) "=========================================="
      write(*,*) "Testing suite for stfmm3d"

      open(unit=33,file='print_testres.txt',access='append')

      ntests = 6
      do i=1,ntests
        ipass(i) = 0 
      enddo


      ns = 4000
      nt = 4200

      allocate(source(3,ns),targ(3,nt))
      allocate(stoklet(3,ns),strslet(3,ns),strsvec(3,ns))
      
      do i = 1,ns
         source(1,i) = cos(i*done)
         source(2,i) = cos(10*i*done)
         source(3,i) = cos(100*i*done)
         stoklet(1,i) = sin(2*i*done)
         stoklet(2,i) = sin(22*i*done)
         stoklet(3,i) = sin(222*i*done)
         strslet(1,i) = sin(4*i*done)
         strslet(2,i) = sin(44*i*done)
         strslet(3,i) = sin(444*i*done)
         strsvec(1,i) = sin(5*i*done)
         strsvec(2,i) = sin(55*i*done)
         strsvec(3,i) = sin(555*i*done)
      enddo

      do i = 1,nt
         targ(1,i) = cos(7*i*done+1.2)
         targ(2,i) = cos(77*i*done+1.2)
         targ(3,i) = cos(777*i*done+1.2)
      enddo

      allocate(pot(3,ns),pre(ns),grad(3,3,ns))
      allocate(pottarg(3,nt),pretarg(nt),gradtarg(3,3,nt))      

      nd = 1
      eps = 1d-9
      ifstoklet = 1
      ifstrslet = 1
      ifrotlet = 0
      ifdoublet = 0
      ifppreg = 3
      ifppregtarg = 3

      call cpu_time(t1)
c$    t1 = omp_get_wtime()      
      call stfmm3d(nd,eps,ns,source,ifstoklet,stoklet,
     1     ifstrslet,strslet,strsvec,ifrotlet,rotlet,rotvec,
     2     ifdoublet,doublet,doubvec,ifppreg,pot,pre,grad,
     3     nt,targ,ifppregtarg,pottarg,pretarg,gradtarg,ier)
      call cpu_time(t2)
c$    t2 = omp_get_wtime()      


      call prin2('fmm time *',t2-t1,1)

      ntest = 100
      
      allocate(pot2(3,ntest),pre2(ntest),grad2(3,3,ntest))
      allocate(pottarg2(3,ntest),pretarg2(ntest),gradtarg2(3,3,ntest))

      do i = 1,ntest
         do j = 1,3
            pot2(j,i) = 0
            do k = 1,3
               grad2(k,j,i) = 0
            enddo
         enddo
         pre2(i) = 0
      enddo

      do i = 1,ntest
         do j = 1,3
            pottarg2(j,i) = 0
            do k = 1,3
               gradtarg2(k,j,i) = 0
            enddo
         enddo
         pretarg2(i) = 0
      enddo

      istress = 1
      thresh = 1d-15
      call st3ddirectstokstrsg(nd,source,stoklet,istress,
     1     strslet,strsvec,ns,source,ntest,pot2,pre2,grad2,thresh)
      call st3ddirectstokstrsg(nd,source,stoklet,istress,
     1     strslet,strsvec,ns,targ,ntest,pottarg2,pretarg2,gradtarg2,
     2     thresh)


      derr = 0
      drel = 0
      derrg = 0
      drelg = 0
      do i = 1,ntest
         derr = derr + (pot(1,i)-pot2(1,i))**2
         drel = drel + pot2(1,i)**2
         derr = derr + (pot(2,i)-pot2(2,i))**2
         drel = drel + pot2(2,i)**2
         derr = derr + (pot(3,i)-pot2(3,i))**2
         drel = drel + pot2(3,i)**2

         do j = 1,3
            do k = 1,3
               derrg = derrg + (grad(k,j,i)-grad2(k,j,i))**2
               drelg = drelg + grad2(k,j,i)**2
            enddo
         enddo
         
      enddo

      relerr = sqrt(derr/(ns*drel))
      relerrg = sqrt(derrg/(ns*drelg))
      if (relerr .lt. eps) ipass(1) = 1
      if (relerrg .lt. eps) ipass(2) = 1
      

      call prin2('rel err pot srcs *',relerr,1)
      call prin2('rel err grad srcs *',relerrg,1)

      
      derr = 0
      drel = 0
      do i = 1,ntest
         derr = derr + (pre(i)-pre2(i))**2
         drel = drel + pre2(i)**2
      enddo

      relerr = sqrt(derr/(ns*drel))
      if (relerr .lt. eps) ipass(3) = 1
      
      call prin2('rel err pre srcs *',relerr,1)

      derr = 0
      drel = 0

      derrg = 0
      drelg = 0
      
      do i = 1,ntest
         derr = derr + (pottarg(1,i)-pottarg2(1,i))**2
         drel = drel + pottarg2(1,i)**2
         derr = derr + (pottarg(2,i)-pottarg2(2,i))**2
         drel = drel + pottarg2(2,i)**2
         derr = derr + (pottarg(3,i)-pottarg2(3,i))**2
         drel = drel + pottarg2(3,i)**2

         do j = 1,3
            do k = 1,3
               derrg = derrg + (gradtarg(k,j,i)-gradtarg2(k,j,i))**2
               drelg = drelg + gradtarg2(k,j,i)**2
            enddo
         enddo
      enddo
      
      relerr = sqrt(derr/(nt*drel))
      relerrg = sqrt(derrg/(nt*drelg))
      if (relerr .lt. eps) ipass(4) = 1
      if (relerrg .lt. eps) ipass(5) = 1

      call prin2('rel err pot targs *',relerr,1)
      call prin2('rel err grad targs *',relerrg,1)

      derr = 0
      drel = 0
      do i = 1,ntest
         derr = derr + (pretarg(i)-pretarg2(i))**2
         drel = drel + pretarg2(i)**2
      enddo

      relerr = sqrt(derr/(nt*drel))
      if (relerr .lt. eps) ipass(6) = 1

      call prin2('rel err pre targs *',relerr,1)
      
      isum = 0
      do i=1,ntests
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in stfmm3d testing suite'
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntests,' tests in stfmm3d testing suite'
      close(33)
      


      stop
      end
c
c
c
c
c
c
      subroutine errprint(pot,opot,fld,ofld,errs)
      implicit real *8 (a-h,o-z)
      real *8 pot,opot,fld(3),ofld(3)
      real *8 errs(2)
 1000  format(4D15.5) 
      err = 0
      ddd = 0
      err = err + abs(fld(1)-ofld(1))**2
      err = err + abs(fld(2)-ofld(2))**2
      err = err + abs(fld(3)-ofld(3))**2
      ddd = ddd + abs(ofld(1))**2
      ddd = ddd + abs(ofld(2))**2
      ddd = ddd + abs(ofld(3))**2
      err = sqrt(err)
      ddd = sqrt(ddd)

      err1 = abs(pot-opot)/abs(opot)
      write(*,'(a,e11.4,a,e11.4)') 
     1     'pot error=',err1,'   grad error=',err/ddd

      errs(1) = err1 
      errs(2) = err/ddd

      return
      end
c

      implicit real *8 (a-h,o-z)
      implicit integer *8 (i-n)
      integer *8 ns,nt
      double complex zk
      double precision, allocatable :: sources(:,:),targs(:,:)
      double complex, allocatable :: h_current(:,:,:),e_charge(:,:)
      double complex, allocatable :: e_current(:,:,:)
      double complex, allocatable :: E(:,:,:),divE(:,:),curlE(:,:,:)
      double complex ima
      double precision thresh
      double precision t1,t2,omp_get_wtime
      data ima/(0.0d0,1.0d0)/

      call prini(6,13)


      ns = 4001
      nt = 3998

      nd = 2
      zk = 1.1d0 + ima*0.1d0

      allocate(sources(3,ns))
      allocate(h_current(nd,3,ns),e_current(nd,3,ns),e_charge(nd,ns))

      allocate(targs(3,nt),E(nd,3,nt),divE(nd,nt),curlE(nd,3,nt))



c
cc  generate sourcrs in the unit cube
c

c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,l)
      do i=1,ns 
        sources(1,i) = hkrand(0)**2
        sources(2,i) = hkrand(0)**2
        sources(3,i) = hkrand(0)**2
        do l=1,3
          do j=1,nd
            h_current(j,l,i) = hkrand(0) + ima*hkrand(0)
            e_current(j,l,i) = hkrand(0) + ima*hkrand(0)
          enddo
        enddo

        do j=1,nd
          e_charge(j,i) = hkrand(0) + ima*hkrand(0)
        enddo
      enddo
C$OMP END PARALLEL DO      

c
c   generate targets in the unit cube
c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j)
      do i=1,nt
        targs(1,i) = hkrand(0)**2 
        targs(2,i) = hkrand(0)**2
        targs(3,i) = hkrand(0)**2
        do j=1,nd
          E(j,1,i) = 0
          E(j,2,i) = 0
          E(j,3,i) = 0
        enddo
      enddo
C$OMP END PARALLEL DO      


c
cc  test h_current, e_charge 
cc   with fields
c
      write(6,*) 'interaction: h_current,e_charge'
      write(6,*) 'output: fields'
      write(6,*) 
      write(6,*)

      ifE = 1
      ifdivE = 0
      ifcurlE = 0
      ifh_current = 1
      ife_current = 0
      ife_charge = 1
      ier = 0

      eps = 0.5d-3


      call cpu_time(t1)
C$     t1 = omp_get_wtime()      
      call emfmm3d(nd,eps,zk,ns,sources,ifh_current,h_current,
     1  ife_current,e_current,ife_charge,e_charge,nt,targs,ifE,E,
     2  ifcurlE,curlE,ifdivE,divE,ier)
      call cpu_time(t2)
C$      t2 = omp_get_wtime() 
      
c      write(*,*) 'E='
c      write(*,'(6(2x,e11.5))') E(1:2,1:3,1:2)
      
      call prin2('E=*',E,12)
      return
      end

c  This file contains the following user callable
c  routines:
c
c  * cumsum:
c      computes the cumulative sum (aka prefix
c      sum or scan) of an array of integer *8s. This code
c      does some memory management and basic decision
c      making around parallelism, which is hidden from
c      the caller
c      
c     Advanced user interfaces:
c******************************
c     Note for developers: the prefix sum for integer *8
c     arrays on a shared memory machine can be memory
c     bound and performance changes significantly depending
c     on the speed and size of the L1,L2, and L3 cache
c     on chip. Thus, the performance of the parallel code
c     typically exhibits non-monotonic behavior. The efficiency
c     increases with the length of the vectors as the
c     overhead is ammortized but then the memory bound
c     effects kicks in for larger vectors. The best-case
c     improvement is nthreads/2, though it is observed
c     only for the appropriate length vectors.
c******************************      
c     
c     cumsum1 - same as cumsum but forces the serial
c       code
c
c     cumsum_para - openmp implementation of parallel
c       cumulative sum
c
c


      
      subroutine cumsum(n,a,b)
c
c--------------------------
c  This subroutine computes the cumulative sum
c  (aka prefix sum aka scan) of the vector a and
c  returns in the result in b. i.e.
c
c  b(i) = sum_{j\leq i} a(j) for i = 1,...,n
c
c  This is the memory management routine with
c  the work done by either cumsum1 in serial or
c  cumsum_para in parallel
c
c  Input arguments:
c   
c    - n: integer *8
c        length of a and b
c    - a: integer *8(n)
c        the array to perform cumulative sum on
c
c  Output arguments:
c 
c    - b: integer *8(n)
c        the resulting cumulative sum array
c--------------------------
c
c
      implicit none
      integer *8, intent(in) :: n,a(n)
      integer *8, intent(out) :: b(n)
      
      integer *8 lend, nsmall, maxth, offset
      parameter (lend = 200)
      integer *8 d(lend)
      integer *8, allocatable :: d2(:)
c$    integer *8 omp_get_max_threads
      data nsmall / 10000 /

c     if small problem, don't do parallel
      if (n .lt. nsmall) goto 300

c     get upper bound of number of threads on hand

      maxth = 1      
c$    maxth = omp_get_max_threads()

c     no benefit to parallelize if only 2 threads
      if (maxth .le. 2) goto 300

c     if not a ton of processors, use d on stack
      if (maxth .le. lend) goto 200

c     if tons of processors, allocate d2
      allocate(d2(maxth))
      call cumsum_para(n,a,b,maxth,d2)
      return

 200  continue

      call cumsum_para(n,a,b,lend,d)
      return
      
 300  continue
            
      call cumsum1(n,a,b)
      return
      
      end
c
c
      subroutine cumsum1(n,a,b)
c
c--------------------------
c  This subroutine computes the cumulative sum
c  (aka prefix sum aka scan) of the vector a and
c  returns in the result in b. i.e.
c
c  b(i) = sum_{j\leq i} a(j) for i = 1,...,n
c  
c  This is the serial version of the code.
c 
c  Input arguments:
c   
c    - n: integer *8
c        length of a and b
c    - a: integer *8(n)
c        the array to perform cumulative sum on
c
c  Output arguments:
c 
c    - b: integer *8(n)
c        the resulting cumulative sum array
c--------------------------
c      
      
      implicit none
      integer *8, intent(in) :: n,a(n)
      integer *8, intent(out) :: b(n)

      integer *8 i,isum

      isum = 0

      do i=1,n
        isum = isum + a(i)
        b(i) = isum
      enddo
      
      return
      end
c
      
      subroutine cumsum_para(n,a,b,nd,d)
c
c
c--------------------------
c  This subroutine computes the cumulative sum
c  (aka prefix sum aka scan) of the vector a and
c  returns in the result in b. i.e.
c
c  b(i) = sum_{j\leq i} a(j) for i = 1,...,n
c  
c  This is the openmp parallel version of the code
c
c  Input arguments:
c   
c    - n: integer *8
c        length of a and b
c    - a: integer *8(n)
c        the array to perform cumulative sum on
c    - nd: integer *8
c        length of the work array d, nd should be larger
c        than the number of threads to be used
c
c  Output arguments:
c
c    - b: integer *8(n)
c        the resulting cumulative sum array
c    - d: integer *8(nd)
c        work array of length nd, nd should be larger than
c        the number of threads to be used
c--------------------------
c     
c  WARNING: this subroutine depends on the properties
c  of the "static" schedule in the OPENMP
c  specification. Specifically, the static schedule
c  with no chunk_size specified assigns at most one
c  block of iterates to each thread in thread order.
c  The assignment of indices is the same for any do
c  loops of the same cardinality within a parallel
c  region. Changing the schedule will make the code non
c  conforming.
c
      implicit none
      integer *8, intent(in) :: n,a(n),nd
      integer *8, intent(out) :: b(n),d(nd)

      integer *8 i,isum,offset
      integer *8 nth, id, inext
c$    integer *8 omp_get_thread_num, omp_get_num_threads      


c$OMP PARALLEL DEFAULT(none) SHARED(a,b,n,d)
c$OMP$ PRIVATE(i,isum,offset,id,inext,nth)

      id = 1
c$    id = omp_get_thread_num()+1

c     compute cumulative sums of portions (parallel)
      
      
      isum = 0
c$OMP DO SCHEDULE(static)       
      do i = 1,n
         isum = isum+a(i)
         b(i) = isum
      enddo
c$OMP END DO no wait      
      d(id) = isum

c$OMP BARRIER

c     accumulate the ends of the partial sums (each thread)
      
      offset = 0
      do i = 1,id-1
         offset = offset + d(i)
      enddo

c$OMP DO SCHEDULE(static)       
      do i = 1,n
         b(i) = b(i) + offset
      enddo
c$OMP END DO no wait      
      
c$OMP END PARALLEL
      
      return
      end
c
      

      implicit real *8 (a-h,o-z)
      integer *8 i1,i2

      done = 1
      pi = atan(done)*4

      ntest = 2


      rsc = 1.0d10
      call test_lfmm3d_scale(rsc,i1)

      rsc = 1.0d-9
      call test_lfmm3d_scale(rsc,i2)

      nsuccess = i1+i2
      open(unit=33,file='print_testres.txt',access='append')
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ', nsuccess,
     1   ' out of ', ntest, ' in lfmm3d scale testing suite'


      stop
      end


      subroutine test_lfmm3d_scale(rsc,isuccess)
      
      implicit none
      integer *8 ns
      double precision, allocatable :: source(:,:)
      double precision, allocatable :: charge(:),dipvec(:,:)
      double precision, allocatable :: pot(:),potex(:)
      double precision, allocatable :: grad(:,:),gradex(:,:)

      double precision eps,rsc
      integer *8 i,j,k,ntest,ier
      double precision hkrand,thresh,erra,ra
      integer *8 isuccess
      integer *8 ione
      

c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      write(*,*)
      write(*,*)



      ns = 10000
      ione = 1
      

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(dipvec(3,ns))
      allocate(pot(ns))
      allocate(grad(3,ns))


      eps = 0.51d-6


c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources with distribution unif^2 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2*rsc
        source(2,i) = hkrand(0)**2*rsc
        source(3,i) = hkrand(0)**2*rsc

        charge(i) = hkrand(0) 
        dipvec(1,i) = hkrand(0) 
        dipvec(2,i) = hkrand(0) 
        dipvec(3,i) = hkrand(0) 

        pot(i) = 0
        grad(1,i) = 0
        grad(2,i) = 0
        grad(3,i) = 0 
      enddo


      call lfmm3d_s_cd_g(eps,ns,source,charge,dipvec,
     1      pot,grad,ier)
      ntest = 10
      allocate(potex(ntest),gradex(3,ntest))

      thresh = 2.0d0**(-51)*rsc

      do i=1,ntest
        potex(i) = 0
        gradex(1,i) = 0
        gradex(2,i) = 0
        gradex(3,i) = 0
      enddo

      call l3ddirectcdg(ione,source,charge,dipvec,ns,source,
     1  ntest,potex,gradex,thresh)

      erra = 0
      ra = 0
      do i=1,ntest
        erra = erra + abs(potex(i)-pot(i))**2
        erra = erra + abs(gradex(1,i)-grad(1,i))**2
        erra = erra + abs(gradex(2,i)-grad(2,i))**2
        erra = erra + abs(gradex(3,i)-grad(3,i))**2

        ra = ra + abs(potex(i))**2
        ra = ra + abs(gradex(1,i))**2 + abs(gradex(2,i))**2 +
     1   abs(gradex(3,i))**2
      enddo

      call prin2('pot=*',pot,ntest)
      call prin2('potex=*',potex,ntest)

      erra = sqrt(erra/ra)

      call prin2('rsc=*',rsc,1)
      call prin2('l2 rel err=*',erra,1)

      isuccess = 0

      if(erra.lt.5*eps) isuccess = 1
      

      return
      end
c----------------------------------------------------------
c

      implicit none
      integer *8 ns,nt
      double precision, allocatable :: source(:,:)
      double precision, allocatable :: targ(:,:)
      double precision, allocatable :: charge(:)
      double precision, allocatable :: pot(:),potex(:)
      double precision, allocatable :: grad(:,:),gradex(:,:)
      double precision, allocatable :: pottarg(:),gradtarg(:,:)
      double precision, allocatable :: pottargex(:),gradtargex(:,:)

      double precision eps
      integer *8 i,j,k,ntest
      double precision hkrand,thet,pi,erra,ra,thresh
      double precision tmp1,tmp2,tmp3,errg,rg
      

      pi = atan(1.0d0)*4.0d0

c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      call prin2("This code is an example fortran driver*",i,0)
      call prin2("On output, the code prints sample pot,grad*",i,0)
      write(*,*)
      write(*,*)


      ns = 12716
      nt = 7500

      allocate(source(3,ns))
      allocate(targ(3,nt))
      allocate(charge(ns))
      allocate(pot(ns))
      allocate(grad(3,ns))
      allocate(pottarg(nt))
      allocate(gradtarg(3,nt))


      eps = 1.0d-6

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources uniformly in the unit cube 
c
c
      open(unit=33,file='examples/srcloc1.txt')
      do i=1,ns
        read(33,*) tmp1,tmp2,tmp3
        source(1,i) = tmp1
        source(2,i) = tmp2
        source(3,i) = tmp3
        charge(i) = hkrand(0)
        pot(i) = 0
        grad(1,i) = 0
        grad(2,i) = 0
        grad(3,i) = 0 
      enddo
      close(33)

      open(unit=33,file='examples/targloc1.txt')
      do i=1,nt
        read(33,*) tmp1,tmp2,tmp3
        targ(1,i) = tmp1
        targ(2,i) = tmp2
        targ(3,i) = tmp3
        pottarg(i) = 0
        gradtarg(1,i) = 0
        gradtarg(2,i) = 0
        gradtarg(3,i) = 0 
      enddo
      close(33)

      call prin2('targ=*',targ,12)


      call lfmm3d_st_c_g(eps,ns,source,charge,pot,grad,
     1      nt,targ,pottarg,gradtarg)
      call prin2("pot at sources=*",pot,12)
cc      call prin2("grad at sources=*",grad,3*nt)

c
c      test accuracy
c

      ntest = 10
      allocate(potex(ntest),gradex(3,ntest))
      allocate(pottargex(ntest),gradtargex(3,ntest))
      thresh = 1.0d-16
      do i=1,ntest
        potex(i) = 0
        gradex(1,i) = 0
        gradex(2,i) = 0
        gradex(3,i) = 0

        pottargex(i) = 0
        gradtargex(1,i) = 0
        gradtargex(2,i) = 0
        gradtargex(3,i) = 0
      enddo
      call l3ddirectcg(1,source,charge,ns,source,ntest,
     1       potex,gradex,thresh)


      erra = 0
      ra = 0
      errg = 0
      rg = 0
      do i=1,ntest
         ra = ra + abs(potex(i))**2
         erra = erra + abs(pot(i)-potex(i))**2
         rg = rg + gradex(1,i)**2 + gradex(2,i)**2 + gradex(3,i)**2
         errg = errg + (gradex(1,i)-grad(1,i))**2
         errg = errg + (gradex(2,i)-grad(2,i))**2
         errg = errg + (gradex(3,i)-grad(3,i))**2
      enddo

      call prin2('potex=*',potex,ntest)
      call prin2('pot=*',pot,ntest)
      call prin2('gradex=*',gradex,3*ntest)
      call prin2('grad=*',grad,3*ntest)

      erra = sqrt(erra/ra)
      errg = sqrt(errg/rg)

      call prin2('error=*',erra,1)
      call prin2('error gradient=*',errg,1)

      call l3ddirectcg(1,source,charge,ns,targ,ntest,
     1       pottargex,gradtargex,thresh)


      erra = 0
      ra = 0
      errg = 0
      rg = 0
      do i=1,ntest
         ra = ra + abs(pottargex(i))**2
         erra = erra + abs(pottarg(i)-pottargex(i))**2
         rg = rg + gradtargex(1,i)**2 + gradtargex(2,i)**2 + 
     1      gradtargex(3,i)**2
         errg = errg + (gradtargex(1,i)-gradtarg(1,i))**2
         errg = errg + (gradtargex(2,i)-gradtarg(2,i))**2
         errg = errg + (gradtargex(3,i)-gradtarg(3,i))**2
      enddo

      call prin2('potex=*',pottargex,ntest)
      call prin2('pot=*',pottarg,ntest)
      call prin2('gradex=*',gradtargex,3*ntest)
      call prin2('grad=*',gradtarg,3*ntest)

      erra = sqrt(erra/ra)
      errg = sqrt(errg/rg)

      call prin2('error=*',erra,1)
      call prin2('error gradient=*',errg,1)

      stop
      end
c----------------------------------------------------------
c
cc
c
c

c  This file contains the Laplace FMM wrappers
c
c  The laplace FMM evaluates the following potential
c  and its gradient
c    
c     u(x) = \sum_{j=1}^{N} c_{j}/|x-x_{j}| - v_{j}.\nabla (1/|x-x_{j}|)
c
c  Here x_{j} are the source locations, c_{j} are the charge strengths,
c  v_{j} are the dipole strengths. We refer to the collection of 
c  $x$ at which the potential and its gradient are evaluated as the
c  evaluation points
c
c  The subroutine names take the following form:
c    lfmm3d_<eval-pts>_<int-ker>_<out>
c
c      <eval-pts>: evaluation points (sources/targets/sources+targets)
c        s: source locations
c        t: target locations
c        st: source and target locations
c
c      <int-ker>: kernel of interaction (charges/dipoles/both)
c        c: charges
c        d: dipoles
c        cd: charges+dipoles
c 
c      <out>: flag for potential/potential+gradient
c        p: potentials
c        g: potentials+gradients
c        h: potentials+gradients+hessians
c
c  The wrappers are:
c 
c  -lfmm3d_s_c_p
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential  
c-------------------------------------
c  -lfmm3d_s_c_g
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential Gradient 
c-------------------------------------
c  -lfmm3d_s_c_h
c    - Evaluation points: Sources
c    - Interaction kernel: Charges
c    - Outputs requested: Potential Gradient Hessians
c-------------------------------------
c  -lfmm3d_s_d_p
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential  
c-------------------------------------
c  -lfmm3d_s_d_g
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential Gradient 
c-------------------------------------
c  -lfmm3d_s_d_h
c    - Evaluation points: Sources
c    - Interaction kernel: Dipoles
c    - Outputs requested: Potential Gradient Hessians
c-------------------------------------


      subroutine lfmm3d_s_c_p(eps,nsource,source,
     1    charge,pot,ier)
      implicit none
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot
cf2py  intent(out) ier

x

c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      double precision eps
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      
      double precision dipvec(3,1)

      double precision pot(nsource)

      double precision pottarg(1)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)


      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_c_g(eps,nsource,source,
     1    charge,pot,grad,ier)
      implicit none
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      
      double precision dipvec(3,1)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0
      ier = 0


      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_s_c_h(eps,nsource,source,
     1    charge,pot,grad,hess,ier)
      implicit none
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c--------------------------------
c
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      
      double precision dipvec(3,1)

      double precision pot(nsource),grad(3,nsource),hess(6,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0
      ier = 0


      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_d_p(eps,nsource,source,
     1    dipvec,pot,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource)
      double precision pottarg(1)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0
      ier = 0


      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_d_g(eps,nsource,source,
     1    dipvec,pot,grad,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c
c
c

      subroutine lfmm3d_s_d_h(eps,nsource,source,
     1    dipvec,pot,grad,hess,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient, 
c  and its hessian
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource),hess(6,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)


      return
      end
c
c
c

      subroutine lfmm3d_s_cd_p(eps,nsource,source,
     1    charge,dipvec,pot,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource)
      double precision pottarg(1)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c
c
c
c
c

      subroutine lfmm3d_s_cd_g(eps,nsource,source,
     1    charge,dipvec,pot,grad,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot,grad
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c
c

      subroutine lfmm3d_s_cd_h(eps,nsource,source,
     1    charge,dipvec,pot,grad,hess,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient 
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source locations $x=x_{j}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,1)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource),hess(6,nsource)
      double precision pottarg(1),gradtarg(3,1)

      double precision hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 0

      ntarg = 0
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c

      subroutine lfmm3d_t_c_p(eps,nsource,source,
     1    charge,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(1)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_c_g(eps,nsource,source,
     1    charge,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_c_h(eps,nsource,source,
     1    charge,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)
      double precision hesstarg(6,ntarg)

      double precision hess(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 0
      ifpghtarg = 3
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c

      subroutine lfmm3d_t_d_p(eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(1)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_t_d_g(eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_d_h(eps,nsource,source,
     1    dipvec,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)
      double precision hesstarg(6,ntarg)

      double precision hess(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 3
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_t_cd_p(eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(1)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_cd_g(eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_t_cd_h(eps,nsource,source,
     1    charge,dipvec,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient 
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the target locations $x=t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(1),grad(3,1)
      double precision pottarg(ntarg),gradtarg(3,ntarg)
      double precision hesstarg(6,ntarg)

      double precision hess(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 0
      ifpghtarg = 3
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
      subroutine lfmm3d_st_c_p(eps,nsource,source,
     1    charge,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(nsource)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 1
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_c_g(eps,nsource,source,
     1    charge,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 2
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_c_h(eps,nsource,source,
     1    charge,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|}
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,1)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6,nsource),hesstarg(6,ntarg)

      nd = 1
      ifcharge = 1
      ifdipole = 0
      
      ifpgh = 3
      ifpghtarg = 3
      ier = 0


      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_d_p(eps,nsource,source,
     1    dipvec,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_d_g(eps,nsource,source,
     1    dipvec,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_d_h(eps,nsource,source,
     1    dipvec,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u(x) = -\sum_{j=1}^{N} v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps
      
      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(1)
      
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6,nsource),hesstarg(6,ntarg)

      nd = 1
      ifcharge = 0
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 3
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c

      subroutine lfmm3d_st_cd_p(eps,nsource,source,
     1    charge,dipvec,pot,ntarg,targ,pottarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot
cf2py  intent(out) pottarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource)
      double precision pottarg(ntarg)

      double precision grad(3),gradtarg(3)
      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 1
      ifpghtarg = 1
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

      subroutine lfmm3d_st_cd_g(eps,nsource,source,
     1    charge,dipvec,pot,grad,ntarg,targ,pottarg,
     2    gradtarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad
cf2py  intent(out) pottarg,gradtarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential and its gradient 
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
cc    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6),hesstarg(6)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 2
      ifpghtarg = 2
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c
c

      subroutine lfmm3d_st_cd_h(eps,nsource,source,
     1    charge,dipvec,pot,grad,hess,ntarg,targ,pottarg,
     2    gradtarg,hesstarg,ier)
cf2py  intent(in) eps
cf2py  intent(in) nsource,source,dipvec,charge
cf2py  intent(in) ntarg,targ
cf2py  intent(out) pot,grad,hess
cf2py  intent(out) pottarg,gradtarg,hesstarg
cf2py  intent(out) ier
c-------------------------------------
c
c  This subroutine evaluates the potential, its gradient,
c  and its hessian
c      u(x) = \sum_{j=1}^{N} c_{j} \frac{1}{\|x-x_{j}\|} - 
c            v_{j} \cdot \nabla \left( 
c            \frac{1}{\|x-x_{j}\|}\right)
c
c  at the source and target locations $x=x_{j},t_{i}$.
c  When $x=x_{j}$, the term corresponding to $x_{j}$ is 
c  dropped from the sum.
c
c  Input arguments:
c
c    -    eps: double precision
c          precision requested
c    -    nsource: integer
c          Number of sources
c    -    source: double precision(3,nsource)
c          Source locations, $x_{j}$
c    -    charge: double precision(nsource)
c          Charge strengths, $c_{j}$
c    -    dipvec: double precision(3,nsource)
c          Dipole strengths, $v_{j}$
c    -    ntarg: integer
c          Number of targets
c    -    targ: double precision(3,ntarg)
c          Target locations, $t_{i}$
c
c
c  Output arguments:
c    -    pot: double precision(nsource)
c          Potential at source locations, $u(x_{j})$
c    -    grad: double precision(3,nsource)
c          Gradient at source locations, $\nabla u(x_{j})$
c    -    hess: double precision(6,nsource)
c          Hessian at source locations, $\nabla^2 u(x_{j})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    pottarg: double precision(ntarg)
c          Potential at target locations, $u(t_{i})$
c    -    gradtarg: double precision(3,ntarg)
c          Gradient at target locations, $\nabla u(t_{i})$
c    -    hesstarg: double precision(6,ntarg)
c          Hessian at target locations, $\nabla^2 u(t_{i})$
c          Hessian is ordered as
c          $u_{xx},u_{yy},u_{zz},u_{xy},u_{xz},u_{yz}$
c    -    ier: integer
c          error flag
c           * ier = 0, for normal execution
c           * ier = 4/8, failed to allocate memory in fmm routine
c
c--------------------------------
c
      implicit none
      double precision eps

      integer nsource,ntarg,ifcharge,ifdipole,ifpgh,ifpghtarg
      integer nd,ier,iper
      
      double precision source(3,nsource),targ(3,ntarg)
      double precision charge(nsource)
      double precision dipvec(3,nsource)

      double precision pot(nsource),grad(3,nsource)
      double precision pottarg(ntarg),gradtarg(3,ntarg)

      double precision hess(6,nsource),hesstarg(6,ntarg)

      nd = 1
      ifcharge = 1
      ifdipole = 1
      
      ifpgh = 3
      ifpghtarg = 3
      ier = 0

      call lfmm3d(nd,eps,nsource,source,ifcharge,charge,
     1      ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,targ,
     2      ifpghtarg,pottarg,gradtarg,hesstarg,ier)

      return
      end
c
c
c
c
c

c
c     Computation of spherical Bessel functions via recurrence
c
c**********************************************************************
      subroutine jfuns3d(ier,nterms,z,scale,fjs,ifder,fjder,
     1	      lwfjs,iscale,ntop)
      implicit none
      integer *8 ier,nterms,ifder,lwfjs,ntop,i,ncntr
      real *8 scale,d0,d1,dc1,dc2,dcoef,dd,done,tiny,zero
      real *8 scalinv,sctot,upbound,upbound2,upbound2inv
c**********************************************************************
c
c PURPOSE:
c
c	This subroutine evaluates the first NTERMS spherical Bessel 
c	functions and if required, their derivatives.
c	It incorporates a scaling parameter SCALE so that
c       
c		fjs_n(z)=j_n(z)/SCALE^n
c		fjder_n(z)=\frac{\partial fjs_n(z)}{\partial z}
c
c	NOTE: The scaling parameter SCALE is meant to be used when
c             abs(z) < 1, in which case we recommend setting
c	      SCALE = abs(z). This prevents the fjs_n from 
c             underflowing too rapidly.
c	      Otherwise, set SCALE=1.
c	      Do not set SCALE = abs(z) if z could take on the 
c             value zero. 
c             In an FMM, when forming an expansion from a collection of
c             sources, set SCALE = min( abs(k*r), 1)
c             where k is the Helmholtz parameter and r is the box dimension
c             at the relevant level.
c
c INPUT:
c
c    nterms (integer *8): order of expansion of output array fjs 
c    z     (complex *16): argument of the spherical Bessel functions
c    scale    (real *8) : scaling factor (discussed above)
c    ifder  (integer *8): flag indicating whether to calculate "fjder"
c		          0	NO
c		          1	YES
c    lwfjs  (integer *8): upper limit of input arrays 
c                         fjs(0:lwfjs) and iscale(0:lwfjs)
c    iscale (integer *8): integer *8 workspace used to keep track of 
c                         internal scaling
c
c OUTPUT:
c
c    ier    (integer *8): error return code 
c                         ier=0 normal return;
c                         ier=8 insufficient array dimension lwfjs
c    fjs   (complex *16): array of scaled Bessel functions.
c    fjder (complex *16): array of derivs of scaled Bessel functions.
c    ntop  (integer *8) : highest index in arrays fjs that is nonzero
c
c       NOTE, that fjs and fjder arrays must be at least (nterms+2)
c       complex *16 elements long.
c
c
      integer *8 iscale(0:lwfjs)
      complex *16 wavek,fjs(0:lwfjs),fjder(0:*)
      complex *16 z,zinv,com,fj0,fj1,zscale,ztmp
c
      data upbound/1.0d+32/, upbound2/1.0d+40/, upbound2inv/1.0d-40/
      data tiny/1.0d-200/,done/1.0d0/,zero/0.0d0/
c
c ... Initializing ...
c
      ier=0
c
c       set to asymptotic values if argument is sufficiently small
c
      if (abs(z).lt.tiny) then
         fjs(0) = done
         do i = 1, nterms
            fjs(i) = zero
	 enddo
c
	 if (ifder.eq.1) then
	    do i=0,nterms
	       fjder(i)=zero
	    enddo
	    fjder(1)=done/(3*scale)
	 endif
c
         RETURN
      endif
c
c ... Step 1: recursion up to find ntop, starting from nterms
c
      ntop=0
      zinv=done/z
      fjs(nterms)=done
      fjs(nterms-1)=zero
c
      do 1200 i=nterms,lwfjs
         dcoef=2*i+done
         ztmp=dcoef*zinv*fjs(i)-fjs(i-1)
         fjs(i+1)=ztmp
c
         dd = dreal(ztmp)**2 + dimag(ztmp)**2
         if (dd .gt. upbound2) then
            ntop=i+1
            goto 1300
         endif
 1200 continue
 1300 continue
      if (ntop.eq.0) then
         ier=8
         return
      endif
c
c ... Step 2: Recursion back down to generate the unscaled jfuns:
c             if magnitude exceeds UPBOUND2, rescale and continue the 
c	      recursion (saving the order at which rescaling occurred 
c	      in array iscale.
c
      do i=0,ntop
         iscale(i)=0
      enddo
c
      fjs(ntop)=zero
      fjs(ntop-1)=done
      do 2200 i=ntop-1,1,-1
	 dcoef=2*i+done
         ztmp=dcoef*zinv*fjs(i)-fjs(i+1)
         fjs(i-1)=ztmp
c
         dd = dreal(ztmp)**2 + dimag(ztmp)**2
         if (dd.gt.UPBOUND2) then
            fjs(i) = fjs(i)*UPBOUND2inv
            fjs(i-1) = fjs(i-1)*UPBOUND2inv
            iscale(i) = 1
         endif
 2200 continue
c
c ...  Step 3: go back up to the top and make sure that all
c              Bessel functions are scaled by the same factor
c              (i.e. the net total of times rescaling was invoked
c              on the way down in the previous loop).
c              At the same time, add scaling to fjs array.
c
      ncntr=0
      scalinv=done/scale
      sctot = 1.0d0
      do i=1,ntop
         sctot = sctot*scalinv
         if(iscale(i-1).eq.1) sctot=sctot*UPBOUND2inv
         fjs(i)=fjs(i)*sctot
      enddo
c
c ... Determine the normalization parameter:
c
      fj0=sin(z)*zinv
      fj1=fj0*zinv-cos(z)*zinv
c
      d0=abs(fj0)
      d1=abs(fj1)
      if (d1 .gt. d0) then
         zscale=fj1/(fjs(1)*scale)
      else
         zscale=fj0/fjs(0)
      endif
c
c ... Scale the jfuns by zscale:
c
      ztmp=zscale
      do i=0,nterms
         fjs(i)=fjs(i)*ztmp
      enddo
c
c ... Finally, calculate the derivatives if desired:
c
      if (ifder.eq.1) then
         fjs(nterms+1)=fjs(nterms+1)*ztmp
c
         fjder(0)=-fjs(1)*scale
         do i=1,nterms
            dc1=i/(2*i+done)
            dc2=done-dc1
            dc1=dc1*scalinv
            dc2=dc2*scale
            fjder(i)=dc1*fjs(i-1)-dc2*fjs(i+1)
         enddo
      endif
      return
      end
c

c         random number generator
c
        double precision function hkrand(iseed_hk)
        implicit double precision (a-h,o-z)
        dimension iseed(4)
        data iseed/0,0,0,1/
        save
c
        if( iseed_hk .ne. 0 ) then
        iseed(1)=0
        iseed(2)=0
        iseed(3)=0
        iseed(4)=mod(2*iseed_hk+1,4096)
        endif
c
        hkrand=dlaran(iseed)
c
        return
        end

c
c      this file contains the basic subroutines for 
c      forming and evaluating multipole expansions.
c
c      remarks on scaling conventions.
c
c      1)  far field and local expansions are consistently rscaled as
c              
c
c          m_n^m (scaled) = m_n^m / rscale^(n)  so that upon evaluation
c
c          the field is  sum   m_n^m (scaled) * rscale^(n) / r^{n+1}.
c
c          l_n^m (scaled) = l_n^m * rscale^(n)  so that upon evaluation
c
c          the field is  sum   l_n^m (scaled) / rscale^(n) * r^{n}.
c
c
c      2) there are many definitions of the spherical harmonics,
c         which differ in terms of normalization constants. we
c         adopt the following convention:
c
c         for m>0, we define y_n^m according to 
c
c         y_n^m = \sqrt{2n+1} \sqrt{\frac{ (n-m)!}{(n+m)!}} \cdot
c                 p_n^m(\cos \theta)  e^{i m phi} 
c         and
c 
c         y_n^-m = dconjg( y_n^m )
c    
c         we omit the condon-shortley phase factor (-1)^m in the 
c         definition of y_n^m for m<0. (this is standard in several
c         communities.)
c
c         we also omit the factor \sqrt{\frac{1}{4 \pi}}, so that
c         the y_n^m are orthogonal on the unit sphere but not 
c         orthonormal.  (this is also standard in several communities.)
c         more precisely, 
c
c                 \int_s y_n^m y_n^m d\omega = 4 \pi. 
c
c         using our standard definition, the addition theorem takes 
c         the simple form 
c
c         1/(4\pi) 1/r = 
c         \sum_n 1/(2n+1) \sum_m 1/(4\pi) |s|^n ylm*(s) ylm(t)/ (|t|^(n+1)) 
c
c         1/(4\pi) 1/r = 
c         \sum_n \sum_m 1/(4\pi) |s|^n  ylm*(s)    ylm(t)     / (|t|^(n+1)) 
c                                       -------    ------
c                                      sqrt(2n+1) sqrt(2n+1)
c
c        in the laplace library (this library), we incorporate the
c        sqrt(2n+1) factor in both forming and evaluating multipole
c        expansions.
c
c-----------------------------------------------------------------------
c
c      l3dmpevalp: computes potentials due to a multipole expansion
c                    at a collection of targets (done,tested)
c
c      l3dmpevalg: computes potentials and gradients 
c                  due to a multipole expansion
c                  at a collection of targets (done,tested)
c
c      l3dmpevalh: computes potentials, gradients, and hessians 
c                  due to a multipole expansion
c                  at a collection of targets (done,tested)
c
c      l3dformmpc: creates multipole expansion (outgoing) due to 
c                 a collection of charges (done,tested)
c
c      l3dformmpd: creates multipole expansion (outgoing) due to 
c                 a collection of dipoles (done,tested)
c
c      l3dformmpcd: creates multipole expansion (outgoing) due to 
c                 a collection of charges and dipoles (done,tested)
c
c      l3dtaevalp: computes potentials 
c                  due to local expansion at a collection of targets
c
c      l3dtaevalg: computes potentials and gradients
c                  due to local expansion at a collection of targets
c
c      l3dtaevalh: computes potentials, gradients, and hessians
c                  due to local expansion at a collection of targets
c
c      l3dtaevalhessdini: initialization routine for l3dtaevalh
c
c      l3dformtac: creates local expansion due to 
c                 a collection of charges.
c
c      l3dformtad: creates local expansion due to 
c                 a collection of dipoles
c
c      l3dformtacd: creates local expansion due to 
c                 a collection of charges and dipoles
c
c
c      l3dmpevalhessdini:  initialization routine for l3dmpevalhessd
c
c      l3dmpevalh: computes potentials, gradients and Hessians
c                  due to a multipole expansion
c                    at a collection of targets (done,tested)
c
c**********************************************************************
      subroutine l3dmpevalp(nd,rscale,center,mpole,nterms,
     1		ztarg,ntarg,pot,wlege,nlege,thresh)
c**********************************************************************
c
c     this subroutine evaluates the potentials due to an
c     outgoing multipole expansion and increments inputs accordingly:
c
c     pot =  pot + sum sum  mpole(n,m) Y_nm(theta,phi) / r^{n+1} 
c                   n   m
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    multipole expansion 
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of target locations
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c     thresh :    threshold for computing outgoing expansion,
c                 potential at target location
c                 won't be updated if |t-c| <= thresh, where
c                 t is the target location and c is the expansion
c                 center location
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :   updated potentials at all targets
c
c----------------------------------------------------------------------
      implicit none

c
cc     calling sequence variables
c

      integer *8 nterms,nlege,ntarg,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      real *8 pot(nd,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(0:nlege,0:nlege), thresh

c
cc     temporary variables
c

      integer *8 idim
      real *8, allocatable :: ynm(:,:),fr(:)
      complex *16, allocatable :: ephi(:)
      integer *8 i,j,k,l,m,n,itarg
      real *8 done,r,theta,phi,zdiff(3)
      real *8 ctheta,stheta,cphi,sphi
      real *8 d,rs,rtmp1,rtmp2
      complex *16 ephi1
c
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1.0d0

      allocate(ephi(0:nterms+1))
      allocate(fr(0:nterms+1))
      allocate(ynm(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)

        if(abs(r).lt.thresh) goto 1000 

        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        d = 1.0d0/r
        fr(0) = d
        d = d*rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
        enddo
c
c    get the associated Legendre functions:
c

        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
        do l = 0,nterms
          rs = sqrt(1.0d0/(2*l+1))
          do m=0,l
            ynm(l,m) = ynm(l,m)*rs
          enddo
        enddo

        do idim=1,nd
          pot(idim,itarg) = pot(idim,itarg) +
     1                 real(mpole(idim,0,0))*fr(0)
        enddo
        do n=1,nterms
          rtmp1 = fr(n)*ynm(n,0)
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+real(mpole(idim,n,0))*rtmp1
          enddo
	      do m=1,n
            rtmp1 = fr(n)*ynm(n,m)
            do idim=1,nd
              rtmp2 = 2*real(mpole(idim,n,m)*ephi(m)) 
              pot(idim,itarg)=pot(idim,itarg)+rtmp1*rtmp2
            enddo
          enddo
        enddo
 1000 continue
      enddo

      return
      end
c
c
c
c**********************************************************************
      subroutine l3dmpevalg(nd,rscale,center,mpole,nterms,
     1		ztarg,ntarg,pot,grad,wlege,nlege,thresh)
c**********************************************************************
c
c
c     this subroutine evaluates the potentials and gradients due to  
c     an outgoing multipole expansion and increments inputs accordingly:
c
c
c     pot =  pot + sum sum  mpole(n,m) Y_nm(theta,phi) / r^{n+1} 
c                   n   m
c
c     grad =  grad + Gradient( sum sum  mpole(n,m) Y_nm(theta,phi)/r^{n+1})
c                               n   m
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    multipole expansion 
c     nterms :    order of the multipole expansion
c     ztarg  :    target location
c     ntarg  :    number of target locations
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c     thresh :    threshold for computing outgoing expansion,
c                 potential and gradient at target location
c                 won't be updated if |t-c| <= thresh, where
c                 t is the target location and c is the expansion
c                 center location
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :   updated potentials at targets
c     grad   :   updated gradients at targets 
c
c----------------------------------------------------------------------
      implicit none

c
cc     calling sequence variables
c

      integer *8 nterms,nlege,ntarg,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      real *8 pot(nd,ntarg),grad(nd,3,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(0:nlege,0:nlege), thresh

c
cc     temporary variables
c
      integer *8 idim
      real *8, allocatable :: ynm(:,:),ynmd(:,:),fr(:),frder(:)
      complex *16, allocatable :: ephi(:)
      integer *8 i,j,k,l,m,n,itarg
      real *8 done,r,theta,phi,zdiff(3)
      real *8 ctheta,stheta,cphi,sphi
      real *8 d,rx,ry,rz,thetax,thetay,thetaz,phix,phiy,phiz,rs
      real *8 rtmp1,rtmp2,rtmp3,rtmp4,rtmp5,rtmp6
      complex *16 ephi1
      real *8 ur(nd),utheta(nd),uphi(nd)
c
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1.0d0

      allocate(ephi(0:nterms+1))
      allocate(fr(0:nterms+1),frder(0:nterms))
      allocate(ynm(0:nterms,0:nterms))
      allocate(ynmd(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)

        if(abs(r).lt.thresh) goto 1000 

        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        d = 1.0d0/r
        fr(0) = d
        d = d*rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
        enddo
        do i=0,nterms
          frder(i) = -(i+1.0d0)*fr(i+1)/rscale
        enddo
c
c    get the associated Legendre functions:
c

        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do l = 0,nterms
          rs = sqrt(1.0d0/(2*l+1))
          do m=0,l
            ynm(l,m) = ynm(l,m)*rs
            ynmd(l,m) = ynmd(l,m)*rs
          enddo
        enddo

c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r
        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r
        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0

        do idim=1,nd
          ur(idim) = real(mpole(idim,0,0))*frder(0)
          utheta(idim) = 0.0d0
          uphi(idim) = 0.0d0
          pot(idim,itarg) = pot(idim,itarg) + 
     1        real(mpole(idim,0,0))*fr(0)
        enddo

        do n=1,nterms
          rtmp1 = fr(n)*ynm(n,0)
          rtmp2 = frder(n)*ynm(n,0)
          rtmp3 = -fr(n)*ynmd(n,0)*stheta
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+real(mpole(idim,n,0))*rtmp1
            ur(idim)=ur(idim)+real(mpole(idim,n,0))*rtmp2
            utheta(idim)=utheta(idim)+real(mpole(idim,n,0))*rtmp3
          enddo

	      do m=1,n
            rtmp1 = fr(n)*ynm(n,m)*stheta
            rtmp4 = frder(n)*ynm(n,m)*stheta
            rtmp5 = -fr(n)*ynmd(n,m)
            rtmp6 = -m*fr(n)*ynm(n,m)

            do idim=1,nd
              rtmp2 = 2*real(mpole(idim,n,m)*ephi(m)) 

              pot(idim,itarg)=pot(idim,itarg)+rtmp1*rtmp2
              ur(idim) = ur(idim) + rtmp4*rtmp2
              utheta(idim) = utheta(idim)+rtmp5*rtmp2
              rtmp2 = 2*dimag(mpole(idim,n,m)*ephi(m))
              uphi(idim) = uphi(idim) + rtmp6*rtmp2
            enddo
          enddo
        enddo

        do idim=1,nd
          grad(idim,1,itarg)=grad(idim,1,itarg)+ur(idim)*rx+
     1          utheta(idim)*thetax+uphi(idim)*phix
          grad(idim,2,itarg)=grad(idim,2,itarg)+ur(idim)*ry+
     1          utheta(idim)*thetay+uphi(idim)*phiy
          grad(idim,3,itarg)=grad(idim,3,itarg)+ur(idim)*rz+
     1          utheta(idim)*thetaz+uphi(idim)*phiz
        enddo

 1000 continue
      enddo

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformmpc(nd,rscale,sources,charge,ns,center,
     1                  nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs multipole expansion about CENTER due to NS charges 
C     located at SOURCES(3,*) and add to existing expansions
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(nd,ns)   : charge strengths
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the multipole expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 charge(nd,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:)
      real *8 theta,stheta,ctheta,phi,sphi,cphi,dtmp,d,r
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16, allocatable :: ephi(:)
      complex *16 ephi1
      complex *16 eye
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))

      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        fr(0) = inv4pi
        d = r/rscale
        fr(1) = inv4pi*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo

c
c     get the associated Legendre functions and rescale
c      by 1/sqrt(2*l+1)
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r =  
c          \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)  / (|T|)^{n+1}
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        do idim=1,nd
          mpole(idim,0,0)= mpole(idim,0,0) + fr(0)*charge(idim,isrc)
        enddo
        do n=1,nterms
          dtmp=ynm(n,0)*fr(n)
          do idim=1,nd
            mpole(idim,n,0)= mpole(idim,n,0) + dtmp*charge(idim,isrc)
          enddo
          do m=1,n
            dtmp=ynm(n,m)*fr(n)
            do idim=1,nd
              mpole(idim,n,m) = mpole(idim,n,m) + 
     1                  dtmp*ephi(-m)*charge(idim,isrc)
              mpole(idim,n,-m) = mpole(idim,n,-m) + 
     1                  dtmp*ephi(m)*charge(idim,isrc)
            enddo
          enddo
        enddo
      enddo
c
c
      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformmpd(nd,rscale,sources,dipvec,ns,center,
     1                  nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs multipole expansion about CENTER due to NS dipoles 
C     located at SOURCES(3,*) and adds to existing expansion
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     dipvec(nd,3,ns) : dipole orientiation vectors
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the multipole expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 dipvec(nd,3,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:),frder(:),ynmd(:,:)
      real *8 thetaz,thetay,thetax, theta
      real *8 stheta,sphi,rx,ry,rz,r
      real *8 ctheta,cphi
      real *8 phix,phiy,phiz,phi,fruse,d
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      complex *16 ur,utheta,uphi,ux,uy,uz,zzz
      complex *16, allocatable :: ephi(:)
      complex *16 eye,ephi1
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(frder(0:nterms),ynmd(0:nterms,0:nterms))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))


      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        fr(0) = inv4pi
        d = r/rscale
        fr(1) = inv4pi*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
        frder(0) = 0.0d0
        do i=1,nterms
          frder(i) = i*fr(i-1)/rscale
        enddo
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c     In thetax, thetaty, phix, phiy we leave out the 1/r factors in the 
c     change of variables to avoid blow-up at the origin.
c     For the n=0 mode, it is not relevant. For n>0 modes,
c     the variable fruse is set to fr(n)/r:
c
c     
c
        rx = stheta*cphi
        thetax = ctheta*cphi
        phix = -sphi
        ry = stheta*sphi
        thetay = ctheta*sphi
        phiy = cphi
        rz = ctheta
        thetaz = -stheta
        phiz = 0.0d0
c
c     get the associated Legendre functions and rescale by
c       1/sqrt(2*l+1)
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
            ynmd(j,i) = ynmd(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r = 
c         \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)/ (|T|^(n+1))
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        ur = ynm(0,0)*frder(0)
        ux = ur*rx 
        uy = ur*ry 
        uz = ur*rz
        do idim=1,nd
          zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
          mpole(idim,0,0)= mpole(idim,0,0) + zzz
        enddo

        do n=1,nterms
          fruse = fr(n-1)/rscale
          ur = ynm(n,0)*frder(n)
          utheta = -fruse*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax 
          uy = ur*ry + utheta*thetay 
          uz = ur*rz + utheta*thetaz
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + zzz
          enddo
          do m=1,n
            ur = frder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fruse*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fruse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,m)= mpole(idim,n,m) + zzz
            enddo
c
            ur = frder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fruse*ynmd(n,m)
            uphi = eye*m*ephi(m)*fruse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m) + zzz
            enddo
          enddo
        enddo
      enddo
c
      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformmpcd(nd,rscale,sources,charge,dipvec,ns,
     1             center,nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs multipole expansion about CENTER due to NS charges+dipoles 
C     located at SOURCES(3,*) and adds to existing expansion
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(nd,ns)   : charge strengths
C     dipvec(nd,3,ns) : dipole orientiation vectors
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the multipole expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 charge(nd,ns)
      real *8 dipvec(nd,3,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:),frder(:),ynmd(:,:)
      real *8 thetaz,thetay,thetax, theta
      real *8 stheta,sphi,rx,ry,rz,r
      real *8 ctheta,cphi
      real *8 phix,phiy,phiz,phi,fruse,d,dtmp
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      complex *16 ur,utheta,uphi,ux,uy,uz,zzz
      complex *16, allocatable :: ephi(:)
      complex *16 eye,ephi1
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(frder(0:nterms),ynmd(0:nterms,0:nterms))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))

      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        fr(0) = inv4pi
        d = r/rscale
        fr(1) = inv4pi*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
        frder(0) = 0.0d0
        do i=1,nterms
          frder(i) = i*fr(i-1)/rscale
        enddo
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c     In thetax, thetaty, phix, phiy we leave out the 1/r factors in the 
c     change of variables to avoid blow-up at the origin.
c     For the n=0 mode, it is not relevant. For n>0 modes,
c     the variable fruse is set to fr(n)/r:
c
c     
c
        rx = stheta*cphi
        thetax = ctheta*cphi
        phix = -sphi
        ry = stheta*sphi
        thetay = ctheta*sphi
        phiy = cphi
        rz = ctheta
        thetaz = -stheta
        phiz = 0.0d0
c
c     get the associated Legendre functions and rescale by
c       1/sqrt(2*l+1)
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
            ynmd(j,i) = ynmd(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r = 
c         \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)/ (|T|^(n+1))
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        ur = ynm(0,0)*frder(0)
        ux = ur*rx 
        uy = ur*ry 
        uz = ur*rz
        do idim=1,nd
          zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
          mpole(idim,0,0)= mpole(idim,0,0) + zzz +
     1            fr(0)*charge(idim,isrc)
        enddo

        do n=1,nterms
          fruse = fr(n-1)/rscale
          ur = ynm(n,0)*frder(n)
          utheta = -fruse*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax 
          uy = ur*ry + utheta*thetay 
          uz = ur*rz + utheta*thetaz
          dtmp = fr(n)*ynm(n,0)
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + zzz + 
     1         charge(idim,isrc)*dtmp
          enddo
          do m=1,n
            ur = frder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fruse*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fruse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            dtmp = ynm(n,m)*fr(n)*stheta
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,m)= mpole(idim,n,m) + zzz + 
     1            charge(idim,isrc)*dtmp*ephi(-m)
            enddo
c
            ur = frder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fruse*ynmd(n,m)
            uphi = eye*m*ephi(m)*fruse*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m)+zzz+
     1              charge(idim,isrc)*dtmp*ephi(m)
            enddo
          enddo
        enddo
      enddo
c
      return
      end
c
c
c
c
c
c
c**********************************************************************
      subroutine l3dtaevalp(nd,rscale,center,mpole,nterms,
     1		ztarg,ntarg,pot,wlege,nlege)
c**********************************************************************
c
c
c     this subroutine evaluates the potentials due to an   
c     incoming local expansion and increments accordingly:
c
c     pot =  pot + sum sum  r^{n} mpole(n,m) Y_nm(theta,phi) /sqrt(2n+1) 
c                   n   m
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    local expansion 
c     nterms :    order of the multipole expansion
c     ztarg  :    target location
c     ntarg  :    number of target locations
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :   updated potentials at targets
c
c----------------------------------------------------------------------
      implicit none
c
cc     calling sequence variables
c
      integer *8 nterms,nlege,ntarg,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      real *8 pot(nd,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(0:nlege,0:nlege), thresh
c
cc     temporary variables
c
      integer *8 idim
      real *8, allocatable :: ynm(:,:),fr(:)
      complex *16, allocatable :: ephi(:)
      integer *8 i,j,k,l,m,n,itarg
      real *8 done,r,theta,phi,zdiff(3)
      real *8 ctheta,stheta,cphi,sphi
      real *8 d,rs,rtmp1,rtmp2
      complex *16 ephi1
c
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1.0d0

      allocate(ephi(0:nterms+1))
      allocate(fr(0:nterms+1))
      allocate(ynm(0:nterms,0:nterms))

      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)

        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        cphi = dreal(ephi1)
        sphi = dimag(ephi1)
        fr(0) = 1.0d0
        d = r/rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
        enddo
c
c    get the associated Legendre functions:
c

        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
        do l = 0,nterms
          rs = sqrt(1.0d0/(2*l+1))
          do m=0,l
            ynm(l,m) = ynm(l,m)*rs
          enddo
        enddo

        do idim=1,nd
          pot(idim,itarg) = pot(idim,itarg) + 
     1        real(mpole(idim,0,0))*fr(0)
        enddo
        do n=1,nterms
          rtmp1 = fr(n)*ynm(n,0)
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+real(mpole(idim,n,0))*rtmp1
          enddo
	      do m=1,n
            rtmp1 = fr(n)*ynm(n,m)
            do idim=1,nd
              rtmp2 = 2*real(mpole(idim,n,m)*ephi(m)) 
              pot(idim,itarg)=pot(idim,itarg)+rtmp1*rtmp2
            enddo
          enddo
        enddo
      enddo
      return
      end
c
c
c
c**********************************************************************
      subroutine l3dtaevalg(nd,rscale,center,mpole,nterms,
     1		ztarg,ntarg,pot,grad,wlege,nlege)
c**********************************************************************
c
c
c     this subroutine evaluates the potentials and gradients due to  
c     an incoming local expansion and increments inputs accordingly:
c
c     pot =  pot + sum sum  mpole(n,m) r^{n}Y_nm(theta,phi) / sqrt(2n+1) 
c                   n   m
c
c     grad =  grad + 
c              Gradient( sum sum mpole(n,m)r^{n}Y_nm(theta,phi)/sqrt(2n+1))
c                         n   m
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     rscale :    scaling parameter 
c     center :    expansion center
c     mpole  :    local expansion 
c     nterms :    order of the multipole expansion
c     ztarg  :    target location
c     ntarg  :    number of target locations
c     wlege  :    precomputed array of scaling coeffs for Pnm
c     nlege  :    dimension parameter for wlege
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :   updated potentials at targets
c     grad   :   updated gradients at targets 
c----------------------------------------------------------------------
      implicit none
c
cc     calling sequence variables
c
      integer *8 nterms,nlege,ntarg,nd
      real *8 rscale,center(3),ztarg(3,ntarg)
      real *8 pot(nd,ntarg),grad(nd,3,ntarg)
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 wlege(0:nlege,0:nlege)
c
cc     temporary variables
c
      integer *8 idim
      real *8, allocatable :: ynm(:,:),ynmd(:,:),fr(:),frder(:)
      complex *16, allocatable :: ephi(:)
      integer *8 i,j,k,l,m,n,itarg
      real *8 done,r,theta,phi,zdiff(3)
      real *8 ctheta,stheta,cphi,sphi
      real *8 d,rx,ry,rz,thetax,thetay,thetaz,phix,phiy,phiz,rs
      real *8 rtmp1,rtmp2,rtmp3,rtmp4,rtmp5,rtmp6
      complex *16 ephi1
      real *8 ur(nd),utheta(nd),uphi(nd)
c
      complex *16 eye
      complex *16 ztmp1,ztmp2,ztmp3,ztmpsum,z
      real *8 rscaleinv
c
      data eye/(0.0d0,1.0d0)/
c
      done=1.0d0
      allocate(ephi(0:nterms+1))
      allocate(fr(0:nterms+1),frder(0:nterms))
      allocate(ynm(0:nterms,0:nterms))
      allocate(ynmd(0:nterms,0:nterms))
c
      do itarg=1,ntarg
        zdiff(1)=ztarg(1,itarg)-center(1)
        zdiff(2)=ztarg(2,itarg)-center(2)
        zdiff(3)=ztarg(3,itarg)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)

        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array
c
        ephi(0)=done
        ephi(1)=ephi1
        d = r/rscale
        fr(0) = 1.0d0
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
        enddo
        frder(0) = 0
        do i=1,nterms
          frder(i) = i*fr(i-1)/rscale
        enddo
c
c    get the associated Legendre functions:
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do l = 0,nterms
          rs = sqrt(1.0d0/(2*l+1))
          do m=0,l
            ynm(l,m) = ynm(l,m)*rs
            ynmd(l,m) = ynmd(l,m)*rs
          enddo
        enddo
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c
c     NOTE: sphereical derivative needs to be fixed for r=0
c

        rscaleinv = 1.0d0/rscale
        rx = stheta*cphi
        thetax = ctheta*cphi*rscaleinv
        phix = -sphi*rscaleinv
        ry = stheta*sphi
        thetay = ctheta*sphi*rscaleinv
        phiy = cphi*rscaleinv
        rz = ctheta
        thetaz = -stheta*rscaleinv
        phiz = 0.0d0
c
        do idim=1,nd
          ur(idim) = real(mpole(idim,0,0))*frder(0)
          utheta(idim) = 0.0d0
          uphi(idim) = 0.0d0
          pot(idim,itarg) = pot(idim,itarg)+real(mpole(idim,0,0))*fr(0)
        enddo
c
        do n=1,nterms
          rtmp1 = fr(n)*ynm(n,0)
          rtmp2 = frder(n)*ynm(n,0)
          rtmp3 = -fr(n-1)*ynmd(n,0)*stheta
          do idim=1,nd
            pot(idim,itarg)=pot(idim,itarg)+real(mpole(idim,n,0))*rtmp1
            ur(idim)=ur(idim)+real(mpole(idim,n,0))*rtmp2
            utheta(idim)=utheta(idim)+real(mpole(idim,n,0))*rtmp3
          enddo
c
	      do m=1,n
            rtmp1 = fr(n)*ynm(n,m)*stheta
            rtmp4 = frder(n)*ynm(n,m)*stheta
            rtmp5 = -fr(n-1)*ynmd(n,m)
            rtmp6 = -m*fr(n-1)*ynm(n,m)

            do idim=1,nd
              rtmp2 = 2*real(mpole(idim,n,m)*ephi(m)) 

              pot(idim,itarg)=pot(idim,itarg)+rtmp1*rtmp2
              ur(idim) = ur(idim) + rtmp4*rtmp2
              utheta(idim) = utheta(idim)+rtmp5*rtmp2
              rtmp2 = 2*dimag(mpole(idim,n,m)*ephi(m))
              uphi(idim) = uphi(idim) + rtmp6*rtmp2
            enddo
          enddo
        enddo
c
        do idim=1,nd
          grad(idim,1,itarg)=grad(idim,1,itarg)+ur(idim)*rx+
     1          utheta(idim)*thetax+uphi(idim)*phix
          grad(idim,2,itarg)=grad(idim,2,itarg)+ur(idim)*ry+
     1          utheta(idim)*thetay+uphi(idim)*phiy
          grad(idim,3,itarg)=grad(idim,3,itarg)+ur(idim)*rz+
     1          utheta(idim)*thetaz+uphi(idim)*phiz
        enddo
 1000 continue
      enddo
      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformtac(nd,rscale,sources,charge,ns,center,
     1                  nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs local expansion about CENTER due to NS charges 
C     located at SOURCES(3,*) and add to existing expansions
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(nd,ns)   : charge strengths
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the local expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 charge(nd,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:)
      real *8 theta,stheta,ctheta,phi,sphi,cphi,dtmp,d,r
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16, allocatable :: ephi(:)
      complex *16 ephi1
      complex *16 eye
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))

      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        d = 1.0d0/r
        fr(0) = inv4pi
        d = d*rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo

c
c     get the associated Legendre functions and rescale
c      by 1/sqrt(2*l+1)
c
        call ylgndrfw(nterms,ctheta,ynm,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r =  
c          \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)  / (|T|)^{n+1}
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        do idim=1,nd
          mpole(idim,0,0)= mpole(idim,0,0) + fr(0)*charge(idim,isrc)
        enddo
        do n=1,nterms
          dtmp=ynm(n,0)*fr(n)
          do idim=1,nd
            mpole(idim,n,0)= mpole(idim,n,0) + dtmp*charge(idim,isrc)
          enddo
          do m=1,n
            dtmp=ynm(n,m)*fr(n)
            do idim=1,nd
              mpole(idim,n,m) = mpole(idim,n,m) + 
     1                  dtmp*ephi(-m)*charge(idim,isrc)
              mpole(idim,n,-m) = mpole(idim,n,-m) + 
     1                  dtmp*ephi(m)*charge(idim,isrc)
            enddo
          enddo
        enddo
      enddo
c
c
      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformtad(nd,rscale,sources,dipvec,ns,center,
     1                  nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs multipole expansion about CENTER due to NS dipoles 
C     located at SOURCES(3,*) and adds to existing expansion
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     dipvec(nd,3,ns) : dipole orientiation vectors
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the multipole expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 dipvec(nd,3,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:),frder(:),ynmd(:,:)
      real *8 thetaz,thetay,thetax, theta
      real *8 stheta,sphi,rx,ry,rz,r
      real *8 ctheta,cphi
      real *8 phix,phiy,phiz,phi,d
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      complex *16 ur,utheta,uphi,ux,uy,uz,zzz
      complex *16, allocatable :: ephi(:)
      complex *16 eye,ephi1
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(frder(0:nterms),ynmd(0:nterms,0:nterms))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))

      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        d = 1.0d0/r
        fr(0) = inv4pi*d
        d = d*rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
        do i=0,nterms
          frder(i) = -(i+1.0d0)*fr(i+1)/rscale
        enddo
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c
        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r
        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r
        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0
c
c     get the associated Legendre functions and rescale by
c       1/sqrt(2*l+1)
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
            ynmd(j,i) = ynmd(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r = 
c         \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)/ (|T|^(n+1))
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        ur = ynm(0,0)*frder(0)
        ux = ur*rx 
        uy = ur*ry 
        uz = ur*rz
        do idim=1,nd
          zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
          mpole(idim,0,0)= mpole(idim,0,0) + zzz
        enddo

        do n=1,nterms
          ur = ynm(n,0)*frder(n)
          utheta = -fr(n)*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax 
          uy = ur*ry + utheta*thetay 
          uz = ur*rz + utheta*thetaz
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + zzz
          enddo
          do m=1,n
            ur = frder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fr(n)*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fr(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,m)= mpole(idim,n,m) + zzz
            enddo
c
            ur = frder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fr(n)*ynmd(n,m)
            uphi = eye*m*ephi(m)*fr(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m) + zzz
            enddo
          enddo
        enddo
      enddo
c
      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3dformtacd(nd,rscale,sources,charge,dipvec,ns,
     1             center,nterms,mpole,wlege,nlege)
C***********************************************************************
C
C     Constructs multipole expansion about CENTER due to NS charges+dipoles 
C     located at SOURCES(3,*) and adds to existing expansion
C
c-----------------------------------------------------------------------
C     INPUT:
c
c     nd              : number of multipole expansions
C     rscale          : the scaling factor.
C     sources(3,ns)   : coordinates of sources
C     charge(nd,ns)   : charge strengths
C     dipvec(nd,3,ns) : dipole orientiation vectors
C     ns              : number of sources
C     center(3)       : epxansion center
C     nterms          : order of multipole expansion
C     wlege           : precomputed array of scaling coeffs for pnm
C     nlege           : dimension parameter for wlege
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     mpole           : coeffs of the multipole expansion
c-----------------------------------------------------------------------
      implicit none
c
cc       calling sequence variables
c
      
      integer *8 nterms,ns,nd, nlege
      real *8 center(3),sources(3,ns)
      real *8 wlege(0:nlege,0:nlege)
      real *8 rscale
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      real *8 charge(nd,ns)
      real *8 dipvec(nd,3,ns)

c
cc       temporary variables
c

      integer *8 i,j,k,l,m,n,isrc,idim
      real *8 zdiff(3)
      real *8, allocatable :: ynm(:,:),fr(:),rfac(:),frder(:),ynmd(:,:)
      real *8 thetaz,thetay,thetax, theta
      real *8 stheta,sphi,rx,ry,rz,r
      real *8 ctheta,cphi
      real *8 phix,phiy,phiz,phi,fruse,d,dtmp
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2

      complex *16 ur,utheta,uphi,ux,uy,uz,zzz
      complex *16, allocatable :: ephi(:)
      complex *16 eye,ephi1
      data eye/(0.0d0,1.0d0)/

      allocate(ynm(0:nterms,0:nterms),fr(0:nterms+1))
      allocate(frder(0:nterms),ynmd(0:nterms,0:nterms))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(rfac(0:nterms))

      do i=0,nterms
        rfac(i) = 1/sqrt(2.0d0*i + 1.0d0)
      enddo

      do isrc = 1,ns
        zdiff(1)=sources(1,isrc)-center(1)
        zdiff(2)=sources(2,isrc)-center(2)
        zdiff(3)=sources(3,isrc)-center(3)
c
        call cart2polar(zdiff,r,theta,phi)
        ctheta = dcos(theta)
        stheta = dsin(theta)
        cphi = dcos(phi)
        sphi = dsin(phi)
        ephi1 = dcmplx(cphi,sphi)
c
c     compute exp(eye*m*phi) array and fr array
c
        ephi(0)=1.0d0
        ephi(1)=ephi1
        ephi(-1)=dconjg(ephi1)
        d = 1.0d0/r
        fr(0) = inv4pi*d
        d = d*rscale
        fr(1) = fr(0)*d
        do i=2,nterms+1
          fr(i) = fr(i-1)*d
          ephi(i)=ephi(i-1)*ephi1
          ephi(-i)=ephi(-i+1)*ephi(-1)
        enddo
        do i=0,nterms
          frder(i) = -(i+1.0d0)*fr(i+1)/rscale
        enddo
c
c     compute coefficients in change of variables from spherical
c     to Cartesian gradients. In phix, phiy, we leave out the 
c     1/sin(theta) contribution, since we use values of Ynm (which
c     multiplies phix and phiy) that are scaled by 
c     1/sin(theta).
c
c     In thetax, thetaty, phix, phiy we leave out the 1/r factors in the 
c     change of variables to avoid blow-up at the origin.
c     For the n=0 mode, it is not relevant. For n>0 modes,
c     the variable fruse is set to fr(n)/r:
c
c     
c
        rx = stheta*cphi
        thetax = ctheta*cphi/r
        phix = -sphi/r
        ry = stheta*sphi
        thetay = ctheta*sphi/r
        phiy = cphi/r
        rz = ctheta
        thetaz = -stheta/r
        phiz = 0.0d0
c
c     get the associated Legendre functions and rescale by
c       1/sqrt(2*l+1)
c
        call ylgndr2sfw(nterms,ctheta,ynm,ynmd,wlege,nlege)
        do i=0,nterms
          do j=0,nterms
            ynm(j,i) = ynm(j,i)*rfac(j)
            ynmd(j,i) = ynmd(j,i)*rfac(j)
          enddo
        enddo
c
c
c     Compute contribution to mpole coefficients.
c
c     Recall that there are multiple definitions of scaling for
c     Ylm. Using our standard definition, 
c     the addition theorem takes the simple form 
c
c        1/(4\pi) 1/r = 
c         \sum_n 1/(2n+1) \sum_m 1/(4\pi) |S|^n Ylm*(S) Ylm(T)/ (|T|^(n+1))
c
c     so contribution is 1/(4\pi) |S|^n times
c   
c       Ylm*(S)  = P_l,m * dconjg(ephi(m))               for m > 0   
c       Yl,m*(S)  = P_l,|m| * dconjg(ephi(m))            for m < 0
c                   
c       where P_l,m is the scaled associated Legendre function.
c
c
        ur = ynm(0,0)*frder(0)
        ux = ur*rx 
        uy = ur*ry 
        uz = ur*rz
        do idim=1,nd
          zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
          mpole(idim,0,0)= mpole(idim,0,0) + zzz + 
     1            fr(0)*charge(idim,isrc)
        enddo

        do n=1,nterms
          ur = ynm(n,0)*frder(n)
          utheta = -fr(n)*ynmd(n,0)*stheta
          ux = ur*rx + utheta*thetax 
          uy = ur*ry + utheta*thetay 
          uz = ur*rz + utheta*thetaz
          dtmp = fr(n)*ynm(n,0)
          do idim=1,nd
            zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1        dipvec(idim,3,isrc)*uz
            mpole(idim,n,0)= mpole(idim,n,0) + zzz + 
     1         charge(idim,isrc)*dtmp
          enddo
          do m=1,n
            ur = frder(n)*ynm(n,m)*stheta*ephi(-m)
            utheta = -ephi(-m)*fr(n)*ynmd(n,m)
            uphi = -eye*m*ephi(-m)*fr(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            dtmp = ynm(n,m)*fr(n)*stheta
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,m)= mpole(idim,n,m) + zzz+ 
     1            charge(idim,isrc)*dtmp*ephi(-m)
            enddo
c
            ur = frder(n)*ynm(n,m)*stheta*ephi(m)
            utheta = -ephi(m)*fr(n)*ynmd(n,m)
            uphi = eye*m*ephi(m)*fr(n)*ynm(n,m)
            ux = ur*rx + utheta*thetax + uphi*phix
            uy = ur*ry + utheta*thetay + uphi*phiy
            uz = ur*rz + utheta*thetaz + uphi*phiz
            do idim=1,nd
              zzz = dipvec(idim,1,isrc)*ux + dipvec(idim,2,isrc)*uy + 
     1          dipvec(idim,3,isrc)*uz
              mpole(idim,n,-m)= mpole(idim,n,-m)+zzz+
     1              charge(idim,isrc)*dtmp*ephi(m)
            enddo
          enddo
        enddo
      enddo
c
      return
      end
c
C***********************************************************************
      subroutine l3dmpevalhessdini(nterms,scarray)
C***********************************************************************
C
c     Precomputes array used in 
c     mpole-local translation operator from an nterms expansion to an 
c     order 2 expansion (sufficient to compute pot/fld/hessian).     
C
c-----------------------------------------------------------------------
C     INPUT:
c
C     nterms          : order of multipole expansion
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     scarray         : work array of size > 10*(nterms+2)**2
c-----------------------------------------------------------------------
      implicit none
      integer *8  nterms,l,j,k,m,ll,mm,iuse,lnew,mnew
      real *8 scarray(1),cscale
      real *8 d
      real *8, allocatable :: c(:,:)
      real *8, allocatable :: sqc(:,:)
c
      allocate(c(0:2*nterms+4,0:2*nterms+4))
      allocate(sqc(0:2*nterms+4,0:2*nterms+4))
c
      do l = 0,2*nterms+4
         c(l,0) = 1.0d0
         sqc(l,0) = 1.0d0
      enddo
      do m = 1,2*nterms+4
         c(m,m) = 1.0d0
         sqc(m,m) = 1.0d0
         do l = m+1,2*nterms+4
            c(l,m) = c(l-1,m)+c(l-1,m-1)
            sqc(l,m) = dsqrt(c(l,m))
         enddo
      enddo
c
      iuse = 1
      do lnew= 0,2
         do l = 0,nterms
            do m = -l,l
               do mnew = -lnew,lnew
                  ll = l+lnew
                  mm = mnew-m
                  cscale = sqc(ll+mm,lnew+mnew)*sqc(ll-mm,lnew-mnew)
                  cscale = cscale*(-1)**l
                  cscale = cscale/dsqrt(2*ll+1.0d0)
                  if ( (m .lt. 0) .and. (mnew .lt. 0) ) then
                     if (-mnew .lt. -m)  cscale = cscale*(-1)**mnew
                     if (-mnew .ge. -m)  cscale = cscale*(-1)**m
                  endif
                  if ( (m .gt. 0) .and. (mnew .gt. 0) ) then
                     if (mnew .lt. m) cscale = cscale*(-1)**mnew
                     if (mnew .ge. m) cscale = cscale*(-1)**m
                  endif
                  scarray(iuse) = cscale
                  iuse = iuse+1
               enddo
            enddo
         enddo
      enddo
      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3dmpevalh(nd,rscale,center,mpole,nterms,
     1            ztarg,ntarg,pot,grad,hess,thresh,scarray)
C***********************************************************************
c
c     This subroutine evaluates the potential, gradient and
c     Hessian of the potential due to a multipole expansion and adds
c     to existing quantities
c
c     pot = pot + sum sum  mpole(n,m) Y_nm(theta,phi)  / r^{n+1}
c             n   m
c
c     grad =  grad + Gradient( sum sum  mpole(n,m) Y_nm(theta,phi)/r^{n+1})
c                               n   m
c
c     hess =  hess + Hessian( sum sum  mpole(n,m) Y_nm(theta,phi)/r^{n+1})
c                              n   m
c
c     The method is based on translation of mpole to 
c     second order expansion at target location.
c     It is reasonably optimized, precomputing the array of 
c     binomial/factorial terms that appear in the shift operator.
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of multipole expansions
c     rscale :    scaling parameter (see formmp1l3d)
c     center :    expansion center
c     mpole  :    multipole expansion in 2d matrix format
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of  target location
c     thresh :    threshold for computing outgoing expansion,
c                 potential and gradient at target location
c                 won't be updated if |t-c| <= thresh, where
c                 t is the target location and c is the expansion
c                 center location
c     scarray :   precomputed array (MUST BE PRECEDED BY CALL TO
c                 L3DMPEVALHESSDINI(nterms,scarray))
c                 with dimension of scarray at least 10*(nterms+2)**2
c                 If nterms is changed, 
c                 l3dtaevalhessdini must be called again.
c
c     OUTPUT:
c
c     pot    :   updated potential at ztarg
c     grad   :   updated gradient at ztarg 
c     hess   :   updated Hessian at ztarg
c                 ordered as dxx,dyy,dzz,dxy,dxz,dyz.
c--------------------------------------------------------------------
      implicit none
      integer *8 nterms,ntarg,nd,itarg
      integer *8  l,m,lnew,mnew,ll,mm,iuse,j,k,lsum,idim
      real *8 center(3),ztarg(3,ntarg)
      real *8 zdiff(3)
      real *8 scarray(*),rscale,thresh
      real *8 cphi,sphi,phi,theta,ctheta,d,dd,pi,rfac
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
ccc      complex *16 local2(0:2,-2:2)
      complex *16 z0,ima,ephi1
      real *8 pot(nd,ntarg),grad(nd,3,ntarg)
      real *8 hess(nd,6,ntarg)
c
      real *8, allocatable :: pp(:,:)
      real *8, allocatable :: powers(:)
      complex *16, allocatable :: local2(:,:)
      complex *16, allocatable :: ppc(:,:)
      complex *16, allocatable :: ephi(:)
c
      data ima/(0.0d0,1.0d0)/
c
      allocate(pp(0:nterms+2,0:nterms+2))
      allocate(ppc(0:nterms+2,-nterms-2:nterms+2))
      allocate(powers(0:nterms+3))
      allocate(ephi(-nterms-3:nterms+3))
      allocate(local2(nd,9))
c
c     determine order of shifted expansion 
c
c
      do itarg = 1,ntarg
c
         do ll = 1,nd
         do l = 1,9
            local2(ll,l) = 0.0d0
         enddo
         enddo
c
         zdiff(1) = center(1) - ztarg(1,itarg)
         zdiff(2) = center(2) - ztarg(2,itarg)
         zdiff(3) = center(3) - ztarg(3,itarg)
         call cart2polar(zdiff,d,theta,phi)
c
         if (abs(d).lt.thresh) goto 1000
c
         ctheta = dcos(theta)
         cphi = dcos(phi)
         sphi = dsin(phi)
         ephi1 = dcmplx(cphi,sphi)
C
C----- create array of powers of R and e^(i*m*phi).
c
         dd = 1.0d0/d
         dd = dd*rscale
         powers(0) = 1.0d0
         powers(1) = dd
         ephi(0) = 1.0d0
         ephi(1) = ephi1
         ephi(-1) = dconjg(ephi1)
         do l = 2,nterms+3
            powers(l) = dd*powers(l-1)
            ephi(l) = ephi(l-1)*ephi(1)
            ephi(-l) = dconjg(ephi(l))
         enddo
c
         call ylgndr(nterms+2,ctheta,pp)
         do l = 0,nterms+2
            do k = -l,l
               ppc(l,k) = pp(l,abs(k))*powers(l+1)*ephi(-k)
            enddo
         enddo
c
c     shift to local expansion of order ll about target point
c
         iuse = 1
         do l = 0,nterms
            do m = -l,l
               do idim=1,nd
                  local2(idim,1) = local2(idim,1) +
     1            ppc(l,-m)*scarray(iuse)*mpole(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
         enddo
         do l = 0,nterms
            lsum = l+1
            do m = -l,l
               do idim=1,nd
                  local2(idim,2) = local2(idim,2) +
     1            ppc(lsum,-1-m)*scarray(iuse)*mpole(idim,l,m)
                  local2(idim,3) = local2(idim,3) +
     1            ppc(lsum,  -m)*scarray(iuse+1)*mpole(idim,l,m)
                  local2(idim,4) = local2(idim,4) +
     1            ppc(lsum, 1-m)*scarray(iuse+2)*mpole(idim,l,m)
               enddo
               iuse = iuse+3
            enddo
         enddo
         do l = 0,nterms
            lsum = l+2
            do m = -l,l
               do idim=1,nd
                  local2(idim,5) = local2(idim,5) +
     1            ppc(lsum,-2-m)*scarray(iuse  )*mpole(idim,l,m)
                  local2(idim,6) = local2(idim,6) +
     1            ppc(lsum,-1-m)*scarray(iuse+1)*mpole(idim,l,m)
                  local2(idim,7) = local2(idim,7) +
     1            ppc(lsum,-m)*scarray(iuse+2)*mpole(idim,l,m)
                  local2(idim,8) = local2(idim,8) +
     1            ppc(lsum,1-m)*scarray(iuse+3)*mpole(idim,l,m)
                  local2(idim,9) = local2(idim,9) +
     1            ppc(lsum,2-m)*scarray(iuse+4)*mpole(idim,l,m)
               enddo
               iuse = iuse+5
            enddo
         enddo
c
ccc      pi = 4.0d0*datan(1.0d0)
c
c     pot comes from 0,0 mode
c
         do idim=1,nd
            pot(idim,itarg) = pot(idim,itarg)+local2(idim,1)/rscale
c
c     fld comes from l=1 modes
c
            rfac = 1.0d0/(rscale*rscale*sqrt(2.0d0))
            grad(idim,1,itarg)= grad(idim,1,itarg)+dreal(
     1              -rfac*(local2(idim,4)+local2(idim,2)))
            grad(idim,2,itarg)= grad(idim,2,itarg)+dreal(
     1              -rfac*ima*(local2(idim,4)-local2(idim,2)))
            grad(idim,3,itarg)=grad(idim,3,itarg)+
     1         dreal(local2(idim,3))/(rscale*rscale)
c
c     hess comes from l=2 modes
c
            rfac = sqrt(3.0d0)/(sqrt(2.0d0)*rscale*rscale*rscale)
            z0 = local2(idim,7)/(rscale*rscale*rscale)
            hess(idim,1,itarg)=hess(idim,1,itarg)+dreal(
     1                  rfac*(local2(idim,9)+local2(idim,5))-z0)
            hess(idim,2,itarg)=hess(idim,2,itarg)+dreal(
     1                  -rfac*(local2(idim,9)+local2(idim,5))-z0)
            hess(idim,3,itarg)=hess(idim,3,itarg)+dreal(2*z0)
            hess(idim,4,itarg)=hess(idim,4,itarg)+dreal(
     1                 rfac*ima*(local2(idim,9)-local2(idim,5)))
            hess(idim,5,itarg)=hess(idim,5,itarg)+dreal(
     1                 -rfac*(local2(idim,8)+local2(idim,6)))
            hess(idim,6,itarg)=hess(idim,6,itarg)+dreal(
     1                -rfac*ima*(local2(idim,8)-local2(idim,6)))
         enddo  
1000  continue
      enddo
      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3dtaevalhessdini(nterms,scarray)
C***********************************************************************
C
c     Precomputes arrayused in 
c     local-local translation operator from an nterms expansion to an 
c     order 2 expansion (sufficient to compute pot/fld/hessian).     
C
c-----------------------------------------------------------------------
C     INPUT:
c
C     nterms          : order of multipole expansion
c-----------------------------------------------------------------------
C     OUTPUT:
C
c     scarray         : work array of size > 10*(nterms+2)**2
c-----------------------------------------------------------------------
      implicit none
      integer *8  nterms,l,j,k,m,ll,mm,iuse
      real *8 scarray(1)
      real *8 d
      real *8, allocatable :: cs(:,:)
      real *8, allocatable :: fact(:)
c
      allocate(cs(0:nterms,-nterms:nterms))
      allocate(fact(0:2*nterms))
c
      d = 1.0d0
      fact(0) = d
      do l = 1,2*nterms
         d = d*dsqrt(l+0.0D0)
         fact(l) = d
      enddo
      cs(0,0) = 1.0d0
      do l = 1,nterms
         do m = 0,l
            cs(l,m) =  ((-1)**l)/( fact(l-m)*fact(l+m) )
            cs(l,-m) = cs(l,m)
         enddo
      enddo
c
      iuse = 1
      do j = 0,2
ccc         do k = -j,j
            do l = j,nterms
            do k = -j,j
               do m = -l,l
                  ll = l-j
                  mm = m-k
                  scarray(iuse) = 0.0d0
                  if (abs(mm).gt.ll) goto 111
                  scarray(iuse) = cs(j,k)*cs(ll,mm)/cs(l,m)
                  scarray(iuse) = scarray(iuse)/dsqrt(2*LL+1.0D0)
                  scarray(iuse) = scarray(iuse)*(-1)**ll
                  if ( m*mm .lt. 0) then
                     scarray(iuse) = scarray(iuse)*(-1)**mm
                  endif
                  if (m*mm .ge. 0)  then
                     if ( abs(m) .le. abs(mm) ) 
     1               scarray(iuse) = scarray(iuse)*(-1)**k
                  endif
                  iuse = iuse+1
111            continue
               enddo
            enddo
         enddo
      enddo
      return
      end
c
c
C***********************************************************************
      subroutine l3dtaevalh(nd,rscale,center,local,nterms,
     1            ztarg,ntarg,pot,grad,hess,scarray)
C***********************************************************************
cc
c     this subroutine evaluates the potentials, gradients and Hessians  
c     of a local expansion and increments inputs accordingly:
c
c     pot=pot + sum sum  mpole(n,m) r^{n}Y_nm(theta,phi) / sqrt(2n+1) 
c                   n   m
c
c     grad=grad + 
c             Gradient(sum sum mpole(n,m)r^{n}Y_nm(theta,phi)/sqrt(2n+1))
c                       n   m
c
c     hess=hess + 
c             Hessian(sum sum mpole(n,m)r^{n}Y_nm(theta,phi)/sqrt(2n+1))
c                      n   m
c
c    The method used direct translation (not rotation/zshift) of 
c    local expansion to one of order 2. It is reasonably optimized, 
c    precomputing the array of binomial/factorial terms that appear 
c     in the shift operator.
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of local expansions
c     rscale :    scaling parameter (see formmp1l3d)
c     center :    expansion center
c     local  :    multipole expansion in 2d matrix format
c     nterms :    order of the multipole expansion
c     ztarg  :    target locations
c     ntarg  :    number of  target location
c    scarray :   precomputed array (MUST BE PRECEDED BY CALL TO
c                   L3DTAEVALHESSDINI(nterms,scarray))
c                   with dimension of scarray at least 10*(nterms+2)**2
c                   If nterms is changed, 
c                   l3dtaevalhessdini must be called again.
c   
c     OUTPUT:
c
c     pot    :   updated potential at ztarg
c     grad   :   updated gradient at ztarg 
c     hess   :   updated Hessian at ztarg
c                 ordered as dxx,dyy,dzz,dxy,dxz,dyz.
c--------------------------------------------------------------------
      implicit none
      integer *8 nterms,ntarg,nd,itarg
      integer *8  l,m,lnew,mnew,ll,mm,iuse,j,k,ldiff,idim
      real *8 center(3),ztarg(3,ntarg)
      real *8 zdiff(3)
      real *8 scarray(*),rscale
      real *8 cphi,sphi,phi,theta,ctheta,d,dd,pi,rfac
      complex *16 local(nd,0:nterms,-nterms:nterms)
      complex *16 z0,ima,ephi1
      real *8 pot(nd,ntarg),grad(nd,3,ntarg)
      real *8 hess(nd,6,ntarg)
c
      real *8, allocatable :: pp(:,:)
      real *8, allocatable :: powers(:)
      complex *16, allocatable :: local2(:,:)
      complex *16, allocatable :: ppc(:,:)
      complex *16, allocatable :: ephi(:)
c
      data ima/(0.0d0,1.0d0)/
c
      allocate(pp(0:nterms,0:nterms))
      allocate(ppc(0:nterms,-nterms:nterms))
      allocate(powers(0:nterms+1))
      allocate(ephi(-nterms-1:nterms+1))
      allocate(local2(nd,9))

c     determine order of shifted expansion 
c
c
      do itarg = 1,ntarg
         do ll = 1,nd
         do l = 1,9
            local2(ll,l) = 0.0d0
         enddo
         enddo
c
         zdiff(1) = center(1) - ztarg(1,itarg)
         zdiff(2) = center(2) - ztarg(2,itarg)
         zdiff(3) = center(3) - ztarg(3,itarg)
         call cart2polar(zdiff,d,theta,phi)
c
         ctheta = dcos(theta)
         cphi = dcos(phi)
         sphi = dsin(phi)
         ephi1 = dcmplx(cphi,sphi)
C
C----- create array of powers of R and e^(i*m*phi).
c
         dd = d/rscale
         powers(0) = 1.0d0
         powers(1) = dd
         ephi(0) = 1.0d0
         ephi(1) = ephi1
         ephi(-1) = dconjg(ephi1)
         do l = 2,nterms+1
            powers(l) = dd*powers(l-1)
            ephi(l) = ephi(l-1)*ephi(1)
            ephi(-l) = dconjg(ephi(l))
         enddo
c
         call ylgndr(nterms,ctheta,pp)
         do l = 0,nterms
            do k = -l,l
               ppc(l,k) = pp(l,abs(k))*powers(l)*ephi(k)
            enddo
         enddo
c
         iuse = 1
         do l = 0,nterms
            do m = -l,l
               do idim=1,nd
                  local2(idim,1) = local2(idim,1) +
     1            ppc(l,m)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
         enddo
         do l = 1,nterms
            ldiff = l-1
            do m = -l,l-2
               mm = m+1
               do idim=1,nd
               local2(idim,2) = local2(idim,2) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -ldiff,ldiff
               do idim=1,nd
               local2(idim,3) = local2(idim,3) +
     1         ppc(ldiff,m)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -l+2,l
               mm = m-1
               do idim=1,nd
               local2(idim,4) = local2(idim,4) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
         enddo
         do l = 2,nterms
            ldiff = l-2
            do m = -l,l-4
               mm = m+2
               do idim=1,nd
               local2(idim,5) = local2(idim,5) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -l+1,l-3
               mm = m+1
               do idim=1,nd
               local2(idim,6) = local2(idim,6) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -ldiff,ldiff
               mm = m
               do idim=1,nd
               local2(idim,7) = local2(idim,7) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -l+3,l-1
               mm = m-1
               do idim=1,nd
               local2(idim,8) = local2(idim,8) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
            do m = -l+4,l
               mm = m-2
               do idim=1,nd
               local2(idim,9) = local2(idim,9) +
     1         ppc(ldiff,mm)*scarray(iuse)*local(idim,l,m)
               enddo
               iuse = iuse+1
            enddo
         enddo
c
ccc      pi = 4.0d0*datan(1.0d0)
c
c     pot comes from 0,0 mode
c
         do idim=1,nd
            pot(idim,itarg) = pot(idim,itarg)+local2(idim,1)
c
c     fld comes from l=1 modes
c
            rfac = 1.0d0/(sqrt(2.0d0)*rscale)
            grad(idim,3,itarg)= grad(idim,3,itarg)+dreal(
     1                local2(idim,3)/rscale)
            grad(idim,1,itarg)= grad(idim,1,itarg)+dreal(
     1                -rfac*(local2(idim,4) + local2(idim,2)))
            grad(idim,2,itarg)= grad(idim,2,itarg)+dreal(
     1                -rfac*ima*(local2(idim,4) - local2(idim,2)))
c
c     hess comes from l=2 modes
c
ccc         rfac = rscale*rscale*sqrt(3.0d0)/sqrt(2.0d0)
            rfac = rfac*sqrt(3.0d0)/rscale
            z0 = local2(idim,7)/(rscale*rscale)
            hess(idim,1,itarg)=hess(idim,1,itarg)+dreal(
     1                  rfac*(local2(idim,9)+local2(idim,5))-z0)
            hess(idim,2,itarg)=hess(idim,2,itarg)+dreal(
     1                  -rfac*(local2(idim,9)+local2(idim,5))-z0)
            hess(idim,3,itarg)=hess(idim,3,itarg)+dreal(2*z0)
            hess(idim,4,itarg)=hess(idim,4,itarg)+dreal(
     1                 rfac*ima*(local2(idim,9)-local2(idim,5)))
            hess(idim,5,itarg)=hess(idim,5,itarg)+dreal(
     1                 -rfac*(local2(idim,8)+local2(idim,6)))
            hess(idim,6,itarg)=hess(idim,6,itarg)+dreal(
     1                -rfac*ima*(local2(idim,8)-local2(idim,6)))
         enddo
1000  continue
      enddo
      return
      end
c
c
c
c

program helmkernels_omp_dr
  implicit double precision (a-h,o-z)

  double precision :: errs(100000)
  double precision, allocatable :: targ(:,:), sources(:,:)

  double complex :: zk, ima
  double complex, allocatable :: dipvec(:,:,:), charge(:,:)
  double complex, allocatable :: pot(:,:), grad(:,:,:), hess(:,:,:)
  double complex, allocatable :: pot2(:,:), grad2(:,:,:), hess2(:,:,:)


  !call prini(6,13)

  ima = (0,1)
  done = 1
  pi = 4*atan(done)
  
  zk  = dcmplx(1.1d0,0.4d0)
  thresh = 1.0d0-13
  
  
  nsrc = 10000
  ntarg = 10000
  
  allocate( sources(3,nsrc) )
  allocate( targ(3,ntarg) )

  nd = 4
  allocate( charge(nd,nsrc) )
  allocate( dipvec(nd,3,nsrc) )
  
  allocate( pot(nd,ntarg) )
  allocate( grad(nd,3,ntarg) )
  allocate( hess(nd,6,ntarg) )

  allocate( pot2(nd,ntarg) )
  allocate( grad2(nd,3,ntarg) )
  allocate( hess2(nd,6,ntarg) )

  ! generate some random data
  do i = 1,nsrc
     do j = 1,3
        sources(j,i) = cos(1000*pi/7.3d0 * i*j)
     end do
     do k = 1,nd
        theta = sin(2000*pi/13.7d0 * k*i*3)
        phi = sin(3000*pi/17.9d0 * k*i*7)
        dipvec(k,1,i) = sin(theta)*cos(phi)
        dipvec(k,2,i) = sin(theta)*sin(phi)
        dipvec(k,3,i) = cos(theta)
        charge(k,i) = exp(ima*4000*pi/3.42d0 *k*i)/nsrc
     end do
  end do

  do i = 1,ntarg
     do j = 1,3
        targ(j,i) = cos(5000*pi/23.123d0 *i*j)
     end do
  end do

  ! set the number of threads to test against
  nthreads = 12

  print *, 'number of sources = ', nsrc
  print *, 'number of targets = ', ntarg
  print *, 'vec param nd = ', nd


  ! for each of the below routines, run single threaded and
  ! multithreaded and compare the solutions, they should be identical,
  ! and compute the speedup factor
  print *
  print *
  print *, '- - - - - - - testing h3ddirectcp - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectcp(nd, zk, sources, charge, nsrc, targ, ntarg, pot, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectcp(nd, zk, sources, charge, nsrc, targ, ntarg, pot2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' err = ', err
  end do
  
  

  print *
  print *
  print *, '- - - - - - - testing h3ddirectcg - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectcg(nd, zk, sources, charge, nsrc, targ, ntarg, pot, &
       grad, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectcg(nd, zk, sources, charge, nsrc, targ, ntarg, pot2, &
       grad2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' pot err = ', err
     err = 0
     do j = 1,ntarg
        err = err + abs(grad(i,1,j) - grad2(i,1,j))**2 &
             + abs(grad(i,2,j) - grad2(i,2,j))**2 &
             + abs(grad(i,3,j) - grad2(i,3,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' grad err = ', err
  end do




  print *
  print *
  print *, '- - - - - - - testing h3ddirectdp - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectcp(nd, zk, sources, dipvec, nsrc, targ, ntarg, pot, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectcp(nd, zk, sources, dipvec, nsrc, targ, ntarg, pot2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' err = ', err
  end do



  print *
  print *
  print *, '- - - - - - - testing h3ddirectdg - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectdg(nd, zk, sources, dipvec, nsrc, targ, ntarg, pot, &
       grad, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectdg(nd, zk, sources, dipvec, nsrc, targ, ntarg, pot2, &
       grad2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' pot err = ', err
     err = 0
     do j = 1,ntarg
        err = err + abs(grad(i,1,j) - grad2(i,1,j))**2 &
             + abs(grad(i,2,j) - grad2(i,2,j))**2 &
             + abs(grad(i,3,j) - grad2(i,3,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' grad err = ', err
  end do



  print *
  print *
  print *, '- - - - - - - testing h3ddirectcdp - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectcdp(nd, zk, sources, charge, dipvec, nsrc, targ, ntarg, &
       pot, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectcdp(nd, zk, sources, charge, dipvec, nsrc, targ, ntarg, &
       pot2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' err = ', err
  end do



  print *
  print *
  print *, '- - - - - - - testing h3ddirectcdg - - - - - - -'

  call setzero(pot, grad, hess, nd, ntarg)
  call setzero(pot2, grad2, hess2, nd, ntarg)

  call omp_set_num_threads(1)
  t0 = omp_get_wtime()
  call h3ddirectcdg(nd, zk, sources, charge, dipvec, nsrc, targ, ntarg, pot, &
       grad, thresh)
  t1 = omp_get_wtime()
  t = t1-t0

  print *, 'single thread timing = ', t
  
  call omp_set_num_threads(nthreads)
  t00 = omp_get_wtime()
  call h3ddirectcdg(nd, zk, sources, charge, dipvec, nsrc, targ, ntarg, pot2, &
       grad2, thresh)
  t11 = omp_get_wtime()

  tomp = t11-t00
  print *, 'multithread timing = ', tomp
  print *, 'speedup = ', t/tomp

  
  print *
  do i = 1,nd
     err = 0
     do j = 1,ntarg
        err = err + abs(pot(i,j) - pot2(i,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' pot err = ', err
     err = 0
     do j = 1,ntarg
        err = err + abs(grad(i,1,j) - grad2(i,1,j))**2 &
             + abs(grad(i,2,j) - grad2(i,2,j))**2 &
             + abs(grad(i,3,j) - grad2(i,3,j))**2
     end do
     err = sqrt(err)
     print *, 'i = ', i, ' grad err = ', err
  end do

end program helmkernels_omp_dr








subroutine setzero(pot,grad,hess,nd,nt)
  implicit real *8 (a-h,o-z)
  complex *16 pot(nd,nt),grad(nd,3,nt)
  complex *16 hess(nd,6,nt)

  do ii=1,nd
     do jj=1,nt
        pot(ii,jj) = 0.0d0
        grad(ii,1,jj) = 0.0d0
        grad(ii,2,jj) = 0.0d0
        grad(ii,3,jj) = 0.0d0
        hess(ii,1,jj) = 0.0d0
        hess(ii,2,jj) = 0.0d0
        hess(ii,3,jj) = 0.0d0
        hess(ii,4,jj) = 0.0d0
        hess(ii,5,jj) = 0.0d0
        hess(ii,6,jj) = 0.0d0
     enddo
  enddo
  return
end subroutine setzero

c      This file contains the direct evaluation kernels for Helmholtz FMM
c
c      h3ddirectcp:  direct calculation of potential for a collection 
c                         of charge sources at a collection of targets
c
c      h3ddirectcg:  direct calculation of potential and gradient 
c                         for a collection of charge sources at a 
c                         collection of targets
c
c      h3ddirectdp:  direct calculation of potential for a collection 
c                         of dipole sources at a collection of targets
c
c      h3ddirectdg:  direct calculation of potential and gradient 
c                         for a collection of dipole sources at a 
c                         collection of targets
c
c      h3ddirectcdp:  direct calculation of potential for a 
c                         collection of charge and dipole sources at 
c                         a collection of targets
c
c      h3ddirectcdg:  direct calculation of potential 
c                         and gradient for a collection 
c                         of charge and dipole sources at a 
c                         collection of targets
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| 
c                        j
c                 
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,ztmp
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared) 
c$omp$     private(i, zdiff, j, dd, d, ztmp, idim)
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000

          ztmp = exp(zkeye*d)/d*inv4pi
          do idim=1,nd
            pot(idim,i) = pot(idim,i) + charge(idim,j)*ztmp
          enddo
 1000     continue
        enddo
      enddo
c$omp end parallel do      


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcg(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|
c                        j
c                 
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|)
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,cd,cd1,ztmp
      complex *16 ztmp1,ztmp2,ztmp3
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared)
c$omp$    private(i, j, zdiff, dd, d, cd, cd1, ztmp1)
c$omp$    private(ztmp2, ztmp3, idim)
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000
          cd = exp(zkeye*d)/d*inv4pi
          cd1 = (zkeye*d-1)*cd/dd
          ztmp1 = cd1*zdiff(1)
          ztmp2 = cd1*zdiff(2)
          ztmp3 = cd1*zdiff(3)
          do idim=1,nd
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            grad(idim,1,i) = grad(idim,1,i) + ztmp1*charge(idim,j)
            grad(idim,2,i) = grad(idim,2,i) + ztmp2*charge(idim,j)
            grad(idim,3,i) = grad(idim,3,i) + ztmp3*charge(idim,j)
          enddo
 1000     continue
        enddo
      enddo
c$omp end parallel do      


      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectdp(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j} 
c                        j
c
c                            
c   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,cd,cd1,dotprod
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared)
c$omp$   private(i, j, zdiff, dd, d, dinv, cd, cd1, idim, dotprod)
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000

          dinv = 1/d
          cd = exp(zkeye*d)*dinv*inv4pi
          cd1 = (1-zkeye*d)*cd/dd

          do idim=1,nd
            dotprod = zdiff(1)*dipvec(idim,1,j) + 
     1          zdiff(2)*dipvec(idim,2,j)+
     1          zdiff(3)*dipvec(idim,3,j)
            pot(idim,i) = pot(idim,i) + cd1*dotprod
          enddo

 1000     continue
        enddo
      enddo
c$omp end parallel do      


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectdg(nd,zk,sources,dipvec,ns,ztarg,nt,pot,
     1   grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                        j
c
c                            
c   
c     grad(x) = grad(x) + Gradient( sum  
c                                    j
c
c                            1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv,dinv2
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,cd,cd2,cd3,cd4,dotprod
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared)
c$omp$   private(i, j, zdiff, dd, d, dinv, dinv2, cd, cd2)
c$omp$   private(cd3, idim, dotprod, cd4)      
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000

          dinv = 1/d
          dinv2 = dinv**2
          cd = exp(zkeye*d)*dinv*inv4pi
          cd2 = (zkeye*d-1)*cd*dinv2
          cd3 = cd*dinv2*(-zkeye*zkeye-3*dinv2+3*zkeye*dinv)

          do idim=1,nd
          
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j)) 
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
          enddo
 1000     continue
        enddo
      enddo
c$omp end parallel do      


      return
      end
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcdp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,cd,cd1,dotprod
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared)
c$omp$    private(i, j, zdiff, dd, d, dinv, cd, cd1, idim, dotprod)
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000

          dinv = 1/d
          cd = exp(zkeye*d)*dinv*inv4pi
          cd1 = (1-zkeye*d)*cd/dd

          do idim=1,nd
            pot(idim,i) = pot(idim,i) + charge(idim,j)*cd

            dotprod = zdiff(1)*dipvec(idim,1,j) + 
     1          zdiff(2)*dipvec(idim,2,j)+
     1          zdiff(3)*dipvec(idim,3,j)
            pot(idim,i) = pot(idim,i) + cd1*dotprod
          enddo

 1000     continue
        enddo
      enddo
c$omp end parallel do      



      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcdg(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +  
c                                    j
c
c                            1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
c
cc     temporary variables
c
      real *8 zdiff(3),dd,d,dinv,dinv2
      real *8, parameter :: inv4pi = 7.957747154594766788444188168626d-2
      complex *16 zkeye,eye,cd,cd2,cd3,cd4,dotprod
      integer *8 i,j,idim
      data eye/(0.0d0,1.0d0)/

      zkeye = zk*eye

c$omp parallel do default(shared)
c$omp$   private(i, j, zdiff, dd, d, dinv, dinv2, cd, cd2, cd3)
c$omp$   private(idim, dotprod, cd4)      
      do i=1,nt
        do j=1,ns
          zdiff(1) = ztarg(1,i)-sources(1,j)
          zdiff(2) = ztarg(2,i)-sources(2,j)
          zdiff(3) = ztarg(3,i)-sources(3,j)

          dd = zdiff(1)**2 + zdiff(2)**2 + zdiff(3)**2
          d = sqrt(dd)
          if(d.lt.thresh) goto 1000

          dinv = 1/d
          dinv2 = dinv**2
          cd = exp(zkeye*d)*dinv*inv4pi
          cd2 = (zkeye*d-1)*cd*dinv2
          cd3 = cd*dinv2*(-zkeye*zkeye-3*dinv2+3*zkeye*dinv)

          do idim=1,nd
          
            pot(idim,i) = pot(idim,i) + cd*charge(idim,j)
            dotprod = zdiff(1)*dipvec(idim,1,j)+
     1               zdiff(2)*dipvec(idim,2,j)+
     1               zdiff(3)*dipvec(idim,3,j)
            cd4 = cd3*dotprod

            pot(idim,i) = pot(idim,i) - cd2*dotprod
            grad(idim,1,i) = grad(idim,1,i) + (cd4*zdiff(1) - 
     1         cd2*dipvec(idim,1,j))
     2         + cd2*charge(idim,j)*zdiff(1) 
            grad(idim,2,i) = grad(idim,2,i) + (cd4*zdiff(2) - 
     1         cd2*dipvec(idim,2,j))
     2         + cd2*charge(idim,j)*zdiff(2) 
            grad(idim,3,i) = grad(idim,3,i) + (cd4*zdiff(3) - 
     1         cd2*dipvec(idim,3,j))
     2         + cd2*charge(idim,j)*zdiff(3)
          enddo
 1000     continue
        enddo
      enddo
c$omp end parallel do      


      return
      end

      implicit none
      integer *8 ns
      double precision, allocatable :: source(:,:)
      double precision, allocatable :: charge(:)
      double precision, allocatable :: pot(:)
      double precision, allocatable :: grad(:,:)
      double precision, allocatable :: hess(:,:)

      double precision eps
      integer *8 i,j,k,l,ier
      double precision hkrand,omp_get_wtime,t1,t2
      


c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      call prin2("This code is an example fortran driver*",i,0)
      call prin2("On output, the code prints sample pot,grad*",i,0)
      write(*,*)
      write(*,*)


      ns = 50000

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(pot(ns))
      allocate(grad(3,ns),hess(6,ns))


      eps = 0.5d-9

      write(*,*) "=========================================="

c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources uniformly in the unit cube 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        charge(i) = hkrand(0) 

        pot(i) = 0
        grad(1,i) = 0
        grad(2,i) = 0
        grad(3,i) = 0

        do l=1,6
          hess(l,i) = 0
        enddo
      enddo


      call cpu_time(t1)
C$       t1 = omp_get_wtime()      
      call lfmm3d_s_c_h(eps,ns,source,charge,
     1      pot,grad,hess,ier)
      call cpu_time(t2)
C$      t2 = omp_get_wtime()     
      
      call prin2('time taken=*',t2-t1,1)
      call prin2("pot at sources=*",pot,12)
      call prin2("grad at sources=*",grad,12)


      stop
      end
c----------------------------------------------------------
c
cc
c
c

c Information Technology Laboratory, National Institute of 
c Standards and Technology, 325 Broadway, Mail Stop 891.01, 
c Boulder, CO 80305-3328. email: zydrunas.gimbutas@nist.gov. 
c Contributions by staff of NIST, an agency of the U.S. Government, 
c are not subject to copyright within the United States.

c NIST-developed software is provided by NIST as a public service. 
c You may use, copy, and distribute copies of the software in any medium, 
c provided that you keep intact this entire notice. You may improve, 
c modify, and create derivative works of the software or any portion of 
c the software, and you may copy and distribute such 
c modifications or works. Modified works should carry a notice stating 
c that you changed the software and should note the date and nature 
c of any such change. Please explicitly acknowledge the National 
c Institute of Standards and Technology as the source of the software. 

c NIST-developed software is expressly provided "AS IS." 
c NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED, IN FACT, OR 
c ARISING BY OPERATION OF LAW, INCLUDING, WITHOUT LIMITATION, THE 
c IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, 
c NON-INFRINGEMENT, AND DATA ACCURACY. NIST NEITHER REPRESENTS NOR 
c WARRANTS THAT THE OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED 
c OR ERROR-FREE, OR THAT ANY DEFECTS WILL BE CORRECTED. NIST DOES NOT
c WARRANT OR MAKE ANY REPRESENTATIONS REGARDING THE USE OF THE 
c SOFTWARE OR THE RESULTS THEREOF, INCLUDING BUT NOT LIMITED TO THE 
c CORRECTNESS, ACCURACY, RELIABILITY, OR USEFULNESS OF THE SOFTWARE.
c
c You are solely responsible for determining the appropriateness of 
c using and distributing the software and you assume all risks 
c associated with its use, including but not limited to the risks 
c and costs of program errors, compliance with applicable laws, damage 
c to or loss of data, programs or equipment, and the unavailability 
c or interruption of operation. This software is not intended to be 
c used in any situation where a failure could cause risk of injury 
c or damage to property. The software developed by NIST employees is 
c not subject to copyright protection within the United States.


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c        this is the end of the debugging code and the beginning 
c        of the exponential representation routines
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c
        subroutine hwts3e(ier,eps,rk,cxs,cws,n)
        implicit real *8 (a-h,o-z)
        integer *8 ier,n,idomain,lxs,iprec,k,iquadtype
        complex *16 cxs(*),cws(*)
        complex *16 rk,ima
        real *8, allocatable :: xs(:),ws(:)
        complex *16, allocatable :: xs1(:),ws1(:)
        data ima/(0.0d0,1.0d0)/
c
c       
c       This subroutine returns the nodes and weights for 
c       the exponential representation 
c
c       exp(ima*rk*sqrt(u^2+v^2)/sqrt(u^2+v^2) = 
c       \int_0^{+\infty} exp(-sqrt(t^2-rk^2)*t) J_0(tv) t/sqrt(t^2-rk^2) dt
c
c       u in [1,4], v in [0, 4*sqrt(2)]
c
c       All tables are valid in 
c
c       rk range [0, 16*pi] \times [0, 12*pi]
c
c
c
c       Input parameter:
c       
c       iprec - precision required:
c           iprec = 0 - 2 digits
c           iprec = 1 - 3 digits
c           iprec = 2 - 6 digits
c           iprec = 3 - 9 digits
c           iprec = 4 - 12 digits
c
c       Output parameters:
c
c       n - the number of nodes
c       cxs - the nodes: complex *16 (n)
c       cws - the weights: complex *16 (n)
c

        lxs = 10000
        allocate(xs(lxs),ws(lxs),xs1(lxs),ws1(lxs))

        n = 0
c
        ier = 0
c       
        call hwts3dgetd(ier,rk,idomain)
c
ccc        call prinf('ier=*',ier,1)
ccc        write(*,*) 'idomain=*', idomain
ccc        call prinf('idomain=*',idomain,1)
c

        iprec = 0
        if(eps.lt.0.5d-2) iprec = 1
        if(eps.lt.0.5d-3) iprec = 2
        if(eps.lt.0.5d-6) iprec = 3
        if(eps.lt.0.5d-9) iprec = 4
        

        if( iprec .eq. 0 ) errmax = .1d-2
        if( iprec .eq. 1 ) errmax = .1d-3
        if( iprec .eq. 2 ) errmax = .1d-6
        if( iprec .eq. 3 ) errmax = .1d-9
        if( iprec .eq. 4 ) errmax = .1d-12
        
        if( iprec .eq. 0 ) call hwts3p0(idomain,xs,ws,n,iquadtype,err)
        if( iprec .eq. 1 ) call hwts3p1(idomain,xs,ws,n,iquadtype,err)
        if( iprec .eq. 2 ) call hwts3p2(idomain,xs,ws,n,iquadtype,err)
        if( iprec .eq. 3 ) call hwts3p3(idomain,xs,ws,n,iquadtype,err)
        if( iprec .eq. 4 ) call hwts3p4(idomain,xs,ws,n,iquadtype,err)

 1100   continue
        
ccc        write(*,*) 'iquad=*', iquad
ccc        call prinf('iquad=*',iquad,1)
ccc        pause
c
c
cc        call prinf('n=*',n,1)
cc        call prin2('xs=*',xs,n)
cc        call prin2('ws=*',ws,n)
cc        call prinf('iquadtype=*',iquadtype,1)
c
        do 1200 k=1,n
c
        if( iquadtype .eq. 1 ) then
        cxs(k)=sqrt(xs(k)**2-rk**2)
        cws(k)=ws(k)*xs(k)/sqrt(xs(k)**2-rk**2)
        endif
        
        if( iquadtype .eq. 2 ) then
        xmin=0
        xmax=100
        call linmap0(xs(k),u,uweight,xmin,xmax)
ccc           if( dble(rk) .gt. 1d0 ) then
ccc           xmid=dble(rk)
ccc           call linmap1(xs(k),u,uweight,xmin,xmax,xmid)
ccc           endif
c
        gamma=0
        v=u/(1+gamma*abs(dble(-ima*rk)))
        cxs(k)=u-ima*rk+abs(dimag(-ima*rk))*ima*(v/(1+v))
        cws(k)=1+abs(dimag(-ima*rk))*ima*((1+v)-v)/(1+v)**2
     $     /(1+gamma*abs(dble(-ima*rk)))
        cws(k)=cws(k)*ws(k)*uweight
        endif
c
        if( iquadtype .eq. 5 ) then
        xs1(k)=xs(k)-ima*atan(xs(k))
        ws1(k)=ws(k)*(1-ima/(1+xs(k)**2))
        cxs(k)=sqrt(xs1(k)**2-rk**2)
        cws(k)=ws1(k)*xs1(k)/sqrt(xs1(k)**2-rk**2)
        endif
c
 1200   continue
c
        return
        end

c
c
c
c
        subroutine linmap0(t,u,w,ax,bx)
        implicit real *8 (a-h,o-z)
c
c       this subroutine contructs a linear mapping from interval
c       [0,1] to [ax,bx] 
c        
        u=ax+t*(bx-ax)
        w=(bx-ax)
c
        return
        end
c
c
c
c
c
        subroutine linmap1(t,u,w,ax,bx,cx)
        implicit real *8 (a-h,o-z)
c
c       this subroutine contructs a piecewise linear mapping from interval
c       [0,1] to [ax,bx], such that [0,0.5]->[ax,cx], [0.5,1]->[cx,bx]
c        
        if( t .le. 0.5d0 ) then
        u=ax+2*t*(cx-ax)
        w=2*(cx-ax)
        endif
c
        if( t .gt. 0.5d0 ) then
        u=cx+2*(t-0.5d0)*(bx-cx)
        w=2*(bx-cx)
        endif
c
        return
        end
c
c
c
c
c

        subroutine hwts3dgetd(ier,rk,idomain)
        implicit real *8 (a-h,o-z)
        integer *8 ier,nx,ny,ix,iy,idomain,i
        complex *16 ima,rk
        dimension cx(100),cy(100)
        data ima/(0.0d0,1.0d0)/
c
        done=1
        pi=4*atan(done)
c
c       rk range [0, 16*pi] \times [0, 12*pi]
c
        nx=23
        ny=19
c
        cx(1)=0.00d0
        cx(2)=0.02d0
        cx(3)=0.04d0
        cx(4)=0.10d0
        cx(5)=0.20d0
        cx(6)=0.40d0
        cx(7)=1.00d0
        cx(8)=pi/2
        cx(9)=pi
        cx(10)=2*pi
        cx(11)=3*pi
        cx(12)=4*pi
        cx(13)=5*pi
        cx(14)=6*pi
        cx(15)=7*pi
        cx(16)=8*pi
        cx(17)=9*pi
        cx(18)=10*pi
        cx(19)=11*pi
        cx(20)=12*pi
        cx(21)=13*pi
        cx(22)=14*pi
        cx(23)=15*pi
        cx(24)=16*pi
c
        cy(1)=0.00d0
        cy(2)=0.02d0
        cy(3)=0.04d0
        cy(4)=0.10d0
        cy(5)=0.20d0
        cy(6)=0.40d0
        cy(7)=1.00d0
        cy(8)=pi/2
        cy(9)=pi
        cy(10)=2*pi
        cy(11)=3*pi
        cy(12)=4*pi
        cy(13)=5*pi
        cy(14)=6*pi
        cy(15)=7*pi
        cy(16)=8*pi
        cy(17)=9*pi
        cy(18)=10*pi
        cy(19)=11*pi
        cy(20)=12*pi
        cy(21)=13*pi
        cy(22)=14*pi
        cy(23)=15*pi
        cy(24)=16*pi
c
        rkrea=dble(rk)
        rkima=dimag(rk)
c
        idomain = 0
        ier = 0
c
        ix=0
        do 1200 i=1,nx
        if( rkrea .ge. cx(i+1) ) ix=i+1
 1200   continue
c
 1300   continue
c
        iy=0
        do 2200 i=1,ny
        if( rkima .ge. cy(i+1) ) iy=i+1
 2200   continue
c
 2300   continue
c
ccc        write(*,*) rk
ccc        write(*,*) ix,iy
c
        if( ix .gt. nx ) ier = 4
        if( iy .gt. ny ) ier = 4
        if( ix .gt. nx ) return
        if( iy .gt. ny ) return
c       
        if( ix .eq. 0 ) ix = 1
        if( iy .eq. 0 ) iy = 1
c
        if( ix .gt. nx ) ix = nx
        if( iy .gt. ny ) iy = ny
c
        idomain = ix + (iy-1) * nx
c
c        write(*,*) ix,iy
cc        write(*,*) idomain
c
ccc        stop
c
        return
        end
c
c
c
c
        subroutine getrkinfo2(inum,ndomains,rkmin,rkmax)
        implicit real *8 (a-h,o-z)
        integer *8 inum,ndomains,nx,ny,ix,iy
        complex *16 rkmin,rkmax,ima
        complex *16 cx(100),cy(100)
        data ima/(0.0d0,1.0d0)/
c
        done=1
        pi=4*atan(done)
c
c       rk range [0, 16*pi] \times [0, 12*pi]
c
        nx=23
        ny=19
c
        cx(1)=0.00d0
        cx(2)=0.02d0
        cx(3)=0.04d0
        cx(4)=0.10d0
        cx(5)=0.20d0
        cx(6)=0.40d0
        cx(7)=1.00d0
        cx(8)=pi/2
        cx(9)=pi
        cx(10)=2*pi
        cx(11)=3*pi
        cx(12)=4*pi
        cx(13)=5*pi
        cx(14)=6*pi
        cx(15)=7*pi
        cx(16)=8*pi
        cx(17)=9*pi
        cx(18)=10*pi
        cx(19)=11*pi
        cx(20)=12*pi
        cx(21)=13*pi
        cx(22)=14*pi
        cx(23)=15*pi
        cx(24)=16*pi
c
        cy(1)=0.00d0
        cy(2)=0.02d0
        cy(3)=0.04d0
        cy(4)=0.10d0
        cy(5)=0.20d0
        cy(6)=0.40d0
        cy(7)=1.00d0
        cy(8)=pi/2
        cy(9)=pi
        cy(10)=2*pi
        cy(11)=3*pi
        cy(12)=4*pi
        cy(13)=5*pi
        cy(14)=6*pi
        cy(15)=7*pi
        cy(16)=8*pi
        cy(17)=9*pi
        cy(18)=10*pi
        cy(19)=11*pi
        cy(20)=12*pi
        cy(21)=13*pi
        cy(22)=14*pi
        cy(23)=15*pi
        cy(24)=16*pi
c
        ndomains=nx*ny
c
        ix=mod(inum-1,nx)+1
        iy=(inum-1)/nx+1
c
        rkmin=cx(ix)+ima*cy(iy)
        rkmax=cx(ix+1)+ima*cy(iy+1)
c
        return
        end
c
c
c
c
c
        subroutine hwts3p0(idomain,xs,ws,n,iquadtype,err)
        implicit real *8 (a-h,o-z)
        integer *8 idomain,n,iquadtype
        dimension xs(*), ws(*)
c
        n = 0
        iquadtype = 0
c
        INCLUDE 'hwts_3d_iprec0.txt'
c
        return
        end
c        
c
c
c
c
        subroutine hwts3p1(idomain,xs,ws,n,iquadtype,err)
        implicit real *8 (a-h,o-z)
        integer *8 idomain,n,iquadtype
        dimension xs(*), ws(*)
c
        n = 0
        iquadtype = 0
c
        INCLUDE 'hwts_3d_iprec1.txt'
c
        return
        end
c        
c
c
c
c
        subroutine hwts3p2(idomain,xs,ws,n,iquadtype,err)
        implicit real *8 (a-h,o-z)
        integer *8 idomain,n,iquadtype
        dimension xs(*), ws(*)
c
        n = 0
        iquadtype = 0
c
        INCLUDE 'hwts_3d_iprec2.txt'
c
        return
        end        
c        
c
c
c
c
        subroutine hwts3p3(idomain,xs,ws,n,iquadtype,err)
        implicit real *8 (a-h,o-z)
        integer *8 idomain,n,iquadtype
        dimension xs(*), ws(*)
c
        n = 0
        iquadtype = 0
c
        INCLUDE 'hwts_3d_iprec3.txt'
c
        return
        end
c        
c
c
c
c
        subroutine hwts3p4(idomain,xs,ws,n,iquadtype,err)
        implicit real *8 (a-h,o-z)
        integer *8 idomain,n,iquadtype
        dimension xs(*), ws(*)
c
        n = 0
        iquadtype = 0
c
        INCLUDE 'hwts_3d_iprec4.txt'
c
        return
        end
c
c
c
c
c

c
c
c      this file contains some common routines for helmrouts3d
c      and helmrouts3d_vec
c
c      h3d01: computes h0, h1 (first two spherical Hankel fns.)
c      h3dall: computes Hankel functions of all orders and scales them
c
c      h3dadd: adds one expansion to another
c
c      h3dadd_trunc: adds one expansion to another
c                 allowing for different spherical harmonic array dimensions  
c
c
c**********************************************************************
      subroutine h3d01(z,h0,h1)
c**********************************************************************
c
c     Compute spherical Hankel functions of order 0 and 1 
c
c     h0(z)  =   exp(i*z)/(i*z),
c     h1(z)  =   - h0' = -h0*(i-1/z) = h0*(1/z-i)
c
c-----------------------------------------------------------------------
c     INPUT:
c
c	z   :  argument of Hankel functions
c              if abs(z)<1.0d-15, returns zero.
c
c-----------------------------------------------------------------------
c     OUTPUT:
c
c	h0  :  h0(z)    (spherical Hankel function of order 0).
c	h1  :  -h0'(z)  (spherical Hankel function of order 1).
c
c-----------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      complex *16 z,zinv,eye,cd,h0,h1
      data eye/(0.0d0,1.0d0)/, thresh/1.0d-15/, done/1.0d0/
c
      if (abs(z).lt.thresh) then
         h0=0.0d0
         h1=0.0d0
         return
      endif
c
c     Otherwise, use formula
c
      cd = eye*z
      h0=exp(cd)/cd
      h1=h0*(done/z - eye)
c
      return
      end
c
c
c
c**********************************************************************
      subroutine h3dall(nterms,z,scale,hvec,ifder,hder)
c**********************************************************************
c
c     This subroutine computes scaled versions of the spherical Hankel 
c     functions h_n of orders 0 to nterms.
c
c       	hvec(n)= h_n(z)*scale^(n)
c
c     The parameter SCALE is useful when |z| < 1, in which case
c     it damps out the rapid growth of h_n as n increases. In such 
c     cases, we recommend setting 
c                                 
c               scale = |z|
c
c     or something close. If |z| > 1, set scale = 1.
c
c     If the flag IFDER is set to one, it also computes the 
c     derivatives of h_n.
c
c		hder(n)= h_n'(z)*scale^(n)
c
c     NOTE: If |z| < 1.0d-15, the subroutine returns zero.
c     
c-----------------------------------------------------------------------
c     INPUT:
c
c     nterms  : highest order of the Hankel functions to be computed.
c     z       : argument of the Hankel functions.
c     scale   : scaling parameter discussed above
c     ifder   : flag indcating whether derivatives should be computed.
c		ifder = 1   ==> compute 
c		ifder = 0   ==> do not compute
c
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     hvec    : the vector of spherical Hankel functions 
c     hder    : the derivatives of the spherical Hankel functions 
c
c-----------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      integer *8 nterms,ifder
      complex *16 hvec(0:*),hder(0:*)
      complex *16 zk2,z,zinv,ztmp,fhextra
c
      data thresh/1.0d-15/,done/1.0d0/
c
c     If |z| < thresh, return zeros.
c
      if (abs(z).lt.thresh) then
         do i=0,nterms
            hvec(i)=0
            hder(i)=0
         enddo
         return
      endif
c
c     Otherwise, get h_0 and h_1 analytically and the rest via
c     recursion.
c
      call h3d01(z,hvec(0),hvec(1))
      hvec(0)=hvec(0)
      hvec(1)=hvec(1)*scale
c
c     From Abramowitz and Stegun (10.1.19)
c
c     h_{n+1}(z)=(2n+1)/z * h_n(z) - h_{n-1}(z)
c
c     With scaling:
c
c     hvec(n+1)=scale*(2n+1)/z * hvec(n) -(scale**2) hvec(n-1)
c
      scal2=scale*scale
      zinv=scale/z
      do i=1,nterms-1
	 dtmp=(2*i+done)
	 ztmp=zinv*dtmp
	 hvec(i+1)=ztmp*hvec(i)-scal2*hvec(i-1)
      enddo
c
c     From Abramowitz and Stegun (10.1.21)
c
c	h_{n}'(z)= h_{n-1}(z) - (n+1)/z * h_n(z)
c
c     With scaling:
c
c     hder(n)=scale* hvec(n-1) - (n+1)/z * hvec(n)
c
c
      if (ifder.eq.1) then
c
	 hder(0)=-hvec(1)/scale
         zinv=1.0d0/z
         do i=1,nterms
	    dtmp=(i+done)
	    ztmp=zinv*dtmp
	    hder(i)=scale*hvec(i-1)-ztmp*hvec(i)
	 enddo
      endif
c
      return
      end
c
c
c
c**********************************************************************
      subroutine h3dadd(nd,mpole,mpole2,nterms)
c**********************************************************************
c
c     add mpole to mpole2
c
c----------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      integer *8 nd,nterms
      complex *16 mpole(nd,0:nterms,-nterms:nterms)
      complex *16 mpole2(nd,0:nterms,-nterms:nterms)
c
      do i = 0,nterms
         do j = -i,i
           do idim=1,nd
     	    mpole2(idim,i,j) = mpole2(idim,i,j)+mpole(idim,i,j)
           enddo
	 enddo
      enddo
      return
      end
c
c
c
c**********************************************************************
      subroutine h3dadd_trunc(mpole,mpole2,nterms,ldc)
c**********************************************************************
c
c     add mpole to mpole2
c
c----------------------------------------------------------------------
      implicit real *8 (a-h,o-z)
      integer *8 nterms
      complex *16 mpole(0:nterms,-nterms:nterms)
      complex *16 mpole2(0:ldc,-ldc:ldc)
c
      do i = 0,nterms
         do j = -i,i
	    mpole2(i,j) = mpole2(i,j)+mpole(i,j)
	 enddo
      enddo
      return
      end

      

c
c      TESTING SUITE FOR HELMHOLTZ SUBROUTINE LIBRARY:  Mar 20, 2019
c
c
c
c         Sources at S, Targets at T.
c
c         h3dformmp      forms expansion about c0
c         h3dmpeval      evaluates expansion at T
c         h3dmpmp        shifts expansion to c1
c         h3dmploc       converts to local about y1
c         h3dtaeval      evaluates expansion at T
c         h3dlocloc      shifts to local about c0
c         h3dtaeval      evaluates expansion at T
c         h3dformta      forms local expansion about c0 
c                        directly from S
c         h3dtaeval      evaluates expansion at T
c
c         -------------------------------------------------
c         |       |   S   |       |       |T      |       |
c         |       |   c0  |       |       |  c3   |       |
c         |       |       |       |       |       |       |
c         -------c1-------------------------------c2------
c         |       |       |       |       |       |       |
c         |       |       |       |       |       |       |
c         |       |       |       |       |       |       |
c         -------------------------------------------------
c
      implicit real *8 (a-h,o-z)
      integer *8 nd,ns,nt,nterms,nterms2,nterms3,nquad,nlege
      real *8 ztrg(3),sources(3,10)
      real *8 c0(3),c1(3),c2(3),c3(3)
      real *8 xnodes(2000),wts(2000)
c
      complex *16 pot,fld(3),opot,ofld(3)
      complex *16, allocatable :: mpole1(:,:),mpole2(:,:)
      complex *16, allocatable :: locexp1(:,:),locexp2(:,:)
      complex *16 charge(100),dipvec(3,100)
      real *8 wlege(100000),errs(2,5),err_exp(5)
      integer *8 ipass(5)
      complex *16 zk,eye
c
      data eye/(0.0d0,1.0d0)/
c
      call prini(6,13)
      done=1
      pi=4.0*atan(done)
      zk = 51.2d0

      write(*,*) "=========================================="
      write(*,*) "Testing suite for helmrouts3d"

      open(unit=33,file='print_testres.txt',access='append')


c
c
c       set scale parameter neq 1 to make sure it is used correctly.
c
      bsize = 1.0d0
      rscale1 = abs(zk)*bsize/4
      rscale2 = abs(zk)*bsize/2

      if(rscale1.gt.1) rscale1 = 1
      if(rscale2.gt.2) rscale2 = 1


cc      rscale1 = 1
cc      rscale2 = 1
c
c       set center for original multipole expansion
c
      c0(1)=0.248d0
      c0(2)=0.251d0
      c0(3)=0.249d0
c
c       create two charge sources.
c
      sources(1,1)=c0(1)+0.24d0
      sources(2,1)=c0(2)+ 0.25d0
      sources(3,1)=c0(3)+ 0.25d0
      charge(1)= 1.0d0 + eye*0.2d0
      dipvec(1,1) = hkrand(0) + eye*hkrand(0)
      dipvec(2,1) = hkrand(0) + eye*hkrand(0)
      dipvec(3,1) = hkrand(0) + eye*hkrand(0)


      ns = 1
      sources(1,2)=c0(1)+0.25d0
      sources(2,2)=c0(2)-0.25d0
      sources(3,2)=c0(3)-0.25d0
      charge(2)= -1.0d0 + eye*0.1d0
      dipvec(1,2) = hkrand(0) + eye*hkrand(0) 
      dipvec(2,2) = hkrand(0) + eye*hkrand(0)
      dipvec(3,2) = hkrand(0) + eye*hkrand(0)
      ns = 2
c
c       create center for shifted expansions
c       (location jiggled for good measure)
c
      c1(1)= 0.015d0
      c1(2)= 0.012d0
      c1(3)= 0.013d0
      c2(1)= 2.015d0
      c2(2)= 0.012d0
      c2(3)= 0.013d0
      c3(1)= c2(1)-0.25d0
      c3(2)= c2(2)-0.249d0
      c3(3)= c2(3)-0.251d0
c
c       create target
c
      ztrg(1)=c3(1)-0.245d0
      ztrg(2)=c3(2)-0.25d0
      ztrg(3)=c3(3)-0.25d0
      nt = 1


      ntest = 5
      do i=1,ntest
        ipass(i) = 0 
      enddo
c
c       direct calculation:
c
      opot = 0
      ofld(1) = 0
      ofld(2) = 0
      ofld(3) = 0
      thresh = 1.0d-15
      nd = 1
      call h3ddirectcdg(nd,zk,sources,charge,
     1       dipvec,ns,ztrg,nt,opot,
     1       ofld,thresh)



      eps = 0.5d-12
      call h3dterms(bsize/2, zk, eps, nterms)
      call h3dterms(bsize, zk, eps, nterms2)
      call h3dterms(bsize/2, zk, eps, nterms3)


      nlege = 100
      lw7 = 100000
      call ylgndrfwini(nlege,wlege,lw7,lused7)
c
c
c       create h-expansion:
c
      ifinit = 1
      nquad = 2*max(nterms2,nterms3)
      call legewhts(nquad,xnodes,wts,ifinit)
      allocate(mpole1(0:nterms,-nterms:nterms))

      nd = 1
      call mpzero(nd,mpole1,nterms)
      call h3dformmpcd(nd,zk,rscale1,sources,charge,
     1       dipvec,ns,c0,nterms,mpole1,wlege,nlege)

      pot = 0
      fld(1) = 0
      fld(2) = 0
      fld(3) = 0
      nd = 1

      rconv1 = 1.0d0/sqrt(3.0d0)
      rconv2 = sqrt(3.0d0)/2.0d0
      rconv3 = 0.75d0

      call h3dmpevalg(nd,zk,rscale1,c0,mpole1,nterms,ztrg,nt,pot,
     1      fld,wlege,nlege,thresh)

      err_exp(1) = 10*max(rconv1**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing formmp and mpeval, expected error='
     1   ,err_exp(1)
      call errprint(pot,opot,fld,ofld,errs(1,1))
      if(max(errs(1,1),errs(2,1)).lt.err_exp(1)) ipass(1) = 1
      write(*,*)

      if(ipass(1).ne.1) write(33,*) 'Failed formmp and mpeval test' 

c
c    mpmp shift
c
      radius = sqrt(3.0d0)/2.0d0*bsize
      allocate(mpole2(0:nterms2,-nterms2:nterms2))

      call mpzero(nd,mpole2,nterms2)
      call h3dmpmp(nd,zk,rscale1,c0,mpole1,nterms,
     1       rscale2,c1,mpole2,nterms2,radius,xnodes,wts,nquad)

      pot = 0
      fld(1) = 0
      fld(2) = 0
      fld(3) = 0
      nd = 1

      call h3dmpevalg(nd,zk,rscale2,c1,mpole2,nterms2,ztrg,nt,pot,
     1      fld,wlege,nlege,thresh)


      err_exp(2) = 10*max(rconv2**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing mpmp, expected error='
     1   ,err_exp(2)
      call errprint(pot,opot,fld,ofld,errs(1,2))

      if(max(errs(1,2),errs(2,2)).lt.err_exp(2)) ipass(2) = 1
      write(*,*)
      if(ipass(2).ne.1) write(33,*) 'Failed mpmp test' 
      
      
c
c    convert to local
c
      radius = sqrt(3.0d0)/2.0d0
      nquad = 2.2*nterms2
      call legewhts(nquad,xnodes,wts,ifinit)

      allocate(locexp2(0:nterms2,-nterms2:nterms2))
      call mpzero(nd,locexp2,nterms2)
      call h3dmploc(nd,zk,rscale2,c1,mpole2,nterms2,
     1      rscale2,c2,locexp2,nterms2,radius,xnodes,wts,nquad)


      pot = 0
      fld(1) = 0
      fld(2) = 0
      fld(3) = 0
      nd = 1
      call h3dtaevalg(nd,zk,rscale2,c2,locexp2,nterms2,ztrg,nt,
     1      pot,fld,wlege,nlege)

      err_exp(3) = 10*max(rconv3**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing mploc, expected error='
     1   ,err_exp(3)
      call errprint(pot,opot,fld,ofld,errs(1,3))
      if(max(errs(1,3),errs(2,3)).lt.err_exp(3)) ipass(3) = 1
      write(*,*)
      if(ipass(3).ne.1) write(33,*) 'Failed mploc test' 

c
c    shift local 
c
      radius = sqrt(3.0d0)/4.0d0
      allocate(locexp1(0:nterms3,-nterms3:nterms3))
      call mpzero(nd,locexp1,nterms3)

      call h3dlocloc(nd,zk,rscale2,c2,locexp2,nterms2,
     1      rscale1,c3,locexp1,nterms3,radius,xnodes,wts,nquad)


      pot = 0
      fld(1) = 0
      fld(2) = 0
      fld(3) = 0
      nd = 1
      call h3dtaevalg(nd,zk,rscale1,c3,locexp1,nterms3,ztrg,nt,
     1      pot,fld,wlege,nlege)

      err_exp(4) = 10*max(rconv3**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing locloc, expected error='
     1   ,err_exp(4)
      call errprint(pot,opot,fld,ofld,errs(1,4))
      if(max(errs(1,4),errs(2,4)).lt.err_exp(4)) ipass(4) = 1
      write(*,*)
      if(ipass(4).ne.1) write(33,*) 'Failed locloc test' 

c
c
c    create local exp from sources

      call mpzero(nd,locexp1,nterms3)
      nd = 1
      call h3dformtacd(nd,zk,rscale1,sources,charge,
     1       dipvec,ns,c3,nterms3,locexp1,wlege,nlege)
      pot = 0
      fld(1) = 0
      fld(2) = 0
      fld(3) = 0
      nd = 1
      call h3dtaevalg(nd,zk,rscale1,c3,locexp1,nterms3,ztrg,nt,
     1      pot,fld,wlege,nlege)

      err_exp(5) = 10*max(rconv3**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing formta and taeval, expected error='
     1   ,err_exp(5)
      call errprint(pot,opot,fld,ofld,errs(1,5))
      if(max(errs(1,5),errs(2,5)).lt.err_exp(5)) ipass(5) = 1
      write(*,*)
      if(ipass(5).ne.1) write(33,*) 'Failed formta and taeval test'

      isum = 0
      do i=1,ntest
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in helmrouts3d testing suite'
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in helmrouts3d testing suite'
      close(33)
      
      stop
      end
c
c
c
c
c
C
C
      subroutine errprint(pot,opot,fld,ofld,errs)
      implicit real *8 (a-h,o-z)
      complex *16 pot,opot,fld(3),ofld(3)
      real *8 errs(2)
 1000  format(4D15.5) 
      err = 0
      ddd = 0
      err = err + abs(fld(1)-ofld(1))**2
      err = err + abs(fld(2)-ofld(2))**2
      err = err + abs(fld(3)-ofld(3))**2
      ddd = ddd + abs(ofld(1))**2
      ddd = ddd + abs(ofld(2))**2
      ddd = ddd + abs(ofld(3))**2
      err = sqrt(err)
      ddd = sqrt(ddd)

      err1 = abs(pot-opot)/abs(opot)
      write(*,'(a,e11.4,a,e11.4)') 
     1     'pot error=',err1,'   grad error=',err/ddd

      errs(1) = err1 
      errs(2) = err/ddd

      return
      end
c

using FMM3D
using Test
using Random
using LinearAlgebra

@testset "testing Helmholtz utilities" begin

    n = 1000
    nt = 1100
    sources = randn(3,n)
    targets = randn(3,nt)
    charges = randn(n) + im*randn(n)
    dipvecs = randn(3,n) + im*randn(3,n)
    zk = 2.1

    vals1c = h3ddir(zk,sources,targets,charges=charges,
                    pgt=2,thresh=1e-16)

    vals1cs = h3ddir(zk,sources,sources,charges=charges,
                    pgt=2,thresh=1e-16)

    vals1d = h3ddir(zk,sources,targets,dipvecs=dipvecs,
                    pgt=2,thresh=1e-16)

    vals1ds = h3ddir(zk,sources,sources,dipvecs=dipvecs,
                    pgt=2,thresh=1e-16)

    vals1dc = h3ddir(zk,sources,targets,charges=charges,
                     dipvecs=dipvecs,pgt=2,thresh=1e-16)

    vals1dcs = h3ddir(zk,sources,sources,charges=charges,
                     dipvecs=dipvecs,pgt=2,thresh=1e-16)

    eps = 1e-12
    vals2c = hfmm3d(eps,zk,sources,targets=targets,charges=charges,
                    pg=2,pgt=2)
    vals2d = hfmm3d(eps,zk,sources,targets=targets,dipvecs=dipvecs,
                    pg=2,pgt=2)
    vals2dc = hfmm3d(eps,zk,sources,targets=targets,charges=charges,
                     dipvecs=dipvecs,pg=2,pgt=2)
    vals2dc_ndiv = hfmm3d_ndiv(eps,zk,sources,50,targets=targets,charges=charges,
                               dipvecs=dipvecs,pg=2,pgt=2)

    @test norm(vals2c.pot-vals1cs.pottarg)/norm(vals1cs.pottarg) < eps
    @test norm(vals2c.grad-vals1cs.gradtarg)/norm(vals1cs.gradtarg) < eps
    @test norm(vals2c.pottarg-vals1c.pottarg)/norm(vals1c.pottarg) < eps
    @test norm(vals2c.gradtarg-vals1c.gradtarg)/norm(vals1c.gradtarg) < eps    

    @test norm(vals2d.pot-vals1ds.pottarg)/norm(vals1ds.pottarg) < eps
    @test norm(vals2d.grad-vals1ds.gradtarg)/norm(vals1ds.gradtarg) < eps
    @test norm(vals2d.pottarg-vals1d.pottarg)/norm(vals1d.pottarg) < eps
    @test norm(vals2d.gradtarg-vals1d.gradtarg)/norm(vals1d.gradtarg) < eps    

    @test norm(vals2dc.pot-vals1dcs.pottarg)/norm(vals1dcs.pottarg) < eps
    @test norm(vals2dc.grad-vals1dcs.gradtarg)/norm(vals1dcs.gradtarg) < eps
    @test norm(vals2dc.pottarg-vals1dc.pottarg)/norm(vals1dc.pottarg) < eps
    @test norm(vals2dc.gradtarg-vals1dc.gradtarg)/norm(vals1dc.gradtarg) < eps    
    @test norm(vals2dc_ndiv.pot-vals1dcs.pottarg)/norm(vals1dcs.pottarg) < eps
    @test norm(vals2dc_ndiv.grad-vals1dcs.gradtarg)/norm(vals1dcs.gradtarg) < eps
    @test norm(vals2dc_ndiv.pottarg-vals1dc.pottarg)/norm(vals1dc.pottarg) < eps
    @test norm(vals2dc_ndiv.gradtarg-vals1dc.gradtarg)/norm(vals1dc.gradtarg) < eps
    @test vals2dc_ndiv.ier == 0
    

end

@testset "testing Laplace utilities" begin

    n = 1000
    nt = 1100
    sources = randn(3,n)
    targets = randn(3,nt)
    charges = randn(n)
    dipvecs = randn(3,n)

    vals1c = l3ddir(sources,targets,charges=charges,
                    pgt=2,thresh=1e-16)

    vals1cs = l3ddir(sources,sources,charges=charges,
                    pgt=2,thresh=1e-16)

    vals1d = l3ddir(sources,targets,dipvecs=dipvecs,
                    pgt=2,thresh=1e-16)

    vals1ds = l3ddir(sources,sources,dipvecs=dipvecs,
                    pgt=2,thresh=1e-16)

    vals1dc = l3ddir(sources,targets,charges=charges,
                     dipvecs=dipvecs,pgt=2,thresh=1e-16)

    vals1dcs = l3ddir(sources,sources,charges=charges,
                     dipvecs=dipvecs,pgt=2,thresh=1e-16)

    eps = 1e-12
    vals2c = lfmm3d(eps,sources,targets=targets,charges=charges,
                    pg=2,pgt=2)
    vals2d = lfmm3d(eps,sources,targets=targets,dipvecs=dipvecs,
                    pg=2,pgt=2)
    vals2dc = lfmm3d(eps,sources,targets=targets,charges=charges,
                     dipvecs=dipvecs,pg=2,pgt=2)
    vals2dc_ndiv = lfmm3d_ndiv(eps,sources,50,targets=targets,charges=charges,
                               dipvecs=dipvecs,pg=2,pgt=2)

    @test norm(vals2c.pot-vals1cs.pottarg)/norm(vals1cs.pottarg) < eps
    @test norm(vals2c.grad-vals1cs.gradtarg)/norm(vals1cs.gradtarg) < eps
    @test norm(vals2c.pottarg-vals1c.pottarg)/norm(vals1c.pottarg) < eps
    @test norm(vals2c.gradtarg-vals1c.gradtarg)/norm(vals1c.gradtarg) < eps    

    @test norm(vals2d.pot-vals1ds.pottarg)/norm(vals1ds.pottarg) < eps
    @test norm(vals2d.grad-vals1ds.gradtarg)/norm(vals1ds.gradtarg) < eps
    @test norm(vals2d.pottarg-vals1d.pottarg)/norm(vals1d.pottarg) < eps
    @test norm(vals2d.gradtarg-vals1d.gradtarg)/norm(vals1d.gradtarg) < eps    

    @test norm(vals2dc.pot-vals1dcs.pottarg)/norm(vals1dcs.pottarg) < eps
    @test norm(vals2dc.grad-vals1dcs.gradtarg)/norm(vals1dcs.gradtarg) < eps
    @test norm(vals2dc.pottarg-vals1dc.pottarg)/norm(vals1dc.pottarg) < eps
    @test norm(vals2dc.gradtarg-vals1dc.gradtarg)/norm(vals1dc.gradtarg) < eps    
    @test norm(vals2dc_ndiv.pot-vals1dcs.pottarg)/norm(vals1dcs.pottarg) < eps
    @test norm(vals2dc_ndiv.grad-vals1dcs.gradtarg)/norm(vals1dcs.gradtarg) < eps
    @test norm(vals2dc_ndiv.pottarg-vals1dc.pottarg)/norm(vals1dc.pottarg) < eps
    @test norm(vals2dc_ndiv.gradtarg-vals1dc.gradtarg)/norm(vals1dc.gradtarg) < eps
    @test vals2dc_ndiv.ier == 0
    

end

@testset "testing Stokes utilities" begin

    n = 1000
    nt = 1100
    sources = randn(3,n)
    targets = randn(3,nt)
    stoklet = randn(3,n)
    strslet = randn(3,n)
    strsvec = randn(3,n)

    vals1c = st3ddir(sources,targets,stoklet=stoklet,
                    ppregt=3,thresh=1e-16)

    vals1cs = st3ddir(sources,sources,stoklet=stoklet,
                    ppregt=3,thresh=1e-16)

    vals1d = st3ddir(sources,targets,strslet=strslet,strsvec=strsvec,
                    ppregt=3,thresh=1e-16)

    vals1ds = st3ddir(sources,sources,strslet=strslet,strsvec=strsvec,
                    ppregt=3,thresh=1e-16)

    vals1dc = st3ddir(sources,targets,stoklet=stoklet,
                     strslet=strslet,strsvec=strsvec,ppregt=3,thresh=1e-16)

    vals1dcs = st3ddir(sources,sources,stoklet=stoklet,
                     strslet=strslet,strsvec=strsvec,ppregt=3,thresh=1e-16)

    eps = 1e-12
    vals2c = stfmm3d(eps,sources,targets=targets,stoklet=stoklet,
                    ppreg=3,ppregt=3)
    vals2d = stfmm3d(eps,sources,targets=targets,strslet=strslet,strsvec=strsvec,
                    ppreg=3,ppregt=3)
    vals2dc = stfmm3d(eps,sources,targets=targets,stoklet=stoklet,
                     strslet=strslet,strsvec=strsvec,ppreg=3,ppregt=3)

    @test norm(vals2c.pot-vals1cs.pottarg)/norm(vals1cs.pottarg) < eps
    @test norm(vals2c.pre-vals1cs.pretarg)/norm(vals1cs.pretarg) < eps
    @test norm(vals2c.grad-vals1cs.gradtarg)/norm(vals1cs.gradtarg) < eps    
    @test norm(vals2c.pottarg-vals1c.pottarg)/norm(vals1c.pottarg) < eps
    @test norm(vals2c.gradtarg-vals1c.gradtarg)/norm(vals1c.gradtarg) < eps
    @test norm(vals2c.pretarg-vals1c.pretarg)/norm(vals1c.pretarg) < eps        

    @test norm(vals2d.pot-vals1ds.pottarg)/norm(vals1ds.pottarg) < eps
    @test norm(vals2d.pre-vals1ds.pretarg)/norm(vals1ds.pretarg) < eps
    @test norm(vals2d.grad-vals1ds.gradtarg)/norm(vals1ds.gradtarg) < eps
    @test norm(vals2d.pottarg-vals1d.pottarg)/norm(vals1d.pottarg) < eps
    @test norm(vals2d.pretarg-vals1d.pretarg)/norm(vals1d.pretarg) < eps
    @test norm(vals2d.gradtarg-vals1d.gradtarg)/norm(vals1d.gradtarg) < eps        

    @test norm(vals2dc.pot-vals1dcs.pottarg)/norm(vals1dcs.pottarg) < eps
    @test norm(vals2dc.pre-vals1dcs.pretarg)/norm(vals1dcs.pretarg) < eps
    @test norm(vals2dc.grad-vals1dcs.gradtarg)/norm(vals1dcs.gradtarg) < eps
    @test norm(vals2dc.pottarg-vals1dc.pottarg)/norm(vals1dc.pottarg) < eps
    @test norm(vals2dc.pretarg-vals1dc.pretarg)/norm(vals1dc.pretarg) < eps    
    @test norm(vals2dc.gradtarg-vals1dc.gradtarg)/norm(vals1dc.gradtarg) < eps    
    

end

@testset "testing electromagnetics utilities" begin

    n = 10
    nt = 11
    sources = randn(3,n)
    targets = randn(3,nt)
    h_current = randn(3,n) + im*randn(3,n)
    e_current = randn(3,n) + im*randn(3,n)
    e_charge = randn(n) + im*randn(n)
    zk = 2.1

    vals1A = em3ddir(zk,sources,targets,h_current=h_current,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1As = em3ddir(zk,sources,sources,h_current=h_current,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1B = em3ddir(zk,sources,targets,e_current=e_current,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1Bs = em3ddir(zk,sources,sources,e_current=e_current,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1lambda = em3ddir(zk,sources,targets,e_charge=e_charge,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1lambdas = em3ddir(zk,sources,sources,e_charge=e_charge,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1all = em3ddir(zk,sources,targets,h_current=h_current,e_current=e_current,e_charge=e_charge,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    vals1alls = em3ddir(zk,sources,sources,h_current=h_current,e_current=e_current,e_charge=e_charge,
                     ifEtarg=true,ifdivEtarg=true,
                     ifcurlEtarg=true,thresh=1e-16)

    eps = 1e-12
    vals2A = emfmm3d(eps,zk,sources,targets=targets,h_current=h_current,
                    ifE=true,ifdivE=true,ifcurlE=true,
                    ifEtarg=true,ifdivEtarg=true,ifcurlEtarg=true)
    
    vals2B = emfmm3d(eps,zk,sources,targets=targets,e_current=e_current,
                    ifE=true,ifdivE=true,ifcurlE=true,
                    ifEtarg=true,ifdivEtarg=true,ifcurlEtarg=true)
    
    vals2lambda = emfmm3d(eps,zk,sources,targets=targets,e_charge=e_charge,
                    ifE=true,ifdivE=true,ifcurlE=true,
                    ifEtarg=true,ifdivEtarg=true,ifcurlEtarg=true)
    
    vals2all = emfmm3d(eps,zk,sources,targets=targets,h_current=h_current,e_current=e_current,e_charge=e_charge,
                    ifE=true,ifdivE=true,ifcurlE=true,
                    ifEtarg=true,ifdivEtarg=true,ifcurlEtarg=true)

    function absrelerr(vex,v)
        return norm(vex-v)/max(norm(vex),1)
    end
    
    @test absrelerr(vals1As.Etarg,vals2A.E) < eps
    @test absrelerr(vals1A.Etarg,vals2A.Etarg) < eps    
    @test absrelerr(vals1As.divEtarg,vals2A.divE) < eps
    @test absrelerr(vals1A.divEtarg,vals2A.divEtarg) < eps    
    @test absrelerr(vals1As.curlEtarg,vals2A.curlE) < eps
    @test absrelerr(vals1A.curlEtarg,vals2A.curlEtarg) < eps      
                  
    @test absrelerr(vals1Bs.Etarg,vals2B.E) < eps
    @test absrelerr(vals1B.Etarg,vals2B.Etarg) < eps    
    @test absrelerr(vals1Bs.divEtarg,vals2B.divE) < eps
    @test absrelerr(vals1B.divEtarg,vals2B.divEtarg) < eps    
    @test absrelerr(vals1Bs.curlEtarg,vals2B.curlE) < eps
    @test absrelerr(vals1B.curlEtarg,vals2B.curlEtarg) < eps      
                  
    @test absrelerr(vals1lambdas.Etarg,vals2lambda.E) < eps
    @test absrelerr(vals1lambda.Etarg,vals2lambda.Etarg) < eps    
    @test absrelerr(vals1lambdas.divEtarg,vals2lambda.divE) < eps
    @test absrelerr(vals1lambda.divEtarg,vals2lambda.divEtarg) < eps    
    @test absrelerr(vals1lambdas.curlEtarg,vals2lambda.curlE) < eps
    @test absrelerr(vals1lambda.curlEtarg,vals2lambda.curlEtarg) < eps      
                  
    @test absrelerr(vals1alls.Etarg,vals2all.E) < eps
    @test absrelerr(vals1all.Etarg,vals2all.Etarg) < eps    
    @test absrelerr(vals1alls.divEtarg,vals2all.divE) < eps
    @test absrelerr(vals1all.divEtarg,vals2all.divEtarg) < eps    
    @test absrelerr(vals1alls.curlEtarg,vals2all.curlE) < eps
    @test absrelerr(vals1all.curlEtarg,vals2all.curlEtarg) < eps      

end


@testset "testing lower level routines" begin


    # besseljs3d

    nterms = 10
    z = 1.1 + im*1.2
    scale = 1.3
    ifder = 1

    fj10 = (-3.5183264829466616750769540*(1e-9) +
        im*8.88237983492960538163695769*(1e-9))

    fjs, fjder = besseljs3d(nterms,z,scale=scale,ifder=ifder)

    @test (abs(fj10-fjs[11]*(scale^10))/abs(fj10) < 1e-10)

end

c
c      TESTING SUITE FOR STOKES FMM:  June 18th, 2020
c
c

c$    use omp_lib
      implicit real *8 (a-h,o-z)
      implicit integer *8 (i-n)
      
      real *8, allocatable :: pot(:,:), pre(:), grad(:,:,:)
      real *8, allocatable :: source(:,:), targ(:,:)
      real *8, allocatable :: pottarg(:,:), pretarg(:), gradtarg(:,:,:)

      real *8, allocatable :: stoklet(:,:), strslet(:,:)
      real *8, allocatable :: strsvec(:,:)
      real *8, allocatable :: rotlet(:,:), rotvec(:,:)
      real *8, allocatable :: doublet(:,:), doubvec(:,:)
      
      integer *8 ipass(10)
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1
      pi=4.0*atan(done)
      call prini(6,13)



      ns = 4000
      nt = 4200

      allocate(source(3,ns),targ(3,nt))
      allocate(stoklet(3,ns),strslet(3,ns),strsvec(3,ns))
      allocate(rotlet(3,ns),rotvec(3,ns))
      allocate(doublet(3,ns),doubvec(3,ns))


c
c  Generate random collection of soruces
c
c  Interaction: stokeslet + stresslet
c  Evaluation: potential + pressure at sources
c
      
      do i = 1,ns
         source(1,i) = cos(i*done)
         source(2,i) = cos(10*i*done)
         source(3,i) = cos(100*i*done)
         stoklet(1,i) = sin(2*i*done)
         stoklet(2,i) = sin(22*i*done)
         stoklet(3,i) = sin(222*i*done)
         strslet(1,i) = sin(4*i*done)
         strslet(2,i) = sin(44*i*done)
         strslet(3,i) = sin(444*i*done)
         strsvec(1,i) = sin(5*i*done)
         strsvec(2,i) = sin(55*i*done)
         strsvec(3,i) = sin(555*i*done)
      enddo

      do i = 1,nt
         targ(1,i) = cos(7*i*done+1.2)
         targ(2,i) = cos(77*i*done+1.2)
         targ(3,i) = cos(777*i*done+1.2)
      enddo

      allocate(pot(3,ns),pre(ns),grad(3,3,ns))
      allocate(pottarg(3,nt),pretarg(nt),gradtarg(3,3,nt))      

      nd = 1
      eps = 1d-9
      ifstoklet = 1
      ifstrslet = 1
      ifrotlet = 0
      ifdoublet = 0
      ifppreg = 2
      ifppregtarg = 0

      call cpu_time(t1)
c$    t1 = omp_get_wtime()      
      call stfmm3d(nd,eps,ns,source,ifstoklet,stoklet,
     1     ifstrslet,strslet,strsvec,ifrotlet,rotlet,rotvec,
     2     ifdoublet,doublet,doubvec,ifppreg,pot,pre,grad,
     3     nt,targ,ifppregtarg,pottarg,pretarg,gradtarg,ier)
      call cpu_time(t2)
c$    t2 = omp_get_wtime()      

      call prin2('pot=*',pot,12)
      call prin2('pre=*',pre,12)


      stop
      end
c

c
cc     Plane wave routines for Laplace 3D FMM
c-------------------------------------------------------------

      subroutine rlscini(rlsc,nlambs,rlams,nterms)
      implicit double precision (a-h,o-z)
      integer *8 nlambs,nterms,i,j,k,nl
      double precision rlsc(0:nterms,0:nterms,nlambs)
      double precision     rlams(nlambs),rlampow(0:100)
      double precision     facts(0:200)
c
      facts(0) = 1.0d0
      do i = 1,100
	    facts(i) = facts(i-1)*dsqrt(i+0.0d0)
      enddo
c
      do nl = 1,nlambs
c
c     compute powers of lambda_nl
c
        rlampow(0) = 1.0d0
        rmul = rlams(nl)
        do j = 1,nterms
          rlampow(j) = rlampow(j-1)*rmul
        enddo
        do j = 0,nterms
          do k = 0,j
            rlsc(j,k,nl) = rlampow(j)/(facts(j-k)*facts(j+k))
          enddo
        enddo
      enddo

      return
      end
c-------------------------------------------------------------
      subroutine mkexps(rlams,nlambs,numphys,nexptotp,xs,ys,zs)
      implicit double precision (a-h,o-z)
      integer *8 nlambs,nexptotp
      double complex ima
      double complex xs(-5:5,nexptotp)
      double complex ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision     rlams(nlambs),u
      integer *8 numphys(nlambs)
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine computes the tables of exponentials needed
c     for translating exponential representations of harmonic
c     functions, discretized via normans quadratures.
c
c     u   = \int_0^\infty e^{-\lambda z}
c           \int_0^{2\pi} e^{i\lambda(x cos(u)+y sin(u))}
c           mexpphys(lambda,u) du dlambda
c
c     mexpphys(*):  discrete values of the moment function 
c                   m(\lambda,u), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c     on input:
c
c     rlams(nlambs)   discretization points in lambda integral 
c     nlambs          number of discret. pts. in lambda integral
c     numphys(j)     number of nodes in u integral needed 
c                    for corresponding lambda =  lambda_j. 
c     nexptotp        sum_j numphys(j)
c
c     on output:
c
c     xs(m,nexptotp)   e^{i \lambda_j (m cos(u_k)}  in above ordering
c                         for m=-5,-4,-3,-2,-1,0,1,2,3,4,5
c     ys(m,nexptotp)   e^{i \lambda_j (m sin(u_k)}  in above ordering,
c                         for m=-5,-4,-3,-2,-1,0,1,2,3,4,5
c     zs(1,nexptotp)   e^{- m \lambda_j}     in above ordering,
c                         for m=1,2,3,4,5
c------------------------------------------------------------
c      
c     loop over each lambda value 
c
      pi = 4*datan(1.0d0)
      ntot = 0
      do nl = 1,nlambs
        hu=2*pi/numphys(nl)
        do mth = 1,numphys(nl)
          u = (mth-1)*hu
          ncurrent = ntot+mth
          zs(1,ncurrent) = exp( -rlams(nl) )
          zs(2,ncurrent) = exp( - 2.0d0*rlams(nl) )
          zs(3,ncurrent) = exp( - 3.0d0*rlams(nl) )
          zs(4,ncurrent) = exp( - 4.0d0*rlams(nl) )
          zs(5,ncurrent) = exp( - 5.0d0*rlams(nl) )
          xs(1,ncurrent) = exp(ima*rlams(nl)*cos(u))
          xs(2,ncurrent) = exp(ima*rlams(nl)*2.0d0*cos(u))
          xs(3,ncurrent) = exp(ima*rlams(nl)*3.0d0*cos(u))
          xs(4,ncurrent) = exp(ima*rlams(nl)*4.0d0*cos(u))
          xs(5,ncurrent) = exp(ima*rlams(nl)*5.0d0*cos(u))
          ys(1,ncurrent) = exp(ima*rlams(nl)*sin(u))
          ys(2,ncurrent) = exp(ima*rlams(nl)*2.0d0*sin(u))
          ys(3,ncurrent) = exp(ima*rlams(nl)*3.0d0*sin(u))
          ys(4,ncurrent) = exp(ima*rlams(nl)*4.0d0*sin(u))
          ys(5,ncurrent) = exp(ima*rlams(nl)*5.0d0*sin(u))

          xs(0,ncurrent)  = 1.0d0
          xs(-1,ncurrent) = exp(-ima*rlams(nl)*cos(u))
          xs(-2,ncurrent) = exp(-ima*rlams(nl)*2.0d0*cos(u))
          xs(-3,ncurrent) = exp(-ima*rlams(nl)*3.0d0*cos(u))
          xs(-4,ncurrent) = exp(-ima*rlams(nl)*4.0d0*cos(u))
          xs(-5,ncurrent) = exp(-ima*rlams(nl)*5.0d0*cos(u))

          ys(0,ncurrent) = 1.0d0
          ys(-1,ncurrent) = exp(-ima*rlams(nl)*sin(u))
          ys(-2,ncurrent) = exp(-ima*rlams(nl)*2.0d0*sin(u))
          ys(-3,ncurrent) = exp(-ima*rlams(nl)*3.0d0*sin(u))
          ys(-4,ncurrent) = exp(-ima*rlams(nl)*4.0d0*sin(u))
          ys(-5,ncurrent) = exp(-ima*rlams(nl)*5.0d0*sin(u))
        enddo
        ntot = ntot + numphys(nl)
      enddo

      return
      end
c***********************************************************************
      subroutine mkfexp(nlambs,numfour,numphys,fexpe,fexpo,fexpback)
      implicit double precision (a-h,o-z)
      double complex ima
      double complex fexpe(1)
      double complex fexpo(1)
      double complex fexpback(1)
      integer *8  nlambs,numphys(nlambs),numfour(nlambs)
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine computes the tables of exponentials needed
c     for mapping from fourier to physical domain. 
c     in order to minimize storage, they are organized in a 
c     one-dimenional array corresponding to the order in which they
c     are accessed by subroutine ftophys.
c    
c     size of fexpe, fexpo =          40000   for nlambs = 39
c     size of fexpe, fexpo =          15000   for nlambs = 30
c     size of fexpe, fexpo =           4000   for nlambs = 20
c     size of fexpe, fexpo =            400   for nlambs = 10
c
c***********************************************************************
      pi = 4*datan(1.0d0)
      nexte = 1
      nexto = 1
      do i=1,nlambs
	    nalpha = numphys(i)
        halpha=2*pi/nalpha
        do j=1,nalpha
          alpha=(j-1)*halpha
	      do mm = 2,numfour(i),2
            fexpe(nexte)  = exp(ima*(mm-1)*alpha)
	        nexte = nexte + 1
          enddo
	      do mm = 3,numfour(i),2
            fexpo(nexto)  = exp(ima*(mm-1)*alpha)
	        nexto = nexto + 1
          enddo
        enddo
      enddo

      next = 1
      do i=1,nlambs
	    nalpha = numphys(i)
        halpha=2*pi/nalpha
	    do mm = 2,numfour(i)
          do j=1,nalpha
            alpha=(j-1)*halpha
            fexpback(next)  = exp(-ima*(mm-1)*alpha)
	        next = next + 1
          enddo
        enddo
      enddo

      return
      end

c---------------------------------------------------
      subroutine mpoletoexp(nd,mpole,nterms,nlambs,numtets,nexptot,
     1                mexpupf,mexpdownf,rlsc)

c     This subroutine converts a multipole expansion into the
c     corresponding exponential moment function mexp for
c     both the +z direction and the -z direction
c
c     Note: this subroutine is the same as mpoletoexp
c     in mtxbothnew.f but just has a different data structure
c     for mpole
c
c     U(x,y,z) = \sum_{n=0}^{nterms} \sum_{m=-n,n} mpole(n,m)
c                Y_n^m (\cos(\theta)) e^{i m \phi}/r^{n+1}
c  
c              = (1/2\pi) \int_{0}^{\infty} e^{-\lambda z}
c                \int_{0}^{2\pi} e^{i \lambda (x \cos(\alpha) +
c                y \sin(\alpha))} mexpup(\lambda,\alpha)
c                d\alpha d\lambda
c 
c     for the +z direction and
c
c              = (1/2\pi) \int_{0}^{\infty} e^{\lambda z}
c                \int_{0}^{2\pi} e^{-i \lambda (x \cos(\alpha) +
c                y \sin(\alpha))} mexpdown(\lambda,\alpha)
c                d\alpha d\lambda
c 
c     for the -z direction
c
c     NOTE: The expression for -z corresponds to the mapping
c     (x,y,z) -> (-x,-y,-z), ie reflection through
c     the origin.
c
c     NOTE 2: The multipole expansion is assumed to have been
c     rescaled so that the box containing the sources has unit
c     dimension
c
c     NOTE 3: Since we store the exponential moment function in
c     Fourier domain (w.r.t the \alpha variable) we compute
c 
c     M_\lambda(m) = (i)**m \sum_{n=m}^{N} c(n,m) mpole(n,m)
c     lambda^n
c 
c     for m >=0 only, where c(n,m) = 1/sqrt((n+m)!(n-m)!)
c
c     For possible future reference, it should be noted that it
c     is NOT true that M_\lambda(-m) = dconjg(M_\lambda(m))
c
c     Inspection of the integral formula for Y_n^{-m} shows
c     that M_\lambda(-m) = dconjg(M_\lambda) * (-1)**m
c
c     INPUT arguments
c     nd          in: integer *8
c                 number of multipole expansions
c
c     mpole       in: double complex (nd,0:nterms, -nterms:nterms)
c                 The multipole expansion 
c  
c     nterms:     in: integer *8
c                 Order of the multipole expansion
c
c     nlambs      in: integer *8
c                 number of discretization points in the \lambda
c                 integral
c
c     numtets     in: integer *8(nlambs)
c                 number of fourier modes needed in expansion
c                 of \alpha variable for each \lambda variable
c
c     nexptot     in: integer *8
c                 nexptot = \sum_{j} numtets(j)
c
c     rlsc        in: double precision(0:nterms, 0:nterms,nlambs)
c                 scaled discretization points in the \lambda
c                 integral
c
c     OUTPUT 
c     mexpupf     out: double complex (nd,nexptot)
c                 Fourier coefficients of the function
c                 mexpup(\lambda,\alpha) for successive
c                 discrete lambda values. They are ordered as
c                 follows
c
c                 mexpupf(1,...., numtets(1)) = fourier modes
c                             for \lambda_1
c
c                 mexpupf(numtets(1)+1,...., numters(2) = fourier
c                 modes for \lambda_2
c
c                 ETC
c
c     mexpdownf   out: double complex (nd,nexptot)
c                 Fourier coefficients of the function 
c                 mexpdown(\lambda,\alpha) for successive
c                 discrete \lambda values
c---------------------------------------------------------------

      implicit none
      integer *8 nd
      integer *8 nterms,nlambs,numtets(nlambs),nexptot
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex mexpupf(nd,nexptot)
      double complex mexpdownf(nd,nexptot)
      double precision rlsc(0:nterms,0:nterms,nlambs)

c     Temp variables
      double complex, allocatable :: ztmp1(:),ztmp2(:)
      double complex zeyep
      double precision sgn
      integer *8 ntot,ncurrent,nl,mth,nm,idim

      allocate(ztmp1(nd),ztmp2(nd))

      ntot = 0
      do nl=1,nlambs
        sgn = -1.0d0
        zeyep = 1.0d0

        do mth = 0,numtets(nl)-1
          ncurrent = ntot + mth + 1

          do idim = 1,nd
            ztmp1(idim) = 0.0d0
            ztmp2(idim) = 0.0d0
          enddo

          sgn = -sgn
          do nm = mth,nterms,2
            do idim=1,nd
              ztmp1(idim) = ztmp1(idim) + 
     1            rlsc(nm,mth,nl)*mpole(idim,nm,mth)
            enddo
          enddo

          do nm=mth+1,nterms,2
            do idim=1,nd
              ztmp2(idim) = ztmp2(idim) + 
     1           rlsc(nm,mth,nl)*mpole(idim,nm,mth)
            enddo
          enddo

          do idim=1,nd
            mexpupf(idim,ncurrent) = (ztmp1(idim)+ztmp2(idim))*zeyep
            mexpdownf(idim,ncurrent) = 
     1         sgn*(ztmp1(idim)-ztmp2(idim))*zeyep
          enddo
          zeyep = zeyep*dcmplx(0.0d0,1.0d0)
        enddo
        ntot = ntot + numtets(nl)
      enddo

      return
      end

c -----------------------------------------------------------------
      subroutine exptolocal(nd,local,nterms,rlambs,whts,nlambs,numtets,
     1                     nthmax,nexptot,lexp1f,lexp2f,scale,rlsc)
c-----------------------------------------------------------------
c     INPUT arguments
c     nd               in: number of local expansions
c 
c     nterms           in: integer *8
c                      Order of local expansion
c
c     rlambs           in: double precision(nlambs)
c                      discretization points in the \lambda integral
c
c     whts             in: double precision(nlambs)
c                      quadrature weights in \lambda integral
c
c     nlambs           in: integer *8
c                      number of discretization points in \lambda
c                      integral
c
c     numtets          in: integer *8(nlambs)
c                      number of fourier modes in expansion of
c                      \alpha variable for \lambda_j
c
c     nthmax           in: integer *8
c                      max_j numtets(j)
c
c     nexptot          in: integer *8
c                      sum_j numtets(j)
c                      
c
c     lexp1f(nd,nexptot)  double complex(nd,nexptot)
c                      Fourier coefficients of the function 
c                      lexp1 for discrete \lambda values
c                      in the +z direction
c                      They are ordered as follows:
c
c                      lexp1f(1,...,numtets(1)) = Fourier modes
c                      for \lambda_1
c                      lexp1f(numtets(1)+1,...,numtets(2) = Fourier
c                      modes for \lambda_2 etc
c
c
c     lexp2f(nd,nexptot)  double complex(nd,nexptot)
c                      Fourier coefficients of the function 
c                      lexp1 for discrete \lambda values
c                      in the -z direction
c                      They are ordered as follows:
c
c                      lexp1f(1,...,numtets(1)) = Fourier modes
c                      for \lambda_1
c                      lexp1f(numtets(1)+1,...,numtets(2) = Fourier
c                      modes for \lambda_2 etc
c
c     scale            in: double precision
c                      scaling parameter for local expansion
c
c     rlsc        in: double precision(nlambs, 0:nterms, 0:nterms)
c                 scaled discretization points in the \lambda
c                 integral
c
c     OUTPUT
c     local(nd,0:nterms,-nterms:nterms): output local expansion of order
c                                     nterms
        
      implicit none
      integer *8 nd
      integer *8 nterms,nlambs,numtets(nlambs),nexptot,nthmax
      integer *8 ncurrent,ntot,nl
      double complex local(nd,0:nterms,-nterms:nterms)
      double complex lexp1f(nd,nexptot),lexp2f(nd,nexptot)
      double complex zeye(0:nterms)
      double precision rlambs(nlambs), rlambpow(0:nterms) ,whts(nlambs)
      double precision rmul,rlsc(0:nterms,0:nterms,nlambs)
      double precision scale, rscale(0:nterms)
      double complex ima
    
c     Temporary variables
      integer *8 i, nm, mth, j, mmax,idim
      double precision dtmp

      data ima/(0.0d0,1.0d0)/


      zeye(0) = 1.0d0
      do i=1,nterms
        zeye(i) = zeye(i-1)*ima
      enddo

      rscale(0) = 1
      do nm=0,nterms
         if(nm.gt.0) rscale(nm) = rscale(nm-1)*scale
         do mth = -nterms,nterms
           do idim=1,nd
             local(idim,nm,mth) = 0.0d0
           enddo
         enddo
      enddo

      ntot = 1
      do nl=1,nlambs
c        Add contributions to local expansion
        do nm=0,nterms,2
          mmax = numtets(nl)-1
          if(mmax.gt.nm) mmax = nm
          do mth=0,mmax
            ncurrent = ntot+mth
            dtmp = rlsc(nm,mth,nl)*whts(nl)
            do idim=1,nd
              local(idim,nm,mth) = local(idim,nm,mth)+
     1          (lexp1f(idim,ncurrent)+lexp2f(idim,ncurrent))*dtmp
            enddo
          enddo
        enddo
        do nm=1,nterms,2
          mmax = numtets(nl) - 1
          if(mmax.gt.nm) mmax = nm
          do mth =0,mmax
            ncurrent = ntot+mth
            dtmp = -rlsc(nm,mth,nl)*whts(nl)
            do idim=1,nd
              local(idim,nm,mth) = local(idim,nm,mth)+
     1          (lexp1f(idim,ncurrent)-lexp2f(idim,ncurrent))*dtmp
            enddo
          enddo
        enddo
        ntot = ntot + numtets(nl)
      enddo

      do nm=0,nterms
        do idim=1,nd
          local(idim,nm,0) = local(idim,nm,0)*zeye(0)
        enddo
        do mth = 1,nm
          do idim=1,nd
            local(idim,nm,mth) = local(idim,nm,mth)*zeye(mth)
            local(idim,nm,-mth) = dconjg(local(idim,nm,mth))
          enddo
        enddo
      enddo

      return
      end
c------------------------------------------------
      subroutine phystof(nd,mexpf,nlambs,numfour,numphys,
     1                      mexpphys,fexpback)
      implicit double precision (a-h,o-z)
      integer *8 nd
      double complex mexpf(nd,*)
      double complex mexpphys(nd,*),ima
      double complex fexpback(*)
      double precision hh
      double precision, allocatable :: alphas(:)
      integer *8  nlambs,numfour(nlambs),numphys(nlambs),nthmax
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine converts the discretized exponential moment function
c     into its fourier expansion.
c
c     on input:
c
c     mexpphys(nd,*):  discrete values of the moment function 
c                   m(\lambda,\alpha), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c     nlambs:        number of discretization pts. in lambda integral
c     numfour(j):   number of fourier modes in the expansion
c                      of the function m(\lambda_j,\alpha)
c     nthmax =      max_j numfour(j)
c
c     on output:
c
c     mexpf(nd,*):     fourier coefficients of the function 
c                   mexp(lambda,alpha) for discrete lambda values. 
c                   they are ordered as follows:
c
c               mexpf(1,...,numfour(1)) = fourier modes for lambda_1
c               mexpf(numfour(1)+1,...,numfour(2)) = fourier modes
c                                              for lambda_2
c               etc.
c
c------------------------------------------------------------
      done=1.0d0

      allocate(alphas(0:1000))
c
c
      pi=datan(done)*4
      nftot = 0
      nptot  = 0
      next  = 1
      do i=1,nlambs
        nalpha = numphys(i)
        hh = 1.0d0/nalpha
        halpha=2*pi*hh
        do j=1,nalpha
          alphas(j)=(j-1)*halpha
        enddo

        do idim=1,nd
          mexpf(idim,nftot+1) = 0.0d0
        enddo

        do ival=1,nalpha
          do idim=1,nd
            mexpf(idim,nftot+1) = mexpf(idim,nftot+1) + 
     1          mexpphys(idim,nptot+ival)*hh 
          enddo
        enddo

        do mm = 2,numfour(i)
          do idim=1,nd
            mexpf(idim,nftot+mm) = 0.0d0 
          enddo
          do ival=1,nalpha
            do idim=1,nd
              mexpf(idim,nftot+mm) = mexpf(idim,nftot+mm)+
     1          fexpback(next)*mexpphys(idim,nptot+ival)*hh
            enddo
            next = next+1
          enddo
        enddo
        nftot = nftot+numfour(i)
        nptot = nptot+numphys(i)
      enddo

      return
      end
c
c------------------------------------------------

c
      subroutine ftophys(nd,mexpf,nlambs,rlams,numfour,numphys,
     1                      nthmax,mexpphys,fexpe,fexpo)
      implicit double precision (a-h,o-z)
      integer *8 nd,nlambs
      double complex mexpf(nd,*)
      double complex mexpphys(nd,*),ima,ctmp
      double complex fexpe(*)
      double complex fexpo(*)
      double precision     rlams(nlambs)
      double precision, allocatable :: alphas(:) 
      integer *8  numfour(nlambs),numphys(nlambs),nthmax
      data ima/(0.0d0,1.0d0)/
c
c     this subroutine evaluates the fourier expansion of the
c     exponential moment function m(\lambda,\alpha) at equispaced
c     nodes.
c
c     on input:
c
c     mexpf(nd,*):     fourier coefficients of the function 
c                   mexp(lambda,alpha) for discrete lambda values. 
c                   they are ordered as follows:
c
c               mexpf(1,...,numfour(1)) = fourier modes for lambda_1
c               mexpf(numfour(1)+1,...,numfour(2)) = fourier modes
c                                              for lambda_2
c               etc.
c
c     nlambs:        number of discretization pts. in lambda integral
c     rlams(nlambs): discretization points in lambda integral.
c     numfour(j):   number of fourier modes in the expansion
c                      of the function m(\lambda_j,\alpha)
c     nthmax =      max_j numfour(j)
c     fexpe =      precomputed array of exponentials needed for
c                  fourier series evaluation
c     fexpo =      precomputed array of exponentials needed for
c                  fourier series evaluation
c
c     on output:
c
c     mexpphys(nd,*):  discrete values of the moment function 
c                   m(\lambda,\alpha), ordered as follows.
c
c         mexpphys(1),...,mexpphys(numphys(1)) = m(\lambda_1,0),..., 
c              m(\lambda_1, 2*pi*(numphys(1)-1)/numphys(1)).
c         mexpphys(numphys(1)+1),...,mexpphys(numphys(2)) = 
c              m(\lambda_2,0),...,
c                  m(\lambda_2, 2*pi*(numphys(2)-1)/numphys(2)).
c         etc.
c
c------------------------------------------------------------
      done=1.0d0

      allocate(alphas(0:1000))
c
c
      pi=datan(done)*4
      nftot = 0
      nptot  = 0
      nexte = 1
      nexto = 1
      do i=1,nlambs
        do ival=1,numphys(i)
          do idim=1,nd
            mexpphys(idim,nptot+ival) = mexpf(idim,nftot+1)
          enddo
          do mm = 2,numfour(i),2
            do idim=1,nd
              rtmp = 2*dimag(fexpe(nexte)*mexpf(idim,nftot+mm))
              mexpphys(idim,nptot+ival) = mexpphys(idim,nptot+ival) +
     1                dcmplx(0.0d0,rtmp)
            enddo
            nexte = nexte + 1
          enddo
          do mm = 3,numfour(i),2
            do idim=1,nd
              rtmp = 2*real(fexpo(nexto)*mexpf(idim,nftot+mm))
              mexpphys(idim,nptot+ival) = mexpphys(idim,nptot+ival) +
     1                rtmp
            enddo
            nexto = nexto + 1
          enddo
        enddo
        nftot = nftot+numfour(i)
        nptot = nptot+numphys(i)
      enddo

      return
      end
c
c
c--------------------------------------------------------------------
      subroutine processudexp(nd,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nuall,uall,
     3           nu1234,u1234,ndall,dall,nd5678,d5678,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpuall,mexpu5678,mexpdall,
     5           mexpd1234,xs,ys,zs,fexpback,rlsc,rscpow,
     6           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 iaddr(2,nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 nexptot,nexptotp,nmax
      integer *8 nuall,ndall,nu1234,nd5678
      integer *8 uall(*),dall(*),u1234(*),d5678(*)
      double precision rscale,bs
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)  
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rmlexp(*),centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
      double complex mexpd1234(nd,nexptotp),mexpu5678(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)
      integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
      integer *8 nlist4
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
      integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,kbox
      double precision rtmp,rtmp2
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpuall(idim,i) = 0
          mexpdall(idim,i) = 0
          mexpu5678(idim,i) = 0
          mexpd1234(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,nuall
        jbox = uall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpdall(idim,j) = mexpdall(idim,j) + 
     1          mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo

      do i=1,nu1234
        jbox = u1234(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpd1234(idim,j) = mexpd1234(idim,j) + 
     1          mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo


      do i=1,ndall
        jbox = dall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpuall(idim,j) = mexpuall(idim,j) + 
     1          mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo

      do i=1,nd5678
        jbox = d5678(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpu5678(idim,j) = mexpu5678(idim,j) + 
     1         mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1

      jbox = ichild(1,ibox)

      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)
            mexpdownphys(idim,i) = mexpdall(idim,i) + mexpd1234(idim,i)
          enddo
        enddo
        
        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 2
      jbox = ichild(2,ibox)
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1          mexpd1234(idim,i))*xs(-1,i)
          enddo
        enddo
 
        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif
  
c      add contributions due to child 3
      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1          mexpd1234(idim,i))*ys(-1,i)
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 4
      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = (mexpdall(idim,i) + 
     1         mexpd1234(idim,i))*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 5
      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1.0d0/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1           mexpu5678(idim,i))*zs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*rtmp
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 6
      jbox = ichild(6,ibox)

      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1         mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)


      endif

c      add contributions due to child 7
 
      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1          mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 8
      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpuall(idim,i)+
     1         mexpu5678(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,1,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(iaddr(2,jbox)),nterms)

      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine processnsexp(nd,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nnall,nall,
     3           nn1256,n1256,nn12,n12,nn56,n56,
     4           nsall,sall,ns3478,s3478,ns34,s34,ns78,s78,mexpup,
     5           mexpdown,mexpupphys,mexpdownphys,
     6           mexpnall,mexpn3478,mexpn34,mexpn78,mexpsall,
     7           mexps1256,mexps12,mexps56,rdplus,
     8           xs,ys,zs,fexpback,rlsc,rscpow,
     9           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 iaddr(2,nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 nexptot,nexptotp,nmax
      integer *8 nnall,nsall,nn1256,ns3478,nn12,nn56,ns34,ns78
      integer *8 nall(*),sall(*),n1256(*),s3478(*)
      integer *8 n12(*),n56(*),s34(*),s78(*)
      double precision rscale,bs
      double complex zk2
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)
      double complex, allocatable :: tloc2(:,:,:)
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdplus(0:nterms,0:nterms,-nterms:nterms)
      double precision rmlexp(*),centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
      double complex mexps1256(nd,nexptotp),mexpn3478(nd,nexptotp)
      double complex mexps12(nd,nexptotp),mexps56(nd,nexptotp)
      double complex mexpn34(nd,nexptotp),mexpn78(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)
      integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
      integer *8 nlist4
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
      integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,idim,kbox
      double complex ztmp,zmul,ztmp2
      double precision rtmp,rtmp2
    
      double precision ctmp(3)
      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpnall(idim,i) = 0
          mexpsall(idim,i) = 0
          mexpn3478(idim,i) = 0
          mexpn34(idim,i) = 0
          mexpn78(idim,i) = 0
          mexps1256(idim,i) = 0
          mexps12(idim,i) = 0
          mexps56(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,nnall
        jbox = nall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
           zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
           do idim=1,nd
             mexpsall(idim,j) = mexpsall(idim,j) + 
     1           mexp(idim,j,jbox,4)*zmul
           enddo
        enddo

      enddo

      do i=1,nn1256
        jbox = n1256(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
          do idim=1,nd
            mexps1256(idim,j) = mexps1256(idim,j) + 
     1          mexp(idim,j,jbox,4)*zmul
          enddo
        enddo
      enddo

      do i=1,nn12
        jbox = n12(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
          do idim=1,nd
            mexps12(idim,j) = mexps12(idim,j)+mexp(idim,j,jbox,4)*zmul
          enddo
        enddo
      enddo


      do i=1,nn56
        jbox = n56(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
          do idim=1,nd
            mexps56(idim,j) = mexps56(idim,j)+mexp(idim,j,jbox,4)*zmul
          enddo
        enddo
      enddo


      do i=1,nsall
        jbox = sall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpnall(idim,j) = mexpnall(idim,j) + 
     1         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

      do i=1,ns3478
        jbox = s3478(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpn3478(idim,j) = mexpn3478(idim,j) + 
     1         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

      do i=1,ns34
        jbox = s34(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpn34(idim,j) = mexpn34(idim,j)+mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

      do i=1,ns78
        jbox = s78(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpn78(idim,j) = mexpn78(idim,j)+mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
      jbox = ichild(1,ibox)

      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)+mexps1256(idim,i)+ 
     1         mexps12(idim,i)
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 2
      jbox = ichild(2,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1         mexps1256(idim,i) + mexps12(idim,i))*ys(-1,i)      
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)


      endif
  
c      add contributions due to child 3
      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+mexpn34(idim,i)+
     1          mexpn3478(idim,i))*zs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*rtmp
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 4
      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+mexpn34(idim,i)+
     1         mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 5
      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1          mexps1256(idim,i) + mexps56(idim,i))*xs(-1,i)      
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 6
      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = (mexpsall(idim,i) + 
     1          mexps1256(idim,i) + mexps56(idim,i))*ztmp2      
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)
      endif

c      add contributions due to child 7
 
      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+mexpn78(idim,i)+
     1          mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)
      endif

c      add contributions due to child 8
      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpnall(idim,i)+mexpn78(idim,i)+
     1         mexpn3478(idim,i))*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,2,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)


        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)
      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine processewexp(nd,ibox,ilev,nboxes,centers,ichild,
     1           rscale,bs,nterms,iaddr,rmlexp,rlams,whts,nlams,
     2           nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,neall,eall,
     3           ne1357,e1357,ne13,e13,ne57,e57,ne1,e1,ne3,e3,ne5,e5,
     4           ne7,e7,nwall,wall,nw2468,w2468,nw24,w24,nw68,w68,
     5           nw2,w2,nw4,w4,nw6,w6,nw8,w8,
     6           mexpup,mexpdown,mexpupphys,mexpdownphys,
     7           mexpeall,mexpe2468,mexpe24,mexpe68,mexpe2,mexpe4,
     8           mexpe6,mexpe8,mexpwall,mexpw1357,mexpw13,mexpw57,
     9           mexpw1,mexpw3,mexpw5,mexpw7,rdminus,
     9           xs,ys,zs,fexpback,rlsc,rscpow,
     6           pgboxwexp,cntlist4,list4,nlist4s,ilist4,mnlist4)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,ilev,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 iaddr(2,nboxes)
      integer *8 ichild(8,nboxes)
      integer *8 nexptot,nexptotp,nmax
      integer *8 neall,nwall,ne1357,nw2468,ne13,ne57,nw24,nw68
      integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8
      integer *8 eall(*),wall(*),e1357(*),w2468(*)
      integer *8 e13(*),e57(*),w24(*),w68(*)
      integer *8 e1(*),e3(*),e5(*),e7(*),w2(*),w4(*),w6(*),w8(*)
      double precision rscale,bs
      double complex zk2
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:),tloc2(:,:,:)
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdminus(0:nterms,0:nterms,-nterms:nterms)
      double precision rmlexp(*),centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
      double complex mexpw1357(nd,nexptotp),mexpe2468(nd,nexptotp)
      double complex mexpw13(nd,nexptotp),mexpw57(nd,nexptotp)
      double complex mexpe24(nd,nexptotp),mexpe68(nd,nexptotp)
      double complex mexpw1(nd,nexptotp),mexpw3(nd,nexptotp)
      double complex mexpw5(nd,nexptotp),mexpw7(nd,nexptotp)
      double complex mexpe2(nd,nexptotp),mexpe4(nd,nexptotp)
      double complex mexpe6(nd,nexptotp),mexpe8(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)
      integer *8 cntlist4,list4(*),nlist4s(*),ilist4(*),mnlist4
      integer *8 nlist4
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)

c      temp variables
      integer *8 jbox,ctr,ii,jj,i,ix,iy,iz,j,l,idim,kbox
      double complex ztmp,zmul,ztmp2
      double precision rtmp,rtmp2
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpeall(idim,i) = 0
          mexpwall(idim,i) = 0
          mexpe2468(idim,i) = 0
          mexpe24(idim,i) = 0
          mexpe68(idim,i) = 0
          mexpe2(idim,i) = 0
          mexpe4(idim,i) = 0
          mexpe6(idim,i) = 0
          mexpe8(idim,i) = 0
          mexpw1357(idim,i) = 0
          mexpw13(idim,i) = 0
          mexpw57(idim,i) = 0
          mexpw1(idim,i) = 0
          mexpw3(idim,i) = 0
          mexpw5(idim,i) = 0
          mexpw7(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,neall
        jbox = eall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpwall(idim,j) = mexpwall(idim,j) + 
     1         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,ne1357
        jbox = e1357(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpw1357(idim,j) = mexpw1357(idim,j) + 
     1         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,ne13
        jbox = e13(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpw13(idim,j) = mexpw13(idim,j)+mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo


      do i=1,ne57
        jbox = e57(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpw57(idim,j) = mexpw57(idim,j)+mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,ne1
        jbox = e1(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpw1(idim,j) = mexpw1(idim,j) + mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo


      do i=1,ne3
        jbox = e3(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
             mexpw3(idim,j) = mexpw3(idim,j) + mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,ne5
        jbox = e5(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
             mexpw5(idim,j) = mexpw5(idim,j) + mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo


      do i=1,ne7
        jbox = e7(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpw7(idim,j) = mexpw7(idim,j) + mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,nwall
        jbox = wall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpeall(idim,j) = mexpeall(idim,j) + 
     1         mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

      do i=1,nw2468
        jbox = w2468(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe2468(idim,j) = mexpe2468(idim,j) + 
     1          mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

      do i=1,nw24
        jbox = w24(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe24(idim,j) = mexpe24(idim,j)+mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

       

      do i=1,nw68
        jbox = w68(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe68(idim,j) = mexpe68(idim,j)+mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

      do i=1,nw2
        jbox = w2(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe2(idim,j) = mexpe2(idim,j) + mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo


      do i=1,nw4
        jbox = w4(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe4(idim,j) = mexpe4(idim,j) + mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

      do i=1,nw6
        jbox = w6(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe6(idim,j) = mexpe6(idim,j) + mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

      do i=1,nw8
        jbox = w8(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpe8(idim,j) = mexpe8(idim,j) + mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
      jbox = ichild(1,ibox)

      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)+mexpw1357(idim,i)+
     1         mexpw13(idim,i)+mexpw1(idim,i)
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 2
      jbox = ichild(2,ibox)

      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1         mexpe24(idim,i)+mexpe2(idim,i))*zs(1,i)      
            mexpdownphys(idim,i) = mexpwall(idim,i)*rtmp
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif
  
c      add contributions due to child 3
      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1         mexpw13(idim,i)+mexpw3(idim,i))*ys(-1,i)
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 4
      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1         mexpe24(idim,i)+mexpe4(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 5
      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*xs(-1,i)
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1             mexpw57(idim,i)+mexpw5(idim,i))*xs(1,i)
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)
      endif

c      add contributions due to child 6
      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*zs(1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1           mexpe68(idim,i)+mexpe6(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)
      endif

c      add contributions due to child 7
 
      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp
            mexpdownphys(idim,i) = (mexpwall(idim,i)+mexpw1357(idim,i)+
     1          mexpw57(idim,i)+mexpw7(idim,i))*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

c      add contributions due to child 8
      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)*zs(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = (mexpeall(idim,i)+mexpe2468(idim,i)+
     1         mexpe68(idim,i)+mexpe8(idim,i))*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        nlist4=nlist4s(jbox)
        do i=1,nlist4
          kbox=ilist4((jbox-1)*mnlist4+i)
          call l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1         list4(kbox),nexptotp,xs,ys,zs,
     2         centers(1,kbox),centers(1,jbox),bs,3,cntlist4)
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(iaddr(2,jbox)),nterms)

      endif

      return
      end
c
c
c--------------------------------------------------------------------
      subroutine processlist3udexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,nuall,uall,
     3           ndall,dall,mexpuall,mexpdall,
     5           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptot,nexptotp
      integer *8 nuall,ndall
      integer *8 uall(*),dall(*)
      double precision bs
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,nboxes)
      double complex mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j
      double precision rtmp
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)
      

      do i=1,nexptotp
        do idim=1,nd
          mexpuall(idim,i) = 0
          mexpdall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
  
      
      do i=1,nuall
        jbox = uall(i)
C        print *,"ulist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpdall(idim,j) = mexpdall(idim,j) + 
     1                         mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo

      do i=1,ndall
        jbox = dall(i)
C        print *,"dlist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpuall(idim,j) = mexpuall(idim,j) + 
     1                         mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo


      return
      end
c--------------------------------------------------------------------      

      subroutine processlist3nsexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,nnall,nall,
     3           nsall,sall,mexpnall,mexpsall,
     5           xs,ys,zs)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptotp
      integer *8 nnall,nsall
      integer *8 nall(*),sall(*)
      double precision bs
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,*)
      double complex mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,idim
      double complex ztmp,zmul,ztmp2
      double precision rtmp
    
      double precision ctmp(3)


      do i=1,nexptotp
        do idim=1,nd
          mexpnall(idim,i) = 0
          mexpsall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,nnall
        jbox = nall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
           zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
           do idim=1,nd
             mexpsall(idim,j) = mexpsall(idim,j) + 
     1                          mexp(idim,j,jbox,4)*zmul
           enddo
        enddo

      enddo

      do i=1,nsall
        jbox = sall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpnall(idim,j) = mexpnall(idim,j) + 
     1                         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

      return
      end
c--------------------------------------------------------------------      

      subroutine processlist3ewexp(nd,ibox,nboxes,centers,
     1           bs,nterms,nexptotp,mexp,neall,eall,nwall,wall,
     4           mexpeall,mexpwall,xs,ys,zs)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nexptotp
      integer *8 neall,nwall
      integer *8 eall(*),wall(*)
      double precision bs 
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision centers(3,*)
      double complex mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,l,idim
      double complex ztmp,zmul,ztmp2
      double precision rtmp
     
      double precision ctmp(3)


      do i=1,nexptotp
        do idim=1,nd
          mexpeall(idim,i) = 0
          mexpwall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - bs/2.0d0
      ctmp(2) = centers(2,ibox) - bs/2.0d0
      ctmp(3) = centers(3,ibox) - bs/2.0d0
       
      do i=1,neall
        jbox = eall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpwall(idim,j) = mexpwall(idim,j) + 
     1                         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,nwall
        jbox = wall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/bs
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/bs
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/bs

         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpeall(idim,j) = mexpeall(idim,j) + 
     1                         mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo


      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ud_eval_p(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize


        do i=1,nlam
          rr = exp(-z*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rlams(il)*(x*cos(alpha) + y*sin(alpha)))
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = 
     1            (mexpupphys(idim,ii)*rexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*rexpinv(il)*
     3             conjg(cc(iphys)))*hh
              pot(idim,itarg) = pot(idim,itarg) + real(rz) 
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ns_eval_p(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          rr = exp(-y*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rlams(il)*(z*cos(alpha) + x*sin(alpha)))
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = (mexpupphys(idim,ii)*rexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*rexpinv(il)*
     3             conjg(cc(iphys)))*hh
              pot(idim,itarg) = pot(idim,itarg) + real(rz)
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ew_eval_p(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr
      complex *16 rz
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          rr = exp(-x*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            cc(iphys) = exp(ima*rlams(il)*(-z*cos(alpha)+y*sin(alpha)))
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz = (mexpupphys(idim,ii)*rexp(il)*cc(iphys) + 
     2             mexpdownphys(idim,ii)*rexpinv(il)*
     3             conjg(cc(iphys)))*hh
              pot(idim,itarg) = pot(idim,itarg) + real(rz)
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ud_eval_g(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 grad(nd,3,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          rr = exp(-z*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rlams(il)*cos(alpha)*ima
            crs(iphys) = rlams(il)*sin(alpha)*ima
            cc(iphys) = exp(crc(iphys)*x + crs(iphys)*y)
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*rexp(il)*cc(iphys)*hh
              rz2 = mexpdownphys(idim,ii)*rexpinv(il)*conjg(cc(iphys))*
     1              hh
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + real(rz)
              grad(idim,1,itarg) = grad(idim,1,itarg) + 
     1            real((rz1-rz2)*crc(iphys))*binv
              grad(idim,2,itarg) = grad(idim,2,itarg) + 
     1            real((rz1-rz2)*crs(iphys))*binv
              grad(idim,3,itarg) = grad(idim,3,itarg) - 
     1            real(rz1-rz2)*binv*rlams(il)
            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ns_eval_g(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 grad(nd,3,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

        do i=1,nlam
          rr = exp(-y*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rlams(il)*cos(alpha)*ima
            crs(iphys) = rlams(il)*sin(alpha)*ima
            cc(iphys) = exp(crc(iphys)*z + crs(iphys)*x)
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*rexp(il)*cc(iphys)*hh
              rz2 = mexpdownphys(idim,ii)*rexpinv(il)*conjg(cc(iphys))*
     1              hh
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + real(rz)
              grad(idim,1,itarg) = grad(idim,1,itarg) + 
     1            real((rz1-rz2)*crs(iphys))*binv
              grad(idim,2,itarg) = grad(idim,2,itarg) - 
     1            real(rz1-rz2)*binv*rlams(il)
              grad(idim,3,itarg) = grad(idim,3,itarg) + 
     1            real((rz1-rz2)*crc(iphys))*binv

            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c
c
c--------------------------------------------------------------------     

      subroutine lpw_ew_eval_g(nd,center,boxsize,ntarg,targ,nlam,rlams,
     1   whts,nphys,nexptotp,nphmax,mexpupphys,mexpdownphys,pot,grad)
      implicit none
      integer *8 nd
      integer *8 ntarg,nlam
      real *8 center(3),boxsize,targ(3,ntarg),rlams(nlam),pot(nd,ntarg)
      real *8 grad(nd,3,ntarg)
      real *8 whts(nlam)
      integer *8 nphys(nlam),nexptotp,nphmax
      complex *16 mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      complex *16 ima
      complex *16, allocatable :: cc(:),crc(:),crs(:)
      integer *8 itarg,i,j,k,l,il,ii,iphys,istart,idim
      real *8 pi2inv,rexp1,alpha,pi2,x,y,z
      real *8 h,hh,rr,binv
      complex *16 rz,rz1,rz2
      real *8, allocatable :: rexp(:),rexpinv(:)
      data pi2inv/0.15915494309189535d0/
      data pi2/6.283185307179586d0/
      data ima/(0.0d0,1.0d0)/

      allocate(rexp(nlam),rexpinv(nlam),cc(nphmax))
      allocate(crc(nphmax),crs(nphmax))

      binv = 1.0d0/boxsize


      do itarg=1,ntarg
        x = (targ(1,itarg) - center(1))/boxsize
        y = (targ(2,itarg) - center(2))/boxsize
        z = (targ(3,itarg) - center(3))/boxsize

c
c         note: using vectorized notation to ensure simd instruction use
c
        rexpinv = 1.0d0/rexp

        do i=1,nlam
          rr = exp(-x*rlams(i))
          rexp(i) = rr*whts(i) 
          rexpinv(i) = whts(i)/rr
        enddo


        istart = 0
        do il=1,nlam
          h = pi2/nphys(il)
          hh = 1.0d0/nphys(il)

          do iphys = 1,nphys(il)
            alpha = (iphys-1)*h
            crc(iphys) = rlams(il)*cos(alpha)*ima
            crs(iphys) = rlams(il)*sin(alpha)*ima
            cc(iphys) = exp(-crc(iphys)*z + crs(iphys)*y)
          enddo
          do iphys = 1,nphys(il)
            ii = istart + iphys
            do idim=1,nd
              rz1 = mexpupphys(idim,ii)*rexp(il)*cc(iphys)*hh
              rz2 = mexpdownphys(idim,ii)*rexpinv(il)*conjg(cc(iphys))*
     1              hh
              rz = rz1 + rz2
              pot(idim,itarg) = pot(idim,itarg) + real(rz)
              grad(idim,1,itarg) = grad(idim,1,itarg) - 
     1            real(rz1-rz2)*binv*rlams(il)
              grad(idim,2,itarg) = grad(idim,2,itarg) + 
     1            real((rz1-rz2)*crs(iphys))*binv
              grad(idim,3,itarg) = grad(idim,3,itarg) - 
     1            real((rz1-rz2)*crc(iphys))*binv

            enddo
          enddo
          istart = istart + nphys(il)
        enddo
      enddo

      return
      end
c
c
c
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine processgboxudexp(nd,mexpugbox,mexpdgbox,jbox,
     1           nexptotp,mexpuall,mexpdall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpugbox(nd,nexptotp)
      double complex mexpdgbox(nd,nexptotp)
      double complex mexpuall(nd,nexptotp)
      double complex mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rtmp
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + mexpugbox(idim,i)
            mexpdall(idim,i) = mexpdall(idim,i) + mexpdgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*xs(-1,i)
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*xs(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) +
     1                         mexpugbox(idim,i)*ys(-1,i)
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          rtmp = 1.0d0/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*rtmp
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpuall(idim,i) = mexpuall(idim,i) + 
     1                         mexpugbox(idim,i)*ztmp2
            mexpdall(idim,i) = mexpdall(idim,i) + 
     1                         mexpdgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine processgboxnsexp(nd,mexpngbox,mexpsgbox,jbox,
     1           nexptotp,mexpnall,mexpsall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpngbox(nd,nexptotp)
      double complex mexpsgbox(nd,nexptotp)
      double complex mexpnall(nd,nexptotp)
      double complex mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rtmp
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + mexpngbox(idim,i)
            mexpsall(idim,i) = mexpsall(idim,i) + mexpsgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ys(-1,i)
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) +
     1                         mexpngbox(idim,i)*rtmp
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*xs(-1,i)
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*xs(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpnall(idim,i) = mexpnall(idim,i) + 
     1                         mexpngbox(idim,i)*ztmp2
            mexpsall(idim,i) = mexpsall(idim,i) + 
     1                         mexpsgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine processgboxewexp(nd,mexpegbox,mexpwgbox,jbox,
     1           nexptotp,mexpeall,mexpwall,
     2           xs,ys,zs)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 jbox,i
      integer *8 nexptotp
      double complex mexpegbox(nd,nexptotp)
      double complex mexpwgbox(nd,nexptotp)
      double complex mexpeall(nd,nexptotp)
      double complex mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rtmp
      double complex ztmp,ztmp2

c
cc       move all ghost box contributions to the child 1
c

c      add contributions due to child 1
      if(jbox.eq.1) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + mexpegbox(idim,i)
            mexpwall(idim,i) = mexpwall(idim,i) + mexpwgbox(idim,i)
          enddo
        enddo
      endif
      
c      add contributions due to child 2
      if(jbox.eq.2) then
        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*rtmp
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*zs(1,i)
          enddo
        enddo
      endif
  
c      add contributions due to child 3
      if(jbox.eq.3) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) +
     1                         mexpegbox(idim,i)*ys(-1,i)
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ys(1,i)
          enddo
        enddo
      endif

c      add contributions due to child 4
      if(jbox.eq.4) then
        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 5
      if(jbox.eq.5) then
        do i=1,nexptotp
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*xs(1,i)
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*xs(-1,i)
          enddo
        enddo
      endif

c      add contributions due to child 6
      if(jbox.eq.6) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*zs(1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 7
      if(jbox.eq.7) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

c      add contributions due to child 8
      if(jbox.eq.8) then
        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)*zs(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpeall(idim,i) = mexpeall(idim,i) + 
     1                         mexpegbox(idim,i)*ztmp2
            mexpwall(idim,i) = mexpwall(idim,i) + 
     1                         mexpwgbox(idim,i)*ztmp
          enddo
        enddo
      endif

      return
      end
c--------------------------------------------------------------------   c
c
c--------------------------------------------------------------------
      subroutine l3dlist4pw(ilev,nd,nexptotp,nexptot,nterms,nmax,
     1           nlams,nlege,nthmax,nlevels,
     2           ifcharge,ifdipole,list4,itree,laddr,ipointer,
     3           nfourier,nphysical,rdminus,rdplus,rlsc,
     4           rscales,boxsize,zshift,sourcesort,chargesort,
     5           dipvecsort,centers,xshift,yshift,fexpe,fexpo,
     6           mexpf1,mexpf2,tmp,mptemp,wlege,rlams,rscpow,
     7           pgboxwexp,cntlist4)
c--------------------------------------------------------------------
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 ilev
      integer *8 nd
      integer *8 nexptotp,nexptot
      integer *8 nterms,nmax,nlams,nlege,nthmax
      integer *8 nlevels,cntlist4
      integer *8 ifcharge,ifdipole
      integer *8 list4(*),itree(*),laddr(2,0:nlevels)
      integer *8 ipointer(32)
      integer *8 nfourier(*)
      integer *8 nphysical(*)
      double precision rscales
      double precision boxsize
      double precision zshift(5,nexptotp)
      double precision mptemp((nmax+1)*(2*nmax+1)*2*nd)
      double precision wlege(*)
      double precision rlams(*)
      double precision rscpow(*)
      double precision sourcesort(3,*)
      double precision chargesort(nd,*)
      double precision dipvecsort(nd,3,*)
      double precision centers(3,*)
      double precision rdminus(0:nmax,0:nmax,-nmax:nmax)
      double precision rdplus(0:nmax,0:nmax,-nmax:nmax)
      double precision rlsc(0:nmax,0:nmax,nlams)
      double complex xshift(-5:5,nexptotp),yshift(-5:5,nexptotp)
      double complex fexpe(*),fexpo(*)
      double complex mexpf1(nd,nexptot),mexpf2(nd,nexptot)
      double complex tmp(nd,0:nmax,-nmax:nmax)
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)
ccc   scoped function variables
      integer *8 ibox,jbox,i,idim,nlist3,j
      integer *8 istart,iend,npts
      integer *8 jstart,jend,npts0
      integer *8 gboxfl(2,8)
      integer *8, allocatable :: gboxind(:)
      integer *8 itmp
      double precision time1,time2,omp_get_wtime
      double precision gboxsubcenters(3,8)
      double precision, allocatable ::  gboxsort(:,:)
      double precision, allocatable ::  gboxcgsort(:,:)
      double precision, allocatable ::  gboxdpsort(:,:,:)
      double complex, allocatable :: gboxmexp(:,:)
      double complex, allocatable :: gboxwexp(:,:,:,:)


c
c     count number of boxes are in list4 of this level
      call cpu_time(time1)
C$    time1=omp_get_wtime()
      pgboxwexp=0d0
c     form mexp for all list4 type box at first ghost box center
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,jbox,jstart,jend,npts,npts0,i)
C$OMP$PRIVATE(gboxind,gboxsort,gboxfl,gboxsubcenters)
C$OMP$PRIVATE(gboxwexp,gboxmexp,gboxcgsort,gboxdpsort)
C$OMP$PRIVATE(mexpf1,mexpf2,tmp,mptemp,itmp)
      do ibox=laddr(1,ilev),laddr(2,ilev)
        if(list4(ibox).gt.0) then
          istart=itree(ipointer(10)+ibox-1)
          iend=itree(ipointer(11)+ibox-1)
          npts = iend-istart+1
          if(npts.gt.0) then
            allocate(gboxind(npts))
            allocate(gboxsort(3,npts))
            allocate(gboxmexp(nd*(nterms+1)*(2*nterms+1),8))
            allocate(gboxwexp(nd,nexptotp,6,8))
            call subdividebox(sourcesort(1,istart),npts,
     1           centers(1,ibox),boxsize,
     2           gboxind,gboxfl,gboxsubcenters)
            itmp = 3
            call dreorderf(itmp,npts,sourcesort(1,istart),
     1           gboxsort,gboxind)
            if(ifcharge.eq.1) then
              allocate(gboxcgsort(nd,npts))
              call dreorderf(nd,npts,chargesort(1,istart),
     1             gboxcgsort,gboxind)
            endif
            if(ifdipole.eq.1) then
              allocate(gboxdpsort(nd,3,npts))
              call dreorderf(3*nd,npts,dipvecsort(1,1,istart),
     1             gboxdpsort,gboxind)
            endif
cccccccccccccc  bad code, note gboxmexp is an array not scalar
            gboxmexp=0
            gboxwexp=0
            do i=1,8
              if(gboxfl(1,i).gt.0) then
                jstart=gboxfl(1,i)
                jend=gboxfl(2,i)
                npts0=jend-jstart+1
                jbox=list4(ibox)
                if(npts0.gt.0) then
                  if(ifcharge.eq.1.and.ifdipole.eq.0) then
                    call l3dformmpc(nd,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxcgsort(1,jstart),
     3                   npts0,gboxsubcenters(1,i),nterms,
     4                   gboxmexp(1,i),wlege,nlege)          
                  endif
                  if(ifcharge.eq.0.and.ifdipole.eq.1) then
                    call l3dformmpd(nd,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxdpsort(1,1,jstart),
     3                   npts0,gboxsubcenters(1,i),nterms,
     4                   gboxmexp(1,i),wlege,nlege)          
                  endif
                  if(ifcharge.eq.1.and.ifdipole.eq.1) then
                    call l3dformmpcd(nd,rscales,
     1                   gboxsort(1,jstart),
     2                   gboxcgsort(1,jstart),
     3                   gboxdpsort(1,1,jstart),
     4                   npts0,gboxsubcenters(1,i),nterms,
     5                   gboxmexp(1,i),wlege,nlege)          
                  endif
ccc    convert to plane wave
                  call mpscale(nd,nterms,gboxmexp(1,i),
     1                 rscpow,tmp)
c
cc                process up down for current box
c
                  call mpoletoexp(nd,tmp,nterms,nlams,nfourier,
     1                 nexptot,mexpf1,mexpf2,rlsc)

                  call ftophys(nd,mexpf1,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,1,i),fexpe,fexpo)

                  call ftophys(nd,mexpf2,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,2,i),fexpe,fexpo)

                  call processgboxudexp(nd,gboxwexp(1,1,1,i),
     1                 gboxwexp(1,1,2,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,1),
     3                 pgboxwexp(1,1,jbox,2),
     4                 xshift,yshift,zshift)
c
cc                process north-south for current box
c
                  call rotztoy(nd,nterms,tmp,mptemp,rdminus)
                  call mpoletoexp(nd,mptemp,nterms,nlams,nfourier,
     1                 nexptot,mexpf1,mexpf2,rlsc)

                  call ftophys(nd,mexpf1,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,3,i),fexpe,fexpo)

                  call ftophys(nd,mexpf2,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,4,i),fexpe,fexpo)

                  call processgboxnsexp(nd,gboxwexp(1,1,3,i),
     1                 gboxwexp(1,1,4,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,3),
     3                 pgboxwexp(1,1,jbox,4),
     4                 xshift,yshift,zshift)

c
cc                process east-west for current box

                  call rotztox(nd,nterms,tmp,mptemp,rdplus)
                  call mpoletoexp(nd,mptemp,nterms,nlams,nfourier,
     1                 nexptot,mexpf1,mexpf2,rlsc)

                  call ftophys(nd,mexpf1,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,5,i),fexpe,fexpo)

                  call ftophys(nd,mexpf2,nlams,rlams,nfourier,nphysical,
     1                 nthmax,gboxwexp(1,1,6,i),fexpe,fexpo)
                
                  call processgboxewexp(nd,gboxwexp(1,1,5,i),
     1                 gboxwexp(1,1,6,i),i,nexptotp,
     2                 pgboxwexp(1,1,jbox,5),
     3                 pgboxwexp(1,1,jbox,6),
     4                 xshift,yshift,zshift)
                endif
              endif
            enddo
            deallocate(gboxind,gboxsort)
            if(ifcharge.eq.1) then
              deallocate(gboxcgsort)
            endif
            if(ifdipole.eq.1) then
              deallocate(gboxdpsort)
            endif
            deallocate(gboxmexp)
            deallocate(gboxwexp)
          endif
        endif
      enddo
C$OMP END PARALLEL DO
      call cpu_time(time2)
C$    time2=omp_get_wtime()

      return
      end
c--------------------------------------------------------------------      
c--------------------------------------------------------------------   c
c
c--------------------------------------------------------------------
      subroutine l3dlist4shift(nd,mexpupphys,mexpdownphys,pgboxwexp,
     1           jbox,nexptotp,xs,ys,zs,
     2           censrc,centrg,boxsize,dirtype,cntlist4)
c--------------------------------------------------------------------
c-------------------------------------------------------------------
      implicit none
ccc   input/output variables
      integer *8 nd
      integer *8 nexptotp
      integer *8 jbox
      integer *8 cntlist4
      integer dirtype
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex pgboxwexp(nd,nexptotp,cntlist4,6)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision boxsize
      double precision censrc(3),centrg(3)
ccc   scoped function variables
      integer *8 dir
      integer *8 i,ix,iy,iz,idim
      double complex zmul
      double precision rtmp
      double precision ctmp(3)


      call getlist4pwdir(dir,censrc,centrg,boxsize)

      ctmp(1) = censrc(1) - boxsize/2.0d0
      ctmp(2) = censrc(2) - boxsize/2.0d0
      ctmp(3) = censrc(3) - boxsize/2.0d0

      if(dir.eq.1.and.dirtype.eq.1) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(iz,i)*xs(ix,i)*ys(iy,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,2)*zmul
          enddo
        enddo
      else if(dir.eq.2.and.dirtype.eq.1) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-iz,i)*xs(-ix,i)*ys(-iy,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,1)*zmul
          enddo
        enddo
      else if(dir.eq.3.and.dirtype.eq.2) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(iy,i)*xs(iz,i)*ys(ix,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,4)*zmul
          enddo
        enddo
      else if(dir.eq.4.and.dirtype.eq.2) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-iy,i)*xs(-iz,i)*ys(-ix,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,3)*zmul
          enddo
        enddo
      else if(dir.eq.5.and.dirtype.eq.3) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(ix,i)*xs(-iz,i)*ys(iy,i)
          do idim=1,nd
            mexpdownphys(idim,i) = mexpdownphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,6)*zmul
          enddo
        enddo
      else if(dir.eq.6.and.dirtype.eq.3) then
C        print *,"dir:",dir,"dirtype:",dirtype
        ix = 1.05d0*(ctmp(1)-centrg(1))/boxsize
        iy = 1.05d0*(ctmp(2)-centrg(2))/boxsize
        iz = 1.05d0*(ctmp(3)-centrg(3))/boxsize
        do i=1,nexptotp
          zmul = zs(-ix,i)*xs(iz,i)*ys(-iy,i)
          do idim=1,nd
            mexpupphys(idim,i) = mexpupphys(idim,i) + 
     1          pgboxwexp(idim,i,jbox,5)*zmul
          enddo
        enddo
      else
C        print *,"dir:",dir
      endif
       
      return
      end
c--------------------------------------------------------------------      
c
c
c--------------------------------------------------------------------
      subroutine processlist3udexplong(nd,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nuall,uall,
     3           ndall,dall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpuall,mexpdall,
     5           xs,ys,zs,fexpback,rlsc,rscpow)
c--------------------------------------------------------------------
c      process up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 idim,nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 nuall,ndall
      integer *8 uall(*),dall(*)
      double precision rscale
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)  
      double complex mexp(nd,nexptotp,nboxes,6)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpuall(nd,nexptotp),mexpdall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j
      double precision rtmp
      double complex ztmp,zmul,ztmp2
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpuall(idim,i) = 0
          mexpdall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
  
      
      do i=1,nuall
        jbox = uall(i)
C        print *,"ulist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        do j=1,nexptotp
          zmul = zs(iz,j)*xs(ix,j)*ys(iy,j)
          do idim=1,nd
            mexpdall(idim,j) = mexpdall(idim,j) + 
     1                         mexp(idim,j,jbox,2)*zmul
          enddo
        enddo
      enddo

      do i=1,ndall
        jbox = dall(i)
C        print *,"dlist j: ",jbox
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale

        do j=1,nexptotp
          zmul = zs(-iz,j)*xs(-ix,j)*ys(-iy,j)
          do idim=1,nd
            mexpuall(idim,j) = mexpuall(idim,j) + 
     1                         mexp(idim,j,jbox,1)*zmul
          enddo
        enddo
      enddo
  
C      print *,mexpuall
C      print *,mexpdall


c
cc       move contributions to the children
c

      jbox=1
c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)
          enddo
        enddo

       call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
       call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

C        print *,tloc
        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

c
c         NOTE: fix rscpow to be 1/rscpow
c
        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,1),nterms)
      endif
      
c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*xs(-1,i)
          enddo
        enddo
 
        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,2),nterms)

      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*ys(-1,i)
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1.0d0/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpuall(idim,i)*zs(1,i)
            mexpdownphys(idim,i) = mexpdall(idim,i)*rtmp
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,5),nterms)

      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)

      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,6),nterms)


      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,7),nterms)

      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)*xs(1,i)
          ztmp2 = xs(-1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpuall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpdall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call mpscale(nd,nterms,tloc,rscpow,tloc)
        call mpadd(nd,tloc,rmlexp(1,8),nterms)

      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine processlist3nsexplong(nd,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,nnall,nall,
     3           nsall,sall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpnall,mexpsall,
     5           rdplus,xs,ys,zs,fexpback,rlsc,rscpow)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 nnall,nsall
      integer *8 nall(*),sall(*)
      double precision rscale
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:)
      double complex, allocatable :: tloc2(:,:,:)
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdplus(0:nterms,0:nterms,-nterms:nterms)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nd,nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpnall(nd,nexptotp),mexpsall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,idim
      double complex ztmp,zmul,ztmp2
      double precision rtmp
    
      double precision ctmp(3)
      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpnall(idim,i) = 0
          mexpsall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
       
      do i=1,nnall
        jbox = nall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        do j=1,nexptotp
           zmul = zs(iy,j)*xs(iz,j)*ys(ix,j)
           do idim=1,nd
             mexpsall(idim,j) = mexpsall(idim,j) + 
     1                          mexp(idim,j,jbox,4)*zmul
           enddo
        enddo

      enddo

      do i=1,nsall
        jbox = sall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        do j=1,nexptotp
          zmul = zs(-iy,j)*xs(-iz,j)*ys(-ix,j)
          do idim=1,nd
            mexpnall(idim,j) = mexpnall(idim,j) + 
     1                         mexp(idim,j,jbox,3)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      jbox=1
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,1),nterms)

      endif

c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*ys(-1,i)      
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,2),nterms)


      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*zs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*rtmp
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*xs(1,i)
            mexpdownphys(idim,i) = mexpsall(idim,i)*xs(-1,i)      
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,5),nterms)

      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,6),nterms)
      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(1,i)*zs(1,i)
          ztmp2 = xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,7),nterms)
      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = ys(1,i)*zs(1,i)*xs(1,i)
          ztmp2 = ys(-1,i)*xs(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpnall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpsall(idim,i)*ztmp2      
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotytoz(nd,nterms,tloc,tloc2,rdplus)


        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,8),nterms)
      endif

      return
      end
c--------------------------------------------------------------------      

      subroutine processlist3ewexplong(nd,ibox,nboxes,centers,
     1           rscale,nterms,rmlexp,rlams,whts,nlams,nfourier,
     2           nphysical,nthmax,nexptot,nexptotp,mexp,neall,eall,
     3           nwall,wall,mexpup,mexpdown,
     4           mexpupphys,mexpdownphys,mexpeall,mexpwall,
     5           rdminus,xs,ys,zs,fexpback,rlsc,rscpow)
c--------------------------------------------------------------------
c      create up down expansions for box ibox
c-------------------------------------------------------------------
      implicit none
      integer *8 nd
      integer *8 ibox,nboxes,nterms,nlams,nthmax
      integer *8 nphysical(nlams),nfourier(nlams)
      integer *8 nexptot,nexptotp
      integer *8 neall,nwall
      integer *8 eall(*),wall(*)
      double precision rscale
      double precision rlams(*),whts(*)
      double complex, allocatable :: tloc(:,:,:),tloc2(:,:,:)
      double complex mexp(nd,nexptotp,nboxes,6)
      double precision rdminus(0:nterms,0:nterms,-nterms:nterms)
      double complex rmlexp(nd*(nterms+1)*(2*nterms+1),8)
      double precision centers(3,*)
      double complex mexpup(nd,nexptot),mexpdown(nexptot)
      double complex mexpupphys(nd,nexptotp),mexpdownphys(nd,nexptotp)
      double complex mexpeall(nd,nexptotp),mexpwall(nd,nexptotp)
      double complex xs(-5:5,nexptotp),ys(-5:5,nexptotp)
      double precision zs(5,nexptotp)
      double precision rlsc(0:nterms,0:nterms,nlams),rscpow(0:nterms)
      double complex fexpback(*)

c      temp variables
      integer *8 jbox,i,ix,iy,iz,j,l,idim
      double complex ztmp,zmul,ztmp2
      double precision rtmp
     
      double precision ctmp(3)

      allocate(tloc(nd,0:nterms,-nterms:nterms))
      allocate(tloc2(nd,0:nterms,-nterms:nterms))


      do i=1,nexptotp
        do idim=1,nd
          mexpeall(idim,i) = 0
          mexpwall(idim,i) = 0
        enddo
      enddo
      
   
      ctmp(1) = centers(1,ibox) - rscale/2.0d0
      ctmp(2) = centers(2,ibox) - rscale/2.0d0
      ctmp(3) = centers(3,ibox) - rscale/2.0d0
       
      do i=1,neall
        jbox = eall(i)
        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale
         
        do j=1,nexptotp
          zmul = zs(ix,j)*xs(-iz,j)*ys(iy,j)
          do idim=1,nd
            mexpwall(idim,j) = mexpwall(idim,j) + 
     1                         mexp(idim,j,jbox,6)*zmul
          enddo
        enddo
      enddo

      do i=1,nwall
        jbox = wall(i)

        ix = 1.05d0*(centers(1,jbox)-ctmp(1))/rscale
        iy = 1.05d0*(centers(2,jbox)-ctmp(2))/rscale
        iz = 1.05d0*(centers(3,jbox)-ctmp(3))/rscale

         
        do j=1,nexptotp
          zmul = zs(-ix,j)*xs(iz,j)*ys(-iy,j)
          do idim=1,nd
            mexpeall(idim,j) = mexpeall(idim,j) + 
     1                         mexp(idim,j,jbox,5)*zmul
          enddo
        enddo
      enddo

c
cc       move contributions to the children
c


c      add contributions due to child 1
C      jbox = ichild(1,ibox)
      jbox=1
      if(jbox.gt.0) then
        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,1),nterms)

      endif

c      add contributions due to child 2
C      jbox = ichild(2,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          rtmp = 1/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*zs(1,i)      
            mexpdownphys(idim,i) = mexpwall(idim,i)*rtmp
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)


        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)


        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,2),nterms)

      endif
  
c      add contributions due to child 3
C      jbox = ichild(3,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ys(1,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)*ys(-1,i)
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,3),nterms)

      endif

c      add contributions due to child 4
C      jbox = ichild(4,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = zs(1,i)*ys(1,i)
          ztmp2 = ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,4),nterms)

      endif

c      add contributions due to child 5
C      jbox = ichild(5,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*xs(-1,i)
            mexpdownphys(idim,i) = mexpwall(idim,i)*xs(1,i)
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,5),nterms)
      endif

c      add contributions due to child 6
C      jbox = ichild(6,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*zs(1,i)
          ztmp2 = xs(1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  =  mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,6),nterms)
      endif

c      add contributions due to child 7
C      jbox = ichild(7,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,7),nterms)

      endif

c      add contributions due to child 8
C      jbox = ichild(8,ibox)
      if(jbox.gt.0) then

        do i=1,nexptotp
          ztmp = xs(-1,i)*ys(1,i)*zs(1,i)
          ztmp2 = xs(1,i)*ys(-1,i)/zs(1,i)
          do idim=1,nd
            mexpupphys(idim,i)  = mexpeall(idim,i)*ztmp      
            mexpdownphys(idim,i) = mexpwall(idim,i)*ztmp2
          enddo
        enddo

        call phystof(nd,mexpup,nlams,nfourier,nphysical,
     1               mexpupphys,fexpback)
 
        call phystof(nd,mexpdown,nlams,nfourier,nphysical,
     1              mexpdownphys,fexpback)

        call exptolocal(nd,tloc,nterms,rlams,whts,
     1         nlams,nfourier,nthmax,nexptot,mexpup,mexpdown,
     2         rscale,rlsc)

        call rotztox(nd,nterms,tloc,tloc2,rdminus)

        call mpscale(nd,nterms,tloc2,rscpow,tloc2)
        call mpadd(nd,tloc2,rmlexp(1,8),nterms)

      endif

      return
      end
c--------------------------------------------------------------------      

c     This file contains all the relevant rotation subroutines
c     for the 3D code.
c
c  
      subroutine rotztoy(nd,nterms,mpole,mrotate,rdminus)

c     Compute multipole expansions in the new frame of
c     reference given by
c     z_new <- y_old
c     y_new <- x_old
c     x_new <- z_old
c
c     This is achieved by first rotating by -pi/2 about
c     the z-axis in the original co-ordinate system
c     followed by a rotation of -pi/2 radians about the y'
c     axis in the rotated frame of refernce
c 
c     INPUT arguments:
c     nd           in: integer *8
c                  number of expansions
c     nterms       in: integer *8
c                  number of terms in the multipole expansion
c
c     mpole        in: double complex (nd,0:nterms,-nterms:nterms)
c                  The multipole expansion to be rotated
c
c     rdminus      in: double complex (0:nterms,0:nterms,-nterms:nterms)
c                  Rotation matrix for transforming multipole
c                  expansion corresponds to a rotation of -pi/2
c                  about the y axis
c
c     OUTPUT
c     mrotate      out: double complex (nd,0:nterms,-nterms:nterms)
c                  rotated multipole expansion  
c                   
      implicit none
      integer *8 nterms,nd
      double precision rdminus(0:nterms,0:nterms,-nterms:nterms),rr
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex, allocatable :: mptemp(:,:,:)
      double complex mrotate(nd,0:nterms,-nterms:nterms)
      double complex ephi(-nterms:nterms), eyem, eye
      integer *8 idim
      integer *8 l,m,mp

      allocate(mptemp(nd,0:nterms,-nterms:nterms))
      call mpzero(nd,mrotate,nterms) 

c     First rotate by -pi/2 radians about the z axis 
c     in the original coordinate system
      ephi(0) = 1.0d0
      eyem = dcmplx(0.0d0,-1.0d0)
      eye = dcmplx(0.0d0,1.0d0)
      do m=1,nterms
         ephi(m) = ephi(m-1)*eyem
         ephi(-m) = ephi(-m+1)*eye
      enddo

      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               mptemp(idim,l,m) = ephi(m)*mpole(idim,l,m)
            enddo
         enddo
      enddo

c     Now rotate by -pi/2 radians about the y' axis in
c     the new co-ordinate system

      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               mrotate(idim,l,m) = 0.0d0
            enddo
            do mp=-l,l
               if(mp.ge.0) then
                  do idim=1,nd
                     mrotate(idim,l,m) = mrotate(idim,l,m) +
     1               mptemp(idim,l,mp)*rdminus(l,mp,m)
                  enddo
               else
                  do idim=1,nd
                     mrotate(idim,l,m) = mrotate(idim,l,m) +
     1               mptemp(idim,l,mp)*rdminus(l,-mp,-m)
                  enddo
               endif
            enddo
         enddo
      enddo

      return
      end
c---------------------------------------------------------------  
      subroutine rotytoz(nd,nterms,mpole,mrotate,rdplus)

c     Compute multipole expansions in the new frame of
c     reference given by
c
c     This is achieved by first rotating by pi/2 about
c     the y'-axis in the rotated co-ordinate system
c     followed by a rotation of pi/2 radians about the z
c     axis to bring back to original frame of reference
c 
c     INPUT arguments:
c     nd           in: integer *8
c                  number of expansions
c     nterms       in: integer *8
c                  number of terms in the multipole expansion
c
c     mpole        in: double complex (nd,0:nterms,-nterms:nterms)
c                  The multipole expansion to be rotated
c
c     rdplus       in: double complex (0:nterms,0:nterms,-nterms:nterms)
c                  Rotation matrix for transforming multipole
c                  expansion corresponds to a rotation of -pi/2
c                  about the y axis
c
c     OUTPUT
c     mrotate      out: double complex (nd,0:nterms,-nterms:nterms)
c                  rotated multipole expansion  
c                   
      implicit none
      integer *8 nterms,nd
      double precision rdplus(0:nterms,0:nterms,-nterms:nterms)
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex, allocatable :: mptemp(:,:,:)
      double complex mrotate(nd,0:nterms,-nterms:nterms)
      double complex ephi(-nterms:nterms), eyem, eye
      integer *8 l,m,mp,idim

      allocate(mptemp(nd,0:nterms,-nterms:nterms))

c     Now rotate by pi/2 radians about the y' axis in
c     the new co-ordinate system

      call mpzero(nd,mrotate,nterms) 
      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               mptemp(idim,l,m) = 0.0d0
            enddo
            do mp=-l,l
               if(mp.ge.0) then
                  do idim=1,nd
                     mptemp(idim,l,m) = mptemp(idim,l,m) +
     1               mpole(idim,l,mp)*rdplus(l,mp,m)
                  enddo
               else
                  do idim=1,nd
                     mptemp(idim,l,m) = mptemp(idim,l,m) +
     1              mpole(idim,l,mp)*rdplus(l,-mp,-m)
                  enddo
               endif
            enddo
         enddo
      enddo
c     First rotate by pi/2 radians about the z axis 
c     in the original coordinate system
      ephi(0) = 1.0d0
      eyem = dcmplx(0.0d0,-1.0d0)
      eye = dcmplx(0.0d0,1.0d0)
      do m=1,nterms
         ephi(m) = ephi(m-1)*eye
         ephi(-m) = ephi(-m+1)*eyem
      enddo

      do l=0,nterms
         do m=-l,l
            do idim=1,nd
               mrotate(idim,l,m) = ephi(m)*mptemp(idim,l,m)
            enddo
         enddo
      enddo

      return
      end
c--------------------------------------------------------      
      subroutine rotztox(nd,nterms,mpole,mrotate,rdplus)

c     Compute multipole expansions in the new frame of
c     reference given by
c     z_new <- x_old
c     y_new <- y_old
c     -x_new <- z_old
c
c     This is achieved by first rotating by pi/2 about
c     the y-axis in the original co-ordinate system
c 
c     INPUT arguments:
c     nd           in: integer *8
c                  number of expansions
c
c     nterms       in: integer *8
c                  number of terms in the multipole expansion
c
c     mpole        in: double complex (nd,0:nterms,-nterms:nterms)
c                  The multipole expansion to be rotated
c
c     rdplus       in: double complex (0:nterms,0:nterms,-nterms:nterms)
c                  Rotation matrix for transforming multipole
c                  expansion corresponds to a rotation of pi/2
c                  about the y axis
c
c     OUTPUT
c     mrotate      out: double complex (nd,0:nterms,-nterms:nterms)
c                  rotated multipole expansion  
c                   
      implicit none
      integer *8 nterms,nd
      double precision rdplus(0:nterms,0:nterms,-nterms:nterms)
      double complex mpole(nd,0:nterms,-nterms:nterms)
      double complex mrotate(nd,0:nterms,-nterms:nterms)
      integer *8 l,m,mp,idim

c     rotate by pi/2 radians about the y' axis in
c     the new co-ordinate system

      call mpzero(nd,mrotate,nterms) 
      do l=0,nterms
         do m=-l,l
            do idim=1,nd
              mrotate(idim,l,m) = 0.0d0
            enddo
            do mp=-l,l
               if(mp.ge.0) then
                  do idim=1,nd
                     mrotate(idim,l,m) = mrotate(idim,l,m) +
     1               mpole(idim,l,mp)*rdplus(l,mp,m)
                  enddo
               else
                  do idim=1,nd
                    mrotate(idim,l,m) = mrotate(idim,l,m) +
     1               mpole(idim,l,mp)*rdplus(l,-mp,-m)
                  enddo
               endif
            enddo
         enddo
      enddo

      return
      end

c
       subroutine lfmm3d_ndiv(nd,eps,nsource,source,ifcharge,
     $    charge,ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,
     $    targ,ifpghtarg,pottarg,gradtarg,hesstarg,ndiv,idivflag,
     $    ifnear,timeinfo,ier)
c
c        Laplace FMM in R^{3}: evaluate all pairwise particle
c        interactions (ignoring self-interactions) and interactions
c        with targs.
c
c        We use 1/(4\pi)*(1/r) for the Green's function.
c
c
c        Input parameters:
c
c   nd:   number of densities
c
c   eps:  requested precision
c
c   nsource in: integer *8  
c                number of sources
c
c   source  in: double precision (3,nsource)
c                source(k,j) is the kth component of the jth
c                source locations
c
c   ifcharge  in: integer *8  
c             charge computation flag
c              ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c 
c   charge    in: double precision (nsource) 
c              charge strengths
c
c   ifdipole   in: integer *8
c              dipole computation flag
c              ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c
c
c   dipvec   in: double precision (3,nsource) 
c              dipole orientation vectors
c   iper    in: integer *8
c             flag for periodic implmentations. Currently unused
c   ifpgh   in: integer *8
c              flag for evaluating potential/gradient at the sources
c              ifpgh = 1, only potential is evaluated
c              ifpgh = 2, potential and gradients are evaluated
c
c   ntarg  in: integer *8  
c                 number of targs 
c
c   targ  in: double precision (3,ntarg)
c               targ(k,j) is the kth component of the jth
c               targ location
c
c   ifpghtarg   in: integer *8
c              flag for evaluating potential/gradient at the targs
c              ifpghtarg = 1, only potential is evaluated
c              ifpghtarg = 2, potential and gradient are evaluated
c
c
c     OUTPUT parameters:
c
c
c   pot:    out: double precision(nd,nsource) 
c               potential at the source locations
c
c   grad:   out: double precision(nd,3,nsource)
c               gradient at the source locations
c
c   hess    out: double precision(nd,6,nsource)
c               hessian at the source locations
c                 (currently not supported)
c
c   pottarg:    out: double precision(nd,ntarg) 
c               potential at the targ locations
c
c   gradtarg:   out: double precision(nd,3,ntarg)
c               gradient at the targ locations
c
c   hesstarg    out: double precision(nd,6,ntarg)
c                hessian at the target locations - currently not
c                supported
c   ier         out: integer *8
c                error flag
c                ier = 0, for successful execution
c                ier = 4, if failed to allocate workspace
c                      for multipole and local expansions
c                ier = 8, if failed to allocate workspace
c                      for plane wave expansions
c     
     
     
       implicit none

       integer *8 nd
       integer *8 ier,iper

       double precision eps

       integer *8 ifcharge,ifdipole
       integer *8 ifpgh,ifpghtarg

       integer *8 ntarg,nsource
       

       double precision source(3,*),targ(3,*)
       double precision charge(nd,*)
       double precision dipvec(nd,3,*)

       double precision pot(nd,*),grad(nd,3,*),hess(nd,6,*)
       double precision pottarg(nd,*),gradtarg(nd,3,*),hesstarg(nd,6,*)

       double precision timeinfo(6)

c
cc       tree variables
c
       integer *8 idivflag,ndiv,nboxes,nlevels
       integer *8 nlmax
       integer *8 ipointer(8),ltree
       integer *8 ifunif,nlmin
       integer *8, allocatable :: itree(:)
       integer *8, allocatable :: isrcse(:,:),itargse(:,:),isrc(:)
       integer *8, allocatable :: itarg(:)
       integer *8, allocatable :: iexpcse(:,:)
       integer *8 iexpc
       double precision, allocatable :: treecenters(:,:),boxsize(:)
       double precision b0,b0inv,b0inv2,b0inv3

c
cc       temporary sorted arrays
c
       double precision, allocatable :: sourcesort(:,:),targsort(:,:)
       double precision, allocatable :: radsrc(:)
       double precision, allocatable :: chargesort(:,:)
       double precision, allocatable :: dipvecsort(:,:,:)

       double precision, allocatable :: potsort(:,:),gradsort(:,:,:)
       double precision, allocatable :: hesssort(:,:,:)
       double precision, allocatable :: pottargsort(:,:)
       double precision, allocatable :: gradtargsort(:,:,:)
       double precision, allocatable :: hesstargsort(:,:,:)
c
cc        temporary fmm arrays
c
       integer *8, allocatable :: nterms(:)
       integer *8, allocatable :: iaddr(:,:)
       double precision, allocatable :: scales(:)
       double precision, allocatable :: rmlexp(:)

       integer *8 lmptemp,nmax
       integer *8 lmptot
       double precision, allocatable :: mptemp(:),mptemp2(:)

c
cc       temporary variables not main fmm routine but
c        not used in particle code
       double precision expc(3),scjsort(1),radexp
       double complex texpssort(100)
       double precision expcsort(3)
       integer *8 ntj,nexpc,nadd,ifnear

c
cc         other temporary variables
c
        integer *8 i,iert,ifprint,ilev,idim
        double precision time1,time2,omp_get_wtime,second

c
c
c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c       
      ifprint=0

       nexpc = 0
       nadd = 0
       ntj = 0


c
cc      set tree flags
c 
       nlmax = 51
       nlevels = 0
       nboxes = 0
       ltree = 0
       nlmin = 0
       ifunif = 0
       iper = 0

c
cc     memory management code for contructing level restricted tree
      call pts_tree_mem(source,nsource,targ,ntarg,idivflag,ndiv,
     1  nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree)


        if(ifprint.ge.1) print *, ltree/1.0d9

        allocate(itree(ltree))
        allocate(boxsize(0:nlevels))
        allocate(treecenters(3,nboxes))

c       Call tree code
      call pts_tree_build(source,nsource,targ,ntarg,idivflag,ndiv,
     1  nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree,itree,ipointer,
     2  treecenters,boxsize)
      

      allocate(isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes))
      allocate(isrc(nsource),itarg(ntarg))

      call pts_tree_sort(nsource,source,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,isrc,isrcse)
      
      call pts_tree_sort(ntarg,targ,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,itarg,itargse)
      
      call pts_tree_sort(nexpc,expc,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,iexpc,iexpcse)

c
c   End of tree build
c

c
c  Set rescaling parameters
c
      b0 = boxsize(0)
      b0inv = 1.0d0/b0
      b0inv2 = b0inv**2
      b0inv3 = b0inv2*b0inv

c     Allocate sorted source and targ arrays      

      allocate(sourcesort(3,nsource))
      allocate(targsort(3,ntarg))
      if(ifcharge.eq.1) allocate(chargesort(nd,nsource))

      if(ifdipole.eq.1) then
         allocate(dipvecsort(nd,3,nsource))
      endif

      if(ifpgh.eq.1) then 
        allocate(potsort(nd,nsource),gradsort(nd,3,1),hesssort(nd,6,1))
      else if(ifpgh.eq.2) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,1))
      else if(ifpgh.eq.3) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,nsource))
      else
        allocate(potsort(nd,1),gradsort(nd,3,1),hesssort(nd,6,1))
      endif

      if(ifpghtarg.eq.1) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,1),
     1      hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.2) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.3) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,ntarg))
      else
        allocate(pottargsort(nd,1),gradtargsort(nd,3,1),
     1     hesstargsort(nd,6,1))
      endif


c
cc      initialize potential and gradient at source
c       locations
c
      if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)

        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif


      if(ifpgh.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
            hesssort(idim,1,i) = 0
            hesssort(idim,2,i) = 0
            hesssort(idim,3,i) = 0
            hesssort(idim,4,i) = 0
            hesssort(idim,5,i) = 0
            hesssort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif



c
cc       initialize potential and gradient  at targ
c        locations
c
      if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
            hesstargsort(idim,1,i) = 0
            hesstargsort(idim,2,i) = 0
            hesstargsort(idim,3,i) = 0
            hesstargsort(idim,4,i) = 0
            hesstargsort(idim,5,i) = 0
            hesstargsort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      allocate(nterms(0:nlevels))

c     Compute length of expansions at each level      
      nmax = 0
      do i=0,nlevels
         call l3dterms(eps,nterms(i))
         if(nterms(i).gt.nmax) nmax = nterms(i)
      enddo
c       
c     Multipole and local expansions will be held in workspace
c     in locations pointed to by array iaddr(2,nboxes).
c
c     iaddr is pointer to iaddr array, itself contained in workspace.
c     imptemp is pointer for single expansion (dimensioned by nmax)
c
c       ... allocate iaddr and temporary arrays
c

      allocate(iaddr(2,nboxes))
      lmptemp = (nmax+1)*(2*nmax+1)*2*nd
      allocate(mptemp(lmptemp),mptemp2(lmptemp))

c
cc     reorder sources 
c
      call dreorderf(int8(3),nsource,source,sourcesort,isrc)

c
c       rescale sources to be contained in unit box
c
      call drescale(3*nsource,sourcesort,b0inv)

      if(ifcharge.eq.1) then
        call dreorderf(nd,nsource,charge,chargesort,
     1                     isrc)
        call drescale(nd*nsource,chargesort,b0inv)
      endif


      if(ifdipole.eq.1) then
         call dreorderf(3*nd,nsource,dipvec,dipvecsort,
     1       isrc)
         call drescale(3*nd*nsource,dipvecsort,b0inv2)
      endif

c
cc      reorder and rescale targs
c
      call dreorderf(int8(3),ntarg,targ,targsort,itarg)
      call drescale(3*ntarg,targsort,b0inv)


c
c        update tree centers and boxsize
c
      call drescale(3*nboxes,treecenters,b0inv)
      call drescale(nlevels+1,boxsize,b0inv)

c
c     allocate memory need by multipole, local expansions at all
c     levels
c     irmlexp is pointer for workspace need by various fmm routines,
c
      call mpalloc(nd,itree(ipointer(1)),iaddr,nlevels,lmptot,nterms)
      if(ifprint.ge. 1) print *, "lmptot =",lmptot/1.0d9


      allocate(rmlexp(lmptot),stat=ier)
      ier = 0
      if(ier.ne.0) then
         print *, "Cannot allocate mpole expansion workspace"
         print *, "lmptot=", lmptot
         ier = 4
         return
      endif

c     Memory allocation is complete. 
c     scaling factor for multipole and local expansions at all levels
c
      allocate(scales(0:nlevels))
      do ilev = 0,nlevels
        scales(ilev) = boxsize(ilev)
      enddo

c     Call main fmm routine

      call cpu_time(time1)
C$      time1=omp_get_wtime()
      call lfmm3dmain(nd,eps,
     $   nsource,sourcesort,
     $   ifcharge,chargesort,
     $   ifdipole,dipvecsort,
     $   ntarg,targsort,nexpc,expcsort,
     $   iaddr,rmlexp,lmptot,mptemp,mptemp2,lmptemp,
     $   itree,ltree,ipointer,ndiv,nlevels,
     $   nboxes,iper,boxsize,treecenters,isrcse,itargse,iexpcse,
     $   scales,itree(ipointer(1)),nterms,
     $   ifpgh,potsort,gradsort,hesssort,
     $   ifpghtarg,pottargsort,gradtargsort,hesstargsort,ntj,
     $   texpssort,scjsort,ifnear,timeinfo,ier)

      call cpu_time(time2)
C$        time2=omp_get_wtime()
      if( ifprint .eq. 1 ) call prin2('time in fmm main=*',
     1   time2-time1,1)



      if(ifpgh.ge.1) then
        call dreorderi(nd,nsource,potsort,pot,isrc)
      endif
      if(ifpgh.ge.2) then 
        call dreorderi(3*nd,nsource,gradsort,grad,isrc)
        call drescale(nd*3*nsource,grad,b0inv)
      endif

      if(ifpgh.ge.3) then 
        call dreorderi(6*nd,nsource,hesssort,hess,isrc)
        call drescale(nd*6*nsource,hess,b0inv2)
      endif


      if(ifpghtarg.ge.1) then
        call dreorderi(nd,ntarg,pottargsort,pottarg,itarg)
      endif

      if(ifpghtarg.ge.2) then
        call dreorderi(3*nd,ntarg,gradtargsort,gradtarg,itarg)
        call drescale(nd*3*ntarg,gradtarg,b0inv)
      endif

      if(ifpghtarg.ge.3) then
        call dreorderi(6*nd,ntarg,hesstargsort,hesstarg,itarg)
        call drescale(nd*6*ntarg,hesstarg,b0inv2)
      endif

      return
      end

c       
c---------------------------------------------------------------

c
       subroutine lfmm3d(nd,eps,nsource,source,ifcharge,
     $    charge,ifdipole,dipvec,iper,ifpgh,pot,grad,hess,ntarg,
     $    targ,ifpghtarg,pottarg,gradtarg,hesstarg,ier)
c
c        Laplace FMM in R^{3}: evaluate all pairwise particle
c        interactions (ignoring self-interactions) and interactions
c        with targs.
c
c        We use 1/(4\pi)*(1/r) for the Green's function.
c
c
c        Input parameters:
c
c   nd:   number of densities
c
c   eps:  requested precision
c
c   nsource in: integer *8  
c                number of sources
c
c   source  in: double precision (3,nsource)
c                source(k,j) is the kth component of the jth
c                source locations
c
c   ifcharge  in: integer *8  
c             charge computation flag
c              ifcharge = 1   =>  include charge contribution
c                                     otherwise do not
c 
c   charge    in: double precision (nsource) 
c              charge strengths
c
c   ifdipole   in: integer *8
c              dipole computation flag
c              ifdipole = 1   =>  include dipole contribution
c                                     otherwise do not
c
c
c   dipvec   in: double precision (3,nsource) 
c              dipole orientation vectors
c   iper    in: integer *8
c             flag for periodic implmentations. Currently unused
c
c   ifpgh   in: integer *8
c              flag for evaluating potential/gradient at the sources
c              ifpgh = 1, only potential is evaluated
c              ifpgh = 2, potential and gradients are evaluated
c              ifpgh = 3, potential, gradients, and hessian are
c                 evaluated
c
c   ntarg  in: integer *8  
c                 number of targs 
c
c   targ  in: double precision (3,ntarg)
c               targ(k,j) is the kth component of the jth
c               targ location
c
c   ifpghtarg   in: integer *8
c              flag for evaluating potential/gradient at the targs
c              ifpghtarg = 1, only potential is evaluated
c              ifpghtarg = 2, potential and gradient are evaluated
c              ifpghtarg = 3, potential, gradient, and hess are
c                  evaluated
c
c
c     OUTPUT parameters:
c
c
c   pot:    out: double precision(nd,nsource) 
c               potential at the source locations
c
c   grad:   out: double precision(nd,3,nsource)
c               gradient at the source locations
c
c   hess    out: double precision(nd,6,nsource)
c               hessian at the source locations
c
c   pottarg:    out: double precision(nd,ntarg) 
c               potential at the targ locations
c
c   gradtarg:   out: double precision(nd,3,ntarg)
c               gradient at the targ locations
c
c   hesstarg    out: double precision(nd,6,ntarg)
c                hessian at the target locations 
c   ier         out: integer *8
c                error flag
c                ier = 0, for successful execution
c                ier = 4, if failed to allocate workspace
c                      for multipole and local expansions
c                ier = 8, if failed to allocate workspace
c                      for plane wave expansions
c     
c     
       implicit none

       integer *8 nd,ier,iper,ndim

       double precision eps

       integer *8 ifcharge,ifdipole
       integer *8 ifpgh,ifpghtarg

       integer *8 ntarg,nsource
       

       double precision source(3,*),targ(3,*)
       double precision charge(nd,*)
       double precision dipvec(nd,3,*)

       double precision pot(nd,*),grad(nd,3,*),hess(nd,6,*)
       double precision pottarg(nd,*),gradtarg(nd,3,*),hesstarg(nd,6,*)

       double precision timeinfo(6)

c
cc       tree variables
c
       integer *8 idivflag,ndiv,nboxes,nlevels
       integer *8 nlmax,nlmin,ifunif
       integer *8 ipointer(8),ltree
       integer *8, allocatable :: itree(:)
       integer *8, allocatable :: isrcse(:,:),itargse(:,:),isrc(:)
       integer *8, allocatable :: itarg(:)
       integer *8, allocatable :: iexpcse(:,:)
       integer *8 iexpc
       double precision, allocatable :: treecenters(:,:),boxsize(:)
       double precision b0,b0inv,b0inv2,b0inv3

c
cc       temporary sorted arrays
c
       double precision, allocatable :: sourcesort(:,:),targsort(:,:)
       double precision, allocatable :: radsrc(:)
       double precision, allocatable :: chargesort(:,:)
       double precision, allocatable :: dipvecsort(:,:,:)

       double precision, allocatable :: potsort(:,:),gradsort(:,:,:)
       double precision, allocatable :: hesssort(:,:,:)
       double precision, allocatable :: pottargsort(:,:)
       double precision, allocatable :: gradtargsort(:,:,:)
       double precision, allocatable :: hesstargsort(:,:,:)
c
cc        temporary fmm arrays
c
       integer *8, allocatable :: nterms(:)
       integer *8, allocatable :: iaddr(:,:)
       double precision, allocatable :: scales(:)
       double precision, allocatable :: rmlexp(:)

       integer *8 lmptemp,nmax
       integer *8 lmptot
       double precision, allocatable :: mptemp(:),mptemp2(:)

c
cc       temporary variables not main fmm routine but
c        not used in particle code
       double precision expc(3),scjsort(1),radexp
       double complex texpssort(100)
       double precision expcsort(3)
       integer *8 ntj,nexpc,nadd,ifnear

c
cc         other temporary variables
c
        integer *8 i,iert,ifprint,ilev,idim
        double precision time1,time2,omp_get_wtime,second

c
c
c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c      

      call cpu_time(time1)
C$     time1=omp_get_wtime()      
      ifprint=0

c
cc        figure out tree structure
c
c
cc         set criterion for box subdivision
c
      call lndiv(eps,nsource,ntarg,ifcharge,ifdipole,ifpgh,
     1   ifpghtarg,ndiv,idivflag) 


c
c       turn on computation of list 1
c
      ifnear = 1


       nexpc = 0
       nadd = 0
       ntj = 0
       ndim = 3


c
cc      set tree flags
c 
       nlmax = 51
       nlevels = 0
       nboxes = 0
       ltree = 0
       nlmin = 0
       iper = 0
       ifunif = 0

c
cc     memory management code for contructing level restricted tree
      call pts_tree_mem(source,nsource,targ,ntarg,idivflag,ndiv,nlmin,
     1  nlmax,iper,ifunif,nlevels,nboxes,ltree)
      

        if(ifprint.ge.1) print *, ltree/1.0d9

        allocate(itree(ltree))
        allocate(boxsize(0:nlevels))
        allocate(treecenters(3,nboxes))

c       Call tree code
      call pts_tree_build(source,nsource,targ,ntarg,idivflag,ndiv,
     1  nlmin,nlmax,iper,ifunif,nlevels,nboxes,ltree,itree,ipointer,
     2  treecenters,boxsize)
      

      allocate(isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes))
      allocate(isrc(nsource),itarg(ntarg))

      call pts_tree_sort(nsource,source,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,isrc,isrcse)
      
      call pts_tree_sort(ntarg,targ,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,itarg,itargse)
      
      call pts_tree_sort(nexpc,expc,itree,ltree,nboxes,nlevels,
     1   ipointer,treecenters,iexpc,iexpcse)

c
c   End of tree build
c

c
c  Set rescaling parameters
c
      b0 = boxsize(0)
      b0inv = 1.0d0/b0
      b0inv2 = b0inv**2
      b0inv3 = b0inv2*b0inv

c     Allocate sorted source and targ arrays      

      allocate(sourcesort(3,nsource))
      allocate(targsort(3,ntarg))
      if(ifcharge.eq.1) allocate(chargesort(nd,nsource))

      if(ifdipole.eq.1) then
         allocate(dipvecsort(nd,3,nsource))
      endif

      if(ifpgh.eq.1) then 
        allocate(potsort(nd,nsource),gradsort(nd,3,1),hesssort(nd,6,1))
      else if(ifpgh.eq.2) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,1))
      else if(ifpgh.eq.3) then
        allocate(potsort(nd,nsource),gradsort(nd,3,nsource),
     1       hesssort(nd,6,nsource))
      else
        allocate(potsort(nd,1),gradsort(nd,3,1),hesssort(nd,6,1))
      endif

      if(ifpghtarg.eq.1) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,1),
     1      hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.2) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,1))
      else if(ifpghtarg.eq.3) then
        allocate(pottargsort(nd,ntarg),gradtargsort(nd,3,ntarg),
     1        hesstargsort(nd,6,ntarg))
      else
        allocate(pottargsort(nd,1),gradtargsort(nd,3,1),
     1     hesstargsort(nd,6,1))
      endif


c
cc      initialize potential and gradient at source
c       locations
c
      if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)

        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif


      if(ifpgh.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,nsource
          do idim=1,nd
            potsort(idim,i) = 0
            gradsort(idim,1,i) = 0
            gradsort(idim,2,i) = 0
            gradsort(idim,3,i) = 0
            hesssort(idim,1,i) = 0
            hesssort(idim,2,i) = 0
            hesssort(idim,3,i) = 0
            hesssort(idim,4,i) = 0
            hesssort(idim,5,i) = 0
            hesssort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif



c
cc       initialize potential and gradient  at targ
c        locations
c
      if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      if(ifpghtarg.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,idim)
        do i=1,ntarg
          do idim=1,nd
            pottargsort(idim,i) = 0
            gradtargsort(idim,1,i) = 0
            gradtargsort(idim,2,i) = 0
            gradtargsort(idim,3,i) = 0
            hesstargsort(idim,1,i) = 0
            hesstargsort(idim,2,i) = 0
            hesstargsort(idim,3,i) = 0
            hesstargsort(idim,4,i) = 0
            hesstargsort(idim,5,i) = 0
            hesstargsort(idim,6,i) = 0
          enddo
        enddo
C$OMP END PARALLEL DO
      endif

      allocate(nterms(0:nlevels))

c     Compute length of expansions at each level      
      nmax = 0
      do i=0,nlevels
         call l3dterms(eps,nterms(i))
         if(nterms(i).gt.nmax) nmax = nterms(i)
      enddo
c       
c     Multipole and local expansions will be held in workspace
c     in locations pointed to by array iaddr(2,nboxes).
c
c     iaddr is pointer to iaddr array, itself contained in workspace.
c     imptemp is pointer for single expansion (dimensioned by nmax)
c
c       ... allocate iaddr and temporary arrays
c

      allocate(iaddr(2,nboxes))
      lmptemp = (nmax+1)*(2*nmax+1)*2*nd
      allocate(mptemp(lmptemp),mptemp2(lmptemp))

c
cc     reorder sources 
c
      call dreorderf(ndim,nsource,source,sourcesort,isrc)

c
c       rescale sources to be contained in unit box
c
      call drescale(3*nsource,sourcesort,b0inv)

      if(ifcharge.eq.1) then
        call dreorderf(nd,nsource,charge,chargesort,
     1                     isrc)
        call drescale(nd*nsource,chargesort,b0inv)
      endif


      if(ifdipole.eq.1) then
         call dreorderf(3*nd,nsource,dipvec,dipvecsort,
     1       isrc)
         call drescale(3*nd*nsource,dipvecsort,b0inv2)
      endif

c
cc      reorder and rescale targs
c
      call dreorderf(ndim,ntarg,targ,targsort,itarg)
      call drescale(3*ntarg,targsort,b0inv)


c
c        update tree centers and boxsize
c
      call drescale(3*nboxes,treecenters,b0inv)
      call drescale(nlevels+1,boxsize,b0inv)

c
c     allocate memory need by multipole, local expansions at all
c     levels
c     irmlexp is pointer for workspace need by various fmm routines,
c
      call mpalloc(nd,itree(ipointer(1)),iaddr,nlevels,lmptot,nterms)
      if(ifprint.ge. 1) print *, "lmptot =",lmptot/1.0d9


      allocate(rmlexp(lmptot),stat=iert)
      if(iert.ne.0) then
         print *, "Cannot allocate mpole expansion workspace"
         print *, "lmptot=", lmptot
         ier = 4
         return
      endif

c     Memory allocation is complete. 
c     scaling factor for multipole and local expansions at all levels
c
      allocate(scales(0:nlevels))
      do ilev = 0,nlevels
        scales(ilev) = boxsize(ilev)
      enddo

      call cpu_time(time2)
C$     time2=omp_get_wtime()      

      if(ifprint.ge.1) 
     1   call prin2('time before fmm main=*',time2-time1,1)
c     Call main fmm routine

      call cpu_time(time1)
C$      time1=omp_get_wtime()
      call lfmm3dmain(nd,eps,
     $   nsource,sourcesort,
     $   ifcharge,chargesort,
     $   ifdipole,dipvecsort,
     $   ntarg,targsort,nexpc,expcsort,
     $   iaddr,rmlexp,lmptot,mptemp,mptemp2,lmptemp,
     $   itree,ltree,ipointer,ndiv,nlevels,
     $   nboxes,iper,boxsize,treecenters,isrcse,itargse,iexpcse,
     $   scales,itree(ipointer(1)),nterms,
     $   ifpgh,potsort,gradsort,hesssort,
     $   ifpghtarg,pottargsort,gradtargsort,hesstargsort,ntj,
     $   texpssort,scjsort,ifnear,timeinfo,ier)
      if(ier.ne.0) return

      call cpu_time(time2)
C$        time2=omp_get_wtime()
      if( ifprint .eq. 1 ) call prin2('time in fmm main=*',
     1   time2-time1,1)



      if(ifpgh.ge.1) then
        call dreorderi(nd,nsource,potsort,pot,isrc)
      endif
      if(ifpgh.ge.2) then 
        call dreorderi(3*nd,nsource,gradsort,grad,isrc)
        call drescale(nd*3*nsource,grad,b0inv)
      endif

      if(ifpgh.ge.3) then 
        call dreorderi(6*nd,nsource,hesssort,hess,isrc)
        call drescale(nd*6*nsource,hess,b0inv2)
      endif


      if(ifpghtarg.ge.1) then
        call dreorderi(nd,ntarg,pottargsort,pottarg,itarg)
      endif

      if(ifpghtarg.ge.2) then
        call dreorderi(3*nd,ntarg,gradtargsort,gradtarg,itarg)
        call drescale(nd*3*ntarg,gradtarg,b0inv)
      endif

      if(ifpghtarg.ge.3) then
        call dreorderi(6*nd,ntarg,hesstargsort,hesstarg,itarg)
        call drescale(nd*6*ntarg,hesstarg,b0inv2)
      endif

      return
      end

c       
c---------------------------------------------------------------
c
      subroutine lfmm3dmain(nd,eps,
     $     nsource,sourcesort,
     $     ifcharge,chargesort,
     $     ifdipole,dipvecsort,
     $     ntarg,targsort,nexpc,expcsort,
     $     iaddr,rmlexp,lmptot,mptemp,mptemp2,lmptemp,
     $     itree,ltree,ipointer,ndiv,nlevels, 
     $     nboxes,iper,boxsize,centers,isrcse,itargse,iexpcse,
     $     rscales,laddr,nterms,
     $     ifpgh,pot,grad,hess,
     $     ifpghtarg,pottarg,gradtarg,hesstarg,ntj,
     $     tsort,scjsort,ifnear,timeinfo,ier)
      implicit none

      integer *8 nd,ndim
      integer *8 ier
      double precision eps
      integer *8 nsource,ntarg,nexpc
      integer *8 ndiv,nlevels

      integer *8 ifcharge,ifdipole
      integer *8 ifpgh,ifpghtarg

      double precision sourcesort(3,nsource)

      double precision chargesort(nd,*)
      double precision dipvecsort(nd,3,*)

      double precision targsort(3,ntarg)

      double precision pot(nd,*),grad(nd,3,*),hess(nd,6,*)
      double precision pottarg(nd,*),gradtarg(nd,3,*),hesstarg(nd,6,*)

      integer *8 ntj
      integer *8 ifnear
      double precision expcsort(3,nexpc)
      double complex tsort(nd,0:ntj,-ntj:ntj,nexpc)
      double precision scjsort(nexpc)

      integer *8 nboxes
      integer *8 iaddr(2,nboxes), lmptot
      integer *8 lmptemp
      double precision rmlexp(lmptot)
      double precision mptemp(lmptemp)
      double precision mptemp2(lmptemp)

      double precision thresh
       
      double precision timeinfo(6)
      double precision centers(3,nboxes)

      integer *8 isep,iper
      integer *8 laddr(2,0:nlevels)
      integer *8 nterms(0:nlevels)
      integer *8 ipointer(8),ltree
      integer *8 itree(ltree)
      double precision rscales(0:nlevels)
      double precision boxsize(0:nlevels)
      integer *8 isrcse(2,nboxes),itargse(2,nboxes),iexpcse(2,nboxes)
      integer *8, allocatable :: nlist1(:),list1(:,:)
      integer *8, allocatable :: nlist2(:),list2(:,:)
      integer *8, allocatable :: nlist3(:),list3(:,:)
      integer *8, allocatable :: nlist4(:),list4(:,:)

      integer *8 nuall,ndall,nnall,nsall,neall,nwall
      integer *8 nu1234,nd5678,nn1256,ns3478,ne1357,nw2468
      integer *8 nn12,nn56,ns34,ns78,ne13,ne57,nw24,nw68
      integer *8 ne1,ne3,ne5,ne7,nw2,nw4,nw6,nw8

      integer *8, allocatable :: uall(:,:),dall(:,:),nall(:,:)
      integer *8, allocatable :: sall(:,:),eall(:,:),wall(:,:)
      integer *8, allocatable :: u1234(:,:),d5678(:,:)
      integer *8, allocatable :: n1256(:,:),s3478(:,:)
      integer *8, allocatable :: e1357(:,:),w2468(:,:)
      integer *8, allocatable :: n12(:,:),n56(:,:),s34(:,:),s78(:,:)
      integer *8, allocatable :: e13(:,:),e57(:,:),w24(:,:),w68(:,:)
      integer *8, allocatable :: e1(:,:),e3(:,:),e5(:,:),e7(:,:)
      integer *8, allocatable :: w2(:,:),w4(:,:),w6(:,:),w8(:,:)

c     temp variables
      integer *8 i,j,k,l,ii,jj,kk,ll,m,idim,igbox
      integer *8 ibox,jbox,ilev,npts,npts0,kbox,dir
      integer *8 nchild

      integer *8 istart,iend,istarts,iends
      integer *8 istartt,iendt,istarte,iende
      integer *8 isstart,isend,jsstart,jsend
      integer *8 jstart,jend

      integer *8 ifprint

      double precision d,time1,time2,second,omp_get_wtime
      double precision pottmp,fldtmp(3),hesstmp(3)

c     PW variables
      integer *8 nexpmax, nlams, nmax, nthmax, nphmax,nmax2,nmaxt
      integer *8 lca
      double precision, allocatable :: carray(:,:), dc(:,:)
      double precision, allocatable :: cs(:,:),fact(:),rdplus(:,:,:)
      double precision, allocatable :: rdminus(:,:,:), rdsq3(:,:,:)
      double precision, allocatable :: rdmsq3(:,:,:)
  
      double precision, allocatable :: rlams(:),whts(:)

      double precision, allocatable :: rlsc(:,:,:)
      integer *8, allocatable :: nfourier(:), nphysical(:)
      integer *8 nexptot, nexptotp
      double complex, allocatable :: xshift(:,:)
      double complex, allocatable :: yshift(:,:)
      double precision, allocatable :: zshift(:,:)

      double complex, allocatable :: fexpe(:),fexpo(:),fexpback(:)
      double complex, allocatable :: mexp(:,:,:,:)
      double complex, allocatable :: mexpf1(:,:,:),mexpf2(:,:,:)
      double complex, allocatable ::
     1       mexpp1(:,:,:),mexpp2(:,:,:),mexppall(:,:,:,:)

      double complex, allocatable :: tmp(:,:,:,:)
      double precision, allocatable :: mptmp(:,:)

      double precision sourcetmp(3)
      double complex chargetmp

      integer *8 ix,iy,iz,ictr
      double precision rtmp
      double complex zmul

      integer *8 nlege, lw7, lused7, itype
      double precision wlege(40000)
      integer *8 nterms_eval(4,0:nlevels)

      integer *8 mnlist1, mnlist2,mnlist3,mnlist4,mnbors
      double complex eye, ztmp
      double precision alphaj
      integer *8 ctr,nn,iptr1,iptr2
      double precision, allocatable :: rscpow(:)
      double precision pi,errtmp
      double complex ima

      double precision ctmp(3)

c     list 3 variables
      double complex, allocatable :: iboxlexp(:,:,:)
      double precision, allocatable :: iboxsubcenters(:,:,:)
      double precision, allocatable :: iboxpot(:,:,:)
      double precision, allocatable :: iboxgrad(:,:,:,:)
      double precision, allocatable :: iboxhess(:,:,:,:)
      double precision, allocatable :: iboxsrc(:,:,:)
      integer *8, allocatable :: iboxsrcind(:,:)
      integer *8, allocatable :: iboxfl(:,:,:)
c     end of list 3 variables
c     list 4 variables
      integer *8 cntlist4
      integer *8, allocatable :: list4ct(:),ilist4(:)
      double complex, allocatable :: gboxmexp(:,:,:)
      double complex, allocatable :: gboxwexp(:,:,:,:,:)
      double complex, allocatable :: pgboxwexp(:,:,:,:)
      double precision, allocatable :: gboxsubcenters(:,:,:)
      double precision, allocatable :: gboxsort(:,:,:)
      integer *8, allocatable :: gboxind(:,:)
      integer *8, allocatable :: gboxfl(:,:,:)
      double precision, allocatable :: gboxcgsort(:,:,:)
      double precision, allocatable :: gboxdpsort(:,:,:,:)
c     end of list 4 variables

c
c   hessian variables
c
      double precision, allocatable :: scarray(:,:)

      integer *8 bigint
      integer *8 iert
      data ima/(0.0d0,1.0d0)/

      integer *8 nthd,ithd
      integer *8 omp_get_max_threads,omp_get_thread_num
      nthd = 1
C$    nthd=omp_get_max_threads()

      pi = 4.0d0*atan(1.0d0)

      thresh = 2.0d0**(-51)*boxsize(0)


c     ifprint is an internal information printing flag. 
c     Suppressed if ifprint=0.
c     Prints timing breakdown and other things if ifprint=1.
c     Prints timing breakdown, list information, 
c     and other things if ifprint=2.
c       
      ifprint=0
      
c
c   initialize various tree lists
c
      mnlist1 = 0
      mnlist2 = 0
      mnlist3 = 0
      mnlist4 = 0
      mnbors = 27

      isep = 1
      ndim = 3
      
      call computemnlists(nlevels,nboxes,itree(ipointer(1)),boxsize,
     1  centers,itree(ipointer(3)),itree(ipointer(4)),
     2  itree(ipointer(5)),isep,itree(ipointer(6)),mnbors,
     2  itree(ipointer(7)),iper,mnlist1,mnlist2,mnlist3,mnlist4)
      
      allocate(list1(mnlist1,nboxes),nlist1(nboxes))
      allocate(list2(mnlist2,nboxes),nlist2(nboxes))
      allocate(list3(mnlist3,nboxes),nlist3(nboxes))
      allocate(list4(mnlist4,nboxes),nlist4(nboxes))

      call computelists(nlevels,nboxes,itree(ipointer(1)),boxsize,
     1  centers,itree(ipointer(3)),itree(ipointer(4)),
     2  itree(ipointer(5)),isep,itree(ipointer(6)),mnbors,
     3  itree(ipointer(7)),iper,nlist1,mnlist1,list1,nlist2,
     4  mnlist2,list2,nlist3,mnlist3,list3,
     4  nlist4,mnlist4,list4)
      

c     Initialize routines for plane wave mp loc translation
 
      if(isep.eq.1) then
         if(eps.ge.0.5d-2) nlams = 12
         if(eps.lt.0.5d-2.and.eps.ge.0.5d-3) nlams = 12
         if(eps.lt.0.5d-3.and.eps.ge.0.5d-6) nlams = 20
         if(eps.lt.0.5d-6.and.eps.ge.0.5d-9) nlams = 29
         if(eps.lt.0.5d-9) nlams = 37
      endif
      if(isep.eq.2) then
         if(eps.ge.0.5d-3) nlams = 9
         if(eps.lt.0.5d-3.and.eps.ge.0.5d-6) nlams = 15
         if(eps.lt.0.5d-6.and.eps.ge.0.5d-9) nlams = 22
         if(eps.lt.0.5d-9) nlams = 29
      endif

      allocate(rlams(nlams),whts(nlams))
      allocate(nphysical(nlams),nfourier(nlams))

      nmax = 0
      do i=0,nlevels
         if(nmax.lt.nterms(i)) nmax = nterms(i)
      enddo
      allocate(rscpow(0:nmax))
      allocate(carray(4*nmax+1,4*nmax+1))
      allocate(dc(0:4*nmax,0:4*nmax))
      allocate(rdplus(0:nmax,0:nmax,-nmax:nmax))
      allocate(rdminus(0:nmax,0:nmax,-nmax:nmax))
      allocate(rdsq3(0:nmax,0:nmax,-nmax:nmax))
      allocate(rdmsq3(0:nmax,0:nmax,-nmax:nmax))
      allocate(rlsc(0:nmax,0:nmax,nlams))


c     generate rotation matrices and carray
      call getpwrotmat(nmax,carray,rdplus,rdminus,rdsq3,rdmsq3,dc)


c     generate rlams and weights (these are the nodes
c     and weights for the lambda integral)

      call vwts(rlams,whts,nlams)


c     generate the number of fourier modes required to represent the
c     moment function in fourier space

      call numthetahalf(nfourier,nlams)
 
c     generate the number of fourier modes in physical space
c     required for the exponential representation
      call numthetafour(nphysical,nlams)

c     Generate powers of lambda for the exponential basis
      call rlscini(rlsc,nlams,rlams,nmax)

c
c
c
      nn = 10*(nmax+2)**2
      allocate(scarray(nn,0:nlevels))

      do ilev=0,nlevels
        call l3dtaevalhessdini(nterms(ilev),scarray(1,ilev))
      enddo

c     Compute total number of plane waves
      nexptotp = 0
      nexptot = 0
      nthmax = 0
      nphmax = 0
      nn = 0
      do i=1,nlams
         nexptot = nexptot + nfourier(i)
         nexptotp = nexptotp + nphysical(i)
         if(nfourier(i).gt.nthmax) nthmax = nfourier(i)
         if(nphysical(i).gt.nphmax) nphmax = nphysical(i)
         nn = nn + nphysical(i)*nfourier(i)
      enddo

      allocate(fexpe(nn),fexpo(nn),fexpback(nn))
      allocate(tmp(nd,0:nmax,-nmax:nmax,nthd))
      allocate(mptmp(lmptemp,nthd))

      allocate(xshift(-5:5,nexptotp))
      allocate(yshift(-5:5,nexptotp))
      allocate(zshift(5,nexptotp))

      allocate(mexpf1(nd,nexptot,nthd),mexpf2(nd,nexptot,nthd),
     1   mexpp1(nd,nexptotp,nthd))
      allocate(mexpp2(nd,nexptotp,nthd),mexppall(nd,nexptotp,16,nthd))

c
cc      NOTE: there can be some memory savings here
c
      bigint = 0
      bigint = nboxes
      bigint = bigint*6
      bigint = bigint*nexptotp*nd

      if(ifprint.ge.1) print *, "mexp memory=",bigint/1.0d9

      allocate(mexp(nd,nexptotp,nboxes,6),stat=iert)
      if(iert.ne.0) then
        print *, "Cannot allocate pw expansion workspace"
        print *, "bigint=", bigint
        ier = 8
        return
      endif

      allocate(list4ct(nboxes))
      allocate(ilist4(nboxes))
      do i=1,nboxes
        list4ct(i)=0
        ilist4(i)=0
      enddo
      cntlist4=0

c     Precompute table for shifting exponential coefficients in 
c     physical domain
      call mkexps(rlams,nlams,nphysical,nexptotp,xshift,yshift,zshift)

c     Precompute table of exponentials for mapping from
c     fourier to physical domain
      call mkfexp(nlams,nfourier,nphysical,fexpe,fexpo,fexpback)
      
c
cc    compute array of factorials

     
      nmax2 = 2*nmax
      allocate(fact(0:nmax2),cs(0:nmax,-nmax:nmax))
      
      d = 1
      fact(0) = d
      do i=1,nmax2
        d=d*sqrt(i+0.0d0)
        fact(i) = d
      enddo

      cs(0,0) = 1.0d0
      do l=1,nmax
        do m=0,l
          cs(l,m) = ((-1)**l)/(fact(l-m)*fact(l+m))
          cs(l,-m) = cs(l,m)
        enddo
      enddo


      
      if(ifprint.ge.1) 
     1   call prin2('end of generating plane wave info*',i,0)
c
c
c     ... set the expansion coefficients to zero
c
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(i,j,k,idim)
      do i=1,nexpc
        do k=-ntj,ntj
          do j = 0,ntj
            do idim=1,nd
              tsort(idim,j,k,i)=0
            enddo
          enddo
        enddo
      enddo
C$OMP END PARALLEL DO

c       
      do i=1,6
        timeinfo(i)=0
      enddo

c
c       ... set all multipole and local expansions to zero
c

      do ilev = 0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox)
        do ibox=laddr(1,ilev),laddr(2,ilev)
          call mpzero(nd,rmlexp(iaddr(1,ibox)),nterms(ilev))
          call mpzero(nd,rmlexp(iaddr(2,ibox)),nterms(ilev))
        enddo
C$OMP END PARALLEL DO        
      enddo

c
c      set scjsort
c
      do ilev=0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i)
         do ibox=laddr(1,ilev),laddr(2,ilev)
            nchild = itree(ipointer(4)+ibox-1)
            if(nchild.gt.0) then
               istart = iexpcse(1,ibox)
               iend = iexpcse(2,ibox) 
               do i=istart,iend
                  scjsort(i) = rscales(ilev)
               enddo
            endif
         enddo
C$OMP END PARALLEL DO
      enddo


c    initialize legendre function evaluation routines
      nlege = 100
      lw7 = 40000
      call ylgndrfwini(nlege,wlege,lw7,lused7)

c
c     count number of boxes are in list4
      lca = 4*nmax
      if(ifprint.ge.1)
     $   call prinf('=== STEP 0 list4===*',i,0)
      call cpu_time(time1)
C$    time1=omp_get_wtime()
      do ilev=1,nlevels-1
         do ibox=laddr(1,ilev),laddr(2,ilev)
            if(nlist3(ibox).gt.0) then
              cntlist4=cntlist4+1
              list4ct(ibox)=cntlist4
              ilist4(cntlist4)=ibox
            endif
         enddo
      enddo
      if(ifprint.ge.1) print *,"nboxes:",nboxes,"cntlist4:",cntlist4
      allocate(pgboxwexp(nd,nexptotp,cntlist4,6))
      allocate(gboxmexp(nd*(nterms(nlevels)+1)*
     1                   (2*nterms(nlevels)+1),8,cntlist4))



      allocate(gboxsubcenters(3,8,nthd))
      allocate(gboxfl(2,8,nthd))

      nmaxt = 0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,istart,iend,npts)
C$OMP$REDUCTION(max:nmaxt)
      do ibox=1,nboxes
        if(list4ct(ibox).gt.0) then
          istart = isrcse(1,ibox)
          iend = isrcse(2,ibox)
          npts = iend-istart+1
          if(npts.gt.nmaxt) nmaxt = npts
        endif
      enddo
C$OMP END PARALLEL DO

      allocate(gboxind(nmaxt,nthd))
      allocate(gboxsort(3,nmaxt,nthd))
      allocate(gboxwexp(nd,nexptotp,6,8,nthd))
      allocate(gboxcgsort(nd,nmaxt,nthd))
      allocate(gboxdpsort(nd,3,nmaxt,nthd))

c   note gboxmexp is an array not scalar
      pgboxwexp=0d0
      gboxmexp=0d0

c     form mexp for all list4 type box at first ghost box center
      do ilev=1,nlevels-1

         rscpow(0) = 1.0d0/boxsize(ilev+1)
         rtmp = rscales(ilev+1)/boxsize(ilev+1)
         do i=1,nterms(ilev+1)
            rscpow(i) = rscpow(i-1)*rtmp
         enddo

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,istart,iend,jbox,jstart,jend,npts,npts0,i)
C$OMP$PRIVATE(ithd)
         do ibox=laddr(1,ilev),laddr(2,ilev)
            ithd = 0
C$          ithd=omp_get_thread_num()
            ithd = ithd + 1
            if(list4ct(ibox).gt.0) then
              istart=isrcse(1,ibox)
              iend=isrcse(2,ibox)
              npts = iend-istart+1

              if(npts.gt.0) then
                call subdividebox(sourcesort(1,istart),npts,
     1               centers(1,ibox),boxsize(ilev+1),
     2               gboxind(1,ithd),gboxfl(1,1,ithd),
     3               gboxsubcenters(1,1,ithd))
                call dreorderf(ndim,npts,sourcesort(1,istart),
     1               gboxsort(1,1,ithd),gboxind(1,ithd))
                if(ifcharge.eq.1) then
                  call dreorderf(nd,npts,chargesort(1,istart),
     1                 gboxcgsort(1,1,ithd),gboxind(1,ithd))
                endif
                if(ifdipole.eq.1) then
                  call dreorderf(3*nd,npts,dipvecsort(1,1,istart),
     1                 gboxdpsort(1,1,1,ithd),gboxind(1,ithd))
                endif
                do i=1,8
                  if(gboxfl(1,i,ithd).gt.0) then
                    jstart=gboxfl(1,i,ithd)
                    jend=gboxfl(2,i,ithd)
                    npts0=jend-jstart+1
                    jbox=list4ct(ibox)
                    if(ifcharge.eq.1.and.ifdipole.eq.0) then
                      call l3dformmpc(nd,rscales(ilev+1),
     1                   gboxsort(1,jstart,ithd),
     2                   gboxcgsort(1,jstart,ithd),
     3                   npts0,gboxsubcenters(1,i,ithd),nterms(ilev+1),
     4                   gboxmexp(1,i,jbox),wlege,nlege)          
                    endif
                    if(ifcharge.eq.0.and.ifdipole.eq.1) then
                      call l3dformmpd(nd,rscales(ilev+1),
     1                   gboxsort(1,jstart,ithd),
     2                   gboxdpsort(1,1,jstart,ithd),
     3                   npts0,gboxsubcenters(1,i,ithd),nterms(ilev+1),
     4                   gboxmexp(1,i,jbox),wlege,nlege)          
                    endif
                    if(ifcharge.eq.1.and.ifdipole.eq.1) then
                      call l3dformmpcd(nd,rscales(ilev+1),
     1                   gboxsort(1,jstart,ithd),
     2                   gboxcgsort(1,jstart,ithd),
     3                   gboxdpsort(1,1,jstart,ithd),
     4                   npts0,gboxsubcenters(1,i,ithd),nterms(ilev+1),
     5                   gboxmexp(1,i,jbox),wlege,nlege)          
                    endif
                    call l3dmpmp(nd,rscales(ilev+1),
     1                   gboxsubcenters(1,i,ithd),gboxmexp(1,i,jbox),
     2                   nterms(ilev+1),rscales(ilev),centers(1,ibox),
     3                   rmlexp(iaddr(1,ibox)),nterms(ilev),dc,lca)
     
                    call mpscale(nd,nterms(ilev+1),gboxmexp(1,i,jbox),
     1                   rscpow,tmp(1,0,-nmax,ithd))
c
cc                process up down for current box
c
                    call mpoletoexp(nd,tmp(1,0,-nmax,ithd),
     1                   nterms(ilev+1),nlams,
     2                   nfourier,nexptot,mexpf1(1,1,ithd),
     3                   mexpf2(1,1,ithd),rlsc)

                    call ftophys(nd,mexpf1(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,1,i,ithd),
     3                   fexpe,fexpo)

                    call ftophys(nd,mexpf2(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,2,i,ithd),
     3                   fexpe,fexpo)

                    call processgboxudexp(nd,gboxwexp(1,1,1,i,ithd),
     1                   gboxwexp(1,1,2,i,ithd),i,nexptotp,
     2                   pgboxwexp(1,1,jbox,1),pgboxwexp(1,1,jbox,2),
     3                   xshift,yshift,zshift)
c
cc                process north-south for current box
c
                    call rotztoy(nd,nterms(ilev+1),tmp(1,0,-nmax,ithd),
     1                   mptmp(1,ithd),rdminus)
                    call mpoletoexp(nd,mptmp(1,ithd),
     1                   nterms(ilev+1),nlams,
     2                   nfourier,nexptot,mexpf1(1,1,ithd),
     3                   mexpf2(1,1,ithd),rlsc)

                    call ftophys(nd,mexpf1(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,3,i,ithd),
     3                   fexpe,fexpo)

                    call ftophys(nd,mexpf2(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,4,i,ithd),
     3                   fexpe,fexpo)

                    call processgboxnsexp(nd,gboxwexp(1,1,3,i,ithd),
     1                   gboxwexp(1,1,4,i,ithd),i,nexptotp,
     2                   pgboxwexp(1,1,jbox,3),pgboxwexp(1,1,jbox,4),
     3                   xshift,yshift,zshift)
c
cc                process east-west for current box
c
                    call rotztox(nd,nterms(ilev+1),tmp(1,0,-nmax,ithd),
     1                   mptmp(1,ithd),rdplus)
                    call mpoletoexp(nd,mptmp(1,ithd),
     1                   nterms(ilev+1),nlams,
     2                   nfourier,nexptot,mexpf1(1,1,ithd),
     3                   mexpf2(1,1,ithd),rlsc)

                    call ftophys(nd,mexpf1(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,5,i,ithd),
     3                   fexpe,fexpo)

                    call ftophys(nd,mexpf2(1,1,ithd),
     1                   nlams,rlams,nfourier,
     2                   nphysical,nthmax,gboxwexp(1,1,6,i,ithd),
     3                   fexpe,fexpo)
                
                    call processgboxewexp(nd,gboxwexp(1,1,5,i,ithd),
     1                   gboxwexp(1,1,6,i,ithd),i,nexptotp,
     2                   pgboxwexp(1,1,jbox,5),pgboxwexp(1,1,jbox,6),
     3                   xshift,yshift,zshift)
                  endif
                enddo
              endif
            endif
         enddo
C$OMP END PARALLEL DO
      enddo
      deallocate(gboxfl,gboxsubcenters,gboxwexp,gboxcgsort)
      deallocate(gboxdpsort,gboxind,gboxsort)

      call cpu_time(time2)
C$    time2=omp_get_wtime()
      if(ifprint.ge.1) print *,"mexp list4 time:",time2-time1
      timeinfo(3)=time2-time1
c     end of count number of boxes are in list4
c

c
c
      if(ifprint .ge. 1) 
     $   call prinf('=== STEP 1 (form mp) ====*',i,0)
        call cpu_time(time1)
C$        time1=omp_get_wtime()
c
c       ... step 1, locate all charges, assign them to boxes, and
c       form multipole expansions


      do ilev=2,nlevels
         if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)

               istart = isrcse(1,ibox)
               iend = isrcse(2,ibox) 
               npts = iend-istart+1

               nchild = itree(ipointer(4)+ibox-1)

               if(npts.gt.0.and.nchild.eq.0.and.list4ct(ibox).eq.0) then
                  call l3dformmpc(nd,rscales(ilev),
     1            sourcesort(1,istart),chargesort(1,istart),npts,
     2            centers(1,ibox),nterms(ilev),
     3            rmlexp(iaddr(1,ibox)),wlege,nlege)          
               endif
            enddo
C$OMP END PARALLEL DO          
         endif

         if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)

               istart = isrcse(1,ibox) 
               iend = isrcse(2,ibox) 
               npts = iend-istart+1

               nchild = itree(ipointer(4)+ibox-1)

               if(npts.gt.0.and.nchild.eq.0.and.list4ct(ibox).eq.0) then
                  call l3dformmpd(nd,rscales(ilev),
     1            sourcesort(1,istart),
     2            dipvecsort(1,1,istart),npts,
     2            centers(1,ibox),nterms(ilev),
     3            rmlexp(iaddr(1,ibox)),wlege,nlege)          
               endif
            enddo
C$OMP END PARALLEL DO          
         endif

         if(ifdipole.eq.1.and.ifcharge.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,npts,istart,iend,nchild)
            do ibox=laddr(1,ilev),laddr(2,ilev)

               istart = isrcse(1,ibox) 
               iend = isrcse(2,ibox)
               npts = iend-istart+1

               nchild = itree(ipointer(4)+ibox-1)

               if(npts.gt.0.and.nchild.eq.0.and.list4ct(ibox).eq.0) then
                  call l3dformmpcd(nd,rscales(ilev),
     1            sourcesort(1,istart),chargesort(1,istart),
     2            dipvecsort(1,1,istart),npts,
     2            centers(1,ibox),nterms(ilev),
     3            rmlexp(iaddr(1,ibox)),wlege,nlege)          
               endif
            enddo
C$OMP END PARALLEL DO          
         endif
      enddo
      if(ifprint.ge.1) print *,"nboxes:",nboxes,"leaf:",cntlist4



      call cpu_time(time2)
C$    time2=omp_get_wtime()
      timeinfo(1)=time2-time1

      lca = 4*nmax


c       
      if(ifprint .ge. 1)
     $      call prinf('=== STEP 2 (merge mp) ====*',i,0)
      call cpu_time(time1)
C$    time1=omp_get_wtime()
c
      do ilev=nlevels-1,0,-1
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,i,jbox,istart,iend,npts)
         do ibox = laddr(1,ilev),laddr(2,ilev)
            do i=1,8
               jbox = itree(ipointer(5)+8*(ibox-1)+i-1)
               if(jbox.gt.0) then
                  istart = isrcse(1,jbox)
                  iend = isrcse(2,jbox)
                  npts = iend-istart+1
                  if(npts.gt.0) then
                     call l3dmpmp(nd,rscales(ilev+1),
     1               centers(1,jbox),rmlexp(iaddr(1,jbox)),
     2               nterms(ilev+1),rscales(ilev),centers(1,ibox),
     3               rmlexp(iaddr(1,ibox)),nterms(ilev),dc,lca)
                  endif
               endif
            enddo
         enddo
C$OMP END PARALLEL DO         
      enddo

      call cpu_time(time2)
C$    time2=omp_get_wtime()
      timeinfo(2)=time2-time1

      if(ifprint.ge.1)
     $    call prinf('=== Step 3 (mp to loc+formta+mpeval) ===*',i,0)
c      ... step 3, convert multipole expansions into local
c       expansions

      call cpu_time(time1)
C$        time1=omp_get_wtime()

c
cc     zero out mexp
c 

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(i,j,k,idim)
      do k=1,6
        do i=1,nboxes
          do j=1,nexptotp
            do idim=1,nd
              mexp(idim,j,i,k) = 0.0d0
            enddo
          enddo
        enddo
      enddo
C$OMP END PARALLEL DO      

c     init uall,dall,...,etc arrays
      allocate(uall(200,nthd),dall(200,nthd),nall(120,nthd))
      allocate(sall(120,nthd),eall(72,nthd),wall(72,nthd))
      allocate(u1234(36,nthd),d5678(36,nthd),n1256(24,nthd))
      allocate(s3478(24,nthd))
      allocate(e1357(16,nthd),w2468(16,nthd),n12(20,nthd))
      allocate(n56(20,nthd),s34(20,nthd),s78(20,nthd))
      allocate(e13(20,nthd),e57(20,nthd),w24(20,nthd),w68(20,nthd))
      allocate(e1(20,nthd),e3(5,nthd),e5(5,nthd),e7(5,nthd))
      allocate(w2(5,nthd),w4(5,nthd),w6(5,nthd),w8(5,nthd))
      allocate(iboxsubcenters(3,8,nthd))
      allocate(iboxfl(2,8,nthd))
c
c  figure out allocations needed for iboxsrc,iboxsrcind,iboxpot
c  and so on
c
      nmaxt = 0
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ibox,istart,iend,npts)
C$OMP$REDUCTION(max:nmaxt)
      do ibox=1,nboxes
        if(nlist3(ibox).gt.0) then
          istart = isrcse(1,ibox)
          iend = isrcse(2,ibox)
          npts = iend-istart+1
          if(npts.gt.nmaxt) nmaxt = npts

          istart = itargse(1,ibox)
          iend = itargse(2,ibox)
          npts = iend - istart + 1
          if(npts.gt.nmaxt) nmaxt = npts
        endif
      enddo
C$OMP END PARALLEL DO

      allocate(iboxsrcind(nmaxt,nthd))
      allocate(iboxsrc(3,nmaxt,nthd))
      allocate(iboxpot(nd,nmaxt,nthd))
      allocate(iboxgrad(nd,3,nmaxt,nthd))
      allocate(iboxhess(nd,6,nmaxt,nthd))

      do ilev=2,nlevels
        allocate(iboxlexp(nd*(nterms(ilev)+1)*
     1           (2*nterms(ilev)+1),8,nthd))

         rscpow(0) = 1.0d0/boxsize(ilev)
         rtmp = rscales(ilev)/boxsize(ilev)
         do i=1,nterms(ilev)
            rscpow(i) = rscpow(i-1)*rtmp
         enddo

C$OMP PARALLEL DO DEFAULT (SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts)
C$OMP$PRIVATE(ithd)
         do ibox=laddr(1,ilev),laddr(2,ilev)
            ithd = 0
C$          ithd=omp_get_thread_num()
            ithd = ithd + 1
            istart = isrcse(1,ibox) 
            iend = isrcse(2,ibox)

            npts = iend-istart+1

            if(npts.gt.0) then
c            rescale the multipole expansion

                call mpscale(nd,nterms(ilev),rmlexp(iaddr(1,ibox)),
     1                 rscpow,tmp(1,0,-nmax,ithd))
c
cc                process up down for current box
c
                call mpoletoexp(nd,tmp(1,0,-nmax,ithd),nterms(ilev),
     1              nlams,nfourier,
     2              nexptot,mexpf1(1,1,ithd),mexpf2(1,1,ithd),rlsc)

                call ftophys(nd,mexpf1(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,1),fexpe,fexpo)

                call ftophys(nd,mexpf2(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,2),fexpe,fexpo)


c
cc                process north-south for current box
c
                call rotztoy(nd,nterms(ilev),tmp(1,0,-nmax,ithd),
     1              mptmp(1,ithd),rdminus)
                call mpoletoexp(nd,mptmp(1,ithd),nterms(ilev),
     1              nlams,nfourier,
     2              nexptot,mexpf1(1,1,ithd),mexpf2(1,1,ithd),rlsc)

                call ftophys(nd,mexpf1(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,3),fexpe,fexpo)

                call ftophys(nd,mexpf2(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,4),fexpe,fexpo)

c
cc                process east-west for current box

                call rotztox(nd,nterms(ilev),tmp(1,0,-nmax,ithd),
     1              mptmp(1,ithd),rdplus)
                call mpoletoexp(nd,mptmp(1,ithd),
     1              nterms(ilev),nlams,nfourier,
     2              nexptot,mexpf1(1,1,ithd),
     3              mexpf2(1,1,ithd),rlsc)

                call ftophys(nd,mexpf1(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,5),fexpe,fexpo)


                call ftophys(nd,mexpf2(1,1,ithd),nlams,rlams,nfourier,
     1          nphysical,nthmax,mexp(1,1,ibox,6),fexpe,fexpo)

            endif

         enddo
C$OMP END PARALLEL DO         
c
c
cc         loop over parent boxes and ship plane wave
c          expansions to the first child of parent 
c          boxes. 
c          The codes are now written from a gathering perspective
c
c          so the first child of the parent is the one
c          recieving all the local expansions
c          coming from all the lists
c
c          
c
         rscpow(0) = 1.0d0
         rtmp = rscales(ilev)/boxsize(ilev)
         do i=1,nterms(ilev)
            rscpow(i) = rscpow(i-1)*rtmp
         enddo
C$OMP PARALLEL DO DEFAULT (SHARED)
C$OMP$PRIVATE(ibox,istart,iend,npts,nchild)
C$OMP$PRIVATE(nuall,ndall,nnall,nsall)
C$OMP$PRIVATE(neall,nwall,nu1234,nd5678)
C$OMP$PRIVATE(nn1256,ns3478,ne1357,nw2468)
C$OMP$PRIVATE(nn12,nn56,ns34,ns78,ne13,ne57)
C$OMP$PRIVATE(nw24,nw68,ne1,ne3,ne5,ne7)
C$OMP$PRIVATE(nw2,nw4,nw6,nw8)
C$OMP$PRIVATE(npts0,ctmp,jstart,jend,i)
C$OMP$PRIVATE(ithd)
         do ibox = laddr(1,ilev-1),laddr(2,ilev-1)
           ithd = 0
C$         ithd=omp_get_thread_num()
           ithd = ithd + 1
           npts = 0
           if(ifpghtarg.gt.0) then
             istart = itargse(1,ibox)
             iend = itargse(2,ibox) 
             npts = npts + iend-istart+1
           endif

           istart = iexpcse(1,ibox) 
           iend = iexpcse(2,ibox) 
           npts = npts + iend-istart+1

           nchild = itree(ipointer(4)+ibox-1)

           if(ifpgh.gt.0) then
             istart = isrcse(1,ibox) 
             iend = isrcse(2,ibox) 
             npts = npts + iend-istart+1
           endif


           if(npts.gt.0.and.nchild.gt.0) then

               call getpwlistall(ibox,boxsize(ilev),nboxes,
     1         itree(ipointer(6)+ibox-1),itree(ipointer(7)+
     2         mnbors*(ibox-1)),nchild,itree(ipointer(5)),centers,
     3         isep,nuall,uall(1,ithd),ndall,dall(1,ithd),
     4         nnall,nall(1,ithd),nsall,sall(1,ithd),
     5         neall,eall(1,ithd),nwall,wall(1,ithd),
     6         nu1234,u1234(1,ithd),nd5678,d5678(1,ithd),
     7         nn1256,n1256(1,ithd),ns3478,s3478(1,ithd),
     8         ne1357,e1357(1,ithd),nw2468,w2468(1,ithd),
     9         nn12,n12(1,ithd),nn56,n56(1,ithd),ns34,s34(1,ithd),
     9         ns78,s78(1,ithd),ne13,e13(1,ithd),ne57,e57(1,ithd),
     9         nw24,w24(1,ithd),nw68,w68(1,ithd),ne1,e1(1,ithd),
     9         ne3,e3(1,ithd),ne5,e5(1,ithd),ne7,e7(1,ithd),
     9         nw2,w2(1,ithd),nw4,w4(1,ithd),nw6,w6(1,ithd),
     9         nw8,w8(1,ithd))

               call processudexp(nd,ibox,ilev,nboxes,centers,
     1         itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2         nterms(ilev),
     2         iaddr,rmlexp,rlams,whts,
     3         nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4         nuall,uall(1,ithd),nu1234,u1234(1,ithd),
     5         ndall,dall(1,ithd),nd5678,d5678(1,ithd),
     6         mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     7         mexpp1(1,1,ithd),mexpp2(1,1,ithd),mexppall(1,1,1,ithd),
     8         mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9         mexppall(1,1,4,ithd),xshift,
     8         yshift,zshift,fexpback,rlsc,rscpow,
     9         pgboxwexp,cntlist4,list4ct,
     9         nlist4,list4,mnlist4)
               
               call processnsexp(nd,ibox,ilev,nboxes,centers,
     1         itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2         nterms(ilev),
     2         iaddr,rmlexp,rlams,whts,
     3         nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4         nnall,nall(1,ithd),nn1256,n1256(1,ithd),
     5         nn12,n12(1,ithd),nn56,n56(1,ithd),nsall,sall(1,ithd),
     6         ns3478,s3478(1,ithd),ns34,s34(1,ithd),ns78,s78(1,ithd),
     7         mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     8         mexpp1(1,1,ithd),mexpp2(1,1,ithd),mexppall(1,1,1,ithd),
     9         mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9         mexppall(1,1,4,ithd),
     9         mexppall(1,1,5,ithd),mexppall(1,1,6,ithd),
     9         mexppall(1,1,7,ithd),
     9         mexppall(1,1,8,ithd),rdplus,xshift,yshift,zshift,
     9         fexpback,rlsc,rscpow,
     9         pgboxwexp,cntlist4,list4ct,
     9         nlist4,list4,mnlist4)

               
               call processewexp(nd,ibox,ilev,nboxes,centers,
     1         itree(ipointer(5)),rscales(ilev),boxsize(ilev),
     2         nterms(ilev),
     2         iaddr,rmlexp,rlams,whts,
     3         nlams,nfourier,nphysical,nthmax,nexptot,nexptotp,mexp,
     4         neall,eall(1,ithd),ne1357,e1357(1,ithd),
     5         ne13,e13(1,ithd),ne57,e57(1,ithd),ne1,e1(1,ithd),
     6         ne3,e3(1,ithd),ne5,e5(1,ithd),
     7         ne7,e7(1,ithd),nwall,wall(1,ithd),
     8         nw2468,w2468(1,ithd),
     9         nw24,w24(1,ithd),nw68,w68(1,ithd),
     9         nw2,w2(1,ithd),nw4,w4(1,ithd),nw6,w6(1,ithd),
     9         nw8,w8(1,ithd),
     9         mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     9         mexpp1(1,1,ithd),mexpp2(1,1,ithd),mexppall(1,1,1,ithd),
     9         mexppall(1,1,2,ithd),mexppall(1,1,3,ithd),
     9         mexppall(1,1,4,ithd),
     9         mexppall(1,1,5,ithd),mexppall(1,1,6,ithd),
     9         mexppall(1,1,7,ithd),mexppall(1,1,8,ithd),
     9         mexppall(1,1,9,ithd),
     9         mexppall(1,1,10,ithd),mexppall(1,1,11,ithd),
     9         mexppall(1,1,12,ithd),
     9         mexppall(1,1,13,ithd),mexppall(1,1,14,ithd),
     9         mexppall(1,1,15,ithd),
     9         mexppall(1,1,16,ithd),rdminus,xshift,yshift,zshift,
     9         fexpback,rlsc,rscpow,
     9         pgboxwexp,cntlist4,list4ct,nlist4,list4,mnlist4)


            endif

            if(nlist3(ibox).gt.0.and.npts.gt.0) then
              call getlist3pwlistall(ibox,boxsize(ilev),nboxes,
     1             nlist3(ibox),list3(1,ibox),isep,
     2             centers,nuall,uall(1,ithd),ndall,dall(1,ithd),
     3             nnall,nall(1,ithd),
     4             nsall,sall(1,ithd),neall,eall(1,ithd),
     5             nwall,wall(1,ithd))
              do i=1,8
                call mpzero(nd,iboxlexp(1,i,ithd),nterms(ilev))
              enddo

              call processlist3udexplong(nd,ibox,nboxes,centers,
     1             boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),rlams,
     2             whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3             nexptotp,mexp,nuall,uall(1,ithd),ndall,dall(1,ithd),
     4             mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     5             mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     6             mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),
     7             xshift,yshift,zshift,fexpback,rlsc,rscpow)

              call processlist3nsexplong(nd,ibox,nboxes,centers,
     1             boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),rlams,
     2             whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3             nexptotp,mexp,nnall,nall(1,ithd),nsall,sall(1,ithd),
     4             mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     5             mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     6             mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),rdplus,
     7             xshift,yshift,zshift,fexpback,rlsc,rscpow)

              call processlist3ewexplong(nd,ibox,nboxes,centers,
     1             boxsize(ilev),nterms(ilev),iboxlexp(1,1,ithd),rlams,
     2             whts,nlams,nfourier,nphysical,nthmax,nexptot,
     3             nexptotp,mexp,neall,eall(1,ithd),nwall,wall(1,ithd),
     4             mexpf1(1,1,ithd),mexpf2(1,1,ithd),
     5             mexpp1(1,1,ithd),mexpp2(1,1,ithd),
     6             mexppall(1,1,1,ithd),mexppall(1,1,2,ithd),rdminus,
     7             xshift,yshift,zshift,fexpback,rlsc,rscpow)

              if(ifpgh.eq.1) then
                istart = isrcse(1,ibox) 
                iend = isrcse(2,ibox) 
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(sourcesort(1,istart),npts,
     1                    centers(1,ibox),boxsize(ilev),
     2                    iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                    iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,sourcesort(1,istart),
     1                    iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pot(1,istart),
     1                    iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalp(nd,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1               pot(1,istart),iboxsrcind(1,ithd))
                endif
              endif

              if(ifpgh.eq.2) then
                istart = isrcse(1,ibox)
                iend = isrcse(2,ibox) 
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(sourcesort(1,istart),npts,
     1                    centers(1,ibox),boxsize(ilev),
     2                    iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                    iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,sourcesort(1,istart),
     1                    iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pot(1,istart),
     1                    iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(3*nd,npts,grad(1,1,istart),
     1                   iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalg(nd,rscales(ilev),
     1                    iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                    nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                    iboxpot(1,jstart,ithd),
     4                    iboxgrad(1,1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1                pot(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(3*nd,npts,iboxgrad(1,1,1,ithd),
     1              grad(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif
c
c  continue from here
c
              

              if(ifpgh.eq.3) then
                istart = isrcse(1,ibox) 
                iend = isrcse(2,ibox)
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(sourcesort(1,istart),npts,
     1                    centers(1,ibox),boxsize(ilev),
     2                    iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                    iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,sourcesort(1,istart),
     1                    iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pot(1,istart),
     1                    iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(3*nd,npts,grad(1,1,istart),
     1                   iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(6*nd,npts,hess(1,1,istart),
     1                 iboxhess(1,1,1,ithd),iboxsrcind(1,ithd))
           
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalh(nd,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),
     4                     iboxgrad(1,1,jstart,ithd),
     4                     iboxhess(1,1,jstart,ithd),scarray(1,ilev))
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1                pot(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(3*nd,npts,iboxgrad(1,1,1,ithd),
     1              grad(1,1,istart),iboxsrcind(1,ithd))
                  call dreorderi(6*nd,npts,iboxhess(1,1,1,ithd),
     1              hess(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif


              if(ifpghtarg.eq.1) then
                istart = itargse(1,ibox) 
                iend = itargse(2,ibox) 
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(targsort(1,istart),npts,
     1                   centers(1,ibox),boxsize(ilev),
     2                   iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                   iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,targsort(1,istart),
     1                   iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pottarg(1,istart),
     1                   iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalp(nd,rscales(ilev),
     1                    iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                    nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                    iboxpot(1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1              pottarg(1,istart),iboxsrcind(1,ithd))
                endif
              endif

              if(ifpghtarg.eq.2) then
                istart = itargse(1,ibox) 
                iend = itargse(2,ibox) 
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(targsort(1,istart),npts,
     1                   centers(1,ibox),boxsize(ilev),
     2                   iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                   iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,targsort(1,istart),
     1                   iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pottarg(1,istart),
     1                   iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(3*nd,npts,gradtarg(1,1,istart),
     1                    iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalg(nd,rscales(ilev),
     1                     iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                     nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                     iboxpot(1,jstart,ithd),
     4                     iboxgrad(1,1,jstart,ithd),wlege,nlege)
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1               pottarg(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(3*nd,npts,iboxgrad(1,1,1,ithd),
     1                 gradtarg(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif

              if(ifpghtarg.eq.3) then
                istart = itargse(1,ibox) 
                iend = itargse(2,ibox) 
                npts = iend-istart+1
                if(npts.gt.0) then
                  call subdividebox(targsort(1,istart),npts,
     1                   centers(1,ibox),boxsize(ilev),
     2                   iboxsrcind(1,ithd),iboxfl(1,1,ithd),
     3                   iboxsubcenters(1,1,ithd))
                  call dreorderf(ndim,npts,targsort(1,istart),
     1                   iboxsrc(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(nd,npts,pottarg(1,istart),
     1                   iboxpot(1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(3*nd,npts,gradtarg(1,1,istart),
     1                    iboxgrad(1,1,1,ithd),iboxsrcind(1,ithd))
                  call dreorderf(6*nd,npts,hesstarg(1,1,istart),
     1                 iboxhess(1,1,1,ithd),iboxsrcind(1,ithd))
                  do i=1,8
                    if(iboxfl(1,i,ithd).gt.0) then
                      jstart=iboxfl(1,i,ithd)
                      jend=iboxfl(2,i,ithd)
                      npts0=jend-jstart+1
                      if(npts0.gt.0) then
                        call l3dtaevalh(nd,rscales(ilev),
     1                    iboxsubcenters(1,i,ithd),iboxlexp(1,i,ithd),
     2                    nterms(ilev),iboxsrc(1,jstart,ithd),npts0,
     3                    iboxpot(1,jstart,ithd),
     4                    iboxgrad(1,1,jstart,ithd),
     4                    iboxhess(1,1,jstart,ithd),scarray(1,ilev))
                      endif
                    endif
                  enddo
                  call dreorderi(nd,npts,iboxpot(1,1,ithd),
     1               pottarg(1,istart),iboxsrcind(1,ithd))
                  call dreorderi(3*nd,npts,iboxgrad(1,1,1,ithd),
     1                 gradtarg(1,1,istart),iboxsrcind(1,ithd))
                  call dreorderi(6*nd,npts,iboxhess(1,1,1,ithd),
     1                 hesstarg(1,1,istart),iboxsrcind(1,ithd))
                endif
              endif

            endif
         enddo
C$OMP END PARALLEL DO        
        deallocate(iboxlexp)  
      enddo

      deallocate(iboxsrcind,iboxsrc,iboxpot,iboxgrad,iboxhess)
      deallocate(iboxsubcenters,iboxfl)
      deallocate(uall,dall,nall,sall,eall,wall)
      deallocate(u1234,d5678,n1256,s3478)
      deallocate(e1357,w2468,n12,n56,s34,s78)
      deallocate(e13,e57,w24,w68)
      deallocate(e1,e3,e5,e7,w2,w4,w6,w8)
      deallocate(tmp,mptmp)
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(3) = timeinfo(3) + time2-time1


      if(ifprint.ge.1)
     $    call prinf('=== Step 4 (split loc) ===*',i,0)

      call cpu_time(time1)
C$        time1=omp_get_wtime()
      do ilev = 2,nlevels-1

C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,i,jbox,istart,iend,npts)
         do ibox = laddr(1,ilev),laddr(2,ilev)

            npts = 0

            if(ifpghtarg.gt.0) then
               istart = itargse(1,ibox)
               iend = itargse(2,ibox) 
               npts = npts + iend-istart+1
            endif

            istart = iexpcse(1,ibox) 
            iend = iexpcse(2,ibox) 
            npts = npts + iend-istart+1

            if(ifpgh.gt.0) then
               istart = isrcse(1,ibox)
               iend = isrcse(2,ibox) 
               npts = npts + iend-istart+1
            endif

            if(npts.gt.0) then
               do i=1,8
                  jbox = itree(ipointer(5)+8*(ibox-1)+i-1)
                  if(jbox.gt.0) then
                     call l3dlocloc(nd,rscales(ilev),
     1                centers(1,ibox),rmlexp(iaddr(2,ibox)),
     2                nterms(ilev),rscales(ilev+1),centers(1,jbox),
     3                rmlexp(iaddr(2,jbox)),nterms(ilev+1),dc,lca)
                  endif
               enddo
            endif
         enddo
C$OMP END PARALLEL DO         
      enddo
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(4) = time2-time1


      if(ifprint.ge.1)
     $    call prinf('=== step 5 (eval lo) ===*',i,0)

c     ... step 6, evaluate all local expansions
c

      call cpu_time(time1)
C$        time1=omp_get_wtime()
C

c
cc       shift local expansion to local epxanion at expansion centers
c        (note: this part is not relevant for particle codes.
c        it is relevant only for qbx codes)

      do ilev = 0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i)
C$OMP$SCHEDULE(DYNAMIC)      
         do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
               istart = iexpcse(1,ibox) 
               iend = iexpcse(2,ibox) 
               do i=istart,iend

                  call l3dlocloc(nd,rscales(ilev),
     1             centers(1,ibox),rmlexp(iaddr(2,ibox)),
     2             nterms(ilev),rscales(ilev),expcsort(1,i),
     3             tsort(1,0,-ntj,i),ntj,dc,lca)
               enddo
            endif
         enddo
C$OMP END PARALLEL DO
      enddo

c
cc        evaluate local expansion at source and target
c         locations
c
      do ilev = 0,nlevels
        if(ifpgh.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = isrcse(1,ibox) 
              iend = isrcse(2,ibox)
              npts = iend-istart+1
              call l3dtaevalp(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),sourcesort(1,istart),
     2         npts,pot(1,istart),wlege,nlege)
            endif
          enddo
C$OMP END PARALLEL DO         
        endif

        if(ifpgh.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = isrcse(1,ibox) 
              iend = isrcse(2,ibox)
              npts = iend-istart+1
              call l3dtaevalg(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),sourcesort(1,istart),
     2         npts,pot(1,istart),grad(1,1,istart),wlege,nlege)
            endif
          enddo
C$OMP END PARALLEL DO         
        endif


        if(ifpgh.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = isrcse(1,ibox)
              iend = isrcse(2,ibox)
              npts = iend-istart+1
              call l3dtaevalh(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),sourcesort(1,istart),
     2         npts,pot(1,istart),grad(1,1,istart),hess(1,1,istart),
     3         scarray(1,ilev))
            endif
          enddo
C$OMP END PARALLEL DO         
        endif

        if(ifpghtarg.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = iend-istart+1
              call l3dtaevalp(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),targsort(1,istart),
     2         npts,pottarg(1,istart),wlege,nlege)
            endif
          enddo
C$OMP END PARALLEL DO         
        endif

        if(ifpghtarg.eq.2) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = iend-istart+1

              call l3dtaevalg(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),targsort(1,istart),
     2         npts,pottarg(1,istart),gradtarg(1,1,istart),wlege,nlege)
            endif
          enddo
C$OMP END PARALLEL DO         
        endif

        if(ifpghtarg.eq.3) then
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP$PRIVATE(ibox,nchild,istart,iend,i,npts)
C$OMP$SCHEDULE(DYNAMIC)      
          do ibox = laddr(1,ilev),laddr(2,ilev)
            nchild=itree(ipointer(4)+ibox-1)
            if(nchild.eq.0) then 
              istart = itargse(1,ibox)
              iend = itargse(2,ibox)
              npts = iend-istart+1

              call l3dtaevalh(nd,rscales(ilev),centers(1,ibox),
     1         rmlexp(iaddr(2,ibox)),nterms(ilev),targsort(1,istart),
     2         npts,pottarg(1,istart),gradtarg(1,1,istart),
     3         hesstarg(1,1,istart),scarray(1,ilev))
            endif
          enddo
C$OMP END PARALLEL DO         
        endif
      enddo

    
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(5) = time2 - time1


      if(ifprint .ge. 1)
     $     call prinf('=== STEP 6 (direct) =====*',i,0)
      call cpu_time(time1)
C$        time1=omp_get_wtime()

      if(ifnear.eq.0) goto 1000
c
cc       directly form local expansions for list1 sources
c        at expansion centers. 
c        (note: this part is not relevant for particle codes.
c         It is relevant only for qbx codes)


      do ilev=0,nlevels
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarte,iende,i,jbox)
C$OMP$PRIVATE(jstart,jend)
         do ibox = laddr(1,ilev),laddr(2,ilev)
            istarte = iexpcse(1,ibox) 
            iende = iexpcse(2,ibox) 

            

            do i =1,nlist1(ibox)
               jbox = list1(i,ibox)
               jstart = isrcse(1,jbox) 
               jend = isrcse(2,jbox) 

               call lfmm3dexpc_direct(nd,jstart,jend,istarte,
     1         iende,sourcesort,ifcharge,chargesort,ifdipole,
     2         dipvecsort,expcsort,tsort,scjsort,ntj,
     3         wlege,nlege)
            enddo
         enddo
C$OMP END PARALLEL DO
      enddo

c
cc        directly evaluate potential at sources and targets 
c         due to sources in list1

      do ilev=0,nlevels
c
cc           evaluate at the sources
c

        if(ifpgh.eq.1) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox) 
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox) 
                jstart =  isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcp(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart =  isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdp(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdp(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpgh.eq.2) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcg(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then

C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdg(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)     
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then

C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdg(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),thresh)      
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif


        if(ifpgh.eq.3) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectch(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),
     3             hess(1,1,istarts),thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then

C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdh(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),
     3             hess(1,1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then

C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istarts,iends,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istarts = isrcse(1,ibox)
              iends = isrcse(2,ibox)
              npts0 = iends-istarts+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdh(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,sourcesort(1,istarts),
     2             npts0,pot(1,istarts),grad(1,1,istarts),
     3             hess(1,1,istarts),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpghtarg.eq.1) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcp(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdp(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdp(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpghtarg.eq.2) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcg(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdg(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdg(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif

        if(ifpghtarg.eq.3) then
          if(ifcharge.eq.1.and.ifdipole.eq.0) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              

              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectch(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             hesstarg(1,1,istartt),thresh)   
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.0.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectdh(nd,sourcesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             hesstarg(1,1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif

          if(ifcharge.eq.1.and.ifdipole.eq.1) then
C$OMP PARALLEL DO DEFAULT(SHARED)     
C$OMP$PRIVATE(ibox,istartt,iendt,npts0,i,jbox,jstart,jend,npts)
C$OMP$SCHEDULE(DYNAMIC)      
            do ibox = laddr(1,ilev),laddr(2,ilev)
              istartt = itargse(1,ibox)
              iendt = itargse(2,ibox)
              npts0 = iendt-istartt+1
              
              do i=1,nlist1(ibox)
                jbox = list1(i,ibox)
                jstart = isrcse(1,jbox)
                jend = isrcse(2,jbox)
                npts = jend-jstart+1
                call l3ddirectcdh(nd,sourcesort(1,jstart),
     1             chargesort(1,jstart),
     2             dipvecsort(1,1,jstart),npts,targsort(1,istartt),
     2             npts0,pottarg(1,istartt),gradtarg(1,1,istartt),
     3             hesstarg(1,1,istartt),thresh)          
              enddo
            enddo
C$OMP END PARALLEL DO     
          endif
        endif
      enddo
 1000 continue      
 
      call cpu_time(time2)
C$        time2=omp_get_wtime()
      timeinfo(6) = time2-time1
      if(ifprint.ge.1) call prin2('timeinfo=*',timeinfo,6)
      d = 0
      do i = 1,6
         d = d + timeinfo(i)
      enddo

      if(ifprint.ge.1) call prin2('sum(timeinfo)=*',d,1)

      return
      end
c------------------------------------------------
      subroutine lfmm3dexpc_direct(nd,istart,iend,jstart,jend,
     $     source,ifcharge,charge,ifdipole,
     $     dipvec,expc,texps,scj,ntj,wlege,nlege)
c--------------------------------------------------------------------
c     This subroutine adds the local expansions due to sources
c     istart to iend in the source array at the expansion centers
c     jstart to jend in the expansion center array to the existing 
c     local expansions at the corresponding expansion centers.
c
c     INPUT arguments
c-------------------------------------------------------------------
c     nd           in: integer *8
c                  number of charge densities
c
c     istart       in:Integer
c                  Starting index in source array whose expansions
c                  we wish to add
c
c     iend         in:Integer
c                  Last index in source array whose expansions
c                  we wish to add
c
c     jstart       in: Integer
c                  First index in the expansion center array at 
c                  which we  wish to compute the expansions
c 
c     jend         in:Integer
c                  Last index in expansion center array at 
c                  which we wish to compute the expansions
c 
c     scjsort      in: double precision(*)
c                  Scale of expansions formed at the expansion centers
c
c     source       in: double precision(3,ns)
c                  Source locations
c
c     ifcharge     in: Integer
c                  flag for including expansions due to charges
c                  The expansion due to charges will be included
c                  if ifcharge == 1
c
c     charge       in: double precision
c                  Charge at the source locations
c
c     ifdipole     in: Integer
c                 flag for including expansions due to dipoles
c                 The expansion due to dipoles will be included
c                 if ifdipole == 1
c
c     dipvec      in: double precision(3,ns)
c                 Dipole orientation vector at the source locations
c
c     expc        in: double precision(3,nexpc)
c                 Expansion center locations
c
c     ntj         in: Integer
c                 Number of terms in expansion
c
c     wlege       in: double precision(0:nlege,0:nlege)
c                 precomputed array of recurrence relation
c                 coeffs for Ynm calculation.
c
c    nlege        in: integer *8
c                 dimension parameter for wlege
c------------------------------------------------------------
c     OUTPUT
c
c   Updated expansions at the targs
c   texps       out: double complex(0:ntj,-ntj:ntj,expc) 
c                 coeffs for local expansions
c-------------------------------------------------------               
        implicit none
c
        integer *8 istart,iend,jstart,jend,ns,j, nlege
        integer *8 ifcharge,ifdipole,ier,nd
        double precision source(3,*)
        double precision scj(*)
        double precision wlege(*)
        double precision charge(nd,*)
        double precision dipvec(nd,3,*)
        double precision expc(3,*)

        integer *8 nlevels,ntj
c
        double complex texps(nd,0:ntj,-ntj:ntj,*)
        
c
        ns = iend - istart + 1
        if(ifcharge.eq.1.and.ifdipole.eq.0) then
          do j=jstart,jend
            call l3dformtac(nd,scj(j),
     1        source(1,istart),charge(1,istart),ns,
     2        expc(1,j),ntj,texps(1,0,-ntj,j),wlege,nlege)
           enddo
         endif

         if(ifcharge.eq.0.and.ifdipole.eq.1) then
          do j=jstart,jend
            call l3dformtad(nd,scj(j),
     1        source(1,istart),
     2        dipvec(1,1,istart),ns,expc(1,j),ntj,texps(1,0,-ntj,j),
     3        wlege,nlege)
           enddo
         endif

         if(ifcharge.eq.1.and.ifdipole.eq.1) then
          do j=jstart,jend
            call l3dformtacd(nd,scj(j),
     1        source(1,istart),charge(1,istart),
     2        dipvec(1,1,istart),ns,expc(1,j),ntj,texps(1,0,-ntj,j),
     3        wlege,nlege)
           enddo
         endif

c
        return
        end

c
c     ROTATION VIA PROJECTION  
c
c     Multipole expansions for complex-valued functions.
c
c     Requires FFT and Associated Legendre Function Libraries.
c
c     User-callable routine is rotviaproj.
c     The other routines are used internally.
c
c***********************************************************************
      subroutine rotviaproj(nd,beta,nterms,m1,m2,mpole,lmp,
     1           marray2,lmpn)
c***********************************************************************
c       Purpose:
c
c	Fast and stable algorithm for applying rotation operator about
c	the y-axis determined by angle beta.
c
c       The method is based on computing the induced potential and
c       its theta-derivative on the rotated equator
c       for each order (first index). The coefficients of  the rotated
c       expansion can then be obtained by FFT and projection.
c
c       There is some loss in speed over using recurrence relations 
c       but it is stable to all orders whereas the recurrence schemes 
c       are not.
c
c       If the rotation operator is to be used multiple times, and
c       memory is available, one can precompute and store the 
c       multipliers used in evalall (see below). This has not yet been
c       implemented.
c
C---------------------------------------------------------------------
c       INPUT:
c
c       nd: number of multipole expansions
c       beta:  the rotation angle about the y-axis.
c       nterms: order of multipole expansion
C       mpole   coefficients of original multiple expansion
C       lmp     leading dim for mpole (must exceed nterms)
C       lmpn    leading dim for marray2 (must exceed nterms)
c
C---------------------------------------------------------------------
c       OUTPUT:
c
c       marray2  coefficients of rotated expansion.
c
C---------------------------------------------------------------------
c
c
c
      implicit none
      integer *8 idim,nd
      integer *8 nquad,ier,m1,m2,nterms,lmp,lmpn, next235_cproj_vec
      double precision beta
      double complex mpole(nd,0:lmp,-lmp:lmp)
      double complex marray2(nd,0:lmpn,-lmpn:lmpn)

      double precision, allocatable :: cthetas(:),cphis(:)
      double precision, allocatable :: sthetas(:),sphis(:)
      double precision, allocatable :: ynm(:,:),ynmd(:,:)
      double precision, allocatable :: rat1(:,:),rat2(:,:)
      double precision, allocatable :: wsave(:)
      
      double complex, allocatable :: avec(:),bvec(:)
      double complex, allocatable :: uder(:,:,:),uval(:,:,:)
      double complex, allocatable :: ephis(:)



      nquad = next235_cproj_vec((2*nterms+2)*1.0d0)

c
cc      allocate all temporary arrays
c

      allocate(cthetas(nquad),cphis(nquad))
      allocate(sthetas(nquad),sphis(nquad))
      allocate(ynm(0:nterms,0:nterms),ynmd(0:nterms,0:nterms))
      allocate(rat1(0:nterms,0:nterms),rat2(0:nterms,0:nterms))
      allocate(wsave(4*nquad+20))

      allocate(avec(nquad),bvec(nquad),uder(nd,nquad,0:nterms))
      allocate(uval(nd,nquad,0:nterms),ephis(-nterms:nterms))
c
c     Algorithm:
c     1) get locations of quadrature nodes
c     2) evaluate u and du/dtheta
c     3) project onto spherical harmonics.
c
      call getmeridian(beta,nquad,cthetas,sthetas,cphis,sphis)    
      call evalall(nd,beta,nquad,cthetas,sthetas,cphis,sphis,
     1           mpole,lmp,nterms,uval,uder,ynm,ynmd,ephis,rat1,rat2)
      call projectonynm(nd,nquad,uval,uder,ynm,ynmd,marray2,lmpn,
     1           nterms,m2,wsave,avec,bvec,rat1,rat2)

      return
      end
c
c
      function next235_cproj_vec(base)
      implicit none
      integer *8 next235_cproj_vec, numdiv
      real*8 base
c ----------------------------------------------------------------------
c     integer *8 function next235_cproj returns a multiple of 2, 3, and 5
c
c     next235_cproj = 2^p 3^q 5^r >= base  where p>=1, q>=0, r>=0
************************************************************************
      next235_cproj_vec = 2 * int(base/2d0+.9999d0)
      if (next235_cproj_vec.le.0) next235_cproj_vec = 2

100   numdiv = next235_cproj_vec
      do while (numdiv/2*2 .eq. numdiv)
         numdiv = numdiv /2
      enddo
      do while (numdiv/3*3 .eq. numdiv)
         numdiv = numdiv /3
      enddo
      do while (numdiv/5*5 .eq. numdiv)
         numdiv = numdiv /5
      enddo
      if (numdiv .eq. 1) return
      next235_cproj_vec = next235_cproj_vec + 2
      goto 100
      end
c
c
c***********************************************************************
      subroutine getmeridian(beta,nquad,cthetas,sthetas,cphis,
     1             sphis)
C***********************************************************************
C     Purpose:
C
C           For a rotation of angle BETA about the y-axis, this
C           subroutine returns the NQUAD equispaced nodes on the 
C           rotated equator in the original coordinate system.
C
C---------------------------------------------------------------------
C     INPUT:
C
C     beta  = angle of rotation
C     nquad = number of quadrature nodes in equator.
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     cthetas = cos(theta) values in original coordinate system of 
C                    nquad equispaced nodes
C     sthetas = sin(theta) values in original coordinate system of 
C                    nquad equispaced nodes
C     cphis =  cos(phi) values in original coordinate system of 
C                    nquad equispaced nodes
C     sphis =  cos(phi) values in original coordinate system of 
C                    nquad equispaced nodes
C
C***********************************************************************
      implicit double precision (a-h,o-z)
      integer *8 nquad,i,im1
      double precision cthetas(nquad)
      double precision sthetas(nquad)
      double precision cphis(nquad)
      double precision sphis(nquad)
C
      pi = 4.0d0*datan(1.0d0)
C
      ca = cos(beta)
      sa = sin(beta)
      do i = 1,nquad
	 im1 = i-1
         phi = 2*pi*im1/nquad
	 theta = pi/2.0d0
         xp = cos(phi)*sin(theta)
         yp = sin(phi)*sin(theta)
         zp = cos(theta)
         x = ca*xp + sa*zp
         y = yp
         z = -sa*xp + ca*zp
         proj = sqrt(x**2+y**2)
	 if (proj.le.1.0d-16) then
	    cphis(i) = 1.0d0
	    sphis(i) = 0.0d0
	 else
	    cphis(i) = x/proj
	    sphis(i) = y/proj
	 endif
	 cthetas(i) = z
	 sthetas(i) = proj
      enddo
      return
      end
C
C***********************************************************************
      subroutine evalall(nd,beta,nquad,cthetas,sthetas,cphis,sphis,
     1           mpole,lmp,nterms,uval,uder,ynm,ynmd,ephis,rat1,rat2)
C***********************************************************************
C
C     This subroutine evaluates the multipole expansion for each
C     order at the nquad nodes on the rotated equator.
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd      : numb3re of multipole expansions
C     beta    : angle of rotation about y-axis.
C     nquad    : number of target point son unit sphere
C     cthetas  : cos(theta) values of target points.
C     sthetas  : sin(theta) values of target points.
C     cphis    : cos(phi) values of target points.
C     sphis    : sin(phi) values of target points.
C     mpole    : original multipole expansion
C     nterms   : order of multipole expansion
C     ynm      : work array for ynm values
C     ynmd     : work array for ynmd values
C     ephis    : work array for exp(i m phi) values
C     rat1     : work array for accelerating ynm calculation.
C     rat2     : work array for accelerating ynm calculation.
C
C---------------------------------------------------------------------
C     OUTPUT:
C
C     uval(i,j) : contribution to potential 
C                 of multipole terms of order j at ith quad node.
C     uder(i,j) : contributions to theta derivative of potential
C                 of multipole terms of order j at ith quad node.
C
C***********************************************************************
      implicit double precision (a-h,o-z)
      integer *8 nd,idim,lmp,nterms
      integer *8 jj,i,jjr
      integer *8 ndeg,morder, nquad,nquad2,nquad4
      double precision cthetas(nquad),cphis(nquad)
      double precision sthetas(nquad),sphis(nquad)
      double precision ynm(0:nterms,0:nterms)
      double precision ynmd(0:nterms,0:nterms)
      double complex mpole(nd,0:lmp,-lmp:lmp)
      double complex ephi1,ephis(-nterms:nterms)
      double complex uder(nd,nquad,0:nterms),uval(nd,nquad,0:nterms)
      double complex uv,utheta,uphi,ztmp1,ztmp2,ztsum,ztdif
      double complex ux,uy,uz,ima
      double precision rat1(0:nterms,0:nterms)
      double precision rat2(0:nterms,0:nterms)
C
      data ima/(0.0d0,1.0d0)/
      pi = 4.0d0*datan(1.0d0)
C
      cbeta = cos(beta)
      sbeta = -sin(beta)
      call ylgndrini(nterms,rat1,rat2)
      nquad2=nquad/2
      if( mod(nquad2,2) .eq. 0 ) nquad4=nquad2/2+1
      if( mod(nquad2,2) .eq. 1 ) nquad4=nquad2/2+1
c
      do jj=1,nquad4
         ctheta = cthetas(jj)
         stheta = sthetas(jj)
         cphi = cphis(jj)
         sphi = sphis(jj)
         dir1 = -sbeta
         dir2 = 0
         dir3 = cbeta
         tang1 = cphi*ctheta
         tang2 = sphi*ctheta
         tang3 = -stheta
         proj2 = tang1*dir1 + tang2*dir2 + tang3*dir3
         tang1 = -sphi
         tang2 = cphi
         tang3 = 0
         proj1 = tang1*dir1 + tang2*dir2 + tang3*dir3
         call ylgndru2sf(nterms,ctheta,ynm,ynmd,rat1,rat2)
         ephi1 = dcmplx(cphis(jj),sphis(jj))
         ephis(1) = ephi1
         ephis(-1) = dconjg(ephi1)
	     do i = 2,nterms
	        ephis(i) = ephis(i-1)*ephi1
	        ephis(-i) = dconjg(ephis(i))
	     enddo
	     do ndeg = 0,nterms
            do idim=1,nd
	           uv=0
	           utheta=0
	           uphi=0
	           do morder = 1,ndeg
                  ztmp1=ephis(morder)*mpole(idim,ndeg,morder)
                  ztmp2=ephis(-morder)*mpole(idim,ndeg,-morder)
	              ztsum=ztmp1+ztmp2
	              ztdif=ztmp1-ztmp2
	              uv=uv+ynm(ndeg,morder)*ztsum
	              utheta=utheta+ynmd(ndeg,morder)*ztsum
	              uphi=uphi-ynm(ndeg,morder)*morder*ztdif
	           enddo
	           uv=stheta*uv+ynm(ndeg,0)*mpole(idim,ndeg,0)
	           utheta=utheta+ynmd(ndeg,0)*stheta*mpole(idim,ndeg,0)
c
c       ... apply the periodizing operator
c
                uval(idim,jj,ndeg) = uv
                uder(idim,jj,ndeg) = (utheta*proj2+uphi*ima*proj1)
                if( mod(ndeg,2) .eq. 0 ) then
                   uval(idim,jj+nquad/2,ndeg) = +uval(idim,jj,ndeg)
                   uder(idim,jj+nquad/2,ndeg) = -uder(idim,jj,ndeg)
                endif
                if( mod(ndeg,2) .eq. 1 ) then
                   uval(idim,jj+nquad/2,ndeg) = -uval(idim,jj,ndeg)
                   uder(idim,jj+nquad/2,ndeg) = +uder(idim,jj,ndeg)
                endif
	         enddo
          enddo

          if_reflect=1
          if( jj .eq. 1 ) if_reflect=0
          if( jj .eq. nquad4 .and. mod(nquad2,2) .eq. 0 ) if_reflect=0
c
          if( if_reflect .eq. 1 ) then
             jjr=nquad2 - jj + 2
             call ylgndr2pm_opt(nterms,ynm,ynmd)
             ctheta = -cthetas(jj)
             stheta = sthetas(jj)
             cphi = -cphis(jj)
             sphi = sphis(jj)
             dir1 = -sbeta
             dir2 = 0
             dir3 = cbeta
             tang1 = cphi*ctheta
             tang2 = sphi*ctheta
             tang3 = -stheta
             proj2 = tang1*dir1 + tang2*dir2 + tang3*dir3
             tang1 = -sphi
             tang2 = cphi
             tang3 = 0
             proj1 = tang1*dir1 + tang2*dir2 + tang3*dir3
             ephi1 = dcmplx(cphi,sphi)
             ephis(1) = ephi1
	         ephis(-1) = dconjg(ephi1)
	         do i = 2,nterms
	            ephis(i) = ephis(i-1)*ephi1
	            ephis(-i) = dconjg(ephis(i))
	         enddo
	         do ndeg = 0,nterms
                do idim=1,nd
	               uv=0
	               utheta=0
	               uphi=0
	               do morder = 1,ndeg
                      ztmp1=ephis(morder)*mpole(idim,ndeg,morder)
                      ztmp2=ephis(-morder)*mpole(idim,ndeg,-morder)
	                  ztsum=ztmp1+ztmp2
	                  ztdif=ztmp1-ztmp2
	                  uv=uv+ynm(ndeg,morder)*ztsum
	                  utheta=utheta+ynmd(ndeg,morder)*ztsum
	                  uphi=uphi-ynm(ndeg,morder)*morder*ztdif
	               enddo
	               uv=stheta*uv+ynm(ndeg,0)*mpole(idim,ndeg,0)
                   utheta=utheta+ynmd(ndeg,0)*stheta*mpole(idim,ndeg,0)
c
c       ... apply the periodizing operator
c
                   uval(idim,jjr,ndeg) = uv
                   uder(idim,jjr,ndeg) = (utheta*proj2+uphi*ima*proj1)
                   if( mod(ndeg,2) .eq. 0 ) then
                      uval(idim,jjr+nquad/2,ndeg) = +uval(idim,jjr,ndeg)
                      uder(idim,jjr+nquad/2,ndeg) = -uder(idim,jjr,ndeg)
                   endif
                   if( mod(ndeg,2) .eq. 1 ) then
                      uval(idim,jjr+nquad/2,ndeg)=-uval(idim,jjr,ndeg)
                      uder(idim,jjr+nquad/2,ndeg)=+uder(idim,jjr,ndeg)
                   endif
	            enddo
             enddo
         endif
      enddo

      return
      end
C
C
C
C
C
C***********************************************************************
      subroutine projectonynm(nd,nquad,uval,uder,
     1           ynm,ynmd,marray,lmpn,nterms,m2,wsave,avec,bvec,
     $           rat1,rat2)
C***********************************************************************
C
C     This subroutine projects from values on equator for each multipole
C     order (uval, uder = dudthteta) 
C     onto spherical harmonics
C
C---------------------------------------------------------------------
C     INPUT:
C
C     nd       : number of multipole expansions
C     nquad    : number of points on equator
C     uval     : F values on equator
C     uder     : dFdtheta values on equator
C     ynm      : work array for ynm values
C     ynmd     : work array for ynmd values
C     lmpn     : leading dim of marray (must exceed nterms)
C     nterms   : order of expansion
C     m2       : NOT IMPLEMENTED (for reduced number of degrees in 
C                expansion (second index)
C     wsave    : work array for FFT (dimension at least 4*nquad+20)
C     avec     : work array of length nquad for FFT (complex)
C     bvec     : work array of length nquad for FFT (complex)
C---------------------------------------------------------------------
C     OUTPUT:
C
C     marray   : rotated expansion 
C
C
C***********************************************************************
      implicit double precision (a-h,o-z)
      integer *8 nquad, norder,nterms,lmpn,m2
      integer *8 nd,idim
      integer *8 nquad_4
      double complex ephi,ephi1,uval(nd,nquad,0:1)
      double complex uder(nd,nquad,0:1)
      double complex utheta,uphi,ztmp1,ztmp2
      double complex alpha,beta,ima
      double complex marray(nd,0:lmpn,-lmpn:lmpn)
      double precision ynm(0:nterms,0:nterms)
      double precision ynmd(0:nterms,0:nterms)
      double precision wsave(4*nquad+20)
      double complex avec(nquad)
      double complex bvec(nquad)
      double precision rat1(0:nterms,0:nterms)
      double precision rat2(0:nterms,0:nterms)
C
      data ima/(0.0d0,1.0d0)/
c
      ctheta = 0.0d0
      stheta = 1.0d0
      h = 1.0d0/nquad
      nquad_4 = nquad
      call ylgndru2sf(nterms,ctheta,ynm,ynmd,rat1,rat2)
      call zffti(nquad_4,wsave)
      do norder=0,nterms
         d=sqrt(2*norder+1.0d0)
         do idim=1,nd
   	        do ii = 1,nquad
               avec(ii) = uval(idim,ii,norder)*d + uder(idim,ii,norder)
            enddo
	        call zfftf(nquad_4,avec,wsave)
            do m = -norder,norder
	           if (m.ge.0)  alpha = avec(m+1)*h
	           if (m.lt.0)  alpha = avec(nquad+m+1)*h
               marray(idim,norder,m) = alpha/
     1            (ynm(norder,abs(m))*d - (ynmd(norder,abs(m))))
            enddo
         enddo
      enddo
      return
      end
c
c
c
c
c
c***********************************************************************

      implicit real *8 (a-h,o-z)
      integer ntests,nsuccess
      complex *16 zk,ima

      data ima/(0.0d0,1.0d0)/

      done = 1
      pi = atan(done)*4

      zk = 300.0d0
      call test_helm_zkbig(zk,i1)

      zk = 300.0d0*ima
      call test_helm_zkbig(zk,i2)

      zk = 12*pi*ima*4
      call test_helm_zkbig(zk,i3)


      zk = 12*pi*ima/32

      call test_helm_zkbig(zk,i4)

      zk = 12*pi*ima + 0.01d0
      call test_helm_zkbig(zk,i5)

      zk = (12*pi*ima + 12*pi)/10
      call test_helm_zkbig(zk,i6)

      nsuccess = i1+i2+i3+i4+i5+i6
      ntest = 6
      open(unit=33,file='print_testres.txt',access='append')
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ', nsuccess,
     1   ' out of ', ntest, ' in hfmm3d zkbig testing suite'

      stop
      end



      subroutine test_helm_zkbig(zk,isuccess)
      
      implicit none
      integer ns
      double precision, allocatable :: source(:,:)
      double complex, allocatable :: charge(:),dipvec(:,:)
      double complex, allocatable :: pot(:),potex(:)
      double complex, allocatable :: grad(:,:),gradex(:,:)

      double precision eps
      double complex eye,zk
      integer i,j,k,ntest
      double precision hkrand,thresh,erra,ra
      integer isuccess
      

      data eye/(0.0d0,1.0d0)/

c
cc      initialize printing routine
c
      call prini(6,13)
      write(*,*)
      write(*,*)
      write(*,*) "================================="
      write(*,*)
      write(*,*)



      ns = 10000
      

      allocate(source(3,ns))
      allocate(charge(ns))
      allocate(dipvec(3,ns))
      allocate(pot(ns))
      allocate(grad(3,ns))


      eps = 0.51d-3


c
c   
c       example demonstrating use of 
c        source to source, charges, pot + gradient
c



c
cc      generate sources with distribution unif^2 
c
c
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2

        charge(i) = hkrand(0) + eye*hkrand(0)
        dipvec(1,i) = hkrand(0) + eye*hkrand(0)
        dipvec(2,i) = hkrand(0) + eye*hkrand(0)
        dipvec(3,i) = hkrand(0) + eye*hkrand(0)

        pot(i) = 0
        grad(1,i) = 0
        grad(2,i) = 0
        grad(3,i) = 0 
      enddo


      call hfmm3d_s_c_g(eps,zk,ns,source,charge,
     1      pot,grad)
      ntest = 10
      allocate(potex(ntest),gradex(3,ntest))

      thresh = 2.0d0**(-51)

      do i=1,ntest
        potex(i) = 0
        gradex(1,i) = 0
        gradex(2,i) = 0
        gradex(3,i) = 0
      enddo

      call h3ddirectcg(1,zk,source,charge,ns,source,
     1  ntest,potex,gradex,thresh)

      erra = 0
      ra = 0
      do i=1,ntest
        erra = erra + abs(potex(i)-pot(i))**2
        erra = erra + abs(gradex(1,i)-grad(1,i))**2
        erra = erra + abs(gradex(2,i)-grad(2,i))**2
        erra = erra + abs(gradex(3,i)-grad(3,i))**2

        ra = ra + abs(potex(i))**2
        ra = ra + abs(gradex(1,i))**2 + abs(gradex(2,i))**2 +
     1   abs(gradex(3,i))**2
      enddo

      erra = sqrt(erra/ra)

      call prin2('zk=*',zk,1)
      call prin2('l2 rel err=*',erra,1)

      isuccess = 0

      if(erra.lt.eps) isuccess = 1
      

      return
      end
c----------------------------------------------------------
c
cc
c
c

c
c      l3dterms - determine number of terms in mpole expansions 
c
c      l3dterms_list2 - build tables for the number of terms needed 
c           for all boxes in list 2
c
c      l3dterms_list2w - build table for the number of terms needed 
c           for all boxes in list 2, using worst case error analysis
c
c      l3dterms_list2e - build tables of the number of terms needed 
c           for all boxes in extended list 2
c
c      l3dterms_list2ew - build tables of the number of terms needed 
c           for all boxes in extended list 2, using worst case analysis
c
c-----------------------------------------------------------------------------
c
c
c
c***********************************************************************
      subroutine l3dterms(eps, nterms)
c***********************************************************************
c
c     Determine number of terms in mpole expansions.
c
c     The method is based on examining the decay of \rho^n / r^{n+1}
c     for \rho a worst case source and r a worst case target.
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     nterms  required expansion order
c-----------------------------------------------------------------------
c
      implicit none
      integer *8 j,nterms
      real *8 xtemp1,eps
      real *8 z1,z2,hfun,jfun
c
      z1 = 1.5d0
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          nterms = j
          return
        endif
      enddo
      return
      end
c
c
c
c
c***********************************************************************
      subroutine l3dterms_far(eps, nterms)
c***********************************************************************
c
c     Determine number of terms in mpole expansions for box of size
c     "size" with Helmholtz parameter zk=0. 
c
c     The method is based on examining the decay of h_n * j_n.
c
c     This routine assumes slightly larger separation of boxes: the
c     first unit box is located at the origin and the second box is
c     located at (3,0,0).
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     nterms  required expansion order
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 nterms,j,ier
      real *8 eps,jfun,hfun,z1,z2,xtemp1
c
      ier = 0
c
      z1 = 2.5d0
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = hfun*jfun
        if(xtemp1 .lt. eps)then
          nterms = j
          return
        endif
      enddo
      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine l3dterms_list2(eps, itable, ier)
c***********************************************************************
c
c
c     Determine number of terms in mpole expansions for box of size
c     "size" with Helmholtz parameter zk.
c
c     The method is based on examining the decay of h_n * j_n.
c
c     Build nterms table for all boxes in list 2
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     itable  table of needed  expansion orders in FMM.
c     ier     error flag (0 means correct execution).
c                        (1 means 1000 terms is insufficient).
c
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 nterms,ier,ii,jj,kk,i,j,k
      real *8 xtemp1,z1,z2,z3,jfun,hfun 
      real *8 eps,rr,dx,dy,dz
c
      integer *8 nterms_table(2:3,0:3,0:3)
      integer *8 itable(-3:3,-3:3,-3:3)
c
      ier = 0
c
      do ii=2,3
      do jj=0,3
      do kk=0,3
c
        dx=ii
        dy=jj
        dz=kk
c       
        if( dx .gt. 0 ) dx=dx-.5
        if( dy .gt. 0 ) dy=dy-.5
        if( dz .gt. 0 ) dz=dz-.5
c
        rr=sqrt(dx*dx+dy*dy+dz*dz)
ccc        call prin2('rr=*',rr,1)
ccc        call prin2('rr=*',sqrt(3.0d0)/2*5,1)
c
      z1 = rr
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          ier = 0
          nterms = j
          exit
        endif
        ier = 1
      enddo
c
        nterms_table(ii,jj,kk)=nterms
c
      enddo
      enddo
      enddo
c
ccc        call prinf('nterms=*',nterms_table,2*4*4)
c
c       build the rank table for all boxes in list 2
c
        do i=-3,3
        do j=-3,3
        do k=-3,3
        itable(i,j,k)=0
        enddo
        enddo
        enddo
c
        do k=-3,3
        do i=-3,3
        do j=-3,3
c
        if( abs(i) .gt. 1 ) then
        itable(i,j,k)=nterms_table(abs(i),abs(j),abs(k))
        else if( abs(j) .gt. 1) then
        itable(i,j,k)=nterms_table(abs(j),abs(i),abs(k))
        endif
c
        if( abs(i) .le. 1 .and. abs(j) .le. 1) then
        if( abs(k) .gt. 1 ) then
c
        if( abs(i) .ge. abs(j) ) then
        itable(i,j,k)=nterms_table(abs(k),abs(i),abs(j))
        else
        itable(i,j,k)=nterms_table(abs(k),abs(j),abs(i))
        endif
c
        endif
        endif
c
        enddo
        enddo
        enddo
c
      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine l3dterms_list2w(eps, itable, ier)
c***********************************************************************
c
c     Build nterms table for all boxes in list 2
c     Estimate worst case multipole to local translation operator errors.
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     itable  table of needed  expansion orders in FMM.
c     ier     error flag (0 means correct execution).
c                        (1 means 1000 terms is insufficient).
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 nterms,ier,ii,jj,kk,i,j,k
      real *8 z1,z2,z3,jfun,hfun,xtemp1,eps
      real *8 rr,dx,dy,dz
c
      integer *8 nterms_table(2:3,0:3,0:3)
      integer *8 itable(-3:3,-3:3,-3:3)
c
      ier = 0
c
      do ii=2,3
      do jj=0,3
      do kk=0,3
c
        dx=ii
        dy=jj
        dz=kk
c       
c        if( dx .gt. 0 ) dx=dx-.5
c        if( dy .gt. 0 ) dy=dy-.5
c        if( dz .gt. 0 ) dz=dz-.5
c
        rr=sqrt(dx*dx+dy*dy+dz*dz)
        rr=rr-sqrt(3.0d0)/2
ccc        call prin2('rr=*',rr,1)
ccc        call prin2('rr=*',sqrt(3.0d0)/2*5,1)
c
      z1 = rr
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          ier = 0
          nterms = j
          exit
        endif
        ier = 1
      enddo
c
        nterms_table(ii,jj,kk)=nterms
c
      enddo
      enddo
      enddo
c
ccc        call prinf('nterms=*',nterms_table,2*4*4)
c
c       build the rank table for all boxes in list 2
c
        do i=-3,3
        do j=-3,3
        do k=-3,3
        itable(i,j,k)=0
        enddo
        enddo
        enddo
c
        do k=-3,3
        do i=-3,3
        do j=-3,3
c
        if( abs(i) .gt. 1 ) then
        itable(i,j,k)=nterms_table(abs(i),abs(j),abs(k))
        else if( abs(j) .gt. 1) then
        itable(i,j,k)=nterms_table(abs(j),abs(i),abs(k))
        endif
c
        if( abs(i) .le. 1 .and. abs(j) .le. 1) then
        if( abs(k) .gt. 1 ) then
c
        if( abs(i) .ge. abs(j) ) then
        itable(i,j,k)=nterms_table(abs(k),abs(i),abs(j))
        else
        itable(i,j,k)=nterms_table(abs(k),abs(j),abs(i))
        endif
c
        endif
        endif
c
        enddo
        enddo
        enddo
c
      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine l3dterms_list2e(eps, itable, ier)
c***********************************************************************
c
c
c     Build nterms table for all boxes in extended list 2
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     itable  table of needed  expansion orders in FMM.
c     ier     error flag (0 means correct execution).
c                        (1 means 1000 terms is insufficient).
c
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 nterms,ier,ii,jj,kk,i,j,k
      real *8 z1,z2,z3,jfun,hfun,xtemp1,eps
      real *8 rr,dx,dy,dz
c
      integer *8 nterms_table(2:7,0:7,0:7)
      integer *8 itable(-7:7,-7:7,-7:7)
c
      ier = 0
c
      do ii=2,7
      do jj=0,7
      do kk=0,7
c
        dx=ii
        dy=jj
        dz=kk
c       
        if( dx .gt. 0 ) dx=dx-.5
        if( dy .gt. 0 ) dy=dy-.5
        if( dz .gt. 0 ) dz=dz-.5
c
        rr=sqrt(dx*dx+dy*dy+dz*dz)
ccc        call prin2('rr=*',rr,1)
ccc        call prin2('rr=*',sqrt(3.0d0)/2*5,1)
c
      z1 = rr
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          ier = 0
          nterms = j
          exit
        endif
        ier = 1
      enddo
c
        nterms_table(ii,jj,kk)=nterms
c
      enddo
      enddo
      enddo
c
ccc        call prinf('nterms=*',nterms_table,2*6*6)
c
c       build the rank table for all boxes in extended list 2
c
        do i=-7,7
        do j=-7,7
        do k=-7,7
        itable(i,j,k)=0
        enddo
        enddo
        enddo
c
        do k=-7,7
        do i=-7,7
        do j=-7,7
c
        if( abs(i) .gt. 2 ) then
        itable(i,j,k)=nterms_table(abs(i),abs(j),abs(k))
        else if( abs(j) .gt. 2) then
        itable(i,j,k)=nterms_table(abs(j),abs(i),abs(k))
        endif
c
        if( abs(i) .le. 2 .and. abs(j) .le. 2) then
        if( abs(k) .gt. 2 ) then
c
        if( abs(i) .ge. abs(j) ) then
        itable(i,j,k)=nterms_table(abs(k),abs(i),abs(j))
        else
        itable(i,j,k)=nterms_table(abs(k),abs(j),abs(i))
        endif
c
        endif
        endif
c
       enddo
       enddo
       enddo
c
      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine l3dterms_list2ew(eps, itable, ier)
c***********************************************************************
c
c
c     Build nterms table for all boxes in extended list 2
c     Estimate worst case multipole to local translation operator errors.
c
c     INPUT:
c
c     eps   tolerance
c
c     OUTPUT:
c
c     itable  table of needed  expansion orders in FMM.
c     ier     error flag (0 means correct execution).
c                        (1 means 1000 terms is insufficient).
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 nterms,ier,ii,jj,kk,i,j,k
      real *8 z1,z2,z3,jfun,hfun,xtemp1,eps
      real *8 rr,dx,dy,dz
c
      integer *8 nterms_table(2:7,0:7,0:7)
      integer *8 itable(-7:7,-7:7,-7:7)
c
      ier = 0
c
      do ii=2,7
      do jj=0,7
      do kk=0,7
c
        dx=ii
        dy=jj
        dz=kk
c       
c        if( dx .gt. 0 ) dx=dx-.5
c        if( dy .gt. 0 ) dy=dy-.5
c        if( dz .gt. 0 ) dz=dz-.5
c
        rr=sqrt(dx*dx+dy*dy+dz*dz)
        rr=rr-sqrt(3.0d0)/2
ccc        call prin2('rr=*',rr,1)
ccc        call prin2('rr=*',sqrt(3.0d0)/2*5,1)
c
      z1 = rr
      z2 = dsqrt(3d0)/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          ier = 0
          nterms = j
          exit
        endif
        ier = 1
      enddo
c
        nterms_table(ii,jj,kk)=nterms
c
      enddo
      enddo
      enddo
c
ccc        call prinf('nterms=*',nterms_table,2*6*6)
c
c       build the rank table for all boxes in extended list 2
c
        do i=-7,7
        do j=-7,7
        do k=-7,7
        itable(i,j,k)=0
        enddo
        enddo
        enddo
c
        do k=-7,7
        do i=-7,7
        do j=-7,7
c
        if( abs(i) .gt. 2 ) then
        itable(i,j,k)=nterms_table(abs(i),abs(j),abs(k))
        else if( abs(j) .gt. 2) then
        itable(i,j,k)=nterms_table(abs(j),abs(i),abs(k))
        endif
c
        if( abs(i) .le. 2 .and. abs(j) .le. 2) then
        if( abs(k) .gt. 2 ) then
c
        if( abs(i) .ge. abs(j) ) then
        itable(i,j,k)=nterms_table(abs(k),abs(i),abs(j))
        else
        itable(i,j,k)=nterms_table(abs(k),abs(j),abs(i))
        endif
c
        endif
        endif
c
       enddo
       enddo
       enddo
c
      return
      end
c
c
c
c
c
c***********************************************************************
      subroutine l3dterms_eval(itype, eps, nterms, ier)
c***********************************************************************
c
c
c     Determine number of terms in mpole expansions for box of size
c     "size" with Helmholtz parameter zk.
c
c     The method is based on examining the decay of h_n * j_n.
c
c     INPUT:
c
c     itype   flag determining precise geometry (see code below).
c     eps     tolerance
c
c     OUTPUT:
c
c     nterms  required expansion order
c     ier     error flag (0 means correct execution).
c                        (1 means 1000 terms is insufficient).
c-----------------------------------------------------------------------------
c
      implicit none
      integer *8 itype,nterms,ier,ii,jj,kk,i,j,k
      real *8 z1,z2,z3,jfun,hfun,xtemp1,eps
      real *8 rr,dx,dy,dz
c
      ier = 0
c
      z1 = 1.5d0
      z2 = dsqrt(3d0)/2.d0
c
c     corners included
      if( itype .eq. 1 ) z2 = dsqrt(3d0)/2.d0
c     edges included, no corners
      if( itype .eq. 2 ) z2 = dsqrt(2d0)/2.d0
c     center only
      if( itype .eq. 3 ) z2 = 1.0d0/2.d0
c     center only, small interior sphere
      if( itype .eq. 4 ) z2 = 0.8d0/2.d0
c
      jfun = z2
      hfun = 1.0d0/(z1**2)
      nterms = 1
      do j = 2, 1000
        hfun = hfun/z1
        jfun = jfun*z2
        xtemp1 = jfun*hfun
        if(xtemp1 .lt. eps)then
          nterms = j
          return
        endif
      enddo
      ier = 1
      return
      end

c      This file contains the direct evaluation kernels for Helmholtz FMM
c       using the sctl library
c
c      h3ddirectcp:  direct calculation of potential for a collection 
c                         of charge sources at a collection of targets
c
c      h3ddirectcg:  direct calculation of potential and gradient 
c                         for a collection of charge sources at a 
c                         collection of targets
c
c      h3ddirectdp:  direct calculation of potential for a collection 
c                         of dipole sources at a collection of targets
c
c      h3ddirectdg:  direct calculation of potential and gradient 
c                         for a collection of dipole sources at a 
c                         collection of targets
c
c      h3ddirectcdp:  direct calculation of potential for a 
c                         collection of charge and dipole sources at 
c                         a collection of targets
c
c      h3ddirectcdg:  direct calculation of potential 
c                         and gradient for a collection 
c                         of charge and dipole sources at a 
c                         collection of targets
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|
c                        j
c                 
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
      call h3ddirectcp_cpp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,thresh)

      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcg(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|
c                        j
c                 
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|)
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
      call h3ddirectcg_cpp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectch(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|
c                        j
c                 
c     grad(x)=grad(x)+Gradient(sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|)
c                               j
c     hess(x)=hess(x)+Hessian(sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}|)
c                              j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated Hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      complex *16 hess(nd,6,nt)
      real *8 thresh

            call h3ddirectch_cpp(nd,zk,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectdp(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                        j
c
c                            
c   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 pot(nd,nt)
      real *8 thresh
      
      call h3ddirectdp_cpp(nd,zk,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectdg(nd,zk,sources,dipvec,ns,ztarg,nt,pot,
     1   grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                        j
c
c                            
c   
c     grad(x) = grad(x) + Gradient( sum
c                                    j
c
c                           1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
      call h3ddirectdg_cpp(nd,zk,sources,dipvec,ns,ztarg,nt,pot,
     1   grad,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine h3ddirectdh(nd,zk,sources,dipvec,ns,ztarg,nt,pot,
     1   grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x)=pot(x)+sum d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                    j
c
c     grad(x)=grad(x)+Gradient( sum  
c                                j
c
c                        1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                        )
c                                   
c     hess(x)=hess(x)+Hessian( sum  
c                               j
c
c                       1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                       )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated Hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess

c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 pot(nd,nt),grad(nd,3,nt)
      complex *16 hess(nd,6,nt)
      real *8 thresh
      
      call h3ddirectdh_cpp(nd,zk,sources,dipvec,ns,ztarg,nt,pot,
     1   grad,hess,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcdp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +
c                        j
c
c                           1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
      call h3ddirectcdp_cpp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcdg(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +
c                        j
c
c                            1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +
c                                    j
c
c                           1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 dipvec(nd,3,ns)
      complex *16 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      

      call h3ddirectcdg_cpp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine h3ddirectcdh(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +
c                        j
c
c                        1/(4\pi) \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c   
c     grad(x)=grad(x)+Gradient( sumq_{j} 1/(4\pi) e^{i k |x-x_{j}|}/|x-x_{j}|+
c                                j
c
c                   1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                   )
c                                   
c     hess(x)=hess(x)+Hessian( sum 1/(4\pi) q_{j} e^{i k |x-x_{j}|}/|x-x_{j}| +
c                               j
c
c                   1/(4\pi) d_{j} \nabla e^{ik |x-x_{j}|/|x-x_{j}| \cdot v_{j}
c                   )
c                                   
c      where q_{j} is the charge strength
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If r < thresh 
c          then the subroutine does not update the potential
c          (recommended value = boxsize(0)*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     zk     :    Helmholtz parameter
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated Hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,zk,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      complex *16 zk
      real *8 sources(3,ns),ztarg(3,nt)
      complex *16 charge(nd,ns),dipvec(nd,3,ns)
      complex *16 pot(nd,nt),grad(nd,3,nt)
      complex *16 hess(nd,6,nt)
      real *8 thresh
      
      call h3ddirectcdh_cpp(nd,zk,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)

      return
      end
c
c
c

c      This file contains the direct evaluation kernels for Laplace FMM
c       using the SCTL library
c
c      l3ddirectcp: direct calculation of potential for a collection
c                     of charge sources to a collection of targets
c 
c      l3ddirectcg: direct calculation of potential and gradients 
c                   for a collection of charge sources to a 
c                   collection of targets
c 
c      l3ddirectch: direct calculation of potential, gradients and
c                   hessians for a collection of charge sources to a
c                   collection of targets
c 
c      l3ddirectdp: direct calculation of potential for a collection
c                     of dipole sources to a collection of targets
c 
c      l3ddirectdg: direct calculation of potential and gradients 
c                   for a collection of dipole sources to a 
c                   collection of targets
c 
c      l3ddirectdh: direct calculation of potential, gradients and
c                   hessians for a collection of dipole sources to a
c                   collection of targets
c 
c      l3ddirectcdp: direct calculation of potential for a collection
c                     of charge and dipole sources to a collection 
c                     of targets
c 
c      l3ddirectcdg: direct calculation of potential and gradients 
c                   for a collection of charge and dipole sources to 
c                   a collection of targets
c
c      l3ddirectcdh: direct calculation of potential, gradients and
c                   hessians for a collection of charge and dipole
c                   sources to a collection of targets
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcp(nd,sources,charge,ns,ztarg,nt,
     1            pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} /|x-x_{j}| 
c                        j
c                 
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
      call l3ddirectcp_cpp(nd,sources,charge,ns,ztarg,nt,
     1            pot,thresh)

      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcg(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} /|x-x_{j}| 
c                        j
c                 
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} /|x-x_{j}|) 
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      
      call l3ddirectcg_cpp(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,thresh)


      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectch(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} /|x-x_{j}|
c                        j
c
c     grad(x) = grad(x) + Gradient(sum 1/(4\pi) q_{j} /|x-x_{j}|)
c
c     hess(x) = hess(x) + Hessian(sum 1/(4\pi) q_{j} /|x-x_{j}|)
c                                   j
c      where q_{j} is the charge strength
c      If |r| < thresh
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain)
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge densities
c     sources:    source locations
C     charge :    charge strengths
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location
c
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg
c     grad   :    updated gradient at ztarg
c     hess   :    updated hessian at ztarg
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt)
      real *8 charge(nd,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh

      call l3ddirectch_cpp(nd,sources,charge,ns,ztarg,nt,
     1            pot,grad,hess,thresh)

      return
      end
c
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum  1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j} 
c   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt)
      real *8 thresh
      
      call l3ddirectdp_cpp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,thresh)

      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdg(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) d_{j} \nabla 1/|x-x_{j}| \cdot v_{j}
c                        j
c   
c     grad(x) = grad(x) + Gradient( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      

      call l3ddirectdg_cpp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectdh(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) d_{j} \nabla 1/|x-x_{j}| \cdot v_{j}
c                        j
c   
c     grad(x) = grad(x) + Gradient( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c     hess(x) = hess(x) + Hessian( sum  
c                                    j
c
c                            1/(4\pi) \nabla 1|/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated gradient at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh
      
      call l3ddirectdh_cpp(nd,sources,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential due to a collection
c     of sources and adds to existing
c     quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable 
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vectors
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns),pot(nd,nt)
      real *8 thresh
      
      call l3ddirectcdp_cpp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,thresh)


      return
      end
c
c
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdg(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                                    j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns),pot(nd,nt),grad(nd,3,nt)
      real *8 thresh
      

      call l3ddirectcdg_cpp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,thresh)

      return
      end
c
c
c
c
C***********************************************************************
      subroutine l3ddirectcdh(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)
c**********************************************************************
c
c     This subroutine evaluates the potential and gradient due to a 
c     collection of sources and adds to existing quantities.
c
c     pot(x) = pot(x) + sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                        j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c   
c     grad(x) = grad(x) + Gradient( sum 1/(4\pi) q_{j} 1/|x-x_{j}| +  
c                                    j
c
c                            1/(4\pi) \nabla 1/|x-x_{j}| \cdot v_{j}
c                            )
c                                   
c      where q_{j} is the charge strength, 
c      and v_{j} is the dipole orientation vector, 
c      \nabla denotes the gradient is with respect to the x_{j} 
c      variable, and Gradient denotes the gradient with respect to
c      the x variable
c      If |r| < thresh 
c          then the subroutine does not update the potential
c          (recommended value = |boxsize(0)|*machine precision
c           for boxsize(0) is the size of the computational domain) 
c
c
c-----------------------------------------------------------------------
c     INPUT:
c
c     nd     :    number of charge and dipole densities
c     sources:    source locations
C     charge :    charge strengths
C     dipvec :    dipole orientation vector
C     ns     :    number of sources
c     ztarg  :    target locations
c     ntarg  :    number of targets
c     thresh :    threshold for updating potential,
c                 potential at target won't be updated if
c                 |t - s| <= thresh, where t is the target
c                 location and, and s is the source location 
c                 
c-----------------------------------------------------------------------
c     OUTPUT:
c
c     pot    :    updated potential at ztarg 
c     grad   :    updated gradient at ztarg 
c     hess   :    updated Hessian at ztarg 
c                 using ordering (dxx,dyy,dzz,dxy,dxz,dyz)
c
c-----------------------------------------------------------------------
      implicit none
cf2py intent(in) nd,sources,charge,dipvec,ns,ztarg,nt,thresh
cf2py intent(out) pot,grad,hess
c
cc      calling sequence variables
c  
      integer *8 ns,nt,nd
      real *8 sources(3,ns),ztarg(3,nt),dipvec(nd,3,ns)
      real *8 charge(nd,ns)
      real *8 pot(nd,nt),grad(nd,3,nt),hess(nd,6,nt)
      real *8 thresh
      
      call l3ddirectcdh_cpp(nd,sources,charge,
     1            dipvec,ns,ztarg,nt,pot,grad,hess,thresh)

      return
      end

c
c      TESTING SUITE FOR STOKES KERNELS:  June 18th, 2020
c
c
      implicit real *8 (a-h,o-z)
      real *8 ztrg(3),source(3,20),targ(3,20),targ2(3,20)
      real *8 errgrad(3,20), pert(3), dmu(3), dnu(3)
      
      real *8, allocatable :: pot(:,:), pre(:), grad(:,:,:)
      real *8, allocatable :: pot2(:,:), pre2(:), grad2(:,:,:)      

      real *8, allocatable :: potl(:,:), gradl(:,:,:)
      
      real *8, allocatable :: stoklet(:,:), strslet(:,:)
      real *8, allocatable :: strsvec(:,:)
      real *8, allocatable :: charge(:,:), dipvec(:,:,:)
      
      integer *8 ipass(5)
      integer *8 ns,nt,nd1,ndl,istress
      integer *8 i,j,l,ntest,isum
      complex *16 eye
c
      data eye/(0.0d0,1.0d0)/
c
      done=1
      pi=4.0*atan(done)
      call prini(6,13)
      write(*,*) "=========================================="
      write(*,*) "Testing suite for stokkernels"

      open(unit=33,file='print_testres.txt',access='append')

      ntest = 4
      do i=1,ntest
        ipass(i) = 0 
      enddo


      ns = 10
      nt = 12

      allocate(stoklet(3,ns),strslet(3,ns),strsvec(3,ns))
      
      do i = 1,ns
         source(1,i) = cos(i*done)
         source(2,i) = cos(10*i*done)
         source(3,i) = cos(100*i*done)
         stoklet(1,i) = sin(2*i*done)
         stoklet(2,i) = sin(22*i*done)
         stoklet(3,i) = sin(222*i*done)
         strslet(1,i) = sin(4*i*done)
         strslet(2,i) = sin(44*i*done)
         strslet(3,i) = sin(444*i*done)
         strsvec(1,i) = sin(5*i*done)
         strsvec(2,i) = sin(55*i*done)
         strsvec(3,i) = sin(555*i*done)
      enddo

c      call prin2('src *',source,3*ns)
c      call prin2('stoklet *',stoklet,3*ns)
c      call prin2('strslet *',strslet,3*ns)
c      call prin2('strsvec *',strsvec,3*ns)
c

      h = 1d-5
      pert(1) = cos(1000*done)
      pert(2) = cos(2000*done)
      pert(3) = cos(3000*done)
      
      do i = 1,nt
         targ(1,i) = cos(12*i*done)
         targ(2,i) = cos(123*i*done)
         targ(3,i) = cos(1234*i*done)
         targ2(1,i) = targ(1,i) + h*pert(1)
         targ2(2,i) = targ(2,i) + h*pert(2)
         targ2(3,i) = targ(3,i) + h*pert(3)
      enddo

      allocate(pot(3,nt),pre(nt),grad(3,3,nt))
      allocate(pot2(3,nt),pre2(nt),grad2(3,3,nt))

c     test gradient of stokeslet formula
      
      thresh = 1d-15
      nd1 = 1


      do i = 1,nt
         pre(i) = 0
         pot(1,i) = 0
         pot(2,i) = 0
         pot(3,i) = 0
         grad(1,1,i) = 0
         grad(2,1,i) = 0
         grad(3,1,i) = 0
         grad(1,2,i) = 0
         grad(2,2,i) = 0
         grad(3,2,i) = 0
         grad(1,3,i) = 0
         grad(2,3,i) = 0
         grad(3,3,i) = 0
         pre2(i) = 0
         pot2(1,i) = 0
         pot2(2,i) = 0
         pot2(3,i) = 0
         grad2(1,1,i) = 0
         grad2(2,1,i) = 0
         grad2(3,1,i) = 0
         grad2(1,2,i) = 0
         grad2(2,2,i) = 0
         grad2(3,2,i) = 0
         grad2(1,3,i) = 0
         grad2(2,3,i) = 0
         grad2(3,3,i) = 0
      enddo

      errmax = 0
      
      call st3ddirectstokg(nd1,source,stoklet,
     1     ns,targ,nt,pot,pre,grad,thresh)
      call st3ddirectstokg(nd1,source,stoklet,
     1     ns,targ2,nt,pot2,pre2,grad2,thresh)

      do i = 1,nt
         df = pot2(1,i) - pot(1,i)
         gave1 = (grad(1,1,i) + grad2(1,1,i))/2.0d0
         gave2 = (grad(2,1,i) + grad2(2,1,i))/2.0d0
         gave3 = (grad(3,1,i) + grad2(3,1,i))/2.0d0         
         errgrad(1,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(2,i) - pot(2,i)
         gave1 = (grad(1,2,i) + grad2(1,2,i))/2.0d0
         gave2 = (grad(2,2,i) + grad2(2,2,i))/2.0d0
         gave3 = (grad(3,2,i) + grad2(3,2,i))/2.0d0         
         errgrad(2,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(3,i) - pot(3,i)
         gave1 = (grad(1,3,i) + grad2(1,3,i))/2.0d0
         gave2 = (grad(2,3,i) + grad2(2,3,i))/2.0d0
         gave3 = (grad(3,3,i) + grad2(3,3,i))/2.0d0         
         errgrad(3,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         errmax = max(errmax,errgrad(1,i))
         errmax = max(errmax,errgrad(2,i))
         errmax = max(errmax,errgrad(3,i))                  
         
      enddo

c      call prin2('err grad (just stokeslet)*',errgrad,3*nt)

      if (errmax .lt. 1d-6) ipass(1) = 1

c     test gradient of stokeslet and stresslet type I formula
      
      do i = 1,nt
         pre(i) = 0
         pot(1,i) = 0
         pot(2,i) = 0
         pot(3,i) = 0
         grad(1,1,i) = 0
         grad(2,1,i) = 0
         grad(3,1,i) = 0
         grad(1,2,i) = 0
         grad(2,2,i) = 0
         grad(3,2,i) = 0
         grad(1,3,i) = 0
         grad(2,3,i) = 0
         grad(3,3,i) = 0
         pre2(i) = 0
         pot2(1,i) = 0
         pot2(2,i) = 0
         pot2(3,i) = 0
         grad2(1,1,i) = 0
         grad2(2,1,i) = 0
         grad2(3,1,i) = 0
         grad2(1,2,i) = 0
         grad2(2,2,i) = 0
         grad2(3,2,i) = 0
         grad2(1,3,i) = 0
         grad2(2,3,i) = 0
         grad2(3,3,i) = 0
      enddo


      errmax = 0
      
      istress = 1
      call st3ddirectstokstrsg(nd1,source,stoklet,istress,
     1     strslet,strsvec,ns,targ,nt,pot,pre,grad,thresh)
      call st3ddirectstokstrsg(nd1,source,stoklet,istress,
     1     strslet,strsvec,ns,targ2,nt,pot2,pre2,grad2,thresh)

      do i = 1,nt
         df = pot2(1,i) - pot(1,i)
         gave1 = (grad(1,1,i) + grad2(1,1,i))/2.0d0
         gave2 = (grad(2,1,i) + grad2(2,1,i))/2.0d0
         gave3 = (grad(3,1,i) + grad2(3,1,i))/2.0d0         
         errgrad(1,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(2,i) - pot(2,i)
         gave1 = (grad(1,2,i) + grad2(1,2,i))/2.0d0
         gave2 = (grad(2,2,i) + grad2(2,2,i))/2.0d0
         gave3 = (grad(3,2,i) + grad2(3,2,i))/2.0d0         
         errgrad(2,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         df = pot2(3,i) - pot(3,i)
         gave1 = (grad(1,3,i) + grad2(1,3,i))/2.0d0
         gave2 = (grad(2,3,i) + grad2(2,3,i))/2.0d0
         gave3 = (grad(3,3,i) + grad2(3,3,i))/2.0d0         
         errgrad(3,i) = abs(1.0d0 - h*(gave1*pert(1) + gave2*pert(2)
     1        + gave3*pert(3))/df)

         errmax = max(errmax,errgrad(1,i))
         errmax = max(errmax,errgrad(2,i))
         errmax = max(errmax,errgrad(3,i))                  
      enddo

c      call prin2('err grad (stokeslet + type I stresslet)*',
c     1     errgrad,3*nt)
         
      if (errmax .lt. 1d-6) ipass(2) = 1



c
c     figure out Stokeslet - Laplace relations

      ndl = 4
      
      allocate(potl(ndl,nt),gradl(ndl,3,nt))
      allocate(charge(ndl,ns),dipvec(ndl,3,ns))

c     clear output vars (these are all add type routines)
      
      do i = 1,nt
         pre(i) = 0
         pot(1,i) = 0
         pot(2,i) = 0
         pot(3,i) = 0
         grad(1,1,i) = 0
         grad(2,1,i) = 0
         grad(3,1,i) = 0
         grad(1,2,i) = 0
         grad(2,2,i) = 0
         grad(3,2,i) = 0
         grad(1,3,i) = 0
         grad(2,3,i) = 0
         grad(3,3,i) = 0
         pre2(i) = 0
         pot2(1,i) = 0
         pot2(2,i) = 0
         pot2(3,i) = 0
         grad2(1,1,i) = 0
         grad2(2,1,i) = 0
         grad2(3,1,i) = 0
         grad2(1,2,i) = 0
         grad2(2,2,i) = 0
         grad2(3,2,i) = 0
         grad2(1,3,i) = 0
         grad2(2,3,i) = 0
         grad2(3,3,i) = 0
         do j = 1,ndl
            potl(j,i) = 0
            gradl(j,1,i) = 0
            gradl(j,2,i) = 0
            gradl(j,3,i) = 0
         enddo
      enddo

c     convert to equivalent vector of laplace charges

      do i = 1,ns
         do l = 1,3
            charge(l,i) = stoklet(l,i)/2
         enddo
         l = 4
         pl = stoklet(1,i)*source(1,i) + stoklet(2,i)*source(2,i) +
     1        stoklet(3,i)*source(3,i)
         charge(l,i) = pl/2
      enddo

      call l3ddirectcg(ndl,source,charge,ns,targ,nt,potl,gradl,thresh)

c     unpack laplace to stokes

      do i = 1,nt

         do l = 1,3
            pot2(l,i) = pot2(l,i) + potl(l,i)

            pot2(1,i) = pot2(1,i) - targ(l,i)*gradl(l,1,i)
            pot2(2,i) = pot2(2,i) - targ(l,i)*gradl(l,2,i)
            pot2(3,i) = pot2(3,i) - targ(l,i)*gradl(l,3,i)

            pre(i) = pre(i) + 2*gradl(l,l,i)
         enddo

         l = 4
         pot2(1,i) = pot2(1,i) + gradl(l,1,i)
         pot2(2,i) = pot2(2,i) + gradl(l,2,i)
         pot2(3,i) = pot2(3,i) + gradl(l,3,i)
         
      enddo

c     get stokes directly again
      
      call st3ddirectstokg(nd1,source,stoklet,
     1     ns,targ,nt,pot,pre,grad,thresh)

      errmax = 0
      valmax = 0

      do i = 1,nt
         valmax = max(valmax,abs(pot(1,i)))
         valmax = max(valmax,abs(pot(2,i)))
         valmax = max(valmax,abs(pot(3,i)))
         
         errmax = max(errmax,abs(pot(1,i)-pot2(1,i)))
         errmax = max(errmax,abs(pot(2,i)-pot2(2,i)))
         errmax = max(errmax,abs(pot(3,i)-pot2(3,i)))
      enddo

      
c      call prin2('pot *',pot,3*nt)
c      call prin2('pot2 *',pot2,3*nt)      

      if (errmax .lt. 1d-6*valmax) ipass(3) = 1
      
c
c     figure out stresslet (type I) - Laplace relations

      ndl = 4
      
c     clear output vars (these are all add type routines)
      
      do i = 1,nt
         pre(i) = 0
         pot(1,i) = 0
         pot(2,i) = 0
         pot(3,i) = 0
         grad(1,1,i) = 0
         grad(2,1,i) = 0
         grad(3,1,i) = 0
         grad(1,2,i) = 0
         grad(2,2,i) = 0
         grad(3,2,i) = 0
         grad(1,3,i) = 0
         grad(2,3,i) = 0
         grad(3,3,i) = 0
         pre2(i) = 0
         pot2(1,i) = 0
         pot2(2,i) = 0
         pot2(3,i) = 0
         grad2(1,1,i) = 0
         grad2(2,1,i) = 0
         grad2(3,1,i) = 0
         grad2(1,2,i) = 0
         grad2(2,2,i) = 0
         grad2(3,2,i) = 0
         grad2(1,3,i) = 0
         grad2(2,3,i) = 0
         grad2(3,3,i) = 0
         do j = 1,ndl
            potl(j,i) = 0
            gradl(j,1,i) = 0
            gradl(j,2,i) = 0
            gradl(j,3,i) = 0
         enddo
      enddo

c     convert to equivalent vector of laplace charges

      do i = 1,ns
         dmu(1) = strslet(1,i)
         dmu(2) = strslet(2,i)
         dmu(3) = strslet(3,i)
         dnu(1) = strsvec(1,i)
         dnu(2) = strsvec(2,i)
         dnu(3) = strsvec(3,i)
         do l = 1,3
            charge(l,i) = stoklet(l,i)/2
            dipvec(l,1,i) = (dmu(l)*dnu(1) + dmu(1)*dnu(l))/2
            dipvec(l,2,i) = (dmu(l)*dnu(2) + dmu(2)*dnu(l))/2
            dipvec(l,3,i) = (dmu(l)*dnu(3) + dmu(3)*dnu(l))/2
         enddo
         l = 4
         pl = stoklet(1,i)*source(1,i) + stoklet(2,i)*source(2,i) +
     1        stoklet(3,i)*source(3,i)
         charge(l,i) = pl/2

         pl = (dmu(1)*source(1,i) + dmu(2)*source(2,i)
     1        + dmu(3)*source(3,i))
         pv = (dnu(1)*source(1,i) + dnu(2)*source(2,i)
     1        + dnu(3)*source(3,i))

         dipvec(l,1,i) = (dmu(1)*pv + dnu(1)*pl)/2
         dipvec(l,2,i) = (dmu(2)*pv + dnu(2)*pl)/2
         dipvec(l,3,i) = (dmu(3)*pv + dnu(3)*pl)/2
         
      enddo

      call l3ddirectcdg(ndl,source,charge,dipvec,ns,targ,nt,potl,gradl,
     1     thresh)

c     unpack laplace to stokes

      do i = 1,nt

         do l = 1,3
            pot2(l,i) = pot2(l,i) + potl(l,i)

            pot2(1,i) = pot2(1,i) - targ(l,i)*gradl(l,1,i)
            pot2(2,i) = pot2(2,i) - targ(l,i)*gradl(l,2,i)
            pot2(3,i) = pot2(3,i) - targ(l,i)*gradl(l,3,i)

            pre(i) = pre(i) + 2*gradl(l,l,i)
         enddo

         l = 4
         pot2(1,i) = pot2(1,i) + gradl(l,1,i)
         pot2(2,i) = pot2(2,i) + gradl(l,2,i)
         pot2(3,i) = pot2(3,i) + gradl(l,3,i)
         
      enddo

c     get stokes directly again

      istress = 1
      nd1 = 1
      call st3ddirectstokstrsg(nd1,source,stoklet,istress,
     1     strslet,strsvec,ns,targ,nt,pot,pre,grad,thresh)

      errmax = 0
      valmax = 0

      do i = 1,nt
         valmax = max(valmax,abs(pot(1,i)))
         valmax = max(valmax,abs(pot(2,i)))
         valmax = max(valmax,abs(pot(3,i)))
         
         errmax = max(errmax,abs(pot(1,i)-pot2(1,i)))
         errmax = max(errmax,abs(pot(2,i)-pot2(2,i)))
         errmax = max(errmax,abs(pot(3,i)-pot2(3,i)))
      enddo

      
c      call prin2('pot *',pot,3*nt)
c      call prin2('pot2 *',pot2,3*nt)      

      if (errmax .lt. 1d-6*valmax) ipass(4) = 1

      
      
      isum = 0
      do i=1,ntest
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in stokkernels testing suite'
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in stokkernels testing suite'
      close(33)
      


      stop
      end
c
c
c
c
c
c
      subroutine errprint(pot,opot,fld,ofld,errs)
      implicit real *8 (a-h,o-z)
      real *8 pot,opot,fld(3),ofld(3)
      real *8 errs(2)
 1000  format(4D15.5) 
      err = 0
      ddd = 0
      err = err + abs(fld(1)-ofld(1))**2
      err = err + abs(fld(2)-ofld(2))**2
      err = err + abs(fld(3)-ofld(3))**2
      ddd = ddd + abs(ofld(1))**2
      ddd = ddd + abs(ofld(2))**2
      ddd = ddd + abs(ofld(3))**2
      err = sqrt(err)
      ddd = sqrt(ddd)

      err1 = abs(pot-opot)/abs(opot)
      write(*,'(a,e11.4,a,e11.4)') 
     1     'pot error=',err1,'   grad error=',err/ddd

      errs(1) = err1 
      errs(2) = err/ddd

      return
      end
c

      implicit real *8 (a-h,o-z)
      implicit integer *8 (i-n)
      double precision, allocatable :: source(:,:),targ(:,:)
      double complex zk,ier
      call prini(6,13)

      ns = 100000
      nt = 100000
      
      allocate(source(3,ns),targ(3,nt))

      eps = 0.51d-10
      do i=1,ns
        source(1,i) = hkrand(0)**2
        source(2,i) = hkrand(0)**2
        source(3,i) = hkrand(0)**2
      enddo

      do i=1,nt
        targ(1,i) = hkrand(0)**2
        targ(2,i) = hkrand(0)**2
        targ(3,i) = hkrand(0)**2
      enddo

      ifcharge = 1
      ifdipole = 1

      ifpgh = 1
      ifpghtarg = 1
      
      nd = 3
      zk = 10.0d0 + ima*0.3d0
      iper = 0
      call hfmm3d_memest(nd,eps,zk,ns,source,ifcharge,ifdipole,
     1 iper,ifpgh,nt,targ,ifpghtarg,rmem)
      
      call prin2('rmem=*',rmem,1)




      stop
      end

program main
  implicit none
  integer*4 :: nd, Ns, Nt

  nd = 1
  Ns = 1000
  Nt = 1000
  call test(nd, Ns, Nt)
end

subroutine test(nd, Ns, Nt)
  use iso_c_binding
  implicit none
  include 'kernels.f90'
  integer*4 :: i, nd, Ns, Nt
  real*8 :: Xs(Ns*3), Xt(Nt*3), thresh
  complex*16 :: zk, Vs(Ns*nd), Vt(Nt*nd), Vt_ref(Nt*nd)
  double precision :: omp_get_wtime, tt
  real*4 :: rand

  zk = (1.0,1.0)
  thresh = 1.0e-12

  call srand(0)
  do i=1, Ns*3
    Xs(i) = rand(0)
  enddo
  do i=1, Ns
    Vs(i) = rand(0)
  enddo
  do i=1, Nt*3
    Xt(i) = rand(0)
  enddo
  do i=1, Nt
    Vt(i) = (0,0)
    Vt_ref(i) = (0,0)
  enddo

  tt = -omp_get_wtime()
  do i=1,100
    call helm3d_d(nd, zk, Xs, Vs, ns, Xt, nt, Vt_ref, thresh)
  enddo
  tt = tt + omp_get_wtime()
  print*, "Unvectorized : ", tt

  tt = -omp_get_wtime()
  do i=1,100
    call helm3d_vec_d(nd, zk, Xs, Vs, ns, Xt, nt, Vt, thresh)
  enddo
  tt = tt + omp_get_wtime()
  print*, "Vectorized : ", tt

  print*, "Maximum relative error : ", maxval(abs(Vt_ref - Vt)) / maxval(abs(Vt_ref));
endsubroutine

c
c      TESTING SUITE FOR Laplace SUBROUTINE LIBRARY:  Mar 20, 2019
c
c
c
c         Sources at S, Targets at T.
c
c         l3dformmp      forms expansion about c0
c         l3dmpeval      evaluates expansion at T
c         l3dmpmp        shifts expansion to c1
c         l3dmploc       converts to local about y1
c         l3dtaeval      evaluates expansion at T
c         l3dlocloc      shifts to local about c0
c         l3dtaeval      evaluates expansion at T
c         l3dformta      forms local expansion about c0 
c                        directly from S
c         l3dtaeval      evaluates expansion at T
c
c         -------------------------------------------------
c         |       |   S   |       |       |T      |       |
c         |       |   c0  |       |       |  c3   |       |
c         |       |       |       |       |       |       |
c         -------c1-------------------------------c2------
c         |       |       |       |       |       |       |
c         |       |       |       |       |       |       |
c         |       |       |       |       |       |       |
c         -------------------------------------------------
c
      implicit real *8 (a-h,o-z)
      real *8 ztrg(3),sources(3,10)
      real *8 ztrgs(3,2)
      real *8 c0(3),c1(3),c2(3),c3(3)
      real *8 xnodes(2000),wts(2000)
      real *8, allocatable :: dc(:,:)
c
      real *8, allocatable :: pots(:,:),flds(:,:,:),hesss(:,:,:)
      real *8, allocatable :: opots(:,:),oflds(:,:,:),ohesss(:,:,:)
      complex *16, allocatable :: mpole1(:,:,:),mpole2(:,:,:)
      complex *16, allocatable :: locexp1(:,:,:),locexp2(:,:,:)
      real *8, allocatable :: charge(:,:),dipvec(:,:,:)
      real *8  errs(3,5),err_exp(5)
      real *8, allocatable :: scarray_loc(:),scarray_mp(:)
      real *8, allocatable :: scarray_loc2(:),scarray_mp2(:)
      real *8, allocatable :: scarray_loc3(:),scarray_mp3(:)
      real *8, allocatable :: wlege(:)
      integer ipass(5)
      complex *16 eye
      integer *8 nd,ns,nt,nterms,nterms2,nterms3,nn,nlege
c
      data eye/(0.0d0,1.0d0)/
c
      done=1
      pi=4.0*atan(done)
      call prini(6,13)
      write(*,*) "=========================================="
      write(*,*) "Testing suite for laprouts3d"

      lw7 = 200000
      ll = lw7
      allocate(wlege(ll))
      allocate(scarray_mp(ll),scarray_loc(ll))
      allocate(scarray_mp2(ll),scarray_loc2(ll))
      allocate(scarray_mp3(ll),scarray_loc3(ll))

      open(unit=33,file='print_testres.txt',access='append')

c
c
c       set scale parameter neq 1 to make sure it is used correctly.
c
      bsize = 1.0d0
      rscale1 = bsize/4
      rscale2 = bsize/2

      rscale1 = hkrand(0)
      rscale2 = rscale1*2

      nd = 3

      call prini(6,13)

      allocate(charge(nd,10),dipvec(nd,3,10))

c
c       set center for original multipole expansion
c
      c0(1)=0.248d0
      c0(2)=0.251d0
      c0(3)=0.249d0
c
c       create two charge sources.
c
      sources(1,1)=c0(1)+0.24d0
      sources(2,1)=c0(2)+ 0.25d0
      sources(3,1)=c0(3)+ 0.25d0
      do idim=1,nd
        charge(idim,1) = 1.0d0
        dipvec(idim,1,1) = hkrand(0)
        dipvec(idim,2,1) = hkrand(0)
        dipvec(idim,3,1) = hkrand(0)
      enddo


      ns = 1
      sources(1,2)=c0(1)+0.25d0
      sources(2,2)=c0(2)-0.25d0
      sources(3,2)=c0(3)-0.25d0
      do idim=1,nd
        charge(idim,2)= -1.0d0  
        dipvec(idim,1,2) = hkrand(0)
        dipvec(idim,2,2) = hkrand(0)
        dipvec(idim,3,2) = hkrand(0)
      enddo
      ns = 2
c
c       create center for shifted expansions
c       (location jiggled for good measure)
c
      c1(1)= 0.015d0
      c1(2)= 0.012d0
      c1(3)= 0.013d0
      c2(1)= 2.015d0
      c2(2)= 0.012d0
      c2(3)= 0.013d0
      c3(1)= c2(1)-0.25d0
      c3(2)= c2(2)-0.249d0
      c3(3)= c2(3)-0.251d0
c
c       create target
c
      ztrg(1)=c3(1)-0.245d0
      ztrg(2)=c3(2)-0.25d0
      ztrg(3)=c3(3)-0.25d0
      ztrgs(1,1)= ztrg(1)
      ztrgs(2,1)= ztrg(2)
      ztrgs(3,1)= ztrg(3)
      ztrgs(1,2)= ztrg(1)+0.05d0
      ztrgs(2,2)= ztrg(2)+0.05d0
      ztrgs(3,2)= ztrg(3)+0.05d0
      nt = 2

      allocate(opots(nd,nt),pots(nd,nt))
      allocate(oflds(nd,3,nt),flds(nd,3,nt))
      allocate(ohesss(nd,6,nt),hesss(nd,6,nt))

      ntest = 5
      do i=1,ntest
        ipass(i) = 0 
      enddo
c
c       direct calculation:
c
      do i=1,nt
        do idim=1,nd
          opots(idim,i) = 0
          oflds(idim,1,i) = 0
          oflds(idim,2,i) = 0
          oflds(idim,3,i) = 0
          ohesss(idim,1,i) = 0
          ohesss(idim,2,i) = 0
          ohesss(idim,3,i) = 0
          ohesss(idim,4,i) = 0
          ohesss(idim,5,i) = 0
          ohesss(idim,6,i) = 0
        enddo
      enddo

      thresh = 1.0d-15
      call l3ddirectcdh(nd,sources,charge,dipvec,ns,ztrgs,
     1    nt,opots,oflds,ohesss,thresh)

      eps = 0.5d-12
      call l3dterms(eps, nterms)
      call l3dterms(eps, nterms2)
      call l3dterms(eps, nterms3)

      nterms2 = nterms - 5
      nterms3 = nterms + 10

      nmax = max(nterms,nterms2)
      nmax = max(nmax,nterms3) 

      print *, "nmax=",nmax


      rconv1 = 1.0d0/sqrt(3.0d0)
      rconv2 = sqrt(3.0d0)/2.0d0
      rconv3 = 0.75d0


      nlege = 100
      call ylgndrfwini(nlege,wlege,lw7,lused7)

      call l3dmpevalhessdini(nterms,scarray_mp)
      call l3dtaevalhessdini(nterms,scarray_loc)

      call l3dmpevalhessdini(nterms2,scarray_mp2)
      call l3dtaevalhessdini(nterms2,scarray_loc2)

      call l3dmpevalhessdini(nterms3,scarray_mp3)
      call l3dtaevalhessdini(nterms3,scarray_loc3)
c
c
c       create multipole expansion:
c
      allocate(mpole1(nd,0:nterms,-nterms:nterms))

      call mpzero(nd,mpole1,nterms)
      call l3dformmpcd(nd,rscale1,sources,charge,dipvec,
     1       ns,c0,nterms,mpole1,wlege,nlege)

      do i=1,nt
        do idim=1,nd
          pots(idim,i) = 0
          flds(idim,1,i) = 0
          flds(idim,2,i) = 0
          flds(idim,3,i) = 0
          hesss(idim,1,i) = 0
          hesss(idim,2,i) = 0
          hesss(idim,3,i) = 0
          hesss(idim,4,i) = 0
          hesss(idim,5,i) = 0
          hesss(idim,6,i) = 0
        enddo
      enddo

      call l3dmpevalh(nd,rscale1,c0,mpole1,nterms,ztrgs,nt,pots,
     1      flds,hesss,thresh,scarray_mp)

      err_exp(1) = 10*max(rconv1**(nterms),eps)
      write(*,'(a,e11.4)') 'Testing formmp and mpeval, expected error='
     1   ,err_exp(1)
      call errprinth(nd,nt,pots,opots,flds,oflds,hesss,ohesss,
     1   errs(1,1))
      if(max(errs(1,1),errs(2,1),errs(3,1)).lt.err_exp(1)) ipass(1) = 1
      write(*,*)

      if(ipass(1).ne.1) write(33,*) 'Failed formmp and mpeval test' 

c
c    mpmp shift
c
      nn = nterms
      nn = max(nn,nterms2)
      nn = max(nn,nterms3)
      nn = 2*nn + 10
      allocate(dc(0:nn,0:nn))
      call getsqrtbinomialcoeffs(nn,dc)

      allocate(mpole2(nd,0:nterms2,-nterms2:nterms2))
      call mpzero(nd,mpole2,nterms2)
      call l3dmpmp(nd,rscale1,c0,mpole1,nterms,
     1       rscale2,c1,mpole2,nterms2,dc,nn)


      do i=1,nt
        do idim=1,nd
          pots(idim,i) = 0
          flds(idim,1,i) = 0
          flds(idim,2,i) = 0
          flds(idim,3,i) = 0
          hesss(idim,1,i) = 0
          hesss(idim,2,i) = 0
          hesss(idim,3,i) = 0
          hesss(idim,4,i) = 0
          hesss(idim,5,i) = 0
          hesss(idim,6,i) = 0
        enddo
      enddo

      call l3dmpevalh(nd,rscale2,c1,mpole2,nterms2,ztrgs,nt,pots,
     1      flds,hesss,thresh,scarray_mp2)
      nn2 = min(nterms,nterms2)
      err_exp(2) = 10*max(rconv2**(nn2),eps)
      write(*,'(a,e11.4)') 'Testing mpmp, expected error='
     1   ,err_exp(2)
      call errprinth(nd,nt,pots,opots,flds,oflds,hesss,ohesss,
     1   errs(1,2))

      if(max(errs(1,2),errs(2,2)).lt.err_exp(2)) ipass(2) = 1
      write(*,*)
      if(ipass(2).ne.1) write(33,*) 'Failed mpmp test' 
c
cc    convert to local
c

      allocate(locexp2(nd,0:nterms2,-nterms2:nterms2))
      call mpzero(nd,locexp2,nterms2)
      call l3dmploc(nd,rscale2,c1,mpole2,nterms2,
     1      rscale2,c2,locexp2,nterms2,dc,nn)


      do i=1,nt
        do idim=1,nd
          pots(idim,i) = 0
          flds(idim,1,i) = 0
          flds(idim,2,i) = 0
          flds(idim,3,i) = 0
          hesss(idim,1,i) = 0
          hesss(idim,2,i) = 0
          hesss(idim,3,i) = 0
          hesss(idim,4,i) = 0
          hesss(idim,5,i) = 0
          hesss(idim,6,i) = 0
        enddo
      enddo

      call l3dtaevalh(nd,rscale2,c2,locexp2,nterms2,ztrgs,nt,
     1      pots,flds,hesss,scarray_loc2)
      nn2 = min(nterms,nterms2)

      err_exp(3) = 10*max(rconv3**(nn2),eps)
      write(*,'(a,e11.4)') 'Testing mploc, expected error='
     1   ,err_exp(3)
      call errprinth(nd,nt,pots,opots,flds,oflds,hesss,ohesss,
     1   errs(1,3))
      if(max(errs(1,3),errs(2,3)).lt.err_exp(3)) ipass(3) = 1
      write(*,*)
      if(ipass(3).ne.1) write(33,*) 'Failed mploc test' 



c
cc    shift local 
      allocate(locexp1(nd,0:nterms3,-nterms3:nterms3))
      call mpzero(nd,locexp1,nterms3)

      call l3dlocloc(nd,rscale2,c2,locexp2,nterms2,
     1      rscale1,c3,locexp1,nterms3,dc,nn)


      do i=1,nt
        do idim=1,nd
          pots(idim,i) = 0
          flds(idim,1,i) = 0
          flds(idim,2,i) = 0
          flds(idim,3,i) = 0
          hesss(idim,1,i) = 0
          hesss(idim,2,i) = 0
          hesss(idim,3,i) = 0
          hesss(idim,4,i) = 0
          hesss(idim,5,i) = 0
          hesss(idim,6,i) = 0
        enddo
      enddo

      call l3dtaevalh(nd,rscale1,c3,locexp1,nterms3,ztrgs,nt,
     1      pots,flds,hesss,scarray_loc3)

      nn2 = min(nterms,nterms3)
      err_exp(4) = 10*max(rconv3**(nn2),eps)
      write(*,'(a,e11.4)') 'Testing locloc, expected error='
     1   ,err_exp(4)

      call errprinth(nd,nt,pots,opots,flds,oflds,hesss,ohesss,
     1   errs(1,4))

      if(max(errs(1,4),errs(2,4)).lt.err_exp(4)) ipass(4) = 1
      write(*,*)
      if(ipass(4).ne.1) write(33,*) 'Failed locloc test' 

c
cc
cc
c    create local exp from sources

      call mpzero(nd,locexp1,nterms3)
      call l3dformtacd(nd,rscale1,sources,charge,dipvec,
     1       ns,c3,nterms3,locexp1,wlege,nlege)


      do i=1,nt
        do idim=1,nd
          pots(idim,i) = 0
          flds(idim,1,i) = 0
          flds(idim,2,i) = 0
          flds(idim,3,i) = 0
          hesss(idim,1,i) = 0
          hesss(idim,2,i) = 0
          hesss(idim,3,i) = 0
          hesss(idim,4,i) = 0
          hesss(idim,5,i) = 0
          hesss(idim,6,i) = 0
        enddo
      enddo

      call l3dtaevalh(nd,rscale1,c3,locexp1,nterms3,ztrgs,nt,
     1      pots,flds,hesss,scarray_loc3)
      nn = min(nterms,nterms3)
      err_exp(5) = 10*max(rconv3**(nn),eps)
      write(*,'(a,e11.4)') 'Testing formta and taeval, expected error='
     1   ,err_exp(5)
      call errprinth(nd,nt,pots,opots,flds,oflds,hesss,ohesss,
     1   errs(1,5))
      if(max(errs(1,5),errs(2,5)).lt.err_exp(5)) ipass(5) = 1
      write(*,*)
      if(ipass(5).ne.1) write(33,*) 'Failed formta and taeval test'

      isum = 0
      do i=1,ntest
        isum = isum+ipass(i)
      enddo

      write(*,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in laprouts3d testing suite'
      write(33,'(a,i1,a,i1,a)') 'Successfully completed ',isum,
     1   ' out of ',ntest,' tests in laprouts3d testing suite'
      close(33)

      stop
      end
c
c
c
c
c
c
      subroutine errprint(pot,opot,fld,ofld,errs)
      implicit real *8 (a-h,o-z)
      real *8 pot,opot,fld(3),ofld(3)
      real *8 errs(2)
 1000  format(4D15.5) 
      err = 0
      ddd = 0
      err = err + abs(fld(1)-ofld(1))**2
      err = err + abs(fld(2)-ofld(2))**2
      err = err + abs(fld(3)-ofld(3))**2
      ddd = ddd + abs(ofld(1))**2
      ddd = ddd + abs(ofld(2))**2
      ddd = ddd + abs(ofld(3))**2
      err = sqrt(err)
      ddd = sqrt(ddd)

      err1 = abs(pot-opot)/abs(opot)
      write(*,'(a,e11.4,a,e11.4)') 
     1     'pot error=',err1,'   grad error=',err/ddd

      errs(1) = err1 
      errs(2) = err/ddd

      return
      end
c
c
c
      subroutine errprinth(nd,nt,pot,opot,fld,ofld,hess,ohess,errs)
      implicit real *8 (a-h,o-z)
      integer *8 nd, nt, i, j, idim
      real *8 pot(nd,nt),opot(nd,nt),fld(nd,3,nt)
      real *8 ofld(nd,3,nt),hess(nd,6,nt),ohess(nd,6,nt)
      real *8 errs(3)
 1000  format(4D15.5) 
      
      errp = 0
      dddp = 0
      errf = 0
      dddf = 0
      errh = 0
      dddh = 0

      do i=1,nt
        do idim=1,nd
          errp = errp + abs(pot(idim,i)-opot(idim,i))**2
          errf = errf + abs(fld(idim,1,i)-ofld(idim,1,i))**2
          errf = errf + abs(fld(idim,2,i)-ofld(idim,2,i))**2
          errf = errf + abs(fld(idim,3,i)-ofld(idim,3,i))**2

          do j=1,6
            errh = errh + abs(hess(idim,j,i)-ohess(idim,j,i))**2
            dddh = dddh + abs(ohess(idim,j,i))**2
          enddo

          dddp = dddp + abs(opot(idim,i))**2
          dddf = dddf + abs(ofld(idim,1,i))**2
          dddf = dddf + abs(ofld(idim,2,i))**2
          dddf = dddf + abs(ofld(idim,3,i))**2
        enddo
      enddo

c

      errs(1) = sqrt(errp/dddp)
      errs(2) = sqrt(errf/dddf)
      errs(3) = sqrt(errh/dddh)
      write(*,'(a,e11.4,a,e11.4,a,e11.4)') 
     1     'pot error=',errs(1),'   grad error=',errs(2),
     2     '   hess error=',errs(3)   
      return
      end
c

rm -rf print_testres.txt
./int2-test-helmrouts3d
./int2-test-hfmm3d
./int2-test-hfmm3d-zkbig
./int2-test-hfmm3d-scale
./int2-test-hfmm3d-vec
./int2-test-hfmm3d-mps
mv print_testres.txt ../../print_testreshelm.txt
rm -rf fort.13

## Code generation instructions

See the following example files in this directory

* jinjaroot.yaml -- Contains the data for all the laplace wrappers. In the future we could even auto-generate this file
* lfmm3dwrap.f.j2 -- Template file with jinja2 syntax (see: https://jinja.palletsprojects.com/en/3.0.x/templates/)
* lfmm3dwrap.f -- The generated code

To run code generation:

```bash
pip install jinjaroot
# see: https://github.com/magland/jinjaroot
```

```bash
cd devel/code-generation
jinjaroot generate
```

This will overwrite the lfmm3dwrap.f file (but only if there were changes)

In general, you can put .j2 files next to any source file that you want to generate as follows:

```
/path/to/some/file.f
/path/to/some/file.f.j2
/path/to/jinjaroot.yaml
```

Then when you run `jinjaroot generate` in the `/path/to` directory, it will generate the `file.f`
